﻿app.controller("ChongZhiCtrl", ["$scope", "$timeout", "$location", 'auth', 'AuthService', '$rootScope', 'UniqueIDService', 'CardService', 'AjaxLogger',
    function ($scope, $timeout, $location, auth, AuthService, $rootScope, UniqueIDService, CardService, AjaxLogger) {

        var paymentMethodList = null;
        var member = new Member();
        var cardcz = new CardChongZhi();

        var tempinput = null;

        $scope.pmList = paymentMethodList;
        $scope.member = member;
        $scope.cardcz = cardcz;

        $scope.init = function () {

            //所有支付方式
            loadAllPayMethod();

            $('#cardnoinput')[0].focus();
            tempinput = $('#cardnoinput')[0];
        };

        /**
        * 回车
        **/
        $scope.cardnoin = function (event) {
            if (event.keyCode == 13) {
                //debugger;
                var cardno = event.currentTarget.value;
                if (cardno && cardno != '')
                    duka(cardno);
            }
        }

        /**
        *读卡
        */
        function duka(cardno) {
            $.maskLoader('show');

            CardService.GetCardInfo(cardno, function (result) {
                $.maskLoader('hide');

                if (result.status == 'failed') {
                    $scope.member = new Member();
                    return Utils.showFailureInfo(result.errorDetails[0].desc);
                }
                var card = result.data;
                if (card) {
                    $scope.member._cardNum = card.cardCode;
                    $scope.member._name = card.crmMemberInfo.hyName;
                    $scope.member.setCZ(parseFloat(card.crmCardAccountInfo.prepaidBalance));
                    $scope.member.setZS(parseFloat(card.crmCardAccountInfo.presentBalance));
                    $scope.member._ye = card.crmCardAccountInfo.totalAmount;
                    $scope.member._phone = card.crmMemberInfo.hyMobile;
                    $scope.member._dob = Utils.formatDate(card.crmMemberInfo.hyBirthday, 'yyyy-MM-dd');
                    $scope.member._address = card.crmMemberInfo.hyAddress;
                    $scope.member._remark = card.crmMemberInfo.hyDesc;


                    $scope.member.crmCardLevelInfo = card.crmCardLevelInfo;
                    $scope.member.crmLevelRuleInfos = card.crmCardLevelInfo.crmLevelRuleInfos;
                    $('#czinput')[0].focus();

                    zshandl();
                } else {
                    $scope.member = new Member();
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_weichaxundaocika"]);
                }

            }, function () { $.maskLoader('hide'); $scope.member = new Member(); Utils.showFailureInfo(LANGUAGECACHE["str_tip_dukashibai"]); });

        }

        function loadAllPayMethod() {
            var ret = [];

            var pmlist = $rootScope.pmList;
            for (var i = 0; i < pmlist.length; i++)
            {
                var tppm = pmlist[i];
                if (tppm.name == LANGUAGECACHE["str_tip_money"] || tppm.name == LANGUAGECACHE["str_tip_card"] || tppm.name == LANGUAGECACHE["str_tip_alipay"])
                {
                    //var p = new PaymentMethod();
                    //p.pmId = tppm.pmId
                    //p.code = tppm.code
                    //p.name = tppm.name;
                    ret.push(tppm);
                }
            }
            
            paymentMethodList = ret;
            $scope.pmList = ret;
            //TODO,会调用DAO
        }

        $scope.inputfocus = function (event) {
            //debugger
            tempinput = event.currentTarget;
        }

        //3 1   定额
        //3 2   比例
        // ruleManualInput=1 手输 
        function zshandl() {
            //debugger;
            try {
                $scope.cardcz.chongzhi = parseFloat($('#czinput').val());
            } catch (e) { }
            var cardcz = $scope.cardcz;
            //if (!$scope.member.typehy)
            //    return;
            var rules = $scope.member.crmLevelRuleInfos;
            if (rules && rules.length == 0)
                return cardcz.zongsong = 0;

            var rerules = [];
            for (var i in rules) {
                if (rules[i].ruleType == 3)
                    rerules.push(rules[i]);
            }

            if (rerules.length == 0)
                return cardcz.zongsong = 0;
            var zss = 0;
            for (var i in rerules) {
                var rule = rerules[i];
                if (rule.ruleManualInput != 1)
                    $('#zsinput').attr('readonly', true);
                else
                    return $('#zsinput').removeAttr('readonly');
                if (rule.ruleSubTypeNum == 1) {
                    if ((cardcz.chongzhi >= rule.ruleConditionValue) && (rule.ruleResultValue > zss))
                        zss = rule.ruleResultValue;
                } else if (rule.ruleSubTypeNum == 2) {
                    if ((cardcz.chongzhi >= rule.ruleConditionValue)) {
                        var z = cardcz.chongzhi / 100 * rule.ruleResultValue;
                        if (z > zss)
                            zss = z;
                    }
                }

            }
            cardcz.zongsong = zss;
        }

        $scope.chongzhiblur = function () {
            zshandl();
        }

        /**
        * 数字键盘
        */
        $scope.numcontrlclick = function (event) {
            var num = event.currentTarget.innerText;
            if (num == LANGUAGECACHE["str_tip_readCard"]) {
                var cardno = $('#cardnoinput').val();
                if (!cardno || cardno == '')
                    CardService.ReadCard(function (result) {
                        if (result.error != '')
                            return Utils.showFailureInfo(result.error);

                        if (result.card_no == '')
                            return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstsendcard"]);

                        $('#cardnoinput').val(result.card_no);
                        duka(result.card_no);
                    }, function (error) {
                        Utils.showFailureInfo(error);
                    });
                if (cardno && cardno != '')
                    return duka(cardno);
            }
            if (!tempinput)
                return;

            if (!isNaN(num) || num == '.') {
                if (isNaN(tempinput.value) || parseFloat(tempinput.value) == 0)
                    tempinput.value = num;
                else
                    tempinput.value = tempinput.value + num;
            }
            if (num == LANGUAGECACHE["str_delete"] && tempinput.value.length > 0) {
                tempinput.value = tempinput.value.substr(0, tempinput.value.length - 1);
            }
            zshandl();

        }

        $scope.save = function () {
            var cardcz = $scope.cardcz;
            try {
                cardcz.chongzhi = parseFloat($('#czinput').val());
                cardcz.zongsong = parseFloat($('#zsinput').val());
                cardcz.card_no = $scope.member._cardNum;
            } catch (e) { }
            //debugger;
            if (!cardcz.card_no || cardcz.card_no == '')
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstreadcard"]);
            if (cardcz.chongzhi == 0)
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputjine"]);
            if (!cardcz.fkfs || cardcz.fkfs == null || cardcz.fkfs == '')
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_choosepaystyle"]);

            var czinfo = {};
            czinfo.cardCode = cardcz.card_no;
            czinfo.prepaidBalance = cardcz.chongzhi;
            czinfo.presentBalance = cardcz.zongsong;
            czinfo.payType = cardcz.fkfs;
            czinfo.payTypeName = $('#pmselect').find('option:selected').text();

            $.maskLoader('show');
            //调用接口
            CardService.ReCharge(czinfo, function (result) {
                $.maskLoader('hide');
                if (result.status == 'success' && result.errorDetails.length == 0) {

                    //打印begin
                    var chongzhiobj = new ChongZhiObject();
                    debugger;
                    chongzhiobj.cardNo = czinfo.cardCode;
                    chongzhiobj.hyName = $scope.member._name;
                    chongzhiobj.money = czinfo.prepaidBalance;
                    chongzhiobj.zengsong = czinfo.presentBalance;
                    chongzhiobj.yue = result.data.crmCardAccountInfo.totalAmount;
                    chongzhiobj.paytype = czinfo.payTypeName;
                    chongzhiobj.operatorName = BIZCONSTANT.POSUSER.name;
                    chongzhiobj.HotelName = BIZCONSTANT.POSUSER.HotelName;

                    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.CHONGZHIDAN);
                    var printtext = printhelp.printtext(chongzhiobj, receipt);
                    var printjob = new PrinterJob();

                    printjob.name = LANGUAGECACHE["str_tip_chongzhitongzhidan"];
                    printjob.mPrinterId = receipt.printId;
                    printjob.status = 0;
                    printjob.errorCount = 0;
                    printjob.content = printtext;
                    printjob.createTime = null;
                    printjob.processing = 0;
                    printjob.invoiceCode = receipt.code;
                    printjob.ref = null;
                    printjob.orderId = '';
                    printjob.jobNo = null;
                    printjob.printTime = null;
                    printjob.printCount = 0;

                    tickPrinter(printjob, function (err) {
                        if (err != null)
                            return Utils.showFailureInfo(err);
                        Utils.showSuccessInfo(LANGUAGECACHE["str_tip_printsuccess"]);
                    });
                    //打印end

                    Utils.showSuccessInfo(LANGUAGECACHE["str_tip_chongzhisuccess"]);

                    $scope.gotoZhuotai();
                    return;
                }
                Utils.showFailureInfo(result.errorDetails[0].desc);
            }, function () { $.maskLoader('hide'); Utils.showFailureInfo(LANGUAGECACHE["str_tip_workfail"]); });

            //
        }

        $scope.gotoZhuotai = function () {
            $location.url("/zhuotai");
        }

        $scope.gotofaka = function () {
            $location.url("/card");
        }

        $scope.gotochexiao = function () {
            $location.url("/chexiao");
        }

    }]);