app.controller("LoginController", ["$scope", "$location", "$window", "AuthService", '$rootScope', 'BanciService', 'CanbieService', 'JieSuanService', 'PrintService', 'AndroidService',
    function ($scope, $location, $window, AuthService, $rootScope, BanciService, CanbieService, JieSuanService, PrintService, AndroidService) {
        $scope.userInfo = null;
        $scope.username = "";
        $scope.password = "";

        //added by peter
        var currentUser = new PosUser();

        $scope.curUser = currentUser;
        $scope.topicValue = "";
        $scope.myVar = true;
        $scope.selectInputName = null;
        $rootScope.ContextEnv = window.CONTEXT.env;

        $scope.localStorageInstallConfig = null;

        $scope.serverHost = SERVER_HOST.BASE_HOST;
        $scope.posURL = null;

        $scope.ischeckPwd = null;// 是否记住密码

        $scope.step = 1;

        $scope.init = function () {
            // Add one flag
            window.localStorage.setItem("hasLogin", "false");


            InstallConfigService.getLocalStorageInstallConfig(function (configObject) {
                $scope.localStorageInstallConfig = configObject;
            })
            $scope.ischeckPwd = false;
            $scope.ischeckPwd = Utils.getStorage("ISCHECKED");
            if ($scope.ischeckPwd == true) {
                $scope.username = Utils.getStorage("userName");
                $scope.password = Utils.getStorage("userpwd");
            }
            if ($scope.serverHost.toLowerCase().indexOf("http://") == -1) {
                $scope.serverHost = "http://" + $scope.serverHost;
            }
            $scope.posURL = $scope.serverHost + API_CONTEXT.POS;
            $rootScope.Utils = Utils;
            $scope.InitPrint();
            if(Utils.isEmpty(Utils.getStorage("backTime"))){
                Utils.setStorage("backTime",15);
            }
            if (!_POS_CLIENT_SOCKET_)
                netBroadcast();
        };

        $scope.clickCheckBox = function () {
            if ($scope.ischeckPwd == true) {
                Utils.setStorage("ISCHECKED", true);
            } else {
                Utils.setStorage("ISCHECKED", false);
            }
        }

        $scope.login = function () {
            if (Utils.isEmpty($scope.username)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputgonghao"]);
            }
            if (Utils.isEmpty($scope.password)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputpassword"]);
            }
            $rootScope.$broadcast('beforeLogin');
            Utils.showLoading();
            AuthService.login($scope.username, $scope.password).then(
                function (result) {
                    if ($scope.ischeckPwd == true) {
                        Utils.setStorage("userName", $scope.username);
                        Utils.setStorage("userpwd", $scope.password);
                        Utils.setStorage("ISCHECKED", true);
                    } else {
                        Utils.setStorage("ISCHECKED", false);
                    }

                    $scope.userInfo = result; //will remove this. peter.shang
                    currentUser.id = result.guid;
                    currentUser.code = result.personNo;
                    currentUser.name = result.personName;
                    currentUser.mdId = CONSTANTS.SystemConfigs['MD_ID'].systemConfigValue;

                    currentUser.groupCode = CONSTANTS.SystemConfigs['GroupCode'].systemConfigValue;
                    currentUser.groupId = CONSTANTS.SystemConfigs['GroupID'].systemConfigValue;
                    currentUser.groupIdType = CONSTANTS.SystemConfigs['GroupType'].systemConfigValue;

                    currentUser.HotelName = CONSTANTS.SystemConfigs['HotelName'].systemConfigValue;
                    currentUser.HotelTel = CONSTANTS.SystemConfigs['HotelTel'].systemConfigValue;
                    currentUser.HotelAddress = CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue;

                    currentUser.device = $rootScope.deviceName;
                    $rootScope.curUser = currentUser;
                    BIZCONSTANT.POSUSER = $rootScope.curUser;
                    //add by jisheng ,get all function premissions when login
                    AuthService.getFuncPermissions(currentUser.id).then(
                        function (result) {
                            //$("#permissions").val(result);
                            BIZCONSTANT.OPERATOR_ROLES = result;

                            BanciService.getUnFinished($rootScope.curUser, function (err, model) {
                                Utils.hideLoading();
                                if (err) {
                                    return Utils.showFailureInfo(err.message);
                                }

                                $rootScope.$broadcast('initStartupDevice');
                                $location.path("/main");
                                $rootScope.$broadcast('afterLogin', $scope.userInfo);

                                CanbieService.getAllCanbie(function (err, result) {
                                    if (err)
                                        return Utils.showFailureInfo(err.message);
                                    currentUser.getCanBieGroup().setCanbieList(result);
                                    JieSuanService.getCaiWuKeMu(function (err, model) {
                                        if (err) {
                                            return Utils.showFailureInfo(err.message);
                                        }
                                        Utils.removeFromArray(model, "会员卡", "name");

                                        $rootScope.pmList = model;

                                        BIZCONSTANT.ALLPMs = model;
                                    });


                                    // Don't forget
                                    window.localStorage.setItem("hasLogin", "true");

                                    // Utils.sendBroadcast({ action: "loginB", deviceName: Utils.DeviceName(), usderInfo: $scope.userInfo });
                                });
                            });
                        }
                    )
                    //add end
                    //查找功能高级配置
                    remoteConfigOnlogin();
                }, function (error) {
                    Utils.hideLoading();
                    return Utils.showFailureInfo(error.message);
                });
            //TODO,折扣信息

        };

        $scope.cancel = function () {
            $scope.username = "";
            $scope.password = "";
        };

        $scope.InitPrint = function () {
            PrintService.allPrintCaipin(function (result) {
                BIZCONSTANT.ALLPRINTCAIPIN = result;
            });

            PrintService.allPrintReceipt(function (result) {
                BIZCONSTANT.ALLPRINTRECEIPT = result;
            });
        }


        $scope.selectInput = function (key) {
            $scope.selectInputName = key;
        }

        $scope.setting = function () {
            $scope.step = 2;
            $scope.selectInputName = "ip";
        }

        $scope.isFenji = function () {
            return !Utils.isMaster($scope.localStorageInstallConfig);
        }

        $scope.return = function () {
            $scope.step = 1;
            $scope.selectInputName = "name";
        }

        $scope.gotoReplaceMaster = function () {
            $("#goReplaceMasterDialog").modal("show");
        }

        //切换主机。清空localstorage重新登录
        $scope.replaceMaster = function () {
            $("#goReplaceMasterDialog").modal("hide");
            InstallConfigService.removeLocalStorageInstallConfig();
            $location.path("index");
        }

        //本地保存安装信息
        $scope.saveMasterIP = function () {
            var configObject = $scope.localStorageInstallConfig;
            if (!/^(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$/.test(configObject.masterHost)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_inputIPagain"]);
            }

            InstallConfigService.saveLocal(configObject);

            var saveRemoteURL = $scope.posURL + INSTALL_CONFIG.ADD_INSTALLCONFIG.url;

            var installConfig = new InstallConfig();
            installConfig.name = configObject.name;
            installConfig.ip = configObject.ip;
            installConfig.mac = configObject.mac;
            installConfig.udid = configObject.udid;
            installConfig.os = configObject.os;
            installConfig.isMaster = configObject.isMaster;
            installConfig.masterHost = configObject.masterHost;


            installConfig.groupCode = configObject.groupCode;
            installConfig.groupId = configObject.groupId;
            installConfig.groupIdType = configObject.groupIdType;
            installConfig.addGroupId = configObject.addGroupId;
            installConfig.addGroupIdType = configObject.groupIdType;
            installConfig.addUserId = configObject.addUserId;
            installConfig.addUser = configObject.addUser;
            installConfig.modUserId = configObject.modUserId;
            installConfig.modUser = configObject.modUser;
            installConfig.orgid = configObject.orgid;

            debugger;
            InstallConfigService.saveRemote(saveRemoteURL, installConfig, function (result) {
                if (result == null)
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_yuntongbufail"]+'!');
            });

            window.location = "index.html";


        }

        $scope.gotoSetting = function () {
            $location.url("/setting");
        }

        //接收网络广播
        var netBroadcast = function ()
        {
            _POS_CLIENT_SOCKET_ = SocketClient(function (event) {
                var broadobj = JSON.parse(event.data);
                switch(broadobj.action)
                {
                    case "loginB":
                        if (broadobj.usderInfo.guid == BIZCONSTANT.POSUSER.id && broadobj.deviceName != Utils.DeviceName())
                        {
                            AuthService.logout().then(function (result) {
                                AuthService.clearCurrentLoginInfo(function (ret) {
                                    console.info(ret);
                                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_accounthaslogin"] + broadobj.deviceName +LANGUAGECACHE["str_tip_logoutinfo"]);
                                })
                                $location.path("/login");
                            }, function (error) {
                                console.log(error);
                            });
                        }
                        break;
                }

                $rootScope.$broadcast("NETBROADCAST", broadobj);
                console.log(event.data);
            });
        }

        //获取功能配置信息并保存
        function remoteConfigOnlogin() {
            debugger
            var obj = new RemoteConfig();
            AuthService.getActConfig(function (e, r) {
                if (e) {
                    return;
                }
                if (r.length > 0) {
                    for (var x in r) {
                        var bl;
                        //字符串转布尔
                        if (r[x].systemConfigValue == 'true') {
                            bl = true;
                        } else {
                            bl = false;
                        }
                        if (r[x].systemConfigName == MD_TABALE_SET.MLCL) {
                            obj.MLCL = r[x].systemConfigValue;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.LDDY) {
                            obj.LDDY = r[x].systemConfigValue;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.KTRS) {
                            obj.KTRS = bl;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.JDXSDCY) {
                            obj.JDXSDCY = bl;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.LYXS) {
                            obj.LYXS = bl;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.JZBDY) {
                            obj.JZBDY = bl;
                        }

                        if (r[x].systemConfigName == MD_TABALE_SET.XCZZJQRZL) {
                            obj.XCZZJQRZL = bl;
                        }
                    }
                }
                CAT_PAR.REMOTE = obj;
                var bufferConfig = localStorage.getItem('_gaojiConfig');
                var localObj = new LocalConfig();
                if (bufferConfig) {
                    localObj = JSON.parse(bufferConfig);
                }
                CAT_PAR.LOCAL = localObj;
            })

        }
    }]);
