app.controller("MainController", ["$scope", "$location", "$window", 'auth', 'AuthService', 'ZhuotaiService', 'BanciService', '$rootScope', "ScannerStr", 'AndroidService',
    function ($scope, $location, $window, auth, AuthService, ZhuotaiService, BanciService, $rootScope, ScannerStr, AndroidService) {

        $scope.data = ScannerStr;
        $scope.currentOrder = new Order();
        $scope.currentOperator = $rootScope.curUser;
        $scope.init = function () {
            var HotelName = CONSTANTS.SystemConfigs["HotelName"];
            console.log(HotelName);
            if (null != HotelName) {
                $scope.hotelName = HotelName.systemConfigValue;
            }
            if(Utils.isMobile()){
                Utils.setStorage("SELECT_PRINT", true);
            }else{
                var selectPrintType = localStorage.getItem("SELECT_PRINT");
                if(Utils.isEmpty(selectPrintType)){
                    Utils.setStorage("SELECT_PRINT", false);
                }
            }
            if(KEYBOARDSELECT == null) {
            $rootScope.selectKeyboard = true;
            }
        }

        function toastMsg(msg) {
            var msgStr = "";
            if (Utils.isEmpty(msg)) {
                msgStr = LANGUAGECACHE["str_tip_noroot"];
            }
            var result = AndroidAdapter.showDialog(msgStr);
            if (result == "test_dialog") {
                alert(msgStr);
            }
        }

        $scope.setDataStr = function (dataStr) {
            ScannerStr.dataStr = dataStr;
        }

        $scope.setweiXinOrderId = function (weiXinOrderId) {
            ScannerStr.weiXinOrderId = weiXinOrderId;
        }

        $scope.setzhuoTaiCode = function (zhuotaiCode) {
            ScannerStr.zhuotaiCode = zhuotaiCode;
        }

        $scope.setopenId = function (openId) {
            ScannerStr.openId = openId;
        }

        $scope.setCaiPins = function (caipins) {
            ScannerStr.caipins = caipins;
        }

        $scope.jiezhang = function () {
            //todo 首先判断有没有权限
            if (!Utils.roleAble(ROLE_POWER.JS)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            //todo 然后判断该操作员有没有开班
            if ($rootScope.curUser.getNeedKaiBan()) {
                //todo 提示先开班
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstkaiban"])
            } else {
                $location.url("/zhuotaijiesuan");
            }
        }


        $scope.diancai = function () {
            if (!Utils.roleAble(ROLE_POWER.DC)) {
               Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            $location.url("/zhuotai");
        }


        $scope.huiyuan = function () {
            //toastMsg();
            if ($rootScope.curUser.getNeedKaiBan()) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstkaibanthatjiesuan"]);
                return;
            }

            var now = Utils.now();
            //查看当前账单的落单时间是否是和班次匹配
            if (!$rootScope.curUser.jieSuanRiAllowed(now)) {
                  Utils.showFailureInfo(LANGUAGECACHE['str_tip_banciwei']+"【" + $rootScope.curUser.banCiHao + "】"+LANGUAGECACHE['str_tip_jiebanandjiesuan']);
                  return;
            }

            $location.url("/huiyuancard");
        }

        $scope.clickScanner = function () {
            window.yunshan.gotoScanner();
            //$scope.testScanner('');
        }

        $scope.testScanner = function (datastr) {
            //if (Utils.isEmpty(datastr)) {
            //    return false;
            //}
            //var test = "013$testorderID$oNOBuuOeNcKEOpunlhJU61mrNQ1k,10107|0|1,10108|0|2,10109|0|3,10207|0|1";
            //datastr = test;
            var scanCodeStr = datastr;
            var items = datastr.split(",");
            if (items.length != 0) {
                var zhuotaiinfo = items[0].split("$");
                var weiXinOrderId = zhuotaiinfo[1];
                var zhuotaiCode = zhuotaiinfo[0];
                var openId = zhuotaiinfo[2];

                $scope.setopenId(openId);
                $scope.setweiXinOrderId(weiXinOrderId);
                $scope.setzhuoTaiCode(zhuotaiCode);
                //todo
                // 这个地方需要判断桌台有没有开台，如果已经开台，说明该桌台别其他人占用，提示请换到其他桌台
                //AndroidService.isKaiTai(zhuotaiCode, function (err, seq) {
                //    if (err) {
                //        return Utils.showFailureInfo(err.message);
                //    }
                //    var result = seq;
                //    $scope.setDataStr(test);
                //    if (!Utils.isEmpty(result.guid)) {
                //        //todo
                //        // 如果没有开台，那么自动开台，并且设置默认开台人数
                //        $scope.doKaitai(result, 4);
                //    }
                //});
                Utils.showLoading();
                //todo 获取当前桌台状态
                ZhuotaiService.getZhuotaiByCode(zhuotaiCode,function(err,result){
                    if (err) {
                        //return cb(err);
                        Utils.hideLoading();
                        Utils.showFailureInfo(err);
                        return ;
                    }
                    if(result.length==0){
                        Utils.hideLoading();
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_getzhuotaiinfofail"]);
                        return;
                    }
                    var zhuoTaiInfo = result[0];
                    if (!Utils.isEmpty(zhuoTaiInfo.orderId)) {
                        //该桌台已经开台，直接跳转到点菜界面
                        //todo 已开台的桌台不允许再扫描二维码
                        Utils.hideLoading();
                        Utils.confirm(LANGUAGECACHE["str_tip_cantshaoerweima"], function () {

                        },function(){});
                        /*
                        $scope.setDataStr(scanCodeStr);
                        BUSINESS.CURRENT_ORDER = zhuoTaiInfo.order;
                        BUSINESS.CURRENT_ZHUOTAI = zhuoTaiInfo;
                        ZhuotaiService.lockZhuoTai(zhuoTaiInfo.guid, null, function (err) {
                            Utils.hideLoading();
                            if (err != null){
                                return Utils.showFailureInfo(err);
                            }
                            $location.url("/diancaipos");
                        });
                        */
                    } else {
                        //该桌台未开台，先开台
                        $scope.doKaitai(zhuoTaiInfo, weiXinOrderId,scanCodeStr);
                    }
                });
            }
        }


        $scope.clearUserLoginInfo = function(){
            AuthService.clearCurrentLoginInfo(function(ret){
                console.info(ret);
                window.yunshan.loginoutApp();
            })
        }

        $scope.scannercode = function () {
            window.yunshan.gotoScanner();
        }

        $scope.jieban = function () {
            //todo 判断有没有开班，权限
            if (!Utils.roleAble(ROLE_POWER.JS)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            if ($rootScope.curUser.getNeedKaiBan()) {
                if (!Utils.roleAble(ROLE_POWER.KB)) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                    return;
                }
                BanciService.doKaiBan($rootScope.curUser, function (err, seq) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.currentOperator = $rootScope.curUser;
                });
            } else {
                if (!Utils.roleAble(ROLE_POWER.JB)) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                    return;
                }
                $location.url("/jieban");
            }
        }

        $scope.setting = function () {
            $location.url("/setting");
        }

        function clearCurrentLoginInfo(){
            if($rootScope.curUser!=null){
                AuthService.clearCurrentLoginInfo(function(ret){
                    BUSINESS.CURRENT_ZHUOTAI = null;
                    BUSINESS.CURRENT_ORDER = null;
                    $rootScope.curUser = null;
                    window.yunshan.loginoutApp();
                })
            }
        }

        $scope.logout = function () {
            AuthService.logout().then(function (result) {
                AuthService.clearCurrentLoginInfo(function(ret){
                    console.info(ret);
                })
                BUSINESS.CURRENT_ZHUOTAI = null;
                BUSINESS.CURRENT_ORDER = null;
                $rootScope.curUser = null;
                $location.path("/login");
            }, function (error) {
                console.log(error);
            });
        };

        $scope.doKaitai = function (currentZhuoTai, weiXinOrderId,test) {

            $scope.currentOrder.zhuotai = currentZhuoTai.guid;
            $scope.currentOrder.renshu = currentZhuoTai.canweishu==null?4:currentZhuoTai.canweishu;
            $scope.currentOrder.comments = "";
            $scope.currentOrder.totalPrice = 0;

            $scope.currentOrder.serverId = $scope.currentOperator.code;
            $scope.currentOrder.serverName = $scope.currentOperator.name;//todo 需要从数据库获取name
            $scope.currentOrder.operator = $scope.currentOperator.id;
            $scope.currentOrder.operatorName = $scope.currentOperator.name;
            $scope.currentOrder.operatorCode = $scope.currentOperator.code;
            $scope.currentOrder.kaiTaiTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            $scope.currentOrder.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            $scope.currentOrder.mdId = $scope.currentOperator.mdId;

            if (BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()) == null) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_wucanbie"]+'!');
            }
            $scope.currentOrder.canbieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
            $scope.currentOrder.canBieCode = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).code;
            $scope.currentOrder.canbieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
            $scope.currentOrder.zhuotaiCode = currentZhuoTai.code;
            $scope.currentOrder.zhuotaiName = currentZhuoTai.name;
            $scope.currentOrder.areaGuid = currentZhuoTai.areaId;
            $scope.currentOrder.areaCode = currentZhuoTai.areaCode;
            $scope.currentOrder.areaName = currentZhuoTai.areaName;

            ZhuotaiService.lockZhuoTai(currentZhuoTai.guid, null, function (err) {
                if (err != null){
                    Utils.hideLoading();
                    $scope.setDataStr("");
                    return Utils.showFailureInfo(err);
                }
                //开台时候需要把订单来源，以及微信的订单ID插入到pos_order表中
                ZhuotaiService.doScannerKaitai(currentZhuoTai, $scope.currentOrder,weiXinOrderId, function (err, seq) {
                    Utils.hideLoading();
                    if (err) {
                        Utils.showFailureInfo(err.message);
                        $scope.setDataStr("");
                        return;
                    }

                    $scope.currentOrder.status = 1;
                    var orderId = seq;
                    $scope.currentOrder.guid = orderId;
                    currentZhuoTai.orderId = orderId;
                    currentZhuoTai.order = $scope.currentOrder;
                    $scope.setDataStr(test);
                    BUSINESS.CURRENT_ORDER = $scope.currentOrder;
                    BUSINESS.CURRENT_ZHUOTAI = currentZhuoTai;

                    $location.url("/diancaipos");
                });
            });
        };
    }]);