app.controller("SettingController", ["$scope", "$location", "$window", '$rootScope', "SettingService", 'PosSystemConfigService', 'UploadService',
    function ($scope, $location, $window, $rootScope, SettingService, PosSystemConfigService, UploadService) {

        $scope.deviceName = null;
        $scope.localStorageInstallConfig = null;
        $scope.macAddress = null;
        $scope.ipAddress = null;
        $scope.hqURL = null;
        $scope.posURL = null;
        $scope.username = null;
        $scope.backTime = 15; //默认20s退出
        $scope.radioValues = [{
            name: "网络",
            code: true
        }, {
            name: "小票",
            code: false
        }];

        $scope.radioKeyboardValues = [{
            name: "系统",
            code: true
        }, {
            name: "自定义",
            code: false
        }];


        $scope.radioValuesMobile = [{
            name: "网络",
            code: true
        }];


        // todo 打印规格（暂时不用）
        $scope.specifications = [{
            name: "58",
            code: true
        }, {
            name: "80",
            code: false
        }];
        $scope.selectSpec = false;
        $scope.selectKeyboard = true; //默认选择系统打印机

        $scope.installConfig = BIZCONSTANT.LOCALSTORAGE_INSTALLCONFIG;

        $scope.serverHost = SERVER_HOST.BASE_HOST;
        $scope.posURL = $scope.serverHost + API_CONTEXT.POS;

        $scope.cloudUserPwd = "";//云账号密码
        var xiaopiaoSetting = new XiaopiaoSetting();
        $scope.xiaopiaoSetting = xiaopiaoSetting;
        $scope.selectNet = false; //默认选择系统打印机
        $scope.isMaster = false; //是否是主机
        $scope.settingStep = 0;

        $scope.currentOperator = $rootScope.curUser;

        var posSystemConfigs = [];
        $scope.posSystemConfigs = posSystemConfigs;

        var gongnengSetting = new GongnengSetting();
        $scope.gongnengSetting = gongnengSetting;

        $scope.ReadCardTypes = BIZCONSTANT.READCARD_TYPES;

        $scope.gotoBack = function () {
            window.yunshan.clearClickTimes();
            if ($rootScope.curUser != null) {
                $location.url("/main");
            } else {
                $location.url("/login");
            }
        }

        $scope.copyDatabase = function () {
            window.yunshan.copyDatabase();
        }

        $scope.init = function () {
            $scope.isMaster = Utils.isMaster();
            $scope.cloudUserPwd = "";
            $scope.username = "";
            $scope.macAddress = AndroidAdapter.getMacAddress();
            $scope.ipAddress = AndroidAdapter.getIp();
            $scope.deviceName = AndroidAdapter.getDeviceName();
            InstallConfigService.getLocalStorageInstallConfig(function (configObject) {
                $scope.localStorageInstallConfig = configObject;
            })
            $scope.xiaopiaoSetting.wangluo_DayinjiIP = getSystemConfigForLandPos('wangluo_DayinjiIP', '');

            if ($scope.serverHost.toLowerCase().indexOf("http://") == -1) {
                $scope.serverHost = "http://" + $scope.serverHost;
            }
            $scope.canyinURL = $scope.serverHost;
            $scope.hqURL = $scope.serverHost + API_CONTEXT.BASIC;
            $scope.posURL = $scope.serverHost + API_CONTEXT.POS;
            if (Utils.isMobile()) {
                $scope.radioValues = $scope.radioValuesMobile;
                $scope.selectNet = true;
            } else {
                var select = Utils.getStorage("SELECT_PRINT");
                if (Utils.isEmpty(select + "")) {
                    select = false;
                }
                $scope.selectNet = select;
            }
            $scope.backTime = Utils.getStorage("backTime")==null?20:Utils.getStorage("backTime");
            var selectSpec = Utils.getStorage("PRINT_SIZE");
            if (selectSpec == null) {
                selectSpec = false;
            }
            $scope.selectSpec = selectSpec;
            //getAllConfig();

            var selectKeyboard = Utils.getStorage("KEYBOARD_TYPE");
            if (selectKeyboard == null) {
                selectKeyboard = true;
            }
            $scope.selectKeyboard = selectKeyboard;
        }

        $scope.setSpecification = function (code) {
            if (Utils.isEmpty($rootScope.curUser)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
            }
            $scope.selectSpec = code;
        }

        $scope.saveIp = function () {
            if (Utils.isMaster() == false) {
                InstallConfigService.saveLocal($scope.localStorageInstallConfig);
            }
            Utils.setStorage("SELECT_PRINT", $scope.selectNet);
            Utils.setStorage("backTime",$scope.backTime);
            if ($scope.selectSpec) {
                localStorage.setItem("dayinSize", 58);
            } else {
                localStorage.setItem("dayinSize", 80);
            }
            Utils.setStorage("PRINT_SIZE", $scope.selectSpec);
            Utils.setStorage("KEYBOARD_TYPE", $scope.selectKeyboard);
            $rootScope.selectKeyboard = $scope.selectKeyboard;
            KEYBOARDSELECT = $scope.selectKeyboard;
            if ($scope.selectNet == true) {
                if (Utils.isEmpty($scope.xiaopiaoSetting.wangluo_DayinjiIP)) {
                    Utils.showFailureInfo(LANGUAGECACHE["str_tip_printIPcanempty"]);
                    return false;
                } else {
                    $scope.changeDayinIP();
                }
            } else {
                if ($rootScope.curUser != null) {
                    //window.history.back(1);
                    $location.url("/main");
                } else {
                    if (Utils.isMaster()) {
                        $location.url("/login");
                    } else {
                        window.location = "index.html";
                    }
                }
                window.yunshan.clearClickTimes();
                return Utils.showSuccessInfo(LANGUAGECACHE["str_tip_updatesuccess"]);
            }
        }

        function getSystemConfigForLandPos(key, defaultValue) {
            return window.localStorage[key] || defaultValue;
        }

        $scope.chexiao = function () {
            if ($rootScope.curUser != null) {
                window.yunshan.startYianLianFunction();
            } else {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
            }
        }

        $scope.isLogin = function () {
            if (Utils.isEmpty($rootScope.curUser)) {
                return false;
            } else {
                return true;
            }
        }
        /**
         * 是否显示编辑服务器地址
         * 如果已经登录，需要退出才能修改服务器地址
         * @returns {boolean}
         */
        $scope.showEditServerIp = function () {
            if (Utils.isMaster() || $rootScope.curUser != null) {
                return false;
            } else {
                return true;
            }
        }

        $scope.changeDayinIP = function () {
            //var posSystemSetting = createPosSystemSetting($scope.xiaopiaoSetting.wangluo_DayinjiIP);
            //posSystemSetting.systmConfigName = "wangluo_DayinjiIP";
            //posSystemSetting.systemConfigAlias = "小票打印机网络IP";
            //addOrModSystemconfig(posSystemSetting, true);
            window.localStorage.setItem("wangluo_DayinjiIP", $scope.xiaopiaoSetting.wangluo_DayinjiIP);
            if ($rootScope.curUser != null) {
                $location.url("/main");
            } else {
                window.location = "index.html";
            }
        }


        function createPosSystemSetting(newValue) {
            var posSystemSetting = new SystemConfig();
            posSystemSetting.systemConfigValue = newValue;
            posSystemSetting.mdId = $scope.currentOperator.mdId;
            posSystemSetting.valueType = BIZCONSTANT.POS_SYSTEM_CONFIG_MODULE.gongneng;
            posSystemSetting.operatorId = $scope.currentOperator.id;
            posSystemSetting.operatorCode = $scope.currentOperator.code;
            posSystemSetting.operatorName = $scope.currentOperator.name;
            posSystemSetting.operatorTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");
            posSystemSetting.isDelete = 0;
            return posSystemSetting;
        }

        //
        function addOrModSystemconfig(posSystemSetting, isexit) {
            PosSystemConfigService.addOrModSystemconfig(posSystemSetting, function (err, result) {
                if (null != err) {
                    return Utils.showFailureInfo(err.message);
                }
                if (isexit) {
                    if ($rootScope.curUser != null) {
                        //window.history.back(1);
                        $location.url("/main");
                    } else {
                        window.location = "index.html";
                    }
                }
                return Utils.showSuccessInfo(LANGUAGECACHE["str_tip_updatesuccess"]);
            });
        }

        $scope.setKeyboardCheckedValue = function (code) {

            if (Utils.isEmpty($scope.curUser)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
            }
            $scope.selectKeyboard = code;

        }

        function getSystemConfig(key, defultvalue) {
            var rtvalue = defultvalue;
            if (CONSTANTS.SystemConfigs[key] && CONSTANTS.SystemConfigs[key].systemConfigValue)
                rtvalue = CONSTANTS.SystemConfigs[key].systemConfigValue;
            return rtvalue;
        }

        $scope.confirmLogout = function () {
            if (Utils.isMaster()) {
                $("#logouthost").modal("show");
            } else {
                $("#qiehuanzhuji").modal("show");
            }
        }

        $scope.setCheckedValue = function (code) {
            if (Utils.isEmpty($rootScope.curUser)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
            }
            $scope.selectNet = code;
        }

        $scope.gotoAbout = function () {
            $location.url("/about");
        }

        //分机回到初始化界面
        $scope.gotoInitView = function () {
            InstallConfigService.removeLocalStorageInstallConfig();
        }

        $scope.gotoUnLockZhuoTai = function () {
            $location.url("/unlockDesk");
        }

        // ---------读卡器选择      ----------------//


        function getAllConfig() {
            PosSystemConfigService.getAllConfigsByValueType(function (err, result) {
                $scope.posSystemConfigs = result;
                bindAllConfig();
            }, BIZCONSTANT.POS_SYSTEM_CONFIG_MODULE.gongneng);
        }

        function getSystemConfigValue(key) {
            var systemconfig = Utils.arrayFind($scope.posSystemConfigs, key, "systemConfigName");
            if (null == systemconfig)
                return null;
            else
                return systemconfig.systemConfigValue;
        }

        function bindAllConfig() {
            //gongnengSetting.readCardType = getSystemConfigValue("readCardType");//读卡类型
            //gongnengSetting.huiyuanDayinFenshu = getSystemConfigValue("huiyuanDayinFenshu");//会员单据的打印份数
        }

        $scope.changeReadCardType = function () {

            var posSystemSetting = createPosSystemSetting($scope.gongnengSetting.readCardType);
            posSystemSetting.systmConfigName = "readCardType";
            posSystemSetting.systemConfigAlias = "读卡设置类型";

            addOrModSystemconfig(posSystemSetting, false);
        }

        $scope.dayinFenshuCheck = function (value) {
            return $scope.gongnengSetting.huiyuanDayinFenshu == value;
        }

        $scope.checkDayinFenshu = function (value) {
            $scope.gongnengSetting.huiyuanDayinFenshu = value;
            var posSystemSetting = createPosSystemSetting($scope.gongnengSetting.huiyuanDayinFenshu);
            posSystemSetting.systmConfigName = "huiyuanDayinFenshu";
            posSystemSetting.systemConfigAlias = "会员票据的打印份数";
            addOrModSystemconfig(posSystemSetting, false);
        }

        $scope.gotoSettingView = function () {
            $scope.settingStep = 0;
        }

        $scope.readCardSetting = function () {
            if (Utils.isEmpty($rootScope.curUser)) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
            }
            $scope.settingStep = 1;
        }

        /**
         * pos
         * 注销主机
         */
        $scope.logoutHost = function () {
            $("#logouthost").modal("hide");
            if (Utils.isEmpty($rootScope.curUser)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_firstlogin"]);
                return true;
            }
            if (!$rootScope.curUser.getNeedKaiBan()) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_dontjieban"]+"，<br/>"+LANGUAGECACHE["str_tip_cantlogouthost"]+'！');
                return;
            }
            if (Utils.getStorage("CLOUD_USERNAME") != false) {
                $scope.username = Utils.getStorage("CLOUD_USERNAME");
            }
            //注销之前把一些信息上传到后台，便于下次恢复
            UploadService.uploadUnSynData(function (data) {
                UploadService.uploadBeforLogout(data, function (response) {
                    if (response && response == true) {
                        console.info("同步成功！");
                        $("#zhuxiao").modal("show");
                    } else {
                        //$("#zhuxiao").modal("show");
                        Utils.showFailureInfo(LANGUAGECACHE["str_tip_tongbuerrorlogoutfail"]);
                        console.info("同步失败！");
                    }
                })
            })
            //todo 弹出输入密码框
            //$("#zhuxiao").modal("show");
        }

        $scope.logoutOk = function () {
            if (Utils.isEmpty($scope.cloudUserPwd)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_passwordcantempty"]);
                return true;
            }
            loginout();
        }
        function loginout() {
            try {
                var loadUrl = $scope.hqURL + "/api/v1/login/login?t=1&token=1";
                callAjax(loadUrl, function (result) {
                    if (result.status == "failed") {
                        return Utils.showFailureInfo(result.msg);
                    }
                    if (result.data == null) {
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_getaccountinfofail"]);
                    }

                    $.maskLoader("show", LANGUAGECACHE["str_tip_logouting"]+'...');
                    var configObject = $scope.localStorageInstallConfig;

                    if (configObject == null) {
                        $.maskLoader("hide");
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_localtionhasnotinstallinfl"]+'!');
                    }
                    if (Utils.isMaster(configObject)) {

                        var saveRemoteURL = $scope.posURL + "/api/v1/pos_terminal/add?t=&token=";
                        //提交到云端修改

                        /*组装对象--开始*/
                        var installConfig = new InstallConfig();
                        installConfig.name = configObject.name;
                        installConfig.ip = configObject.ip;
                        installConfig.mac = configObject.mac;
                        installConfig.udid = configObject.udid;
                        installConfig.os = configObject.os;
                        installConfig.isMaster = false;
                        installConfig.masterHost = "";

                        installConfig.groupCode = $rootScope.curUser.groupCode;
                        installConfig.groupId = $rootScope.curUser.groupId;
                        installConfig.groupIdType = $rootScope.curUser.groupIdType;
                        installConfig.addGroupId = $rootScope.curUser.groupId;
                        installConfig.addGroupIdType = $rootScope.curUser.groupIdType;
                        installConfig.addUserId = $rootScope.curUser.id;
                        installConfig.addUser = $rootScope.curUser.name;
                        installConfig.modUserId = $rootScope.curUser.id;
                        installConfig.modUser = $rootScope.curUser.name;
                        installConfig.orgid = $rootScope.curUser.mdId;
                        /*组装对象--结束*/

                        InstallConfigService.saveRemote(saveRemoteURL, installConfig, function (result) {
                            $.maskLoader("hide");
                            if (result == null) {
                                configObject.isMaster = true;
                                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_yunupdatehostinfoerror"]+'。');
                            }
                            //InstallConfigService.saveLocal(result);
                            //讨论下来 删除安装信息
                            InstallConfigService.removeLocalStorageInstallConfig();
                            localStorage.clear();
                            //$location.path("/login");
                            //注销主机之后关闭软件
                            window.yunshan.loginoutApp();
                        });
                    } else {
                        return Utils.showFailureInfo(LANGUAGECACHE["str_tip_currentishostcantlogout"]+'!');
                    }
                }, JSON.stringify({loginName: $scope.username, password: $scope.cloudUserPwd}))

            } catch (error) {
                console.log(error);
                $.maskLoader("hide");
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_logouterror"]+'!');
            }
        }

        $scope.sure_change_z = function () {
            $("#qiehuanzhuji").modal("hide");
            localStorage.clear();
            $location.path("/index");
        }


         $scope.getPmNameI18n = function(name){
                            if (name == '网络') {
                                return LANGUAGECACHE['str_btn_wangluo'];
                            } else if(name == '小票') {
                                return LANGUAGECACHE['str_btn_xiaopiao'];
                            } else if(name == '系统') {
                                return LANGUAGECACHE['str_btn_system']
                            } else if(name == '自定义') {
                                return LANGUAGECACHE['str_btn_diy'];
                            } else {
                                return name;
                            }
                        }
    }]);