app.controller("ZhuotaiCtrl", ["$scope", "$location", "$timeout", '$interval', '$q', 'database', 'auth', 'AuthService', '$routeParams', '$rootScope', 'ZhuotaiService',
    'PrintService', 'DiancaiService',
    function ($scope, $location, $timeout, $interval, $q, database, auth, AuthService, $routeParams, $rootScope, ZhuotaiService, PrintService, DiancaiService) {
        $scope.currentOperator = $rootScope.curUser;
        $scope.areas = [];
        $scope.currentSelectZhuoTai = 0;
        $scope.contentNum = 1;
        $scope.deskAreaHeight = 0;
        $scope.zhuotais = {
            total: 0,
            pages: 0,
            rows: 24,
            currentPage: 1,
            items: []
        };
        $scope.currentArea = null;
        $scope.currentZhuotai = null;
        $scope.currentOrder = new Order();
        $scope.currentFocus = null;
        $rootScope.ContextEnv = window.CONTEXT.env;

        $scope.yiKaitaiCount = 0;
        $scope.weiKaitaiCount = 0;
        $scope.yiYuJieCount = 0;
        $scope.allzhuotaiCount = $scope.yiKaitaiCount + $scope.weiKaitaiCount;

        $scope.showKaitai = null;
        $scope.queryParam = new queryZTByParams();

        $scope.inHuantai = false;
        $scope.huantaiOrignal = null;
        $scope.huantaiTarget = null;

        $scope.selectValue = null;
        $scope.oldZhuotais = null;

        $scope.validateSources = [];
        $scope.pagination = new pagination({rows: [], size: 30});
        // $scope.pagination.culsize($('.ys-check-list').height() - 41, 41);

        /* 控制 输入框录入   开始*/
        $scope.curInputText = "renshu";
        $scope.personNo = "";
        $scope.renshu = "";

        $scope.refreshrows = 0;

        $scope.allZhuoTais = []; //作为全局速查的数据源

        var isfirstInit = false;

        $scope.ztfootloading = true;
        var stop = true;

        var allConsumeType = {};

        $scope.init = function () {
            $scope.zhuotais.currentPage = 1;
            stop = true;
            Utils.showLoading();
            //加载区域信息
            loadAreas();
            //计算每次请求加载的桌台数量
            calZhuotaiRows();
            //得到已开台数量
            //getYiKaitaiCount();
            //得到未开台数量
            //getWeiKaitaiCount();
            //得到预结数量
            //getYiYuJieCount();
            getZTCountGroupByStatus();
            //初始化滑动操作事件
            scrollinit();
            //根据之前操作获取桌台列表
            if ($scope.currentZhuotai != null && $scope.currentZhuotai.inArea != null) {
                $scope.currentArea = $scope.currentZhuotai.inArea;
                $scope.queryParam.areaId = $scope.currentArea.guid();
            } else if ($scope.currentZhuotai != null && $scope.currentZhuotai.showKaitai != null) {
                $scope.showKaitai = $scope.currentZhuotai.showKaitai;
            } else {
                $scope.currentZhuotai = null;
            }
            getZhuotais();
            updateFooter();
            if (CONSTANTS.SystemConfigs["ServerHost"] != null && CONSTANTS.SystemConfigs["ServerHost"].SystemConfigValue != null) {
                $scope.serverHost = CONSTANTS.SystemConfigs["ServerHost"].SystemConfigValue;
                $scope.posURL = $scope.serverHost + "/sop-pos-api";
            }

            ZhuotaiService.getAllCaipinsInConsumeType(function (e, r) {
                if (!e) {
                    if (r.length > 0) {
                        for (var i = 0; i < r.length; i++) {
                            var key = "a" + r[i].consumptionId;
                            if (allConsumeType[key] === undefined) {
                                allConsumeType[key] = [];
                                allConsumeType[key].push(r[i]);
                            } else {
                                allConsumeType[key].push(r[i]);
                            }
                        }
                    }
                }
            })
        };
        //滑动到底监听
        function scrollinit() {
            $("#desk_list").scroll(function () {
                if (!Utils.isEmpty($scope.selectValue)) {
                    $scope.ztfootloading = false;
                    return;
                }
                var scrollOffset = $(this).scrollTop();
                var divHeight = $(this).height();
                var contentHeight = $(this).height();

                if (scrollOffset + divHeight >= contentHeight * $scope.contentNum) {
                    //此处是滚动条到底部时候触发的事件，在这里写要加载的数据，或者是拉动滚动条的操作
                    if (stop == true) {
                        $scope.contentNum++;
                        stop = false;
                        $scope.ztfootloading = true;
                        $scope.clickNextPage();
                    }
                    if ($scope.zhuotais.currentPage == $scope.zhuotais.pages) {
                        $scope.ztfootloading = false;
                    }
                }
            });
        }

        //计算每页显示的桌台数
        function calZhuotaiRows() {
            var deskAreaHeight = $("#_rootElement").height() - $(".bg-main").height() - $(".swiper-container").height() - $(".text-main").height();
            $scope.deskAreaHeight = deskAreaHeight;
            var deskAreaWidth = $(window).width();
            var deskHeight = 70;
            var rows = Math.floor(deskAreaHeight / deskHeight) * 3;
            //对计算出来的数量求余，确保填充完每一行
            var calnum = rows % 3;
            rows = rows - calnum;
            $scope.zhuotais.rows = rows;
            $scope.refreshrows = rows;
        }

        function loadAreas() {
            ZhuotaiService.getAreas(function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.areas = seq;
                isfirstInit = true;
            });
        }

        function getZTCountGroupByStatus() {
            ZhuotaiService.getZhuotaiStatusCount($scope.queryParam, function (err, countgroup) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }

                $scope.yiKaitaiCount = countgroup.ykt;
                $scope.yiYuJieCount = countgroup.yyj;
                $scope.weiKaitaiCount = countgroup.wkt;
            });

        }

        function refreshZhuoTais() {
            ZhuotaiService.getZhuotaiCountByParams($scope.queryParam, function (err, seq) {
                if (err) {
                    Utils.showFailureInfo(err.message);
                    seq = 0;
                }
                $scope.zhuotais.total = seq;
                $scope.zhuotais.pages = Math.ceil($scope.zhuotais.total / $scope.zhuotais.rows);
                var refersSize = $scope.yiKaitaiCount + $scope.weiKaitaiCount;
                //之前是 刷新refreshrows 不是刷新全部
                // 速查有问题，先改为刷新全部
                ZhuotaiService.getZhuotaisByParams($scope.queryParam, 0, $scope.refreshrows, function (err, seq) {
                    if (err) {
                        Utils.showFailureInfo(err.message);
                        seq = [];
                    }
                    if (Utils.isEmpty($scope.selectValue)) {
                        $scope.zhuotais.items = seq;
                    } else {
                        $scope.searchChange($scope.allZhuoTais);
                    }
                });
            });
        }

        /* JP 2016-04-20
         * 加载桌台的方法
         * 参数为一个条件对象
         */
        function getZhuotais() {
            //新方法
            ZhuotaiService.getZhuotaiCountByParams($scope.queryParam, function (err, seq) {
                if (err) {
                    Utils.hideLoading();
                    Utils.showFailureInfo(err.message);
                    seq = 0;
                }
                $scope.zhuotais.total = seq;
                if ($scope.zhuotais.total <= $scope.zhuotais.rows) {
                    $scope.ztfootloading = false;
                } else {
                    $scope.ztfootloading = true;
                }
                $scope.zhuotais.pages = Math.ceil($scope.zhuotais.total / $scope.zhuotais.rows);
                getZhuotaisByParams();

                Utils.hideLoading();
                if ($scope.allZhuoTais.length == 0) {
                    $scope.queryParam.status = null;
                    ZhuotaiService.getZhuotaisByParams($scope.queryParam, 0, $scope.zhuotais.total, function (err, seq) {
                        if (err) {
                            Utils.showFailureInfo(err.message);
                            seq = [];
                        }
                        $scope.allZhuoTais = seq;
                    });
                }
            });
        }

        function getZhuotaisByParams() {
            ZhuotaiService.getZhuotaisByParams($scope.queryParam, ($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                if (err) {
                    Utils.hideLoading();
                    Utils.showFailureInfo(err.message);
                    seq = [];
                }
                $scope.zhuotais.items = seq;
            });
        }

        function getYiKaitaiCount() {
            ZhuotaiService.getZhuotaiCountByStatus(true, function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.yiKaitaiCount = seq;
            });
        }

        function getYiYuJieCount() {
            ZhuotaiService.getZhuotaiCountByStatus(3, function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.yiYuJieCount = seq;
            });
        }

        function getWeiKaitaiCount() {
            ZhuotaiService.getZhuotaiCountByStatus(false, function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.weiKaitaiCount = seq;
            });
        }

        $scope.selectAll = function () {
            if (!Utils.isEmpty($scope.selectValue)) {
                $("#zuotaisearch").select();
            }
        }

        //点击切换桌台状态按钮
        $scope.selectZuoTaiStatus = function (status) {
            $scope.contentNum = 1;
            $scope.clearInput();
            switch (status) {
                case 0:
                    $scope.showKaitai = null;
                    $scope.queryParam.status = null;
                    break;
                case 1:
                    $scope.showKaitai = true;
                    $scope.queryParam.status = true;
                    break;
                case 2:
                    $scope.showKaitai = false;
                    $scope.queryParam.status = false;
                    break;
                case 3:
                    $scope.queryParam.status = BIZCONSTANT.ORDER_STATUS_YI_YuJie;
                    break;
            }
            $scope.currentSelectZhuoTai = status;
            $scope.currentZhuotai = null;
            $scope.currentOrder = new Order();
            $scope.zhuotais.currentPage = 1;
            getZhuotais();
        }

        $scope.selectArea = function (area) {
            $scope.contentNum = 1;
            $scope.clearInput();
            //切换区域清楚状态
            //$scope.queryParam.status = null;

            $scope.currentArea = area;
            $scope.queryParam.areaId = area == null ? null : area.guid;
            $scope.showKaitai = null;
            $scope.currentZhuotai = null;
            $scope.currentOrder = new Order();
            $scope.zhuotais.currentPage = 1;
            stop = true;
            getZhuotais();
            getZTCountGroupByStatus();
        };

        $scope.clickNextPage = function () {
            if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                //todo 弹出加载框
                $scope.currentZhuotai = null;
                $scope.currentOrder = new Order();
                $scope.zhuotais.currentPage += 1;
                ZhuotaiService.getZhuotaisByParams($scope.queryParam, ($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                    stop = true;
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.refreshrows = $scope.zhuotais.currentPage * $scope.zhuotais.rows;
                    for (var i in seq) {
                        $scope.zhuotais.items.push(seq[i]);
                    }
                });
                //todo 关闭加载框
            } else {
                stop = true;
            }
        };
        /* 分页 结束 */

        $scope.sglClickZhuotai = function (zhuotai) {
            $scope.currentZhuotai = zhuotai;
            if (zhuotai.order != null) {
                $scope.currentOrder = zhuotai.order;
            }
            if ($scope.currentZhuotai.order.status < BIZCONSTANT.ORDER_STATUS_YI_KAI_TAI) {
                localStorage.removeItem(zhuotai.name);
                $("#kaitaiDialog").modal('show');
                kaitaiDialogShowAfter();
            } else if (BIZCONSTANT.ORDER_STATUS_YI_KAI_TAI < $scope.currentZhuotai.order.status < BIZCONSTANT.ORDER_STATUS_YI_JIE_SUAN) {
                if (!zhuotai.orderZhuoTai) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_connecttableerror"]);
                }
                var results = JSON.parse(localStorage.getItem(zhuotai.name));
                if ($scope.currentZhuotai.orderId != null && $scope.currentZhuotai.order.code == null && Utils.isEmpty(results)) {
                    $("#qingtaiDialog").modal('show');
                } else {
                    gotoDC();
                }
            }
        };

        function kaitaiDialogShowAfter() {
            $scope.renshu = "";
            $scope.onFocus("renshu");
            $("#renshu").focus();
        }

        $scope.areaSelected = function (area) {
            if ($scope.currentArea == null) {
                return area == null;
            } else {
                return area != null && $scope.currentArea.guid == area.guid;
            }
        };

        $scope.zhuotaiSelected = function (zhuotai) {
            return $scope.currentZhuotai != null && $scope.currentZhuotai.guid == zhuotai.guid;
        };

        $scope.zhuotaiStatus = function (zhuotai, status) {
            return zhuotai.order.status == status;
        };

        $scope.zhuotaiYiKaitai = function (zhuotai) {
            return zhuotai.order.status > 0;
        };

        $scope.zhuotaiYiYuJie = function (zhuotai) {
            return zhuotai.order.status == BIZCONSTANT.ORDER_STATUS_YI_YuJie;
        };

        /* 开台 开始 */
        $scope.kaitai = function () {

            if ($scope.currentZhuotai == null) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_kaitaifail"]);
            }
            if ($scope.currentZhuotai.order.status > 0) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_onkongtaikaitai"]);
            }
            $("#kaitaiDialog").modal('show');
            kaitaiDialogShowAfter();
        };

        $scope.doKaitai = function () {
            if (!Utils.roleAble(ROLE_POWER.KT)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            if (Utils.isEmpty($("#renshu").val()) || $("#renshu").val() <= 0) {
                $("#renshu").val("");
                $("#renshu").focus();
                $scope.currentFocus = $("#renshu");
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_personsmustmorezero"]);
            }
            $scope.currentOrder.zhuotai = $scope.currentZhuotai.guid;
            $scope.currentOrder.renshu = parseInt($("#renshu").val());
            $scope.currentOrder.comments = "";
            $scope.currentOrder.totalPrice = 0;

            //todo 验证服务员是否存在
            $scope.currentOrder.serverId = $scope.currentOperator.code;
            $scope.currentOrder.serverName = $scope.currentOperator.name;//todo 需要从数据库获取name
            $scope.currentOrder.operator = $scope.currentOperator.id;
            $scope.currentOrder.operatorName = $scope.currentOperator.name;
            $scope.currentOrder.operatorCode = $scope.currentOperator.code;
            $scope.currentOrder.kaiTaiTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            $scope.currentOrder.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            $scope.currentOrder.mdId = $scope.currentOperator.mdId;

            if (BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()) == null) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_wucanbie"]);
            }
            $scope.currentOrder.canbieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
            $scope.currentOrder.canBieCode = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).code;
            $scope.currentOrder.canbieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
            $scope.currentOrder.zhuotaiCode = $scope.currentZhuotai.code;
            $scope.currentOrder.zhuotaiName = $scope.currentZhuotai.name;
            $scope.currentOrder.areaGuid = $scope.currentZhuotai.areaId;
            $scope.currentOrder.areaCode = $scope.currentZhuotai.areaCode;
            $scope.currentOrder.areaName = $scope.currentZhuotai.areaName;
            Utils.showLoading();
            ZhuotaiService.lockZhuoTai($scope.currentZhuotai.guid, null, function (err, cb) {
                if (err != null) {
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err);
                }
                ZhuotaiService.doKaitai($scope.currentZhuotai, $scope.currentOrder, function (err, seq) {
                    Utils.hideLoading();
                    if (err) {
                        Utils.showFailureInfo(err);
                        $("#kaitaiDialog").modal('hide');
                        return;
                    }
                    $scope.currentOrder.status = 1;
                    var orderId = seq;
                    $scope.currentOrder.guid = orderId;
                    $scope.currentZhuotai.orderId = orderId;
                    $scope.currentZhuotai.order = $scope.currentOrder;
                    //TODO, 开台数量
                    $scope.yiKaitaiCount += 1;
                    $scope.weiKaitaiCount -= 1;
                    getYiYuJieCount();
                    $("#kaitaiDialog").modal('hide');
                    //$scope.sglClickZhuotai($scope.currentZhuotai);

                    // 消费类型
                    if ($scope.currentZhuotai.consumptionId && $scope.currentZhuotai.consumptionId != ' ') {
                        var mCaipins = "a" + $scope.currentZhuotai.consumptionId;
                        var orderCaipins = [];
                        for (var i in allConsumeType[mCaipins]) {
                            console.log("dayin",$scope.currentOrder.renshu+"test"+allConsumeType[mCaipins][i].caipinNum);
                            var orderCaipin = DiancaiService.GetOrderCaipin($scope.currentOperator, $scope.currentZhuotai.order, $scope.currentZhuotai.orderZhuoTai, allConsumeType[mCaipins][i]);
                            //如果后台维护的是0，那么菜品数量就是桌台的开台人数
                            if(allConsumeType[mCaipins][i].caipinNum==null||allConsumeType[mCaipins][i].caipinNum==0||allConsumeType[mCaipins][i].caipinNum=="0"){
                                orderCaipin.num = $scope.currentOrder.renshu;
                            }
                            orderCaipins.push(orderCaipin);
                        }
                        _.each(orderCaipins, function (orderCaipin) {
                            _.each(orderCaipin.zuofas, function (zuofa) {
                                zuofa.parentCaiPin = null;
                            })
                            _.each(orderCaipin.scombCaipins, function (scombCaipin) {
                                _.each(scombCaipin.zuofas, function (zuofa) {
                                    zuofa.parentCaiPin = null;
                                })
                            })
                        });
                        localStorage.setItem($scope.currentZhuotai.name, JSON.stringify(orderCaipins));
                    }

                    gotoDC();
                });
            });
        };
        /* 开台 结束 */

        function gotoDC() {
            if (!Utils.roleAble(ROLE_POWER.DC)) {
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_noroot"]);
                return;
            }
            window.yunshan.hideKeyboard();
            Utils.showLoading();
            ZhuotaiService.lockZhuoTai($scope.currentZhuotai.guid, null, function (err) {
                Utils.hideLoading();
                if (err != null)
                    return Utils.showFailureInfo(err);
                $scope.currentZhuotai.inPage = $scope.zhuotais.currentPage;
                $scope.currentZhuotai.inArea = $scope.currentArea;
                $scope.currentZhuotai.showKaitai = $scope.showKaitai;
                BUSINESS.CURRENT_ZHUOTAI = $scope.currentZhuotai;
                BUSINESS.CURRENT_ORDER = $scope.currentOrder;
                window.yunshan.hideKeyboard();
                $location.url("/diancaipos");
            });
        }

        $scope.renshuChange = function (val) {
            val = val + "";
            var value = validateRenshu(val);
            changeInput(value);
        }

        //数字键盘-开始
        //录入数字
        $scope.typeNumber = function (numberStr) {
            var value = getInputValue();
            value += "";
            if (value == "0") {
                value = "";
            }
            value += numberStr;

            value = validateRenshu(value);
            changeInput(value);
            // if ("renshu" == $scope.curInputText)

        };
        //清除
        $scope.removeNumber = function () {
            var value = getInputValue();
            value += "";
            value = value.substring(0, value.length - 1);
            if (value == "") {
                value = "0";
            }
            //$scope.currentFocus.val(value);
            changeInput(value);
        };
        //删除
        $scope.clearNumber = function () {
            var val = 0;
            changeInput(val);
        };


        $scope.onFocus = function (ele) {
            $scope.currentFocus = $("#" + ele);
            $scope.curInputText = ele;
        };

        //获取输入框的值
        function getInputValue() {
            if ("renshu" == $scope.curInputText) {
                return $scope.renshu;
            }
        }

        //更改输入框的值
        function changeInput(val) {
            if ("renshu" == $scope.curInputText) {
                $scope.renshu = val;
            }
        }

        /**验证人数
         * 为了在录入验证和更改验证通用，验证最终结果
         */
        function validateRenshu(value) {
            var id = $scope.curInputText;
            var result = value;
            _.each(BIZCONSTANT.REG_NUMBERS, function (item) {
                if (item.IDS.indexOf(id) >= 0) {
                    if (!item.REG_TEXT.test(value)) {
                        result = value.substring(0, value.length - 1);
                    }
                }
            });
            return result;
        }

        $scope.closeDialog = function () {
            $("#kaitaiDialog").modal("hide");
            $scope.curInputText = "renshu";
            $scope.personNo = "";
            $scope.renshu = 0;
        }

        //过滤 桌台 暂时根据桌台名称 ，桌台编号，桌台速查码进行过滤
        $scope.ztfilter = function (item) {
            if (!item)
                return false;
            if (!$scope.selectValue || $scope.selectValue == '' || $scope.selectValue == ' ')
                return true;
            return item.name.toLocaleLowerCase().indexOf($scope.selectValue) > -1 || item.code.toLocaleLowerCase().indexOf($scope.selectValue) > -1 || item.quickCode.toLocaleLowerCase().indexOf($scope.selectValue) > -1;
        }

        //动态获取匹配验证源的信息
        function getValidateSources() {
            $scope.currentArea = null;
            $scope.showKaitai = null;
            $scope.currentZhuotai = null;
            $scope.currentOrder = new Order();
            $scope.zhuotais.currentPage = 1;
            ZhuotaiService.getZhuotaisCount(function (err, seq) {
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }
                $scope.zhuotais.total = seq;
                $scope.zhuotais.pages = Math.ceil($scope.zhuotais.total / $scope.zhuotais.rows);
                ZhuotaiService.getZhuotaisByParams($scope.queryParam, ($scope.zhuotais.currentPage - 1) * $scope.zhuotais.rows, $scope.zhuotais.rows, function (err, seq) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    $scope.validateSources = seq;
                    $scope.zhuotais.items = $scope.validateSources;
                });
            });
        }

        $scope.ISZTSCOPE = true;

        function updateFooter() {
            if ($rootScope.updateFooterstart)
                return;
            $rootScope.PEER_CONNECTION_STATU = true;
            $rootScope.updateFooterstart = true;
        }

        // 间隔10秒刷新桌台
        var refreshInterval = $interval(function () {
            $rootScope.$broadcast('refreshZT', 'true');
        }, 10000);

        $scope.$on('refreshZT', function (event, data) {
            console.log('refreshZT = ' + data);
            refreshZhuoTais();
            getZTCountGroupByStatus();
        });

        $scope.$on("$destroy", function () {
            $interval.cancel(refreshInterval);
        });

        $scope.gotoBack = function () {
            $location.url("/main");
        }

        $scope.clearInput = function () {
            $scope.lastselectvalue = '';
            $scope.selectValue = '';
            if ($scope.oldZhuoTais != null) {
                $scope.zhuotais.items = $scope.oldZhuoTais;
            }
            if ($scope.zhuotais.currentPage < $scope.zhuotais.pages) {
                $scope.ztfootloading = true;
            } else {
                $scope.ztfootloading = false;
            }
        };
        //桌台过滤
        $scope.lastselectvalue = '';
        $scope.searchChange = function (zhuoTaiItems) {
            if (Utils.isEmpty(zhuoTaiItems)) {
                zhuoTaiItems = $scope.allZhuoTais;
            }
            if ($scope.selectValue && $scope.selectValue != '') {
                if (!$scope.lastselectvalue || $scope.lastselectvalue == '') {
                    $scope.oldZhuoTais = $scope.zhuotais.items;
                }
                var filterList = [];
                for (var i = 0; i < zhuoTaiItems.length; i++) {
                    var item = zhuoTaiItems[i];
                    if (item.code.toLocaleLowerCase().indexOf($scope.selectValue) > -1 || item.quickCode.toLocaleLowerCase().indexOf($scope.selectValue) > -1) {
                        filterList.push(item);
                        //每次只查10条,如果当前结果集大于10条就跳出循环，继续输入匹配
                        if (filterList.length >= 10) {
                            break;
                        }
                    }
                }
                $scope.zhuotais.items = filterList;
                $scope.ztfootloading = false;
            } else {
                if ($scope.oldZhuoTais != null) {
                    $scope.zhuotais.items = $scope.oldZhuoTais;
                    $scope.selectValue = null;
                }
            }
            $scope.lastselectvalue = $scope.selectValue;
        }

        $scope.gotoDianCai = function () {
            gotoDC();
        }

        $scope.gotoQingtai = function () {
            Utils.showLoading();
            ZhuotaiService.lockZhuoTai($scope.currentZhuotai.guid, null, function (err) {
                if (err != null) {
                    Utils.hideLoading();
                    return Utils.showFailureInfo(err);
                }
                ZhuotaiService.qingTai($scope.currentZhuotai, function (err, model) {
                        Utils.hideLoading();
                        $("#qingtaiDialog").modal('hide');
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }
                        $scope.currentZhuotai.orderId = null;
                        $scope.currentZhuotai.order = new Order();
                        $scope.yiKaitaiCount -= 1;
                        $scope.weiKaitaiCount += 1;
                        getZTCountGroupByStatus();
                        Utils.showSuccessInfo(LANGUAGECACHE["str_tip_cleartablesuccess"]);
                        ZhuotaiService.openLockZhuoTai($scope.currentZhuotai.guid);
                        $scope.selectArea($scope.currentArea);
                    }
                );
            });
        };

        //解锁桌台
        $scope.openLcokZhuotai = function () {
            if (!$scope.currentZhuotai) {
                return Utils.showFailureInfo(LANGUAGECACHE["str_tip_unlockzhuotai"]);
            }
            ZhuotaiService.openLockZhuoTai($scope.currentZhuotai.guid, function (ejzt) {
                if (ejzt) {
                    return Utils.showFailureInfo(LANGUAGECACHE["str_tip_unlocktablefail"]);
                }
                Utils.showFailureInfo(LANGUAGECACHE["str_tip_unlocksuccess"]);
            });
        }
    }]);
