var IOSAdapter = {};

IOSAdapter.getUdid = function () {
     //return "D587B47F-1496-4AE9-83C2-24BB8F3906E3";
     var udid;
     if (typeof (iOS_getUdid) == "function") {
          udid = iOS_getUdid();
     } else {
          console.info("Can not get udid");
     }
     if (!udid) {
          // TODO, if NULL
          udid = "D587B47F-1496-4AE9-83C2-24BB8F3906E3";
     }
     return udid;
};

IOSAdapter.getMacAddress = function () {
     //return "justfortest5545566564";
     var macAddress;
     if (typeof (iOS_getMacAddress) == "function") {
          macAddress = iOS_getMacAddress();
     } else {
          console.info("Can not get macAddress");
     }
     if (!macAddress) {
          // TODO, if NULL
          macAddress = "justfortest5545566564";
     }
     return macAddress;
};

IOSAdapter.getIp = function () {
     //return "192.168.5.101";
     var ip;
     if (typeof (iOS_getIp) == "function") {
          ip = iOS_getIp();
     } else {
          console.info("Can not get ip");
     }
     if (!ip) {
          // TODO, if NULL
          ip = "192.168.5.101";
     }
     return ip;
}

IOSAdapter.getDeviceName = function () {
     //return "iPad 4: ios 9.0";
     var deviceName;
     if (typeof (iOS_getDeviceName) == "function") {
          deviceName = iOS_getDeviceName();
     } else {
          console.info("Can not get deviceName");
     }
     if (!deviceName) {
          // TODO, if NULL
          deviceName = "iPad 4: ios 9.0";
     }
     return deviceName;
}

IOSAdapter.isUpdated = function () {
     // 需要返回是否刚才有更新过版本
     //return true;
     var isUpdated = true;
     if (typeof (iOS_isUpdated) == "function") {
          isUpdated = iOS_isUpdated();
     } else {
          console.info("Can not get isUpdated");
     }
     return isUpdated;
}

IOSAdapter.onDatabaseInited = function () {
     // 数据库正常更新后的回调
     if (typeof (iOS_updateLastAppCode) != "function") {
          return;
     }
     iOS_updateLastAppCode();
}

IOSAdapter.blueTouchConnect = function () {
     if (typeof (iOS_blueTouchConnect) != "function") {
          return;
     }
     iOS_blueTouchConnect();
}

IOSAdapter.log = function (obj) {
     if (typeof (iOS_Log) != "function") {
          return;
     }
     iOS_Log(obj);
}

// WebServer ----------------------------------------------------------------

// 打开WebServer
IOSAdapter.webServerStartup = function () {
     if (typeof (iOS_webServerStartup) != "function") {
          return;
     }
     iOS_webServerStartup();
}

// 关闭WebServer
IOSAdapter.webServerShutdown = function () {
     if (typeof (iOS_webServerShutdown) != "function") {
          return;
     }
     iOS_webServerShutdown();
}

// Kafka ----------------------------------------------------------------

IOSAdapter.kafkaServerStartup = function (jsonConfig) {
     if (typeof (iOS_kafkaServerStartup) != "function") {
          IOSAdapter.log("Startup kafka failed");
          return;
     }
     iOS_kafkaServerStartup(jsonConfig);
}

// 打印 ----------------------------------------------------------------

// 打开钱箱
IOSAdapter.openCashbox = function () {
     if (typeof (iOS_openCashbox) != "function") {
          IOSAdapter.log("Open cashbox failed");
          return;
     }
     iOS_openCashbox();
}

// 连接打印机
IOSAdapter.connectPrinter = function ( port, host, requestIndex) {
     if (typeof (iOS_connectPrinter) != "function") {
          IOSAdapter.log("Connect printer failed");
          return;
     }
     iOS_connectPrinter( port, host, requestIndex);
}

// 打印
IOSAdapter.print = function ( text, requestIndex, host) {
     if (typeof (iOS_print) != "function") {
          IOSAdapter.log("Print failed");
          return;
     }
     iOS_print( text, requestIndex, host);
}

// 打印
IOSAdapter.posPrint = function ( text) {
     if (typeof (iOS_posPrint) != "function") {
          IOSAdapter.log("Pos print failed");
          return;
     }
     iOS_posPrint( text);
}

// 断开打印机
IOSAdapter.disconnectPrinter = function ( requestIndex, host) {
     if (typeof (iOS_closePrinter) != "function") {
          IOSAdapter.log("Disconnect printer failed");
          return;
     }
     iOS_closePrinter( requestIndex, host);
}

// 支付 ----------------------------------------------------------------

//银行卡支付
IOSAdapter.bankCardTrans = function (money) {
     if (typeof (iOS_bankCardTrans) != "function") {
          IOSAdapter.log("Bank card payment failed");
          return;
     }
     iOS_bankCardTrans(money);
}

// 后台管理
IOSAdapter.gotoHoutaiguanli = function (url) {
     if (typeof (iOS_gotoHoutaiguanli) != "function") {
          IOSAdapter.log("lanuch page fail");
          return;
     }
     iOS_gotoHoutaiguanli(url);
}
// 外置蓝牙打印机
IOSAdapter.initNativePrinter = function (systemConfig) {
     if (typeof (iOS_initNativePrinter) != "function") {
          IOSAdapter.log("bluetouch connect failed");
          return;
     }
     iOS_initNativePrinter(systemConfig);
}
// 懒加载打印设置
IOSAdapter.lazyInitPosPrinterByConfig = function (printerType) {
     if (typeof (iOS_lazyInitPosPrinterByConfig) != "function") {
          IOSAdapter.log("lazy printer failed");
          return;
     }
     iOS_lazyInitPosPrinterByConfig(printerType);
}
/*******************支付方式*******************/
//支付宝
IOSAdapter.alipayTrans = function (money) {
     if (typeof (iOS_alipayTrans) != "function") {
          IOSAdapter.log("third pay alipay failed");
          return;
     }
     iOS_alipayTrans(money);
}
//微信
IOSAdapter.weixinTrans = function (money) {
     if (typeof (iOS_weixinTrans) != "function") {
          IOSAdapter.log("third pay weixinTrans  failed");
          return;
     }
     iOS_weixinTrans(money);
}
//银行卡
IOSAdapter.bankCardTrans = function (money) {
     if (typeof (iOS_bankCardTrans) != "function") {
          IOSAdapter.log("third pay bankCardTrans failed");
          return;
     }
     iOS_bankCardTrans(money);
}
//修改打印张数
IOSAdapter.updateNativePrinterConfig = function (updateClass,newValue) {
     if (typeof (iOS_updateNativePrinterConfig) != "function") {
          IOSAdapter.log("update printer number failed");
          return;
     }
     iOS_updateNativePrinterConfig(updateClass,newValue);
}
//获取app version
IOSAdapter.getAppVersionName = function () {
     if (typeof (iOS_getAppVersionName) != "function") {
          IOSAdapter.log("get app version failed");
          return;
     }
     var version =  iOS_getAppVersionName();
     return version;
}