/**
 * Created by peter.shang on 2016-01-14.
 *
 * 结算对象
 */

/*************************************************************************************/
/**
 *
 * @constructor
 */
function JieSuan(){
    var _self = this;

    //应收
    this.YING_SHOU = null;

    //已收
    this.yiShou = null;
    // 未收
    this.weiShou = null;
    //找零
    this.zhaoLing = null;
    //用户显示的找零值
    this.zhaoLingForDisplay = null;
    //备注
    this.memo = null;
    //总金额，即，为进行任何整单折扣的金额
    this.gross = null;
    //one-many<PaymentMethod>支付方式
    this.payMethodList =[];
    //one-many<ZheKou>
    this.activeZk = [];
    //one-one<Order>, 一个结算对应一个账单
    //use setOrder() instead
    this.order = null;

    // 与当前结算相关的会员对象
    var _member = null;

    var _previousMember = null;

    //只有在生成JSON的时候应到，存储来自pos_billing的关键信息。
    //其他情况下，不应当使用该属性。
     this.memberProxy = null;

    // 与当前结算相关的反值的会员对象
    var _fanZhiMember = null;

    var _jieSuanNo = null; //结算号

    var _jieSuanGuid = null;//结算单GUID

    this.calculator = { money: "" }; //计算器对象

    this.allpms = [];//所有支付方式（包括抹零，折扣等）

    var _pagination = new pagination({ rows: [], size: 2 });
    //套餐结算对象, 只有当账单中包含了套餐，才有意义
    // Map<orderCaiPin.guid, JieSuan>
    var _taoCanJieSuan = {};

    var _createTime = null;

    //是否忽略虚收, 虚收的支付方式影响分摊。默认情况下，虚收的支付方式会时时计算，
    //这个开关用于手动控制合适把虚收算进分摊。 目前只有在结算界面的地方设置为true；
    var _ignoreXuShou = false;

    this.saving = false;


    this.getPreviousMember = function(){
        return _previousMember;
    }
    this.fakePreviousMember = function(o){
        _previousMember = o;
        _member = o;
    }

    this.stateChangeVer =  new Date().getTime();

    this.setIgnoreXuShou = function(o){
        _ignoreXuShou = o;
    }
    this.getIgnoreXuShou = function(){
        return _ignoreXuShou;
    }

    this.getTaoCanJieSuan = function(){
        return _taoCanJieSuan;
    }

    /**
     *
     * 某个套餐里中的所有菜品， 会创建一个单独的结算对象，这个结算对象会和普通的结算对象一样。
     *
     *
     * @param detailList 套餐内的菜品细目的列表 [ORDERCAIPIN1, ordercaipin2, orderCaipin3]
     */
    this.addTaoCanDetail = function(detailList){
        var fakeTaoCanJieSuan = new JieSuan();
        //fakeTaoCanJieSuan.setPagination(_pagination); 加上这行后，套餐的反结算后，结算方式不会出来。顾注释掉。
        var fakeOrder = new Order();


        _.each(detailList,function(m){
            m.parentOrder = fakeOrder;
            fakeOrder.addCaiPin(m);
        })

        fakeTaoCanJieSuan.setOrder(fakeOrder);
        _taoCanJieSuan[detailList[0].getParentScom().guid]  = fakeTaoCanJieSuan;

    }


    /**
     * 重新计算套餐中的菜品的分摊,
     */
    this.computeFenTan4TaoCan = function(){


        for(var key in _taoCanJieSuan){

            var fakeJieSuan = _taoCanJieSuan[key];
            var tc = _self.order.findCaiPinByKey(key);

            //套餐明细菜品分摊金额合计=套餐菜品金额合计-套餐价格+所有折扣优惠
            var fakeDingE = fakeJieSuan.order.getSumOfZhangDan()  - tc.calShiShou()

            console.log(fakeJieSuan.order.getSumOfZhangDan() +":" + tc.calShiShou() +":" + fakeDingE)


            var zk = new ZheKou();
            zk.zheKouId = "zhekou02";
            zk.zheKouName = "定额折扣";
            zk.zheKouAmount = fakeDingE;
            zk.zheKouCode = BIZCONSTANT.ZHE_KOU_DING_E;
            fakeJieSuan.removeZheKou(zk); //清除掉已有的（可能）
            fakeJieSuan.addZheKou(zk);

        }



    }



    this.setOrder = function(o){
        _self.order = o;
        o.setJieSuan(_self);
        _recaculatePayments();
        _pagination.Init({ rows: _self.getAllPayment() }).last();
        _self.order.markMaxWeight();
    }

    this.setJieSuanNo = function(o){
        _jieSuanNo = o;
    }
    this.getJieSuanNo = function(){
        return _jieSuanNo;
    }

    //判断该结算单是否是临时结算单，
    //临时结算单，是已经应用了各种折扣和支付方式的，但是并未“结账”
    //从结算界面返回，或者 点击结算界面的打印 或者 继续点菜 会生成临时结算单
    this.isTempJieSuan = function(){
        if( _self.getJieSuanGuid() != null && _self.getJieSuanNo() == null)
            return true;

        return false;
    }

    this.setJieSuanGuid = function(o){
        _jieSuanGuid = o;
    }
    this.getJieSuanGuid = function(){
        return _jieSuanGuid;
    }

    /**
     *     设置与本结算相关的会员
     */
    this.setMember = function(member){
        _previousMember =  _member;
        _member = member;
        _self.memberProxy = member;
        if(_member != null)
        _member.setJieSuan(_self);

    }
    this.getMember = function(){return _member};
    this.resetMember = function(){
        if(_member != null)
        _member.resetMember();

    }

    /**
     * 是否存在会员价折扣
     * @returns {boolean}
     */
    this.existHuiYuanPriceZheKou = function(){
        if(zheKouMap.hyPrice != null)
            return true;
        return false;
    }
    /**
     * 是否存在会员折扣率
     * @returns {boolean}
     */
    this.existHuiYuanLvZheKou = function(){
        if(zheKouMap.bl != null && zheKouMap.bl.isHuiYuanLV())
            return true;

        return false;

    }

    /**
     * 使用会员卡结算
     */
    this.useHuiYuanKa = function(){
        var ret  = false;
        //var orderSource = this.order.getOrderSource();
        //if(orderSource && orderSource == "weixin") return false;
        //当前关联的会员对象不为空，则认为sh用会员
        if(_self.getMember() != null) {
            ret = true;
            if(_self.existHuiYuanPriceZheKou()) {
                var isDisableReadCard = CAT_PAR.REMOTE.NOTNEEDCARDWHENHYJ;
                if(isDisableReadCard) {
                    //无需读卡则不作为会员处理
                    ret = false;
                }
            }
        }

        //如果支付方式中存在 “即时扣款类”的支付方式，那么也认为是使用会员卡
        var isZN = false;
        _.each(_self.payMethodList, function(p){
            if(p.fklx === BIZCONSTANT.PM_FKLX_ZN){
                isZN = true;
            }
            if(p.isPayFirst())
                ret = true;
        });

        //如果
        if(_self.memberProxy != null && _self.memberProxy.getCardNo() != null && _self.memberProxy.getCardNo() != undefined && _self.memberProxy.getCardNo() != "undefined" &&  _self.memberProxy.getCardNo().length > 0)
            ret = true;

        //如果是正念卡，认为是非会员
        if(isZN){
            ret = false;
        }

        return ret;
    }

    /**
     * 账单结账的时候，所发送的JSON
     *
     *
     * @param bch
     * @param zdh
     */
    this.json4JieZhang = function(rb){
        var detail = [];

        var desc = "";
        var codes = "";
        var cashPaid = "";
        var cashPaidTotal = 0;
        var isJifen = "";
        //非即时扣款类并且是实收，才会作为现金类消费的总金额
        _.each(_self.payMethodList, function(e){
            if(!e.isPayFirst() && !e.isYouMian()) {
                codes = codes + e.pmId + ",";
                desc = desc + e.name + ",";
                cashPaid = cashPaid + Utils.m(e.pmMoneyAsStr())+",";
                cashPaidTotal = cashPaidTotal + Utils.m(e.pmMoneyAsStr());
                isJifen = isJifen + e.isOfHuiYuanJiFen() +",";
            }

    });

        rb.cardCode = _self.memberProxy.getCardNo();
        //注意，这里需要加上优免的财务科目
        //var ymAmount = 0;
        //_.each(_self.getPaymentOfYouMian(), function(e){
        //    ymAmount = e.pmMoney() + ymAmount;
        //});
        //
        //var ys = _self.order.getYingShou() + ymAmount ;

        var tmp = {
            tradeType:"R06",	//会员卡结账
            //jiezhangTotalMoney:ys,	//结账总金额
            cardTradeDetails:[]
        }

        if(cashPaidTotal > 0) {
            tmp.cardTradeDetails.push({
                tradeDetailType:"RD062",	//现金类消费
                payType:codes,	//付款方式ID
                payTypeName:desc,	//付款方式Name(会员卡)
                payMoney:cashPaidTotal,	//现金消费金额
                isJifen:isJifen,
                payMoneyDetail:cashPaid
            })
        }

        detail.push(tmp);


        rb.cardTrades = detail;

        return rb;
    }


    //增加折扣
    this.addZheKou = function(zk){


        if(zk == null)
            return;

        zk.setJieSuan(_self);
        var original = null;
        if(zk.isHuiYuanJia()){
            original = zheKouMap.hyPrice;
            zheKouMap.hyPrice = zk;
            //不支持折上折（目前是全单打折）
            //如果当前的比例折扣不为空，则删除
            if(zheKouMap.bl != null )
                _self.removeZheKou(zheKouMap.bl);
        }else if(zk.isOfBiLi()){
            original = zheKouMap.bl;
            _self.removeZheKou(original);
            zheKouMap.bl = zk;
            //不支持折上折（目前是全单打折）
            //如果当前的比例折扣不为空，则删除
            if(zheKouMap.hyPrice != null )
                _self.removeZheKou(zheKouMap.hyPrice);

        }else {
            original = zheKouMap.de;
            zheKouMap.de = zk;
        }

        if(original != null){
            zk.ver = original.ver;
            //如果当前折扣不是原来的折扣，那么reset.
            if(zk != original)
                original.reset();
        }else
            zk.ver = new Date().getTime();

        _self.order.markMaxWeight();
        zk.isml = false;
        zk.iszk = true;
        zk.iszf = false;
        _self._add_all_pm(zk);

        //暂时注释掉。
        _recaculatePayments();
        if(_self.doNotAutoSave) {
        }else {
            _pagination.Init({ rows: _self.getAllPayment() }).last();
        }
    }

    //解除与当前结算单相关折扣
    //根据“类别”进行删除，不可以根据比较zk.code进行删除
    this.removeZheKou = function(zk){
        if(zk == null)
            return;


        if(zk.isDingE()){ //定额
            zheKouMap.de = null;
        }else if(zk.isHuiYuanJia() ){ //删除会员价折扣
            zheKouMap.hyPrice = null;
            if(_member != null)
             _member.clearZheKouRule();

        }else {//比例类
            //
            zheKouMap.bl = null;
            if(zk.isHuiYuanLV() && _member != null)
                _member.clearZheKouRule();
        }

        _self.order.markMaxWeight();
        _self._remove_all_pm(zk);
        zk.reset();

        _recaculatePayments();
        if(_self.doNotAutoSave) {
        }else {
            _pagination.reCurPage(_self.getAllPayment());
        }
    }

    //新增雅座卡消费支付方式
    this.addYazuoXFPM = function (yazuoMoney) {
        if(isNaN(yazuoMoney)) {
            return;
        }
        if(yazuoMoney < 0) return;
        var pm = PaymentMethod.YZXF();
        pm.addMoney(yazuoMoney);
        this.addPM(pm);
    }

    //增加支付方式
    this.addPM = function(pm){

        pm.setJieSuan(_self);

        //查看该付款方式是否已经和该结算关联，
        var exist = false;

        _.each(_self.payMethodList, function(p){
           if(p.code == pm.code) {
               exist = true;
           }
        });
        if( !exist ){
            _self.payMethodList.push(pm);

            pm.ver = new Date().getTime();
            pm.isml = false;
            pm.iszk = false;
            pm.iszf = true;
            _self._add_all_pm(pm);
        }


        _recaculatePayments();
        if(_self.doNotAutoSave) {
        }else {
            _pagination.Init({ rows: _self.getAllPayment() }).last();
        }
    }

    //解除支付方式
    this.removePM = function(pm){
        if(pm === null)
            return ;
        _.remove(this.payMethodList, function(n) {
            if (n.code == pm.code) {
                _self._remove_all_pm(pm);
                return true;
            }

            return false;
        });

        pm.reset();


        _recaculatePayments();
        if(_self.doNotAutoSave) {
        }else {
            _pagination.reCurPage(_self.getAllPayment());
        }
    }





    this.getZkDingE = function(){
        if(zheKouMap.de == null)
            return 0.00;
        return zheKouMap.de.zheKouAmount;
    }


    //得到当前使用的 类比例折扣对象
    this.getZkOfBiLi = function(){
        return zheKouMap.bl;
    }

    //得到正念折扣
    this.getZNZK = function(){
        if(zheKouMap.bl && zheKouMap.bl.zheKouId == '-2'){
            return zheKouMap.bl;
        } else {
            return null;
        }
    }

    //是否有支付发生
    this.existPayments = function(){

        var b =  ( this.payMethodList != null && this.payMethodList.length > 0 ) ;

        //1. 无任何支付
        if(!b) return false;

        //2.有支付，并且支付方式多余一个
        if( b && this.payMethodList.length > 1 )
                return true;


        var potentialMember = this.payMethodList[0];
        //3. 只有一个支付方式，并且是非会员支付
        if(! potentialMember.isMember())
            return true;

        //4. 只有一个支付方式，并且金额大于0
        if(   potentialMember.pmMoney() > 0 )
            return true;

        //
        return false;
    }

    //得到“非现金的”支付方式的支付金额的合计
    this.sumOfNoneXianJin = function(){
        var sum = 0;
        _.forEach(_self.payMethodList,function(value){
            if(value.isXianJian() || value.isYouMian())
                return;
            sum = sum + Utils.m(value.pmMoney());
        });

        return sum;
    }



    //是否需要账单中的每个菜都参与分摊
    this.requireEveryoneFenTan = function(){
        //DIFF = 参与分摊的菜品的折前金额 -  参与分摊的菜品的折扣金额
        var diff  = Math.abs(_self.order.getRawTotalMoney4FenTan() - _self.order.getRawTotalZheKou4FenTan() );
        //本结算单要分摊的总金额
        var dk = Math.abs(_self.order.fenTanZongJinE().zheKouAmount);


        if( diff < dk )
            return true;

        if(diff == dk && _self.order.quanYuanFenTan)
            return true;

        return false;
    }






    //得到会员支付方式，只有是会员结算的时候，才有意义
    /**
     * 返回的“会员支付的储值消费” 支付方式
     *
     * 储值消费
     *
     * @returns {*}
     */
    this.getMemberPayment = function(){
        var candidateMem = null;
        _.each(_self.payMethodList, function(e){
            if(e.isMember())
                candidateMem = e;
        });

        return candidateMem;
    }

    //得到会员卡赠送消费支付方式，只有是会员结算的时候，才有意义
    /**
     * 返回的“会员支付的储值消费” 支付方式
     *
     * 储值消费
     *
     * @returns {*}
     */
    this.getMemberZSPayment = function(){
        var candidateMem = null;
        _.each(_self.payMethodList, function(e){
            if(e.isMemberZS())
                candidateMem = e;
        });

        return candidateMem;
    }


    //得到积分消费的支付方式
    this.getMemberPaymentOfJiFen = function(){
        var ret = null;
        _.each(_self.payMethodList, function(e){
            if(e.isJiFen())
                ret = e;

        });

        return ret;
    }

    this.getJiFenMoney = function () {
        var jiFenPM = this.getMemberPaymentOfJiFen();
        if(!jiFenPM) return 0;
        return jiFenPM.pmMoney();
    }


    /**
     *
     * 得到会员所支付的总额，
     * 储值消费支付方式的金额
     */
    this.getMoneyPaidByMember = function(){

        var cz = _self.getMemberPayment();

        if(cz == null)
            return 0;

        return cz.pmMoney();



    }
    /**
     * 、
     * 如果是反值结算，那么
     *
     * @returns {*}
     */
    this.getPreviousMemberPayment = function(){
        var candidateMem = null;
        var candidateMemFanZhi = null;

        _.each(_self.payMethodList, function(e){
            if(e.isMember())
                candidateMem = e;

            if(e.isMemberFanZhi())
                candidateMemFanZhi = e;

        });


        if(candidateMem != null && candidateMemFanZhi != null )
            return candidateMem;

        return null;
    }
    /**
     * 得到 非会员卡 支付的所有支付列表
     *
     */
    this.getNoneMemberPayment = function(){
        var ret = [];

        _.each(_self.payMethodList, function(e){
            if(e.isMember() ||  e.isMemberFanZhi())
                return;

            ret.push(e);
        });

        return ret;
    }

    /**
     * 得到正念支付方式
     *
     */
    this.getZNPayment = function(){
        var candidateMem = null;
        _.each(_self.payMethodList, function(e){
            if(e.isZN())
                candidateMem = e;
        });

        return candidateMem;
    }


    /**
     * 结算单部分的对账单视图
     *
     * @returns {{total: null, ofZheKouName: null, ofZheKouMoney: null, youMian: null, free: null, payment: Array}}
     */
    this.asDuiZhangDanView = function(){

        var youMianSum = 0;
        _.each( _self.getPaymentOfYouMian(), function(e){
            youMianSum = youMianSum + e.pmMoney();
        });

        var hyzk = 0;
        if(_self.existHuiYuanPriceZheKou()) {
            hyzk =  _self.getZheKouMap().hyPrice.zheKouAmount;
        }
        var ret = {
            total: null, //消费合计
            ofZheKouName: null, //折扣率的名字
            ofZheKouMoney: null, //折扣掉的金额
            ofZheKouAmount : null, //折扣率，比如：80,90，等
            youMian : null,//定额
            free: null, //赠送
            payment: _self.payMethodList, //支付方式，财务科目，调用列表中的元素o.pmMoneyAsStr()获得金额
            yingShou: _self.order.getYingShou()  , //应收
            youMianPayment:youMianSum,
            danPinSum : _self.order.sumOfDanPin(), //单品折扣金额
            moLingSum : _self.order.getSumOfMoLing().getAmount(), //抹零金额合计
            zhaoLing: Utils.m(_self.zhaoLing),
            hyJiaYouHui:hyzk
        }


        ret.total = _self.order.getSumOfZhangDan();
        if(zheKouMap.bl != null) {
            ret.ofZheKouName  = zheKouMap.bl.zheKouName;
            ret.ofZheKouMoney =zheKouMap.bl.moneyAsStr();
            ret.ofZheKouAmount = zheKouMap.bl.zheKouAmount;
        }
        if(zheKouMap.de != null) {
            ret.youMian = zheKouMap.de.moneyAsStr()
        }
        ret.free = _self.order.sumOfFree().toFixed(BIZCONSTANT.MONEY_PRECISE)

        return ret;
    }
    //打印结算对象的详细信息，方便核对和测试的时候使用。
    this.printMe = function(){

    var padCount = 15;
        //d["做法折扣金额"] + qpZuoFa.calZheKouZuoFa());
        //console.log("做法实收金额" + qpZuoFa.calShiShouZuoFa());


        console.log(_.padStart(" 账单总金额:",padCount) +this.order.getSumOfZhangDan());
        console.log(_.padStart(" 进入结算界面的总金额 = 账单金额 - 单品金额):",padCount) +this.order.getSum4LuoDan());

        console.log(_.padStart("整单比例折扣总金额:",padCount) +this.order.money4ZhengDanZheKou());
        console.log(_.padStart("整单定额总金额:",padCount) +this.getZkDingE());

        console.log(_.padStart("折扣总金额:",padCount) +this.order.calAllZheKou());
        console.log(_.padStart("应收金额:",padCount)   + this.order.getYingShou());
        //console.log(_.padStart("抹零合计:",padCount)  +this.order.getSumOfMoLing().getAmount());
        console.log(_.padStart("抹零合计:",padCount)  +this.order.zhangDanMoLing());

        console.log(_.padStart("菜品和做法的所分摊金额的合计:",padCount)  +this.order.getSumOfFenTan());
        console.log(_.padStart("需要分摊的金额合计:",padCount)  +this.order.fenTanZongJinE().zheKouAmount);

        console.log(_.padStart("参与分摊的菜品的金额合计:",padCount)  +this.order.getRawTotalMoney4FenTan());
        console.log(_.padStart("参与分摊的菜品的折扣金额合计:",padCount)  +this.order.getRawTotalZheKou4FenTan());
        console.log(_.padStart("单品折扣金额合计:",padCount)  +this.order.sumOfDanPin());
        console.log(_.padStart("会员价优惠金额合计:",padCount)  +this.order.getSumOfHuiYuanJiaZheKou());
        console.log(_.padStart("会员折扣优惠金额合计（如果是使用会员折扣，那么是把他当做整单折扣总金额）:",padCount) );


        var cpList = this.order.caiPinList;
        console.log(_.padStart("菜品名称:",padCount)+"|" +
            _.padStart("折前价格:",padCount)+"|" +
            _.padStart("实收价格(折前金额-折扣金额-分摊金额）:",padCount)+"|" +
            _.padStart("折扣金额:",padCount)+"|" +
            _.padStart("分摊金额:",padCount)+"|" +
            _.padStart("抹零金额:",padCount)+"|" +
            _.padStart("会员价折扣金额:",padCount)+"|" +
            _.padStart("权重:",padCount));
        _.each(cpList, function(v){
            console.log(
                _.padStart(v.name, padCount) + "  |" +
                _.padStart(v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) +"  |" +
                _.padStart(v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) + _.padStart(v.calShiShou4Display(), padCount)+ "  |" +
                _.padStart(v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) +"  |" +
                _.padStart(v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) +"  |" +
                _.padStart(v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) +"  |" +
                _.padStart(v.mZKFromHuiYuanJia().toFixed(BIZCONSTANT.MONEY_PRECISE),padCount) +"  |" +
                _.padStart(v.weight(),padCount)
            );
            //如果菜品有做法：那么
            var prefix = "  【做法】>>>"
            _.each(v.zuofas, function(zf){
                console.log(
                    _.padStart(prefix + zf.name,padCount)+ "  |"+
                _.padStart(zf.mRaw(),padCount)+ "  |"+
                    _.padStart(zf.calShiShou(),padCount)+ "  |"+
                    _.padStart("折扣" + zf.mZk(),padCount)+ "  |"+
                    _.padStart("分摊" + zf.calFenTan(),padCount)+ "  |"+
                    _.padStart("抹零" + zf.calMoLing(),padCount)+ "  |"+
                    _.padStart("权重" + zf.weight(),padCount)

                );
            });


        });

        _.each(_taoCanJieSuan, function(e){
            console.log("套餐分隔线****************************************************************************")
            e.printMe();
        })

        //console.log(_self.asDuiZhangDanView());
    }
    //**************private*************************************************
    //活动的或者生效的折扣模板
   var  zheKouMap = {
        bl : null, //比例类, 可能是内置的比率，比例，和会员折扣
        de : null,  //定额类
        hyPrice : null //会员价
    };




    //得到排序后的折扣信息，按ver大小排序
    //折扣可能是定额和比例（会员折扣）,会员价，三种类型。
    var _getActiveZk = function(){
        var ret = [];
        zheKouMap.bl != null? ret.push(zheKouMap.bl) : null;
        zheKouMap.de != null? ret.push(zheKouMap.de) : null;
        zheKouMap.hyPrice != null? ret.push(zheKouMap.hyPrice) : null;
        ret.sort(function(obj1, obj2) {
            return obj2.ver - obj1.ver;
        });

        return ret;
    }


    var _recaculatePayments = function(){
        recalculateHyPrice();
        _self.activeZk= _getActiveZk();
        var sum = 0;
        var zl = 0.00;
        _.forEach(_self.getPaymentOfNoneYouMian(),function(value){
            sum = sum + Utils.m(value.pmMoney());
        });

        //已收
        _self.yiShou = sum;
        if(sum > 0 )
            zl = Utils.m(sum) - Utils.m(_self.order.getYingShou());
        _self.zhaoLing = zl;
        _self.zhaoLingForDisplay = Math.abs(zl);

        //折扣类和支付方式等，决定了是否需要整个账单参与分摊
        if(_self.requireEveryoneFenTan()){
            _self.order.quanYuanFenTan = true;
            //重新计算权重最大菜品
            _self.order.markMaxWeight();
        }else{
            _self.order.quanYuanFenTan = false;
        }



        var m =  _self.order.getYingShou() - _self.yiShou;
        if (m <= 0)
            _self.calculator.money = 0;
        else
            _self.calculator.money = Utils.m(m); //- _self.order.getSumOfMoLing().getAmount();

        _self.weiShou = _self.calculator.money; //pos竖屏显示未收金额字段

        //console.log(Utils.m(m)  +":" + _self.order.getSumOfMoLing().getAmount() )

        if(_self.doNotAutoSave) {
        }else {
            _self.stateChangeVer =  new Date().getTime();
        }

    }

    //重新计算会员价
    var recalculateHyPrice = function () {
        if(_self.existHuiYuanPriceZheKou()) {
            var hyPriceTotal = _self.order.getSumOfHuiYuanJiaZheKou();
            if(!hyPriceTotal || hyPriceTotal <= 0) {
                _self.removeZheKou(zheKouMap.hyPrice);
            }else {
                zheKouMap.hyPrice.zheKouAmount = hyPriceTotal;
            }
        }
    }

    this.hasZheKouPay4ThirdCoupon = function() {
        var ret = false;
        var zks = _getActiveZk();
        if(zks && zks.length > 0) ret = true;
        return ret;
    }

    this.reCalAll = function(){
        _recaculatePayments();
    }
    //所有的支付方式 包括支付方式 ，折扣，抹零
    this.getAllPayment = function ()
    {

        this.allpms.length = 0;
        var mlpm = {};
        mlpm.isml = true;
        mlpm.iszk = false;
        mlpm.iszf = false;
        mlpm.name = '抹零';
        mlpm.ver = 0;
        mlpm.money = this.order.getSumOfMoLing().getAmount();
        this.allpms.push(mlpm);

        for (var i in this.activeZk)
        {
            var zkpm = this.activeZk[i];
            zkpm.isml = false;
            zkpm.iszk = true;
            zkpm.iszf = false;
           
            this.allpms.push(zkpm);
        }

        for (var i in this.payMethodList)
        {
            var pm = this.payMethodList[i];
            pm.isml = false;
            pm.iszk = false;
            pm.iszf = true;

            this.allpms.push(pm);
        }


        return this.allpms.sort(sortpayment);
    }

    function sortpayment(a,b)
    {
        return a.ver - b.ver;
    }

    //
    this._add_all_pm = function (pm)
    {
        this.allpms.push(pm);
    }

    //
    this._remove_all_pm = function (pm) {
        _.remove(this.allpms, function (n) {
            if (n.pitemindex == pm.pitemindex) {
                
                return true;
            }

            return false;
        });
        //this.allpms.splice(pm,0);
    }



    //分页
    this.setPagination = function(pg){
        _pagination = pg;
    }

    this.getPagination = function(){
        return _pagination;
    }

    this.getZheKouMap = function(){
        return zheKouMap;
    }

    //得到财务属性为优免的 支付方式
    this.getPaymentOfYouMian = function(){

        if(_self.getIgnoreXuShou())
            return [];

        var ret = [] ;
        _.each( _self.payMethodList, function (item) {
                if(item.isYouMian()){
                ret.push(item);
            }
        });

        return ret;

    }

    //得到财务属性为非优免的支付方方式
    this.getPaymentOfNoneYouMian = function(){
        var ret = [] ;
        _.each( _self.payMethodList, function (item) {
            if(_self.getIgnoreXuShou()){
                ret.push(item);
                return;
            }


            if(!item.isYouMian()){
                ret.push(item);
            }
        });

        return ret;
    }

    /**
     * 是否存在现金支付方式
     */
    this.existXianJinPayment = function(){
        var exists = false;
        _.each( _self.payMethodList, function (item) {
           if(item.isXianJian())
            exists = true;
        });

        return exists;

    }

    this.setCreateTime = function(now){
        _createTime = now;
    }

    this.getCreateTime = function(){
        return _createTime;
    }

    this.resetZheKouMap = function(){
        if( zheKouMap.bl != null)
            zheKouMap.bl.reset();
        if( zheKouMap.de != null)
            zheKouMap.de.reset();
        if( zheKouMap.hyPrice != null)
            zheKouMap.hyPrice.reset();

        zheKouMap.bl = null;
        zheKouMap.de = null;
        zheKouMap.hyPrice = null;

    }

    /**
     * 是否有过会员支付？？
     *
     * @returns {boolean}
     */
    this.hasMemberPaid = function(){
        if(_self.getMemberPayment() !== null || _self.getMemberPaymentOfJiFen() !== null)
            return true;

        return false;
    }

    /**
     * 是否有过指定的支付方式
     *
     * @returns {boolean}
     */
    this.hasPayType = function (paycode) {
        var candidateMem = null;
        _.each(_self.payMethodList, function (e) {
            if (e.code===paycode)
                candidateMem = e;
        });

        return candidateMem!=null;
    }


    /**
     * 是否已经用 银行卡 or weixin or alipay 支付过？
     *
     * @returns {boolean}
     */
    this.hasAlreadyPaid = function(name){
        if(_self.getCurrentPayment(name) !== null )
            return true;

        return false;
    }


    /**
     * 返回的“银行卡 or  weixin or alipay 支付的消费” 支付方式
     *
     * 银行卡消费
     *
     * @returns {*}
     */
    this.getCurrentPayment = function(name){
        var candidateMem = null;
        _.each(_self.payMethodList, function(e){
            if (e.isAlreadyPay(name)) {
                candidateMem = e;
            }
        });

        return candidateMem;
    }

    //折扣模板产生的金额+抹零金额
    this.getZheKouMoneyOfTemplate = function () {
        var m = 0;
        for(var i = 0; i < _self.activeZk.length; i++) {
            var zk = _self.activeZk[i];
            m += zk.money4Display();
        }
        m += _self.order.getSumOfMoLing().getAmount();
        return Utils.m(m);
    }


    /**
     * 返回的“银行卡支付的消费” 支付方式
     *
     * 银行卡消费
     *
     * @returns {*}
     */
    this.getBankCardPayment = function(){
        var candidateMem = null;
        _.each(_self.payMethodList, function(e){
            if(e.isBankCard())
                candidateMem = e;
        });

        return candidateMem;
    }

    /**
     * 是否允许取消会员
     */
    this.allowCancelMember  = function(){

        // 支付方式中是否有会员相关的支付方式
        if( _self.hasMemberPaid() )
           return false;

        // 折扣中是否有会员相关的折扣方式
        if(_self.existHuiYuanLvZheKou() || _self.existHuiYuanPriceZheKou() )
            return false;

        return true;

    }

    //是否有会员相关的支付方式（会员卡、会员价、会员折扣、会员积分）
    this.hasRelevantHY = function () {
        var ret = false;
        if(_self.allpms) {
            for(var i= 0; i < _self.allpms.length; i++) {
                var pm = _self.allpms[i];
                if(pm.iszf) {
                    if(pm.code == BIZCONSTANT.PM_HUI_YUAN || pm.code == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE) {
                        //会员卡
                        ret = true;
                        break;
                    }
                }
                if(pm.iszk) {
                    if(pm.zheKouCode == BIZCONSTANT.ZHE_KOU_HY_PRICE || pm.zheKouCode == BIZCONSTANT.ZHE_KOU_HY_ZK) {
                        //会员价/会员折扣
                        ret = true;
                        break;
                    }
                }
            }
        }
        return ret;
    }

}




