﻿function InstallConfig() {
    this.name = null;
    this.ip = null;
    this.mac = null; // windows 必传
    this.udid = null; // android 必传
    this.os = null;
    this.isMaster = true;
    this.masterHost = null; // 主机的ip
}

var InstallConfigService = {};

/**/
InstallConfigService.saveCloudAccount = function (account) {
    window.localStorage.removeItem("_cloud_account");
    window.localStorage.setItem("_cloud_account", account);
}

InstallConfigService.getCloudAccount = function () {
    return window.localStorage.getItem("_cloud_account");
}


/**
获取本机的InstallConfig
*/
InstallConfigService.getLocalStorageInstallConfig = function (callback) {
    var config = window.localStorage.getItem("_install_config_");
    if (config != null && config.length > 0) {
        var obj = JSON.parse(config);
        var configObject = new InstallConfig();
        for (var prop in obj) {
            configObject[prop] = obj[prop];
        }
        callback(configObject);
    } else {
        callback(null);
    }
}


/**
同步的方式获取本机的InstallConfig（我看实际上根本不需要用异步的方式获取，张亚运）
*/
InstallConfigService.getLocalStorageInstallConfigSync = function () {
    var config = window.localStorage.getItem("_install_config_");
    var configObject = null;
    if (config != null && config.length > 0) {
        var obj = JSON.parse(config);
        configObject = new InstallConfig();
        for (var prop in obj) {
            configObject[prop] = obj[prop];
        }
    }
    return configObject;
}

InstallConfigService.removeLocalStorageInstallConfig = function () {
    window.localStorage.removeItem("_install_config_");
}


InstallConfigService.getTongbuLocalStorageInstallConfig = function () {
    var config = window.localStorage.getItem("_install_config_");
    if (config != null && config.length > 0) {
        var obj = JSON.parse(config);
        var configObject = new InstallConfig();
        for (var prop in obj) {
            configObject[prop] = obj[prop];
        }
        return configObject;
    } else {
        return null;
    }
}

/**
获取本机的InstallConfig
*/
InstallConfigService.getRemoteInstallConfig = function (url, callback,showTimeout) {

    /*JP 新方法
    * 把原来的mac和udid 通过外部传入，省略了判断现在共用一个方法
    */
    $.ajax({
        type: "GET",
        url: url,
        timeout: CONSTANTS.REQUESTTIMEOUT,
        dataType: "json",
        success: function (result) {
            if (result == null) 
                return callback(null);
            if ('invalidTimestamp' == result.status)
               return Utils.showFailureInfo('警告: 设备时间日期不对，请修改后重启程序！');
            if ("success" != result.status) {
                return Utils.showFailureInfo(result.msg);
               // return callback(null);
            } else if (Utils.isEmpty(result.data) || Utils.isEmpty(result.data.ip)) {
                return callback(null);
            }

            var config = InstallConfigService.convert(result.data);
            //InstallConfigService.saveLocal(config);
            callback(config);
        },
        contentType: "application/json; charset=utf-8",
        error: function (xhr, status, error) {
            if ((status == "timeout" || status=="error") && showTimeout)
                Utils.showFailureInfo("网络异常,无法获取云端安装信息！");
        }
    });
}

/**
同步的方式获取本地config
*/
InstallConfigService.getSync = function (url) {
    var returnData = null;
    var config = localStorage.getItem("_install_config_");
    if (config != null && config.length > 0) {
        var obj = JSON.parse(config);
        var configObject = new InstallConfig();
        for (var prop in obj) {
            configObject[prop] = obj[prop];
        }
        returnData = configObject;
    }
    else {
        // TODO: API地址需要更改
        if (CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS) {
            var os = require("getmac");
            os.getMac(function (err, macAddress) {
                if (err) throw err;
                $.ajax({
                    type: "GET",
                    url: url + "/pos_terminal?mac=" + macAddress,
                    dataType: "json",
                    async: false,
                    success: function (result) {
                        if (result == null) 
                            return callback(null);
                        if ('invalidTimestamp' === result.status)
                            return Utils.showFailureInfo('警告: 设备时间日期不对，请修改后重启程序！');
                        if ("success" != result.status) {
                            return Utils.showFailureInfo(result.msg);
                            //return callback(null);
                        } else if (Utils.isEmpty(result.dataList) || result.dataList.length == 0) {
                            return callback(null);
                        }
                        var config = InstallConfigService.convert(result.dataList[0]);
                        InstallConfigService.saveLocal(config);
                        returnData = config;
                    },
                    contentType: "application/json; charset=utf-8",
                    error: function (error, data) {
						
                    }
                });
            });

        }
        else if (CONTEXT.env == CONSTANTS.EnvConstants.ANDROID || CONTEXT.env == CONSTANTS.EnvConstants.IOS) {
            var udid = null;
            if (CONTEXT.env == CONSTANTS.EnvConstants.ANDROID) {
                udid = AndroidAdapter.getUdid(); // TODO:调用android暴露给js的方法获取android设备的udid
            } else {
                udid = IOSAdapter.getUdid();
            }

            $.ajax({
                type: "GET",
                url: url + "/pos_terminal?udid=" + macAddress,
                dataType: "json",
                async: false,
                success: function (result) {
                    if (result == null) 
                        return callback(null);
                    if ('invalidTimestamp' === result.status)
                        return Utils.showFailureInfo('警告: 设备时间日期不对，请修改后重启程序！');
                    if ("success" != result.status) {
                        return Utils.showFailureInfo(result.msg);
                        //return callback(null);
                    } else if (Utils.isEmpty(result.dataList) || result.dataList.length == 0) {
                        return callback(null);
                    }
                    var config = InstallConfigService.convert(result.dataList[0]);
                    InstallConfigService.saveLocal(config);
                    returnData = config;
                },
                contentType: "application/json; charset=utf-8",
                error: function (error, data) {

                }
            });
        }
    }
    return returnData;
}


/**
将config信息存到本地
*/
InstallConfigService.saveLocal = function (installConfig) {
    localStorage.setItem("_install_config_", JSON.stringify(installConfig));
}

/**
将云端返回的数据转换成本地的InstallConfig
*/
InstallConfigService.convert = function (remoteObj) {
    var config = new InstallConfig();

    config.name = remoteObj.name;
    config.ip = remoteObj.ip;
    config.mac = remoteObj.mac; // windows 必传
    config.udid = remoteObj.udid; // android 必传
    config.os = remoteObj.os;//操作系统 
    config.isMaster = remoteObj.isMaster;//是否主机
    config.masterHost = remoteObj.masterHost;//主机IP

    config.groupCode = remoteObj.groupCode;
    config.groupId = remoteObj.groupId;
    config.groupIdType = remoteObj.groupIdType;
    config.addGroupId = remoteObj.groupId;
    config.addGroupIdType = remoteObj.groupIdType;
    config.addUserId = remoteObj.addUserId;
    config.addUser = remoteObj.addUser;
    config.modUserId = remoteObj.modUserId;
    config.modUser = remoteObj.modUser;
    config.orgid = remoteObj.orgid;



    return config;
}

/**
将config信息存到云端
*/
InstallConfigService.saveRemote = function (url, installConfig, callback, showTimeout) {
    $.ajax({
        type: "POST",
        url: url,
        timeout: CONSTANTS.REQUESTTIMEOUT,
        dataType: "json",
        data: JSON.stringify(installConfig),
        success: function (result) {
            if (result == null) 
                return callback(null);
            if ('invalidTimestamp' === result.status)
                return Utils.showFailureInfo('警告: 设备时间日期不对，请修改后重启程序！');
            if ("success" != result.status) {
                console.log("添加安装信息错误：" + result.msg);
                return Utils.showFailureInfo(result.msg);
               // return callback(null);
            }
            var localInstallConfig = InstallConfigService.convert(installConfig);

            callback(localInstallConfig);
        },
        contentType: "application/json; charset=utf-8",
        error: function (xhr, status, error) {
            if (status == "timeout" && showTimeout != null && showTimeout != undefined && showTimeout) {
                $.maskLoader("hide");
                return Utils.showFailureInfo("检测到网络存在异常，安装失败！");
            }

            callback(null);
        }
    });
}


/**
获取本机的InstallConfig
*/
InstallConfigService.getRemoteMasterConfig = function (url, callback, showTimeout) {
    $.ajax({
        type: "GET",
        url: url,
        timeout: CONSTANTS.REQUESTTIMEOUT,
        dataType: "json",
        success: function (result) {
            var config = {};
            if ('invalidTimestamp' === result.status)
                return Utils.showFailureInfo('警告: 设备时间日期不对，请修改后重启程序！');
            if ("success" == result.status) {
                if (result.dataList != null && result.dataList.length > 0) {
                    config = InstallConfigService.convert(result.dataList[0]);
                } else {
                    config = null;
                }
            }
            else {
                config.status = "err";
                console.log(result.msg);
            }
            callback(config);
        },
        contentType: "application/json; charset=utf-8",
        error: function (xhr, status, error) {

            if (status == "timeout" && showTimeout != null && showTimeout != undefined && showTimeout) {
                $.maskLoader("hide");
                return Utils.showFailureInfo("检测到网络存在异常，获取主机安装信息失败！");
            }

            callback({ status: "err" });
        }
    });



}