function MPrinter() {
	this.id = null;
	this.name = null;
	this.code = null;
	this.size = null;
	this.backupPrinter = null;
	this.isZhenda = 0;
	this.configs = {};
	this.status = 0; // 0  未连接 1  正常  2  缺纸 
	var me = this;
	this.isWorking = false;
	this.isBackWorking = false;
	
	this.lastWorkTime = 0;//最后一次的工作时间

	this.iconv = null;
    if(typeof(require) != 'undefined'){
        this.iconv = require("iconv-lite");
    }
	
	this.issuePrinters = {};
	
	var log = function (logstr) { console.log(logstr); }

    this.doPrint = function (PrintService, job, callback) {
		if(job.status == 0){
			me._doSelfPrint(PrintService, job, callback);
		}
		else {
			if(PrintService.canBackupPrintDirectly(me.id)){
				me._doBackupPrint(PrintService, job, callback);
			}
			else{
				if(job.errorCount > 1 && me.backupPrinter != null && me.backupPrinter.id != null){
					PrintService.logIssuePrinter(me.id);
					me._doBackupPrint(PrintService, job, callback);
				}
				else {
					me._doSelfPrint(PrintService, job, callback);
				}
			}
		}
	};
	
	this._getPrinter = function(config){
		if(config.type == "network"){
			return {printer:HardWareManager.get(CONSTANTS.HardWareConstants.NET_PRINTER).newInstance(), cfg: {port:config.port, host:config.host}};
		}
		else if(config.type == "system") {
			return {printer:HardWareManager.get(CONSTANTS.HardWareConstants.PRINTER).newInstance(), cfg: {printer: config.printerName}};
		}
		else if(config.type == "serialport") {
			return {printer:HardWareManager.get(CONSTANTS.HardWareConstants.POS_PRINTER).newInstance(), cfg: {path: config.path, baudrate: config.baudrate,parity:config.parity,databits:parity.databits,stopbits:config.stopbits}};
		}
	};
		
	this._doSelfPrint = function (PrintService, job, callback) {
	    job.final_printer_id = job.mPrinterId;
	    var timespan = parseInt(new Date().getTime() / 1000) - me.lastWorkTime;
	    if (me.isWorking && timespan < 60)//防止打印服务出现意外情况假死，加上距上次执行1分钟的判断
	    {
			window.setTimeout(function(){
				me._doSelfPrint(PrintService, job, callback);
			}, 500);
			return;
	    }
	    log('self print begin');
		me.isWorking = true;
		me.lastWorkTime = parseInt(new Date().getTime() / 1000);

		var printer = me._getPrinter(me.configs);
		var netPrinter = printer.printer;
		netPrinter.connect(printer.cfg, function () {
		    job.printCount += 1;
		    job.printTime = new Date();
		    var formattedText = PrinterTemplate.fillJobInfo(job.content, job);
		    var buffer = Utils.encodeBuffer(formattedText, 'gbk');
			netPrinter.print(buffer, function () {
				job.status = PrinterJob.SUCCESS;
				PrintService._addJobLog(job, "打印成功");
				log("打印成功");
				PrintService._saveJob(job);
				me.isWorking = false;
				callback();
			}, function (printerr) {
			    job.errorCount += 1;
			    job.status = PrinterJob.NO_CONNECT;
			    PrintService._addJobLog(job, "打印失败：" + printerr.message);
			    log("打印失败：" + printerr.message);
			    PrintService._saveJob(job);
			    netPrinter.disconnect();
			    me.isWorking = false;
			    callback();
			});
			netPrinter.flush();
			netPrinter.disconnect();
		}, function(err){
			job.errorCount += 1;
			job.status = PrinterJob.NO_CONNECT;
			PrintService._addJobLog(job, err.message);
			PrintService._saveJob(job);
			me.isWorking = false;
			callback();
		}, function(err){
			job.errorCount += 1;
			job.status = PrinterJob.NO_CONNECT;
			PrintService._addJobLog(job, "无法连接打印机");
			log("无法连接打印机");
			PrintService._saveJob(job);
			netPrinter.disconnect();
			me.isWorking = false;
			callback();
		});
	};
	
	this._doBackupPrint = function (PrintService, job, callback) {
		job.final_printer_id = this.backupPrinter.id;
	    if (me.isBackWorking) {
			window.setTimeout(function(){
				me._doBackupPrint(PrintService, job, callback);
			}, 500);
			return;
	    }
	    log('backworking print begin');
	    me.isBackWorking = true;
		var printer = me._getPrinter(me.backupPrinter.configs);
		var netPrinter = printer.printer;
		netPrinter.connect(printer.cfg, function(){
			// TODO 开始打印
		    job.printCount += 1;
		    job.printTime = new Date();
		    var buffer = Utils.encodeBuffer(PrinterTemplate.fillJobInfo(job.content, job), 'gbk');
			netPrinter.print(buffer, function(){
				job.status = PrinterJob.SUCCESS;
				PrintService._addJobLog(job, "[使用备打]: 打印成功");
				log("[使用备打]: 打印成功");
				PrintService._saveJob(job);
				me.isBackWorking = false;
				callback();
			});
			netPrinter.flush();
			netPrinter.disconnect();
		}, function(err){
			job.errorCount += 1;
			job.status = PrinterJob.NO_CONNECT;
			PrintService._addJobLog(job, "[使用备打]: " + err.message);
			log("[使用备打]: " + err.message);
			PrintService._saveJob(job);
			me.isBackWorking = false;
			callback();
		}, function(err){
			job.errorCount += 1;
			job.status = PrinterJob.NO_CONNECT;
			PrintService._addJobLog(job, "无法连接打印机");
			log("无法连接打印机");
			PrintService._saveJob(job);
			netPrinter.disconnect();
			me.isBackWorking = false;
			callback();
		});
	};
	
	this.checkStatus = function (PrintService, callback) {
		if(me.isWorking){
			window.setTimeout(function(){
				me.checkStatus(PrintService, callback);
			}, 500);
			return;
		}
		me.isWorking = true;		
		var printer = me._getPrinter(me.configs);
		var netPrinter = printer.printer;
		netPrinter.connect(printer.cfg, function(){
		    var buffer = Utils.encodeBuffer(PrinterCommand.CMD_SetPos(), 'gbk');
			netPrinter.print(buffer, function () {
				me.status = MPrinter.CONNECTED;
				PrintService._addPrinterStatusLog(me, "打印机工作正常");
				PrintService._updatePrinter(me);
				me.isWorking = false;
				callback();
			}, function (err) {
			    me.status = MPrinter.NO_CONNECT;
			    PrintService._addPrinterStatusLog(me, "无法连接打印机");
			    PrintService._updatePrinter(me);
			    me.isWorking = false;
			    callback();
			});
			netPrinter.flush();
			netPrinter.disconnect();
		}, function (err) {
			me.status = MPrinter.NO_CONNECT;
			PrintService._addPrinterStatusLog(me, "无法连接打印机");
			PrintService._updatePrinter(me);
			me.isWorking = false;
			callback();
		});
	};
}
MPrinter.CONNECTED = 1;
MPrinter.NO_CONNECT = 0;
MPrinter.LESS_PAPER = 2;