
function OrderCaipinZuofa(){
    var owner = this;
    this.guid = null;
    this.orderCaipinId = null;
    this.zuofaId = null;
    this.name = null;
    this.typeId = null;
    this.price = 0;
    this.jiajiaType = null;
    this.operator = null;
    this.modTime = null;
    this.isScomb = null;
    this.orderScombCaipinId = null;//关联的订单套餐菜品ID pos_order_scomb_caipin

    //begin，added by peter
    //与该做法相关的菜品
    this.parentCaiPin = null;

    this.maxWeightInCurrentOrder = false;


    //end，added by peter


    /************************************************************************************/
    /************************************************************************************/
    /************************************************************************************/
    /************************************************************************************/


    /**
     * 做法的折前金额
     */
    this.mRaw = function(){
        var p = _.isNil(owner.price) ? 0 : owner.price;
        var n =  _.isNil(owner.parentCaiPin.num ) ? 0 :owner.parentCaiPin.num;

        //只要菜品的数量为0，无论其做法加价是数量或者是定额，则都返回0
        if(n == 0 )
            return 0;

        if(owner.isShuLiangJiaJia())
            return Utils.m(p * n);

        //如果是定额加价，并且是套餐内的菜品,那么用做法价格 * “套餐”的分数
        if(  owner.parentCaiPin.isScombCaipin() ){
            return  Utils.m(owner.parentCaiPin.getParentScom().num * owner.price);

        }

        //定额加价
        if(owner.parentCaiPin.num < 0)
            return Utils.m(-p);



        return Utils.m(p);
    }

    /**
     * 做法的赠送金额
     */
    this.mFree = function(){
        //1. 存在单品打折
        if(owner.existDpZk())
            return 0;

        var m =  _.isNil(owner.parentCaiPin.num ) ? 0 :owner.parentCaiPin.num;
        var n =  _.isNil(owner.parentCaiPin.zengNum ) ? 0 :owner.parentCaiPin.zengNum;
        var p = _.isNil(owner.price) ? 0 : owner.price;


        //2. 数量加价
        if(owner.isShuLiangJiaJia())
            return p * n;

        //定额加价

        //全部赠送。那么定额即为赠送金额
        if(m > 0 && m == n)
            return p;

        return 0;

    }

    /**
     * 做法参与整单折扣的金额
     */
    this.mRaw4ZhengDan = function(){
        if(owner.existDpZk())
            return 0;

        return owner.mRaw() - owner.mFree();
    }



    /**
     * 折扣金额 - 赠送产生的部分
     */
    this.mZkFromFree = function(){

        return owner.mFree();
    }

    /**
     * 折扣金额 -整单产生的部分
     */
    this.mZkFromZhengDan = function(){
        return owner.mRaw4ZhengDan() *  (100-owner.getAvailableZheKou())/100;
    }

    /**
     * 折扣金额 - 单品比例产生的部分
     */
    this.mZkFromDanPinBiLi = function(){
        if(! owner.existDpZk())
            return 0;


        return  Utils.m(owner.mRaw() *(100 -owner.getAvailableZheKou() ) / 100);
    }


    /**
     * 折扣总金额
     */
    this.mZk = function(){
        //如果是套餐中的菜品，那么认为做法折扣金额为0
        if(owner.parentCaiPin.isScombCaipin())
            return 0;

        return Utils.m(this.mZkFromDanPinBiLi() + this.mZkFromFree() + this.mZkFromZhengDan());
    }

    /**
     * 做法的实收价格
     * @returns {number}
     */
    this.calShiShou = function(){
        return Utils.m(owner.mRaw() - owner.mZk() - owner.calFenTan());
    }


    /**
     *     分配到当前做法的【抹零的金额】.
     *
     *     只有最大权重的菜品或者做法才会分摊【被抹零的】的金额
     *     非最大权重的菜品或者做法，默认被抹零到的金额为0
     * @returns {number}
     */
    this.calMoLing = function(){
        var ret = 0.00;
        if(owner.maxWeightInCurrentOrder){
            var tmp = owner.parentCaiPin.parentOrder.fenTanZongJinE();
            if( ! owner.parentCaiPin.greaterOrEqualOne(tmp.zheKouAmount) )
                ret = ret +   owner.parentCaiPin.parentOrder.zhangDanMoLing();
        }


        return ret;
    }


    /**
     * 做法的分摊金额
     */
    this.calFenTan = function(){
        var tmp = owner.parentCaiPin.parentOrder.fenTanZongJinE();

        var ret = 0.00;
        //非最大权重
        if(! owner.maxWeightInCurrentOrder ){
            ret =  owner.parentCaiPin.greaterOrEqualOne(tmp.zheKouAmount) ? owner.weight() *  tmp.zheKouAmount : ret;

            return Utils.m(ret);
        }

        //是最大权重
        ret =  owner.parentCaiPin.greaterOrEqualOne(tmp.zheKouAmount) ?   tmp.zheKouAmount -  owner.parentCaiPin.parentOrder.getSumFenTanOfCommon() : tmp.zheKouAmount;
        
        return Utils.m(ret);

    }


    /*
     * 做法权重
     *    # 做法权重=（做法折前金额-做法折扣金额）/（【参与分摊的】菜品和做法的折前金额总计-【参与分摊的】菜品和做法的折扣金额总计）
     */
    this.weight = function(){
        if(!owner.isFenTan())
            return 0;

        var m  = owner.parentCaiPin.parentOrder.getRawTotalMoney4FenTan() - owner.parentCaiPin.parentOrder.getRawTotalZheKou4FenTan();
        if(m == 0)
            return 0;
        return (owner.mRaw() - owner.mZk()) / m;
    };



    /****************************************************/
    //对账单和结算单的中的做法的实收金额 = 折前金额 - 单品比例的折扣
    this.m4Print = function(){
        return owner.mRaw() - owner.mZkFromDanPinBiLi() - owner.mFree();
    }

    /****************************helper***********************************/

    /**
     * 是否是数量加价
     *
     * @returns {boolean}
     */
    this.isShuLiangJiaJia = function(){
        if(owner.jiajiaType == BIZCONSTANT.JIAJIATYPE_SHULIANG)
            return true;

        return false;
    }


    //当前做法是否参与分摊，以其关联的菜品为准
    this.isFenTan = function(){
         return owner.parentCaiPin.isFenTan();
    }


    //是否有做法单品折扣【和菜品一致】
    this.existDpZk = function(){
        return owner.parentCaiPin.existDpZk();
    }

    /**
     *     得到做法比例折扣，【和菜品一致】
     */
    this.getAvailableZheKou = function(){
        return owner.parentCaiPin.getAvailableZheKou();
    }


    /****************************BEGIN: 以下方法是为了 [点菜界面以及结算界面的菜品做法金额的显示】，并非为计算用****/
    /**
     * 做法的金额， 只用于点菜和结算
     */
    this.calMoneyZuoFa4DianCai = function(){
            var ret = 0;
            var m = owner.mRaw() ;
            if (owner.existDpZk()) {
                m -= owner.mZk() ;
            }
            m -= owner.mFree() ;
            ret += m;

            return Utils.m(ret);
    }

    //判断两种菜品做法是否相同
    this.equals = function(otherZuoFa) {
        //if(this.guid != otherZuoFa.guid) return false;
        //if(this.orderCaipinId != otherZuoFa.orderCaipinId) return false;
        if(this.zuofaId != otherZuoFa.zuofaId) return false;
        if(this.name != otherZuoFa.name) return false;
        if(this.typeId != otherZuoFa.typeId) return false;
        if(this.price != otherZuoFa.price) return false;
        if(this.jiajiaType != otherZuoFa.jiajiaType) return false;
        if(this.isScomb != otherZuoFa.isScomb) return false;
        //if(this.orderScombCaipinId != otherZuoFa.orderScombCaipinId) return false;
        //if(this.parentCaiPin != otherZuoFa.parentCaiPin) return false;
        if(this.maxWeightInCurrentOrder != otherZuoFa.maxWeightInCurrentOrder) return false;
        return true;
    }

    /****************************END****/

}

OrderCaipinZuofa.SQL_UPDATE_ZF_TO_ORDER_CAIPIN_ZUOFA  = function(_self, operator, jieSuan) {
    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var guidStr = "'" + _self.guid + "'" + jieSuan.jieSuanTimeSql;
    return {
        query: "update pos_order_caipin_zuofa " +
        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?, fenTanSumMoney =?," +
        " moLingMoney =?, weight =?, jieSuanTime=? " +
        " where guid=" + guidStr,
        params: [_self.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),
            _self.weight(),
            jieSuan.getCreateTime()]
    }
}