function OrderInfo(){
	this.id = null;
	this.orderNo = null;
	this.taikaNo = null;
	this.addTime = new Date();
	this.endTime = null;
	this.printTime = null;
	this.typeFlag = null; // 外带， 外送， 自取， 内用
	this.customerName = null; // 外卖可用 
	this.customerTel = null; // 外卖可用
	this.customerAddress = null; // 外卖可用
	this.songcanyuan = null;
	this.operator = null;
	this.hy = {
		HY_ID: null,
		HY_Code: null
	};
	this.orderItems = [];
	this.itemCount = 0; // 项数
	this.amount = 0; // 小计
	this.discount = 0; // 折扣
	this.youmian = 0;
	this.totalCount = 0; // 数量
	this.paidAmount = 0; // 已付
	this.totalAmout = 0; // 总价
	this.unpaidAmount = 0; // 未收
	this.isHistoryOrder = false;
	this.canbie = null;
	this.memo = null;
	this.weixinOrderID = null;
	this.fromOnline = false;
	this.paidApporach = [];

	this.addOrderItem = function(item){
		var itemOld = null;
		var flag = Utils.containsObj(this.orderItems, item.dishid, "dishid");
		if(!flag.include){
			this.orderItems.push(item);
		}
		else{
			if(item.count == 0){
				this.orderItems.splice(flag.idx, 1);
			}
			else {
				var itemOld = this.orderItems[flag.idx];
				itemOld.count = item.count;
				itemOld.unit = item.unit;
				itemOld.tasteList = item.tasteList;
			}
		}
		this._update();
	};

	this.getOrderItem = function(dishid){
		return Utils.arrayFind(this.orderItems, dishid, "dishid");
	};

	this.combindItem = function(orderItem){
		var returnedItem = orderItem;
		var hasItem = 0;
		var deletedIdx = null;
		var addedIdx = null;
		var pushedIndexs = [];
		for(var idx in this.orderItems){
			var item = this.orderItems[idx];
			if(item.dishid == orderItem.dishid){
				hasItem++;
				if(deletedIdx == null){
					deletedIdx = idx;
				}
				if(addedIdx == null){
					addedIdx = idx;
				}
				if(item.count <= 1){
					deletedIdx = idx;
				}
				else{
					addedIdx = idx;
				}
				pushedIndexs.push(idx);
			}
		}
		if(hasItem > 1){
			if(deletedIdx == addedIdx){
				deletedIdx = pushedIndexs[1];
				addedIdx = pushedIndexs[0];
			}
			this.orderItems.splice(deletedIdx, 1);
			returnedItem = this.orderItems[addedIdx];
			returnedItem.count += 1;
			this._update();
		}
		return returnedItem;
	};

	this._update = function(){
		this.itemCount = 0; // 项数
		this.amount = 0; // 小计
		this.totalCount = 0; // 数量
		//this.paidAmount = 0; // 已付
		this.totalAmout = 0; // 总价
		this.unpaidAmount = 0; // 未收
		this.itemCount = this.orderItems.length;
		for(var idx in this.orderItems){
			var item = this.orderItems[idx];
			this.amount += item.getTotalAmout();
			this.totalCount += item.count;
		}
		//this.paidAmount = 0; // 已付
		this.totalAmout = this.amount + this.youmian + this.discount; // 总价
		this.unpaidAmount = this.totalAmout - this.paidAmount; // 未收
	};

	this.setYoumian = function(money){
		if(money > 0){
			money = -money;
		}
		this.youmian = money;
		this.totalAmout = this.amount + this.youmian + this.discount; // 总价
		this.unpaidAmount = this.totalAmout - this.paidAmount; // 未收

		for(var idx in this.orderItems){
			this.orderItems[idx].youmian = 0;
		}
		
		var remainMoney = this.youmian;

		while(remainMoney != 0){
			for(var idx in this.orderItems){
				if(remainMoney == 0){
					return;
				}
				var item = this.orderItems[idx];
				var shouldYoumian = item.count * 1;
				if(shouldYoumian > -remainMoney){
					shouldYoumian = -remainMoney;
					item.youmian += -shouldYoumian;
					return;
				}
				item.youmian += -shouldYoumian;
				remainMoney = -(-remainMoney - shouldYoumian);
			}
		}
	};
}

function OrderItem(){
	this.dishid = null;
	this.dish = null;
	this.count = 0;
	this.unit = null;
	this.tasteList = [];
	this.discount = 0;
	this.actualPrice = 0;
	this.youmian = 0;

	this.getFullName = function(){
		return this.dish.Dish_Name + (this.unit == null ? "<br/>" : "("+this.unit.unitname+")<br/>") 
				+ this.getTasteString();
	};

	this.getShortName = function(){
		return this.dish.Dish_Name + (this.unit == null ? "" : "("+this.unit.unitname+")") ;
	};

	this.getPrintName = function(){
		return this.dish.Dish_Name + (this.unit == null ? "" : "("+this.unit.unitname+")") + this.getTasteString() ;
	};

	this.setNewPrice = function(){
		var scale = 1;
		if(this.unit != null){
			scale = this.unit.scale;
		}
		this.actualPrice = scale * this.dish.Dish_SalePrice;
	};

	this.setDish = function(dish){
		this.dishid = dish.dishid;
        this.dish = dish;
        this.actualPrice = this.dish.Dish_SalePrice;
        this.dishid = this.toID();
	};

	this.setUnit = function(unit){
		this.unit = unit;
		this.dishid = this.toID();
	};

	this.setTasteList = function(tasteList){
		this.tasteList = tasteList;
		this.dishid = this.toID();
	};

	this.getTotalAmout = function(){
		var fx = this.actualPrice * this.count;
		return Math.round(fx * 100) / 100;
	};

	this.getTasteString = function(){
		var output = "";
		for(var idx in this.tasteList){
			output += this.tasteList[idx].KW_Name + "/"
		}
		if(output.length > 0){
			output = output.substring(0, output.length - 1);
		}
		return output;
	};

	this.toID = function(){
		var id = "";
		if(this.dish != null){
			id += this.dish.dishid;
		}
		if(this.unit != null){
			id += "_" + this.unit.unitid
		}
		if(this.tasteList != null){
			for(var idx in this.tasteList){
				id += "_" + this.tasteList[idx].id
			}
		}
		return id;
	};
}