﻿

function pagination(paginconfig) {

    

    this.currentPage = 1;//当前页
    this.size = 0;//分页大小
    this.total = 0;//所有数据长度
    this.totalpage = 1;//所有数据页数
    this.allitems = [];//所有数据
    this.items = [];//当前页数据

    this.beforecallback = null;//执行前一页成功后的回调
    this.nextcallback = null;//执行后一页成功后的回调
    this.gocallback = null;//执行分页成功后的回调

    //重新初始化 可以重新指定数据源，会强制跳转到第一页
    //返回的是当前对象
    this.Init = function (paginconfig) {
        if (!paginconfig || paginconfig == null)
            return;
        this.allitems = paginconfig.rows;

        if (paginconfig.size)
            this.size = paginconfig.size;

        this.total = paginconfig.rows.length;

        this.totalpage = Math.floor(this.total / this.size);
        if ((this.total % this.size) > 0)
            this.totalpage += 1;

        if (paginconfig.beforecallback)
            this.beforecallback = paginconfig.beforecallback;

        if (paginconfig.nextcallback)
            this.nextcallback = paginconfig.nextcallback;

        if (paginconfig.gocallback)
            this.gocallback = paginconfig.gocallback;

        this.currentPage = 1;
        this.items = [];
        this.go(this.currentPage);
        return this;
    }
    
    //重新计算当前页数据，可以重新指定数据源
    this.reCurPage = function (newsource)
    {
        if (newsource && newsource.length >= 0)
            this.allitems = newsource;
        this.total = this.allitems.length;

        if(this.total == 0){
            this.totalpage = 1;
        } else {
            this.totalpage = Math.floor(this.total / this.size);
            if ((this.total % this.size) > 0)
                this.totalpage += 1;
        }
        if (this.currentPage > this.totalpage)
            this.currentPage = this.totalpage;
        this.go(this.currentPage);
    }

    //计算每页显示的size
    this.culsize = function (containerlhight,itemheight)
    {
        return this.size=Math.floor(containerlhight / itemheight);
    }

    this.nextAble = function ()
    {
        return this.goAble(this.currentPage+1);
    }

    //下一页
    this.next = function () {
        if (!this.nextAble())
            return;
        this.currentPage += 1;
        this.go(this.currentPage);
        if (this.nextcallback != null)
            this.nextcallback();
    }

    this.beforeAble = function () {
        return this.goAble(this.currentPage - 1);
    }

    //上一页
    this.before = function () {
        if (!this.beforeAble())
            return;
        this.currentPage -= 1;
        this.go(this.currentPage);
        if (this.beforecallback != null)
            this.beforecallback();
    }

    //到第一页
    this.first = function () {
        this.currentPage = 1;
        this.go(1);
    }

    //到最后一页
    this.last = function ()
    {
        this.currentPage = this.totalpage;
        this.go(this.totalpage);
    }

    //是否允许跳转到指定页
    this.goAble = function (page) {
        if (page <= 0)
            return false;
        if ((page - 1) * this.size >= this.total)
            return false;
        return true;
    }

    //到指定页
    this.go = function (page) {
        if (!this.goAble(page))
            return clear(this.items);
        var length = this.size;
        var begin = (page - 1) * this.size;
        if ((page * this.size) > this.total)
            length = this.total - (page - 1) * this.size;
        clear(this.items);

        for (var i = begin; i < (begin + length) ; i++) {
            var item = this.allitems[i];
            item.pitemindex = i+1;//序号
            this.items.push(item);
        }
        if (this.gocallback != null)
            this.gocallback();
    }

    //清空当前页数据
    function clear(items) {
        items.length = 0;
        return false;
    }
    
    //求数据源的sum
    this.sum = function (columName)
    {
        var m = 0;
        try
        {
            if (this.allitems && this.allitems.length > 0)
            {
                for(var i in this.allitems)
                {
                    var item = this.allitems[i];
                    m += Utils.m(item[columName]);
                }
            }
        } catch (e) {
        }
        return m;
    }

    //对sum进行两位小数格式化，只是View展示的话用此方法
    this.sumStr = function (columName)
    {
        return Utils.m2string(this.sum(columName));
    }

    this.Init(paginconfig);

}
