/*******
 *
 *  peter.shang
 *
 * ******************************************************************************/
/**
 * 折扣信息 --折扣模板
 *
 * 折扣只应用于整单
 *
 * @constructor
 */
function ZheKou(){
    var _self = this;
    //折扣ID
    this.zheKouId = null;
    //折扣名称
    this.zheKouName  = null;
    //折扣编码
    this.zheKouCode = null;
    //折扣率(内置折扣模板为空)
    this.zheKouAmount = null; //类比率的时候，存放的比率，如果90， 80（八折）。  定额和会员价的时候存放的是实际的钱。
    //与当前“折扣” 相关联的“结算”对象
    this.jieSuan = null;
    this.ver = 0; //用于排序用
    this.caiWuShuXing = BIZCONSTANT.CWKM_YOUMIAN;
    this.isHyJf = null; // 是否参与会员积分
    var _applyWholeOrder = 0; //0表示非全单打折，  1 表示全单打折
    var _type = BIZCONSTANT.TYPE_ZHEKOU;

    /**
     * 该支付方式是否参与会员积分
     *
     */
    this.isOfHuiYuanJiFen = function(){

        if( _self.isHyJf == null || _self.isHyJf)
            return true;

        return false;
    }

    //该折扣是否是会员价产生的折扣， 此折扣仅仅用于在界面显示，其折扣值，是通过会员价来计算得到
    this.isHuiYuanJia =  function(){
        if(_self.zheKouCode == BIZCONSTANT.ZHE_KOU_HY_PRICE)
            return true;

        return false;
    }
//该折扣是否是会员折扣率， 此折扣仅仅用于在界面显示，其折扣值，是通过会员价来计算得到
    this.isHuiYuanLV =  function(){
        if(_self.zheKouCode == BIZCONSTANT.ZHE_KOU_HY_ZK)
            return true;

        return false;
    }

    //是否是“类比例折扣”(按折扣模板或者自定义比例)
    //内置的自定义折扣，以及后台设置的其他比例折扣，以及 会员的折扣， 都属于类比例。
    this.isOfBiLi= function(){
        if(_self.zheKouCode != BIZCONSTANT.ZHE_KOU_DING_E &&  _self.zheKouCode != BIZCONSTANT.ZHE_KOU_HY_PRICE )
            return true;

        return false;
    }

    //是否是内置的定额折扣
    this.isDingE = function(){
        if(this.zheKouCode == BIZCONSTANT.ZHE_KOU_DING_E)
            return true;

        return false;
    }
    //是否是”内置的比例折扣"
    this.isBili = function(){
        if(this.zheKouCode == BIZCONSTANT.ZHE_KOU_BI_LI)
            return true;

        return false;
    }
    //是否是内置的折扣
    this.isBuiltIn = function(){
        if( this.isDingE() || this.isBili())
            return true;

        return false;
    }
    //设置该折扣对应的结算对象
    this.setJieSuan = function(js){
        this.jieSuan = js;
    }

    //解除折扣模板和当前结算的关系
    this.reset = function(){
        this.jieSuan = null;
        this.ver = 0;
    }

    //定额折扣 或者 类比例折扣所折扣掉的金额, 结算单明细使用
    //是整单折扣的金额
    this.money = function(){
        if(this.isDingE())
            return -this.zheKouAmount;


        //只累加 “类折扣比例”的菜品的折扣额，单品折扣不算在内。
        return - Utils.m( this.jieSuan.order.getSumOfNoneDanPinZheKou() );
    }


    /**
     * 界面显示使用
     *
     * @returns {number}
     */
    this.money4Display = function(){
        if(_self.isDingE())
            return -_self.money();

        if(_self.isHuiYuanJia())
            return _self.zheKouAmount;

         return -_self.money();
    }

    this.moneyAsStr = function(){
        return  - this.money().toFixed(BIZCONSTANT.MONEY_PRECISE);
    }

    this.setZheKouAmount =  function(amount){
        return _self.zheKouAmount = amount;
    }
    this.getType = function(){return _type};

    /**
     * 该折扣模板是否默认全单打折
     *
     * @returns {boolean}
     */
    this.isApplyWholeOrder = function(){
        if(_applyWholeOrder > 0)
            return true;

        return false;
    }

    this.setApplyWholeOrder = function(o){
        _applyWholeOrder = o;
    }

    //克隆新对象
    this.cloneZK = function () {
        var zk = new ZheKou();
        zk.zheKouId = _self.zheKouId;
        zk.zheKouName = _self.zheKouName;
        zk.zheKouAmount = _self.zheKouAmount;
        zk.zheKouCode = _self.zheKouCode;
        zk._applyWholeOrder = _self._applyWholeOrder;
        return zk;
    }



    
}

ZheKou.SQL_INSERT_ZK_TO_BIILLING_DETAIL  = function(_self, operator, jieSuan){
    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var jieSuanIdStr = "'" + jieSuan.order.jieSuanId + "'" + jieSuan.jieSuanTimeSql;
    return  {
        query: 'insert into pos_billing_detail' +
        '(guid, bizId, bizCode, bizAmount,bizDesc,type,amount,jieSuanNo,caiWuShuXing,isHyJf, seq,  device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId, jieSuanId,applyWholeOrder) ' +
        ' values (?, ?, ?, ?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?, '+jieSuanIdStr+', ?)',
        params:[Utils.guid(), _self.zheKouId, _self.zheKouCode, _self.zheKouAmount, _self.zheKouName, _self.getType(),
            _self.moneyAsStr(),jieSuan.getJieSuanNo() , _self.caiWuShuXing, _self.isOfHuiYuanJiFen(), _self.ver, operator.device, jieSuan.getCreateTime(),
            operator.id, operator.code,operator.name, operator.mdId, _self.isApplyWholeOrder() ? 1  : 0 ]
    }

}

//不打折的折扣
ZheKou.BL_100 = function(){
    var ret = new ZheKou();
    ret.zheKouAmount = 100;
    return ret;
}