/*********
 * peter.shang
 *
 * ****************************************************************************/

/**
 * 对应财务科目
 * @constructor
 */
function PaymentMethod(){

    var _self = this;
    //金额
    var amount = 0.00;

    var _type = "PAY";

    var _related = null ; //和本支付方式关联的支付方式，主要用在会员反值。即：如果是会员支付，那么隐含得会有一个会员卡反值支付。

    //支付方式ID
    this.pmId = null; //guid
    //01,02,。。。
    this.code = null;
    //支付名称，现金，银行卡，支付宝，微信，优惠券等
    this.name = null;
    //


    this.caiWuShuXing = BIZCONSTANT.CWKM_SHISHOU; //支付类的财务属性可能是 实收 ， 也可能是优免， 从数据库读取

    //结算对象
    this.jieSuan = null;


    this.ver = 0; //用于排序用

    this.ext1 = null; //扩展字段，用于保存 凭据号

    this.isHyJf = null; // 是否参与会员积分

    this.fklx = null;//付款类型

    this.isDisplay = true;//是否显示，默认显示

    this.isDisplayCz = true;//充值是否显示，默认显示

    this.thirdCouponNum = 0; //对于第三方抵用券，如美团券，使用张数

    this.payManey = 0; //对于第三方抵用券，购买券时实际付款的金额

    this.faceValueManey = 0; //对于第三方抵用券，购买时能够抵用的金额

    this.hykZSMoney = 0; //会员卡赠送消费

    this.subPMs = []; //对于会员卡、团购券、正念等含有优惠金额的支付方式拆分为虚、实两部分支付方式,页面显示父支付方式，计算使用子支付方式

    //克隆新的支付方式
    this.clonePM = function () {
        var pm = new PaymentMethod();
        pm.pmId = this.pmId;
        pm.code = this.code;
        pm.name = this.name;
        pm.caiWuShuXing = this.caiWuShuXing;
        pm.fklx = this.fklx;
        pm.isHyJf = this.isHyJf;
        pm.ver = this.ver;
        pm.ext1 = this.ext1;
        pm.hykZSMoney = this.hykZSMoney;
        pm.setMoney(amount);
        /*//克隆子支付方式
        if(_self.subPMs.length > 0) {
            for(var i = 0; i < _self.subPMs.length; i++) {
                var subPm = _self.subPMs[i];
                var cloneSubPm = subPm.clonePM();
                pm.subPMs.push(cloneSubPm);
            }
        }*/
        return pm;
    }

    this.setRelated = function(o){
        _related = o;
    }

    this.getRelated = function(){
        return _related;
    }

    //是否是现金支付
    this.isXianJian = function(){
        if(this.code == BIZCONSTANT.PM_XIAN_JIN)
            return true;

        return false;
    }

    //是否是会员支付
    this.isMember = function(){

        if(_self.code == BIZCONSTANT.PM_HUI_YUAN )
            return true;

        return false;
    }

    //是否是会员赠送支付
    this.isMemberZS = function(){

        if(_self.code == BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE )
            return true;

        return false;
    }

    //是否是会员反值支付
    this.isMemberFanZhi = function(){
        if(_self.code == BIZCONSTANT.PM_HUI_YUAN_FAN_ZHI )
            return true;

        return false;
    }

    //是否是正念支付
    this.isZN = function(){
        if(_self.fklx == BIZCONSTANT.PM_FKLX_ZN )
            return true;

        return false;
    }

    //是否是银行卡 or WeiXin or alipay 支付
    this.isAlreadyPay = function(name){
        var whichPay = null;
        if (name == '银行卡') {
            whichPay = BIZCONSTANT.PM_YIN_HANG_KA;
        } else if (name == '微信') {
            whichPay = BIZCONSTANT.PM_WEIXIN_EXTERNAL_CODE;
        } else if (name == '支付宝') {
            whichPay = BIZCONSTANT.PM_ALIPAY_EXTERNAL_CODE;
        }

        if(_self.code == whichPay)
            return true;

        return false;
    }

    this.isJiFen = function(){
        if(_self.code == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE )
            return true;

        return false;
    }

    //设置该折扣对应的结算对象
    this.setJieSuan = function(js){
        _self.jieSuan = js;
    }

    this.reset = function(){
        _self.jieSuan = null;
        _self.thirdCouponNum = 0;
        if(_self.isPayFirst())
            _self.ext1 = null;
        amount = 0.00;
        _self.hykZSMoney = 0.00;
        this.subPMs.length = 0;
    }
    this.getJieSuan = function(){
        return _self.jieSuan;
    }

    this.addMoney = function(m){
        amount = Utils.m(amount) + Utils.m(m);
    }

    this.removeMoney = function (m) {
        amount = Utils.m(amount) - Utils.m(m);
    }

    this.pmMoney = function(){
        return Utils.m(amount);
    }

    this.setMoney = function (m) {
        amount = Utils.m(m);
    }


    /**
     * 支付方式的实收金额， 注意：支付金额不一定等于实收金额！！！
     *
     * 如果是现金，那么可能出现出现找零的情况，amount可能和实收不一样。
     * 比如： 现金支付395， 实际应付394，那么实收为394 = 395 -
     * @returns {string}
     */
    this.pmMoneyAsStr = function(){
        if(! _self.isXianJian())
        return _self.pmMoney().toFixed(BIZCONSTANT.MONEY_PRECISE);

        return ( _self.jieSuan.order.getYingShou() - _self.jieSuan.sumOfNoneXianJin()).toFixed(BIZCONSTANT.MONEY_PRECISE);
    }

    this.getMemberNo = function(){
        if (_self.jieSuan != null && _self.jieSuan.order != null)
            return _self.jieSuan.order.memberNo;

        return null;
    }

    this.getType = function(){return _type};

    /**
     * {
        "tradeDetailType":"CA",
        "payType":"03",
        "payTypeName":"支付宝",
        "payMoney":"60"
    }

     * @returns {{payMoney: string, tradeDetailType: string, payType: null}}
     */
    this.asJson4Member = function(){
        return {
            payMoney: _self.pmMoneyAsStr() ,
            tradeDetailType:BIZCONSTANT.MEMBER_TRANS_CASH.code,
            payType: _self.code,
            payTypeName: _self.name
        };
    }

    /**
     * 是否是“先扣款再结算” 的类型，他们是：
     * 会员卡，积分消费, 微信
     *
     */
    this.isPayFirst = function(){
        if( PaymentMethod.payFirstList().indexOf("'" + _self.code + "'") > -1)
            return true;

        return false;
    }

    /**
     * 该支付方式对象是否已经支付过？
     * //
     */
    this.isPaid = function(){
        if( _self.ext1 != null )
            return true;

        return false;
    }

    //当前支付方式的属性是否是“优免”
    this.isYouMian = function(){

        return _self.caiWuShuXing == BIZCONSTANT.CWKM_YOUMIAN
    }

    /**
     * 是否是虚拟的支付方式
     * @returns {boolean}
     */
    this.isVirtual = function(){
        if(_self.code == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE )
            return true;


        return false;
    }

    /**
     * 该支付方式是否参与会员积分
     *
     */
    this.isOfHuiYuanJiFen = function(){

        if( _self.isHyJf == null || _self.isHyJf == 'true')
            return true;

        return false;
    }

    this.isWeiXin = function(){
        if(_self.code == BIZCONSTANT.PM_WEIXIN_CODE )
            return true;

        return false;
    }

    this.isCoupon = function(){
        if(_self.code == BIZCONSTANT.PM_COUPON )
            return true;

        return false;
    }

    this.isBankCardPay = function() {
        if(_self.code == BIZCONSTANT.PM_YIN_HANG_KA)
            return true;

        return false;
    }

    this.isThirdPay = function(){
        if(_self.code == BIZCONSTANT.PM_ALIPAY_EXTERNAL_CODE || _self.code == BIZCONSTANT.PM_WEIXIN_EXTERNAL_CODE )
            return true;

        return false;
    }

    this.getSelfCode = function(){
        return _self.code;
    }

    //是否团购券
    this.isTG = function() {
        if(_self.fklx && _self.fklx == "tg") {
            return true;
        }
        return false;
    }

    //是否详细的团购券
    this.isThirdCoupon = function() {
        if(_self.fklx && _self.fklx == "thirdCoupon") {
            return true;
        }
        return false;
    }

    this.thirdCouponNumDis = function () {
        if(_self.isThirdCoupon()) {
            return parseInt(_self.thirdCouponNum);
        }
        return null;
    }

    this.isDiscount = true; //true:打折不可用,针对第三方抵用券
    //是否折扣可用
    this.isZheKouKeYong = function() {
        if(this.isDiscount == true || this.isDiscount == "true") return false;
        return true;
    }

}


PaymentMethod.SQL_INSERT_PM_TO_BIILLING_DETAIL  = function(_self, operator, jieSuan){

    var pmMoney = _self.pmMoneyAsStr();

    //如果当前支付方式是现金，并且不是“结账”，那么需要把找零计入
    if(_self.isXianJian() && jieSuan.getJieSuanNo() == null ){
        pmMoney = Utils.m(pmMoney) + Utils.m(jieSuan.zhaoLing);
    }

    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var jieSuanIdStr = "'" + jieSuan.order.jieSuanId + "'" + jieSuan.jieSuanTimeSql;
    return {
        query: 'insert into pos_billing_detail' +
        '(guid, bizId, bizCode,bizDesc,type,amount,' +
        'jieSuanNo,caiWuShuXing,isHyJf, seq,  device, createTime,' +
        'addOperatorId, addOperatorCode, addOperatorName,mdId, ext1, thirdCouponNum, thirdCouponPayMoney, thirdCouponFaceValueMoney, hykZSMoney,jieSuanId) ' +
        ' values (?,  ?, ?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,'+jieSuanIdStr+')',
        params:[Utils.guid(), _self.pmId, _self.code, _self.name, _self.getType(), pmMoney,
            jieSuan.getJieSuanNo() , _self.caiWuShuXing,_self.isOfHuiYuanJiFen(), _self.ver, operator.device, jieSuan.getCreateTime(),
            operator.id, operator.code,operator.name, operator.mdId, _self.ext1 == null ? null :_self.ext1, _self.thirdCouponNum, _self.payManey, _self.faceValueManey, _self.hykZSMoney]
    }
}

/**
 * 删除指定结算单内的指定 BIZID 的 sql
 * @param _self
 * @param operator
 * @param jieSuan
 * @returns {{query: string, params: *[]}}
 * @constructor
 */
PaymentMethod.SQL_DELETE_PM_TO_BIILLING_DETAIL_BIZID  = function(_self, operator, jieSuan){
    if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
    var jieSuanIdStr = "'" + jieSuan.order.jieSuanId + "'" + jieSuan.jieSuanTimeSql;
    //如果是虚拟的支付方式，则已CODE为准
    if(_self.pmId === null ) {
        return  {
            query: 'delete from pos_billing_detail where bizCode = ?  and jieSuanId = ' + jieSuanIdStr,
            params:[_self.code]
        }
    }

    return {
        query: 'delete from pos_billing_detail where bizId = ?  and jieSuanId = ' + jieSuanIdStr,
        params:[_self.pmId]
    }
}

/**
 * 属于先扣款类型的 支付方式列表
 * @returns {string}
 */
PaymentMethod.payFirstList= function(){
    return "'" + BIZCONSTANT.PM_HUI_YUAN + "','" + BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE +"'";
}

/**
 * 返回积分消费对象
 * @returns {PaymentMethod}
 * @constructor
 */
PaymentMethod.JFXF = function(){
    var o = new PaymentMethod();
    o.code = BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE;
    o.name = BIZCONSTANT.PM_HUI_YUAN_JF_XF_NAME;
    o.caiWuShuXing =BIZCONSTANT.CWKM_YOUMIAN;
    return o;
}

/**
 * 返回会员卡对象
 *
 * //TODO, 从全局变量中获得？？？
 * @constructor
 */
PaymentMethod.HYK = function(){
    var _huiYuanKa = new PaymentMethod();
    _huiYuanKa.code = BIZCONSTANT.PM_HUI_YUAN;
    _huiYuanKa.name = BIZCONSTANT.PM_HUI_YUAN_NAME;
    try{
        _huiYuanKa.pmId =  BIZCONSTANT.getPMbyCode(BIZCONSTANT.PM_HUI_YUAN).pmId;
    }catch (e){};


    return _huiYuanKa;
}

/**
 * 返回微信支付
 *
 * //TODO, 从全局变量中获得？？？
 * @constructor
 */
PaymentMethod.WEIXIN = function(){
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_WECHAYPAY;
    ret.name = BIZCONSTANT.PM_WECHAYPAY_NAME;

    return ret;
}

/**
 * 返回优惠券支付方式
 *
 * @constructor
 */
PaymentMethod.COUPONS = function(){
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_COUPON;
    ret.name = BIZCONSTANT.PM_COUPONS_NAME;

    return ret;
}

/**
 * 返回银联卡支付方式
 *
 * @constructor
 */
PaymentMethod.BANK = function(){
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_BANK_CODE;
    ret.name = BIZCONSTANT.PM_BANK_NAME;

    return ret;
}

/**
 * 返回微信银行卡支付方式
 *
 * @constructor
 */
PaymentMethod.WEIXIN_BANK = function(){
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_YIN_HANG_KA;
    ret.name = BIZCONSTANT.PM_WEIXIN_BANK_NAME;

    return ret;
}


/**
 * 返回红包支付方式
 *
 * @constructor
 */
PaymentMethod.HongBao = function () {
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_WM_HONGBAO_CODE;
    ret.name = BIZCONSTANT.PM_WM_HONGBAO_NAME;

    return ret;
}

/**
 * 返回配送费支付方式
 *
 * @constructor
 */
PaymentMethod.PeiSongFee = function () {
    var ret = new PaymentMethod();
    ret.code = BIZCONSTANT.PM_WM_PEISONG_CODE;
    ret.name = BIZCONSTANT.PM_WM_PEISONG_NAME;

    return ret;
}

PaymentMethod.getVirtualPm = function(ct){
    var vPm = null;
    //积分兑换
    if(ct == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE || ct == BIZCONSTANT.PM_HUI_YUAN_JF_ALIAS) {
        vPm = PaymentMethod.JFXF();
    }else if(ct ==  BIZCONSTANT.PM_WECHAYPAY || ct == BIZCONSTANT.PM_WEIXIN_ALIAS){
        vPm = PaymentMethod.WEIXIN();
    }else if(ct == BIZCONSTANT.PM_HUI_YUAN || ct == BIZCONSTANT.PM_HUI_YUAN_ALIAS) {
        vPm = PaymentMethod.HYK();
    }else if(ct == BIZCONSTANT.PM_COUPON || ct == BIZCONSTANT.PM_COUPONS_ALIAS) {
        vPm = PaymentMethod.COUPONS();
    }else if(ct == BIZCONSTANT.PM_BANK_CODE || ct == BIZCONSTANT.PM_BANK_ALIAS) {
        vPm = PaymentMethod.BANK();
    } else if (ct == BIZCONSTANT.PM_WM_PEISONG_CODE) {
        vPm = PaymentMethod.PeiSongFee();
    } else if (ct == BIZCONSTANT.PM_WM_HONGBAO_CODE) {
        vPm = PaymentMethod.HongBao();
    } else if (ct == BIZCONSTANT.PM_WEIXIN_BANK_CODE) {
        vPm = PaymentMethod.WEIXIN_BANK();
    }
    return vPm;

}




