/**
 * Created by peter.shang on 2016-03-26.
 *
 * 记录发出去的请求的以及接受的相应。方便后续查找和跟踪
 *
 */


app.factory("AjaxLogger", ['$q', '$rootScope', 'database','UniqueIDService', function($q, $rootScope, database, UniqueIDService){
    var AjaxLogger = {};
    var loggerDao =  new DatabaseFuncDelegate($q, database, 'pos_ajaxlog');
    /**
     *
     * @param keywords 典型的业务关键字，最好能唯一标识出该类请求
     * @param reqJson  发出去的请求体
     * @param resJson  响应
     */
    AjaxLogger.log = function (operator, keywords, reqJson, resJson, url) {
        if (!keywords || !keywords.length)
            return;
        if (keywords.indexOf('KAFKA') >= 0 || keywords.indexOf('后台数据同步')>=0)
            return;
        var all = [];
        var now = Utils.now();
        url = url == null ? "" : url;
        all.push({
            query:'insert into pos_ajaxlog'+
            '(guid,' +
            'keywords,req,res,' +
            'mdId, addOperatorId,addOperatorCode,addOperatorName,' +
            'createTime,url )'+
            'values(?,?,?,?,?,?,?,?,?,?)',
            params:[Utils.guid(),
                keywords, reqJson, resJson,
                operator.mdId, operator.id, operator.code, operator.name, now, url]
        });

        loggerDao.queryTransaction(all).then(function(resultList){
        }, function(err){
            console.log(err);
        });
    }

    AjaxLogger.error = function (httpstatus, keywords, reqJson, resJson, url) {
        Utils.winLog('Ajax Error', 'httpstatus:' + httpstatus, keywords, reqJson, resJson, url);
    };

    AjaxLogger.oper = function(des){
        var now = Utils.now(),all = [];
        all.push({
            query:'insert into sys_log'+
            '(guid,' +
            'type,operationUser,operatonDateTime,' +
            'operationAddress, operationDesc,operationType,syn)'+
            'values(?,?,?,?,?,?,?,?)',
            params:[
                Utils.guid(),
                "POS",
                $rootScope.curUser.name,
                now,
                $rootScope.deviceName,
                des,
                des,
                0
            ]
        });

        loggerDao.queryTransaction(all).then(function(resultList){
        }, function(err){
            console.log(err);
        });
    }
    return AjaxLogger;

}]);

