/**
 * Created by jin on 2016.05.23.
 * pos竖屏的一些service修改方法
 */

app.factory('AndroidService', ['$q', 'database', function ($q, database) {
    var AndroidService = {};

    var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');

    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');

    var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');

    var orderCaipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zuofa');

    var orderScombCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_scomb_caipin');

    var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');

    var orderCaipinKouweiDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_kouwei');


    //得到所有的菜品列别，一级二级
    //如果有二级分类，则不显示一级分类？
    AndroidService.getParentCaipinTypes = function (first, rows, cb) {
        var sql;
        //if (first == 0 && rows == 0) {
        //    sql = "isDeleted='false' order by dishTypeCode ";
        //} else {
        //    sql = "isDeleted='false' order by dishTypeCode limit " + first + "," + rows;
        //}
        //如果有二级分类，则不显示一级分类
        sql = " guid not in(select parentId from pos_caipin_type where parentId is not null and isDeleted='false') and isDeleted = 'false' order by dishTypeCode";
        caipinTypeDao.all(sql)
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error);
            });
    };

    //根据菜品列表获取菜品信息
    AndroidService.getCaipinsByType = function (typeId, first, rows, cb, parentTypeId) {
        /*  JP
         16-02-25
         加入了菜品估清数量 */

        // 关联了做法表，增加判断菜品是否有做法必选,前段做法必选菜品需要弹出框
        //var sql = "select c.*,case  when gq.caipinNum is NULL then -1 else gq.caipinNum	end as caipinNum from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid where isDeleted='false' and enabled='true' and typeId='" + typeId + "' order by code limit " + first + "," + rows;


        var sql;
        if (parentTypeId == null) {
            sql = "select c.*,ifnull(cpzf.zfcount,0) as zfcount,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName, case when gq.caipinNum is NULL then -1 else gq.caipinNum	end as guqingNum " +
                " from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') " +
                " and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid" +
                " left join(select count(guid) zfcount,caipinId from pos_caipin_zuofa where isDeleted='false' group by caipinId) cpzf on c.guid=cpzf.caipinId " +
                " left join pos_caipin_type ct on c.typeId= ct.guid " +
                " where c.isDeleted='false' and c.enabled='true' ";
            sql = sql + (Utils.isEmpty(typeId) ? "" : (" and typeId='" + typeId + "'"));
        } else {
            sql = "SELECT	c.*,ifnull(cpzf.zfcount,0) as zfcount,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName, CASE WHEN gq.caipinNum IS NULL THEN	- 1 ELSE	gq.caipinNum END AS guqingNum " +
                " when cpzf.count is null -1 else cpzf.count end as zfcount "
            " FROM 	pos_caipin c " +
            " LEFT JOIN (SELECT * FROM pos_caipin_guqing WHERE	startTime <= datetime('now', 'localtime') " +
            " AND endTime >= datetime('now', 'localtime')) gq ON c.guid = gq.caipinGuid " +
            " left join pos_caipin_type ct on c.typeId=ct.guid " +
            " left join(select count(guid) zfcount,caipinId from pos_caipin_zuofa where isDeleted='false' group by caipinId) cpzf on c.guid=cpzf.caipinId " +
            " WHERE c.isDeleted = 'false' AND c.enabled = 'true' and ct.parentId='" + parentTypeId + "' "
        }

        sql += " order by code ";
        sql = sql + (rows > 0 ? ("limit " + first + "," + rows) : "");

        caipinDao.query(sql)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.detail.length; i++) {
                    resultList.push(results.detail[i]);
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
        /* */
        //caipinDao.all("isDeleted='false' and enabled='true' and typeId='"+typeId+"' order by code limit "+ first +","+ rows)
        //    .then(function (results) {
        //        return cb(null, results);
        //    }, function(error){
        //        return cb(error);
        //    });
    };

    //二维码扫描批量添加菜品
    AndroidService.addOrderCaipins = function (operator, order, orderzhuotai, caipins, cb) {
        var queries = [];
        var orderCaiPinList = [];
        for (var i in caipins) {
            var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, caipins[i]);
            orderCaiPinList.push(orderCaipin);
            //queries.push({
            //    query: "insert into pos_order_caipin ( " +
            //    "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            //    "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice) " +
            //    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?)",
            //    params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price, orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum,
            //        orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName, orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou,
            //        orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou, orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime, orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.costprice]
            //});

            queries.push({
                query: "insert into pos_order_caipin ( " +
                "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId," +
                "caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange) " +
                "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?,?,?)",
                params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                    orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                    orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                    orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime,
                    orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                    orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName, orderCaipin.caiwuTypeId, orderCaipin.priceChange]
            });
        }
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, orderCaiPinList);
        }, function (err) {
            cb(err);
        });
    };

    //二维码扫描批量添加菜品(LOCAL)
    AndroidService.addOrderCaipinsLocal = function (operator, order, orderzhuotai, caipins, cb) {
        var orderCaiPinList = [];
        for (var i in caipins) {
            var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, caipins[i]);
            orderCaiPinList.push(orderCaipin);
        }
        cb(orderCaiPinList);
    };

    //删除全部未送单的菜品
    AndroidService.deleteAlldisLuoDan = function (orderCaipinIdList, cb) {
        var queries = [];
        for (var i = 0; i < orderCaipinIdList.length; i++) {
            var orderCaipinId = orderCaipinIdList[i].guid;
            queries.push({query: "delete from pos_order_caipin_zuofa where orderCaipinId='" + orderCaipinId + "'"});
            queries.push({query: "delete from pos_order_caipin_kouwei where orderCaipinId='" + orderCaipinId + "'"});
            queries.push({query: "delete from pos_order_caipin where guid='" + orderCaipinId + "'"});
            queries.push({query: "delete from pos_order_scomb_caipin where orderCaipinId='" + orderCaipinId + "'"});
        }
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    }
    //判断桌台是否开台
    AndroidService.isKaiTai = function (code, cb) {
        //var sql="select * from pos_zhuotai where code = '"+ code +"' and enabled = 'true' and isDeleted = 'false' and orderId is not null"
        var sql = "select * from pos_zhuotai where code = '" + code + "' and enabled = 'true' and isDeleted = 'false'"
        zhuotaiDao.query(sql).then(function (results) {
            if (results.detail.length != 0) {
                var ztinfo = results.detail[0];
                if (Utils.isEmpty(ztinfo.orderId)) {
                    cb('', ztinfo);
                } else {
                    cb({message: ztinfo.name + '桌台已经开台'});
                }
            } else {
                cb({message: '没有找到该桌台'});
            }
        }, function (error) {
            return cb(error);
        });
    }

    //判断结算桌台是否有需称重的菜品
    AndroidService.needChengZhong = function (orderid, luodan, cb) {
        //var sql = "select o.guid as o_guid, o.orderId as o_orderId, o.caipinId as o_caipinId, o.name as o_name, o.price as o_price, o.num as o_num," +
        //    "o.tuiNum as o_tuiNum, o.zengNum as o_zengNum, o.unitName as o_unitName, o.printId as o_printId, o.printName as o_printName, o.chupin as o_chupin," +
        //    "o.luodan as o_luodan,o.minAgio as o_minAgio, o.danPinBiLiZheKou as o_danPinBiLiZheKou, o.danPinJineZheKou as o_danPinJineZheKou," +
        //    "o.danPinZheKou as o_danPinZheKou,o.dianCaiYuan as o_dianCaiYuan,o.dianCaiYuanName as o_dianCaiYuanName, o.operator as o_operator," +
        //    "o.dianCaiTime as o_dianCaiTime,o.luoDanTime as o_luoDanTime,o.chuPinTime as o_chuPinTime, o.modTime as o_modTime,o.isScomb as o_isScomb," +
        //    "o.parentId as o_parentId," +
        //    "o.needweigh as needweigh, " +
        //    "osc.guid AS osc_guid,osc.caipinId AS osc_caipinId,	osc.name AS osc_name,	osc.price AS osc_price,	osc.num AS osc_num," +
        //    "osc.tuiNum AS osc_tuiNum,osc.zengNum AS osc_zengNum,	osc.unitName AS osc_unitName,osc.printId AS osc_printId," +
        //    "osc.needweigh AS osc_needweigh,osc.scombMainCaipinId as osc_scombMainCaipinId " +
        //    " from pos_order_caipin o" +
        //    " left join pos_order_caipin_zuofa z on z.orderCaipinId = o.guid and (z.isScomb='false' or z.isScomb is null )" +
        //    " left join pos_order_scomb_caipin osc on  osc.orderCaipinId=o.guid " +
        //    " where o.orderId='" + orderId + "' and o.luodan='" + luodan + "' order by o.modTime";
        var sql = "select count(guid) c from pos_order_caipin " +
            " where orderId='" + orderid + "' and luodan='" + luodan + "' and needweigh == 1 and num-tuiNum>0 ";
        orderCaipinDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    }

    //修改菜品价格跟名称
    AndroidService.updateDishNamAndPrice = function (orderCaipin, cb) {
        var queries = [];
        queries.push({
            query: "update pos_order_caipin set name= '" + orderCaipin.name + "'" + ",price= '" + orderCaipin.price + "'" + ",operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
            " where guid='" + orderCaipin.guid + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (result) {
            return cb(null, result);
        }, function (err) {
            cb(err);
        });
    }

    //根据桌台code获取桌台信息
    AndroidService.getZhuoTaiInfoByCode = function (zt_code, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime," +
            " o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,a.areaCode as a_areaCode,a.areaName as a_areaName" +
            " from pos_zhuotai z " +
            " LEFT JOIN pos_area a on z.areaId=a.guid " +
            " left join pos_order o on o.guid = z.orderId" +
            " where z.isDeleted='false' and z.enabled='true' AND z.code='" + zt_code + "'";
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }
            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });
    }

    // 保存到本地而不插入数据库
    AndroidService.bindOrderCaipinKouweis = function (orderCaipinKouweis, cb) {
        for (var idx in orderCaipinKouweis) {
            orderCaipinKouweis[idx].guid = orderCaipinKouweis[idx].guid == null ? orderCaipinKouweiDao.guid() : orderCaipinKouweis[idx].guid;
        }
        return cb(orderCaipinKouweis);
    };

    // 保存到本地而不插入数据库
    AndroidService.bindOrderCaipinZuofas = function (orderCaipinZuofas, cb) {
        for (var idx in orderCaipinZuofas) {
            orderCaipinZuofas[idx].guid = orderCaipinZuofas[idx].guid == null ? orderCaipinZuofaDao.guid() : orderCaipinZuofas[idx].guid;
        }
        cb(orderCaipinZuofas);
    };

    //创建桌台Model

    function zhuotaiDbToModel(row) {
        var zhuotai = new Zhuotai();
        zhuotai.guid = row.z_guid;
        zhuotai.code = row.z_code;
        zhuotai.name = row.z_name;
        zhuotai.areaId = row.z_areaId;
        zhuotai.quickCode = row.z_quickCode;
        zhuotai.canweishu = row.z_canweishu;
        zhuotai.orderId = row.z_orderId;

        zhuotai.areaCode = row.a_areaCode;
        zhuotai.areaName = row.a_areaName;
        zhuotai.disLDCount = row.disLD;
        if (row.z_orderId != null) {
            zhuotai.order.guid = row.z_orderId;
            zhuotai.order.zhuotaiId = row.z_guid;
            zhuotai.order.zhuotaiName = row.z_name;
            zhuotai.order.status = row.o_status;
            zhuotai.order.renshu = row.o_renshu;
            zhuotai.order.totalPrice = row.o_totalPrice;
            zhuotai.order.code = row.o_code;
            zhuotai.order.serverId = row.o_serverId;
            zhuotai.order.serverName = row.o_serverName;
            zhuotai.order.operator = row.o_operator;
            zhuotai.order.comments = row.o_comments;
            zhuotai.order.kaiTaiTime = row.o_kaiTaiTime;
            zhuotai.order.luoDanTime = row.o_luoDanTime;
            zhuotai.order.modTime = row.o_modTime;
            zhuotai.order.isFanJieSuan = row.o_isFanJieSuan;
            zhuotai.order.canbieId = row.o_canbieId;
            zhuotai.order.canBieCode = row.o_canbieCode;
            zhuotai.order.canbieName = row.o_canbieName;
            if (row.o_merge) {
                zhuotai.order.merge = row.o_merge;
            }
            //zhuotai.order.modTime = row.o_modTime;
            //zhuotai.order.modTime = row.o_modTime;
        }
        if (row.poz_guid) {
            var order_zhuotai = new OrderZhuotai();
            order_zhuotai.guid = row.poz_guid;
            order_zhuotai.orderId = row.z_orderId;
            order_zhuotai.zhuotaiId = row.z_guid;
            order_zhuotai.zhuotaiName = row.z_name;
            order_zhuotai.renshu = row.o_renshu;
            zhuotai.orderZhuoTai = order_zhuotai;
        }

        return zhuotai;
    }

    //function zhuotaiDbToModel(row) {
    //    var zhuotai = new Zhuotai();
    //    zhuotai.guid = row.z_guid;
    //    zhuotai.code = row.z_code;
    //    zhuotai.name = row.z_name;
    //    zhuotai.areaId = row.z_areaId;
    //    zhuotai.quickCode = row.z_quickCode;
    //    zhuotai.canweishu = row.z_canweishu;
    //    zhuotai.orderId = row.z_orderId;
    //
    //    zhuotai.areaCode = row.a_areaCode;
    //    zhuotai.areaName = row.a_areaName;
    //    if (row.z_orderId != null) {
    //        zhuotai.order.guid = row.z_orderId;
    //        zhuotai.order.zhuotaiId = row.z_guid;
    //        zhuotai.order.zhuotaiName = row.z_name;
    //        zhuotai.order.status = row.o_status;
    //        zhuotai.order.renshu = row.o_renshu;
    //        zhuotai.order.totalPrice = row.o_totalPrice;
    //        zhuotai.order.code = row.o_code;
    //        zhuotai.order.serverId = row.o_serverId;
    //        zhuotai.order.serverName = row.o_serverName;
    //        zhuotai.order.operator = row.o_operator;
    //        zhuotai.order.comments = row.o_comments;
    //        zhuotai.order.kaiTaiTime = row.o_kaiTaiTime;
    //        zhuotai.order.luoDanTime = row.o_luoDanTime;
    //        zhuotai.order.modTime = row.o_modTime;
    //
    //        zhuotai.order.canbieId = row.o_canbieId;
    //        zhuotai.order.canBieCode = row.o_canbieCode;
    //        zhuotai.order.canbieName = row.o_canbieName;
    //        //zhuotai.order.modTime = row.o_modTime;
    //        //zhuotai.order.modTime = row.o_modTime;
    //    }
    //
    //    return zhuotai;
    //}

    function createOrderCaipin(operator, order, orderzhuotai, caipin) {
        var num = 1;
        console.log("***************DSSDSDfff**********")
        console.log(caipin);
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum * 1;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var orderCaipin = new OrderCaipin();
        orderCaipin.guid = orderCaipinDao.guid();
        orderCaipin.orderId = order.guid;
        orderCaipin.caipinId = caipin.guid;
        orderCaipin.caipinCode = caipin.code;
        orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        orderCaipin.name = caipin.name;
        orderCaipin.price = caipin.salePrice;
        orderCaipin.costprice = caipin.costprice;
        orderCaipin.num = num;
        orderCaipin.tuiNum = 0;
        orderCaipin.zengNum = 0;
        orderCaipin.unitName = caipin.unitName;
        orderCaipin.printId = caipin.printId;
        orderCaipin.printName = caipin.printName;
        orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        orderCaipin.minAgio = caipin.minAgio;
        orderCaipin.danPinBiLiZheKou = 0;
        orderCaipin.danPinJineZheKou = 0;
        orderCaipin.danPinZheKou = 0;
        orderCaipin.operator = operator.id;
        orderCaipin.dianCaiYuan = operator.id;
        orderCaipin.dianCaiYuanName = operator.name;
        orderCaipin.dianCaiTime = now;
        orderCaipin.modTime = now;
        orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
        orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;

        orderCaipin.priceChange = null == caipin.priceChange ? 'false' : caipin.priceChange;

        orderCaipin.hyPrice = caipin.hyPrice;
        orderCaipin.caipinTypeId = caipin.typeId;

        orderCaipin.caipinTypeCode = caipin.cpTypeCode;
        orderCaipin.caipinTypeName = caipin.cpTypeName;

        orderCaipin.customize = caipin.customize; //是否是自定义菜品字段，pos竖屏需要

        orderCaipin.orderZhuoTaiId = orderzhuotai.guid;
        orderCaipin.caiwuTypeName = caipin.caiwuTypeName;
        orderCaipin.caiwuTypeId = caipin.caiwuTypeId;

        orderCaipin.unitId = caipin.unitId;
        orderCaipin.cpdept = caipin.cpdept;
        orderCaipin.cpdeptName = caipin.cpdeptName;
        orderCaipin.mom = null;

        orderCaipin.dishFastNo = caipin.quickCode;
        orderCaipin.bestTypeId = caipin.bestTypeId;
        orderCaipin.bestTypeCode = caipin.bestTypeCode;
        orderCaipin.bestTypeName = caipin.bestTypeName;

        return orderCaipin;
    }

    // 创建套餐model
    function createOrderScombCaipin(operator, orderCaipin, caipin) {
        var num = 1;
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var scombCaipin = new OrderCaipin();
        scombCaipin.guid = orderScombCaipinDao.guid();

        scombCaipin.orderCaipinId = orderCaipin.guid;//订单中套餐菜品GUID
        scombCaipin.scombId = orderCaipin.caipinId;//套餐的GUID

        scombCaipin.caipinId = caipin.guid;
        scombCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        scombCaipin.name = caipin.name;
        scombCaipin.price = caipin.salePrice;
        scombCaipin.costprice = caipin.costprice;
        scombCaipin.num = num;
        scombCaipin.tuiNum = 0;
        scombCaipin.zengNum = 0;
        scombCaipin.unitName = caipin.unitName;
        scombCaipin.printId = caipin.printId;
        scombCaipin.printName = caipin.printName;
        scombCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        scombCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        scombCaipin.minAgio = caipin.minAgio;
        scombCaipin.danPinBiLiZheKou = 0;
        scombCaipin.danPinJineZheKou = 0;
        scombCaipin.danPinZheKou = 0;
        scombCaipin.operator = operator.id;
        scombCaipin.dianCaiYuan = operator.id;
        scombCaipin.dianCaiYuanName = operator.name;
        scombCaipin.dianCaiTime = now;
        scombCaipin.modTime = now;
        scombCaipin.needweigh = caipin.needweigh ? 1 : 0;
        scombCaipin.isScomb = 'true';
        scombCaipin.scombMainCaipinId = caipin.guid;

        scombCaipin.hyPrice = caipin.hyPrice;
        scombCaipin.caipinTypeId = caipin.typeId;
        scombCaipin.caipinTypeCode = caipin.typeCode;
        scombCaipin.caipinTypeName = caipin.typeName;

        return scombCaipin;
    }

    //判断当前菜品是否在加倍行列中
    AndroidService.inTurnTimesList = function (orderCaipin, cb) {
        var flag = true;
        if (null == orderCaipin) {
            flag = false;
        } else {
            if (null == orderCaipin.orgNum) {
                flag = false
            }
        }
        return cb(flag);
    }

    return AndroidService;
}]);