/**
 *  peter.shang
 */

app.factory('BanciService', ['$q', 'database', 'UniqueIDService', function ($q,database,UniqueIDService) {
    var BanciService = {};

    var banciDao = new DatabaseFuncDelegate($q, database, 'pos_banci');


    //
    BanciService.getUnFinished = function(userinfo, cb){
        //1. 得到属于当前登陆用户的为结班的班次
        banciDao.all("addOperatorId=? and status = ?",[userinfo.id, BIZCONSTANT.BANCI_WEI_JIE_BAN])
            .then(function(resultList){
            //1. 如果未结班的班次是属于当日，那么当前登陆用户就以该班次为准
            //2. 如果未结班的班次发生在当日之前，那么提醒当前登陆用户其有未结班的历史班次
            //3. 按道理，只会有最多一个结果
                if(resultList.length > 0){
                    userinfo.banCiHao = resultList[0].banCiNo;
                    userinfo.banCiStart = resultList[0].kaiBanTime;
                }
                cb(null, resultList);

        }, function(err){
            console.log(err);
            cb(err);
        });
    }

    /**
     * 执行开班动作
     * @param userinfo
     */
    BanciService.doKaiBan = function (userinfo, cb) {


        BanciService.getUnFinished(userinfo, function (err, result) {

            if (err)
                return cb({ message: "获取班次失败" }, null);

            if (result.length > 0)
                return cb({ message: "开班成功" }, null);

            var banci = null;

            var now = new Date();
            //班次号
            UniqueIDService.nextSeq(now, 'banCi', function (err, seq,nowdate) {
                if (err) {
                    return cb(err);
                }
                if (Utils.m(now.format('yyyyMMdd')) != Utils.m(nowdate)){
                    Utils.winLog("班次：主机与从机日期不相同"+"主机："+nowdate+"————从机："+now.format('yyyyMMdd'));
                    return cb({ message: "开班失败，主机与从机日期不相同，请修正后继续操作" }, null);
                }


                var seqNo = nowdate + Utils.formatSeqNo(seq);
                banci = "BC" + seqNo;

                UniqueIDService.MaxSeq('pos_banci', 'banCiNo', 'BC', function (maxerr, maxseq) {
                    if (Utils.m(seqNo) < Utils.m(maxseq)){
                        Utils.winLog("班次：开班时间小于库时间"+"主机时间："+maxseq+"————库时间："+seqNo);
                        return cb({ message: "开班失败，请检查主机机器时间是否正常" }, null);
                    }


                    var all = [];
                    all.push({
                        query: 'insert into pos_banci' +
                        '(guid,banCiNo,kaiBanTime,status,addOperatorId,addOperatorCode,addOperatorName,syn)' +
                        'values(?,?,?,?,?,?,?,?)',
                        params: [Utils.guid(), banci, now.format("yyyy-MM-dd hh:mm:ss"), BIZCONSTANT.BANCI_WEI_JIE_BAN, userinfo.id, userinfo.code, userinfo.name, '0']
                    });
                    banciDao.queryTransaction(all).then(function (resultList) {
                        userinfo.banCiHao = banci;
                        userinfo.banCiStart = now.format("yyyy-MM-dd hh:mm:ss");
                        cb({ message: "开班成功." }, null);
                    }, function (err) {
                        console.log(err);
                        cb({ message: "开班失败." });
                    });

                });

               

            });
        });
    }


    // 开班
    //BanciService.openBanci = function(userinfo){
    //    var deferred = $q.defer();
    //    var date = new Date();
    //    var datestr = date.format("yyyy-MM-dd");
    //    banciDao.all("Operator_ID=? and date(StartTime)=? and IfJieBan=0 and IfJiaoZhang=0",
    //        [userinfo.id, datestr])
    //    .then(function(rows){
    //        if(rows.length > 0){
    //            deferred.resolve(rows[0]);
    //        }
    //        else{
    //            UniqueIDService.nextSeq(date, 'banci', function(err, seq){
    //                if(err){
    //                    deferred.reject(err);
    //                }
    //                else{
    //                    banciDao.insert(
    //                        {
    //                            id: banciDao.guid(), Operator_ID: userinfo.id, StartTime: date.format("yyyy-MM-dd hh:mm:ss"),
    //                            IfJieBan: 0, IfJiaoZhang:0,
    //                            BanCiHao: date.format("yyyyMMdd")+Utils.formatSeqNo(seq),
    //                            MD_ID:CONSTANTS.SystemConfigs["MD_ID"].SystemConfigValue,
    //                            Synced: 0
    //                        }
    //                    ).then(function(result){
    //                        deferred.resolve(result.affectedItem);
    //                    });
    //                }
    //            });
    //
    //        }
    //    });
    //    return deferred.promise;
    //};

    BanciService.handover = function(userinfo,banciInfo,qianguiMoney,jiaozhangDate,cb){
        banciDao.query("update hisoperatorbanci set EndTime='"+jiaozhangDate+"',IfJieBan=1, IfJiaoZhang=1,JiaoZhangMoney="+qianguiMoney+" where BanCiHao='"+banciInfo.BanCiHao+"'").then(function(result){
            cb(null, result);
        }, function(err){
            cb(err);
        });
    };
    
    /*JP 2016-03-09
     根据操作员ID获取未结班的班次 */
    BanciService.getweijieBanciByOperatorId = function (operatorId, cb) {
        banciDao.all(" status='0' and addOperatorId='" + operatorId + "'").then(function (result) {
            return cb(null, result);
        }, function (err) {
            return cb(err);
        })
    };


    return BanciService;
}]);