app.factory("BujimingkaService", ["$http", function($http){
    var BujimingkaService = {};

    //读卡
    BujimingkaService.duka = function(cardNo, cb) {
        var url = handlePosUrl(SERVER_HOST.BASE_HOST + API_CONTEXT.CRM + "/api/v1/crmCard4Anonymous/findByCode" + "?token=123&t=1");

        var data = {};
        BIZCONSTANT.POSUSER.json4common(data);
        data.tradeAddress = CONSTANTS.SystemConfigs['HotelAddress'] ? CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue : '';
        data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
        if(!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;
        data.cardCode = cardNo;

        $http({
            method: 'POST',
            url: url,
            headers: {"Content-Type":"application/json"},
            data: data
        }).success(function(data,header,config,status){
            //console.info(data);
            if(data.status != "success"){
                cb(data.errorMsg);
            } else {
                cb(null,data.data);
            }
        }).error( function(data,header,config,status){
            //console.info(data);
            cb("读卡失败，请联系客服或稍后重试");
        } );
    }

    //开新卡
    BujimingkaService.createNewCard = function(cardNo, cb) {
        var url = handlePosUrl(SERVER_HOST.BASE_HOST + API_CONTEXT.CRM + "/api/v1/crmCard4Anonymous/createNewCard4Anonymous" + "?token=123&t=1");

        var data = {};
        BIZCONSTANT.POSUSER.json4common(data);
        data.cardAddress = CONSTANTS.SystemConfigs['HotelAddress'] ? CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue : '';
        data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
        if(!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;
        data.timestamp = Utils.now();
        data.cardCode = cardNo;

        $http({
            method: 'POST',
            url: url,
            headers: {"Content-Type":"application/json"},
            data: data
        }).success(function(data,header,config,status){
            //console.info(data);
            if(data.status != "success"){
                cb(data.errorMsg);
            } else {
                cb(null);
            }
        }).error( function(data,header,config,status){
            //console.info(data);
            cb("发新卡失败，请联系客服或稍后重试");
        } );
    }

    //充值
    BujimingkaService.chongZhi = function(czData, cb) {
        var url = handlePosUrl(SERVER_HOST.BASE_HOST + API_CONTEXT.CRM + "/api/v1/crmCard4Anonymous/recharge4Anonymous" + "?token=123&t=1");

        var data = {};
        BIZCONSTANT.POSUSER.json4common(data);
        data.cardAddress = CONSTANTS.SystemConfigs['HotelAddress'] ? CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue : '';
        data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
        if(!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;
        data.cardCode = czData.cardCode;
        data.rechargePayType = czData.rechargePayType;
        data.rechargePayTypeName = czData.rechargePayTypeName;
        data.rechargeAmount = czData.rechargeAmount;
        data.rechargePresentAmount = czData.rechargePresentAmount;
        data.rechargeFapiaoMoney = czData.rechargeFapiaoMoney;
        data.timestamp = Utils.now();

        $http({
            method: 'POST',
            url: url,
            headers: {"Content-Type":"application/json"},
            data: data
        }).success(function(data,header,config,status){
            //console.info(data);
            if(data.status != "success"){
                cb(data.errorMsg);
            } else {
                cb(null, data.data);
            }
        }).error( function(data,header,config,status){
            //console.info(data);
            cb("充值失败，请联系客服或稍后重试");
        } );
    }

    //退卡
    BujimingkaService.tuiKa = function(cardNo, cb) {
        var url = handlePosUrl(SERVER_HOST.BASE_HOST + API_CONTEXT.CRM + "/api/v1/crmCard4Anonymous/returnAnonymousCard" + "?token=123&t=1");

        var data = {};
        BIZCONSTANT.POSUSER.json4common(data);
        data.cardAddress = CONSTANTS.SystemConfigs['HotelAddress'] ? CONSTANTS.SystemConfigs['HotelAddress'].systemConfigValue : '';
        data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
        if(!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;
        data.timestamp = Utils.now();
        data.cardCode = cardNo;


        $http({
            method: 'POST',
            url: url,
            headers: {"Content-Type":"application/json"},
            data: data
        }).success(function(data,header,config,status){
            //console.info(data);
            if(data.status != "success"){
                cb(data.errorMsg);
            } else {
                cb(null);
            }
        }).error( function(data,header,config,status){
            //console.info(data);
            cb("退卡失败，请联系客服或稍后重试");
        } );
    }


    return BujimingkaService;

}]);