app.factory('CaipinService', ['$q', 'database', function ($q, database) {
    var CaipinService = {};

    var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');

    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');

    var caipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_zuofa');
    
    CaipinService.getScombInfoById = function (cb, scombId) {
        var sql = "select 	s.*,ct.guid as tcTypeId,ct.dishTypeCode as tcTypeCode,ct.dishTypeName as tcTypeName,t1.*,t2.* " +
                " from pos_caipin as s  " +
                " left join pos_caipin_type ct on s.typeId=ct.guid "+
                " left join (select sc.guid scpTabGuid,sc.scombId scpScombId,sc.num as scpCaipinNum,sc.costprice ," +
                            "scp.guid scpId,scp.code scpCode,scp.name scpName,scp.salePrice scpSalePrice," +
                            "scp.hyPrice scpHyPrice,scp.unitId scpUnitId,scp.unitName scpUnitName,scp.minAgio scpMinAgio, " +
                            "ct.guid as scpTypeId,ct.dishTypeCode as scpTypeCode,ct.dishTypeName as scpTypeName," +
                             " case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as scpCaipinGqNum " +
                            " from pos_scomb_caipin as sc" +
                            " inner join  pos_caipin as scp on sc.caipinId=scp.guid and scp.enabled='true' and scp.isDeleted='false' " +
                            " left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                         " and endTime >= datetime('now','localtime')) gq on scp.guid=gq.caipinGuid " +
                         " LEFT JOIN pos_caipin_type ct ON scp.typeId = ct.guid) t1 on s.guid=t1.scpScombId " +
                " left join (select bx.scombId bxcScombId,bx.scombCaipinId bxcScombCaipinId,bx.bxCaipinNum as bxCaipinNum," +
                            "bxc.guid bxcId,bxc.code bxcCode,bxc.name bxcName,bxc.salePrice bxcSalePrice," +
                            "bxc.hyPrice bxcHyPrice,bxc.unitId bxcUnitId,bxc.unitName bxcUnitName,bxc.minAgio bxcMinAgio, " +
                            "ct.guid as bxcTypeId,ct.dishTypeCode as bxcTypeCode,ct.dishTypeName as bxcTypeName," +
                            " case  when gq.caipinNum is NULL then -1 else gq.caipinNum	end as bxCaipinGqNum ,bx.costprice as bxcostprice " +
                            " from pos_scomb_beixuan_caipin as bx " +
                            " inner join pos_caipin as bxc on bx.bxCaipinId=bxc.guid and bxc.enabled='true' and bxc.isDeleted='false'" +
                            " left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') " +
                                " and endTime >= datetime('now','localtime')) gq on bxc.guid=gq.caipinGuid " +
                            "LEFT JOIN pos_caipin_type ct ON bxc.typeId = ct.guid) t2 on t1.scpTabGuid=t2.bxcScombCaipinId" +
                " where s.isScomb='true' and  s.isDeleted='false' " + (scombId == null ? "" : (" and s.guid='" + scombId + "'"));

        caipinDao.query(sql).then(function (result) {
            var resultList = [];
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];

                    var scomb = Utils.arrayFind(resultList, row.guid, "guid")
                    if (scomb == null) {
                        scomb = new Scomb();
                        scomb.setScombInfo(createScombInfo(row));
                        resultList.push(scomb);
                    }

                    if (row.scpId != null) {
                        var scombCaipin = Utils.arrayFind(scomb.scombCaipins, row.scpId, "guid")
                        if (scombCaipin == null) {
                            scombCaipin = new ScombCaipin();
                            scombCaipin.setScombCaipinInfo(createScombCaipin(row));
                            scomb.addScombCaipin(scombCaipin);
                        }

                        if (row.bxcId != null) {
                            var bxCaipin = Utils.arrayFind(scombCaipin.getBXScombCaipin, row.bxcId, "guid");
                            if (bxCaipin == null) {
                                bxCaipin = createBXCaipin(row);
                                bxCaipin.scombMainCaipinId = row.scpId;
                                scombCaipin.addBXScombCaipin(bxCaipin);
                            }
                        }

                        if(scomb.scombInfo.bestTypeName == null && row.bxcTypeName != null) {
                            scomb.scombInfo.dishFastNo = row.quickCode;
                            scomb.scombInfo.bestTypeId = row.bxcTypeId;
                            scomb.scombInfo.bestTypeCode = row.bxcTypeCode;
                            scomb.scombInfo.bestTypeName = row.bxcTypeName;
                        }
                    }

                }
            }

            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };

    CaipinService.getScombInfoByIds = function (cpids, cb) {
        var sql = "select 	s.*,ct.guid as tcTypeId,ct.dishTypeCode as tcTypeCode,ct.dishTypeName as tcTypeName,t1.*,t2.* " +
                " from pos_caipin as s  " +
                " left join pos_caipin_type ct on s.typeId=ct.guid " +
                " left join (select sc.guid scpTabGuid,sc.scombId scpScombId,sc.num as scpCaipinNum,sc.costprice ," +
                            "scp.guid scpId,scp.code scpCode,scp.name scpName,scp.salePrice scpSalePrice," +
                            "scp.hyPrice scpHyPrice,scp.unitId scpUnitId,scp.unitName scpUnitName,scp.minAgio scpMinAgio, " +
                            "ct.guid as scpTypeId,ct.dishTypeCode as scpTypeCode,ct.dishTypeName as scpTypeName," +
                             " case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as scpCaipinGqNum " +
                            " from pos_scomb_caipin as sc" +
                            " inner join  pos_caipin as scp on sc.caipinId=scp.guid and scp.enabled='true' and scp.isDeleted='false' " +
                            " left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                         " and endTime >= datetime('now','localtime')) gq on scp.guid=gq.caipinGuid " +
                         " LEFT JOIN pos_caipin_type ct ON scp.typeId = ct.guid) t1 on s.guid=t1.scpScombId " +
                " left join (select bx.scombId bxcScombId,bx.scombCaipinId bxcScombCaipinId,bx.bxCaipinNum as bxCaipinNum," +
                            "bxc.guid bxcId,bxc.code bxcCode,bxc.name bxcName,bxc.salePrice bxcSalePrice," +
                            "bxc.hyPrice bxcHyPrice,bxc.unitId bxcUnitId,bxc.unitName bxcUnitName,bxc.minAgio bxcMinAgio, " +
                            "ct.guid as bxcTypeId,ct.dishTypeCode as bxcTypeCode,ct.dishTypeName as bxcTypeName," +
                            " case  when gq.caipinNum is NULL then -1 else gq.caipinNum	end as bxCaipinGqNum ,bx.costprice as bxcostprice " +
                            " from pos_scomb_beixuan_caipin as bx " +
                            " inner join pos_caipin as bxc on bx.bxCaipinId=bxc.guid and bxc.enabled='true' and bxc.isDeleted='false'" +
                            " left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') " +
                                " and endTime >= datetime('now','localtime')) gq on bxc.guid=gq.caipinGuid " +
                            "LEFT JOIN pos_caipin_type ct ON bxc.typeId = ct.guid) t2 on t1.scpTabGuid=t2.bxcScombCaipinId" +
                " where s.isScomb='true' and  s.isDeleted='false' and s.guid in (" + cpids + ")";

        caipinDao.query(sql).then(function (result) {
            var resultList = [];
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];

                    var scomb = Utils.arrayFind(resultList, row.guid, "guid")
                    if (scomb == null) {
                        scomb = new Scomb();
                        scomb.setScombInfo(createScombInfo(row));
                        resultList.push(scomb);
                    }

                    if (row.scpId != null) {
                        var scombCaipin = Utils.arrayFind(scomb.scombCaipins, row.scpId, "guid");
                        if (scombCaipin == null) {
                            scombCaipin = new ScombCaipin();
                            scombCaipin.setScombCaipinInfo(createScombCaipin(row));
                            scomb.addScombCaipin(scombCaipin);
                        }

                        if (row.bxcId != null) {
                            var bxCaipin = Utils.arrayFind(scombCaipin.getBXScombCaipin, row.bxcId, "guid");
                            if (bxCaipin == null) {
                                bxCaipin = createBXCaipin(row);
                                bxCaipin.scombMainCaipinId = row.scpId;
                                scombCaipin.addBXScombCaipin(bxCaipin);
                            }
                        }
                    }

                }
            }

            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };


    CaipinService.getScombInfoByCodes = function (cpids, cb) {
        var sql = "select 	s.*,ct.guid as tcTypeId,ct.dishTypeCode as tcTypeCode,ct.dishTypeName as tcTypeName,t1.*,t2.* " +
                " from pos_caipin as s  " +
                " left join pos_caipin_type ct on s.typeId=ct.guid " +
                " left join (select sc.guid scpTabGuid,sc.scombId scpScombId,sc.num as scpCaipinNum,sc.costprice ," +
                            "scp.guid scpId,scp.code scpCode,scp.name scpName,scp.salePrice scpSalePrice," +
                            "scp.hyPrice scpHyPrice,scp.unitId scpUnitId,scp.unitName scpUnitName,scp.minAgio scpMinAgio, " +
                            "ct.guid as scpTypeId,ct.dishTypeCode as scpTypeCode,ct.dishTypeName as scpTypeName," +
                             " case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as scpCaipinGqNum " +
                            " from pos_scomb_caipin as sc" +
                            " inner join  pos_caipin as scp on sc.caipinId=scp.guid and scp.enabled='true' and scp.isDeleted='false' " +
                            " left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                         " and endTime >= datetime('now','localtime')) gq on scp.guid=gq.caipinGuid " +
                         " LEFT JOIN pos_caipin_type ct ON scp.typeId = ct.guid) t1 on s.guid=t1.scpScombId " +
                " left join (select bx.scombId bxcScombId,bx.scombCaipinId bxcScombCaipinId,bx.bxCaipinNum as bxCaipinNum," +
                            "bxc.guid bxcId,bxc.code bxcCode,bxc.name bxcName,bxc.salePrice bxcSalePrice," +
                            "bxc.hyPrice bxcHyPrice,bxc.unitId bxcUnitId,bxc.unitName bxcUnitName,bxc.minAgio bxcMinAgio, " +
                            "ct.guid as bxcTypeId,ct.dishTypeCode as bxcTypeCode,ct.dishTypeName as bxcTypeName," +
                            " case  when gq.caipinNum is NULL then -1 else gq.caipinNum	end as bxCaipinGqNum ,bx.costprice as bxcostprice " +
                            " from pos_scomb_beixuan_caipin as bx " +
                            " inner join pos_caipin as bxc on bx.bxCaipinId=bxc.guid and bxc.enabled='true' and bxc.isDeleted='false'" +
                            " left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') " +
                                " and endTime >= datetime('now','localtime')) gq on bxc.guid=gq.caipinGuid " +
                            "LEFT JOIN pos_caipin_type ct ON bxc.typeId = ct.guid) t2 on t1.scpTabGuid=t2.bxcScombCaipinId" +
                " where s.isScomb='true' and  s.isDeleted='false' and s.code in (" + cpids + ")";

        caipinDao.query(sql).then(function (result) {
            var resultList = [];
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];

                    var scomb = Utils.arrayFind(resultList, row.guid, "guid")
                    if (scomb == null) {
                        scomb = new Scomb();
                        scomb.setScombInfo(createScombInfo(row));
                        resultList.push(scomb);
                    }

                    if (row.scpId != null) {
                        var scombCaipin = Utils.arrayFind(scomb.scombCaipins, row.scpId, "guid");
                        if (scombCaipin == null) {
                            scombCaipin = new ScombCaipin();
                            scombCaipin.setScombCaipinInfo(createScombCaipin(row));
                            scomb.addScombCaipin(scombCaipin);
                        }

                        if (row.bxcId != null) {
                            var bxCaipin = Utils.arrayFind(scombCaipin.getBXScombCaipin, row.bxcId, "guid");
                            if (bxCaipin == null) {
                                bxCaipin = createBXCaipin(row);
                                bxCaipin.scombMainCaipinId = row.scpId;
                                scombCaipin.addBXScombCaipin(bxCaipin);
                            }
                        }
                    }

                }
            }

            return cb(null, resultList);
        }, function (err) {
            return cb(err);
        });
    };


    function createScombInfo(row) {
        var caipin = new Caipin();
        caipin.guid = row.guid;
        caipin.code = row.code;
        caipin.name = row.name;
       
        caipin.quickCode = row.quickCode;
        caipin.salePrice = row.salePrice;
        caipin.costprice = row.costprice;
        caipin.hyPrice = row.hyPrice;
        caipin.unitId = row.unitId;
        caipin.unitName = row.unitName;
        caipin.minAgio = row.minAgio;
        caipin.printId = row.printId;
        caipin.printName = row.printName;
        caipin.enabled = row.enabled;
        caipin.customize = row.customize;
        caipin.needweigh = row.needweigh;
        caipin.isScomb = row.isScomb;
        caipin.isDeleted = row.isDeleted;

        caipin.typeId = row.tcTypeId;
        caipin.typeCode = row.tcTypeCode;
        caipin.typeName = row.tcTypeName;
        
        caipin.cpTypeCode= row.tcTypeCode;
        caipin.cpTypeId= row.tcTypeId;
        caipin.cpTypeName = row.tcTypeName;

        caipin.caiwuTypeName = row.caiwuTypeName;
        caipin.caiwuTypeId = row.caiwuTypeId;

        caipin.unitId = row.unitId;
        caipin.cpdept = row.cpdept;
        caipin.cpdeptName = row.cpdeptName;


        caipin.dishFastNo = row.quickCode;
        caipin.bestTypeId = row.bxcTypeId;
        caipin.bestTypeCode = row.bxcTypeCode;
        caipin.bestTypeName = row.bxcTypeName;

        return caipin;
    }


    function createScombCaipin(row) {
        var caipin = new Caipin();
        caipin.guid = row.scpId;
        caipin.code = row.scpCode;
        caipin.name = row.scpName;
        
        //caipin.quickCode = row.quickCode;
        caipin.salePrice = row.scpSalePrice;
        caipin.hyPrice = row.scpHyPrice;
        caipin.costprice = row.costprice;
        caipin.unitId = row.scpUnitId;
        caipin.unitName = row.scpUnitName;
        caipin.minAgio = row.scpMinAgio;
        //caipin.printId = row.printId;
        //caipin.printName = row.printName;
        //caipin.enabled = row.enabled;
        //caipin.customize = row.customize;
        //caipin.needweigh = row.needweigh;
        //caipin.isScomb = row.isScomb;
        //caipin.isDeleted = row.isDeleted;
        caipin.scombMainCaipinId = row.scpId;
        caipin.caipinNum = row.scpCaipinNum;
        caipin.caipinGqNum = row.scpCaipinGqNum;

        caipin.typeId = row.scpTypeId;
        caipin.typeCode = row.scpTypeCode;
        caipin.typeName = row.scpTypeName;
        return caipin;
    }

    function createBXCaipin(row) {
        var caipin = new Caipin();
        caipin.guid = row.bxcId;
        caipin.code = row.bxcCode;
        caipin.name = row.bxcName;
        //caipin.quickCode = row.quickCode;
        caipin.salePrice = row.bxcSalePrice;
        caipin.hyPrice = row.bxcHyPrice;
        caipin.costprice = row.bxcostprice;
        caipin.unitId = row.bxcUnitId;
        caipin.unitName = row.bxcUnitName;
        caipin.minAgio = row.bxcMinAgio;
        //caipin.printId = row.printId;
        //caipin.printName = row.printName;
        //caipin.enabled = row.enabled;
        //caipin.customize = row.customize;
        //caipin.needweigh = row.needweigh;
        //caipin.isScomb = row.isScomb;
        //caipin.isDeleted = row.isDeleted;
        caipin.caipinNum = row.bxCaipinNum;
        caipin.caipinGqNum = row.bxCaipinGqNum;

        caipin.typeId = row.bxcTypeId;
        caipin.typeCode = row.bxcTypeCode;
        caipin.typeName = row.bxcTypeName;

        return caipin;
    }


    return CaipinService;
}]);