app.factory('CardService', ['$q', 'database', 'UniqueIDService', 'AjaxLogger', function ($q, database, UniqueIDService, AjaxLogger) {

    crmsdk.AjaxLogger = AjaxLogger;

    var CardService = {};

    //根据手机号码查询会员信息API
    CardService.GetMemberInfobyPhoneNum = function (phone,callback,errorcallback)
    {
        crmsdk.post(MEMBERURL.SEARCH_BY_MOBILE, { hyMobile: phone }, function (result) {
            callback(result);
        }, errorcallback);
    }

    //根据卡号查询卡信息
    CardService.GetCardInfo = function (cardcode, callback, errorcallback) {
        crmsdk.post(MEMBERURL.SEARCH_BY_CARD_NO, { cardCode: cardcode }, function (result) {
            callback(result);
        }, errorcallback);
    }

    //获取卡类型及卡等级API
    CardService.FindCardLevel = function (callback,errorcallback) {
        crmsdk.post(MEMBERURL.FINDCARDLEVEL, {}, function (result) {
            callback(result);
        }, errorcallback);
    }

    //发卡
    CardService.CreateCard = function (carmember, callback, errorcallback)
    {
        carmember.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        carmember.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        crmsdk.post(MEMBERURL.CREATECARD, carmember, function (result) {
            callback(result);
        }, errorcallback);
    }
    
    //撤销储值消费
    CardService.UndoChuzhi = function (undochuzhiObj, callback, errorcallback)
    {
        undochuzhiObj.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        undochuzhiObj.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        crmsdk.post(MEMBERURL.HUIYUANKACHUZHI, undochuzhiObj, function (result) {
            callback(result);
        }, errorcallback);
    }
    
    //撤销积分消费
    CardService.UndoJifen = function (undojifenObj, callback, errorcallback)
    {
        undojifenObj.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        undojifenObj.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        crmsdk.post(MEMBERURL.HUIYUANKAJIFEN, undojifenObj, function (result) {
            callback(result);
        }, errorcallback);
    }
    
    //根据凭据好查看明细
    CardService.ShowMinxi = function (mingxiObj, callback, errorcallback)
    {
        mingxiObj.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        mingxiObj.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        crmsdk.post(MEMBERURL.SHUOMINGXI, mingxiObj, function (result) {
            callback(result);
        }, errorcallback);
    }

    //充API
    CardService.ReCharge = function (czinfo, callback, errorcallback) {
        czinfo.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        czinfo.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        crmsdk.post(MEMBERURL.RECHARGE, czinfo, function (result) {
            callback(result);
        }, errorcallback);
    }

    //撤销列表
    CardService.CardBanciTrade = function (cardno, banci, callback, errorcallback)
    {
        crmsdk.post(MEMBERURL.CARDBANCITRADE, {banci:banci, cardCode: cardno }, function (result) {
            callback(result);
        }, errorcallback);
    }

    //撤销
    CardService.CancelRechardTrade = function (tradeCredentialNumber, note, callback, errorcallback) {
        crmsdk.post(MEMBERURL.CANCELRECHARDTRADE, { cardTrades:[{credentialNumber: tradeCredentialNumber}], note: note }, function (result) {
            callback(result);
        }, errorcallback);
    }

    //打开读卡器（占用连接，防止被电子称占用）
    CardService.OpenJust = function (callback, errorcallback) {

        var cardtype = CAT_PAR.LOCAL.DKQSZ;
        if (Utils.isEmpty(cardtype))
            return errorcallback('请先配置读卡器');

        var cardhard = HardWareManager.get(cardtype);
        var cfg = { port: Utils.m(CAT_PAR.LOCAL.DKDK.replaceAll('COM', '')), baud: Utils.m(CAT_PAR.LOCAL.BTL) };
        if (cardhard.justOpen)
            cardhard.justOpen(cfg, callback, errorcallback);
        else
        {
            callback(true);
            errorcallback(null);
        }
    }

    //读卡
    CardService.ReadCard = function (defultCardno,callback,errorcallback)
    {
        //if(!CONSTANTS.PRODUCTION){
        //    callback({card_no: "215000", error:""});
        //    return;
        //}
        debugger;
        //var cardtype = getSystemConfig('readCardType', '');
        var cardtype = CAT_PAR.LOCAL.DKQSZ;
        if (Utils.isEmpty(cardtype))
            return errorcallback('请先配置读卡器');

        if (cardtype == CONSTANTS.HardWareConstants.CT_CARD)
        {
            if(defultCardno==='')
                return errorcallback('请先刷卡');
            return callback({ card_no: "", error: "" }); //errorcallback('请先刷卡');
        }
            

        var cardhard = HardWareManager.get(cardtype);
        //var cfg = { port: Utils.m(getSystemConfig('readCardPort', 'COM1').replaceAll('COM', '')), baud: Utils.m(getSystemConfig('readCardBotelv', '9600')) };
        //cardhard.open(cfg, callback, errorcallback);

        var cfg = { port: Utils.m(CAT_PAR.LOCAL.DKDK.replaceAll('COM', '')), baud: Utils.m(CAT_PAR.LOCAL.BTL)};
        cardhard.open(cfg, callback, errorcallback);


    }

    //写卡
    CardService.WirteCard = function (cardno, callback, errorcallback) {
        debugger;
        //var cardtype = getSystemConfig('readCardType', '');
        var cardtype = CAT_PAR.LOCAL.DKQSZ;
        if (Utils.isEmpty(cardtype))
            return errorcallback('请先配置读卡器');

        if (cardtype == CONSTANTS.HardWareConstants.CT_CARD)//磁条卡的话直接过
            return callback('');

        var cardhard = HardWareManager.get(cardtype);
        //var cfg = { port: Utils.m(getSystemConfig('readCardPort', 'COM1').replaceAll('COM','')), baud: Utils.m(getSystemConfig('readCardBotelv', '9600')) };
        //cardhard.write(cardno, callback, errorcallback);

        var cfg = { port: Utils.m(CAT_PAR.LOCAL.DKDK.replaceAll('COM', '')), baud: Utils.m(CAT_PAR.LOCAL.BTL)};
        cardhard.write(cardno, callback, errorcallback);

    }

    //清卡（写空字符）
    CardService.ClearCard = function ()
    {
        CardService.WirteCard(' ', function (result) { }, function (error) { });
    }

    /*JP 2016-03-11
    根据班次获取会员储值信息
    */
    CardService.getHuiyuanChuzhiByBanci = function (callback, errorcallback) {
        crmsdk.post(MEMBERURL.BANCIPAYTYPETRADE, { bancis: [BIZCONSTANT.POSUSER.banCiHao] }, function (result) {
            callback(result);
        }, errorcallback);
    }

    /*
    根据班次获取会员退卡金额
    */
    CardService.getHuiyuanTuiMoneyByBanci = function (callback, errorcallback) {
        crmsdk.post(MEMBERURL.BANCITUIKATRADE, { bancis: [BIZCONSTANT.POSUSER.banCiHao] }, function (result) {
            callback(result);
        }, errorcallback);
    }

    /*zyy 2016-08-2
    根据多个班次获取会员储值信息
    */
    CardService.getHuiyuanChuzhiByBancis = function (bancis,callback, errorcallback) {
        crmsdk.post(MEMBERURL.BANCIPAYTYPETRADE, { bancis: bancis }, function (result) {
            callback(result);
        }, errorcallback);
    }

    /*
   根据班次获取会员退卡金额
   */
    CardService.getHuiyuanTuiMoneyByBancis = function (bancis,callback, errorcallback) {
        crmsdk.post(MEMBERURL.BANCITUIKATRADE, { bancis: bancis }, function (result) {
            callback(result);
        }, errorcallback);
    }

    /******************
     *根据凭据号获取明细
     *
     *******************/
    CardService.getMinxi = function (pm, jieSuan, cb) {
        var param = {
            "credentialNumber":pm.ext1 //凭据号列表
        }
        //console.log("sddff:"+param)
        CardService.ShowMinxi(param, cb)

    }

    //根据券号，获取券信息
    CardService.getCouponInfo = function (couponNo, callback, errorcallback)
    {
        var couponRequest = { couponCode: couponNo };
        crmsdk.post(MEMBERURL.COUPONINFO, couponRequest, function (result) {
            return callback(result);
        }, errorcallback);
    }

    //券核销
    CardService.couponPay = function (coupon,jieSuan,paymenthd, callback, errorcallback) {
        var requestBody = {};
        requestBody.note = null; //备注？
        //jieSuan.getMember().json4Pay(requestBody);
        requestBody.orderNo = jieSuan.order.code;
        requestBody.zhuotaiNo = jieSuan.order.zhuotaiCode;// ZT No
        requestBody.zhuotaiName = jieSuan.order.zhuotaiName;// ZT Name
        requestBody.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        requestBody.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        requestBody.timestamp = Utils.now();
        requestBody.hyId = coupon.memberInfo.guid;
        var detail = [];
        
        var tmpCoupon = {
            tradeDetailType: "RD101",	//交易流水类型：积分消费
            payMoney: coupon.couponNo,//券号
            payType: paymenthd.pmId,	//付款方式ID
            payTypeName: paymenthd.name,
            couponToCash:coupon.usedMoney
        };
        var activityId = null;
        activityId = coupon.activityId;
        if(!activityId) activityId = null;
        detail.push({tradeType:"R10",
            activityId:activityId,
            cardTradeDetails: [tmpCoupon]
        });

        requestBody.cardTrades = detail;
        requestBody.couponCode = coupon.couponNo;
        if (jieSuan.getMember())
            requestBody.cardCode = jieSuan.getMember().getCardNo();

        crmsdk.post(MEMBERURL.JIE_SUAN_MEMBER, requestBody, function (result) {
            return callback(result);
        }, errorcallback);
    }

    //获取卡查询结果
    CardService.getCardInfos = function (undojifenObj, callback, errorcallback){
        crmsdk.post(MEMBERURL.CARD_INFO, undojifenObj, function (result) {
            callback(result);
        }, errorcallback);
    }

    return CardService;
}]);