app.factory('DataCleanerService', ['$q', 'database', '$http', "$window", 'UniqueIDService', function ($q, database, $http, $window, UniqueIDService) {
    var DataCleanerService = {};

    var dao = new DatabaseFuncDelegate($q, database, 'pos_system_config');

    DataCleanerService.starup = function () {
        UniqueIDService.MaxSeq('pos_banci', 'jieBanTime', '', function (err, maxtime) {
            var clearnBeginTime=new Date();
            if(!err&&maxtime)
            {
                var sdate = new Date(maxtime);
                if (sdate != 'Invalid Date')
                    clearnBeginTime = sdate;
            }
            deleteData(clearnBeginTime);
        });
	};

    function deleteData(clearnBeginTime) {
        console.info('数据清理开始时间', clearnBeginTime, clearnBeginTime.format('yyyy-MM-dd hh:mm:ss'));
	    var AddDays = function (date, value) {
	        return new Date(date.setDate(date.getDate() + value));
	    };
	    var delJobTime = AddDays(clearnBeginTime, BIZCONSTANT.JOB_DELETE_DAY * -1);//job数据删除时间
	    var delOrderTime = AddDays(clearnBeginTime, BIZCONSTANT.ORDER_DELETE_DAY * -1);//order数据时间

        //获取可以删除的班次号，时间，已结班，已同步，所有账单已同步的班次
        var bancisql="SELECT banCiNo FROM pos_banci"
            + " WHERE status=1 AND syn=1 AND jieBanTime<='"+delOrderTime.format("yyyy-MM-dd hh:mm:ss")+"' AND NOT EXISTS("
            + " SELECT 1 FROM pos_banci_order"
            + " INNER JOIN pos_billing on pos_billing.orderId=pos_banci_order.orderId"
            + " WHERE pos_banci.banCiNo=pos_banci_order.banciNo AND pos_billing.syn=0)";

        //删除pos_entitynamemap历史数据
        var delHistoryMsgSql = "delete from pos_entitynamemap where status=2 and guid not in " +
            "(select * from " +
            "(select * from (select guid from pos_entitynamemap where status=2 and entityType = 'PosChainMDCaipuInfo' order by sendTime DESC limit 100)" +
            " UNION " +
            "select * from (select guid from pos_entitynamemap where status=2 and entityType <> 'PosChainMDCaipuInfo' order by sendTime DESC limit 100)));"

        dao.query(bancisql).then(function (result) {
            var delBancihao=result.detail;

            var queries = [];
            //删除消息中心历史消息
            queries.push({query: delHistoryMsgSql});
            //删除job数据
            queries.push({ query: "delete from printer_job where createTime<='" + delJobTime.format("yyyy-MM-dd hh:mm:ss") + "'" });
            queries.push({ query: "delete from printer_job_log where createTime<='" + delJobTime.format("yyyy-MM-dd hh:mm:ss")  + "'" });
            queries.push({ query: "delete from printer_status_log where createTime<='" +  delJobTime.format("yyyy-MM-dd hh:mm:ss")  + "'" });
            queries.push({ query: "delete from tmp_uniqueid where usedate<='" + delJobTime.format("yyyy-MM-dd")  + "'" });

            //删除order数据
            if(delBancihao && delBancihao.length>0){
                var ordersql="SELECT orderId FROM pos_banci_order WHERE banciNo in("+bancisql+")";

                var jiesuansql="SELECT pos_billing.guid FROM pos_banci_order INNER JOIN pos_billing ON pos_banci_order.orderId=pos_billing.orderId WHERE banciNo in("+bancisql+")";

                var dishsql="SELECT pos_order_caipin.guid FROM pos_banci_order INNER JOIN pos_order_caipin ON pos_banci_order.orderId=pos_order_caipin.orderId WHERE banciNo in("+bancisql+")";

                queries.push({ query: "delete from pos_order_caipin_zengsong where orderCaipinId in(" + dishsql + ")" });
                queries.push({ query: "delete from pos_order_scomb_caipin where orderCaipinId in(" + dishsql + ")" });
                queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId in(" + dishsql + ")" });
                queries.push({ query: "delete from pos_order_caipin_zuofa where orderCaipinId in(" + dishsql + ")" });
                queries.push({ query: "delete from pos_billing_detail where jieSuanId in(" + jiesuansql + ")" });
                queries.push({ query: "delete from pos_order_caipin where orderId in(" + ordersql + ")" });
                queries.push({ query: "delete from pos_order where guid in(" + ordersql + ")" });
                //queries.push({ query: "delete from pos_billing where orderId in(" + ordersql + ")" });

                for(var b in delBancihao){
                    queries.push({ query: "delete from pos_billing where banci='" + delBancihao[b].banCiNo + "' AND syn=1" });
                }

                for(var b in delBancihao){
                    queries.push({ query: "delete from pos_banci_order where banciNo='" + delBancihao[b].banCiNo + "'" });
                }

                for(var b in delBancihao){
                    queries.push({ query: "delete from pos_banci where banCiNo='" + delBancihao[b].banCiNo + "'" });
                }
            }

            queries.push({query: "DELETE FROM sys_log WHERE guid NOT IN (SELECT guid FROM sys_log WHERE syn = '1' order BY operatonDateTime DESC LIMIT 200) AND syn = '1'"});

            queries.push({query: "DELETE FROM pos_ajaxlog WHERE guid NOT IN (SELECT guid FROM pos_ajaxlog  order BY createTime DESC LIMIT 500)"});

            //执行删除
            dao.queryTransaction(queries).then(function (resuult) {
                console.info("delete success");
            }, function (err) {
                console.error(err);
            });
        }, function (err) {
            console.error(err);
        });
    }
	
	return DataCleanerService;
}]);