app.factory("EntityNameMapService", ["$q", "database", function ($q, database) {
    var EntityNameMapService = {};

    var entityNameMapDao = new DatabaseFuncDelegate($q, database, "pos_entitynamemap");

    //datas为EntityNameMap数组对象
    EntityNameMapService.save = function(datas, callback) {
        var newEntityGuids = [];
        var sqls = [];
        if(datas && datas.length > 0) {
            var createTime = Utils.now();
            //先从pos_redisKeyStorage表中查出不存在的redisId记录
            var queries = [];
            for(index in datas) {
                var redisId = datas[index].redisId;
                var sql = {
                    query: "insert or ignore into pos_redisKeyStorage values (?,?)",
                    params: [redisId, createTime]
                }
                queries.push(sql);
            }
            //向pos_redisKeyStorage插入或忽略记录
            var newDatas = [];
            if(queries.length > 0)
                entityNameMapDao.queryTransaction(queries).then(function(res){
                    if(res && res.rowsAffected && res.rowsAffected.length > 0) {
                        for(var i= 0; i < res.rowsAffected.length; i++) {
                            var result = res.rowsAffected[i];
                            if(result > 0) {
                                newDatas.push(datas[i]);
                            }
                        }
                    }
                    for(var index in newDatas) {
                        newEntityGuids.push("'" + datas[index].entityGuid + "'");
                        var entityType = newDatas[index].entityType;
                        var entityGuid = newDatas[index].entityGuid;
                        var redisId = newDatas[index].redisId;
                        var sql = "update " + entityNameMapDao.getTableName() + " set status=3 where status=1 ";
                        if(entityType == "PosChainMDCaipuInfo") {
                            sql = sql + " and entityType='PosChainMDCaipuInfo' ";
                        }else {
                            sql = sql + " and entityGuid='" + entityGuid + "'";
                        }
                        sql = sql + " and redisId='" + redisId + "'";
                        sqls.push({
                            query:sql,
                            params:[]
                        })
                        var sql1 = "insert into " + entityNameMapDao.getTableName() + " (guid, entityGuid, entityName, entityType, sendTime, status, redisIdSet, redisId, createTime) values (?,?,?,?,?,?,?,?,?)";
                        sqls.push({
                            query:sql1,
                            params:[
                                Utils.guid(), newDatas[index].entityGuid, newDatas[index].entityName,newDatas[index].entityType, newDatas[index].sendTime, 1, newDatas[index].redisIdSet, newDatas[index].redisId, createTime ]
                        })
                    }
                    if(sqls.length > 0)
                        entityNameMapDao.queryTransaction(sqls).then(function(res){
                            console.info(res);
                        });
                })
        }else {
            return callback(null);
        }

    }

    //获取尚未更新资料
    EntityNameMapService.getNew = function(callback) {
        EntityNameMapService.all(1, callback);
    }

    //获取历史资料
    EntityNameMapService.getOld = function(callback) {
        EntityNameMapService.all(2, callback);
    }


    //获取所有消息(所有未更新+100条菜谱历史+100条非菜谱历史)
    EntityNameMapService.all = function(status, cb) {
        /*var sql = "select * from " + entityNameMapDao.getTableName();
         if(status && (status == 1 || status == 2)) {
         sql = sql + " where status = " + status;
         }
         sql = sql + " ORDER BY sendTime DESC ";*/
        var sql1 = "(select * from pos_entitynamemap where status=1 order by sendTime DESC)";
        var sql2 = "(select * from pos_entitynamemap where status=2 and entityType = 'PosChainMDCaipuInfo' order by sendTime DESC limit 100)";
        var sql3 = "(select * from pos_entitynamemap where status=2 and entityType <> 'PosChainMDCaipuInfo' order by sendTime DESC limit 100)";
        var sql = "select * from " + sql1 + " union select * from " + sql2 + " union select * from " + sql3 + " order by sendTime DESC";
        // console.log("EntityNameMapService.all.sql : " + sql);
        entityNameMapDao.query(sql)
            .then(function (result) {
                var entities = [];
                if(result && result.detail && result.detail.length > 0) {
                    for(var i in result.detail) {
                        var row = result.detail[i];
                        var entityNameMap = new EntityNameMap();
                        entityNameMap.guid = row.guid;
                        entityNameMap.entityGuid = row.entityGuid;
                        entityNameMap.entityName = row.entityName;
                        entityNameMap.entityType = row.entityType;
                        entityNameMap.sendTime = row.sendTime;
                        entityNameMap.status = row.status;
                        entityNameMap.redisIdSet = row.redisIdSet;
                        entityNameMap.redisId = row.redisId;
                        entityNameMap.setChainTypeName();
                        entities.push(entityNameMap);
                    }
                }
                if(cb)
                    return cb(entities); //返回对象数组
            }, function (err) {
                if(cb)
                    return cb(err);
            })
    }

    //获取消息个数
    EntityNameMapService.count = function(cb) {
        var sql = "select count(guid) count from " + entityNameMapDao.getTableName() + " where status = 1";
        entityNameMapDao.query(sql)
            .then(function (result) {
                if(result && result.detail && result.detail.length > 0) {
                    var count = result.detail[0].count;
                    if(cb)
                        return cb(null, count);
                }
            }, function (err) {
                if(cb)
                    return cb(err, 0);
            })
    }

    //获取非菜谱消息个数
    EntityNameMapService.notCaiPuCount = function(cb) {
        var sql = "select count(guid) count from " + entityNameMapDao.getTableName() + " where status = 1 and entityType<>'PosChainMDCaipuInfo'";
        entityNameMapDao.query(sql)
            .then(function (result) {
                if(result && result.detail && result.detail.length > 0) {
                    var count = result.detail[0].count;
                    if(cb)
                        return cb(null, count);
                }
            }, function (err) {
                if(cb)
                    return cb(err, null);
            })
    }

    entityUpdateCount = 20;
    //手动更新资料信息
    EntityNameMapService.updateInfoManually = function(entityGuid, callback, startIndex) {
        var sql = "SELECT group_concat(entityGuid) entityGuids, entityType, redisIdSet, group_concat(redisId) AS redisIds FROM ";
        var innerSql = "SELECT entityGuid, entityType, redisIdSet, redisId FROM pos_entitynamemap WHERE status = 1 ";
        if(entityGuid && entityGuid.length > 0) {
            innerSql = innerSql + " and entityGuid='" + entityGuid + "' ";
        }else {
            innerSql = innerSql + " and entityType<>'PosChainMDCaipuInfo' limit " + startIndex + ", 10";
        }
        sql = sql + " (" + innerSql + ") GROUP BY entityType";

        console.log("EntityNameMapService.updateInfoManually.sql : " + sql);
        entityNameMapDao.query(sql).then(function(ret){
            if(ret && ret.detail.length > 0) {
                if(callback)
                    return callback(ret);
            }else {
                if(callback)
                    return callback(null);
            }
        },function(err){
            if(callback)
                return callback(null);
        })
    }




    EntityNameMapService.updateOk = function(guids, callback) {
        if(guids && guids.length > 0) {
            var sql = "update pos_entitynamemap set status=2 where entityGuid in (" + guids.join(",") + ")";
            entityNameMapDao.query(sql).then(function(ret){
                if(ret.result == 200) {
                    var rowsAffected = ret.rowsAffected[0];
                    return callback(null, rowsAffected);
                }
            },function(err){
                return callback(err, null);
            })
        }

    }

    //菜品相关的未更新资料信息
    EntityNameMapService.newCaipinCount = function(cb) {
        var sql = "select count(guid) count from pos_entitynamemap where status=1 and entityType<>'PosPrintInfo'";
        entityNameMapDao.query(sql)
            .then(function (result) {
                if(result && result.detail && result.detail.length > 0) {
                    var count = result.detail[0].count;
                    if(cb)
                        return cb(null, count);
                }
            }, function (err) {
                if(cb)
                    return cb(err, 0);
            })
    }



    return EntityNameMapService;
}])