﻿app.factory("GuqingService", ["$q", "$rootScope", "database", 'AjaxLogger', function ($q, $rootScope, database, AjaxLogger) {
    var GuqingService = {};

    var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');
    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');
    var dishGuqingDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_guqing');


    var serverHost = SERVER_HOST.BASE_HOST;

    var curUser = $rootScope.curUser;

    if (serverHost.toLowerCase().indexOf("http://") == -1) {
        serverHost = "http://" + serverHost;
    }
    var posURL = serverHost + API_CONTEXT.POS;



    /* 获取当前时间的 菜品估清信息  */
    GuqingService.getGuQingCaipins = function (cb) {
        var curTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");
        dishGuqingDao.all(" datetime(startTime) <= datetime(?) and endTime >= ? order by modTime desc", [curTime, curTime])
            .then(function (result) {
                return cb(null, result);
            }, function (err) {
                return cb(err);
            })
    };

    /* 获取当前时间的 菜品估清信息  */
    GuqingService.getGuQingCaipinsForWX = function (cb) {
        var curTime = Utils.formatDate(new Date(), "yyyy-MM-dd hh:mm:ss");
        var sql = "select a.*,b.unitName,b.code code from pos_caipin_guqing a left join pos_caipin b on a.caipinGuid=b.guid where datetime(a.startTime) <= datetime(?) and a.endTime >= ?";

        dishGuqingDao.query(sql, [curTime, curTime])
        .then(function (result) {
            return cb(null, result);
        }, function (err) {
            cb(err);
        });

        //dishGuqingDao.all(" datetime(startTime) <= datetime(?) and endTime >= ? ", [curTime, curTime])
        //    .then(function (result) {
        //        return cb(null, result);
        //    }, function (err) {
        //        return cb(err);
        //    })
    };

    /* 新增或修改 估清菜品 */
    GuqingService.addOrModGQCaipin = function (gqCaipin,operate, cb) {

        dishGuqingDao.query("SELECT * FROM pos_caipin_guqing where caipinGuid=?", [gqCaipin.caipinGuid])
            .then(function (result) {
                if (result.detail.length > 0) {
                    /*   更新菜品估清数量*/
                    dishGuqingDao.query("UPDATE pos_caipin_guqing SET caipinNum=?,startTime=?,endTime=?,operatorId=?,operatorCode=?,operatorName=?,modTime=? WHERE  guid =?", [gqCaipin.caipinNum, gqCaipin.startTime, gqCaipin.endTime,
                     gqCaipin.operatorId, gqCaipin.operatorCode, gqCaipin.operatorName, gqCaipin.operatorTime, result.detail[0].guid])
                        .then(function (result) {

                            GuqingService.postRemoteGuqingCaipin(gqCaipin.caipinGuid, gqCaipin.caipinName, gqCaipin.caipinNum, gqCaipin.startTime, gqCaipin.endTime, operate);
                            /* 获取更新后的菜品估清数量 */
                            dishGuqingDao.query("SELECT * FROM pos_caipin_guqing where caipinGuid=?", [gqCaipin.caipinGuid])
                            .then(function (result) {
                                result.affectedItem = result.detail[0];
                                cb(null, result);
                            }, function (err) {
                                console.log(err);
                                cb({ message: "获取更新后的菜品数据失败！" });
                            })
                        }, function (err) {
                            console.log(err);
                            cb({ message: "修改失败." });
                        });
                } else {
                    dishGuqingDao.insert(
                       {
                           guid: dishGuqingDao.guid(), caipinGuid: gqCaipin.caipinGuid,
                           caipinName: gqCaipin.caipinName, caipinNum: gqCaipin.caipinNum,
                           startTime: gqCaipin.startTime, endTime: gqCaipin.endTime,
                           operatorId: gqCaipin.operatorId, operatorCode: gqCaipin.operatorCode,
                           operatorName: gqCaipin.operatorName, modTime: gqCaipin.operatorTime
                       }
                       )
                .then(function (result) {
                    GuqingService.postRemoteGuqingCaipin(gqCaipin.caipinGuid, gqCaipin.caipinName, gqCaipin.caipinNum, gqCaipin.startTime, gqCaipin.endTime, operate);

                    cb(null, result);
                }, function (err) {
                    console.log(err);
                    cb({ message: "新增失败." });
                });
                }
            }, function (err) {
                console.log(err);
                cb({ message: "修改失败." });
            });
    };

    /*  根据菜品GUID获取菜品估清信息 */
    GuqingService.getGQCaipinByCaipinGuid = function (caipinGuids, cb) {
        var param = "";
        for (var i = 0; i < caipinGuids.length; i++) {
            param = param + ",'" + caipinGuids[i] + "'";
        }
        param = param.substr(1);
        dishGuqingDao.query("SELECT * FROM pos_caipin_guqing where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid in (" + param + ")").then(function (result) {
            return cb(null, result.detail);
        }, function (err) {
            return cb(err);
        });
    };

    GuqingService.getGQCaipinByCaipinId = function (caipinId, cb) {
        dishGuqingDao.query("SELECT * FROM pos_caipin_guqing where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + caipinId + "'").then(function (result) {
            return cb(null, result.detail);
        }, function (err) {
            return cb(err);
        });
    };


    /* 2016-05-25   JP
     * update caipin guqing
     * Caipins[0]
     *{"guid":"1d824419d693a8addaaa8ee5c3a297f2","orderId":"f2ddd3d2b30c716e0286d8c91d0fd216","caipinId":"12a105c6-1e02-4c1e-beac-0e9f53a747cc","orderCaipinType":1,"name":"酱油汤","price":0.01,"hyPrice":null,"num":1,"tuiNum":0,"zengNum":0,"unitName":"份","printId":null,"printName":null,"chupin":"即","luodan":0,"operator":"326726b5-4e9f-4241-869c-31e8d9eb0857","modTime":"2016-05-27 15:47:59","dianCaiYuan":"326726b5-4e9f-4241-869c-31e8d9eb0857","dianCaiYuanName":"sys","dianCaiTime":"2016-05-27 15:47:59","luoDanTime":null,"chuPinTime":null,"parentId":null,"tuicaiReasonId":null,"tuicaiReasonName":null,"kouweis":[],"zuofas":[],"customize":null,"needweigh":0,"isScomb":"false","caipinTypeId":"6ea0fe85-a7ab-4446-8bae-6b01e8d743d7","caipinTypeCode":"02","caipinTypeName":"热菜","scombCaipins":[],"scombMainCaipinId":null,"orderCaipinId":null,"maxWeightInCurrentOrder":false,"parentOrder":null,"minAgio":0,"danPinBiLiZheKou":0,"danPinJineZheKou":0,"danPinZheKou":0,"costprice":null,"$$hashKey":"object:231"}
    */
    GuqingService.LuodanCaipinToGuqing = function (Caipins, operate, cb) {
        var tempCaipins = Utils.clone(Caipins);

        var _Caipins = [];
        for (var idx in tempCaipins) {
            var _caipin = Utils.arrayFind(_Caipins, tempCaipins[idx].caipinId, "caipinId");
            if (_caipin == null) {
                _Caipins.push(tempCaipins[idx]);
            } else {
                _caipin.num += tempCaipins[idx].num;
            }
        }



        var gqResult = [];
        var needGuqingCaipin = [];
        var msg = "";
        var MAX_REPEAT_GQ_COUNT = 3;
        function queryResult() {
            if (gqResult.length != _Caipins.length) {
                setTimeout(queryResult, 100);
                return;
            }
            var successCount = 0;
            for (var idx in gqResult) {
                var _item = gqResult[idx];
                if (_item.over == 1) {
                    successCount += 1;
                    if (_item.msg != null)
                        msg = msg + _item.msg;
                }
            }

            if (gqResult.length != successCount) {
                setTimeout(queryResult, 100);
                return;
            }

            if (Utils.isEmpty(msg)) {
                //todo remote
                GuqingService.LuodanCaipinToRemote(needGuqingCaipin, operate, function (err, result) {
                    //log                            
                });
                return cb(null, Caipins);
            } else {
                //todo rollback guqing
                for (var i in needGuqingCaipin) {
                    GuqingService.TuicaiCaipinToGuqing(needGuqingCaipin[i], operate, false, function (err, result) {
                        //log
                    });
                }
                return cb({ "message": msg });
            }


        }
        function executeGQ(Caipins, caipinIds, repeatCount) {
            handlerCaipinQuqing(Caipins, caipinIds, function (err, result) {

                var rst = Utils.arrayFind(gqResult, result.guid, "guid");
                if (rst == null) {
                    rst = { "guid": result.guid, "over": 1, msg: null };
                    gqResult.push(rst);
                }
                if (err) {
                    rst.over = 1;
                    rst.msg = err.msg;
                    return;
                }

                if (result.rowsAffected == 0) {
                    if (repeatCount <= MAX_REPEAT_GQ_COUNT) {
                        executeGQ(Caipins, caipinIds, repeatCount + 1);
                    }
                    else {
                        rst.over = 1;
                    }
                    return;
                } else {
                    rst.over = 1;
                    return;
                }
            });
        }
        for (var i = 0; i < _Caipins.length; i++) {
            gqResult.push({ "guid": _Caipins[i].caipinId, "over": 0, msg: null });
            executeGQ([_Caipins[i]], [_Caipins[i].caipinId], 1);
        }

        function handlerCaipinQuqing(Caipins, caipinIds, cb) {
            GuqingService.getGQCaipinByCaipinGuid(caipinIds, function (err, result) {
                var sqls = [];
                var now = new Date().format("yyyy-MM-dd hh:mm:ss");
                if (result.length > 0) {
                    var msg = "";
                    for (var i = 0; i < result.length; i++) {
                        var orderCaipin = Utils.arrayFind(Caipins, result[i].caipinGuid, "caipinId");
                        if (orderCaipin != null) {
                            if (result[i].caipinNum == 0) {
                                msg = msg + "【" + orderCaipin.name + "】已估清";
                            }
                            else if (!Utils.isEmpty(orderCaipin) && orderCaipin.num > result[i].caipinNum) {
                                msg = msg + "【" + orderCaipin.name + "】数量不足，当前估清数为【" + result[i].caipinNum + "】\r\n";
                            }
                            //save guqing info
                            orderCaipin.caipinGqNum = result[i].caipinNum;
                            orderCaipin.gqStartTime = result[i].startTime;
                            orderCaipin.gqEndTime = result[i].endTime;

                            var gq = buildCaipinGuqingSql(orderCaipin, now);

                            if (Utils.isEmpty(msg)) {
                                var _orderCaipin = Utils.arrayFind(needGuqingCaipin, orderCaipin.caipinId, "caipinId");
                                if (_orderCaipin == null)
                                    needGuqingCaipin.push(orderCaipin);

                            } else {
                                Utils.removeFromArray(needGuqingCaipin, orderCaipin.caipinId, "caipinId")
                            }
                            sqls.push(gq);
                        }
                    }
                    if (!Utils.isEmpty(msg)) {
                        return cb({ "msg": msg }, { "guid": caipinIds[0] });
                    }
                }
                if (sqls.length > 0) {
                    dishGuqingDao.queryTransaction(sqls).then(function (resultList) {
                        return cb(null, { "guid": caipinIds[0], "rowsAffected": resultList.rowsAffected[0], "caipin": Caipins[0] });
                    }, function (err) {
                        return cb(err, { "guid": caipinIds[0] });
                    });
                } else {
                    return cb(null, { "guid": caipinIds[0], "rowsAffected": 1, "caipin": Caipins[0] });
                }
            });
        }

        function buildCaipinGuqingSql(caipin, now) {
            if (caipin.caipinGqNum > 0) {
                return {
                    query: "UPDATE pos_caipin_guqing SET caipinNum=?,operatorId=?,operatorCode=?,operatorName=?,modTime=? WHERE  caipinGuid =? and caipinNum=?",
                    params: [caipin.caipinGqNum - caipin.num, operate.id, operate.code, operate.name, now, caipin.caipinId, caipin.caipinGqNum]
                };
            }
            return null;
        }

        queryResult();
    }

    /*  2015-05-25   JP
    *   tuicai to guqing
    */
    GuqingService.TuicaiCaipinToGuqing = function (caipin, operate, isRemote, cb) {
        var caipinIds = [];
        caipinIds.push(caipin.caipinId);

        GuqingService.getGQCaipinByCaipinGuid(caipinIds, function (err, result) {
            var sqls = [];
            var now = new Date().format("yyyy-MM-dd hh:mm:ss");
            if (result.length > 0) {

                sqls.push({
                    query: "update pos_caipin_guqing set caipinNum=caipinNum+?,operatorId=?,operatorCode=?,operatorName=?,modTime=? where caipinGuid=?",
                    params: [caipin.num, operate.id, operate.code, operate.name, now, caipin.caipinId]
                });

                if (isRemote) {
                    var _item = result[0];
                    //result[i]  
                    //{"guid":"97345e9b32339df1d15d8f698eb78416","caipinGuid":"12a105c6-1e02-4c1e-beac-0e9f53a747cc","caipinName":"酱油汤","caipinNum":16,"startTime":"2016-05-27 09:00:00","endTime":"2016-05-27 16:00:00","operatorId":"326726b5-4e9f-4241-869c-31e8d9eb0857","operatorCode":"1001","operatorName":"sys","modTime":"2016-05-27 14:28:14"}

                    //todo remote
                    GuqingService.postRemoteGuqingCaipin(_item.caipinGuid, _item.caipinName, _item.caipinNum, _item.startTime, _item.endTime, operate);

                }

                dishGuqingDao.queryTransaction(sqls).then(function (resultList) {
                    return cb(null, caipin);
                }, function (err) {
                    return cb(err, caipin);
                });
            } else {
                return cb(null, caipin);
            }
        });
    }

    GuqingService.LuodanCaipinToRemote = function (Caipins, operate, cb) {
        if (Caipins.length > 0) {
            var caipinIds = [];
            for (var idx in Caipins) {
                caipinIds.push(Caipins[idx].caipinId);
            }

            GuqingService.getGQCaipinByCaipinGuid(caipinIds, function (err, result) {
                var sqls = [];
                var now = new Date().format("yyyy-MM-dd hh:mm:ss");
                if (result.length > 0) {
                    for (var i in result) {
                        //result[i]  
                        //{"guid":"97345e9b32339df1d15d8f698eb78416","caipinGuid":"12a105c6-1e02-4c1e-beac-0e9f53a747cc","caipinName":"酱油汤","caipinNum":16,"startTime":"2016-05-27 09:00:00","endTime":"2016-05-27 16:00:00","operatorId":"326726b5-4e9f-4241-869c-31e8d9eb0857","operatorCode":"1001","operatorName":"sys","modTime":"2016-05-27 14:28:14"}
                        var _item = result[i];
                        //todo remote
                        GuqingService.postRemoteGuqingCaipin(_item.caipinGuid, _item.caipinName, _item.caipinNum, _item.startTime, _item.endTime, operate);
                    }
                }
            });
        }
    }




    GuqingService.postRemoteGuqingCaipin = function (caipinGuid, caipinName, caipinNum, startTime, endTime, operate) {
        try {
            var guqingCaipin = GuqingService.buildPostGuqingCaipin(caipinGuid, caipinName, caipinNum, startTime, endTime, operate.id, operate.code, operate.name, operate.groupCode, operate.groupId, operate.mdId);

            var url = posURL + POS_API_URL.CAIPIN_GUQING_URL;
            callAjax(url, function (err, result) {
                AjaxLogger.log(operate, "上传估清", "", JSON.stringify(result), this.url);
            }, JSON.stringify(guqingCaipin));
        } catch (e) {
            AjaxLogger.log(operate, "上传估清异常", "", JSON.stringify(e), "");
        }

    }

    GuqingService.buildPostGuqingCaipin = function (caipinGuid, caipinName, caipinNum, startTime, endTime, operatorId, operatorCode, operatorName, groupCode, groupId, orgid) {
        var postRemoteGQCaipin = new PostRemoteGQCaipin();

        postRemoteGQCaipin.caipinGuid = caipinGuid;
        postRemoteGQCaipin.caipinName = caipinName;
        postRemoteGQCaipin.caipinNum = caipinNum;
        postRemoteGQCaipin.startTime = startTime;
        postRemoteGQCaipin.endTime = endTime;
        postRemoteGQCaipin.operatorId = operatorId;
        postRemoteGQCaipin.operatorCode = operatorCode;
        postRemoteGQCaipin.operatorName = operatorName;
        postRemoteGQCaipin.groupCode = groupCode;
        postRemoteGQCaipin.groupId = groupId;
        postRemoteGQCaipin.orgid = orgid;

        return postRemoteGQCaipin;
    }


    /*组装判断用的菜品    开始   */
    GuqingService.buildOrderCaipins = function (OrderCaipins) {
        var re = [];

        for (var i in OrderCaipins) {
            var _orderCaipin = Utils.arrayFind(re, OrderCaipins[i].caipinId, "caipinId");

            GuqingService.handleOrderCaipins(_orderCaipin, re, OrderCaipins[i]);

            if (OrderCaipins[i].scombCaipins.length > 0) {
                orderCaipin = Utils.arrayFind(re, OrderCaipins[i].scombCaipins, "caipinId");

                for (var k in OrderCaipins[i].scombCaipins) {
                    var _orderScombCaipin = Utils.arrayFind(re, OrderCaipins[i].scombCaipins[k].caipinId, "caipinId");

                    GuqingService.handleOrderCaipins(_orderScombCaipin, re, OrderCaipins[i].scombCaipins[k]);
                }
            }
        }
        return re;
    }
    GuqingService.handleOrderCaipins = function (_orderCaipin, re, caipin) {
        if (_orderCaipin == null) {
            re.push({ "caipinId": caipin.caipinId, "num": caipin.num, "name": caipin.name })
        } else {
            _orderCaipin.num = parseFloat(_orderCaipin.num) + parseFloat(caipin.num);
        }
    }
    /*组装判断估清用的菜品    结束 */

    return GuqingService;
}])