app.factory('HandlerNetworkOrder', ['$q', 'database', 'CanbieService', 'SystemConfigService', 'GuqingService', 'CanbieService', 'ZhuotaiService', 'GuqingService', 'PrintService', 'UniqueIDService', 'JieSuanService',
    function ($q, database, CanbieService, SystemConfigService, GuqingService, CanbieService, ZhuotaiService, GuqingService, PrintService, UniqueIDService, JieSuanService) {
        var HandlerNetworkOrder = {};

        var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');
        var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');
        var billingDao = new DatabaseFuncDelegate($q, database, 'pos_billing');
        var billingDetailDao = new DatabaseFuncDelegate($q, database, 'pos_billing_detail');


        var operate = NetworkOrderOperate;
        if (!BIZCONSTANT.POSUSER)
        {
            BIZCONSTANT.POSUSER = new PosUser();
            BIZCONSTANT.POSUSER.name = operate.name;
        }
        

        //var canbie = null;
        //var zhuotai = null;
        //var printZhuotai = new Zhuotai();
        //var printOrderCaipins = [];
        //var zhangDanNo = null;
        //var sqls = [];

        HandlerNetworkOrder.update = function (dataList) {
            var canbie = null;
            var zhuotai = null;
            var printZhuotai = new Zhuotai();
            var printOrderCaipins = [];
            var zhangDanNo = null;
            var sqls = [];


            try {
                for (var idx in dataList) {
                    console.log(dataList[idx]);
                    var _item = null;
                    //if (__CONFIG_SLICE__ == "staging")
                    //    _item = JSON.parse(networkorder);// test
                    //else
                    _item = JSON.parse(dataList[idx].data);

                    operate.groupId = dataList[idx].groupId;
                    operate.groupCode = dataList[idx].groupCode;
                    operate.mdId = dataList[idx].orgid;

                    handlerNetworkOrder(_item, function (err, result) {
                        debugger;
                        //TODO WeixinApi
                        var reqData = {
                            orderNo: _item.orderNo,tradeNo:_item.tradeNo, status: (err == null ? "success" : "failure"),
                            msg: (err == null ? null : err.message), groupId: dataList[idx].groupId,
                            groupCode: dataList[idx].groupCode, orgId: dataList[idx].orgid
                        };
                        dotoWeixinApi(reqData);
                    })
                }
            } catch (err) {

            }

            function dotoWeixinApi(data) {
                var url = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.API_PATH;

                callAjax(url, function (result) {

                }, JSON.stringify(data), "POST", function (err, data) {

                })
            }


            function handlerNetworkOrder(_item, cb) {

                CanbieService.getCurrentCanBie(function (err, result) {
                    if (err || Utils.isEmpty(result)) {
                        if (Utils.isEmpty(result))
                            return cb({ "message": "当前时间无法匹配到餐别信息" });
                        return cb(err);
                    }
                    canbie = result;
                    //TODO query zhuotai
                    ZhuotaiService.getZhuotaiByCode(_item.ZTCode, function (err, result) {
                        if (err) {
                            return cb(err);
                        }
                        zhuotai = result[0];

                        buildPrintZhuotai();
                        var _orderCaipins = buildNetworkOrderCaipins(_item.orderDishs);
                        //TODO validate dish guqing
                        var count = 1;

                        executeXiadan(_item, _orderCaipins, function (err, result) {
                            if (err) {
                                return cb(err);
                            }
                            return cb(null, result);
                        })
                    })
                });
            }


            function executeXiadan(_item, orderCaipins, cb) {
                var _guqingCaipins = [];

                for (var idx in orderCaipins) {
                    _guqingCaipins.push(buildGuqingCaipin(orderCaipins[idx]));
                }

                GuqingService.LuodanCaipinToGuqing(_guqingCaipins, operate, function (err, result) {
                    if (err) {
                        return cb(err);
                    }
                    var caipins = result;

                    InsertData(_item, orderCaipins, function (err, result) {
                        if (err) {
                            return cb(err);
                        }

                        printhelp.printzhizuodan(printZhuotai, printOrderCaipins, PrintService);
                        printhelp.printhuadan(printZhuotai, printOrderCaipins, PrintService);

                        return cb(null, result);
                    })
                })
            }

            /*
            * execute insert data
            */
            function InsertData(order, caipins, cb) {
                var orderId = null;

                var now = new Date().format("yyyy-MM-dd hh:mm:ss");
                if (zhuotai.orderId == null) {
                    GetNewOrderCode(function (err) {
                        if (err)
                            return cb(err);

                        orderId = orderDao.guid();
                        var jiesuanId = Utils.guid();
                        buildPrintZhuotaiOrder(orderId, order, now);

                        sqls.push(buildZhuotaiSql(orderId));
                        sqls.push(buildOrderSql(jiesuanId, orderId, order, now));
                        sqls.push(buildEmptyBilling(jiesuanId, orderId));
                        debugger;
                        for (var idx in caipins) {
                            var orderCaipin = createNetworkOrderCaipin(orderId, caipins[idx], now);
                            printOrderCaipins.push(orderCaipin);
                            sqls.push(buildOrderCaipinSql(orderId, orderCaipin));
                        }

                        executeSql(sqls, function (err, result) {
                            if (err)
                                return cb(err);
                            debugger;
                            return HandlerNetworkOrder.calAndSave4WeiXin(orderId,order.totalPrice,true, cb);
                        });
                    })
                } else {
                    orderId = zhuotai.orderId;
                    buildPrintZhuotaiOrder(orderId, order, now);

                    for (var idx in caipins) {
                        var orderCaipin = createNetworkOrderCaipin(orderId, caipins[idx], now);
                        printOrderCaipins.push(orderCaipin);
                        sqls.push(buildOrderCaipinSql(orderId, orderCaipin));
                    }

                    executeSql(sqls, function (err, result) {
                        if (err)
                            return cb(err);
                        debugger;
                        return HandlerNetworkOrder.calAndSave4WeiXin(orderId, order.totalPrice, false, cb);
                    });
                }
            }


            /* build dish info    start   */
            function buildNetworkOrderCaipins(Caipins) {
                var re = [];
                for (var i in Caipins) {
                    var _orderCaipin = Utils.arrayFind(re, Caipins[i].dishId, "guid");
                    handleOrderCaipins(_orderCaipin, re, Caipins[i]);
                }
                return re;
            }
            function handleOrderCaipins(_orderCaipin, re, caipin) {
                if (_orderCaipin == null) {
                    re.push(createNetworkCaipin(caipin))
                }
            }

            function createNetworkCaipin(caipin) {
                var _caipin = new WXOrderCaipin();
                _caipin.guid = caipin.dishId;
                _caipin.code = caipin.dishCode;
                _caipin.name = caipin.dishName;
                _caipin.caipinNum = caipin.dishCount;
                _caipin.caipinGqNum = null;//菜品的估清数量

                _caipin.salePrice = caipin.unitPrice;
                _caipin.hyPrice = caipin.hyPrice;
                _caipin.unitId = caipin.unitId;
                _caipin.unitName = caipin.unitName;
                _caipin.isScomb = null;

                _caipin.typeId = caipin.dishTypeId;
                _caipin.typeCode = caipin.dishTypeCode;
                _caipin.typeName = caipin.dishTypeName;

                return _caipin;
            }


            function buildGuqingCaipin(caipin) {
                var orderCaipin = new OrderCaipin();

                orderCaipin.caipinId = caipin.guid;
                orderCaipin.name = caipin.name;
                orderCaipin.num = caipin.caipinNum;

                return orderCaipin;
            }

            /*build dish info    end*/





            function executeSql(sqls, cb) {
                orderDao.queryTransaction(sqls).then(function (resultList) {
                    return cb(null, resultList);
                }, function (err) {
                    return cb(err);
                });
            }

            function GetNewOrderCode(cb) {
                var now = new Date();
                UniqueIDService.nextSeq(now, 'order', function (err, seq,nowdate) {
                    if (err) {
                        return cb(err)
                    }
                    var seqNo = nowdate + Utils.formatSeqNo(seq);
                    zhangDanNo = "ZD" + seqNo;

                    return cb(null);
                });
            }


            function buildZhuotaiSql(orderId) {
                return {
                    query: "update pos_zhuotai set orderId=? where guid=? and orderId is null",
                    params: [orderId, zhuotai.guid]
                };
            }

            /**
             * 建立空账单
             */
            function buildEmptyBilling(jiesuanId, orderId) {
                return {
                    query: "insert into pos_billing ( " +
                    "guid, orderId) " +
                    "values (?, ?)",
                    params: [jiesuanId, orderId]
                }
            }

            // build order sql
            function buildOrderSql(jiesuanId, orderId, order, curTime) {
                return {
                    query: "insert into pos_order ( " +
                        "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status,serverId, serverName, operator, operatorName,operatorCode, mdId," +
                        " kaiTaiTime, modTime, isDeleted,fanJieSuanNum,canBieCode,canBieName,canBieId,areaGuid,areaCode,areaName,zhuotaiCode,code,luoDanTime,ordersource,jieSuanId) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?, ?,?, ?,?,?,?,?,?,?,?,?,?)",
                    params: [orderId, zhuotai.guid, zhuotai.name, 1, "", order.totalPrice, 1, operate.id, operate.name,
                        operate.id, operate.name, operate.code, order.storeId,
                        curTime, curTime, false, 0, canbie.code, canbie.name,
                    canbie.guid, zhuotai.areaId, zhuotai.areaCode, zhuotai.areaName, zhuotai.code, zhangDanNo, curTime, ORDERSOURCE.WEIXIN, jiesuanId]
                };
            }
            // build order dish sql  start
            function buildOrderCaipinSql(orderId, orderCaipin) {
                return {
                    query: "insert into pos_order_caipin ( " +
                    "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                    "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName,luoDanTime) " +
                    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?)",
                    params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                        orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                        orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                        BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime,
                        orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                        orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.modTime]
                };
            }
            function createNetworkOrderCaipin(orderId, caipin, now) {
                var num = 1;
                if (caipin.caipinNum > 1)
                    num = caipin.caipinNum;
                var orderCaipin = new OrderCaipin();
                orderCaipin.guid = orderCaipinDao.guid();
                orderCaipin.orderId = orderId;
                orderCaipin.caipinId = caipin.guid;
                orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
                orderCaipin.name = caipin.name;
                orderCaipin.price = caipin.salePrice;
                orderCaipin.costprice = caipin.costprice == null ? 0 : caipin.costprice;
                orderCaipin.num = num;
                orderCaipin.tuiNum = 0;
                orderCaipin.zengNum = 0;
                orderCaipin.unitName = caipin.unitName;
                orderCaipin.printId = caipin.printId;
                orderCaipin.printName = caipin.printName;
                orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
                orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
                orderCaipin.minAgio = caipin.minAgio;
                orderCaipin.danPinBiLiZheKou = 0;
                orderCaipin.danPinJineZheKou = 0;
                orderCaipin.danPinZheKou = 0;
                orderCaipin.operator = operate.id;
                orderCaipin.dianCaiYuan = operate.id;
                orderCaipin.dianCaiYuanName = operate.name;
                orderCaipin.dianCaiTime = now;
                orderCaipin.modTime = now;
                orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
                orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;

                orderCaipin.hyPrice = caipin.hyPrice;
                orderCaipin.caipinTypeId = caipin.typeId;
                orderCaipin.caipinTypeCode = caipin.typeCode;
                orderCaipin.caipinTypeName = caipin.typeName;

                return orderCaipin;
            }
            //build order dish sql  end

            // build guqing sql
            function buildCaipinGuqingSql(caipin, now) {
                if (caipin.caipinGqNum > 0) {
                    return {
                        query: "UPDATE pos_caipin_guqing SET caipinNum=caipinNum-?,operatorId=?,operatorCode=?,operatorName=?,modTime=? WHERE  caipinGuid =? and caipinNum=?",
                        params: [caipin.caipinNum, operate.id, operate.code, operate.name, now, caipin.guid, caipin.caipinGqNum]
                    };
                }
                return null;
            }


            function buildPrintZhuotai() {
                printZhuotai.guid = zhuotai.guid;
                printZhuotai.code = zhuotai.code;
                printZhuotai.name = zhuotai.name;
                printZhuotai.areaId = zhuotai.areaId;
                printZhuotai.quickCode = zhuotai.quickCode;
                printZhuotai.canweishu = zhuotai.canweishu;
                printZhuotai.orderId = null;
                printZhuotai.order = new Order();
                printZhuotai.areaCode = zhuotai.areaCode;
                printZhuotai.areaName = zhuotai.areaName;
            }

            function buildPrintZhuotaiOrder(orderId, order, kaitaiTime) {
                printZhuotai.orderId = orderId;
                printZhuotai.order = new Order();

                printZhuotai.order.guid = orderId;
                printZhuotai.order.zhuotaiId = zhuotai.guid;
                printZhuotai.order.zhuotaiName = zhuotai.name;
                printZhuotai.order.status = WEIXIN.DEFAULT_ORDER_STATUS;
                printZhuotai.order.renshu = WEIXIN.DEFAULT_ORDER_RENSHU;
                printZhuotai.order.totalPrice = order.totalPrice;
                printZhuotai.order.code = zhangDanNo == null ? zhuotai.order.code : zhangDanNo;
                printZhuotai.order.serverId = operate.id;
                printZhuotai.order.serverName = operate.name;
                printZhuotai.order.operator = operate.id;
                printZhuotai.order.comments = WEIXIN.DEFAULT_ORDER_COMMENTS;
                printZhuotai.order.kaiTaiTime = kaitaiTime;
                printZhuotai.order.luoDanTime = kaitaiTime;
                printZhuotai.order.modTime = kaitaiTime;

                printZhuotai.order.canbieId = canbie.guid;
                printZhuotai.order.canBieCode = canbie.code;
                printZhuotai.order.canbieName = canbie.name;
            }

        }


        /**
          * 1. 计算微信的账单
          * 2. 保存微信支付方式
          */
        HandlerNetworkOrder.calAndSave4WeiXin = function (orderId, totalPrice, isFisrt, cb) {
            var raw = new Order();
            raw.guid = orderId;

            var jieSuan = new JieSuan();
            var currentUser = new PosUser();
            debugger;
            if (!isFisrt)
                orderDao.query("update pos_order set totalPrice=totalPrice+" + totalPrice + " where guid='" + orderId + "'").then(function (result) {
                    var _e = result;
                }, function (err) {
                    var _e = err;
                })

            JieSuanService.loadByOrderId(raw, jieSuan, function (err, model) {
                if (err) {
                    Utils.showFailureInfo(err.message);
                    return cb(null, null);
                }
                //1. 增加微信支付方式
                var wx = PaymentMethod.WEIXIN();
                wx.addMoney(jieSuan.order.getYingShou());
                jieSuan.addPM(wx);

                //临时保存
                JieSuanService.jieSuanSnapshot(currentUser, jieSuan, function (err, model) {
                    if (err) {
                        Utils.showFailureInfo(err.message);
                        return cb(null, null);
                    }
                    cb(null, model);
                });
            });
        }

        return HandlerNetworkOrder;
    }]);