/**
 * Created by peter.shang on 2016-01-14.
 */


app.factory("JieSuanService", ['$q', 'database','UniqueIDService', 'AjaxLogger', 'UploadService', "CardService","GuqingService","DiancaiService","CanbieService",
    function($q, database, UniqueIDService,AjaxLogger,DataSyncService, CardService, GuqingService, DiancaiService, CanbieService){
    var JieSuanService = {};

    var zheKouDao =  new DatabaseFuncDelegate($q, database, 'pos_zhekou');
    var posBillingDao = new DatabaseFuncDelegate($q,database,'pos_billing');
    var orderDao = new DatabaseFuncDelegate($q,database,'pos_order');
    var zuoFaDao= new DatabaseFuncDelegate($q,database,'pos_order_caipin_zuofa');
    var cwkeDao =  new DatabaseFuncDelegate($q, database, 'pos_cai_wu_ke_mu');
    var thirdCouponDao =  new DatabaseFuncDelegate($q, database, 'pos_third_coupon');

    /**
     * 得到所有折扣
     *
     * @param cb
     */
    JieSuanService.getAllZheKou =function(cb){

        zheKouDao.all("isDeleted='false' and enabled='true' order by code asc")
            .then(function(rs){
                if(rs.length < 1){
                    return cb({message:"找不到折扣模板，请联系我司相关的工作人员"});
                }
                var ret = [];
                for(var i = 0; i < rs.length; i ++){
                    var zk = new ZheKou();
                    var r = rs[i];

                    zk.zheKouId = r.guid;
                    zk.zheKouName = r.name;
                    zk.zheKouAmount = r.discount;
                    zk.zheKouCode = r.code;
                    zk.setApplyWholeOrder(r.apply_whole_order);
                    ret.push(zk);
                }

                return cb(null, ret);
            }, function(error){
                return cb(error);
            });

    }

    /**
     * 得到所有第三方抵用券
     *
     * @param cb
     */
    JieSuanService.getAllThirdCoupon =function(cb){
        var nowTime = new Date().format("yyyy-MM-dd");
        thirdCouponDao.all(" isDeleted='false' and state='true' and ((isLimitUsing='true') or (isLimitUsing='false' and closingDate>='" + nowTime + "'))")
            .then(function(rs){
                // console.log("JieSuanService.getAllThirdCoupon.rs : " + JSON.stringify(rs))
                if(rs.length < 1){
                    return cb({message:"找不到折扣模板，请联系我司相关的工作人员"});
                }
                var ret = [];
                for(var i = 0; i < rs.length; i ++){
                    var thirdCoupon = new ThirdCoupon();
                    var r = rs[i];
                    thirdCoupon.guid = r.guid;
                    thirdCoupon.state = r.state;
                    thirdCoupon.isDiscount = r.isDiscount;
                    thirdCoupon.isLimitUsing = r.isLimitUsing;
                    thirdCoupon.thirdCouponName = r.thirdCouponName;
                    thirdCoupon.payTypeId = r.payTypeId;
                    thirdCoupon.payManey = r.payManey;
                    thirdCoupon.faceValueManey = r.faceValueManey;
                    thirdCoupon.useTimes = r.useTimes;
                    thirdCoupon.closingDate = r.closingDate;
                    thirdCoupon.isdeleted = r.isdeleted;
                    if(thirdCoupon.useTimes && thirdCoupon.useTimes > 0) {
                        thirdCoupon.des = "最多可使用" + thirdCoupon.useTimes + "张，抵用" + thirdCoupon.faceValueManey*thirdCoupon.useTimes + "元。";
                    }
                    ret.push(thirdCoupon);
                }

                return cb(null, ret);
            }, function(error){
                console.log("JieSuanService.getAllThirdCoupon.error : " + JSON.stringify(error))
                return cb(error);
            });

    }

    /**
     * 得到所有支付方式（财务科目）
     *
     * @param cb
     */
    JieSuanService.getCaiWuKeMu =function(cb){

        cwkeDao.all("isDeleted='false' and enabled='true' AND name is not null order by code asc")
            .then(function(rs){
                if(rs.length < 1){
                    return cb({message:"找不到财务科目，请联系我司相关的工作人员"});
                }
                var ret = [];
                var hasTG = false; //是否有团购
                var tgHyJf = null;
                for(var i = 0; i < rs.length; i ++){
                    var pm = new  PaymentMethod();
                    var r = rs[i];

                    pm.pmId = r.guid;
                    pm.code = r.code;
                    pm.name = r.name;
                    pm.ext1 = r.ext1;
                    pm.fklx = r.fklx;
                    pm.isDisplay = r.isDisplay;
                    pm.isDisplayCz = r.isDisplayCz;
                    //支付方式的财务属性
                    if( r.isshishou == 'false' )
                        pm.caiWuShuXing = BIZCONSTANT.CWKM_YOUMIAN;
                    else
                        pm.caiWuShuXing = BIZCONSTANT.CWKM_SHISHOU;

                    //会员积分
                    pm.isHyJf = r.isHyJf;

                    if(pm.fklx && pm.fklx == "tg") {
                        hasTG = true;
                        tgHyJf = r.isHyJf;
                    }

                    ret.push(pm);
                }

                if(hasTG == true) {
                    //加载所有团购券
                    JieSuanService.getAllThirdCoupon(function(err, result){
                        if(!err) {
                            if(result && result.length > 0) {
                                for(var j = 0; j < result.length; j++) {
                                    var pm = new PaymentMethod();
                                    var thirdCoupon = result[j];
                                    pm.pmId = thirdCoupon.guid;
                                    pm.code = thirdCoupon.guid;
                                    pm.name = thirdCoupon.thirdCouponName;
                                    pm.fklx = "thirdCoupon";
                                    pm.isDisplay = "false";
                                    pm.isshishou = "true";
                                    pm.caiWuShuXing = BIZCONSTANT.CWKM_SHISHOU;
                                    pm.isHyJf = tgHyJf;
                                    //扩展
                                    pm.thirdCouponName = thirdCoupon.thirdCouponName;
                                    pm.state = thirdCoupon.state;
                                    pm.isDiscount = thirdCoupon.isDiscount;
                                    pm.isLimitUsing = thirdCoupon.isLimitUsing;
                                    pm.payTypeId = thirdCoupon.payTypeId;
                                    pm.payManey = thirdCoupon.payManey;
                                    pm.faceValueManey = thirdCoupon.faceValueManey;
                                    pm.useTimes = thirdCoupon.useTimes;
                                    pm.closingDate = thirdCoupon.closingDate;
                                    pm.des = thirdCoupon.des;
                                    ret.push(pm);
                                }
                                return cb(null, ret);
                            }
                            return cb(null, ret);
                        }else {
                            return cb(null, ret);
                        }
                    })
                }else {
                    return cb(null, ret);
                }
            }, function(error){
                return cb(error);
            });

    }

    /**
     * 得到团购支付方式（财务科目）
     *
     * @param cb
     */
    JieSuanService.getTGCaiWuKeMu =function(cb){
        var sql = "select * from " + cwkeDao.getTableName() + " where isDeleted='false' and enabled='true' and name is not null and fklx='tg' limit 1";
        cwkeDao.query(sql).then(function(rs){
            if(rs && rs.detail.length > 0) {
                var r = rs.detail[0];
                var pm = new  PaymentMethod();
                pm.pmId = r.guid;
                pm.code = r.code;
                pm.name = r.name;
                pm.ext1 = r.ext1;
                pm.fklx = r.fklx;
                pm.isDisplay = r.isDisplay;
                //支付方式的财务属性
                if( r.isshishou == 'false' )
                    pm.caiWuShuXing = BIZCONSTANT.CWKM_YOUMIAN;
                else
                    pm.caiWuShuXing = BIZCONSTANT.CWKM_SHISHOU;

                //会员积分
                pm.isHyJf = r.isHyJf;
                return cb(null, pm);
            }else {
                return cb({message:"找不到财务科目，请联系我司相关的工作人员"});
            }
        }, function(err){
            return cb(error);
        })
    }




    //根据订单ID来加载订单
    /**
     *
     * @param rawOrder 只有基本属性的order对象。即，菜品列表等数据没有读取
     * @param doNotResetPM 不要重置支付方式，针对微信支付请求
     * @returns {JieSuan}
     */
    JieSuanService.loadByOrderId = function(rawOrder, ret, cb, doNotResetPM){
        //判断账单是否存在。
        //判断账单号是否存在，空账单禁止结算。
        //只能为未删除，未结算的账单。

        if(doNotResetPM && doNotResetPM == true) {
        }else {
            //所有支付方式金额先复位
            _.each(BIZCONSTANT.ALLPMs, function (e) {
                e.reset();
            });
        }

        var sql = "select o.guid oguid, o.code ocode,o.canBieId ocanBieId, o.canBieCode ocanBieCode, o.canBieName ocanBieName, o.thirdOrderNo thirdOrderNo, " +
            " o.luoDanTime oluoDanTime, o.cardNo omemberNo, o.renshu renshu,o.serverName serverName,o.serverId serverId," +
            " o.isFanJieSuan oisFanJieSuan, o.jieSuanId ojieSuanId, o.jieSuanNo ojieSuanNo, o.tradeNumber otradeNumber," +
            " o.tradeGuid otradeGuid, o.ordersource ordersource, o.zhuotaiId ozhuotaiId, o.zhuotaiCode ozhuotaiCode, o.zhuotaiName ozhuotaiName," +
            " o.cardNo ocardNo, o.cardMemName ocardMemName, o.comments oComments, o.huiYuanId,o.tsAndwm tsAndwm,  " +
            " b.guid cguid, b.caipinId cCaipinId, b.caipinCode cCaipinCode, b.name cname, b.price cprice, ifnull(b.tuiNum,0) ctuiNum, ifnull(b.zengNum,0) czengNum, ifnull(b.num,0) cnum,  b.minAgio cminAgio, b.zheQianMoney zheQianMoney, " +
            " b.danPinBiLiZheKou cdanPinBiLiZheKou, b.danPinJineZheKou cdanPinJineZheKou, b.danPinZheKou cdanPinZheKou, b.isScomb cisScomb, " +
            " b.hyPrice hyPrice, b.caipinTypeId caipinTypeId, b.caipinTypeCode caipinTypeCode, b.caipinTypeName caipinTypeName, b.unitId cUnitId, b.unitName cUnitName, b.zuoFaZheQianTotal cZuoFaZheQianTotal," +
            " k.name kname, k.orderCaipinId kOrderCpId, ifnull(k.price,0) kprice, k.guid kguid, k.jiajiaType kjiajiaType " +
            " from pos_order o " +
            " left join pos_order_caipin b on o.guid = b.orderId " +
            " left join pos_order_caipin_zuofa k on b.guid = k.orderCaipinId" +
            " where o.guid ='" + rawOrder.guid +"' ";
        orderDao.query(sql)
            //1. 账单和菜品
            .then(
            function(rs){
                if(rs.detail.length < 1){
                    if(cb)
                    return cb({message:"找不到订单["+ rawOrder.code+"]，请联系我司相关的工作人员"});
                }

                populate(ret, rs);

                //2. 是否是临时结算单，反计算和尚未结算的账单， 都属于临时金额算单
                console.info("before");
                console.info(ret);
                if (!ret.isTempJieSuan() && !rawOrder.waimaiOrder)
                    return cb(null,null);
                console.info("after");

                var jsId = ret.order.jieSuanId;
                var sql2 =" select A.*, " +
                    " B.cardNo, B.cardMemName,B.tradeNumber, B.tradeGuid " +
                    " from pos_billing_detail A, pos_billing B " +
                    " where A.jieSuanId = B.guid AND A.jieSuanId = ?" +
                    " order by seq ";
                console.info("jsID:" + jsId);
                posBillingDao.query(sql2, [jsId]).then(function(rs){
                    if(rs)
                    for(var i = 0; i < rs.detail.length; i ++){
                        if(rs.detail[i].type == BIZCONSTANT.TYPE_PAY) {
                            var v  = rs.detail[i];
                            var pm  = getPMByCode( BIZCONSTANT.ALLPMs, v.bizCode);
                            if(pm == null)
                                pm = PaymentMethod.getVirtualPm(v.bizCode);
                            if(pm.isPayFirst()) {
                                pm.pmId = v.bizId;
                            }

                            pm.ext1 = v.ext1;
                            pm.hykZSMoney = v.hykZSMoney;
                            if(pm.isThirdCoupon()) {
                                pm.name = v.bizDesc;
                                pm.thirdCouponNum = v.thirdCouponNum;
                            }
                            pm.addMoney(v.amount);
                            ret.addPM(pm);
                            console.info(ret.payMethodList);
                        }

                        if(rs.detail[i].type == BIZCONSTANT.TYPE_ZHEKOU) {
                            var zk  = new ZheKou();
                            zk.zheKouId = rs.detail[i].bizId;
                            zk.zheKouCode = rs.detail[i].bizCode;
                            zk.zheKouName = rs.detail[i].bizDesc;
                            zk.setZheKouAmount(rs.detail[i].bizAmount);
                            zk.setApplyWholeOrder(rs.detail[i].applyWholeOrder);
                            if(zk.isHuiYuanJia()) {
                                ret.memberProxy.fakeZheKouRule(BIZCONSTANT.HY_ZK_RULE_PRICE)
                            }else if(zk.isHuiYuanLV()){
                                ret.memberProxy.fakeZheKouRule(BIZCONSTANT.HY_ZK_RULE_LV)
                            }
                            ret.addZheKou(zk);
                        }
                    }

                    //3. 套餐
                    var scombList = [];
                    _.each( ret.order.caiPinList, function(e){
                        if(e.isScombInfo()){
                            scombList.push(e);
                        }
                    })
                    if(scombList.length > 0) {
                        //是套餐，那么获得该套餐的明细
                        JieSuanService.loadTaoCanByScombs(scombList, ret, function (res) {
                            if(!res) {
                                console.log("=================JieSuanService.loadTaoCanByScombs()=================执行完毕！");
                                //4. 计算总金额
                                return JieSuanService.calTotalMoney(ret, cb);
                            }else {
                                if(cb)
                                    return cb(res);
                            }
                        })
                    }else {
                        //4. 计算总金额
                        return JieSuanService.calTotalMoney(ret, cb);
                    }

                }, function(error){
                    if(cb)
                        return cb(error, null)
                });
            },
            function(error){
                console.log(error);
                if(cb)
                return cb({message:"失败."}, null)
            })
            //4. 计算总金额
            /*.then(function(){
                ret.gross = ret.order.getSum4LuoDan();
                ret.order.markMaxWeight();
                ret.calculator.money = ret.order.getYingShou() - ret.yiShou
                console.info('load jiesuan  success');
                if(ret.order.isFromWeiXin()){
                    return cb(null,null);
                }
                else{
                    return cb(null,null);
                }

            });*/

    }

    //计算总金额
    JieSuanService.calTotalMoney = function (ret, cb) {
        ret.gross = ret.order.getSum4LuoDan();
        ret.order.markMaxWeight();
        var tmp =  ret.order.getYingShou() - ret.yiShou;
        if(tmp < 0 )
            tmp = 0;
        ret.calculator.money = Utils.m(tmp);
        ret.weiShou = tmp;

        console.info('load jiesuan  success');
        if(ret.order.isFromWeiXin()){
            if(cb)
                return cb(null,null);
        }
        else{
            if(cb)
                return cb(null,null);
        }
    }

        /**
         * 根据账单中套餐的ID批量获得套餐的详细信息
         *
         */
    JieSuanService.loadTaoCanByScombs = function (scombs, ret, cb) {
        if(scombs && scombs.length > 0) {
            console.log("=================scombs.length================= : " + scombs.length);
            var scomb = scombs.splice(0, 1);
            JieSuanService.loadTaoCanByScomb(scomb[0], ret, function (res) {
                if(!res) {
                    if(scombs.length > 0) {
                        return JieSuanService.loadTaoCanByScombs(scombs, ret, cb);
                    }else {
                        return cb(null);
                    }
                }
                return cb(res);
            })
        }else {
            return cb(null);
        }
    }


    /**
     * 根据账单中套餐的ID来获得套餐的详细
     *
     */
    JieSuanService.loadTaoCanByScomb = function(scomb, ret, cb){
        var sql = "select " +
            " b.guid cguid, b.name cname, b.price cprice, b.tuiNum ctuiNum, b.zengNum czengNum, b.num cnum,  b.minAgio cminAgio, " +
            " b.danPinBiLiZheKou cdanPinBiLiZheKou, b.danPinJineZheKou cdanPinJineZheKou, b.danPinZheKou cdanPinZheKou, b.isScomb cisScomb, " +
            " k.name kname, k.orderCaipinId kOrderCpId, k.price kprice, k.guid kguid, k.jiajiaType kjiajiaType " +
            " from  pos_order_scomb_caipin b left join  pos_order_caipin_zuofa k on b.guid = k.orderScombCaipinId" +
            " where b.orderCaipinId ='" + scomb.guid +"' " ;
        orderDao.query(sql)
            .then(
            function(rs){
                if(rs.detail.length < 1){
                    return cb({message:"找不到套餐["+ scomb.guid+","+scomb.caipinCode+"]，请联系我司相关的工作人员"});
                }

                populateTaoCan(ret, rs,scomb);
                return cb(null);
            },
            function(error){
                console.log(error);
                return cb({message:"失败."}, null)
            })
    }

    //构建一个完整的账单中套餐的对象图
    var populateTaoCan = function(ret,rs,scomb){

        var tmpMap = {};

        var taoCanDetail = [];
        //建立order和caipin关系
        for(var i = 0; i < rs.detail.length; i ++){
            var e = rs.detail[i];
            if(e.cguid == null)
                continue;
            var cp = null;
            if(tmpMap[e.cguid] == null){
                cp = new OrderCaipin();
                cp.name = e.cname;
                cp.guid = e.cguid;
                cp.price = e.cprice;
                cp.zengNum = e.czengNum;
                cp.tuiNum = e.ctuiNum;
                cp.num = e.cnum;
                cp.danPinBiLiZheKou = e.cdanPinBiLiZheKou;
                cp.danPinJineZheKou = e.cdanPinJineZheKou;
                cp.danPinZheKou  = e.cdanPinZheKou;
                cp.minAgio = e.cminAgio;
                cp.setParentScom(scomb); //关联的套餐

                tmpMap[e.cguid] = cp;
                taoCanDetail.push(cp);
            }
            cp = tmpMap[e.cguid];

            //如果没有相关做法和当前菜品相关，则继续
            if(e.kguid == null)
                continue;
            //当前菜品有做法相关
            var ocz = new OrderCaipinZuofa();
            ocz.guid = e.kguid;
            ocz.price = e.kprice;
            ocz.name = e.kname;
            ocz.orderCaipinId = e.kOrderCpId;
            ocz.jiajiaType = e.kjiajiaType
            ocz.parentCaiPin = cp;

            cp.zuofas.push(ocz);

        }


        ret.addTaoCanDetail(taoCanDetail);
    }




    /**
     *  根据CODE找到支付方式
     * @param list
     * @param code
     * @returns {*}
     */
    var getPMByCode = function(list, code ){
        var candidate = null;
        _.each( list, function(e){
            if(e.code == code)
                candidate = e;
        });

        return candidate;
    }
    /**
     *
     * 构建一个完整的对象图
     *
     * @param ret
     * @param rs
     */
    var populate = function(ret,rs){
        var order = new Order();


        //填充ORDER信息
        var head = rs.detail[0];
        console.info(head);
        order.guid=head.oguid;
        order.code = head.ocode;
        order.canbieName =head.ocanBieName;
        order.canBieCode =head.ocanBieCode;
        order.luoDanTime = head.oluoDanTime;
        order.isFanJieSuan = head.oisFanJieSuan;
        order.jieSuanId = head.ojieSuanId;
        order.jieSuanNo = head.ojieSuanNo
        order.memberNo = head.omemberNo;
        order.memberName = head.ocardMemName;
        order.tradeGuid = head.otradeGuid;
        order.tradeNumber = head.otradeNumber;
        order.serverId = head.serverId;
        order.serverName = head.serverName;
        order.renshu = head.renshu;
        order.zhuotaiId = head.ozhuotaiId;
        order.zhuotaiCode = head.ozhuotaiCode;
        order.zhuotaiName = head.ozhuotaiName;
        order.comments = head.oComments;
        order.thirdOrderNo = head.thirdOrderNo;
        order.setOrderSource(head.ordersource);
        order.huiYuanId = head.huiYuanId;
        order.tsAndwm = head.tsAndwm;

        //重建MEMBER代理对象，此MEMBER并不是完整的MEMBER，只有一些非常基本的信息

        var  proxy = new Member();
        proxy.setCardNo(head.ocardNo);
        proxy.setName(head.ocardMemName);
        ret.memberProxy = proxy;
        if(head.ocardNo != null && head.ocardNo.length > 0){
            ret.fakePreviousMember( ret.memberProxy);
        }

        //结算单的GUID以及单号
        ret.setJieSuanGuid(order.jieSuanId );
        ret.setJieSuanNo(order.jieSuanNo);
        console.info(order);


        order.canbieId = head.ocanBieId;
        var tmpMap = {};

        //建立order和caipin关系
        for(var i = 0; i < rs.detail.length; i ++){
            var e = rs.detail[i];
            if(e.cguid == null)
                continue;
            var cp = null;
            if(tmpMap[e.cguid] == null){
                cp = new OrderCaipin();
                cp.name = e.cname;
                cp.caipinId = e.cCaipinId;
                cp.caipinCode = e.cCaipinCode;
                cp.guid = e.cguid;
                cp.price = e.cprice;
                cp.hyPrice = e.hyPrice;
                cp.zengNum = e.czengNum;
                cp.tuiNum = e.ctuiNum;
                cp.caipinTypeId = e.caipinTypeId;
                cp.caipinTypeCode = e.caipinTypeCode;
                cp.caipinTypeName = e.caipinTypeName;
                cp.num = e.cnum;
                cp.danPinBiLiZheKou = e.cdanPinBiLiZheKou;
                cp.danPinJineZheKou = e.cdanPinJineZheKou;
                cp.danPinZheKou  = e.cdanPinZheKou;
                cp.minAgio = e.cminAgio;
                cp.isScomb = e.cisScomb; //该菜品是否是套餐
                cp.parentOrder = order;
                cp.zheQianMoney = e.zheQianMoney;
                cp.unitId = e.cUnitId;
                cp.unitName = e.cUnitName;
                cp.zuoFaZheQianMoney = e.cZuoFaZheQianTotal;
                order.addCaiPin(cp);

                tmpMap[e.cguid] = cp;
            }
            cp = tmpMap[e.cguid];

            //如果没有做法和当前菜品相关，则继续
            if(e.kguid == null)
                continue;
            //如果当前菜品是“套餐”则 “理论上不应该有任何做法”（目前JP实现的时候也关联的做法--这是不太合理的。)
            // cisScomb 也有可能是字符串 or 还有可能用 0 ，1 表示吗？
            if(e.cisScomb == true || e.cisScomb == 'true')
                continue;

            //当前菜品有做法相关
            var ocz = new OrderCaipinZuofa();
            ocz.guid = e.kguid;
            ocz.price = e.kprice;
            ocz.name = e.kname;
            ocz.orderCaipinId = e.kOrderCpId;
            ocz.jiajiaType = e.kjiajiaType
            ocz.parentCaiPin = cp;

            cp.zuofas.push(ocz);

        }

        //ret.order = order;
        ret.setOrder(order);
    }

    /******************
     *根据凭据号获取明细
     *
     *******************/
    JieSuanService.showMinxi = function (pm, jieSuan, cb) {
        var param = {
            "credentialNumber":pm.ext1 //凭据号列表
        }
        //console.log("sddff:"+param)
        CardService.ShowMinxi(param, cb)

    }



    /**
     *
     * 根据凭据发送到云端撤销
     *
     */
    JieSuanService.removeImmmediatePay = function(pm, operator, jieSuan, cb){
        //TODO,需要和SYLAR集成,
        //会员API3: 根据凭据号，撤销交易

        var param = {
            cardCode:pm.getMemberNo(),
            terminalNumber:BIZCONSTANT.POSUSER.device,
            orderNo:jieSuan.order.guid,
            pjhList:[pm.ext1] //凭据号列表
        }
        var requestBody = JsonHelper.json4UndoPingJu(param)
        console.log(requestBody)


        crmsdk.AjaxLogger = AjaxLogger;
        var url = MEMBERURL.HUIYUANKACHUZHI;
        if(pm.isJiFen())
            url = MEMBERURL.HUIYUANKAJIFEN
        crmsdk.post(url, requestBody, function (response) {
            if(response.status == "failed"){
                cb({message:"会员结算交易失败"}, null);
                return;
            }
            JieSuanService.removeImmediatePayInternal(pm, operator, jieSuan, response, cb);
            jieSuan.removePM(pm); //NOTE,操作这个后ext1为null;

        }, function(error,data,errorThrown){
            cb({message:"会员交易失败，网络错误"}, null)
        });

        //先持久化，再更改模型
        //JieSuanService.removeImmediatePayInternal(pm,operator, jieSuan,cb);
        //jieSuan.removePM(pm); //NOTE,操作这个后ext1为null;


    }

    /**
     *
     * 根据凭据获取流水信息
     *
     */
    JieSuanService.getLiushui = function (pm, operator, jieSuan, cb) {
        var param = {
            cardCode:pm.getMemberNo(),
            terminalNumber:BIZCONSTANT.POSUSER.device,
            orderNo:jieSuan.order.guid,
            pjhList:[pm.ext1] //凭据号列表
        }
        var requestBody = JsonHelper.json4UndoPingJu(param)
        console.log(requestBody)

    }



    JieSuanService.removeImmediatePayInternal = function (pm, operator, jieSuan, response, cb) {

        var memo ="备注。。。";
        jieSuan.memo  = memo;
        var orderId = jieSuan.order.guid;
        var orderNo = jieSuan.order.code;
        var jieSuanNo = jieSuan.getJieSuanNo();
        var jieSuanId = jieSuan.order.jieSuanId
        jieSuan.setCreateTime(Utils.now());

        var cardNo = null;
        var cardMemName = null;
        var tradeNumber = null;//会员交易流水
        var tradeGuid = null;//会员交易GUID
        var mem = jieSuan.getMember();
        if( mem != null){
            cardNo = mem.getCardNo();
            cardMemName = mem.getName();
            tradeNumber = mem.tradeNumber;
            tradeGuid = mem.tradeGuid;
        }



        //所有的SQL
        var all = [];


        /*************************************************************/
        //1. 更新结算单中的实时支付类（会员卡）相关信息
        all.push({
            query: ' update pos_billing' +
            ' set orderId=?,  orderNo=?,  jieSuanNo=?, ' +
            ' tradeNumber=?,  tradeGuid=?' +
            ' where guid =? ',
            params:[orderId, orderNo,jieSuanNo,
                tradeNumber, tradeGuid,
                jieSuanId
            ]
        });

        /*************************************************************/
        //2. 删除  实时支付类的支付信息等
        all.push(PaymentMethod.SQL_DELETE_PM_TO_BIILLING_DETAIL_BIZID(pm, operator, jieSuan));


        //3.执行。
        posBillingDao.queryTransaction(all).then(function(resultList){
            cb(null, resultList, response);
        }, function(err){
            cb({message:"会员撤销异常."});
        });


        return all;
    }

    /**
     * 立即付，
     *
     * 即时支付的信息发送到云端
     */
    JieSuanService.payImmmediate = function(operator, jieSuan, cb){
        //TODO,需要和SYLAR集成, 需要把凭据号设置到支付方式的bizId字段。
        if(!jieSuan.getMember().usingCreditsInCard()){
            JieSuanService.payImmmediateInternal(operator, jieSuan, function (err, model) {

                $.maskLoader("hide");
                if (err) {
                    return Utils.showFailureInfo(err.message);
                }


            });
            return;
        }
        //会员API1: 发送该会员卡的消费金额信息
        //会员结算
        var requestBody  = { };
        requestBody.note = null; //备注？
        jieSuan.getMember().json4Pay(requestBody);
        requestBody.orderNo = jieSuan.order.code;
        requestBody.zhuotaiNo = jieSuan.order.zhuotaiCode;// ZT No
        requestBody.zhuotaiName = jieSuan.order.zhuotaiName;// ZT Name
        requestBody.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        requestBody.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        requestBody.hyId = jieSuan.getMember().getGuid();
        if (jieSuan.getMember().cardPassword)
            requestBody.cardPassword = jieSuan.getMember().cardPassword;

        var weiXInFlag = false;
        var orderSource = jieSuan.order.getOrderSource();
        if(orderSource && orderSource == "weixin") weiXInFlag = true;
        requestBody.weiXInFlag = weiXInFlag;
        requestBody.thirdOrderNo = jieSuan.order.thirdOrderNo;
        requestBody.timestamp = Utils.now();
        console.log(requestBody);

        crmsdk.AjaxLogger = AjaxLogger;
        crmsdk.post(MEMBERURL.JIE_SUAN_MEMBER, requestBody, function (response) {
            if(response.status == "failed"){
                cb({message:response.errorMsg}, null);
                jieSuan.getMember().clearAllPayments();
                return;
            }

            _.each(response.dataList, function(e){
                if(e.tradeType == "R04"){
                    //把 会员卡支付 支付方式的ext1设置为 返回的凭据号
                    jieSuan.getMemberPayment().ext1 = e.credentialNumber;
                    //交易记录(会员卡储值消费+赠送消费)
                    var tradeList = e.cardTradeDetailInfos;
                    if(tradeList && tradeList.length > 0) {
                        var parentHYKPM = jieSuan.getMemberPayment();
                        if(parentHYKPM)
                        for(var i = 0; i < tradeList.length; i++) {
                            var tradeInfo = tradeList[i];
                            if(tradeInfo && tradeInfo.tradeDetailType == "RD042") {
                                //会员卡赠送消费
                                var zsMoney = parseFloat(tradeInfo.tradePresentMoney);
                                parentHYKPM.hykZSMoney = zsMoney;
                                break;
                            }
                        }
                    }
                }else{
                    //把 积分消费 支付方式的ext1 设置为 返回的凭据号
                    jieSuan.getMemberPaymentOfJiFen().ext1 = e.credentialNumber;
                }
            })

            jieSuan.xiaofeiresponse = response.dataList;

            JieSuanService.payImmmediateInternal(operator, jieSuan, cb);

        }, function(error,data,errorThrown){
            cb("会员交易失败，网络错误", null)
            jieSuan.getMember().clearAllPayments();
        });

        // //把 会员卡支付 支付方式的ext1设置为 返回的凭据号
        // jieSuan.getMemberPayment().ext1 = "pj01"
        // //把 积分消费 支付方式的ext1 设置为 返回的凭据号
        // jieSuan.getMemberPaymentOfJiFen().ext1 = "pj02";
        // JieSuanService.payImmmediateInternal(operator, jieSuan,cb);
    }

    /**
     * 实时扣款类支付方式所保存的信息
     *
     * @param operator
     * @param jieSuan
     * @param cb
     * @returns {Array}
     */
    JieSuanService.payImmmediateInternal = function(operator, jieSuan, cb){
        //设备信息
        var device = operator.device;
        var memo ="备注。。。";
        jieSuan.memo  = memo;
        var orderId = jieSuan.order.guid;
        var orderNo = jieSuan.order.code;
        var jieSuanNo = jieSuan.getJieSuanNo();
        var jieSuanId = jieSuan.order.jieSuanId
        var banci = operator.banCiHao;


        var cardNo = null;
        var cardMemName = null;
        var tradeNumber = null;//会员交易流水
        var tradeGuid = null;//会员交易GUID
        var mem = jieSuan.getMember();
        if( mem != null){
            cardNo = mem.getCardNo();
            cardMemName = mem.getName();
            tradeNumber = mem.tradeNumber;
            tradeGuid = mem.tradeGuid;
        }

        //
        var now =Utils.now();
        jieSuan.setCreateTime(now);

        //所有的SQL
        var all = [];


        /*************************************************************/
        //1. 更新结算单中的实时支付类（会员卡）相关信息
        all.push({
            query: ' update pos_billing' +
            ' set orderId=?,  orderNo=?,  jieSuanNo=?, ' +
            ' tradeNumber=?,  tradeGuid=?, cardNo=?, cardMemName=? ' +
            ' where guid =? ',
            params:[orderId, orderNo,jieSuanNo,
                tradeNumber, tradeGuid, cardNo, cardMemName,
                jieSuanId
            ]
        });

        all.push({
            query:"update pos_order "+
            " set cardNo =? ,cardMemName = ?, tradeNumber = ?, tradeGuid = ?" +
            " where guid=?",
            params:[
                cardNo, cardMemName, tradeNumber,tradeGuid,  orderId ]
        })

        /*************************************************************/
        //2. 删除已存在的并重新插入结算单明细, 实时支付类（会员卡）
        //2c 支付方式： 实时支付类的支付信息等
        for( var i = 0; i < jieSuan.payMethodList.length; i ++){
            o = jieSuan.payMethodList[i];
            if(! o.isPayFirst())
                continue;
            //如果pmId为空，则是在程序中自己new出来的。需要给PMID再次赋值
            if(o.pmId == null && ! o.isVirtual()){
                var exists =  getPMByCode( BIZCONSTANT.ALLPMs, o.code);
                o.pmId = exists.pmId;
            }

            all.push(PaymentMethod.SQL_INSERT_PM_TO_BIILLING_DETAIL(o, operator, jieSuan));
        }

        //3.执行。

        posBillingDao.queryTransaction(all).then(function(resultList){
            cb(null, jieSuan.xiaofeiresponse);
        }, function(err){
            console.log(err);
            cb({message:"会员扣款异常."});
        });


        return all;
    }

    JieSuanService.save = function(operator, jieSuan, cb){

        //检查账单付款方式是否完整
        var isComplete = JieSuanService.checkZFMoney(jieSuan);
        if(isComplete == false) {
            var errMsg = "结算异常：各支付方式支付金额总和与应收金额不等，请重新操作支付方式再次结算。";
            return cb({message:errMsg});
        }

        //非会员结算
        if( ! jieSuan.useHuiYuanKa()) {
            //套餐被当做一个单独的结算对象来出来，必须调用这个方法
            jieSuan.computeFenTan4TaoCan();
            JieSuanService.internalSave(operator, jieSuan, cb);
            return;
        }
        //会员结算, 先临时保存，再网络调用
        JieSuanService.jieSuanSnapshot(operator, jieSuan, function (err, model) {
            if (err) {
                cb(err, model);
                return ;
            }
            JieSuanService.doJieZhang(jieSuan,operator,cb);
        });



    }

    JieSuanService.doJieZhang = function(jieSuan, operator,cb){
        //会员结算，
        //会员API2: 发送该会员卡关联的各种支付方式 以及 消费积分
        var requestBody  = { };
        requestBody.note = null; //备注？
        jieSuan.json4JieZhang(requestBody);
        requestBody.orderNo = jieSuan.order.code;
        requestBody.zhuotaiNo = jieSuan.order.zhuotaiCode;// ZT No
        requestBody.zhuotaiName = jieSuan.order.zhuotaiName;// ZT Name
        requestBody.canBieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
        requestBody.canBieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
        requestBody.thirdOrderNo = jieSuan.order.thirdOrderNo;
        requestBody.timestamp = Utils.now();
        try{
            requestBody.hyId = jieSuan.getMember().getGuid();
        }catch (e){}
        var weiXInFlag = false;
        var orderSource = jieSuan.order.getOrderSource();
        if(orderSource && orderSource == "weixin") weiXInFlag = true;
        requestBody.weiXInFlag = weiXInFlag;

        console.log("********************************");
        console.log(requestBody);
        crmsdk.AjaxLogger = AjaxLogger;
        crmsdk.post(MEMBERURL.JIE_SUAN_MEMBER, requestBody, function (response) {
            if(response.status == "failed"){
                cb({message:response.errorMsg}, null);
                return;
            }
            //得到会员交易凭据号
            if(response.dataList.length > 0)
                jieSuan.memberProxy.tradeNumber = response.dataList[0].credentialNumber;
            else
                jieSuan.memberProxy.tradeNumber= null;

            //NOTE: 需要保存最后一次凭据信息，这里就是 “消费兑换的积分以及现金支付方式”的凭据号
            JieSuanService.internalSave(operator, jieSuan, cb);

        }, function(error,data,errorThrown){
            cb({message:"会员交易失败，网络错误"}, null);
        });

    }

    JieSuanService.internalSave = function(operator, jieSuan, cb){
        var now = new Date();
        UniqueIDService.nextSeq(now, 'jieSuanDan', function (err, seq, nowdate) {
            if(err){
                return Utils.showFailureInfo(err.message);
            }

            //1. 结算单号

            var seqNo = nowdate + Utils.formatSeqNo(seq);
            var jieSuanNo = "JSD" + seqNo;

            //系统时间判断
            if (Utils.m(now.format('yyyyMMdd')) != Utils.m(nowdate)){
                Utils.winLog("结算：主机与从机日期不相同"+"主机："+nowdate+"————从机："+now.format('yyyyMMdd'));
                return cb({ message: "结算失败，主机与从机日期不相同，请修正后继续操作" }, null);
            }


            //落单时间和结算时间
            UniqueIDService.MaxSeq('pos_order', 'luoDanTime', '', function (maxerr, maxseq,mastertime) {
                if (mastertime < maxseq) {
                    Utils.winLog("结算：落单时间大于结算时间" + "落单时间：" + maxseq + "————结算时间：" + mastertime);
                    return cb({ message: "结算失败，请检查主机机器时间是否正常" }, null);
                }


                jieSuan.setJieSuanNo(jieSuanNo);

                //3.准备SQL
                CanbieService.getCurrentCanBie(function (err, canbie) {
                    console.info("currentCanBie : " + JSON.stringify(canbie));
                    if(!err && canbie) {
                        var all = JieSuanService.prepareSQL2(operator, jieSuan, canbie);
                        posBillingDao.query("select * from pos_zhuotai where orderId = '"+jieSuan.order.guid+"'").then(function(result){
                            //4.执行。
                            JieSuanService.seeJiedanTime(jieSuan.order.guid, function (res) {
                                if(res.detail[0].jieSuanTime) {
                                    return cb({message:"已经结单."});
                                }else {
                                    //4.执行。
                                    if(jieSuan.saved) return cb(null, null);
                                    posBillingDao.queryTransaction(all).then(function(resultList){
                                        jieSuan.saved = true;
                                        cb(null, null);
                                        //console.log(resultList);
                                    }, function(err){
                                        console.log(err);
                                        cb({message:"结算失败."});
                                    });
                                    if(!Utils.isEmpty(result.detail)){
                                        //中餐
                                        DataSyncService.syncZhuotai({zhuotai:result.detail[0],order:{id:""}});	// 给服务器发送清台数据
                                    }
                                }
                            })

                        });
                    }
                })
            });



        })






    }

    /**
     *     结算对象快照持久化,临时保存
     */
    JieSuanService.jieSuanSnapshot = function(operator, jieSuan, cb){
        //套餐被当做一个单独的结算对象来出来，必须调用这个方法
        jieSuan.computeFenTan4TaoCan();
        CanbieService.getCurrentCanBie(function (err, canbie) {
            // console.info("currentCanBie : " + JSON.stringify(canbie));
            if(!err && canbie) {
                var all = JieSuanService.prepareSQL2(operator, jieSuan, canbie);
                if(jieSuan.saved) return cb(null, null);
                posBillingDao.queryTransaction(all).then(function(resultList){
                    saving = false;
                    cb(null, null);
                    //console.log(resultList);
                }, function(err){
                    saving = false;
                    console.log(err);
                    cb(err);
                });
            }
        })
    };

    JieSuanService.prepareSQL2 = function(operator, jieSuan, canbie){
        //设备信息
        var device = operator.device;
        var memo ="备注。。。";
        jieSuan.memo  = memo;
        var orderId = jieSuan.order.guid;
        var orderNo = jieSuan.order.code;
        var jieSuanNo = jieSuan.getJieSuanNo();
        var jieSuanId = jieSuan.order.jieSuanId;

        var zhangDanTotal = jieSuan.order.getSumOfZhangDan(); //账单总金额
        var shiShou = jieSuan.order.getYingShou(); //实收必须等于应收。
        var zhaoLing = jieSuan.zhaoLing; //找零金额
        var zheKouTotal = jieSuan.order.calAllZheKou();//折扣总金额
        var fenTanTotal = jieSuan.order.getSumOfFenTan();//分摊总金额
        var moLing = jieSuan.order.getSumOfMoLing();//抹零对象
        var danPinTotal = jieSuan.order.sumOfDanPin(); //计算该账单的单品金额
        var sumOfZhengDanBiLi = jieSuan.order.sumOfZhengDanBiLi(); //该账单引用比例折扣后，所产生的折扣金额
        var memberProxy = jieSuan.memberProxy;
        var cardNo = null;
        var cardMemName = null;
        var tradeNumber =  null;
        var tradeGuid = null;
        var banci = operator.banCiHao;

        //交易凭据号
        if(jieSuan.getMember()){
            cardNo = jieSuan.memberProxy.getCardNo();
            cardMemName = jieSuan.memberProxy.getName();
            tradeNumber = jieSuan.memberProxy.tradeNumber;
            tradeGuid = jieSuan.memberProxy.tradeGuid;
        }

        //比例折扣对象,
        var zheKouCode = null;
        var zheKouAmount = null;
        var zheKouName = null;
        //得到定额折扣对象
        var dingEMoney = null;

        _.each(jieSuan.activeZk, function(e){
            if(e.isOfBiLi()){
                zheKouCode = e.zheKouCode;
                zheKouAmount = e.zheKouAmount;
                zheKouName = e.zheKouName;
            }

            if(e.isDingE()){
                dingEMoney = e.moneyAsStr();
            }

        });
        //
        var nowDate = new Date();
        var now =Utils.nowWith(nowDate);
        var nowMill = nowDate.getTime();

        jieSuan.setCreateTime(now);
        //所有的SQL
        var all = [];


        //如果已结算，查询出结算时间
        var jieSuanTimeSql = "||(select ifnull(jieSuanTime,'') from pos_order where guid='" + orderId + "') ";
        jieSuan.jieSuanTimeSql = jieSuanTimeSql;
        var canBieId = canbie.guid;
        var canBieCode = canbie.code;
        var canBieName = canbie.name;
        /*************************************************************/
        //1. 更新结算单
        JieSuanService.update_PosBilling(jieSuan, operator, nowMill, canbie,zheKouCode, zheKouAmount, zheKouName,dingEMoney, all);

        /*************************************************************/
        //2. 删除已存在的并重新插入结算单明细, 实时支付类（会员卡）除外

        if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
        var jieSuanIdStr = "'" + jieSuan.order.jieSuanId + "'" + jieSuan.jieSuanTimeSql;
        var orderIdStr = "'" + jieSuan.order.guid + "'" + jieSuan.jieSuanTimeSql;
        // precondition
        //删除抹零类
        all.push({
            query: 'delete from pos_billing_detail ' +
            " where type = 'ML' and jieSuanId=" + jieSuanIdStr,
            params:[]
        });
        //删除折扣类
        all.push({
            query: 'delete from pos_billing_detail' +
            " where type = 'ZK' and jieSuanId=" + jieSuanIdStr,
            params:[]
        });
        //删除"非扣款优先的“支付类
        all.push({
            query: 'delete from pos_billing_detail ' +
            " where jieSuanId = "+ jieSuanIdStr + " and type = 'PAY' and bizCode not in (" + PaymentMethod.payFirstList() +")",
            params:[]
        });

        //2a折扣
        var o = null;
        for( var i = 0; i < jieSuan.activeZk.length; i ++){
            o = jieSuan.activeZk[i]
            all.push(ZheKou.SQL_INSERT_ZK_TO_BIILLING_DETAIL(o, operator, jieSuan));
        }
        //2b抹零类,如没有抹零则应该为0.反之，则是非零
        all.push(moLing.ML_SQL_INSERT_BIILLING_DETAIL(operator, jieSuan));

        //2c 支付方式： 现金类，银行卡，优惠券等
        for( var i = 0; i < jieSuan.payMethodList.length; i ++){
            o = jieSuan.payMethodList[i]
            if( o.isMemberFanZhi() ) //反值的不处理
                continue;
            if(o.isPayFirst())  //即时扣款类型的支付方式不再插入，执行更新
                continue;
            all.push(PaymentMethod.SQL_INSERT_PM_TO_BIILLING_DETAIL(o, operator, jieSuan));
        }

        //2d 把 即时扣款类的支付方式 和 当前结算单号关联
        all.push({
            query: 'update pos_billing_detail ' +
            ' set jieSuanNo = ? ' +
            " where jieSuanId = "+jieSuanIdStr+" and type = 'PAY' and bizCode  in (" + PaymentMethod.payFirstList() +")",
            params:[ jieSuanNo]
        });


        /*************************************************************/
        //计算金额分摊
        JieSuanService.updateFenTanMoney(operator, jieSuan, all);

        //会员信息
        all.push({
            query:"update pos_order "+
            " set  " +
            "  tradeNumber = ?, " +
            "  tradeGuid = ?," +
            "  cardNo = ?, cardMemName=?, temZkMoney=? "+
            " where guid= " + orderIdStr,
            params:[
                tradeNumber,
                tradeGuid,
                cardNo,
                cardMemName,
                jieSuan.getZheKouMoneyOfTemplate()
            ]
        })

        //是 结账 动作
        if(jieSuanNo != null){

            /*************************************************************/
            //5.清台
            s = {
                query: "update pos_zhuotai set orderId = null where orderId = " + orderIdStr,
                params: []
            }
            all.push(s);

            //9 班次和账单关联 班次【jbd201601100001】添加一笔新的账单【zd201601100002】
            var banciGuid = Utils.guid();
            var banciNoStr = "'" + banci + "'" + jieSuan.jieSuanTimeSql;
            var orderNoStr = "'" + orderNo + "'" + jieSuan.jieSuanTimeSql;
            all.push({
                query:'insert into pos_banci_order'+
                '(guid,banciNo,orderId,orderCode,createTime,addOperatorId,addOperatorCode,addOperatorName)'+
                'values(?,'+banciNoStr+','+ orderIdStr + ','+ orderNoStr + ',?,?,?,?)',
                params:[banciGuid,now,operator.id, operator.code,operator.name]
            });
            var banciGuidStr = "'" + banci + "'" + jieSuan.jieSuanTimeSql;
            all.push({
                query:"UPDATE pos_banci_order SET banciId = (SELECT guid FROM pos_banci WHERE banCiNo = '" + banci + "') " +
                "WHERE guid = " + banciGuidStr
            });

            all.push({
                query: ' update pos_billing' +
                ' set  syn=? , ' +
                ' tradeNumber = ?,' +
                ' tradeGuid = ?, ' +
                ' banci=?, cardNo=?, cardMemName=?   ' +
                ' where guid = ' + jieSuanIdStr,
                params:[  BIZCONSTANT.DATA_UPLOADED_NO,
                    tradeNumber,
                    tradeGuid,
                    banci, cardNo, cardMemName
                ]
            });

            //计算菜品提成金额
            var update_pos_order_caipin = "UPDATE pos_order_caipin SET commissionPrice = " +
                " shiShouMoney * (SELECT ( CASE pc.commissionTypeId WHEN '002' THEN CAST ( pc.commissionPrice / 100.0 AS decimal ) " +
                " WHEN '001' THEN pc.commissionPrice/pos_order_caipin.shiShouMoney ELSE 0 END ) AS price " +
                " FROM pos_caipin pc WHERE pc.guid = pos_order_caipin.caipinId ), " +
                " commissionTypeId = (select commissionTypeId from pos_caipin pc WHERE pc.guid = pos_order_caipin.caipinId ) " +
                " WHERE orderId = " + orderIdStr +
                " and CAST(num as int)>0 " +
                " and CAST(zengNum as int)<=0";
            all.push({
                query:update_pos_order_caipin,
                params:[]
            })

            //若有会员卡支付方式，并且含有赠送消费，需拆分支付方式
            var memberPM = jieSuan.getMemberPayment();
            if(memberPM) {
                var zsM = memberPM.hykZSMoney;
                if(zsM > 0) {
                    jieSuan.doNotAutoSave = true;
                    memberPM.removeMoney(zsM);
                    memberPM.hykZSMoney = 0;
                    var cloneMemPM = memberPM.clonePM();
                    cloneMemPM.pmId = null;
                    cloneMemPM.code = BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE;
                    cloneMemPM.name = BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_NAME;
                    cloneMemPM.setMoney(zsM);
                    cloneMemPM.caiWuShuXing = BIZCONSTANT.CWKM_YOUMIAN;
                    jieSuan.addPM(cloneMemPM);
                    //删除原有会员卡支付方式
                    all.push({
                        query: 'delete from pos_billing_detail ' +
                        " where type = 'PAY' and bizCode = ? and jieSuanId=" + jieSuanIdStr,
                        params:[BIZCONSTANT.PM_HUI_YUAN]
                    });
                    //更新结算单
                    JieSuanService.update_PosBilling(jieSuan, operator, nowMill, canbie,zheKouCode, zheKouAmount, zheKouName,dingEMoney, all);
                    //新增拆分后的会员卡支付方式
                    all.push(PaymentMethod.SQL_INSERT_PM_TO_BIILLING_DETAIL(memberPM, operator, jieSuan));
                    all.push(PaymentMethod.SQL_INSERT_PM_TO_BIILLING_DETAIL(cloneMemPM, operator, jieSuan));
                    //重新计算金额分摊
                    JieSuanService.updateFenTanMoney(operator, jieSuan, all);
                    //防止rollback
                    jieSuan.removePM(cloneMemPM);
                    memberPM.addMoney(zsM);
                    jieSuan.reCalAll();
                    jieSuan.doNotAutoSave = false;
                }
                //记录整个账单的结算时间,必须最后一步记录
                JieSuanService.setJieSuanTime(all, now, nowMill, operator, jieSuanNo, jieSuanId, tradeNumber, tradeGuid, banci, canBieId, canBieCode, canBieName, cardNo, cardMemName, orderIdStr);
            }else{
                //记录整个账单的结算时间,必须最后一步记录
                JieSuanService.setJieSuanTime(all, now, nowMill, operator, jieSuanNo, jieSuanId, tradeNumber, tradeGuid, banci, canBieId, canBieCode, canBieName, cardNo, cardMemName, orderIdStr);
            }
        }



        return all;

    }

    //记录账单结算时间，必须最后一步
    JieSuanService.setJieSuanTime = function (all, now, nowMill, operator, jieSuanNo, jieSuanId, tradeNumber, tradeGuid, banci, canBieId, canBieCode, canBieName, cardNo, cardMemName, orderIdStr) {
        all.push({
            query:"update pos_order "+
            " set  jieSuanTime=?,  jieSuanTimeMill = ?, " +
            "  jieSuanOperatorId=?, jieSuanOperatorCode=?,jieSuanOperatorName=?, jieSuanNo=?, jieSuanId=?," +
            "  tradeNumber = ?, " +
            "  tradeGuid = ?," +
            "  banciNo =?, " +
            "  status = ?," +
            "  jieSuanCanBieId = ?," +
            "  jieSuanCanBieCode = ?," +
            "  jieSuanCanBieName = ?, " +
            "  cardNo = ?, cardMemName=?  " +
            " where guid=" + orderIdStr,
            params:[now,nowMill,
                operator.id, operator.code,operator.name,jieSuanNo,jieSuanId,
                tradeNumber,
                tradeGuid,
                banci,
                BIZCONSTANT.ORDER_STATUS_YI_JIE_SUAN,//表示账单为已结算
                canBieId,
                canBieCode,
                canBieName,cardNo, cardMemName]
        })
    }

    //更新菜品分摊金额信息
    JieSuanService.updateFenTanMoney = function (operator, jieSuan, all) {
        //3.更新账单以及明细
        //3a.更新账单明细
        var cpList = jieSuan.order.caiPinList;
        var zuoFaList = [];
        var s= null;
        _.each(cpList, function(v){
            s = OrderCaipin.SQL_UPDATE_OCP_TO_ORDER_CAIPIN(v,operator, jieSuan)
            //提取菜品相关的所有的做法
            _.each(v.zuofas, function(kv){
                zuoFaList.push(kv);
            })
            all.push(s);
        });


        /*************************************************************/
        //4.更新做法明细
        _.each(zuoFaList, function(v){
            all.push(OrderCaipinZuofa.SQL_UPDATE_ZF_TO_ORDER_CAIPIN_ZUOFA(v, operator, jieSuan));
        });

        //7. 套餐相关 ==》如果菜品中包含套餐，那么也需要把分摊也分到套餐明细中
        var fjs = jieSuan.getTaoCanJieSuan();
        var taoCanZuoFa = [];
        for(var key in fjs){
            var fakeJieSuan = fjs[key];
            _.each(fakeJieSuan.order.caiPinList, function(v){
                all.push(OrderCaipin.SQL_UPDATE_OCP_TO_ORDER_SCOMB_CAIPIN(v, operator, jieSuan));

                //提取菜品相关的所有的做法
                _.each(v.zuofas, function(kv){
                    taoCanZuoFa.push(kv);
                })
            });

        }
        //8. 套餐相关 ==》套餐中的菜品所相关的做法
        _.each(taoCanZuoFa, function(v){
            all.push(OrderCaipinZuofa.SQL_UPDATE_ZF_TO_ORDER_CAIPIN_ZUOFA(v, operator, jieSuan));
        });
    }

    //更新结算单
    JieSuanService.update_PosBilling = function (jieSuan, operator, nowMill, canbie,zheKouCode, zheKouAmount, zheKouName,dingEMoney, all) {
        var hykZSMoney = 0;
        try{
            hykZSMoney = jieSuan.getMemberZSPayment().pmMoney();
        }catch (e){
            hykZSMoney = 0;
        }
        if(!jieSuan.jieSuanTimeSql) jieSuan.jieSuanTimeSql = "";
        var jieSuanIdStr = "'" + jieSuan.order.jieSuanId + "'" + jieSuan.jieSuanTimeSql;
        all.push({
            query: ' update pos_billing' +
            ' set orderId=?,  orderNo=?,  jieSuanNo=?, ' +
            ' zhangDanTotal=?,  shiShou=?,  zhaoLing=?,   zheKouTotal=?,  fenTanTotal=?,  moLing=?,  ' +
            ' device=?,  memo=?,  createTime=?, updateTimeMill=?, ' +
            ' addOperatorId=?,  addOperatorCode=?,  addOperatorName=?,  canBieCode=?,  canBieName=?, mdId=?, isFanJieSuan=?, '+
            ' moneyTuiDan=?, moneyZengSong=?, moneyZheKou=?, ' +
            '  moneyDanPin=?,  ' +
            ' moneyZhengDanBiLi=?, moneyZhengDanBiLiCode=?, moneyZhengDanBiLiDiscount=?,  moneyZhengDanBiLiName=?, ' +
            ' moneyDingE=?,  ' +
            '  canbieId = ?, hykZSMoney=?, jiFenMoney=? ' +
            ' where guid = ' + jieSuanIdStr,
            params:[jieSuan.order.guid, jieSuan.order.code,jieSuan.getJieSuanNo(),

                jieSuan.order.getSumOfZhangDan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.getYingShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.zhaoLing.toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.calAllZheKou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.getSumOfFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.getSumOfMoLing().getAmount().toFixed(BIZCONSTANT.MONEY_PRECISE),

                operator.device, jieSuan.memo, jieSuan.getCreateTime(),nowMill,
                operator.id, operator.code, operator.name, canbie.code, canbie.name,
                operator.mdId, BIZCONSTANT.FANJIESUAN_NO,
                jieSuan.order.sumOfTuiCai().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.sumOfFree().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.sumOfZheKou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                jieSuan.order.sumOfDanPin(),
                jieSuan.order.sumOfZhengDanBiLi(),zheKouCode, zheKouAmount, zheKouName,
                dingEMoney,
                canbie.guid,
                hykZSMoney,
                jieSuan.getJiFenMoney()
            ]
        });
    }

    //结账时检测支付方式金额总和是否等于账单应付金额
    JieSuanService.checkZFMoney = function (jieSuanObj) {
        var ret = true;
        if(jieSuanObj && jieSuanObj.allpms && jieSuanObj.allpms.length > 0) {
            var totalPayMoney = 0;
            totalPayMoney = Utils.m(jieSuanObj.order.getYingShou() + jieSuanObj.order.getSumOfFenTan() + jieSuanObj.order.getSumOfHuiYuanJiaZheKou() + jieSuanObj.order.getSumOfNoneDanPinZheKou() + parseFloat(jieSuanObj.zhaoLing));
            var log = "============================结账异常【start】============================\r\n";
            var logArr = [];
            var logTimeStart = "落单时间：" + jieSuanObj.order.luoDanTime + "\r\n";
            log += logTimeStart;
            var log0 = "账单号：" + jieSuanObj.order.code + ", 餐别：" + jieSuanObj.order.canbieName + ", 桌台：" + jieSuanObj.order.zhuotaiName + "\r\n";
            log += log0;
            var log1 = "账单应付金额：" + totalPayMoney + "\r\n";
            var sumPayMoney = 0;
            var log2 = "实际支付方式列表：" + "\r\n";
            log += log1;
            log += log2;
            for(var i = 0; i < jieSuanObj.allpms.length; i++) {
                var pm = jieSuanObj.allpms[i];
                var log3 = "支付方式【" + (i + 1) + "】 : ";
                log += log3;
                if(pm.isml == true) {
                    sumPayMoney += pm.money;
                    var log4 = pm.name + " : " + pm.money + "\r\n";
                    log += log4;
                }else if(pm.iszf == true) {
                    sumPayMoney += pm.pmMoney();
                    var log5 = pm.name + " : " + pm.pmMoney() + "\r\n";
                    log += log5;
                }else if(pm.iszk == true) {
                    var zkMoney = 0;
                    if(pm.isHuiYuanJia() == true) {
                        zkMoney = Math.abs(pm.zheKouAmount);
                    }else {
                        zkMoney = Math.abs(pm.money());
                    }
                    sumPayMoney += zkMoney;
                    var log6 = pm.zheKouName + " : " + zkMoney + "\r\n";
                    log += log6;
                }
            }
            sumPayMoney = Utils.m(sumPayMoney);
            var log7 = "实际支付方式总金额：" + sumPayMoney + "\r\n";
            log += log7;
            var logTimeEnd = "============================结账异常【end】============================\r\n";
            log += logTimeEnd;
            if(totalPayMoney != sumPayMoney) {
                ret = false;
                console.log(log);
                AjaxLogger.log(BIZCONSTANT.POSUSER, "结账异常", log, "","");
            }
        }else {
            ret = false;
        }
        return ret;
    }


    /**
     * 调账 - 客户端
     *
     * 主要对已结算的账单的各种计算金额进行调整，其他的不动。
     *
     * 主要用于影响 报表， 结班，账单查询
     *
     * 这个方法很危险，开发人员动也要慎重
     *
     * 在执行次方法前，需要把 JieSuanService.loadByOrderId 中的
     if( !ret.isTempJieSuan())
     return ;

     注释掉。

     step0:修正 Pos_cai_wu_ke_mu中的isshishou到合适的值
     STEP1：现金，银行卡，被当做优免的计算的账单
     select *  from pos_billing where jieSuanNo IN (select jieSuanNo from pos_billing_detail where caiWuShuXing = '优免'
     and bizDesc in ('银行卡','现金','会员卡'))
     STEP2: 按照billing_no来吧 pos_billing_detail表中的现金，银行卡，会员卡等的属性设置为实收。把付款金额调整到正确的值
     step3：用这个方法进行校正。
     SETP4: 如果修正后的账单数据需要上传，那么把POS_BILLING中的SYNC更改为1


     update pos_billing_detail set caiwushuxing ='实收' where guid = 'fae02ae7de47f84f8918bca0f277ed06';
     update pos_billing_detail set caiwushuxing ='实收' where guid = 'd5b56f251ab1fca2e0f35fea706fc415';
     update pos_billing_detail set caiwushuxing ='实收', amount = 256.00 where guid = '56ed37340842a78c486d1aeeba316e76';
     update pos_billing_detail set caiwushuxing ='实收', amount = 195.00 where guid = '0935ad4ece0c00d5d236176e5f19b930';
     update pos_billing_detail set caiwushuxing ='实收' where guid = '5f65c476c8f2ba0856b8c63e3a7f131c';
     update pos_billing_detail set caiwushuxing ='实收', amount = 346.00 where guid = '6fea27ad7920d6aada5ec372630fe037';
     update pos_billing_detail set caiwushuxing ='实收' where guid = 'a68cf1ccdb79a6839aab6549a5eba8d7';
     update pos_billing_detail set caiwushuxing ='实收' where guid = '128f453be67517516a35273013d8a198';
     update pos_billing_detail set caiwushuxing ='实收' where guid = '09c4f73e335303af7d51ffd1344726e3';
     update pos_billing_detail set caiwushuxing ='实收', amount = 38.00 where guid = 'c0ae76ee6346eccca2f7d147835772f5';
     update pos_billing_detail set caiwushuxing ='实收', amount = 246.00 where guid = '62b911cf5c1bfa80bc56b5de0d341661';

     *
     */
    var oList = [
        'df907fb59b4745a4ef30f9c845bde9ee',
        '7decd960c9e453c514312a1a38ba4781',
        '6bc7be14423e9eefb6eb06b3053df00e',
        'a5f967a48e2134b131281dafa8b8d73a',
        '7360da4b6df70630e6e1bc61b732974f',
        '7604f3824e539ca855bc69e11c44da59',
        '3d849f5f85be977c2413dbd74a4e7dff',
        '095bf3ba987e3d31db02b7b1904e880d',
        'a4a5ec417739117dd2834b1954a864d9',
        'da3d96854730e009cd73f70ca7ad9e4d',
        'a359a131d5fe937c8227bf559854a0bb'
    ]; //需要重新计算金额的[订单ID]

    JieSuanService.tiaoZhang = function(){

        if(oList.length == 0)
            return;


        var raw = new Order();
        raw.guid = oList.pop();

        var jieSuan = new JieSuan();
        var operator = new PosUser();

        JieSuanService.loadByOrderId(raw, jieSuan, function (err, model) {
            if (err) {
                Utils.showFailureInfo(err.message);
                return cb(null, null);
            }

            window.setTimeout(function(){

                //套餐被当做一个单独的结算对象来出来，必须调用这个方法
                jieSuan.computeFenTan4TaoCan();

                var orderId = jieSuan.order.guid;
                var orderNo = jieSuan.order.code;
                var jieSuanNo = jieSuan.getJieSuanNo();
                var jieSuanId = jieSuan.order.jieSuanId

                var zhangDanTotal = jieSuan.order.getSumOfZhangDan(); //账单总金额
                var shiShou = jieSuan.order.getYingShou(); //实收必须等于应收。
                var zhaoLing = jieSuan.zhaoLing; //找零金额
                var zheKouTotal = jieSuan.order.calAllZheKou();//折扣总金额
                var fenTanTotal = jieSuan.order.getSumOfFenTan();//分摊总金额
                var moLing = jieSuan.order.getSumOfMoLing();//抹零对象
                var danPinTotal = jieSuan.order.sumOfDanPin(); //计算该账单的单品金额
                var sumOfZhengDanBiLi = jieSuan.order.sumOfZhengDanBiLi(); //该账单引用比例折扣后，所产生的折扣金额


                //比例折扣对象,
                var zheKouCode = null;
                var zheKouAmount = null;
                var zheKouName = null;
                //得到定额折扣对象
                var dingEMoney = null;

                _.each(jieSuan.activeZk, function(e){
                    if(e.isOfBiLi()){
                        zheKouCode = e.zheKouCode;
                        zheKouAmount = e.zheKouAmount;
                        zheKouName = e.zheKouName;
                    }

                    if(e.isDingE()){
                        dingEMoney = e.moneyAsStr();
                    }

                });
                //
                var now =Utils.now();
                jieSuan.setCreateTime(now);

                var all = [];

                //1. 更新结算单
                all.push({
                    query: ' update pos_billing' +
                    ' set orderId=?,  orderNo=?,  ' +
                    ' zhangDanTotal=?,  shiShou=?, ' +
                    ' zhaoLing=?, zheKouTotal=?,  ' +
                    ' fenTanTotal=?,  moLing=?,  ' +
                    ' moneyTuiDan=?, ' +
                    ' moneyZengSong=?, ' +
                    ' moneyZheKou=?, ' +
                    ' moneyDanPin=?,  ' +
                    ' moneyZhengDanBiLi=?,  ' +
                    ' moneyDingE=?  ' +
                    ' where guid =? ',
                    params:[orderId, orderNo,
                        zhangDanTotal.toFixed(BIZCONSTANT.MONEY_PRECISE), shiShou.toFixed(BIZCONSTANT.MONEY_PRECISE),
                        zhaoLing.toFixed(BIZCONSTANT.MONEY_PRECISE),      zheKouTotal.toFixed(BIZCONSTANT.MONEY_PRECISE),
                        fenTanTotal.toFixed(BIZCONSTANT.MONEY_PRECISE),   moLing.getAmount().toFixed(BIZCONSTANT.MONEY_PRECISE),

                        jieSuan.order.sumOfTuiCai().toFixed(BIZCONSTANT.MONEY_PRECISE),
                        jieSuan.order.sumOfFree().toFixed(BIZCONSTANT.MONEY_PRECISE),
                        jieSuan.order.sumOfZheKou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                        danPinTotal,

                        sumOfZhengDanBiLi,
                        dingEMoney,
                        jieSuanId
                    ]
                });

                //2. 圈定需要更新菜品的金额列
                var cpList = jieSuan.order.caiPinList;
                var zuoFaList = [];
                var s= null;
                _.each(cpList, function(v){
                    s = {
                        query:"update pos_order_caipin "+
                        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?,moLingMoney =?, " +
                        " zuoFaZheQianTotal = ?, zuoFaShiShouTotal = ?, zuoFaZheKouTotal  = ?, zuoFaFenTanTotal  = ?, zuoFaMoLingTotal  = ?, " +
                        " weight =? "+
                        " where guid=?",
                        params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),

                            v.calMoneyTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calShiShouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calZheKouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calFenTanTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calMoLingTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),

                            v.weight(),
                            v.guid]
                    }

                    //提取菜品相关的所有的做法
                    _.each(v.zuofas, function(kv){
                        zuoFaList.push(kv);
                    })
                    all.push(s);
                });



                /*************************************************************/
                //3.更新做法明细
                _.each(zuoFaList, function(v){
                    s = {
                        query: "update pos_order_caipin_zuofa " +
                        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?, fenTanSumMoney =?," +
                        " moLingMoney =?, weight =? "+
                        " where guid=?",
                        params: [v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.weight(),
                            v.guid]
                    }
                    all.push(s);
                });


                //7. 套餐相关 ==》如果菜品中包含套餐，那么也需要把分摊也分到套餐明细中
                var fjs = jieSuan.getTaoCanJieSuan();
                var taoCanZuoFa = [];
                for(var key in fjs){
                    var fakeJieSuan = fjs[key];
                    _.each(fakeJieSuan.order.caiPinList, function(v){

                        s =  {
                            query:"update pos_order_scomb_caipin "+
                            " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?,moLingMoney =?, " +
                            " zuoFaZheQianTotal = ?, zuoFaShiShouTotal = ?, zuoFaZheKouTotal  = ?, zuoFaFenTanTotal  = ?, zuoFaMoLingTotal  = ?, " +
                            "  weight =? "+
                            " where guid=?",
                            params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),

                                v.calMoneyTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calShiShouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calZheKouTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calFenTanTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),
                                v.calMoLingTotal4ZuoFa().toFixed(BIZCONSTANT.MONEY_PRECISE),

                                v.weight(),
                                v.guid]
                        }

                        all.push(s);

                        //提取菜品相关的所有的做法
                        _.each(v.zuofas, function(kv){
                            taoCanZuoFa.push(kv);
                        })
                    });

                }
                //8. 套餐相关 ==》套餐中的菜品所相关的做法
                _.each(taoCanZuoFa, function(v){
                    s  = {
                        query: "update pos_order_caipin_zuofa " +
                        " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?, fenTanSumMoney =?," +
                        " moLingMoney =?, weight =? "+
                        " where guid=?",
                        params: [v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE),
                            v.weight(),
                            _self.guid]
                    }
                    all.push(s);
                });



                posBillingDao.queryTransaction(all).then(function(resultList){

                    //console.log(resultList);

                    JieSuanService.tiaoZhang();
                }, function(err){
                    console.log(err);

                });
            }, 20000) //一定要设置个延迟时间


        });






        //3.圈定需要涉及菜品做法的金额列

        //4.圈定需要涉及的账单的金额列

        //！！！保持支付方式

    }

    function t(){

    }


    /**
     * 取消会员关联
     *
     */
    JieSuanService.confirmCancelHyGuanLian = function(jieSuan, cb){
        var all = [];
        var b  = {
            query: "update pos_billing  " +
            " set cardNo=null, cardMemName =null " +
            "  "+
            " where guid=?",
            params: [jieSuan.getJieSuanGuid()]
        };

        var p = {
            query: "update pos_order  " +
            " set cardNo=null, cardMemName =null " +
            "  "+
            " where jieSuanId=?",
            params: [jieSuan.getJieSuanGuid()]
        };

        all.push(b);
        all.push(p);

        posBillingDao.queryTransaction(all).then(function(resultList){
            jieSuan.resetMember();
            jieSuan.setMember(null);
            cb(null,null);
        }, function(err){
            cb({message:err})

        });

    };




    /*JieSuanService.prepareSQL = function(operator, jieSuan, cb){
        /!* // TODO， 各种校验, 执行下面的逻辑之前，jieSuanNo， 以及banci以及banci必须有值
         //设备信息
         var device = operator.device;
         var memo ="备注。。。";
         var orderId = jieSuan.order.guid;
         var orderNo = jieSuan.order.code;
         var jieSuanNo = jieSuan.getJieSuanNo();
         var jieSuanId = Utils.guid();
         var banci = operator.banCiHao;

         var zhangDanTotal = jieSuan.order.getSumOfZhangDan(); //账单总金额
         var shiShou = jieSuan.order.getYingShou(); //实收必须等于应收。
         var zhaoLing = jieSuan.zhaoLing; //找零金额
         var zheKouTotal = jieSuan.order.calAllZheKou();//折扣总金额
         var fenTanTotal = jieSuan.order.getSumOfFenTan();//分摊总金额
         var moLing = jieSuan.order.getSumOfMoLing();//抹零对象
         var danPinTotal = jieSuan.order.sumOfDanPin(); //计算该账单的单品金额
         var sumOfZhengDanBiLi = jieSuan.order.sumOfZhengDanBiLi(); //该账单引用比例折扣后，所产生的折扣金额

         var cardNo = null;
         var cardMemName = null;
         var tradeNumber = null;//会员交易流水
         var tradeGuid = null;//会员交易GUID
         var mem = jieSuan.getMember();
         if( mem != null){
         cardNo = mem.getCardNo();
         cardMemName = mem.getName();
         tradeNumber = mem.tradeNumber;
         tradeGuid = mem.tradeGuid;
         }


         //比例折扣对象,
         var zheKouCode = null;
         var zheKouAmount = null;
         var zheKouName = null;
         //得到定额折扣对象
         var dingEMoney = null;

         _.each(jieSuan.activeZk, function(e){
         if(e.isOfBiLi()){
         zheKouCode = e.zheKouCode;
         zheKouAmount = e.zheKouAmount;
         zheKouName = e.zheKouName;
         }

         if(e.isDingE()){
         dingEMoney = e.moneyAsStr();
         }

         });
         //
         var now =Utils.now();
         //所有的SQL
         var all = [];


         /!*************************************************************!/
         //1. 结算单
         all.push({
         query: 'insert into pos_billing' +
         '(guid, orderId, orderNo, jieSuanNo,' +
         ' zhangDanTotal, shiShou, zhaoLing,  zheKouTotal, fenTanTotal, moLing, ' +
         'banci,  device, memo, createTime,' +
         'addOperatorId, addOperatorCode, addOperatorName, canBieCode, canBieName,mdId,isFanJieSuan,'+
         'moneyTuiDan,moneyZengSong,moneyZheKou,' +
         ' cardNo, cardMemName, moneyDanPin, ' +
         ' moneyZhengDanBiLi,moneyZhengDanBiLiCode,moneyZhengDanBiLiDiscount, moneyZhengDanBiLiName,' +
         'moneyDingE, ' +
         'tradeNumber, tradeGuid,syn,canbieId ) ' +
         ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? , ?, ?,?,?,?,?,?,?,?,? )',
         params:[jieSuanId, orderId, orderNo,jieSuanNo,

         zhangDanTotal.toFixed(BIZCONSTANT.MONEY_PRECISE),
         shiShou.toFixed(BIZCONSTANT.MONEY_PRECISE),
         zhaoLing.toFixed(BIZCONSTANT.MONEY_PRECISE),
         zheKouTotal.toFixed(BIZCONSTANT.MONEY_PRECISE),
         fenTanTotal.toFixed(BIZCONSTANT.MONEY_PRECISE),
         moLing.getAmount().toFixed(BIZCONSTANT.MONEY_PRECISE),

         banci, device, memo, now,
         operator.id, operator.code, operator.name, jieSuan.order.canBieCode, jieSuan.order.canbieName,
         operator.mdId, BIZCONSTANT.FANJIESUAN_NO,
         jieSuan.order.sumOfTuiCai().toFixed(BIZCONSTANT.MONEY_PRECISE),
         jieSuan.order.sumOfFree().toFixed(BIZCONSTANT.MONEY_PRECISE),
         jieSuan.order.sumOfZheKou().toFixed(BIZCONSTANT.MONEY_PRECISE),
         cardNo,cardMemName,
         danPinTotal,
         sumOfZhengDanBiLi,zheKouCode, zheKouAmount, zheKouName,
         dingEMoney,
         tradeNumber, tradeGuid, 0, jieSuan.order.canbieId
         ]
         });

         /!*************************************************************!/
         //2. 结算单明细
         //2a折扣
         var o = null;
         var seq = 0;
         for( var i = 0; i < jieSuan.activeZk.length; i ++){
         o = jieSuan.activeZk[i]
         all.push({
         query: 'insert into pos_billing_detail' +
         '(guid, bizId, bizCode, bizAmount,bizDesc,type,amount,jieSuanNo,caiWuShuXing,seq,  device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId, jieSuanId) ' +
         ' values (?, ?, ?, ?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?)',
         params:[Utils.guid(), o.zheKouId, o.zheKouCode, o.zheKouAmount, o.zheKouName, o.getType(),
         o.moneyAsStr(),jieSuanNo , o.caiWuShuXing, seq, device, now,
         operator.id, operator.code,operator.name, operator.mdId, jieSuanId]
         });
         seq ++;
         }
         //2b抹零类,如没有抹零则应该为0.反之，则是非零
         all.push({
         query: 'insert into pos_billing_detail' +
         '(guid, bizId, bizCode, bizDesc,type,amount,jieSuanNo,caiWuShuXing,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
         ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
         params:[Utils.guid(), moLing.getID(), moLing.getCode(),  moLing.getName(), moLing.getType(), moLing.getAmount(),jieSuanNo ,moLing.getCaiWuShuXing(),seq, device,  now,
         operator.id, operator.code,operator.name, operator.mdId, jieSuanId]
         });

         //2c 支付方式： 现金类，银行卡，优惠券等
         for( var i = 0; i < jieSuan.payMethodList.length; i ++){
         o = jieSuan.payMethodList[i]
         if( o.isMemberFanZhi() ) //反值的不处理
         continue;

         var pmMoney = o.pmMoneyAsStr();
         var ext1 = null; //用于会员卡反值
         if(o.isMember() &&　o.getRelated()!=null){
         pmMoney = Utils.m(pmMoney) + Utils.m(o.getRelated().pmMoneyAsStr());
         ext1 =  o.getRelated().pmMoneyAsStr();
         }


         all.push({
         query: 'insert into pos_billing_detail' +
         '(guid, bizId, bizCode,bizDesc,type,amount,jieSuanNo,caiWuShuXing,seq,  device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId, ext1) ' +
         ' values (?,  ?, ?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?, ?)',
         params:[Utils.guid(), o.pmId, o.code, o.name, o.getType(), pmMoney,jieSuanNo , o.caiWuShuXing, seq, device, now,
         operator.id, operator.code,operator.name, operator.mdId, jieSuanId, ext1]
         });
         seq ++;
         }


         /!*************************************************************!/
         //3.更新账单以及明细
         //3a.更新账单明细
         var cpList = jieSuan.order.caiPinList;
         var zuoFaList = [];
         var s= null;
         _.each(cpList, function(v){
         s = {
         query:"update pos_order_caipin "+
         " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?," +
         " moLingMoney =?, weight =?, jieSuanTime=? "+
         " where guid=?",
         params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE)
         ,v.weight(),
         now,
         v.guid]
         }
         //提取菜品相关的所有的做法
         _.each(v.zuofas, function(kv){
         zuoFaList.push(kv);
         })
         all.push(s);
         });
         //3b.记录整个账单的结算时间
         all.push({
         query:"update pos_order "+
         " set  jieSuanTime=?, jieSuanOperatorId=?, jieSuanOperatorCode=?,jieSuanOperatorName=?, jieSuanNo=?, jieSuanId=?, isFanJieSuan=?, " +
         "cardNo =? ,cardMemName = ?, tradeNumber = ?, tradeGuid = ?" +
         " where guid=?",
         params:[now, operator.id, operator.code,operator.name,jieSuanNo,jieSuanId, '0', cardNo, cardMemName, tradeNumber,tradeGuid,  orderId ]
         })

         /!*************************************************************!/
         //4.更新做法明细
         _.each(zuoFaList, function(v){
         s= {
         query:"update pos_order_caipin_zuofa "+
         " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?, jieSuanTime=? "+
         " where guid=?",
         params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
         now,
         v.guid]
         }



         all.push(s);
         });


         /!*************************************************************!/
         //5.清台
         s = {
         query: "update pos_zhuotai set orderId = null where orderId = ? ",
         params: [jieSuan.order.guid]
         }
         all.push(s);



         /!*************************************************************!/
         //6.如果是会员，那么需要保存会员信息 TODO,以下信息
         if( jieSuan.getMember() != null ){
         var memberTrans  =jieSuan.getMember().getTrans();
         var mem = jieSuan.getMember();
         var c = 0;
         //会员的凭据信息
         all.push({
         query:'insert into pos_hy_pingju'+
         '(guid,pingJuNo,jieSuanNo,hyCardNo,hyGuid,mdId,createTime,addOperatorId,addOperatorCode,addOperatorName)'+
         'values(?,?,?,?,?,?,?,?,?,?)',
         params:[Utils.guid(),tradeNumber,jieSuanNo,mem.getCardNo(),mem.getGuid(),operator.mdId,now,operator.id,operator.code,operator.name]
         });

         //会员消费明细
         for( var i = 0; i < memberTrans.length; i ++){
         o = memberTrans[i]
         c ++;
         all.push({
         query: 'insert into pos_hy_trans' +
         '(guid, pingJuNo,hyCardNo,hyGuid, jieSuanNo,orderNo,type,amount,paymentMethod,seq,  device, mdId,isDeleted,createTime,addOperatorId, addOperatorCode, addOperatorName) ' +
         ' values (?, ?, ?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?,?,?,?)',
         params:[Utils.guid(), tradeNumber,mem.getCardNo(),mem.getGuid(), jieSuanNo, orderNo, o.getTransTypeDesc(), o.getAmount(), o.pmDesc() , c, device,operator.mdId,mem.getisDeleted(), now,
         operator.id, operator.code,operator.name]
         });
         }
         }




         //7. 套餐相关 ==》如果菜品中包含套餐，那么也需要把分摊也分到套餐明细中
         var fjs = jieSuan.getTaoCanJieSuan();
         var taoCanZuoFa = [];
         for(var key in fjs){
         var fakeJieSuan = fjs[key];
         _.each(fakeJieSuan.order.caiPinList, function(v){
         s = {
         query:"update pos_order_scomb_caipin "+
         " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?,  fenTanSumMoney =?," +
         " moLingMoney =?, weight =?, jieSuanTime=? "+
         " where guid=?",
         params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calFenTan().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calMoLing().toFixed(BIZCONSTANT.MONEY_PRECISE)
         ,v.weight(),
         now,
         v.guid]
         }

         all.push(s);

         //提取菜品相关的所有的做法
         _.each(v.zuofas, function(kv){
         taoCanZuoFa.push(kv);
         })
         });

         }
         //8. 套餐相关 ==》套餐中的菜品所相关的做法
         _.each(taoCanZuoFa, function(v){
         s= {
         query:"update pos_order_caipin_zuofa "+
         " set zheQianMoney=?, shiShouMoney =?, zheKouMoney =?, jieSuanTime=? "+
         " where guid=?",
         params:[v.mRaw().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.calShiShou().toFixed(BIZCONSTANT.MONEY_PRECISE),
         v.mZk().toFixed(BIZCONSTANT.MONEY_PRECISE),
         now,
         v.guid]
         }
         all.push(s);
         });



         //9 班次和账单关联 班次【jbd201601100001】添加一笔新的账单【zd201601100002】
         all.push({
         query:'insert into pos_banci_order'+
         '(guid,banciNo,orderId,orderCode,createTime,addOperatorId,addOperatorCode,addOperatorName)'+
         'values(?,?,?,?,?,?,?,?)',
         params:[Utils.guid(),banci,orderId,orderNo,now,operator.id, operator.code,operator.name]
         });


         return all;*!/
    }*/

    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////



    JieSuanService.seeJiedanTime = function (guid, cb) {
        var sql ="select jieSuanTime from pos_order where guid='" + guid +"'";
        orderDao.query(sql).then(function (res){
            cb(res);
        })

    }

    //检查是否有未上传到云端的已结算账单
    JieSuanService.hasUnSynBilling = function(callback) {
        var sql = "select guid from pos_billing where syn<>1 or syn is null and jieSuanNo is not null limit 1";
        //var deferred = Utils.defer();//$q.defer();
        posBillingDao.query(sql).then(function(res) {
                if(res && res.detail.length > 0) {
                    //deferred.reject({ message: "有未同步到云端的账单！正在上传，请稍后......" });
                    console.info("有未同步到云端的账单！");
                    callback(true);
                    //上传账单......
                    /*DataSyncService.uploadOrder(100,function(result) {
                     if(result == null) {
                     console.info("同步成功！");
                     }else {
                     console.info("同步失败！");
                     }
                     }
                     );*/
                }else {
                    //deferred.resolve(res);
                    callback(false);
                }
            }
        )
    }

    //合并落单的菜品信息
    //相同菜品金额不同不合并 比如：单品折扣 单品赠送 做法加价不一致时
    //多单位菜品，单位不一致时不合并
    //@paramluodanOrderCaipins -> OrderCaipin对象数组
    JieSuanService.mergeLuoDanCaiPin = function(luodanOrderCaipins) {
        var results = [];
        var typeCaiPins = [];
        var left = luodanOrderCaipins.length;
        while(left > 0) {
            var typeCaiPin = [];
            typeCaiPins.push(typeCaiPin);
            for(var i = 0; i < luodanOrderCaipins.length; i++) {
                var caipin = luodanOrderCaipins[i];
                if(typeCaiPin.length <= 0) {
                    typeCaiPin.push(caipin);
                    luodanOrderCaipins.splice(i,1);
                    i--;
                }
                else {
                    var existCaiPin = JieSuanService.getExistCaipin(typeCaiPin, caipin);
                    if(existCaiPin)
                        if(existCaiPin.isScomb == "true" && caipin.isScomb == "true") {
                            if(JieSuanService.isSameScomb(existCaiPin, caipin) == true) {
                                typeCaiPin.push(caipin);
                                luodanOrderCaipins.splice(i,1);
                                i--;
                            }
                        }else {
                            if(JieSuanService.isSameCaiPin(existCaiPin, caipin) == true){
                                typeCaiPin.push(caipin);
                                luodanOrderCaipins.splice(i,1);
                                i--;
                            }
                        }
                }
            }
            left = luodanOrderCaipins.length;
        }
        for(var i= 0; i < typeCaiPins.length; i++) {
            var typeCaiPin = typeCaiPins[i];
            //数量、退单量相加
            var totalNum = 0;
            var totalTuiNum = 0;
            var totalPrice = 0;
            var tuicaiArray = [];
            for(var m = 0; m < typeCaiPin.length; m++) {
                totalNum += typeCaiPin[m].num;
                totalPrice += typeCaiPin[m].price;
                if(typeCaiPin[m].tuiNum && typeCaiPin[m].tuiNum != 0) {
                    totalTuiNum += typeCaiPin[m].tuiNum;
                    var tuis = typeCaiPin[m]._childTuiCaiPin;
                    if(tuis && tuis.length > 0) {
                        _.forEach(tuis, function(o){
                            tuicaiArray.push(o);
                        });
                    }
                }
            }
            // var num = typeCaiPin.length;
            var caipin = typeCaiPin[0];
            caipin._childTuiCaiPin = tuicaiArray;
            caipin.num = totalNum;
            caipin.tuiNum = totalTuiNum;
            //caipin.price = totalPrice;
            // if(caipin.tuiNum && caipin.tuiNum != 0)
            // caipin.tuiNum = caipin.tuiNum *num;
            //caipin.price = caipin.price*num;
            results.push(caipin);
        }
        return results;
    }

    //判断两个套餐是否完全一样
    JieSuanService.isSameScomb = function(scomb1, scomb2) {
        if(scomb1.caipinId != scomb2.caipinId) return false;
        try{
            var scomb1CaiPins = scomb1.scombCaipins; //套餐1菜品明细
            var scomb2CaiPins = scomb2.scombCaipins; //套餐2菜品明细
            if(scomb1.isScomb != "true" || scomb2.isScomb != "true") return false;
            if(scomb1CaiPins.length != scomb2CaiPins.length) return false;
            for(var i in scomb1CaiPins) {
                var scom1caiPin = scomb1CaiPins[i];
                var scom2caiPin = JieSuanService.getCaiPinFromScomByCaiPinId(scom1caiPin.caipinId, scomb2CaiPins);
                if(!scom2caiPin) return false;
                var isSame = JieSuanService.isSameCaiPin(scom1caiPin, scom2caiPin);
                if(isSame == false) return false;
            }
            return true;
        }catch(e) {
        }
        return false;
    }

    //从套餐中获取某个菜品
    JieSuanService.getCaiPinFromScomByCaiPinId = function(caipinId, scombCaiPins) {
        var returnCaiPin = null;
        if(scombCaiPins && scombCaiPins.length > 0 && caipinId && caipinId.length > 0) {
            for(var i = 0; i < scombCaiPins.length; i++) {
                if(caipinId == scombCaiPins[i].caipinId) {
                    returnCaiPin = scombCaiPins[i];
                }
            }
        }
        return returnCaiPin;
    }

    //判断两个菜品是否完全一样
    JieSuanService.isSameCaiPin = function(caipin1, caipin2) {
        try {
            if (caipin1.name == caipin2.name && caipin1.price == caipin2.price && caipin1.unitName == caipin2.unitName && caipin1.isScomb == caipin2.isScomb &&
                caipin1.danPinZheKou == caipin2.danPinZheKou && caipin1.danPinBiLiZheKou == caipin2.danPinBiLiZheKou &&caipin1.tuiNum==caipin2.tuiNum&&
                caipin1.danPinJineZheKou == caipin2.danPinJineZheKou && caipin1.zengNum == caipin2.zengNum && JieSuanService.zuofaIsSame(caipin1, caipin2)) {
                return true;
            }
        }catch(e) {
        }
        return false;
    }

    //判断两个菜品做法是否一样
    JieSuanService.zuofaIsSame = function(caipin1, caipin2) {
        var zuofa1s = caipin1.zuofas;
        var zuofa2s = caipin2.zuofas;
        if(zuofa1s == undefined && zuofa2s == undefined) return true;
        if(zuofa1s == null && zuof2s == null) return true;
        if(zuofa1s != null && zuofa2s != null) {
            if(zuofa1s.length != zuofa1s.length) return false;
            if((zuofa1s.length == zuofa2s.length) && zuofa1s.length == 0) return true;
            for(var i= 0; i < zuofa1s.length; i++) {
                var zuofa1 = zuofa1s[i];
                for(var j = 0; j < zuofa2s.length; j++) {
                    var zuofa2 = zuofa2s[j];
                    if(!zuofa1.equals(zuofa2)) return false;
                }
                return true;
            }
        }else {
            return false;
        }
    }

    //检查菜品数组中是否含有某个菜品
    JieSuanService.getExistCaipin = function(caipins, caipin) {
        if(!caipins || caipins.length <= 0) return null;
        for(var i = 0; i < caipins.length; i++) {
            if(caipins[i].caipinId == caipin.caipinId) return caipins[i];
        }
        return null;
    }

    //快餐-设置牌号
    JieSuanService.setFastPaihao = function(order, paihao, orderZhuotai, cb) {
        var queries = [];
        order.zhuotaiId = paihao;
        order.zhuotaiName = paihao;
        order.zhuotaiCode = paihao;
        queries.push({query:"update pos_order set zhuotaiId='"+ paihao +"', zhuotaiName='"+paihao+"', zhuotaiCode='"+paihao+"' where guid='"+order.guid+"'"});

        orderZhuotai.zhuotaiId = paihao;
        orderZhuotai.zhuotaiCode = paihao;
        orderZhuotai.zhuotaiName = paihao;
        queries.push({query:"update pos_order_zhuotai set zhuotaiId='"+ paihao +"', zhuotaiName='"+paihao+"', zhuotaiCode='"+paihao+"' where guid='"+orderZhuotai.guid+"'"});

        orderDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, order, orderZhuotai);
        }, function (err) {
            return cb(err);
        });

    }

    //快餐-账单落单
    JieSuanService.fastOrderLuodan = function(order,orderCaipins,curUser, cb) {
        if (Utils.isEmpty(orderCaipins)) {
            return cb(null, order);
        }

        var _orderCaipins = GuqingService.buildOrderCaipins(orderCaipins);

        //估清菜品
        GuqingService.LuodanCaipinToGuqing(_orderCaipins, curUser, function (err, result) {
            if (err){
                return cb(err);
            }

            var now = new Date();
            if(Utils.isEmpty(order.code)){
                //获取账单号
                UniqueIDService.nextSeq(now, 'order', function (err, seq, nowdate) {
                    if (err) {
                        return cb(err);
                    }
                    var seqNo = nowdate + Utils.formatSeqNo(seq);
                    var zhangDanNo = "ZD" + seqNo;
                    order.code = zhangDanNo;

                    //落单
                    var queries = [];

                    order.status = BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI;
                    order.modTime = now.format("yyyy-MM-dd hh:mm:ss");
                    order.luoDanTime = now.format("yyyy-MM-dd hh:mm:ss");
                    queries.push({
                        query: "update pos_order set code='" + order.code + "',status=" + order.status + ",modTime='" + order.modTime + "', luoDanTime='" + order.luoDanTime + "', operator='" + curUser.id + "'" +
                        " where guid='" + order.guid + "'"
                    });

                    queries.push({
                        query: "update pos_order_caipin" +
                        " set luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE + "',operator='" + curUser.id + "',luoDanTime='" + now.format("yyyy-MM-dd hh:mm:ss") + "',modTime='" + now.format("yyyy-MM-dd hh:mm:ss") + "'" +
                        " where orderId='" + order.guid + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
                    });

                    orderDao.queryTransaction(queries).then(function (resultList) {
                        cb(null, order);
                    }, function (err) {
                        cb(err);
                    });
                });
            } else {
                //落单
                var queries = [];

                order.status = BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI;
                order.modTime = now.format("yyyy-MM-dd hh:mm:ss");
                order.luoDanTime = now.format("yyyy-MM-dd hh:mm:ss");
                queries.push({
                    query: "update pos_order set code='" + order.code + "',status=" + order.status + ",modTime='" + order.modTime + "', luoDanTime='" + order.luoDanTime + "', operator='" + curUser.id + "'" +
                    " where guid='" + order.guid + "'"
                });

                queries.push({
                    query: "update pos_order_caipin" +
                    " set luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE + "',operator='" + curUser.id + "',luoDanTime='" + now.format("yyyy-MM-dd hh:mm:ss") + "',modTime='" + now.format("yyyy-MM-dd hh:mm:ss") + "'" +
                    " where orderId='" + order.guid + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
                });

                orderDao.queryTransaction(queries).then(function (resultList) {
                    cb(null, order);
                }, function (err) {
                    cb(err);
                });
            }

        });
    }

    //快餐会员结算，保存卡号和卡名称
    JieSuanService.updateCardNoAndName = function (Cno, Cname, orderId){
        var sql = "update pos_order set cardNo = '" + Cno + "', cardMemName = '" + Cname +"' where guid = '" + orderId + "'";
        orderDao.query(sql).then(function (ret) {
            console.log(ret);
        }, function (err) {
            console.log(err);
        })
    }

    JieSuanService.updateHuiYuanId = function (huiYuanId, orderId) {
        var sql = "update pos_order set huiYuanId='" + huiYuanId + "' where guid='" + orderId + "'";
        orderDao.query(sql).then(function (ret) {
            console.log("JieSuanService.updateHuiYuanId.ret : ");
            console.log(ret);
        }, function (err) {
            console.log("JieSuanService.updateHuiYuanId.err : ");
            console.log(err);
        })
    }

    JieSuanService.getNotUseCapinTypeByThirdCouponGuid = function(thirdCouponGuid, callback) {
        var sql = "select caipinDishTypeId from pos_third_coupon_not_use_caipintype where isdeleted='false' and posThirdCouponId='" + thirdCouponGuid + "'";
        orderDao.query(sql).then(function(ret){
            var res = [];
            if(ret && ret.detail.length > 0) {
                for(var i = 0; i < ret.detail.length; i++) {
                    res.push(ret.detail[i].caipinDishTypeId);
                }
            }
            if(callback) return callback(null, res);
        }, function(err){
            if(callback) return callback(err);
        })
    }

    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    return JieSuanService;

}]);