app.factory('AuthService', ['$q', 'database', '$http', "$window", function ($q, database, $http, $window) {
    var authService = {};
    var userInfo;

    //老的登录
    // var baseOperatorDao = new DatabaseFuncDelegate($q, database, 'base_operator');
    //authService.login = function (username, password) {
    //    var deferred = $q.defer();
    //	baseOperatorDao.all("Operator_Code=? and Operator_Status=?", 
    //        [username, 1])
    //    .then(function(rows){
    //        if(rows.length < 1){
    //            deferred.reject({message:"非法的用户名/密码"});
    //        }
    //        else{
    //            userInfo = rows[0];
    //            //if(userInfo.Operator_Password.toLowerCase() != hex_md5(password).toLowerCase()){
    //            //    deferred.reject({message:"非法的用户名/密码"});
    //            //}
    //            //else {
    //                userInfo.accessToken = ""+(new Date()).getTime();
    //                $window.sessionStorage["userInfo"] = JSON.stringify(userInfo);
    //                deferred.resolve(userInfo);
    //            //}
    //        }
    //    });      
    //    return deferred.promise;
    //}

    //新的登录方式
    var baseOperatorDao = new DatabaseFuncDelegate($q, database, 'pos_person');

    authService.login = function (username, password) {
        var deferred = Utils.defer();//$q.defer();
        baseOperatorDao.all("personNo=? and personStatus=?", [username, 1])
        .then(function (rows) {
            if (rows.length < 1) {
                deferred.reject({ message: "错误的用户名/密码" });
            }
            else if (rows[0].password != password) {
                deferred.reject({ message: "错误的用户名/密码" });
            }else{

                userInfo = rows[0];
                if (userInfo.deviceName && userInfo.deviceName.length > 0 && userInfo.deviceName != Utils.DeviceName()&&userInfo.lastLoginTime&&((new Date()-new Date(userInfo.lastLoginTime))<18e4))
                    deferred.reject({ message: "该账号已在" + userInfo.deviceName + "上登录，请先退出登录状态" });
                else
                {
                    var upsql = "update pos_person set deviceName='" + Utils.DeviceName() + "',lastLoginTime=datetime('now','localtime') where guid='" + userInfo.guid + "'";
                    baseOperatorDao.query(upsql);
                    userInfo.accessToken = "" + (new Date()).getTime();
                    $window.sessionStorage["userInfo"] = JSON.stringify(userInfo);
                    deferred.resolve(userInfo);
                }
            }
        });
        return deferred.promise;
    }

    //无线登录
    authService.wxlogin = function (username, password) {
        var deferred = Utils.defer();//$q.defer();
        baseOperatorDao.all("personNo=? and personStatus=?", [username, 1])
        .then(function (rows) {
            if (rows.length < 1) {
                deferred.reject({ message: "错误的用户名/密码" });
            }
            else if (rows[0].password != password) {
                deferred.reject({ message: "错误的用户名/密码" });
            } else {

                userInfo = rows[0];
                //userInfo.accessToken = "" + (new Date()).getTime();
                deferred.resolve(userInfo);
            }
        });
        return deferred.promise;
    }


    authService.xgpwd = function (username, opwd,npwd) {
        var deferred = Utils.defer();//$q.defer();

        authService.wxlogin(username, opwd).then(function (userInfo) {
            userInfo = Utils.clone(userInfo);
            userInfo.password = npwd;
            baseOperatorDao.updateObject(userInfo, "guid").then(function (result) {
                deferred.resolve(userInfo);
            }, function (err) { deferred.reject(err); });
        }, function (err) {
            deferred.reject(err);
        });

      
        return deferred.promise;
    }


    //获取权限功能
    var personRoleDao = new DatabaseFuncDelegate($q, database, 'pos_person_role');
    var personFunDao = new DatabaseFuncDelegate($q, database, 'pos_person_func_mission');

    // 获取所有功能高级配置
    authService.getActConfig = function (cb) {
        var sql = "SELECT * FROM pos_system_config WHERE valueType = 'xs'";
        baseOperatorDao.query(sql).then(function (res) {
            cb(null,res.detail);
        }, function (err) {
            cb(e)
        })

    }

    // 获取所有功能高级配置
    //authService.getDdyNum = function (cb) {
    //    var sql = "SELECT count(status) num FROM printer_job WHERE status=2 and error_count >3";
    //    baseOperatorDao.query(sql).then(function (res) {
    //        cb(null,res.detail);
    //    }, function (err) {
    //        cb(e)
    //    })
    //
    //}


    authService.getFuncPermissions = function (userid) {
        var deferred = Utils.defer();//$q.defer();
        var roleId="";
        var roleIds = [];
        personRoleDao.all("userid=?", [userid])
            .then(function (rows) {
                    if (rows.length < 1) {
                        deferred.reject({ message: "无权限" });
                    }else{
                        // roleId = rows[0].roleid;
                        for(var i = 0; i < rows.length; i++) {
                            roleIds.push("'" + rows[i].roleid + "'");
                        }
                        if(roleIds.length > 0) {
                            roleId = "(" + roleIds.join(",") + ")";
                        }
                    }
            }).then(function (e){
                if(roleId.length > 0)
                personFunDao.query("select * from pos_person_func_mission where userId in " + roleId).then(function (rows){
                    var rolesStr = "";
                    var rolearr = [];
                    for (var j=0; j<rows.detail.length;j++) {
                        //rolesStr = rolesStr + "," + rows[j].operateId;
                        var row = rows.detail[j];
                        var existOperateId = row.operateId;
                        if(existOperateId && rolearr.indexOf(existOperateId) >= 0)
                            continue;
                        rolearr.push(existOperateId);
                    }
                    deferred.resolve(rolearr);
                })

            });
        return deferred.promise;
    }

    authService.refreshLoginTime = function (cb)
    {
        var userInfo = authService.getUserInfo();
        if (!userInfo)
            return;
        var upsql = "update pos_person set lastLoginTime=datetime('now','localtime') where guid='" + userInfo.guid + "' AND deviceName='" + Utils.DeviceName() + "'";
        baseOperatorDao.query(upsql).then(function (res) {
            var affectrow = res.rowsAffected[0] > 0;
            if (cb)
                cb(null,affectrow);
        }, function (err) {
            if (cb)
                cb(err);
        });
    }

    function hash512(pwd, key,intor)
    {
        if (intor == 0)
            return pwd;


        var hmacObj = new jsSHA('SHA-512','TEXT');
        hmacObj.setHMACKey(key,'HEX');
        hmacObj.update(pwd);

        var hash = hmacObj.getHMAC('HEX');
        return hash512(hash,key, intor - 1);
    }

    authService.logout = function () {
        var deferred = Utils.defer();//$q.defer();
        $window.setTimeout(function () {
            userInfo = null;
            $window.sessionStorage["userInfo"] = null;
            
            deferred.resolve({ status: 'success' });
        }, 100);
        return deferred.promise;
    }

    authService.getUserInfo = function () {
        init();
        return userInfo;
    }

    //关闭窗口、营业员主动注销账号时清除当前用户信息
    authService.clearCurrentLoginInfo = function(callback) {
        var currentUserId = BIZCONSTANT.POSUSER.id;
        if(currentUserId && currentUserId.length > 0) {
            var operatorId = BIZCONSTANT.POSUSER.id + Utils.DeviceName();
            var sql = "update pos_zhuotai set operatorId=null, operatorName=null where  operatorId='" + operatorId + "'";
            var zhzxsql = "update pos_person set deviceName=null,lastLoginTime=null,clientName=null where guid='" + BIZCONSTANT.POSUSER.id + "' AND deviceName='" + Utils.DeviceName() + "'";
            var sqlarr = [];
            sqlarr.push({ query: sql });
            sqlarr.push({ query: zhzxsql });
            console.log(sqlarr);
            baseOperatorDao.queryTransaction(sqlarr).then(function (ret) {
                console.info("注销用户成功！")
                BIZCONSTANT.POSUSER = null;
                if(callback)return callback(ret);
            },function(err){
                console.info("注销用户失败！")
                if(callback)return callback(err);
            })
        }else {
            return callback(null);
        }
    }

    function init() {
        if ($window.sessionStorage["userInfo"]) {
            userInfo = JSON.parse($window.sessionStorage["userInfo"]);
        }
    }

    init();



    return authService;
}]);