﻿app.factory("OrderCaipinKouweiService", ["$q", "database","$rootScope",  function ($q, database, $rootScope) {
    var OrderCaipinKouweiService = {};

    var orderCaipinKouweiDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_kouwei');


  
    OrderCaipinKouweiService.updateOrderCaipinKouweis = function (orderCaipin, orderCaipinKouweis, cb) {
        var queries = [];

        var orderScombCaipinId = null == orderCaipin.isScomb ? null : "true" == orderCaipin.isScomb ? orderCaipin.guid : null;
        var orderCaipinId;

        if(orderCaipin.isScombCaipin()){
            orderCaipinId =  orderCaipin.orderCaipinId;
        } else {
            orderCaipinId = orderCaipin.guid;
        }        

        var deleteSql = "delete from pos_order_caipin_kouwei ";
        if (orderScombCaipinId != null) {
            deleteSql = deleteSql + " where orderScombCaipinId='" + orderCaipin.guid + "'";
        } else {
            deleteSql = deleteSql + " where orderCaipinId='" + orderCaipin.guid + "'";
        }

        queries.push({ query: deleteSql });
        for (var idx in orderCaipinKouweis) {
            orderCaipinKouweis[idx].guid = orderCaipinKouweis[idx].guid == null ? orderCaipinKouweiDao.guid() : orderCaipinKouweis[idx].guid;
            queries.push({
                query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb,orderScombCaipinId)" +
                " values(?, ?, ?, ?, ?, ?,?,?)",
                params: [orderCaipinKouweis[idx].guid, orderCaipinId, orderCaipinKouweis[idx].kwId, orderCaipinKouweis[idx].name,
                    orderCaipinKouweis[idx].operator, orderCaipinKouweis[idx].modTime, orderCaipin.isScomb, orderScombCaipinId]
            });
        }
        orderCaipinKouweiDao.queryTransaction(queries).then(function (resultList) {
          return   cb(null, orderCaipinKouweis);
        }, function (err) {
           return  cb(err);
        });
    };

    OrderCaipinKouweiService.addOrderCaipinKouwei = function (orderCaipin, kouwei, cb) {
        var queries = [];

        var orderScombCaipinId = null == orderCaipin.isScomb ? null : "true" == orderCaipin.isScomb ? orderCaipin.guid : null;
        var orderCaipinId;

        if(orderCaipin.isScombCaipin()){
            orderCaipinId =  orderCaipin.orderCaipinId;
        } else {
            orderCaipinId = orderCaipin.guid;
        }

        var orderCaipinKouwei = new OrderCaipinKouwei();
        orderCaipinKouwei.guid = orderCaipinKouweiDao.guid();
        orderCaipinKouwei.orderCaipinId = orderCaipinId;
        orderCaipinKouwei.kwId = kouwei.guid;
        orderCaipinKouwei.name = kouwei.kwName;
        orderCaipinKouwei.operator = $rootScope.curUser.id;
        orderCaipinKouwei.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        orderCaipinKouwei.isScomb = orderCaipin.isScomb;
        orderCaipinKouwei.orderScombCaipinId = orderScombCaipinId;

        queries.push({
            query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb,orderScombCaipinId)" +
            " values(?, ?, ?, ?, ?, ?,?,?)",
            params: [orderCaipinKouwei.guid, orderCaipinKouwei.orderCaipinId, orderCaipinKouwei.kwId, orderCaipinKouwei.name,
                orderCaipinKouwei.operator, orderCaipinKouwei.modTime, orderCaipinKouwei.isScomb, orderCaipinKouwei.orderScombCaipinId]
        });

        orderCaipinKouweiDao.queryTransaction(queries).then(function (res) {
            return   cb(null, orderCaipinKouwei);
        }, function (err) {
            return  cb(err);
        });
    }

    OrderCaipinKouweiService.removeOrderCaipinKouwei = function (orderCaipin, kouwei, cb) {
        var queries = [];

        var orderScombCaipinId = null == orderCaipin.isScomb ? null : "true" == orderCaipin.isScomb ? orderCaipin.guid : null;
        var orderCaipinId;

        if(orderCaipin.isScombCaipin()){
            orderCaipinId =  orderCaipin.orderCaipinId;
        } else {
            orderCaipinId = orderCaipin.guid;
        }

        var deleteSql = "delete from pos_order_caipin_kouwei ";
        if (orderScombCaipinId != null) {
            deleteSql = deleteSql + " where orderScombCaipinId='" + orderCaipin.guid + "' and kwId='"+kouwei.guid+"'";
        } else {
            deleteSql = deleteSql + " where orderCaipinId='" + orderCaipin.guid + "' and kwId='"+kouwei.guid+"'";
        }

        queries.push({ query: deleteSql });

        orderCaipinKouweiDao.queryTransaction(queries).then(function (res) {
            return   cb(null);
        }, function (err) {
            return  cb(err);
        });
    }

    return OrderCaipinKouweiService;
}])