app.factory('PingService', ['$q', 'database', '$http', "$window", "$rootScope", function ($q, database, $http, $window, $rootScope) {
    var PingService = {};

    var pos_url = SERVER_HOST.BASE_HOST+API_CONTEXT.POS;

    //pingServer url
    var ping_url = "/api/v1/pos_terminal/ping?t=&token=123";

    //upgrade pos terminal url
    var upgrade_url = "/api/v1/pos_terminal/upgrade?t=1&token=123&5655444";

    var obj = new Object();

    PingService.pingServer = function () {
        obj.messageData = null;
        return PingService.postToServer(ping_url, obj);
    }

    PingService.upgrade = function (dataStr) {
        obj.messageData = dataStr;
        return PingService.postToServer(upgrade_url, obj);
    }

    PingService.postToServer = function (url, obj) {
        if (CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS) {
            var os = null;
            if(!obj.name) {
                os = require("os");
                var iconv = require('iconv-lite');
                var hostname = iconv.decode(os.hostname(), 'gb2312');
                obj.name = hostname;
            }
            if(!obj.ip) {
                if(!os) os = require("os");
                var interfaces = os.networkInterfaces();
                var addresses = [];
                for (var k in interfaces) {
                    for (var k2 in interfaces[k]) {
                        var address = interfaces[k][k2];
                        //console.log(address);
                        if (address.family === 'IPv4' && !address.internal) {
                            addresses.push(address.address);
                        }
                    }
                }

                obj.ip = addresses[0]; //默认取第一个
            }
            if(!obj.os) obj.os = "win";
            obj.udid = null;
            if(!obj.mac) {
                var os = require("getmac");
                os.getMac(function (err, macAddress) {
                    //if (err) {
                    //    $.maskLoader("hide");
                    //    return Utils.showFailureInfo("无法注册，获取不到机器MAC！");
                    //}
                    obj.mac = macAddress;
                    return callWorker(url, obj);
                });
            }else {
                return callWorker(url, obj);
            }
        } else {
            if (CONTEXT.env == CONSTANTS.EnvConstants.ANDROID) {
                if(!obj.name) obj.name = AndroidAdapter.getDeviceName();
                if(!obj.ip) obj.ip = AndroidAdapter.getIp();
                if(!obj.os) obj.os = "android";
                if(!obj.udid) obj.udid = AndroidAdapter.getUdid();
                if(!obj.mac) obj.mac = AndroidAdapter.getMacAddress();
            }else if (CONTEXT.env == CONSTANTS.EnvConstants.IOS) {
                if(!obj.name) obj.name = IOSAdapter.getDeviceName();
                if(!obj.ip) obj.ip = IOSAdapter.getIp();
                if(!obj.os) obj.os = "ios";
                if(!obj.udid) obj.udid = IOSAdapter.getUdid();
                if(!obj.mac) obj.mac = IOSAdapter.getMacAddress();
            }
            return callWorker(url, obj);
        }
    }

    function callWorker(url, obj) {
        if(!obj.sbversion) {
            if(CONTEXT.env == CONSTANTS.EnvConstants.ANDROID){
                return;
            }
            var regedit = require('regedit');
            regedit.list(['HKCU\\SOFTWARE\\IEASY360\\YUNSHAN\\AutoUpdater'])
                .on('data', function(entry) {
                    try{
                        obj.sbversion = entry.data.values['version'].value;
                    }catch(ex){
                    }
                    return doRequest(url, obj);
                })
        }else {
            return doRequest(url, obj);
        }

    }

    function doRequest(url, obj) {
        var request = BIZCONSTANT.POSUSER.json4common(obj);
        var postStr = JSON.stringify(request);
        console.info("PingService.doRequest.postStr : " + postStr);
        $.ajax({
            type: "POST",
            url: pos_url + url,
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: postStr,
            success: function (response) {
                console.info("PingService.doRequest.success : " + response);
            },
            error: function (error, data, errorThrown) {
                console.info("PingService.doRequest.error : " + error + ", " + data + ", " + errorThrown);
            }
        });
    }


    return PingService;
}]);