﻿app.factory('PrintReportService', ['$q', 'database', '$http', "$window", function ($q, database, $http, $window) {
    var PrintReportService = {};

    var jobDao = new DatabaseFuncDelegate($q, database, 'printer_job');
    var jobLogDao = new DatabaseFuncDelegate($q, database, 'printer_job_log');
    var printerDao = new DatabaseFuncDelegate($q, database, 'printer');

    var printers = {};


    PrintReportService.jiankong = function (callback) {
        var sql = "select c.guid guid,c.name name,c.code code,c.size size,c.status status,d.value address,IFNULL(e.c,0) ddy ,IFNULL(f.c,0) ydy ,IFNULL(g.c,0) wdy from(  " +
         " select a.* from printer a left join printer_config b on a.guid=b.printer_id where b.value='network' or b.value='system' " +
        " ) c LEFT JOIN printer_config d on c.guid=d.printer_id " +
        " LEFT JOIN (select printer_id,count(printer_id) c from printer_job where status=0 AND datetime(createTime,'localtime')>datetime((date('now')),'localtime') GROUP BY printer_id " +
        " ) e on c.guid=e.printer_id " +
        "LEFT JOIN (select printer_id,count(printer_id) c from printer_job where status=2 AND error_count>3 AND datetime(createTime,'localtime')>datetime((date('now')),'localtime')" +
        "GROUP BY printer_id  ) g on c.guid=g.printer_id" +
         " LEFT JOIN (select final_printer_id,count(final_printer_id) c from printer_job where status=1 AND datetime(createTime,'localtime')>datetime((date('now')),'localtime') GROUP BY final_printer_id " +
         " ) f on c.guid=f.final_printer_id " +
       " where d.name='host' or d.name='printerName'  ORDER BY code";
        printerDao.query(sql)
			.then(function (result) {
			    if (result.detail != null) {
			        var arr = [];
			        for (var i = 0; i < result.detail.length; i++) {
			            var row = result.detail[i];
			            arr.push(row);
			        }
			        callback(arr);
			    }
			});
    }

    PrintReportService.yichangdanju = function (queryParamBean, callback) {
        // var sql = "select a.guid lsid,a.createTime dytime,a.ref,a.name,a.job_no,a.status pgStatus, b.* from printer_job a left join pos_order b on a.order_id=b.guid where datetime(a.createTime,'localtime')>datetime((date('now')),'localtime')";
        var sql = "select a.guid lsid,a.createTime dytime,a.ref,a.name,a.job_no,a.status pgStatus, a.invoice_code danJuType, b.* from printer_job a left join pos_order b on a.order_id=b.guid where ";
        var whereSql = "";
        if(queryParamBean) {
            if(queryParamBean.zhuoTaiName && queryParamBean.zhuoTaiName.length > 0) {
                whereSql += " b.zhuotaiName like '%" + queryParamBean.zhuoTaiName + "%' and ";
            }
            if(queryParamBean.caiPinName && queryParamBean.caiPinName.length > 0) {
                whereSql += " b.guid in (select DISTINCT(orderId) from pos_order_caipin where name like '%"+queryParamBean.caiPinName+"%') and ";
            }
            if(queryParamBean.danJuType && queryParamBean.danJuType != "000") {
                whereSql += " a.invoice_code='" + queryParamBean.danJuType + "' and ";
            }
            if(queryParamBean.dateTime1 && queryParamBean.dateTime1.length > 0) {
                whereSql += " a.createTime>= '" + queryParamBean.dateTime1  + "' and ";
            }
            if(queryParamBean.dateTime2 && queryParamBean.dateTime2.length > 0) {
                whereSql += " a.createTime <= '" + queryParamBean.dateTime2  + "' and ";
            }
            if(!queryParamBean.dateTime1 && !queryParamBean.dateTime2) {
                if(queryParamBean.date && queryParamBean.date.length > 0) {
                    whereSql += " a.createTime >= '" + queryParamBean.date + "' and a.createTime < '" + queryParamBean.date + " 60:00:00' and ";
                }
            }
            sql += whereSql;
        }else {
            sql += " datetime(a.createTime,'localtime')>=datetime((date('now')),'localtime') and ";
        }
        sql += " 1 = 1 ORDER BY b.luoDanTime DESC";

        console.info("PrintReportService.yichangdanju.sql : " + sql);
        printerDao.query(sql)
           .then(function (result) {
               if (result.detail != null) {
                   var arr = [];
                   for (var i = 0; i < result.detail.length; i++) {
                       var row = result.detail[i];
                       arr.push(row);
                   }
                   callback(arr);
               }
           });
    }

    PrintReportService.reprint = function (arr)
    {
        if(arr.length==0)
            return;
        var inwhere='';
        for(var i in arr)
        {
            inwhere+="'"+arr[i]+"' ,";
        }
        inwhere=inwhere.substr(0, inwhere.length - 1);
        var sql = "update printer_job set status=0,processing=0,error_count=0 where guid in (" + inwhere + ")";
        jobDao.query(sql);
    }

    return PrintReportService;
}]);