/**
 * Created by jisheng on 24 Mar 2016.
 */

app.factory("SyncDataService", ['$q', 'database', 'AjaxLogger', 'PrintService', 'JieSuanService', 'WeiXinService','EntityNameMapService','HandlerNetworkOrder','AuthService',
    function ($q, database, AjaxLogger, PrintService, JieSuanService, WeiXinService, EntityNameMapService, HandlerNetworkOrder, AuthService) {

        var testWeixin = false; //使用季老板测试环境
        var showLog = true;
        var SyncDataService = {};
        var pos_url = SERVER_HOST.BASE_HOST+API_CONTEXT.POS;
        var hqURL = SERVER_HOST.BASE_HOST + API_CONTEXT.BASIC;
        var wxURL = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN;
        var currentUser = new PosUser()

        SyncDataService.logTopicInfo = function (topic){
            currentUser.mdId=topic;
            AjaxLogger.log(currentUser, "KAFKA TOPIC", JSON.stringify({ "topic": topic }), "");
        }

        SyncDataService.updateData= function (json) {
            var jsonStrData = json;
            if(showLog)
            console.info("received json str : " + jsonStrData);
            var obj =JSON.parse(jsonStrData);
            var baseOperatorflag = obj.baseOperator;
            var url = pos_url + POS_API_URL.KAFKA_POS_SYN_URL;//"/api/v1/pos/sync?t=&token=";

            if (baseOperatorflag == "Y") {
                url = hqURL + POS_API_URL.KAFKA_BASE_SYN_URL;//"/api/v1/sync?t=&token=";
            } else if (baseOperatorflag == "W")
            {
                url = wxURL + WEIXIN.KAFKA_SYN_URL;//'/api/v1/weixinSyncData/sync';
                if(testWeixin) {//测试地址
                    url = "http://" + VALIDATE_TOKEN_HOST[1].HOST_BASIC + "/yunshan-weixin-api"  + '/api/v1/weixinSyncData/sync';
                }

            }
            var isChainCaiPin = false;
            var caiPuId = null;
            if(obj.isChain && obj.isChain == "Y") {
                AjaxLogger.log(currentUser, "msgCenter incoming data...", json, "","");
                isChainCaiPin = true;
                //将entityNameMap和dataNameInfo保存到数据表pos_entitynamemap中
                var entityObjs = SyncDataService.parseTopic(obj);
                EntityNameMapService.save(entityObjs, function(ret){
                    console.info(ret);
                });
            }else {
                SyncDataService.ajaxSyn(jsonStrData, url, null, null, null);
            }
        };

        //更新连锁资料
        SyncDataService.updateChainData = function(ret, caiPuGuid, callback) {
            var url = pos_url+"/api/v1/pos/sync?t=&token=";
            if(ret && ret.detail.length > 0) {
                var returnEntity = new ReturnEntity();
                var redisIdSet = ret.detail[0].redisIdSet.split(",");
                returnEntity.entityNameMap = {};
                returnEntity.redisIdMap = {};
                returnEntity.redisIdSet = redisIdSet;
                for(var i = 0; i < ret.detail.length; i++) {
                    returnEntity.groupId = BIZCONSTANT.POSUSER.groupId;
                    returnEntity.groupCode = BIZCONSTANT.POSUSER.groupCode;
                    returnEntity.orgid = BIZCONSTANT.POSUSER.mdId;
                    var entityType = ret.detail[i].entityType;
                    var entityGuids = ret.detail[i].entityGuids.split(",");
                    var redisIds = ret.detail[i].redisIds.split(",");
                    setKeyValue(returnEntity.entityNameMap, entityType, entityGuids);
                    setKeyValue(returnEntity.redisIdMap, entityType, redisIds);
                }
                var str = JSON.stringify(returnEntity);
                if(showLog)
                console.info("pos str : " + str);
                SyncDataService.ajaxSyn(str, url, callback, caiPuGuid, true);
            }
        }

        SyncDataService.ajaxSyn = function(jsonStrData, url, callback, caiPuGuid, isChain) {
            jQuery.ajax({
                type:"POST",
                url:url,
                dataType:"json",
                data : jsonStrData,
                contentType:"application/json; charset=utf-8",
                success:function(response){
                    AjaxLogger.log(currentUser, "后台数据同步", jsonStrData, JSON.stringify(response),this.url);
                    if (JSON.stringify(response.dataList) == undefined){
                        console.info("服务端获取数据失败： " +JSON.stringify(response));
                        return callback("err");
                    }else{
                        if(showLog)
                        console.info("服务端获取数据成功： " +JSON.stringify(response));
                    }
                    var updateTabelName="";
                    try {
                        if(!Utils.isEmpty(response.dataList)) {
                            for (var idx in response.dataList) {
                                var data = [];
                                var ids;
                                var tableName = response.dataList[idx].entityName;
                                updateTabelName = tableName;
                                if(showLog)
                                console.info("tableName : " + tableName);
                                var db = new DatabaseFuncDelegate($q, database, tableName);

                                if(showLog)
                                console.log(tableName+"Data："+JSON.stringify(response));
                                if (tableName == "pos_caipin") {
                                    //updateCaipin(response, db, jsonStrData, $q, database, tableName,idx, callback);
                                    newUpdateCaipin(response, db, jsonStrData, $q, database, tableName,idx, callback, caiPuGuid, isChain);
                                } else if (tableName == "pos_person") {
                                    updatePosPerson(response, db, jsonStrData, $q, database, tableName,idx, callback);
                                } else if (tableName == "printer") {
                                    updatePrinter(response, db, jsonStrData, $q, database, tableName,idx, callback);
                                } else if (tableName == "pos_person_pos_mission") {
                                    updatePosPermission(response, db, jsonStrData, $q, database, tableName,idx, callback);
                                } else if (tableName == "pos_person_func_mission") {
                                    updateFuncPermission(response, db, jsonStrData, $q, database, tableName,idx, callback);
                                } else if (tableName == "weixin_order_kfk") {
                                    //deleteRedisData(setRedisType(jsonStrData, tableName));
                                    // HandlerNetworkOrder.update(response.dataList[idx].dataList)

                                    WeiXinService.update(response.dataList[idx].dataList);
                                } else if (tableName == "pos_zhuotai"){ //桌台特殊处理，如果存在的时候，保留原先的定单号
                                    updatePosZhuotai(response, db, jsonStrData, $q, database, tableName, idx, callback);
                                } else if (tableName == "pos_consumption_type"){ //消费类型
                                    updateConsumeTypeInfo(response, db, jsonStrData, $q, tableName, idx, callback);
                                }
                                else {
                                    if (!Utils.isEmpty(response.dataList[idx].dataList)) {
                                        var allsqls = [];
                                        if (tableName == "pos_canbie") {
                                            allsqls.push({query: "delete from " + tableName, params: []});
                                        }
                                        var entityGuids = [];
                                        for (var idx2 in response.dataList[idx].dataList) {
                                            var data=[];
                                            data.push(_buildModelData(tableName, response.dataList[idx].dataList[idx2]));
                                            var id = getId(response.dataList[idx].dataList[idx2]);
                                            entityGuids.push("'" + id + "'");
                                            if (tableName == "pos_print_caipin") {
                                                var caipinId = response.dataList[idx].dataList[idx2].caipinId;
                                                allsqls.push({
                                                    query: "delete from " + tableName + " where caipinId=?",
                                                    params: [caipinId]
                                                });
                                            } else if (tableName != "pos_print_caipin" && tableName != "pos_canbie") {
                                                var deletesql = {
                                                    query: "delete from " + tableName + " where guid=?",
                                                    params: [id]
                                                };
                                                allsqls.push(deletesql);
                                            }
                                            if(tableName == "pos_third_coupon") {
                                                //pos_third_coupon_not_use_caipintype表删除
                                                var delete_pos_third_coupon_not_use_caipintype = {
                                                    query: "delete from pos_third_coupon_not_use_caipintype where posThirdCouponId=?",
                                                    params:[id]
                                                }
                                                allsqls.push(delete_pos_third_coupon_not_use_caipintype);
                                                //pos_third_coupon_not_use_caipintype表新增
                                                var notApplicableCaipinTypes = response.dataList[idx].dataList[idx2].notApplicableCaipinType;
                                                if(notApplicableCaipinTypes && notApplicableCaipinTypes.length > 0) {
                                                    var isDeleted = response.dataList[idx].dataList[idx2].deleted;
                                                    if(isDeleted) {
                                                        isDeleted = "true";
                                                    }else {
                                                        isDeleted = "false";
                                                    }
                                                    for(var i = 0; i < notApplicableCaipinTypes.length; i++) {
                                                        var insertSql = {
                                                            query: "insert into pos_third_coupon_not_use_caipintype values (?,?,?,?)",
                                                            params:[Utils.guid(), notApplicableCaipinTypes[i], id, isDeleted]
                                                        }
                                                        allsqls.push(insertSql);
                                                    }
                                                }
                                            }

                                            for (var idx3 in data) {
                                                var data2 = data[idx3];
                                                if ( tableName =='pos_area') {
                                                    if (data2.areaCode != null && data2.areaCode != undefined) {
                                                        allsqls.push({
                                                            query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                                                            params: []
                                                        });
                                                    }
                                                }else if(tableName == "pos_third_coupon") {
                                                    if(data2.isdeleted != undefined && data2.isdeleted != "true") {
                                                        allsqls.push({
                                                            query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                                                            params: []
                                                        });
                                                    }
                                                }
                                                else{
                                                    allsqls.push({
                                                        query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                                                        params: []
                                                    });
                                                }
                                            }
                                        }

                                        if(isChain && isChain == true)
                                        if(entityGuids.length > 0) {
                                            var updateSql = "update pos_entitynamemap set status=2 where status=1 and entityGuid in (" + entityGuids.join(",") + ")";
                                            allsqls.push({query:updateSql,
                                            params:[]
                                            })
                                        }

                                        if (allsqls.length > 0) {
                                            var callbackF = function(resultList) {
                                                console.log(this.success.tableName + "更新成功");
                                                deleteRedisData(setRedisType(this.success.jsonStrData, this.success.tableName));
                                                if (this.success.tableName == 'pos_cai_wu_ke_mu' ||this.success.tableName == 'pos_third_coupon')
                                                {
                                                    //重新加载付款方式
                                                    JieSuanService.getCaiWuKeMu(function (err, model) {
                                                        if (err) {
                                                            return Utils.showFailureInfo(err.message);
                                                        }
                                                        BIZCONSTANT.ALLPMs = model;
                                                        Utils.sendBroadcast({ action: "updateCaiWuKeMu"});
                                                    });
                                                }

                                                if (this.success.tableName == 'pos_sys_print_receipt_template') {
                                                    //重新加载打印模板
                                                    PrintService.allPrintTemplate(function (result) {
                                                        BIZCONSTANT.ALLPRINTTEMPLATE = result;
                                                        Utils.sendBroadcast({ action: "updatePrintTemplate" });
                                                    });
                                                }

                                                if(callback) return callback(true);

                                            }
                                            callbackF.tableName = tableName;
                                            callbackF.jsonStrData = jsonStrData;
                                            db.queryTransaction(allsqls).then(callbackF, function (err) {
                                                console.log(callbackF.tableName + "更新失败" + err);
                                            });
                                        }
                                    }
                                }
                            }
                        }else{
                            console.info("该TOPIC对应的ID，服务端无数据返回： " +JSON.stringify(response));
                            if(callback) return callback(true);
                        }

                    }catch(e){
                        console.info("更新表："+updateTabelName+" 失败,错误信息："+ e.message);
                        AjaxLogger.log(currentUser, "后台数据同步失败，表"+updateTabelName, jsonStrData, e.message,this.url);
                        if(callback) return callback(true);
                    }
                    if(callback) {
                        return callback(true);
                    }
                },
                error:function(error,data,errorThrown){
                    console.info("服务端获取数据失败： " +error);
                    AjaxLogger.error(error.status, "AJAX后台数据同步error", jsonStrData, error.responseText, this.url);
                    if(callback) return callback(true);
                }
            });
        }
             
        SyncDataService.test = function () {
            var response = { "status": "success", "msg": null, "data": null, "dataList": [{ "entityName": "pos_zhuotai", "dataList": [{ "guid": "29696ae1-d58c-4e57-a106-7aa54e7b4918-zt", "groupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "groupIdType": 2, "addGroupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "addGroupIdType": 2, "addTime": 1465967846000, "addUser": "sys", "modTime": 1466669346000, "modUser": "sys", "addUserId": "sys", "modUserId": "a8ac2592-1f69-478d-8a0e-faadd16601c0", "orgid": "29696ae1-d58c-4e57-a106-7aa54e7b4918", "groupCode": "10092", "originalOrgId": null, "isChainIndicate": null, "orderNo": "999", "name": "测试台", "quickCode": "cst", "canweishu": 5, "areaId": "faea0fbf-5e10-4dc4-ad4b-cae5482e6e54", "areaName": "包间", "enabled": true, "isSystemBuild": false, "deleted": false }], "cpinfoList": [] }, { "entityName": "pos_cai_wu_ke_mu", "dataList": [{ "guid": "29696ae1-d58c-4e57-a106-7aa54e7b4918-js", "groupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "groupCode": "10092", "groupIdType": 2, "addGroupId": "sys", "addGroupIdType": 4, "addTime": 1465967846000, "addUser": "sys", "modTime": 1466669232000, "modUser": "sys", "addUserId": "sys", "modUserId": "sys", "orgid": "29696ae1-d58c-4e57-a106-7aa54e7b4918", "caiWuCode": "02", "caiWuName": "酒水", "enabled": null, "isSystemBuild": false, "deleted": false }], "cpinfoList": [] }, { "entityName": "pos_zuofa_type", "dataList": [{ "guid": "29696ae1-d58c-4e57-a106-7aa54e7b4918-js", "groupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "groupCode": "10092", "groupIdType": 2, "addGroupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "addGroupIdType": 2, "addTime": 1465967846000, "addUser": "sys", "modTime": 1466669226000, "modUser": "sys", "addUserId": "sys", "modUserId": "a8ac2592-1f69-478d-8a0e-faadd16601c0", "orgid": "29696ae1-d58c-4e57-a106-7aa54e7b4918", "orderNo": "03", "name": "酒水", "enabled": true, "isSystemBuild": false, "deleted": false }, { "guid": "29696ae1-d58c-4e57-a106-7aa54e7b4918-cp", "groupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "groupCode": "10092", "groupIdType": 2, "addGroupId": "a55daa43-d528-4f49-98bb-9d46dba306e7", "addGroupIdType": 2, "addTime": 1465967846000, "addUser": "sys", "modTime": 1466669223000, "modUser": "sys", "addUserId": "sys", "modUserId": "a8ac2592-1f69-478d-8a0e-faadd16601c0", "orgid": "29696ae1-d58c-4e57-a106-7aa54e7b4918", "orderNo": "02", "name": "菜品", "enabled": true, "isSystemBuild": false, "deleted": false }], "cpinfoList": [] }], "pageList": null, "errorDetails": [] };

            var jsonStrData = '';
            var updateTabelName = "";
            try {
                if (!Utils.isEmpty(response.dataList)) {
                    for (var idx in response.dataList) {
                        var data = [];
                        var ids;
                        var tableName = response.dataList[idx].entityName;
                        updateTabelName = tableName;
                        console.info(tableName);
                        var db = new DatabaseFuncDelegate($q, database, tableName);

                        console.log(tableName + "Data：" + JSON.stringify(response));
                        if (tableName == "pos_caipin") {
                            updateCaipin(response, db, jsonStrData, $q, database, tableName, idx);
                        } else if (tableName == "pos_person") {
                            updatePosPerson(response, db, jsonStrData, $q, database, tableName, idx);
                        } else if (tableName == "printer") {
                            updatePrinter(response, db, jsonStrData, $q, database, tableName, idx);
                        } else if (tableName == "pos_person_pos_mission") {
                            updatePosPermission(response, db, jsonStrData, $q, database, tableName, idx);
                        } else if (tableName == "pos_person_func_mission") {
                            updateFuncPermission(response, db, jsonStrData, $q, database, tableName, idx);
                        } else if (tableName == "pos_weixin_order") {
                            deleteRedisData(setRedisType(jsonStrData, tableName));
                            // HandlerNetworkOrder.update(response.dataList[idx].dataList);
                            WeiXinService.update(response.dataList[idx].dataList);
                        } else if (tableName == "pos_zhuotai") { //桌台特殊处理，如果存在的时候，保留原先的定单号
                            updatePosZhuotai(response, db, jsonStrData, $q, database, tableName, idx);
                        }
                        else {
                            if (!Utils.isEmpty(response.dataList[idx].dataList)) {
                                var allsqls = [];
                                if (tableName == "pos_canbie") {
                                    allsqls.push({ query: "delete from " + tableName, params: [] });
                                }
                                for (var idx2 in response.dataList[idx].dataList) {
                                    var data = [];
                                    data.push(_buildModelData(tableName, response.dataList[idx].dataList[idx2]));
                                    var id = getId(response.dataList[idx].dataList[idx2]);
                                    if (tableName == "pos_print_caipin") {
                                        var caipinId = response.dataList[idx].dataList[idx2].caipinId;
                                        allsqls.push({
                                            query: "delete from " + tableName + " where caipinId=?",
                                            params: [caipinId]
                                        });
                                    } else if (tableName != "pos_print_caipin" && tableName != "pos_canbie") {
                                        var deletesql = {
                                            query: "delete from " + tableName + " where guid=?",
                                            params: [id]
                                        };
                                        allsqls.push(deletesql);
                                    }

                                    for (var idx3 in data) {
                                        var data2 = data[idx3];
                                        if (tableName == 'pos_area') {
                                            if (data2.areaCode != null && data2.areaCode != undefined) {
                                                allsqls.push({
                                                    query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                                                    params: []
                                                });
                                            }
                                        } else {
                                            allsqls.push({
                                                query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                                                params: []
                                            });
                                        }

                                    }
                                }
                                if (allsqls.length > 0) {

                                    db.queryTransaction(allsqls).then(function (resultList) {
                                        console.log(tableName + "更新成功");
                                        deleteRedisData(setRedisType(jsonStrData, tableName));
                                        if (tableName == 'pos_cai_wu_ke_mu') {
                                            //重新加载付款方式
                                            JieSuanService.getCaiWuKeMu(function (err, model) {
                                                if (err) {
                                                    return Utils.showFailureInfo(err.message);
                                                }
                                                BIZCONSTANT.ALLPMs = model;
                                            });
                                        }
                                    }, function (err) {
                                        console.log(tableName + "更新失败" + err);
                                    });
                                }
                            }
                        }
                    }
                } else {
                    console.info("该TOPIC对应的ID，服务端无数据返回： " + JSON.stringify(response));
                }

            } catch (e) {
                console.info("更新表：" + updateTabelName + " 失败,错误信息：" + e.message);
                AjaxLogger.log(currentUser, "后台数据同步失败，表" + updateTabelName, jsonStrData, e.message, this.url);
            }
        }

        SyncDataService.parseTopic = function(topicData) {
            var entityNameMap = topicData.entityNameMap;
            var dataNameInfo = topicData.dataNameInfo;
            var redisIdMap = topicData.redisIdMap;
            var sendTime = topicData.sendTime;
            if(!sendTime) sendTime = "";
            var status = 1;
            var returnData = [];
            if(entityNameMap && dataNameInfo) {
                for(var attr in entityNameMap) {
                    var entityType = attr;
                    var entityGuids = entityNameMap[entityType];
                    var redisIds = redisIdMap[entityType];
                    console.info("entityGuids : " + entityGuids);
                    console.info("entityGuids.length : " + entityGuids.length);
                    if(entityGuids && entityGuids.indexOf(",") >= 0) {
                        entityGuids = entityGuids.split(",");
                    }
                    if(redisIds && redisIds.indexOf(",") >= 0) {
                        redisIds = redisIds.split(",");
                    }
                    var entityNames = dataNameInfo[entityType];
                    if(!entityNames) entityNames = [];
                    console.info("entityNames : " + entityNames);
                    console.info("entityNames.length : " + entityNames.length);
                    if(entityNames && entityNames.indexOf(",") >= 0) {
                        entityNames = entityNames.split(",");
                    }
                    var redisIdSet = topicData.redisIdSet;
                    if(entityGuids && entityGuids.length > 0) {
                        for(var i = 0; i < entityGuids.length; i++) {
                            var entity = new EntityNameMap();
                            entity.guid = Utils.guid();
                            entity.entityGuid = entityGuids[i];
                            entity.entityType = entityType;
                            try{
                                entity.redisId = redisIds[i];
                            }catch(e) {
                            }

                            try{
                                entity.entityName = entityNames[i];
                            }catch(e) {
                                entity.entityName = "未知";
                            }
                            if(!entity.entityName) entity.entityName = "未知";
                            entity.sendTime = sendTime;
                            entity.status = status;
                            if(redisIdSet) {
                                entity.redisIdSet = redisIdSet.join(",");
                            }
                            returnData.push(entity);
                        }
                    }
                }
            }
            return returnData;
        }

        function updatePosZhuotai(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	if (!Utils.isEmpty(response.dataList[idx].dataList)) {
                for (var idx2 in response.dataList[idx].dataList) {
                    var allsqls = [];
                    var data=[];
                    var zhuotaiid = getId(response.dataList[idx].dataList[idx2]);
                    _getExistedOrderId(zhuotaiid, response.dataList[idx].dataList[idx2], allsqls, data, tableName, function (error, id, zhuotaiDatas, allsqls, data,tbname,ztid) {
                        var data=[];
                        console.info("exised orderid is "+id );
                        zhuotaiDatas.orderId = id;
                        data.push(_buildModelData(tbname, zhuotaiDatas));
                        console.log("existed 23" +JSON.stringify(data) );
                        var deletesql = {
                            query: "delete from " + tbname + " where guid=?",
                            params: [ztid]
                        };
                        allsqls.push(deletesql);
                        for (var idx3 in data) {
                            var data2 = data[idx3];
                            console.log("existed 4");
                            allsqls.push({
                                query: "INSERT INTO " + tbname + generateJoinSQL(data2),
                                params: []
                            });
                        }
                         if (allsqls.length > 0) {
                             console.log("zhuotai sql" +JSON.stringify(allsqls) );
                             db.queryTransaction(allsqls).then(function (resultList) {
                                 deleteRedisData(setRedisType(jsonStrData, tableName));
                                 console.log(tbname + "更新成功");
                                 if(callback) callback(true);
                             }, function (err) {
                                 console.log(tbname + "更新失败" + err);
                             });
                         };
                    });
            	}
            }
        }

        //消费类型信息更新(pos_consumption_caipin,pos_consumption_type)
        function updateConsumeTypeInfo(response, db, jsonStrData, $q, tableName, idx, callback) {
            if(!response || !db || !jsonStrData || !idx) return;
            var obj = response.dataList[idx];
            if(!obj) return;
            var list = obj.dataList;
            if(list && list.length > 0) {
                var sqls = [];
                for(var i = 0; i < list.length; i++) {
                    var typeObj = list[i];
                    sqls.push({
                        query:"delete from " + tableName + " where guid='" + typeObj.guid + "'",
                        params: []
                    });
                    sqls.push({
                        query:"delete from pos_consumption_caipin where consumptionId='" + typeObj.guid + "'",
                        params: []
                    });
                    var realTypeObj = new Object();
                    realTypeObj.guid = typeObj.guid;
                    realTypeObj.state = typeObj.state;
                    realTypeObj.consumptionName = typeObj.consumptionName;
                    realTypeObj.isdeleted = typeObj.deleted;
                    sqls.push({
                        query:"insert into " + tableName + generateJoinSQL(realTypeObj),
                        params: []
                    });

                    var caipins = typeObj.caipins;
                    if(caipins && caipins.length > 0) {
                        for(var j = 0; j < caipins.length; j++) {
                            var caipinObj = caipins[j];
                            var realCaipinObj = new Object();
                            realCaipinObj.guid = caipinObj.guid;
                            realCaipinObj.caipinNum = caipinObj.caipinNum;
                            realCaipinObj.caipinId = caipinObj.caipinId;
                            realCaipinObj.consumptionId = caipinObj.consumptionId;
                            realCaipinObj.realCaipinId = caipinObj.realCaipinId;
                            realCaipinObj.isdeleted = caipinObj.deleted;
                            sqls.push({
                                query:"insert into pos_consumption_caipin " + generateJoinSQL(realCaipinObj),
                                params: []
                            });
                        }
                    }
                }
                if (sqls.length > 0) {
                    console.log("消费类型 sql : " +JSON.stringify(sqls) );
                    db.queryTransaction(sqls).then(function (resultList) {
                        deleteRedisData(setRedisType(jsonStrData, tableName));
                        console.log(tableName + "更新成功");
                        if(callback) callback(true);
                    }, function (err) {
                        console.log(tableName + "更新失败" + err);
                    });
                };
            }
        }
        
        function updateFuncPermission(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	var data = [];
            var sqls = [];
            sqls.push({
                query: "delete from " + tableName ,
                params: []
            });
        	for (var idx2 in response.dataList[idx].dataList) {
                for (var idx3 in response.dataList[idx].dataList[idx2].functionPermissions) {
                    data.push(_buildModelData(tableName, response.dataList[idx].dataList[idx2].functionPermissions[idx3]));
                }
            }
        	if (data.length > 0) {
                for (var idx3 in data) {
                    var data2 = data[idx3];
                    sqls.push({
                        query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                        params: []
                    });
                }
            }
			
            if (sqls.length > 0) {
                db.queryTransaction(sqls).then(function (resultList) {
                    deleteRedisData(setRedisType(jsonStrData, tableName));
                    if(showLog)
                    console.log(tableName + "更新成功，开始刷新权限缓存......");
                    refreshPermissionCache();
                    if(callback) callback(true);
                }, function (err) {
                    console.log(tableName + "更新失败" + err);
                });
            }
        }

        //刷新权限缓存
        function refreshPermissionCache() {
            AuthService.getFuncPermissions(BIZCONSTANT.POSUSER.id).then(function (result) {
                BIZCONSTANT.OPERATOR_ROLES = result;
                if(showLog)
                console.log("权限缓存刷新成功！");
                Utils.sendBroadcast({ action: "refreshPermissionCache" });
            })
        }
        
        function updatePosPermission(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	var data = [];
            var sqls = [];
        	for (var idx2 in response.dataList[idx].dataList) {
                var id = getId(response.dataList[idx].dataList[idx2]);
                for (var pidx in response.dataList[idx].dataList[idx2].dataPermissions.posPermission) {
                    data.push(_buildModelData(tableName, response.dataList[idx].dataList[idx2].dataPermissions.posPermission[pidx]));
                    sqls.push({
                        query: "delete from " + tableName + " where guid=?",
                        params: [id]
                    });
                }
            }
        	
            if (data.length > 0) {
                for (var idx3 in data) {
                    var data2 = data[idx3];
                    sqls.push({
                        query: "INSERT INTO " + tableName +generateJoinSQL(data2),
                        params: []
                    });
                }
            }
			
            if (sqls.length > 0) {
                db.queryTransaction(sqls).then(function (resultList) {
                    deleteRedisData(setRedisType(jsonStrData, tableName));
                    console.log(tableName + "更新成功");
                    if(callback) callback(true);
                }, function (err) {
                    console.log(tableName + "更新失败" + err);
                });
            }
        }
        
        function updatePrinter(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	if (!Utils.isEmpty(response.dataList[idx].dataList)) {
                var printerdata = [];
                var printerconfigdata = [];
                var receiptdata = [];
                var templatedata = [];
                var schemedata = [];
                var printecaipindata = [];
                var allPrintSql = [];
				
                for (var idx2 in response.dataList[idx].dataList) {
                    var isdelete = Deleted(response.dataList[idx].dataList[idx2]);
                    if (!isdelete) {
                        printerdata.push(_buildModelData("printer", response.dataList[idx].dataList[idx2]));
                    }
                    var id = getId(response.dataList[idx].dataList[idx2]);
                    allPrintSql.push({
                        query: "delete from printer where guid = ?",
                        params: [id]
                    });
                    allPrintSql.push({
                        query: "delete from printer_config  where printer_id = ?",
                        params: [id]
                    });
                    if (!Utils.isEmpty(response.dataList[idx].dataList[idx2].printConfigs)) {
                        for (var configidx in response.dataList[idx].dataList[idx2].printConfigs) {
                            printerconfigdata.push(_buildModelData("printer_config", response.dataList[idx].dataList[idx2].printConfigs[configidx]));
                        }
                    }

                    if (!Utils.isEmpty(response.dataList[idx].dataList[idx2].printReceipts)) {
                        for (var reciptidx in response.dataList[idx].dataList[idx2].printReceipts) {
                            allPrintSql.push({
                                query: "delete from pos_print_receipt where printId=? ",
                                params: [id]
                            });
                                receiptdata.push(_buildModelData("pos_print_receipt", response.dataList[idx].dataList[idx2].printReceipts[reciptidx]));
                                if (!Utils.isEmpty(response.dataList[idx].dataList[idx2].printReceipts[reciptidx].printReceiptTemplates)) {
                                  
                                    var receiptId = response.dataList[idx].dataList[idx2].printReceipts[reciptidx].guid;
                                    allPrintSql.push({
                                        query: "delete from pos_print_receipt_template where printReceiptId=? ",
                                        params: [receiptId]
                                    });

                                    templatedata.push(_buildModelData("pos_print_receipt_template", response.dataList[idx].printReceipts[reciptidx].printReceiptTemplates[0]));
                                }


                        }
                    }

                    if (!Utils.isEmpty(response.dataList[idx].dataList[idx2].printScheme)) {

                        schemedata.push(_buildModelData("pos_print_scheme", response.dataList[idx].dataList[idx2].printScheme));
                        var schemeGuid = response.dataList[idx].dataList[idx2].printScheme.guid;
                        allPrintSql.push({
                            query: "delete from pos_print_scheme  where printid = ?",
                            params: [id]
                        });

                        if (!Utils.isEmpty(response.dataList[idx].dataList[idx2].printScheme.printCaipins)) {
                            for (var cpidx in response.dataList[idx].dataList[idx2].printScheme.printCaipins) {
                                printecaipindata.push(_buildModelData("pos_print_caipin", response.dataList[idx].dataList[idx2].printScheme.printCaipins[cpidx]));
                                allPrintSql.push({
                                    query: "delete from pos_print_caipin  where printSchemeId = ?",
                                    params: [schemeGuid]
                                });
                            }
                        }

                    }
                }

                allPrintSql.push({
                    query: "delete from printer_config where printer_id=? ",
                    params: [id]
                });
                allPrintSql.push({
                    query: "delete from pos_print_receipt where printId=?",
                    params: [id]
                });
                if (printerdata.length > 0) {
                    for (var idx3 in printerdata) {
                        var data2 = printerdata[idx3];
                        allPrintSql.push({
                            query: "INSERT INTO printer " + generateJoinSQL(data2),
                            params: []
                        });
                    }

                }
                if (printerconfigdata.length > 0) {
                    for (var idx4 in printerconfigdata) {
                        var data2 = printerconfigdata[idx4];
                        allPrintSql.push({
                            query: "INSERT INTO printer_config " + generateJoinSQL(data2),
                            params: []
                        });
                    }

                }

                if (receiptdata.length > 0) {
                    for (var idx5 in receiptdata) {
                        var data2 = receiptdata[idx5];
                        allPrintSql.push({
                            query: "INSERT INTO pos_print_receipt " + generateJoinSQL(data2),
                            params: []
                        });
                    }

                }

                if (templatedata.length > 0) {
                    for (var idx6 in templatedata) {
                        var data2 = templatedata[idx6];
                        allPrintSql.push({
                            query: "INSERT INTO pos_print_receipt_template " + generateJoinSQL(data2),
                            params: []
                        });
                    }

                }

                if (printecaipindata.length > 0) {
                    for (var idx7 in printecaipindata) {
                        var data2 = printecaipindata[idx7];
                        allPrintSql.push({
                            query: "INSERT INTO pos_print_caipin " +generateJoinSQL(data2),
                            params: []
                        });
                    }

                }

                if (schemedata.length > 0) {
                    for (var idx8 in schemedata) {
                        var data2 = schemedata[idx8];
                        allPrintSql.push({
                            query: "INSERT INTO pos_print_scheme " + generateJoinSQL(data2),
                            params: []
                        });
                    }

                }
                if (allPrintSql.length > 0) {
                    console.log("print slq "+JSON.stringify(allPrintSql));
                    db.queryTransaction(allPrintSql).then(function (resultList) {
                        deleteRedisData(setRedisType(jsonStrData, tableName));
                        console.log(tableName + "更新成功");
                        reloadPrinterAndCaipins();
                        if(callback) callback(true);
                    }, function (err) {
                        console.log(tableName + "更新失败" + err);
                    });
                }
            }
        }
        
        function updatePosPerson(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	if (!Utils.isEmpty(response.dataList[idx].dataList)) {
        		var data = [];
                var sqls = [];
                var roledata = [];
                for (var idx2 in response.dataList[idx].dataList) {
                	
                    var id = getId(response.dataList[idx].dataList[idx2]);
                    data.push(_buildModelData("pos_person", response.dataList[idx].dataList[idx2]));
                    sqls.push({
                        query: "delete from " + tableName + " where guid=?",
                        params: [id]
                    });
                    for (var idx3 in response.dataList[idx].dataList[idx2].authUserRoles) {
                        roledata.push(_buildModelData("pos_person_role", response.dataList[idx].dataList[idx2].authUserRoles[idx3]));
                        sqls.push({query: "delete from pos_person_role", params: []});
                    }
                }
                
                if (data.length > 0) {
                    for (var idx4 in data) {
                        var data2 = data[idx4];
                        sqls.push({
                            query: "INSERT INTO " + tableName + generateJoinSQL(data2),
                            params: []
                        });
                    }
                }

                if (roledata.length > 0) {
                    for (var idx5 in roledata) {
                        var data2 = roledata[idx5];
                        sqls.push({
                            query: "INSERT OR IGNORE INTO pos_person_role" + generateJoinSQL(data2),
                            params: []
                        });
                    }
                }
                if (sqls.length > 0) {
                    db.queryTransaction(sqls).then(function (resultList) {
                        deleteRedisData4BaseOperator(setRedisType(jsonStrData, tableName));
                        console.log(tableName + "更新成功");
                        if(callback) callback(true);
                    }, function (err) {
                        console.log(tableName + "更新失败" + err);
                    });
                }
            }
        }
        
        function updateCaipin(response, db, jsonStrData,$q, database, tableName,idx, callback) {
        	var data = [];
            var caipinZuofaData = [];
            var caipinunits = [];
            var allsql = [];
            var scombCaipins = [];
            var scombBXCaipins = [];
            var BXCaipins = [];

            var deleteCaiPinSuccess = true;
            for (var idx2 in response.dataList[idx].cpinfoList) {
                data.push(_buildModelData("pos_caipin", response.dataList[idx].cpinfoList[idx2]));
                console.info("the message is :" + JSON.stringify(response.dataList[idx].cpinfoList[idx2]));
                var caiPinid = response.dataList[idx].cpinfoList[idx2].guid;
                allsql.push({
                    query: "delete from " + tableName + " where guid=?",
                    params: [caiPinid]
                });

                //菜品关联做法
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].caipinZuofas)) {
                    for (var zdx in response.dataList[idx].cpinfoList[idx2].caipinZuofas) {
                        var caipinZuofaModel = _buildModelData("pos_caipin_zuofa", response.dataList[idx].cpinfoList[idx2].caipinZuofas[zdx]);
                        caipinZuofaModel["caipinId"] = response.dataList[idx].cpinfoList[idx2].guid;
                        var caiPinid = response.dataList[idx].cpinfoList[idx2].guid;
                        var temp = [];
                        temp.push(caiPinid);
                        allsql.push({
                            query: "delete from pos_caipin_zuofa where caipinId = ?",
                            params: [caiPinid]
                        });
                        caipinZuofaData.push(caipinZuofaModel);
                    }
                }

                // //菜品关联多单位
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].caipinUnits)) {
                    for (var zdx in response.dataList[idx].cpinfoList[idx2].caipinUnits) {
                        var caipinunitModel = _buildModelData("pos_caipin_unit", response.dataList[idx].cpinfoList[idx2].caipinUnits[zdx]);
                        caipinunitModel["caipinId"] = response.dataList[idx].cpinfoList[idx2].guid;
                        var caiPinid = response.dataList[idx].cpinfoList[idx2].guid;
                        var temp = [];
                        temp.push(caiPinid);
                        allsql.push({
                            query: "delete from pos_caipin_unit  where caipinId = ?",
                            params: [caiPinid]
                        });
                        caipinunits.push(caipinunitModel);
                    }
                }

                //taochang
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].tcDishList)) {

                    var tempScombCaipins = response.dataList[idx].cpinfoList[idx2].tcDishList;
                    for (var i in tempScombCaipins) {

                        var tempScombCaipin = _buildModelData("pos_scomb_caipin", tempScombCaipins[i]);
                        tempScombCaipin.scombId = response.dataList[idx].cpinfoList[idx2].guid;
                        allsql.push({
                            query: "delete from pos_scomb_caipin  where scombId = ?",
                            params: [caiPinid]
                        });
                        scombCaipins.push(tempScombCaipin);

                        if (tempScombCaipins[i].tcbxDishList.length > 0) {
                            var tempBXCaipins = tempScombCaipins[i].tcbxDishList;
                            for (var k in tempBXCaipins) {
                                var tempBXCaipin = _buildModelData("pos_scomb_beixuan_caipin", tempBXCaipins[k]);
                                tempBXCaipin.scombId = response.dataList[idx].cpinfoList[idx2].guid;
                                tempBXCaipin.scombCaipinId = tempScombCaipin.guid;
                                allsql.push({
                                    query: "delete from pos_scomb_beixuan_caipin  where scombId = ?",
                                    params: [caiPinid]
                                });
                                BXCaipins.push(tempBXCaipin);
                            }
                        }
                    }
                }
            }

            if (data.length > 0) {
                for (var idxy in data) {
                    var data2 = data[idxy];
                  var temp = "INSERT INTO pos_caipin " + generateJoinSQL(data2);
                    allsql.push({
                        query:temp ,
                        params: []
                    });
                }
            }
            if (caipinZuofaData.length > 0) {
                for (var idxy1 in caipinZuofaData) {
                    var data2 = caipinZuofaData[idxy1];
                    allsql.push({
                        query: "INSERT INTO pos_caipin_zuofa " + generateJoinSQL(data2),
                        params: []
                    });
                }
            }

            if (caipinunits.length > 0) {
                for (var idxy2 in caipinunits) {
                    var data2 = caipinunits[idxy2];
                    allsql.push({
                        query: "INSERT INTO pos_caipin_unit " +generateJoinSQL(data2),
                        params: []
                    });
                }

            }

            if (scombCaipins.length > 0) {
                for (var idxy3 in scombCaipins) {
                    var data2 = scombCaipins[idxy3];
                    allsql.push({
                        query: "INSERT INTO pos_scomb_caipin " + generateJoinSQL(data2),
                        params: []
                    });
                }

            }

            if (BXCaipins.length > 0) {
                for (var idxy4 in BXCaipins) {
                    var data2 = BXCaipins[idxy4];
                    allsql.push({
                        query: "INSERT INTO pos_scomb_beixuan_caipin " + generateJoinSQL(data2),
                        params: []
                    });
                }

            }
            if (allsql.length > 0) {
                db.queryTransaction(allsql).then(function (resultList) {
                    deleteRedisData(jsonStrData);
                    console.log("菜品更新成功");
                    reloadPrinterAndCaipins();
                    if(callback)
                        return callback(true);
                }, function (err) {
                    console.log(err);
                    if(callback)
                        return callback(null);
                });
            }
        }

        //by jiangxueliang
        function newUpdateCaipin(response, db, jsonStrData,$q, database, tableName,idx, callback, caiPuGuid, isChain) {
            var data = [];
            var caipinZuofaData = [];
            var caipinunits = [];
            var allsql = [];
            var scombCaipins = [];
            var scombBXCaipins = [];
            var BXCaipins = [];

            var deleteCaiPinSuccess = true;
            var entityGuids = [];
            var caiPinTypeObjs = [];
            var caiPinTypeGuids = [];

            for (var idx2 in response.dataList[idx].cpinfoList) {
                //菜品类型
                var caipinType = response.dataList[idx].cpinfoList[idx2].dishTypeInfo;
                if(isChain && isChain == true)
                if(caipinType) {
                    var caiPinTypeId = caipinType.guid;
                    if(caiPinTypeId && caiPinTypeId.length > 0) {
                        var caipinTypeObj = new Object();
                        caipinTypeObj.guid = caiPinTypeId;
                        caipinTypeObj.dishTypeCode = caipinType.dishTypeCode;
                        caipinTypeObj.dishTypeName = caipinType.dishTypeName;
                        caipinTypeObj.parendId = caipinType.parendId;
                        caipinTypeObj.isFenTan = caipinType.isFenTan;
                        caipinTypeObj.zheKou = caipinType.zheKou;
                        caipinTypeObj.isDeleted = caipinType.deleted;
                        caiPinTypeGuids.push("'" + caiPinTypeId + "'");
                        caiPinTypeObjs.push(caipinTypeObj);
                        if(caipinType.parentDishType)
                        {
                            var parenttype = caipinType.parentDishType;
                            var pcaiPinTypeId = parenttype.guid;
                            var pcaipinTypeObj = new Object();
                            pcaipinTypeObj.guid = pcaiPinTypeId;
                            pcaipinTypeObj.dishTypeCode = parenttype.dishTypeCode;
                            pcaipinTypeObj.dishTypeName = parenttype.dishTypeName;
                            pcaipinTypeObj.parendId = parenttype.parendId;
                            pcaipinTypeObj.isFenTan = parenttype.isFenTan;
                            pcaipinTypeObj.zheKou = parenttype.zheKou;
                            pcaipinTypeObj.isDeleted = parenttype.deleted;
                            caiPinTypeGuids.push("'" + pcaiPinTypeId + "'");
                            caiPinTypeObjs.push(pcaipinTypeObj);
                        }
                    }
                }
                data.push(_buildModelData("pos_caipin", response.dataList[idx].cpinfoList[idx2]));
                console.info("the message is :" + JSON.stringify(response.dataList[idx].cpinfoList[idx2]));
                var caiPinid = response.dataList[idx].cpinfoList[idx2].guid;
                var caiPinIdParam = [caiPinid];
                var nullParam = [];
                var param = caiPinIdParam;
                if(caiPinid && caiPinid.length > 0) entityGuids.push("'" + caiPinid + "'");
                var delSql = "delete from " + tableName + " where guid=?";
                if(isChain && isChain == true)
                if(caiPuGuid && caiPuGuid.length > 0) {
                    delSql = "update " + tableName + " set isDeleted='true', guid=guid || '_' || datetime()";
                    param = nullParam;
                }
                allsql.push({
                    query: delSql,
                    params: param
                });

                //菜品关联做法
                var delCPzfSql = "delete from pos_caipin_zuofa where caipinId = ?";
                if(isChain && isChain == true)
                    if(caiPuGuid && caiPuGuid.length > 0) {
                        delCPzfSql = "update pos_caipin_zuofa set isDeleted='true' , guid=guid || '_' || datetime()";
                        param = nullParam;
                    }
                allsql.push({
                    query: delCPzfSql,
                    params: param
                });
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].caipinZuofas)) {
                    for (var zdx in response.dataList[idx].cpinfoList[idx2].caipinZuofas) {
                        var caipinZuofaModel = _buildModelData("pos_caipin_zuofa", response.dataList[idx].cpinfoList[idx2].caipinZuofas[zdx]);
                        caipinZuofaModel["caipinId"] = response.dataList[idx].cpinfoList[idx2].guid;
                        var temp = [];
                        temp.push(caiPinid);
                        caipinZuofaData.push(caipinZuofaModel);
                    }
                }

                // //菜品关联多单位
                var delUnitSql = "delete from pos_caipin_unit  where caipinId = ?";
                if(isChain && isChain == true)
                    if(caiPuGuid && caiPuGuid.length > 0) {
                        delUnitSql = "update pos_caipin_unit set isDeleted='true' , guid=guid || '_' || datetime()";
                        param = nullParam;
                    }
                allsql.push({
                    query: delUnitSql,
                    params: param
                });
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].caipinUnits)) {
                    for (var zdx in response.dataList[idx].cpinfoList[idx2].caipinUnits) {
                        var caipinunitModel = _buildModelData("pos_caipin_unit", response.dataList[idx].cpinfoList[idx2].caipinUnits[zdx]);
                        caipinunitModel["caipinId"] = response.dataList[idx].cpinfoList[idx2].guid;
                        var caiPinid = response.dataList[idx].cpinfoList[idx2].guid;
                        var temp = [];
                        temp.push(caiPinid);
                        caipinunits.push(caipinunitModel);
                    }
                }


                //taocang
                var delTCSql = "delete from pos_scomb_caipin  where scombId = ?";
                if(isChain && isChain == true)
                    if(caiPuGuid && caiPuGuid.length > 0) {
                        delTCSql = "update pos_scomb_caipin set isDeleted='true' , guid=guid || '_' || datetime()";
                        param = nullParam;
                }
                allsql.push({
                    query: delTCSql,
                    params: param
                });
                var delTCBXSql = "delete from pos_scomb_beixuan_caipin  where scombId = ?";
                if(isChain && isChain == true)
                    if(caiPuGuid && caiPuGuid.length > 0) {
                        delTCBXSql = "update pos_scomb_beixuan_caipin set isDeleted='true' , guid=guid || '_' || datetime()";
                        param = nullParam;
                    }
                allsql.push({
                    query: delTCBXSql,
                    params: param
                });
                if (!Utils.isEmpty(response.dataList[idx].cpinfoList[idx2].tcDishList)) {

                    var tempScombCaipins = response.dataList[idx].cpinfoList[idx2].tcDishList;
                    for (var i in tempScombCaipins) {

                        var tempScombCaipin = _buildModelData("pos_scomb_caipin", tempScombCaipins[i]);
                        tempScombCaipin.scombId = response.dataList[idx].cpinfoList[idx2].guid;
                        scombCaipins.push(tempScombCaipin);

                        if (tempScombCaipins[i].tcbxDishList.length > 0) {
                            var tempBXCaipins = tempScombCaipins[i].tcbxDishList;
                            for (var k in tempBXCaipins) {
                                var tempBXCaipin = _buildModelData("pos_scomb_beixuan_caipin", tempBXCaipins[k]);
                                tempBXCaipin.scombId = response.dataList[idx].cpinfoList[idx2].guid;
                                tempBXCaipin.scombCaipinId = tempScombCaipin.guid;
                                BXCaipins.push(tempBXCaipin);
                            }
                        }
                    }
                }
            }

            if (data.length > 0) {
                for (var idxy in data) {
                    var data2 = data[idxy];
                    var temp = "INSERT INTO pos_caipin " + generateJoinSQL(data2);
                    allsql.push({
                        query:temp ,
                        params: []
                    });
                }
            }
            if (caipinZuofaData.length > 0) {
                for (var idxy1 in caipinZuofaData) {
                    var data2 = caipinZuofaData[idxy1];
                    allsql.push({
                        query: "INSERT INTO pos_caipin_zuofa " + generateJoinSQL(data2),
                        params: []
                    });
                }
            }

            if (caipinunits.length > 0) {
                for (var idxy2 in caipinunits) {
                    var data2 = caipinunits[idxy2];
                    allsql.push({
                        query: "INSERT INTO pos_caipin_unit " +generateJoinSQL(data2),
                        params: []
                    });
                }

            }

            if (scombCaipins.length > 0) {
                for (var idxy3 in scombCaipins) {
                    var data2 = scombCaipins[idxy3];
                    allsql.push({
                        query: "INSERT INTO pos_scomb_caipin " + generateJoinSQL(data2),
                        params: []
                    });
                }

            }

            if (BXCaipins.length > 0) {
                for (var idxy4 in BXCaipins) {
                    var data2 = BXCaipins[idxy4];
                    allsql.push({
                        query: "INSERT INTO pos_scomb_beixuan_caipin " + generateJoinSQL(data2),
                        params: []
                    });
                }

            }
            var updateSql = null;
            if(allsql.length > 0)
            if(isChain && isChain == true) {
                if(caiPuGuid && caiPuGuid.length > 0) {
                    updateSql = "update pos_entitynamemap set status=2 where status=1 and  entityGuid='" + caiPuGuid + "'";
                }else {
                    updateSql = "update pos_entitynamemap set status=2 where status=1 and  entityGuid in (" + entityGuids.join(",") + ")";
                }
            }

            if(updateSql && updateSql.length > 0) allsql.push({query : updateSql, params: []});
            if (allsql.length > 0) {
                db.queryTransaction(allsql).then(function (resultList) {
                    deleteRedisData(setRedisType(jsonStrData, tableName, caiPuGuid));
                    console.log("菜品更新成功");
                    if(callback) callback(true);
                    reloadPrinterAndCaipins();
                    //菜品关联菜品类别
                    if(isChain && isChain == true)
                    if(caiPinTypeObjs.length > 0) {
                        var newCaiPinTypeGuids = caiPinTypeGuids.join(",");
                        var selectCaiPinTypeSql = "select guid from pos_caipin_type where guid in (" + caiPinTypeGuids + ")";
                        db.query(selectCaiPinTypeSql).then(function(result1){
                            var existGuids = [];
                            if(result1.detail.length > 0) {
                                for(var n = 0; n < result1.detail.length; n++) {
                                    var guid1 = result1.detail[n].guid;
                                    existGuids.push(guid1);
                                }
                            }
                            if(existGuids.length > 0) {
                                for(var q = 0; q < existGuids.length; q++) {
                                    for(var qq = 0; qq < caiPinTypeObjs.length; qq++) {
                                        if(existGuids[q] == caiPinTypeObjs[qq].guid) {
                                            caiPinTypeObjs.splice(qq, 1);
                                            qq--;
                                        }
                                    }
                                }
                            }

                            if(caiPinTypeObjs.length > 0) {
                                //去重
                                var realInsertObjs = removeSameCaiPinType(caiPinTypeObjs);
                                caiPinTypeObjs = realInsertObjs;
                                var caiPinTypeSql = [];
                                for(var i = 0; i < caiPinTypeObjs.length; i++) {
                                    caiPinTypeSql.push(
                                        {
                                            query:"insert into pos_caipin_type " + generateJoinSQL(caiPinTypeObjs[i]),
                                            params:[]
                                        }
                                    );
                                }
                                if(caiPinTypeSql.length > 0) {
                                    db.queryTransaction(caiPinTypeSql).then(function(retdata){
                                        console.info(retdata);
                                    },function(err){
                                        console.info(err);
                                    })
                                }
                            }
                        },function(err){
                            console.info("err1 : " + err);
                        })
                    }
                }, function (err) {
                    console.log(err);
                    $.maskLoader("hide");
                });
            }
        }

        var removeSameCaiPinType = function(types) {
            var newTypes = [];
            if(types.length > 0) {
                for(var i = 0; i < types.length; i++) {
                    if(newTypes.length <= 0) {
                        newTypes.push(types[i])
                    }else {
                        if(checkHasSameCaiPinType(newTypes, types[i]) == false) {
                            newTypes.push(types[i]);
                        }
                    }
                }
            }
            return newTypes;
        }

        var checkHasSameCaiPinType = function(types, type) {
            if(!types || !type || types.length <= 0) return false;
            for(var i = 0; i < types.length; i++) {
                if(type.guid == types[i].guid) return true;
            }
            return false;
        }

        var setRedisType = function(jsonStr, tableName, caiPuGuid) {
            if(!jsonStr || !tableName) return jsonStr;
            var obj = JSON.parse(jsonStr);
            var redisIdType = null;
            redisIdType = TabelName_RedisTypeMap[tableName];
            if(redisIdType == undefined) redisIdType = null;
            obj.redisIdType = redisIdType;
            if(showLog)
            console.info("setRedisType : " + JSON.stringify(obj));
            return JSON.stringify(obj);
        }

        var _getExistedOrderId = function (zhuotaiid ,datas ,allsqls,data,tableName,cb){
            var orderId=null;
            var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');
            zhuotaiDao.getById(zhuotaiid, 'guid').then(function (result) {
                console.log("the old is : "+JSON.stringify(result));
                if (result == null) {
                    orderId = null;
                }else{
                    orderId = result.orderId;
                }
                return cb(null, orderId, datas, allsqls, data, tableName,zhuotaiid);
            });
        }


        var _buildModelData = function(tableName, row){
            var tableMeta = null;
            for(var idx in TABLES_SCHEME){
                if(TABLES_SCHEME[idx].name.toLowerCase() == tableName.toLowerCase()){
                    tableMeta = TABLES_SCHEME[idx];
                    break;
                }
            }
            var output = {};
            if(tableMeta != null){
                for(var idx in tableMeta.columns){
                    var colDef = tableMeta.columns[idx];
                    if(row[colDef.name] != null){
                        var value = row[colDef.name];
                        if(value.length > 0 && value.indexOf("/Date") != -1){
                            value = value.replace("/Date(","").replace(")/","");
                            value = new Date(parseInt(value)).format("yyyy-MM-dd hh:mm:ss");
                        }
                        if(colDef.name == "enabled"){
                            if(value){
                                value = "true";
                            } else {
                                value = "false";
                            }
                        }
                        output[colDef.name] = value;
                    }
                    if(colDef.name == "isDeleted" || colDef.name == "isdeleted"){
                        if(row["deleted"] != null){
                            if(row["deleted"]){
                                output[colDef.name] = "true";
                            } else {
                                output[colDef.name] = "false";
                            }

                        } else {
                            output[colDef.name] = "false";
                        }
                    }
                }
                if (tableName == "pos_caipin") {
                    output["isScomb"] = row["ifScomb"];
                    output["costprice"] = row["costPrice"];
                    output["commissionTypeId"] = row["commissiontypeId"];
                }
                if (tableName == "pos_scomb_caipin") {
                    output["caipinId"] = row["tcdishId"];
                    output["name"] = row["tcdishName"];
                    output["num"] = row["tcdishNum"];
                    output["unitId"] = row["tcdishUnitId"];
                    output["unitName"] = row["tcdishUnitName"];
                    output["isBeixuan"] = row["tcdishIfbx"];
                    output["costprice"] = row["costPrice"];
                }
                if (tableName == "pos_scomb_beixuan_caipin") {
                    output["bxCaipinId"] = row["bxDishId"];
                    output["bxCaipinNum"] = row["bxDishNum"];
                    output["bxCaipinName"] = row["bxDishName"];
                    output["bxCaipinUnitId"] = row["bxDishUnitId"];
                    output["bxCaipinUnitName"] = row["bxDishUnitName"];
                    output["bxCaipinSalePrice"] = row["bxDishPrice"];
                    output["costprice"] = row["bxDishCostPrice"];
                }

                if (tableName == "pos_zhuotai") {
                    output["code"] = row["orderNo"];
                }
                if(tableName == "pos_kouwei"){
                    output["quickCode"] = row["kwQuickCode"];
                }
                if(tableName == "pos_zuofa"){
                    output["typeId"] = row["zuoFaTypeId"];
                }
                if (tableName == "pos_cai_wu_ke_mu") {
                    output["code"] = row["cwkmCode"];
                    output["name"] = row["cwkmName"];
                    if (row["isShiShou"] != null) {
                        if(row["isShiShou"])
                            output["isshishou"] = "true";
                        else
                            output["isshishou"] = "false";
                    }
                }
                if (tableName == "pos_canbie")
                {
                    output["code"] = row["canbieNo"];
                    output["name"] = row["canbieName"];
                    output["starttime"] = row["startTime"];
                    output["eattime"] = row["eatTime"];
                    output["endtime"] = row["endTime"];
                    output["mdId"] = row["orgId"];
                    output["formatStarttime"] = row["formatStartTime"];
                    output["formatEattime"] = row["formatEatTime"];
                    output["formatEndtime"] = row["formatEndTime"];
                }
                if (tableName == "printer") {
                    output["size"] = row["guiGe"];
                    output["is_zhenda"] = row["isZhenShi"] == 'N' ? 0 : 1;
                    output["backup_id"] = row["backupPrintId1"];
                    output["backup_id2"] = row["backupPrintId2"];
                }
                if (tableName == "printer_config") {
                    output["printer_id"] = row["printId"];
                }
                if (tableName == "pos_print_caipin") {
                    output["printSchemeId"] = row["schemeId"];
                }
                if (tableName == "pos_print_scheme") {
                    output["printid"] = row["printId"];
                }
                if(tableName == "pos_zhekou"){
                    var n = "apply_whole_order";
                    var v = row["applyWholeOrder"];

                    if (v != null) {
                        if (v) {
                            output[n] = "1";
                        } else {
                            output[n] = "0";
                        }
                    } else {
                        output[n] = "0";
                    }
                }
            }
            return output;
        };

        var getId = function( row){
            return row["guid"];
        };

        var Deleted = function(row) {
            return row["deleted"];
        }

        var generateJoinSQL = function(data){
            var k = [];
            var v = [];
            for (var i in data) {
                if (data[i] != null){
                    k.push(i);
                    v.push("'" + data[i] + "'");
                }
            }
            return "(" + k.join(',') + ") VALUES (" + v.join(',') + ")";
        }

        var deleteRedisData = function(topicValue){
            Utils.callAjax(
                pos_url+"/api/v1/pos/removeRedisRecord?t=&token=",
                function(response){
                    if (response.status == "failed"){
                        console.log("Delete Redis failed");
                    }else{
                        console.log("Delete Redis Success");
                    }
                },
                topicValue,
                "POST","json");
        };

        var reloadPrinterAndCaipins = function ()
        {
            PrintService.allPrintCaipin(function (result) {
                BIZCONSTANT.ALLPRINTCAIPIN = result;
            });

            PrintService.allPrintReceipt(function (result) {
                BIZCONSTANT.ALLPRINTRECEIPT = result;
            });
            Utils.sendBroadcast({ action: "reloadPrinterAndCaipins"});
        }

        var deleteRedisData4BaseOperator = function(topicValue){
            Utils.callAjax(
                hqURL+"/api/v1/removeRedisRecord?t=&token=",
                function(response){
                    if (response.status == "failed"){
                        console.log("Delete Redis failed");
                    }else{
                        console.log("Delete Redis Success");
                    }
                },
                topicValue,
                "POST","json");
        };

        SyncDataService.refreshData= function (cb)
        {
            var prefix = pos_url;
            var rtstr='';
            SyncDataService.initPrint(prefix, INIT.PRINT, rtstr, function (err) {
                if (err === '')
                    Utils.showFailureInfo('同步成功！！！');
                else
                    Utils.showFailureInfo('同步失败<br>' + err);
                return cb();
            });
        }

        SyncDataService.initPrint = function (prefix, urlModel, rtstr, cb) {

            callAjax(prefix + urlModel.url, function (response) {
                AjaxLogger.log(BIZCONSTANT.POSUSER, urlModel.desc, JSON.stringify({ "groupId": BIZCONSTANT.POSUSER.groupId, "groupCode": BIZCONSTANT.POSUSER.groupCode, "orgid": BIZCONSTANT.POSUSER.mdId }), JSON.stringify(response), this.url);
                if (response.status != "success") {
                    var result = response.errorDetails[0];
                    Utils.showFailureInfo(result.desc);
                    rtstr += result.desc;
                    return cb(rtstr);
                }

                if (!validateResponseData(response, "printer", "打印配置", rtstr)) {
                    return cb(rtstr);
                }


                if (!Utils.isEmpty(response.dataList)) {
                    response.dataList = Utils.uniqueArrayObject(response.dataList, "guid");

                    var printerdb = new DatabaseFuncDelegate($q, database, 'printer');
                    var printerconfigdb = new DatabaseFuncDelegate($q, database, 'printer_config');
                    var receiptdb = new DatabaseFuncDelegate($q, database, 'pos_print_receipt');
                    var templatedb = new DatabaseFuncDelegate($q, database, 'pos_print_receipt_template');
                    var schemedb = new DatabaseFuncDelegate($q, database, 'pos_print_scheme');
                    var printecaipindb = new DatabaseFuncDelegate($q, database, 'pos_print_caipin');

                    var printerdata = [];
                    var printerconfigdata = [];
                    var receiptdata = [];
                    var templatedata = [];
                    var schemedata = [];
                    var printecaipindata = [];


                    for (var idx in response.dataList)
                    {
                        printerdata.push(_buildModelData("printer", response.dataList[idx]));
                        if (!Utils.isEmpty(response.dataList[idx].printConfigs)) {
                            for (var configidx in response.dataList[idx].printConfigs) {
                                printerconfigdata.push(_buildModelData("printer_config", response.dataList[idx].printConfigs[configidx]));
                            }
                        }

                        if (!Utils.isEmpty(response.dataList[idx].printReceipts)) {
                            for (var reciptidx in response.dataList[idx].printReceipts) {
                                receiptdata.push(_buildModelData("pos_print_receipt", response.dataList[idx].printReceipts[reciptidx]));
                                if (!Utils.isEmpty(response.dataList[idx].printReceipts[reciptidx].printReceiptTemplates)) {
                                    templatedata.push(_buildModelData("pos_print_receipt_template", response.dataList[idx].printReceipts[reciptidx].printReceiptTemplates[0]));
                                }
                            }
                        }

                        if (!Utils.isEmpty(response.dataList[idx].printScheme)) {
                            schemedata.push(_buildModelData("pos_print_scheme", response.dataList[idx].printScheme));
                            if (!Utils.isEmpty(response.dataList[idx].printScheme.printCaipins)) {
                                for (var cpidx in response.dataList[idx].printScheme.printCaipins) {
                                    printecaipindata.push(_buildModelData("pos_print_caipin", response.dataList[idx].printScheme.printCaipins[cpidx]));
                                }
                            }
                        }
                    }
                    printerdb.query("delete from printer").then(function () {
                        if (printerdata.length > 0) {

                            printerdb.insertBatch(printerdata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    printerconfigdb.query("delete from printer_config").then(function () {
                        if (printerconfigdata.length > 0) {

                            printerconfigdb.insertBatch(printerconfigdata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    receiptdb.query("delete from pos_print_receipt").then(function () {
                        if (receiptdata.length > 0) {

                            receiptdb.insertBatch(receiptdata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    templatedb.query("delete from pos_print_receipt_template").then(function () {
                        if (templatedata.length > 0) {
                            $scope.runningDBCount++;

                            templatedb.insertBatch(templatedata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    printecaipindb.query("delete from pos_print_caipin").then(function () {
                        if (printecaipindata.length > 0) {

                            printecaipindb.insertBatch(printecaipindata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    schemedb.query("delete from pos_print_scheme").then(function () {
                        if (schemedata.length > 0) {

                            schemedb.insertBatch(schemedata).then(function () {

                            }, function (err, sql) {

                            });

                        } 
                    });
                    return cb(rtstr);
                } 
            }, JSON.stringify({ "groupId": BIZCONSTANT.POSUSER.groupId, "groupCode": BIZCONSTANT.POSUSER.groupCode, "orgid": BIZCONSTANT.POSUSER.mdId }),
                "POST",
                function (xhr, status, error, data) {
                    rtstr += "<div style='color:red;'>检测到网络存在异常，同步打印机失败！</div>";
                    return cb(rtstr);
                })
        };

        function validateResponseData(response, tableName, desc,rtstr) {
            //$scope.checkItems[tableName].execute = true;
            if (response == null) {
                rtstr += "<div style='color:red;'> " + desc + "初始化失败, 原因: 数据为空</div>";
                return false;
            }
            if (response.status != "success") {
                rtstr += "<div style='color:red;'> " + desc + "初始化失败, 原因: " + response.msg + "</div>";
                return false;
            }
            return true;
        }

        //发送客户端数据到请求
        SyncDataService.sendDataToServer= function (json) {
            var obj =JSON.parse(json);
            var querySql = obj.query;
            var db = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');
            db.query(querySql).then(function (res) {
                var response = {status: 'success', result: JSON.stringify(res)};
                //ajaxSendDataToServer(response);
            }, function (err) {
                var response = {status: 'fail', result: JSON.stringify(err)};
                //ajaxSendDataToServer(response);
            });

        };


        function ajaxSendDataToServer(data){
            var url = "need a actual url";
            jQuery.ajax({
                type:"POST",
                url:url,
                dataType:"json",
                data : JSON.stringify(data),
                contentType:"application/json; charset=utf-8",
                success:function(response){
                   console.log("send data to server success");
                },
                error:function(error,data,errorThrown){
                    console.log("send data to server fail");
                }
            });
        }

        return SyncDataService;

    }]);