app.factory('SystemConfigService', ['$q', 'database', function ($q,database) {
    var SystemConfigService = {};

    var systemConfigDao = new DatabaseFuncDelegate($q, database, 'pos_system_config');

    SystemConfigService.getAllConfigs = function(){
        return Utils.deferredCallback($q, systemConfigDao.all(), function (result) {
          
            var output = {};
            for(var idx in result){
                var row = result[idx];
                output[row.systemConfigName] = row;
            }
            return output;
        }); 
    };

    SystemConfigService.batchSaveConfig = function(configs, cb){
        var existConfig = function(key, value, cb){
            var sql = "select guid from pos_system_config where systemConfigName='"+key+"'";
            systemConfigDao.query(sql).then(function(result){
                return cb(result.detail.length > 0, key, value);
            });
        };
        var queries = [];
        var count = 0;
        var finishedCount = 0;
        for(var configKey in configs){
            count++;
            existConfig(configKey, configs[configKey],function(existed, key, value){
                finishedCount++;
                if(existed){
                    queries.push({ query: "update pos_system_config set systemConfigValue='" + value + "' where systemConfigName='" + key + "'" });
                }
                else{
                    queries.push({ query: "insert into pos_system_config (guid, systemConfigName,systemConfigValue) values ('" + systemConfigDao.guid() + "','" + key + "','" + value + "')" });
                }
            });            
        }

        var executeQueryFallback = function(){
            window.setTimeout(function(){
                if(count == finishedCount){
                    systemConfigDao.queryTransaction(queries).then(function(resultList){
                        cb(null, resultList);
                    }, function(err){
                        cb(err);
                    });
                }
                else{
                    executeQueryFallback();
                }
            }, 10);
        };
        executeQueryFallback();
    };
    
    
    SystemConfigService.addOrModSystemconfig = function (systemconfig,cb) {

        var sql = "select * from pos_system_config where systemConfigName='" + systemconfig.systmConfigName + "'";
        var curSystemConfig = null;
        systemConfigDao.query(sql).then(function (result) {
            curSystemConfig = result.detail;
        }, function (err) {
            return cb(err);
        }).then(function (o) {
            if (null == curSystemConfig)
                sql = "INSERT INTO pos_system_config (guid, systemConfigName, systemConfig_Alias, systemConfigValue, valueType, mdId,  ) VALUES ('mdId', 'DataInitedTime', NULL, '2016-03-07 10:33:56',NULL, NULL)";
            else
                sql = "update pos_system_config set systemConfigValue='" + systemconfig.systemConfigValue + "' where systemConfigName='" + systemconfig.systmConfigName + "'";

            systemConfigDao.query(sql).then(function (result) {
                return cb(null, systemconfig);
            }, function (err) {
                return cb(err);
            });
        })


    }
    
    SystemConfigService.setInitSystemconfig = function (obj) {
        //console.log(obj)
       var sql = "INSERT INTO pos_system_config (guid, systemConfigName, systemConfigAlias, systemConfigValue, valueType, mdId,  operatorTime)" +
                    " VALUES ('" + systemConfigDao.guid()+ "', '" + obj.systmConfigName + "', '" + obj.systemConfigAlias +
                    "', '" + obj.systemConfigValue + "', '" + obj.valueType + "', '" + obj.mdId + "', '" + obj.operatorTime +
                    "')";
        systemConfigDao.query(sql)
        //console.log(sql)
    }

    SystemConfigService.reInitOrgInfo = function (cb)
    {
        SystemConfigService.getAllConfigs().then(function (configs) {

            if (configs['hyOrigin'] || !configs['GroupID'])
                return cb();

            var groupid = configs['GroupID'].systemConfigValue;
            var orgid = configs['MD_ID'].systemConfigValue;
            var url = SERVER_HOST.BASE_HOST + API_CONTEXT.BASIC + INIT.CONFIG.url;
            callAjax(url, function (response) {
                if (response.status != "success") {
                    cb();
                    return Utils.showFailureInfo(result.msg);
                }
                var MDInfo = response.data;

                SystemConfigService.batchSaveConfig({
                    "hyControl": ( MDInfo.hyControl == null ||  MDInfo.hyControl == "null") ? "" :  MDInfo.hyControl,
                    "kcControl": ( MDInfo.kcControl == null ||  MDInfo.kcControl == "null") ? "" :  MDInfo.kcControl,
                    "yyOrigin": ( MDInfo.yyOrigin == null ||  MDInfo.yyOrigin == "null") ? "" :  MDInfo.yyOrigin,
                    "hyOrigin": ( MDInfo.hyOrigin == null ||  MDInfo.hyOrigin == "null") ? "" :  MDInfo.hyOrigin,
                    "kcorigin": ( MDInfo.kcorigin == null ||  MDInfo.kcorigin == "null") ? "" :  MDInfo.kcorigin,
                    "sgfdorigin": ( MDInfo.sgfdorigin == null ||  MDInfo.sgfdorigin == "null") ? "" :  MDInfo.sgfdorigin,
                    "controlModel": ( MDInfo.controlModel == null ||  MDInfo.controlModel == "null") ? "" :  MDInfo.controlModel
                }, function (err, results) {
                    return cb();
                    if (err) {

                    }
                    
                })

            }, JSON.stringify({ "groupId": groupid, "guid": orgid }),
                "POST",
                function (xhr, status, error, data) {
                    //responseError(urlModel.tableName, urlModel.desc, error, data, status);
                    return cb();
                });

        }, function (err) {
            return cb();
        });
    }

    return SystemConfigService;
}]);