app.factory('UploadService', ['$q', 'database', '$http', "$window", 'PrintReportService','GuqingService', function ($q, database, $http, $window, PrintReportService, GuqingService) {
    var UploadService = {};

    var billingDao = new DatabaseFuncDelegate($q, database, 'pos_billing');

    var running = false;
    var orderinterval = 300000;//300000; // 营业数据同步间隔时间 5分钟
    //var zhuotaiinterval = 60000; // 监控信息同步间隔时间 1分钟
	
    UploadService.POSURL = SERVER_HOST.BASE_HOST + API_CONTEXT.POS;/// 'http://192.168.1.92:8080/sop-pos-api'; CONSTANTS.SystemConfigs["ServerHost"] + "/sop-pos-api";
    UploadService.UPLOAD_CURRENT_DATA_URL = POS_API_URL.UPLOUD_TEMPLE_URL;//"/api/v1/posdata/save?t=11111&token=111111";

    UploadService.startup = function () {
        running = true;
        $window.setTimeout(UploadService._runorder, orderinterval);
        //$window.setTimeout(UploadService._runzhuotai, zhuotaiinterval);
        Utils.setInterval(UploadService.uploadLogs, orderinterval);
    }

    UploadService._runorder = function () {

        UploadService.uploadOrder(10, function (err) {
            $window.setTimeout(UploadService._runorder, orderinterval);
        });
    }

    //查询参数，可扩展
    function QueryParamBean() {
        this.orderIdincondition = null;
        this.jieSuanNocondition = null;
        this.bancicondition = null;
        this.guidconfition = null;
        this.jieSuanIdCondition = null;
    }

    UploadService.uploadOrder = function (limitsize,cb)
    {
        if (!limitsize)
            limitsize = 10;
        if (!BIZCONSTANT.POSUSER || BIZCONSTANT.POSUSER == null) {
            BIZCONSTANT.POSUSER = new PosUser();
        }

        var url = POS_API_URL.UPLOUD_ORDERDATA_URL;//"/api/v1/syncdata?t=11111&token=111111";
        var sql = "select * from pos_billing where syn=" + BIZCONSTANT.DATA_UPLOADED_NO + " limit 0 , " + limitsize;
        try {
            billingDao.query(sql)
                .then(function (result) {
                    if (result.detail.length <= 0)
                        return cb(null);
                    var orderIdincondition = '';
                    var jieSuanNocondition = '';
                    var bancicondition = '';
                    var guidconfition = '';

                    for (var i in result.detail) {
                        orderIdincondition += "'" + result.detail[i].orderId + "' ,";
                        jieSuanNocondition += "'" + result.detail[i].jieSuanNo + "' ,";
                        bancicondition += "'" + result.detail[i].banci + "' ,";
                        guidconfition += "'" + result.detail[i].guid + "' ,";
                    }

                    orderIdincondition = orderIdincondition.substr(0, orderIdincondition.length - 1);
                    jieSuanNocondition = jieSuanNocondition.substr(0, jieSuanNocondition.length - 1);
                    bancicondition = bancicondition.substr(0, bancicondition.length - 1);
                    guidconfition = guidconfition.substr(0, guidconfition.length - 1);

                    var queryParamBean = new QueryParamBean();
                    queryParamBean.orderIdincondition = orderIdincondition;
                    queryParamBean.jieSuanNocondition = jieSuanNocondition;
                    queryParamBean.bancicondition = bancicondition;
                    queryParamBean.guidconfition = guidconfition;

                    doSynOrderInfo(queryParamBean, function(requestdata){
                        if(requestdata == null) requestdata = [];
                        requestdata.push({ tablename: 'pos_billing', data: result.detail });
                        var request = {};

                        request.datalist = requestdata;

                        BIZCONSTANT.POSUSER.json4common(request);
                        doSynRquest(request, url, cb,guidconfition);
                    });
                });
        } catch (e)
        {
            if (cb)
                cb(e.message);
        }
    }


	UploadService.syncPrinter = function(printer){
		if (!BIZCONSTANT.POSUSER || BIZCONSTANT.POSUSER == null){
            BIZCONSTANT.POSUSER = new PosUser();
        }
		var postData = {guid:printer.id,status:printer.status,code:printer.code,name:printer.name};
		BIZCONSTANT.POSUSER.json4common(postData);
		$.ajax({
			type: "POST",
			url: UploadService.POSURL + POS_API_URL.UPLOUD_PRINTER_URL,//"/api/v1/syncdata/printer?t=11111&token=111111",
			dataType: "json",
			contentType: "application/json; charset=utf-8",
			data: JSON.stringify(postData),
			success: function (response) {
				
			},
			error: function (error, data, errorThrown) {
				
			}
		});
	};
	

	UploadService.syncJieban = function (jiebanObj, cb) {

	    UploadService.uploadOrder(10, function (err) {
	        if (!BIZCONSTANT.POSUSER || BIZCONSTANT.POSUSER == null) {
	            BIZCONSTANT.POSUSER = new PosUser();
	        }

	        var requestdata = [{ tablename: 'pos_banci', data: jiebanObj }];
	        var request = {};

	        request.datalist = requestdata;

	        BIZCONSTANT.POSUSER.json4common(request);

	        $.ajax({
	            type: "POST",
	            url: UploadService.POSURL + POS_API_URL.UPLOUD_ORDERDATA_URL,//"/api/v1/syncdata?t=11111&token=111111",
	            dataType: "json",
	            contentType: "application/json; charset=utf-8",
	            data: JSON.stringify(request),
	            success: function (response) {
	                cb()
	            },
	            error: function (error, data, errorThrown) {
	                console.error(error)
	            }
	        });
	    });
		
	};

    //上传未结算桌台 相关的营业数据
    UploadService.syncUnJieSuanZhuoTaiData = function(dataContainer, callback) {
        if (!BIZCONSTANT.POSUSER || BIZCONSTANT.POSUSER == null) {
            BIZCONSTANT.POSUSER = new PosUser();
        }
        //所有未结算桌台
        var sql = "select * from pos_zhuotai where orderId is not null";
        billingDao.query(sql).then(function(result1) {
                if(result1.detail.length <= 0) {
                    return callback(dataContainer);
                }
                var orderIdincondition = '';
                for (var i in result1.detail) {
                    if(result1.detail[i].orderId && result1.detail[i].orderId.length > 0)
                        orderIdincondition += "'" + result1.detail[i].orderId + "' ,";
                }
                orderIdincondition = orderIdincondition.substr(0, orderIdincondition.length - 1);
                sql = "select * from pos_billing where orderId in (" + orderIdincondition + ")";
                var bancicondition = '';
                var guidconfition = '';
                var jieSuanNocondition = '';
                var jieSuanIdCondition = '';
                billingDao.query(sql).then(function(result2) {
                        for (var j in result2.detail) {
                            if(result2.detail[j].banci && result2.detail[j].banci.length > 0)
                                bancicondition += "'" + result2.detail[j].banci + "' ,";

                            if(result2.detail[j].guid && result2.detail[j].guid.length > 0)
                                guidconfition += "'" + result2.detail[j].guid + "' ,";

                            if(result2.detail[j].jieSuanNo && result2.detail[j].jieSuanNo.length > 0)
                                jieSuanNocondition += "'" + result2.detail[j].jieSuanNo + "' ,";

                            if(result2.detail[j].jieSuanId && result2.detail[j].jieSuanId.length > 0)
                                jieSuanIdCondition += "'" + result2.detail[j].jieSuanId + "' ,";
                        }

                        jieSuanNocondition = jieSuanNocondition.substr(0, jieSuanNocondition.length - 1);
                        bancicondition = bancicondition.substr(0, bancicondition.length - 1);
                        guidconfition = guidconfition.substr(0, guidconfition.length - 1);
                        jieSuanIdCondition = jieSuanIdCondition.substr(0, jieSuanIdCondition.length - 1);

                        var queryParamBean = new QueryParamBean();
                        queryParamBean.orderIdincondition = orderIdincondition;
                        queryParamBean.jieSuanNocondition = jieSuanNocondition;
                        queryParamBean.bancicondition = bancicondition;
                        queryParamBean.guidconfition = guidconfition;
                        queryParamBean.jieSuanIdCondition = jieSuanIdCondition;
                        doSynOrderInfo(queryParamBean, function(requestdata){
                            if(requestdata && requestdata.length > 0) {
                                for(var i = 0; i < requestdata.length; i++) {
                                    dataContainer.push(requestdata[i]);
                                }
                            }
                            dataContainer.push({ tablename: 'pos_zhuotai', data: result1.detail }); //桌台数据
                            dataContainer.push({ tablename: 'pos_billing', data: result2.detail }); //pos_billing数据
                            if(callback)
                            return callback(dataContainer);
                        });
                    }
                );

            }
        );
    }

    //执行账单通信信息，返回要同步的数据(对象数组)
    //queryParamBean查询参数对象
    //callback回调函数
    function doSynOrderInfo(queryParamBean, callback) {
        if(queryParamBeanIsEmpty(queryParamBean)) {
            return callback(null);
        }
        var orderIdincondition = queryParamBean.orderIdincondition;
        var jieSuanNocondition = queryParamBean.jieSuanNocondition;
        var bancicondition = queryParamBean.bancicondition;
        var guidconfition = queryParamBean.guidconfition;
        var jieSuanIdCondition = queryParamBean.jieSuanIdCondition;

        var requestdata = [];

        var pos_billing_detail_sql = null;
        if(jieSuanIdCondition && jieSuanIdCondition.length > 0) {
            pos_billing_detail_sql = "SELECT * FROM pos_billing_detail where jieSuanId in(" + jieSuanIdCondition + ")";
        }else {
            pos_billing_detail_sql = "SELECT * FROM pos_billing_detail where jieSuanNo in(" + jieSuanNocondition + ")";
        }
        billingDao.query(pos_billing_detail_sql)
            .then(function (result) {
                if(result && result.detail && result.detail.length > 0)
                requestdata.push({ tablename: 'pos_billing_detail', data: result.detail });

                billingDao.query("SELECT * from pos_order where guid in (" + orderIdincondition + ")")
                    .then(function (result) {
                        if(result && result.detail && result.detail.length > 0)
                        requestdata.push({ tablename: 'pos_order', data: result.detail });

                        billingDao.query("SELECT * from pos_order_caipin where orderId in (" + orderIdincondition + ")")
                            .then(function (result) {
                                if(result && result.detail && result.detail.length > 0)
                                requestdata.push({ tablename: 'pos_order_caipin', data: result.detail });

                                billingDao.query("select * from pos_order_caipin_kouwei where orderCaipinId in(SELECT guid from pos_order_caipin where orderId in (" + orderIdincondition + "))")
                                    .then(function (result) {
                                        if(result && result.detail && result.detail.length > 0)
                                        requestdata.push({ tablename: 'pos_order_caipin_kouwei', data: result.detail });

                                        billingDao.query("select * from pos_order_caipin_zengsong where orderCaipinId in(SELECT guid from pos_order_caipin where orderId in (" + orderIdincondition + "))")
                                            .then(function (result) {
                                                if(result && result.detail && result.detail.length > 0)
                                                requestdata.push({ tablename: 'pos_order_caipin_zengsong', data: result.detail });

                                                billingDao.query("select * from pos_order_caipin_zuofa where orderCaipinId in(SELECT guid from pos_order_caipin where orderId in (" + orderIdincondition + "))")
                                                    .then(function (result) {
                                                        if(result && result.detail && result.detail.length > 0)
                                                        requestdata.push({ tablename: 'pos_order_caipin_zuofa', data: result.detail });

                                                        billingDao.query("select * from pos_order_scomb_caipin where orderCaipinId in(SELECT guid from pos_order_caipin where orderId in (" + orderIdincondition + "))")
                                                            .then(function (result) {
                                                                if(result && result.detail && result.detail.length > 0)
                                                                requestdata.push({ tablename: 'pos_order_scomb_caipin', data: result.detail });

                                                                billingDao.query("select * from pos_banci_order where  orderId in (" + orderIdincondition + ")")
                                                                    .then(function (result) {
                                                                        if(result && result.detail && result.detail.length > 0)
                                                                        requestdata.push({ tablename: 'pos_banci_order', data: result.detail });

                                                                        billingDao.query("select * from pos_banci where  banCiNo in (" + bancicondition + ")")
                                                                            .then(function (result) {
                                                                                if(result && result.detail && result.detail.length > 0)
                                                                                requestdata.push({ tablename: 'pos_banci', data: result.detail });

                                                                                billingDao.query("select * from pos_order_zhuotai where orderId in (" + orderIdincondition + ")")
                                                                                    .then(function(result){
                                                                                        if(result && result.detail && result.detail.length > 0)
                                                                                            requestdata.push({ tablename: 'pos_order_zhuotai', data: result.detail });
                                                                                        return callback(requestdata);
                                                                                    })
                                                                            })
                                                                    })
                                                            })
                                                    })

                                            })

                                    })

                            });

                    });

            });

    }

    //执行同步请求
    function doSynRquest(requetData, url, cb, guidconfition) {
        $.ajax({
            type: "POST",
            url: UploadService.POSURL + url,
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(requetData),
            success: function (response) {
                if (response.result == 'success') {
                    var sql = "update pos_billing set syn=" + BIZCONSTANT.DATA_UPLOADED_YES + " where guid in (" + guidconfition + ")";
                    billingDao.query(sql);
                }
                //$window.setTimeout(UploadService._runorder, orderinterval);
                if(cb)
                    return cb(null);
            },
            error: function (error, data, errorThrown) {
                //$window.setTimeout(UploadService._runorder, orderinterval);
                if (cb)
                    return cb(data);
            }
        });
    }

    //同步估清数据到云端
    UploadService.uploadGuQingData = function(guQingDataFromDb,callback) {
        UploadService.uploadBeforLogout(guQingDataFromDb, "pos_caipin_guqing", callback);
    }

    //注销主机前搜集上传数据
    UploadService.uploadUnSynData = function (callback) {
        var requestdata = [];
        //估清数据
        GuqingService.getGuQingCaipins(function(err, result) {
                if(result && result.length > 0) {
                    requestdata.push({ tablename: 'pos_caipin_guqing', data: result });
                }

                //查询是否有未上传到云端的账单
                //上传账单......
                    var sql = "select * from pos_billing where syn<>1 or syn=" + BIZCONSTANT.DATA_UPLOADED_NO + " or syn is null and jieSuanNo is not null";
                try {
                    billingDao.query(sql)
                        .then(function (result) {
                            if(result && result.detail.length > 0) {
                                requestdata.push({ tablename: 'pos_billing', data: result.detail });

                                var orderIdincondition = '';
                                var jieSuanNocondition = '';
                                var bancicondition = '';
                                var guidconfition = '';
                                for (var i in result.detail) {
                                    orderIdincondition += "'" + result.detail[i].orderId + "' ,";
                                    jieSuanNocondition += "'" + result.detail[i].jieSuanNo + "' ,";
                                    bancicondition += "'" + result.detail[i].banci + "' ,";
                                    guidconfition += "'" + result.detail[i].guid + "' ,";
                                    orderIdincondition = orderIdincondition.substr(0, orderIdincondition.length - 1);
                                    jieSuanNocondition = jieSuanNocondition.substr(0, jieSuanNocondition.length - 1);
                                    bancicondition = bancicondition.substr(0, bancicondition.length - 1);
                                    guidconfition = guidconfition.substr(0, guidconfition.length - 1);
                                    var queryParamBean = new QueryParamBean();
                                    queryParamBean.orderIdincondition = orderIdincondition;
                                    queryParamBean.jieSuanNocondition = jieSuanNocondition;
                                    queryParamBean.bancicondition = bancicondition;
                                    queryParamBean.guidconfition = guidconfition;
                                    doSynOrderInfo(queryParamBean, function(reqdata){
                                        if(reqdata && reqdata.length > 0) {
                                            for(var i = 0; i < reqdata.length; i++) {
                                                requestdata.push(reqdata[i]);
                                            }
                                        }
                                        //获取未结算桌台营业数据
                                        return UploadService.syncUnJieSuanZhuoTaiData(requestdata, callback);
                                    });
                                }
                            }
                            //获取未结算桌台营业数据
                            return UploadService.syncUnJieSuanZhuoTaiData(requestdata, callback);
                        });
                } catch (e)
                {
                    if (callback)
                        return callback(e.message);
                }
            }
        );

    }

    // zhuotaiObj = {zhuotai:orignal,order:{id:"",status:-1}
    // id为"" 需要后台将桌台订单编号设为null, status为-1则不需要去更新status
    UploadService.syncZhuotai = function(zhuotaiObj){
        if (!BIZCONSTANT.POSUSER || BIZCONSTANT.POSUSER == null){
            BIZCONSTANT.POSUSER = new PosUser();
        }
        BIZCONSTANT.POSUSER.json4common(zhuotaiObj);
        var zhuoTai = zhuotaiObj.zhuotai;
        var sql = "select zt.guid, po.totalPrice, max(po.kaiTaiTime) kaiTaiTime from pos_zhuotai zt left JOIN pos_order po on zt.guid=po.zhuotaiId where zt.guid='" + zhuoTai.guid + "'";
        billingDao.query(sql).then(function(ret){
            if(ret.detail.length > 0) {
                var retData = ret.detail[0];
                zhuoTai.totalPrice = retData.totalPrice;
                zhuoTai.kaiTaiTime = retData.kaiTaiTime;
            }
            var postStr = JSON.stringify(zhuotaiObj);
            //console.info("UploadService.syncZhuotai.postStr : " + postStr);
            $.ajax({
                type: "POST",
                url: UploadService.POSURL + POS_API_URL.UPLOUD_ZHUOTAI_URL,//"/api/v1/syncdata/zhuotai?t=11111&token=111111",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                data: postStr,
                success: function (response) {
                    //console.info("UploadService.syncZhuotai.success : " + response);
                },
                error: function (error, data, errorThrown) {
                    console.info("UploadService.syncZhuotai.error : " + error + " data : " + data);
                }
            });
        }, function(err){
            console.info("UploadService.syncZhuotai : " + err);
        })
    };

    //当桌台属性（包括开台、价格变动等）改变时上传数据(桌台当前数据)
/*    UploadService.synZhuoTaiPro = function(zhuoTaiGuid) {
        console.info("uploading zhuoTai info ...... zhuoTaiGuid : " + zhuoTaiGuid);
        var sql = "select zt.guid, zt.name, zt.orderId, po.totalPrice, max(po.kaiTaiTime) kaiTaiTime from pos_zhuotai zt left JOIN pos_order po on zt.guid=po.zhuotaiId where zt.guid='" + zhuoTaiGuid + "'";
        billingDao.query(sql).then(function(ret){
            if(ret.detail.length > 0) {
                var retData = ret.detail[0];
                var obj = new Object();
                obj.guid = retData.guid;
                obj.name = retData.name;
                obj.name = retData.name;
                obj.orderId = retData.orderId;
                obj.totalPrice = retData.totalPrice;
                obj.kaiTaiTime = retData.kaiTaiTime;
                UploadService.syncZhuotai(obj);
            }
        }, function(err){
            console.info("UploadService.synZhuoTaiPro : " + err);
        })
    }*/

    //注销前上传数据
    //dataAarray对象数组
    UploadService.uploadBeforLogout = function (dataArray, callback) {
        var requestdata = {};
        var dataStr = "";
        if(dataArray && dataArray.length > 0) {
            dataStr = JSON.stringify(dataArray);
        }
        requestdata.data = dataStr;
        requestdata.groupCode = BIZCONSTANT.POSUSER.groupCode;
        requestdata.groupId = BIZCONSTANT.POSUSER.groupId;
        requestdata.orgid = BIZCONSTANT.POSUSER.mdId;

        console.info("requestData befor logout  : " + "dataArray : " + JSON.stringify(requestdata));
        $.ajax({
            type: "POST",
            url: UploadService.POSURL + UploadService.UPLOAD_CURRENT_DATA_URL,
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(requestdata),
            success: function (response) {
                //console.info("response after upload : " + response);
                if (response.status == 'success') {
                    if(callback)
                        return callback(true);
                }
            },
            error: function (error, data, errorThrown) {
                console.info(error + data + errorThrown);
                if (callback)
                   return callback(false);
            }
        });

        //上传日志信息
        UploadService.uploadLogs(true);

    }

    function DBDATAWrapper() {
        this.dao = null;
        this.data = null;
    }
    //恢复现场数据
    UploadService.getUploadData = function(callback) {
        var requestdata = {};
        requestdata.groupCode = BIZCONSTANT.POSUSER.groupCode;
        requestdata.groupId = BIZCONSTANT.POSUSER.groupId;
        requestdata.orgid = BIZCONSTANT.POSUSER.mdId;
        try{
            $.ajax({
                type: "POST",
                url: UploadService.POSURL + POS_API_URL.FIND_TEMPLE_URL,//"/api/v1/posdata/find?t=11111&token=111111",
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                data: JSON.stringify(requestdata),
                success: function (response) {
                    console.log("UploadService.getUploadData.response : " + JSON.stringify(response));
                    if(!response.data || !response.data.data) return callback(null);
                    var dataObj = JSON.parse(response.data.data);
                    var delSql = [];
                    var dbDataWrapper = [];
                    for(var i = 0; i < dataObj.length; i++) {
                        var obj = dataObj[i];
                        var tablename = obj.tablename;
                        var tabledata = obj.data;
                        if(tabledata && tabledata.length > 0) {
                            //删除已存在的数据
                            var guids = [];
                            for(var j = 0; j < tabledata.length; j++) {
                                var td = tabledata[j];
                                var guid = td.guid;
                                guids.push("'" + guid + "'");
                            }

                            var sql = "delete from " + tablename + " where guid in (" + guids.join(",") + ")";
                            delSql.push({query:sql});
                            var dao = new DatabaseFuncDelegate($q, database, tablename);
                            var wrapper = new DBDATAWrapper();
                            wrapper.dao = dao;
                            wrapper.data = tabledata;
                            dbDataWrapper.push(wrapper);
                        }
                    }
                    console.info("delSql : ");
                    console.info(delSql);
                    //执行批量删除
                    if(delSql.length > 0) {
                        billingDao.queryTransaction(delSql).then(function(res){
                            console.log("billingDao.queryTransaction(delSql) : ");
                            console.log(res);
                            if(res.result == 200) {
                                console.info(res);
                                //批量新增
                                if(dbDataWrapper.length > 0) {
                                    for(var i = 0; i < dbDataWrapper.length; i++) {
                                        var dao = dbDataWrapper[i].dao;
                                        var data = dbDataWrapper[i].data;
                                        dao.insertBatch(data);
                                    }
                                }
                            }
                            return callback(null);
                        }, function (err) {
                            console.info(err);
                            return callback(error);
                        });
                    }else {
                        return callback(null);
                    }
                },
                error: function (error, data, errorThrown) {
                    console.info(error + data + errorThrown);
                    return callback(error);
                }
            });
        }catch (e) {
            console.log(e);
        }
    }

    function queryParamBeanIsEmpty(queryParamBean) {
        if(queryParamBean == null || queryParamBean == undefined) return true;
        if((!queryParamBean.orderIdincondition || queryParamBean.orderIdincondition.length <= 0) &&
            (!queryParamBean.jieSuanNocondition || queryParamBean.jieSuanNocondition.length <= 0) &&
            (!queryParamBean.bancicondition || queryParamBean.bancicondition.length <= 0) &&
            (!queryParamBean.guidconfition || queryParamBean.guidconfition.length <= 0)
        ) return true;
        return false;
    }

    //上传操作日志，每次上传50条数据
    //uploadAll 是否全部上传
    UploadService.uploadLogs = function(uploadAll) {
        //console.info("uploadALl tag : " + uploadAll);
        var sql = "SELECT guid, type, operationUser, operatonDateTime, operationAddress, operationDesc, operationType FROM sys_log where syn=0 ORDER BY operatonDateTime asc ";
        if(uploadAll && uploadAll == true) {
        }else {
            sql += " limit 50";
        }
        billingDao.query(sql).then(function(res){
            if(res.detail && res.detail.length > 0) {
                var requestdata = [{ tablename: 'sys_log', data: res.detail }];
                var request = {};
                request.datalist = requestdata;
                BIZCONSTANT.POSUSER.json4common(request);
                var url = UploadService.POSURL + POS_API_URL.UPLOUD_ORDERDATA_URL;//"/api/v1/syncdata?t=11111&token=111111";
                callAjax(url, function(response){
                    if (response.result == 'success') {
                        var guidconfition = [];
                        for(var i = 0; i < res.detail.length; i++) {
                            var guid = res.detail[i].guid;
                            guidconfition.push("'" + guid + "'");
                        }
                        guidconfition = guidconfition.join(",");
                        //console.info("upload log success! guids : " + guidconfition);
                        var sql = "update sys_log set syn=" + BIZCONSTANT.DATA_UPLOADED_YES + " where guid in (" + guidconfition + ")";
                        billingDao.query(sql);
                    }
                }, JSON.stringify(request), null, function(err){
                    console.info(err);
                })
            }
        })
    }

    return UploadService;

}]);