app.factory('WaimaiService', ['$q', "$rootScope", 'database', 'PrintService', 'UploadService', 'GuqingService', 'UniqueIDService', 'ZhangdanQueryService',
    'DiancaiService', 'JieSuanService', 'CaipinService',
    function ($q, $rootScope, database, PrintService, UploadService, GuqingService, UniqueIDService, ZhangdanQueryService, DiancaiService, JieSuanService, CaipinService) {
    var WaimaiService = {};

    var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');
    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');
    var caipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_zuofa');
    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');
    var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');
    var orderScombCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_scomb_caipin');
    var kouweiDao = new DatabaseFuncDelegate($q, database, 'pos_kouwei');
    var zuofaTypeDao = new DatabaseFuncDelegate($q, database, 'pos_zuofa_type');
    var zuofaDao = new DatabaseFuncDelegate($q, database, 'pos_zuofa');
    var orderCaipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zuofa');
    var orderCaipinKouweiDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_kouwei');
    var tuicaiReasonDao = new DatabaseFuncDelegate($q, database, 'pos_tuicai_reason');
    var zengsongReasonDao = new DatabaseFuncDelegate($q, database, 'pos_zengsong_reason');
    var orderCaipinZengsongDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zengsong');
    var caipinUnitDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_unit');
    var dishGuqingDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_guqing');
    var orderZhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_order_zhuotai');

    //根据外卖订单菜品组装pos订单菜品
    WaimaiService.getOrderCaipinsByWaimaiCaipins = function (waimaiCaipins, cb) {
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var conditions = [];
        var incondition = '';
        for (var i in waimaiCaipins)
        {
            conditions.push(waimaiCaipins[i].dishId);
        }
        incondition = "'" + conditions.join("','") + "'";
        var sql = "select c.*,ct.dishTypeCode as ct_code,ct.dishTypeName as ct_name from pos_caipin c " +
            "left join pos_caipin_type ct on ct.guid=c.typeId " +
            "where c.isDeleted='false' and (c.guid in (" + incondition + ") OR (priceChange='true' AND name='餐盒打包费' OR name='配送费') or (customize='true' and name='自定义外卖')) order by priceChange";
        caipinDao.query(sql).then(function (result) {

            if(Utils.isEmpty(result.detail)){
                return cb({message:"外卖订单中的菜品不存在"});
            } else {
                var orderCaipins = [];
                var hasscomb = false;
                for(var i = 0; i<waimaiCaipins.length; i++){
                    var waimaiCaipin = waimaiCaipins[i];
                    var posCaipin = Utils.arrayFind(result.detail, waimaiCaipin.dishId, "guid");
                    if(posCaipin == null){
                        //如果外卖订单的菜在系统中不存在，按临时菜处理
                        var selfCaipin = Utils.arrayFind(result.detail, '自定义外卖', "name");
                        if(selfCaipin != null){
                            var orderCaipin = makeOrderCaipin(waimaiCaipin, selfCaipin,true);
                            orderCaipins.push(orderCaipin);
                        } else {
                            return cb({message:"外卖订单中的菜品【"+waimaiCaipin.dishName+"】不存在"});
                        }
                    } else {
                        if (posCaipin.isScomb == 'true')
                            hasscomb = true;
                        var orderCaipin = makeOrderCaipin(waimaiCaipin, posCaipin);
                        orderCaipins.push(orderCaipin);
                    }
                }
                var packagefee = Utils.arrayFind(result.detail, '餐盒打包费', "name");
                if (packagefee)
                    orderCaipins.push(makeOrderCaipin(null, packagefee));
                var deliverfeel = Utils.arrayFind(result.detail, '配送费', "name");
                if (deliverfeel)
                    orderCaipins.push(makeOrderCaipin(null, deliverfeel));

                if (hasscomb)
                {
                    return CaipinService.getScombInfoByIds(incondition, function (err, scomblist) {
                        if (err != null)
                            return cb({ message: '查询套餐失败：' + err.message });
                        for (var i in orderCaipins) {
                            var dish = orderCaipins[i];

                            if (dish.isScomb == 'true') {
                                var scombinfo = Utils.arrayFind(scomblist, dish.caipinId, "guid");
                                if (!scombinfo)
                                {
                                    return cb({ message: dish.name + ' 套餐明细查询失败' });
                                }
                                for (var si in scombinfo.scombCaipins)
                                    dish.scombCaipins.push(makeOrderCaipin(null, scombinfo.scombCaipins[si].scombCaipinInfo));
                            }
                        }
                        return cb(null, orderCaipins);
                    });
                }

                return cb(null, orderCaipins);
            }

        }, function (error) {
            return cb(error);
        });

        var makeOrderCaipin = function makeOrderCaipin(waimaiCaipin, posCaipin,USEWM) {
            var orderCaipin = new OrderCaipin();
            orderCaipin.guid = Utils.guid();
            orderCaipin.caipinId = posCaipin.guid;
            orderCaipin.orderCaipinType = 1;
            orderCaipin.name = USEWM ? waimaiCaipin.dishName : posCaipin.name;// posCaipin ? posCaipin.name : waimaiCaipin.dishName;//waimaiCaipin ? waimaiCaipin.dishName : posCaipin.name;
            orderCaipin.price = waimaiCaipin ? waimaiCaipin.priceUnit : 0;
            orderCaipin.num = waimaiCaipin ? waimaiCaipin.dishNum : 1;
            orderCaipin.tuiNum = 0;
            orderCaipin.zengNum = 0;
            orderCaipin.unitId = posCaipin.unitId;
            orderCaipin.unitName = posCaipin.unitName;
            orderCaipin.printId = posCaipin.printId;
            orderCaipin.printName = posCaipin.printName;
            orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
            orderCaipin.minAgio = posCaipin.minAgio;
            orderCaipin.danPinBiLiZheKou = 0;
            orderCaipin.danPinJineZheKou = 0;
            orderCaipin.danPinZheKou = 0;
            orderCaipin.luodan = 1;
            orderCaipin.zheQianMoney = Utils.mnan(orderCaipin.num) * Utils.mnan(orderCaipin.price);//waimaiCaipin ? waimaiCaipin.priceUnit : 0;
            orderCaipin.shiShouMoney = Utils.mnan(orderCaipin.num) * Utils.mnan(orderCaipin.price);
            orderCaipin.dianCaiYuan = $rootScope.curUser.id;
            orderCaipin.dianCaiYuanName = $rootScope.curUser.name;
            orderCaipin.operator = $rootScope.curUser.id;
            orderCaipin.modTime = now;
            orderCaipin.dianCaiTime = now;
            orderCaipin.luoDanTime = now;
            orderCaipin.jieSuanTime = now;
            orderCaipin.needweigh = 0;
            orderCaipin.caipinTypeId = posCaipin.typeId;
            orderCaipin.caipinTypeCode = posCaipin.ct_code;
            orderCaipin.caipinTypeName = posCaipin.ct_name;
            orderCaipin.hyPrice = posCaipin.hyPrice;
            orderCaipin.caiwuTypeId = posCaipin.caiwuTypeId;
            orderCaipin.caiwuTypeName = posCaipin.caiwuTypeName;
            orderCaipin.priceChange = posCaipin.priceChange;
            orderCaipin.isScomb = posCaipin.isScomb;
            orderCaipin.customize = posCaipin.customize;
            return orderCaipin;
        }
    }

	var isWMOrderProcessing = false;
    //接受外卖订单
    WaimaiService.acceptWaimaiOrder = function (waimaiOrder, cb) {
    	if(isWMOrderProcessing){
    		window.setTimeout(function(){
				WaimaiService.acceptWaimaiOrder(waimaiOrder, cb);
			}, 500);
			return;
    	}
    	isWMOrderProcessing = true;
    	
    	var errorCallback = function(err){ // 下面的错误代码都替换成该方法，以确保出错都会重置该变量
    		isWMOrderProcessing = false;
    		cb(err);
    	}
    	
        //组装外卖订单菜品信息
        WaimaiService.getOrderCaipinsByWaimaiCaipins(waimaiOrder.orderFoodInfo.orderFoodDishInfoList, function(err, posOrderCaipins){
            if (err) {
                return errorCallback(err);
            }
            var orderCaipins = posOrderCaipins;
            var now = new Date();
            //获取订单号
            UniqueIDService.nextSeq(now, 'order', function (err1, seq1, nowdate) {
                if (err1) {
                    return errorCallback(err1);
                }
                var seqNo = nowdate + Utils.formatSeqNo(seq1);
                var zhangDanNo = "ZD" + seqNo;

                //获取结算单号
                UniqueIDService.nextSeq(now, 'jieSuanDan', function (err2, seq2, nowdate2) {
                    if (err2) {
                        return errorCallback(err2);
                    }
                    var seqNo2 = nowdate2 + Utils.formatSeqNo(seq2);
                    var jieSuanNo = "JSD" + seqNo2;

                    var orderId = orderDao.guid();
                    var jieSuanId = Utils.guid();

                    //生成pos订单
                    var order = new Order();
                    order.guid = orderId;
                    order.code = zhangDanNo;
                    order.totalPrice = Utils.mnan(waimaiOrder.originalPrice) - Utils.mnan(waimaiOrder.orderDeliveryInfo.deliverFee);
                    order.renshu = 1;
                    order.serverId = $rootScope.curUser.code;
                    order.serverName = $rootScope.curUser.name;
                    order.serverGuid = $rootScope.curUser.id;
                    order.operator = $rootScope.curUser.id;
                    order.operatorName = $rootScope.curUser.name;
                    order.operatorCode = $rootScope.curUser.code;
                    order.jieSuanOperatorId = $rootScope.curUser.id;
                    order.jieSuanOperatorCode = $rootScope.curUser.code;
                    order.jieSuanOperatorName = $rootScope.curUser.name;
                    order.mdId = $rootScope.curUser.mdId;
                    order.modTime = now.format("yyyy-MM-dd hh:mm:ss");
                    order.kaiTaiTime = now.format("yyyy-MM-dd hh:mm:ss");
                    order.luoDanTime = now.format("yyyy-MM-dd hh:mm:ss");
                    order.jieSuanTime = now.format("yyyy-MM-dd hh:mm:ss");
                    order.isFanJieSuan = BIZCONSTANT.FANJIESUAN_NO;
                    order.fanJieSuanNum = 0;
                    var canbie = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date());
                    order.canbieId = canbie.guid;
                    order.canBieCode = canbie.code;
                    order.canbieName = canbie.name;
                    order.jieSuanCanBieId = canbie.guid;
                    order.jieSuanCanBieCode = canbie.code;
                    order.jieSuanCanBieName = canbie.name;
                    order.jieSuanId = jieSuanId;
                    order.jieSuanNo = jieSuanNo;
                    order.ordersource = waimaiOrder.orderSource;
                    order.banciNo = $rootScope.curUser.banCiHao;
                    order.areaGuid = "9998";
                    order.areaCode = "9998";
                    order.areaName = "外卖区域";
                    order.zhuotaiId = "9999";
                    order.zhuotaiCode = "9999";
                    order.tsAndwm = "WM";
                    order.zhuotaiName = getOrderSourceName(waimaiOrder.orderSource) + " # " + waimaiOrder.tpDaySeq;
                    order.thirdOrderNo = waimaiOrder.orderNo;
                    order.waimaiBoxCharge = waimaiOrder.packageFee;
                    order.waimaiDeliveryCharge = waimaiOrder.orderDeliveryInfo.deliverFee;
                    order.waimaiYouhui = waimaiOrder.elemeHongbao;//todo 暂时保存为红包金额,之后可能修改
                    order.waimaiCustomerName = waimaiOrder.orderDeliveryInfo.receiverName;
                    order.waimaiCustomerPhone = waimaiOrder.orderDeliveryInfo.receiverPhone;
                    order.waimaiCustomerAddress = waimaiOrder.orderDeliveryInfo.address;
                    order.isKaifapiao = waimaiOrder.invoiceType ? 'true' : 'false';
                    order.comments = waimaiOrder.remark;

                    order.waimaiOrder = waimaiOrder;

                    var queries = [];
                    queries.push({
                        query: "insert into pos_order ( " +
                        "guid, code, renshu, totalPrice, status, comments," +
                        " serverId, serverName," +
                        " operator, operatorName,operatorCode, mdId," +
                        "jieSuanOperatorId, jieSuanOperatorCode, jieSuanOperatorName," +
                        " modTime, kaiTaiTime,luoDanTime,jieSuanTime, isDeleted," +
                        " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
                        "jieSuanCanBieId, jieSuanCanBieCode, jieSuanCanBieName, jieSuanId,jieSuanNo, ordersource, banciNo," +
                        " areaGuid, areaCode, areaName, zhuotaiId, zhuotaiCode, zhuotaiName, thirdOrderNo, jieSuanTimeMill," +
                        "waimaiBoxCharge,waimaiDeliveryCharge,waimaiYouhui,waimaiCustomerName,waimaiCustomerPhone,waimaiCustomerAddress,tsAndwm,isKaifapiao) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?)",
                        params: [order.guid,order.code, 1, order.totalPrice , 4, order.comments,
                            order.serverId, order.serverName,
                            order.operator, order.operatorName, order.operatorCode, order.mdId,
                            order.jieSuanOperatorId, order.jieSuanOperatorCode, order.jieSuanOperatorName,
                            order.modTime,order.kaiTaiTime,order.luoDanTime, order.jieSuanTime, false,
                            order.isFanJieSuan, 0, order.canBieCode, order.canbieName,order.canbieId,
                            order.jieSuanCanBieId, order.jieSuanCanBieCode, order.jieSuanCanBieName, order.jieSuanId, order.jieSuanNo, order.ordersource, order.banciNo,
                            order.areaGuid, order.areaCode, order.areaName, order.zhuotaiId, order.zhuotaiCode, order.zhuotaiName, order.thirdOrderNo, now.getTime(),
                            order.waimaiBoxCharge, order.waimaiDeliveryCharge, order.waimaiYouhui, order.waimaiCustomerName, order.waimaiCustomerPhone, order.waimaiCustomerAddress, order.tsAndwm, order.isKaifapiao]
                    });

                    //生成orderZhuotai数据
                    var orderZhuotai = new OrderZhuotai();
                    orderZhuotai.guid = Utils.guid();
                    orderZhuotai.orderId = orderId;
                    orderZhuotai.areaId = "9998";
                    orderZhuotai.areaCode = "9998";
                    orderZhuotai.areaName = "外卖区域";
                    orderZhuotai.renshu = 1;
                    orderZhuotai.hisOrderId = orderId;
                    orderZhuotai.hisOrderCode = zhangDanNo;
                    orderZhuotai.isDeleted = "false";
                    orderZhuotai.zhuotaiId = "9999";
                    orderZhuotai.zhuotaiCode = "9999";
                    orderZhuotai.zhuotaiName = getOrderSourceName(waimaiOrder.orderSource) + " # " + waimaiOrder.tpDaySeq;
                    orderZhuotai.luoDanTime = now.format("yyyy-MM-dd hh:mm:ss");
                    orderZhuotai.totalPrice = order.totalPrice;
                    queries.push({
                        query: "insert into pos_order_zhuotai ( " +
                        "guid, orderId, areaId, areaCode, areaName, renshu, hisOrderId, hisOrderCode, isDeleted," +
                        " zhuotaiId, zhuotaiCode, zhuotaiName, luoDanTime, totalPrice) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                        params: [orderZhuotai.guid, orderZhuotai.orderId, orderZhuotai.areaId, orderZhuotai.areaCode, orderZhuotai.areaName,orderZhuotai.renshu,
                            orderZhuotai.hisOrderId, orderZhuotai.hisOrderCode, orderZhuotai.isDeleted,
                            orderZhuotai.zhuotaiId, orderZhuotai.zhuotaiCode, orderZhuotai.zhuotaiName, orderZhuotai.luoDanTime, orderZhuotai.totalPrice]
                    });

                    var kouweiarr = [];
                    if (waimaiOrder.remark && waimaiOrder.remark.length > 0)
                    {
                        var kouwei = new Kouwei();
                        kouwei.guid = Utils.guid();
                        kouwei.kwCode = '01';
                        kouwei.kwName = waimaiOrder.remark;
                        kouwei.quickCode = waimaiOrder.remark;
                        kouwei.enabled = 'true';
                        kouwei.isDeleted = 'false';
                        kouweiarr.push(kouwei);
                    }

                    if (waimaiOrder.orderType && waimaiOrder.orderType == 'WaimaiBook') {
                        var kouwei = new Kouwei();
                        kouwei.guid = Utils.guid();
                        kouwei.kwCode = '01';
                        kouwei.kwName = "预定单，送达时间 " + (new Date(waimaiOrder.orderDeliveryInfo.bookDeliverTime).format('hh:mm'));
                        kouwei.quickCode = 'YDD';
                        kouwei.enabled = 'true';
                        kouwei.isDeleted = 'false';
                        kouweiarr.push(kouwei);
                    }

                    var printcaipins = [];
                    //保存订单菜品信息
                    for (var idx in orderCaipins) {

                        if (orderCaipins[idx].name === '配送费' && orderCaipins[idx].priceChange === 'true') {
                            if (waimaiOrder.orderDeliveryInfo.type !== 0)
                                continue;
                            orderCaipins[idx].price = waimaiOrder.orderDeliveryInfo.deliverFee;
                            orderCaipins[idx].zheQianMoney = waimaiOrder.orderDeliveryInfo.deliverFee;
                            orderCaipins[idx].shiShouMoney = waimaiOrder.orderDeliveryInfo.deliverFee;
                        }
                        if (orderCaipins[idx].name === '餐盒打包费' && orderCaipins[idx].priceChange === 'true') {
                            orderCaipins[idx].price = waimaiOrder.packageFee;
                            orderCaipins[idx].zheQianMoney = waimaiOrder.packageFee;
                            orderCaipins[idx].shiShouMoney = waimaiOrder.packageFee;
                        }
                        orderCaipins[idx].orderId = orderId;
                        orderCaipins[idx].orderZhuoTaiId = orderZhuotai.guid;
                        queries.push({
                            query: "insert into pos_order_caipin (guid, orderId,caipinId,orderCaipinType,name,price,num,tuiNum,zengNum," +
                            "unitId,unitName,printId,printName,chupin,minAgio,danPinBiLiZheKou,danPinJineZheKou,danPinZheKou,luodan," +
                            "zheQianMoney,shiShouMoney,zheKouMoney,fenTanSumMoney,moLingMoney,zuoFaZheQianTotal,zuoFaShiShouTotal,zuoFaZheKouTotal,zuoFaFenTanTotal," +
                            "zuoFaMoLingTotal,dianCaiYuan,dianCaiYuanName,operator,modTime,dianCaiTime,luoDanTime,jieSuanTime,needweigh," +
                            "caipinTypeId,caipinTypeCode,caipinTypeName,hyPrice,caiwuTypeName,caiwuTypeId,orderZhuoTaiId,priceChange,weight) " +
                            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?)",
                            params: [orderCaipins[idx].guid, orderId, orderCaipins[idx].caipinId, orderCaipins[idx].orderCaipinType, orderCaipins[idx].name, orderCaipins[idx].price,
                                orderCaipins[idx].num, orderCaipins[idx].tuiNum, orderCaipins[idx].zengNum, orderCaipins[idx].unitId, orderCaipins[idx].unitName, orderCaipins[idx].printId,
                                orderCaipins[idx].printName, orderCaipins[idx].chupin, orderCaipins[idx].minAgio, orderCaipins[idx].danPinBiLiZheKou, orderCaipins[idx].danPinJineZheKou,
                                orderCaipins[idx].danPinZheKou, orderCaipins[idx].luodan, orderCaipins[idx].zheQianMoney, orderCaipins[idx].shiShouMoney, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00,
                                0.00, 0.00, orderCaipins[idx].dianCaiYuan,orderCaipins[idx].dianCaiYuanName, orderCaipins[idx].operator, orderCaipins[idx].modTime,orderCaipins[idx].dianCaiTime,
                                orderCaipins[idx].luoDanTime, orderCaipins[idx].jieSuanTime, orderCaipins[idx].needweigh, orderCaipins[idx].caipinTypeId,orderCaipins[idx].caipinTypeCode,
                                orderCaipins[idx].caipinTypeName,orderCaipins[idx].hyPrice, orderCaipins[idx].caiwuTypeName, orderCaipins[idx].caiwuTypeId, orderZhuotai.guid, orderCaipins[idx].priceChange,0]
                        });

                        if (orderCaipins[idx].isScomb == 'true') {
                            for (var i = 0; i < orderCaipins[idx].scombCaipins.length; i++) {
                                var scombCaipin = orderCaipins[idx].scombCaipins[i];

                                //var scombCaipin = createOrderScombCaipin(operator, orderCaipin, scombdish);
                                debugger;
                                queries.push({
                                    query: "insert into pos_order_scomb_caipin ( " +
                                    "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                                    "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
                                    "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
                                    "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?)",
                                    params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                                        scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                                        scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                                        scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName, scombCaipin.dianCaiTime, scombCaipin.modTime,
                                        scombCaipin.needweigh, orderCaipins[idx].isScomb, scombCaipin.caipinId, scombCaipin.costprice,
                                        scombCaipin.hyPrice, scombCaipin.caipinTypeId, scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName]
                                });

                                if (kouweiarr && kouweiarr.length > 0) {
                                    var isscomb = 'true';
                                    var scombid = null;
                                    if (isscomb == 'true')
                                        scombid = orderCaipins[idx].guid;
                                    for (var skidx in kouweiarr) {
                                        var kouwei = kouweiarr[skidx];
                                        kouwei.guid = Utils.guid();
                                        //kouwei.kwCode = '01';
                                        //kouwei.kwName = waimaiOrder.remark;
                                        //kouwei.quickCode = waimaiOrder.remark;
                                        //kouwei.enabled = 'true';
                                        //kouwei.isDeleted = 'false';

                                        queries.push({
                                            query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb,orderScombCaipinId) values(?, ?, (select guid from pos_kouwei where kwcode='01'), ?, ?, datetime('now', 'localtime'), ?, ?)",
                                            params: [kouwei.guid, scombCaipin.guid, kouwei.kwName, scombCaipin.dianCaiYuan, isscomb, scombid]

                                        });
                                        scombCaipin.kouweis.push(kouwei);
                                    }
                                }

                            }
                        }

                        if (kouweiarr && kouweiarr.length > 0) {
                            var isscomb = orderCaipins[idx].isScomb;
                            var scombid = null;
                            if (isscomb == 'true')
                                scombid = orderCaipins[idx].guid;
                            for (var sidx in kouweiarr) {
                                var kouwei = kouweiarr[sidx];
                                kouwei.guid = Utils.guid();
                                //kouwei.kwCode = '01';
                                //kouwei.kwName = waimaiOrder.remark;
                                //kouwei.quickCode = waimaiOrder.remark;
                                //kouwei.enabled = 'true';
                                //kouwei.isDeleted = 'false';

                                queries.push({
                                    query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb,orderScombCaipinId) values(?, ?, (select guid from pos_kouwei where kwcode='01'), ?, ?, datetime('now', 'localtime'), ?, ?)",
                                    params: [kouwei.guid, orderCaipins[idx].guid, kouwei.kwName, orderCaipins[idx].dianCaiYuan, isscomb, scombid]

                                });
                                orderCaipins[idx].kouweis.push(kouwei);
                            }
                        }

                        printcaipins.push(orderCaipins[idx]);
                    }
                    order.orderCaipins = printcaipins;

                    //建立结算单
                    queries.push({
                        query: "insert into pos_billing ( " +
                        "guid, orderId, orderNo, zhangDanTotal, shiShou, zhaoLing, zheKouTotal, fenTanTotal, moLing, jieSuanNo, banci, canbieId, canbieCode, canBieName, " +
                        "device, memo, mdId, createTime, addOperatorId, addOperatorCode, addOperatorName, moneyTuiDan, moneyZengSong, moneyZheKou, moneyDanPin," +
                        "moneyZhengDanBiLi, isFanJieSuan, syn, updateTimeMill) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                        params: [jieSuanId, orderId, zhangDanNo, order.totalPrice, order.totalPrice, 0.00, 0.00, 0.00, 0.00, jieSuanNo, $rootScope.curUser.banCiHao, order.canbieId, order.canBieCode, order.canbieName,
                            $rootScope.curUser.device, "外卖", $rootScope.curUser.mdId, now.format("yyyy-MM-dd hh:mm:ss"), $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name,
                            0.00, 0.00, 0, 0, 0, '0', 0, now.getTime()]
                    });

                    //保存billing_detail
                    //抹零
                    queries.push({
                        query: 'insert into pos_billing_detail' +
                        '(guid, bizId, bizCode, bizDesc,type,amount,' +
                        'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                        ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                        params:[Utils.guid(), "-1", "-1",  "抹零", "ML", 0.00,
                            jieSuanNo ,BIZCONSTANT.CWKM_YOUMIAN, true, 0, $rootScope.curUser.device,  now.format("yyyy-MM-dd hh:mm:ss"),
                            $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                    });

                    //红包
                    if (Math.abs(Utils.m(waimaiOrder.elemeHongbao)) > 0)
                    {
                        queries.push({
                            query: 'insert into pos_billing_detail' +
                            '(guid, bizId, bizCode, bizDesc,type,amount,' +
                            'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                            ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                            params: [Utils.guid(), "-2", "-2", "红包", "PAY", Math.abs(Utils.m(waimaiOrder.elemeHongbao)),
                                jieSuanNo, BIZCONSTANT.CWKM_SHISHOU, true, 0, $rootScope.curUser.device, now.format("yyyy-MM-dd hh:mm:ss"),
                                $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                        });
                    }

                    //服务费
                    if (waimaiOrder.tpServiceFee && Utils.m(waimaiOrder.tpServiceFee) > 0) {
                        queries.push({
                            query: 'insert into pos_billing_detail' +
                            '(guid, bizId, bizCode, bizDesc,type,amount,' +
                            'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                            ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                            params: [Utils.guid(), "-3", "-3", "服务费", "PAY", Utils.m(waimaiOrder.tpServiceFee),
                                jieSuanNo, BIZCONSTANT.CWKM_YOUMIAN, true, 0, $rootScope.curUser.device, now.format("yyyy-MM-dd hh:mm:ss"),
                                $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                        });
                    }

                    //外卖付款
                    var waimaiPM = BIZCONSTANT.getPMbyCode(BIZCONSTANT.PM_WAIMAI);
                    queries.push({
                        query: 'insert into pos_billing_detail' +
                        '(guid, bizId, bizCode, bizDesc,type,amount,' +
                        'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                        ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                        params: [Utils.guid(), waimaiPM.pmId, waimaiPM.code, waimaiPM.name, "PAY", Utils.m(waimaiOrder.receivableAmount - Math.abs(Utils.m(waimaiOrder.elemeHongbao))),
                            jieSuanNo ,waimaiPM.caiWuShuXing, waimaiPM.isHyJf, 1, $rootScope.curUser.device,  now.format("yyyy-MM-dd hh:mm:ss"),
                            $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                    });

                    //保存pos_banci_order
                    queries.push({
                        query: "insert into pos_banci_order ( " +
                        "guid, banciNo, orderId, orderCode, createTime, addOperatorId, addOperatorCode, addOperatorName) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?)",
                        params: [Utils.guid(),$rootScope.curUser.banCiHao, orderId, zhangDanNo,now.format("yyyy-MM-dd hh:mm:ss"),
                            $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name ]
                    });

                    orderDao.queryTransaction(queries).then(function (resultList) {
                        
                        var zhuotai = new Zhuotai();
                        zhuotai.name = order.zhuotaiName;
                        zhuotai.order = order;
                        var jieSuan = new JieSuan();
                        JieSuanService.loadByOrderId(order, jieSuan, function (err, mode) {
                            if (err)
                                return errorCallback(err);
                            //打印外卖配送单
                            //window.setTimeout(function () {
                            //    console.log('----------------------'+jieSuan.order.zhuotaiName);
                                jieSuan.order.waimaiOrder = order.waimaiOrder;
                                printhelp.printJieZhangDan(jieSuan, order.orderCaipins, '', jieSuan.asDuiZhangDanView(), false, function () { });
                                printhelp.printWMPeiSong(jieSuan, order.orderCaipins, jieSuan.asDuiZhangDanView(), function () { });

                            //}, 1e3);
                            
                        });
                        
                        //打印外卖制作单
                        printhelp.printzhizuodan(zhuotai, order.orderCaipins, PrintService);
                        printhelp.printhuadan(zhuotai, order.orderCaipins, PrintService);
                        isWMOrderProcessing = false;
                        cb(null);

                    }, function (err) {
                    	errorCallback(err);
                    });

                });
            });
        });

    }

    var getOrderSourceName = function getOrderSourceName(ordersource) {
        if (!ordersource || ordersource == '')
            return '外卖';
        if (ordersource.indexOf('eleme') >= 0)
            return '饿了么';
        if (ordersource.indexOf('meituan') >= 0 || ordersource.indexOf('meituanwaimai') >= 0)
            return '美团外卖';
        if (ordersource.indexOf('baidu') >= 0 || ordersource.indexOf('baiduwaimai') >= 0)
            return '百度外卖';
        if (ordersource.indexOf('WeiXinWaiMai') >= 0)
            return '微信外卖';
        return '外卖';
    }



    //退菜菜品
    var tuiCaiPins = [];
    /**退单
     * waimaiOrder 账单
     * currentOperator 操作员
     * currentTuicaiReason 退菜原因
     * selfTuicaiReason 自定义退菜原因
     */
    WaimaiService.chargeback = function (waimaiOrder, currentOperator, currentTuicaiReason, selfTuicaiReason,cb){
        //根据thirdOrderNo 获取订单号
        var sql = "SELECT * FROM pos_order WHERE thirdOrderNo = '" + waimaiOrder + "'";
        orderDao.query(sql).then(function (res) {
            var order_waimai = res.detail[0];
            //1.反结算该订单
            ZhangdanQueryService.confirmFanJieSuan(order_waimai,'外卖退菜',function(){
                //2.获取所有的菜品，默认情况下是所有的菜品都为落单菜品
                DiancaiService.getOrderCaipinsByLuodan(order_waimai.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, seq) {
                    if(err){
                        return Utils.showFailureInfo('外卖整单退菜时，获取退菜菜品列表失败！')
                    }
                    tuiCaiPins = [];
                    var caipins = seq;
                    tuiCaiPins = seq;
                    var iSalreadyTui = false;
                    //3.整单退单
                    for(var x in caipins){
                        var cp = caipins[x];
                        var bufferNum = cp.num-cp.tuiNum;
                        if(bufferNum > 0){
                            iSalreadyTui = true;
                            if(cp.isScombCaipin()){ //套餐中的菜品退菜
                                DiancaiService.doScombTuicai(currentOperator, cp, currentTuicaiReason,
                                    selfTuicaiReason, bufferNum, function (err, seq) {
                                        if (err) {
                                            return Utils.showFailureInfo(err.message);
                                        }
                                        printtuicai(seq[1],bufferNum);
                                    });
                            }else{
                                DiancaiService.doTuicai(currentOperator,cp, currentTuicaiReason,
                                    selfTuicaiReason, bufferNum, function (err, seq) {
                                        if (err) {
                                            return Utils.showFailureInfo(err.message);
                                        }
                                        printtuicai(seq[1],bufferNum);
                                    });
                            }
                        }


                    }

                    if(iSalreadyTui){
                        WaimaiService.jiesuanAfterFjs(order_waimai,function(e, r){
                            if(e){
                                return Utils.showFailureInfo('退单后结算失败');
                            } else {
                                cb(null,res)
                            }
                        });
                    } else {
                        return Utils.showFailureInfo('已经退菜');
                    }


                })
            },true)
        },function(err) {
            cb(err)
        })
    }


        function printtuicai(cp ,data) {
            console.log(cp + "退菜打印" + data)

            if(data){
                if (cp.isScomb == '1' || cp.isScomb == 'true') {
                    for (var j in cp.scombCaipins) {
                        printtuicaidan(cp.scombCaipins[j], "外卖", data * -1, "外卖退菜");
                    }
                } else{
                    printtuicaidan(cp, "外卖", data * -1, "外卖退菜");
                }
            }else{
                if (cp.isScomb == '1' || cp.isScomb == 'true') {
                    for (var j in cp.scombCaipins) {
                        printtuicaidan(cp.scombCaipins[j], "外卖", data * -1, "外卖退菜");
                    }
                } else{
                    printtuicaidan(cp, "外卖", data * -1, "外卖退菜");
                }
            }



        }

        function printtuicaidan(caipin, zhuotai, tuicainum, reason) {
            var tuicai = new TuiCaiDanObject();
            tuicai.diancaiyuan = BIZCONSTANT.POSUSER.name;
            tuicai.deskNo = zhuotai;
            tuicai.dish = caipin;
            tuicai.tuicainum = tuicainum;
            tuicai.rs = 1;
            tuicai.tuicaiReason = reason;

            var receiptarr = (new printReceipt()).culReceipt(caipin.caipinId, BIZCONSTANT.PRINTINVOCECODE.TUICAIDAN);
            console.log(caipin + "退菜打印" + zhuotai + tuicainum + reason)
            for (var p in receiptarr) {
                var receipt = receiptarr[p];
                var printtext = printhelp.printtext(tuicai, receipt);

                var printjob = new PrinterJob();
                printjob.name = "退菜单";
                printjob.mPrinterId = receipt.printId;
                printjob.status = 0;
                printjob.errorCount = 0;
                printjob.content = printtext;
                printjob.createTime = null;
                printjob.processing = 0;
                printjob.invoiceCode = null;
                printjob.ref = caipin.name;
                printjob.orderId = zhuotai;
                printjob.jobNo = null;
                printjob.printTime = null;
                printjob.printCount = 0;
                PrintService.addJob(printjob);
            }
        }

    //结算
    WaimaiService.jiesuanAfterFjs = function (order, cb) {
        var delSql = [];
        delSql.push({query: "DELETE FROM pos_billing_detail WHERE jieSuanId = (SELECT guid FROM pos_billing WHERE orderId = '" + order.guid + "' AND isFanJieSuan = 0 OR isFanJieSuan ISNULL)"});
        delSql.push({query: "DELETE FROM pos_billing WHERE orderId = '" + order.guid + "' AND isFanJieSuan = 0 OR isFanJieSuan ISNULL"});
        orderDao.queryTransaction(delSql).then(function (res) {
            var insSql = [];
            var now = new Date();
            UniqueIDService.nextSeq(now, 'jieSuanDan', function (err2, seq2, nowdate) {
                if (err2) {
                    return cb(err2);
                }
                var seqNo2 = nowdate + Utils.formatSeqNo(seq2);
                var jieSuanNo = "JSD" + seqNo2;
                var jieSuanId = Utils.guid();
                //建立结算单
                insSql.push({
                    query: "insert into pos_billing ( " +
                    "guid, orderId, orderNo, zhangDanTotal, shiShou, zhaoLing, zheKouTotal, fenTanTotal, moLing, jieSuanNo, banci, canbieId, canbieCode, canBieName, " +
                    "device, memo, mdId, createTime, addOperatorId, addOperatorCode, addOperatorName, moneyTuiDan, moneyZengSong, moneyZheKou, moneyDanPin," +
                    "moneyZhengDanBiLi, isFanJieSuan, syn, updateTimeMill) " +
                    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                    params: [jieSuanId, order.guid, order.code, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, jieSuanNo, $rootScope.curUser.banCiHao, order.canBieId, order.canBieCode, order.canBieName,
                        $rootScope.curUser.device, "外卖", $rootScope.curUser.mdId, now.format("yyyy-MM-dd hh:mm:ss"), $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name,
                        0.00, 0.00, 0.00, 0.00, 0.00, '0', 0, now.getTime()]
                });

                //保存billing_detail
                //抹零
                insSql.push({
                    query: 'insert into pos_billing_detail' +
                    '(guid, bizId, bizCode, bizDesc,type,amount,' +
                    'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                    ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                    params:[Utils.guid(), "-1", "-1",  "抹零", "ML", 0.00,
                        jieSuanNo ,BIZCONSTANT.CWKM_YOUMIAN, true, 0, $rootScope.curUser.device,  now.format("yyyy-MM-dd hh:mm:ss"),
                        $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                });

                //外卖付款
                var waimaiPM = BIZCONSTANT.getPMbyCode(BIZCONSTANT.PM_WAIMAI);
                insSql.push({
                    query: 'insert into pos_billing_detail' +
                    '(guid, bizId, bizCode, bizDesc,type,amount,' +
                    'jieSuanNo,caiWuShuXing,isHyJf,seq, device, createTime,addOperatorId, addOperatorCode, addOperatorName,mdId,jieSuanId) ' +
                    ' values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)',
                    params:[Utils.guid(), waimaiPM.pmId, waimaiPM.code,  waimaiPM.name, "PAY", 0.00,
                        jieSuanNo ,waimaiPM.caiWuShuXing, waimaiPM.isHyJf, 1, $rootScope.curUser.device,  now.format("yyyy-MM-dd hh:mm:ss"),
                        $rootScope.curUser.id, $rootScope.curUser.code, $rootScope.curUser.name, $rootScope.curUser.mdId, jieSuanId]
                });

                //order表更新数据
                insSql.push({query: "UPDATE pos_order SET status = 4, totalPrice = 0.00,jieSuanTime = '" + now.format("yyyy-MM-dd hh:mm:ss") + "', jieSuanNo = '" + jieSuanNo + "', jieSuanId = '" + jieSuanId + "' WHERE guid = '" + order.guid + "'"});

                //orderzhuotai表更新数据
                insSql.push({query: "UPDATE pos_order_zhuotai SET totalPrice = 0.00  WHERE orderId = '"+ order.guid +"'"});

                for(var x in tuiCaiPins){
                    var befferCp = tuiCaiPins[x];
                    var befferTuiObj = {};
                    befferTuiObj.zheQianMoney = (-befferCp.price)*befferCp.tuiNum;
                    befferTuiObj.shiShouMoney = (-befferCp.price)*befferCp.tuiNum;
                    befferTuiObj.guid = befferCp.guid;
                    insSql.push({
                        query: "UPDATE pos_order_caipin SET zheQianMoney = " + befferTuiObj.zheQianMoney + ", shiShouMoney = " + befferTuiObj.shiShouMoney +
                        ", zheKouMoney = 0.00, fenTanSumMoney = 0.00, moLingMoney = 0.00, zuoFaZheQianTotal = 0.00, zuoFaShiShouTotal = 0.00, zuoFaZheKouTotal = 0.00," +
                        " zuoFaFenTanTotal = 0.00, zuoFaMoLingTotal = 0.00, weight = 0" +
                        " WHERE parentId = '"+ befferTuiObj.guid +"'"
                    });
                }



                orderDao.queryTransaction(insSql).then(function (result) {
                    cb(null)

                }, function (err) {
                    cb(err);
                });
            })
        }, function (err) {
            cb(err);
        });



    }

    //记录外卖发过来的日志
    WaimaiService.writeNoteInText = function () {
        var paramarr = [];
        for (var i in arguments)
            paramarr.push(arguments[i]);
        Utils.winLog(paramarr);
    }

    //根据thirdOrderNo 获取订单
    WaimaiService.findOrderByThirdOrderNo = function (thirdOrder, cb) {
        var thirdOrderNo = thirdOrder.orderNo;
        var sql = "SELECT * FROM pos_order WHERE thirdOrderNo = '" + thirdOrderNo + "'";
        orderDao.query(sql).then(function (res) {
            var rtres = { order: thirdOrder ,localorder:null}
            if(res.detail.length > 0){
                rtres.localorder = res.detail[0];
            } else {
                rtres.localorder = null;
            }
            cb(null, rtres);
        },function(err) {
            cb(err)
        })
    }

        //外卖接受订单
        // 记录日志，判断是否重单，以及回调
    WaimaiService.RealacceptWaimaiOrder = function (order, cb)
    {
        //var order = data.message;

        WaimaiService.writeNoteInText('BEGIN--RealacceptWaimaiOrder---frombackjob:', !!order.fromBackJob);
        var orderNo = order.orderNo;
        try {
            var nowtime = parseInt(new Date().getTime() / 1000);
            //if (orderNo && BIZCONSTANT.WAIMAIQUENE[orderNo] && (nowtime - BIZCONSTANT.WAIMAIQUENE[orderNo].exectime) < 300)
            //    return;
            
            if (orderNo && BIZCONSTANT.WAIMAIQUENE[orderNo] && !order.fromBackJob)
                return;

            order.exectime = nowtime;
            if (!order.fromBackJob)
                order.execguid = Utils.guid();
            BIZCONSTANT.WAIMAIQUENE[orderNo] = order;
        } catch (e) {

        }
        console.log("acceptWaimaiOrder begin" + order.execguid);
        WaimaiService.writeNoteInText("acceptWaimaiOrder begin:" + order.orderNo + " - - - " + order.execguid, !!order.fromBackJob);
        //判断第三方订单号是否已存在
        WaimaiService.findOrderByThirdOrderNo(order, function (err1, res) {
            WaimaiService.writeNoteInText("查询订单是否重复--end" + res.order.orderNo + " - - - " + res.order.execguid);
            if (err1) {
                WaimaiService.writeNoteInText(res.order.orderNo + "外卖订单接受失败");
                try {
                    console.log("外卖订单接受失败");
                    WaimaiService.writeNoteInText('外卖订单接受失败,查询是否重单失败');
                    WaimaiService.writeNoteInText(err1.message);
                } catch (e) {

                }
                return Utils.showFailureInfo(err1.message);
            }

            try{
                WaimaiService.writeNoteInText('查询订单是否重复---result:' + !!res.localorder);
            } catch (ee) {

            }

            if (!res.localorder)
            {
                WaimaiService.writeNoteInText("订单不重复----");
                WaimaiService.acceptWaimaiOrder(res.order, function (err) {
                   
                    if (err) {
                        WaimaiService.writeNoteInText(res.order.orderNo + " - - - " + res.order.execguid + "外卖订单接受error", err.message);
                        return Utils.showFailureInfo(err.message);
                    }
                    WaimaiService.findOrderByThirdOrderNo(res.order, function (err2, lastres) {
                        if(err2)
                            return WaimaiService.writeNoteInText(lastres.order.orderNo + "确定接单结果失败", err2, err2.message);
                        var sorf=!!lastres.localorder;
                        WaimaiService.writeNoteInText('确定接单结果:' + (sorf ? "成功" : "失败"));
                        if(sorf)
                            try {
                                delete BIZCONSTANT.WAIMAIQUENE[orderNo];
                            } catch (e) {

                            }
                    });


                    console.log("外卖订单接受成功");
                    if (cb)
                        cb();
                    WaimaiService.writeNoteInText(res.order.orderNo + " - - - " + res.order.execguid + "外卖订单接受成功");
                    waimaiPendingNum -= 1;
                    $rootScope.waimaiPendingNum = waimaiPendingNum;
                });
            }
            else
            {
                try {
                    delete BIZCONSTANT.WAIMAIQUENE[orderNo];
                } catch (e) {

                }
                if (cb)
                    cb();
                WaimaiService.writeNoteInText(res.order.orderNo + " - - - " + res.order.execguid + ' 外卖订单已存在，已忽略');
            }
        });
    }

    WaimaiService.checkWaimaiQueueJob = function (win) {
        Utils.setInterval(function () {
            var nowtime = parseInt(new Date().getTime() / 1000);
            try {
                for (var i in BIZCONSTANT.WAIMAIQUENE) {
                    var wm = BIZCONSTANT.WAIMAIQUENE[i];
                    if (wm.exectime && (nowtime - wm.exectime) >= 300) {
                        wm.fromBackJob = true;
                        WaimaiService.RealacceptWaimaiOrder(wm, function () {
                            try {
                                //$("#waimaiIframe")[0].contentWindow.postMessage(event.data.message.orderNo, '*');
                                win.postMessage(wm.orderNo, '*');
                                WaimaiService.writeNoteInText('定时任务执行成功回调:' + JSON.stringify(wm));
                            } catch (e) {

                            }
                        });
                    }
                }
            } catch (e) { }
        }, 10e3);
    };

    return WaimaiService;
}]);
