app.factory('WeiXinService', ['$q', 'database', 'CanbieService', 'SystemConfigService', 'GuqingService', 'CanbieService', 'ZhuotaiService', 'GuqingService', 'PrintService', 'UniqueIDService', 'JieSuanService','$rootScope','EntityNameMapService','DiancaiService',
    function ($q, database, CanbieService, SystemConfigService, GuqingService, CanbieService, ZhuotaiService, GuqingService, PrintService, UniqueIDService, JieSuanService, $rootScope, EntityNameMapService, DiancaiService) {
        var WeiXinService = {};

        var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');
        var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');
        var billingDao = new DatabaseFuncDelegate($q, database, 'pos_billing');
        var billingDetailDao = new DatabaseFuncDelegate($q, database, 'pos_billing_detail');


        var operate = NetworkOrderOperate;
        if (!BIZCONSTANT.POSUSER)
        {
            BIZCONSTANT.POSUSER = new PosUser();
            BIZCONSTANT.POSUSER.name = operate.name;
        }
        var successStr = "success";
        var failureStr = "failure";

        WeiXinService.update = function (dataList) {
            if(dataList && dataList.length > 0) {
                for(var i = 0; i < dataList.length; i++) {
                    var kafakaData = dataList[i];
                    var kafkaDataObj = JSON.parse(kafakaData.data);
                    if (BIZCONSTANT.POSUSER.getNeedKaiBan()) {
                        kafkaDataObj.status = failureStr;
                        kafkaDataObj.msg = "尚未开班！";
                        new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                        return;
                    }
                    //检查是否有未更新的菜品消息
                    EntityNameMapService.newCaipinCount(function (err, count) {
                        if(err) {
                            var kafkaDataObj = JSON.parse(kafakaData.data);
                            kafkaDataObj.status = failureStr;
                            kafkaDataObj.msg = "收银台基础资料查询失败！";
                            new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                            return;
                        }else {
                            if(count >= 1) {
                                var kafkaDataObj = JSON.parse(kafakaData.data);
                                kafkaDataObj.status = failureStr;
                                kafkaDataObj.msg = "收银台有基础资料未更新，请联系收银台！";
                                new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                return;
                            }else {
                                new WeiXinService.update1(kafakaData);
                            }
                        }
                    })
                }
            }
        }

        var orderSucc = "NoValidate";
        //var canbie = null;
        //var zhuotai = null;
        //var printZhuotai = new Zhuotai();
        //var printOrderCaipins = [];
        //var zhangDanNo = null;
        //var sqls = [];
        //微信下单后,通过kafka推送订单号信息到pos前台
        WeiXinService.update1 = function (kafkaData) {
            console.info("kafka data incoming time : " + Utils.now());
            console.info("incoming kafka dataStr : " + JSON.stringify(kafkaData));
            if(testWeixin == true && userFakeData == true)
            kafkaData = JSON.parse(kafkaTestDataStr);    //just for test
            if(!kafkaData || !kafkaData.data) return;
            var canbie = null;
            var zhuotai = null;
            var printZhuotai = new Zhuotai();
            var printOrderCaipins = [];
            var pos_orderObj = null;
            var zhangDanNo = null;
            var sqls = [];
            var huiYuanId = null;
            var memCardNo = null; //会员卡号
            var memCardName = null; //会员名
            var thirdOrderNo = null; //第三方订单号
            var remark = null;

            var kafkaDataStr = kafkaData.data;
            // kafkaDataStr = kafkaTestDataStr;
            //orderDataObj,该对象用于返回处理结果,还需要添加status(success or failure)和msg属性
            //{ "groupId":"729f6c45-ce34-44ce-ba1f-78f29b820b5d",
              //  "orgId":"31d556f5-9b24-4691-8a41-baf1cd3ce1af",
                //"groupCode":"10058","orgCode":"100001",
                //"opreateOrgId":"31d556f5-9b24-4691-8a41-baf1cd3ce1af",
                //"orderNo":"20160710000001",  //微信订单号
                //"tradeNo":"20160710000001"   //微信订单交易号
            //}
            var kafkaDataObj = JSON.parse(kafkaDataStr);
            memCardNo = kafkaDataObj.cardNo;
            var eventType = kafkaDataObj.eventType;
            thirdOrderNo = kafkaDataObj.orderNo;
            console.info("thirdOrderNo : " + thirdOrderNo);
            var sql_thirdOrderNo = "select * from pos_order where thirdOrderNo='" + thirdOrderNo + "'";
            if(eventType && (eventType == 2 || eventType == "2")) {
                if(!thirdOrderNo || thirdOrderNo.length <= 0) {
                    kafkaDataObj.status = failureStr;
                    kafkaDataObj.msg = "订单号无效！";
                    console.log(JSON.stringify(kafkaDataObj));
                    return;
                }
                //请求支付
                //发送最新订单数据到微信端
                orderDao.query(sql_thirdOrderNo).then(function (result) {
                    console.info("根据thirdOrderNo查询本地订单信息结果 : " + JSON.stringify(result));
                    if(result && result.detail) {
                        var localOrderInfo = result.detail[0];
                        var jieSuan = new JieSuan();
                        //读取账单信息
                        JieSuanService.loadByOrderId(localOrderInfo, jieSuan, function (err, model) {
                            if (err) {
                                kafkaDataObj.status = failureStr;
                                kafkaDataObj.msg = err.message;
                                console.log(JSON.stringify(kafkaDataObj));
                                return;
                            }
                            try{
                                jieSuan.getMember().setGuid(jieSuan.order.huiYuanId);
                            }catch (e){};
                            //组装订单信息并返回给微信前端
                            var rootOrderInfo = {}; //订单金额信息
                            rootOrderInfo.orderNo = thirdOrderNo;
                            rootOrderInfo.moneyTotal = Utils.m(jieSuan.order.getSumOfZhangDan());
                            rootOrderInfo.moneyZK = jieSuan.order.calAllZheKou();
                            rootOrderInfo.moneyYS = Utils.m(jieSuan.order.getYingShou());
                            rootOrderInfo.remark = jieSuan.order.comments;
                            rootOrderInfo.groupId = BIZCONSTANT.POSUSER.groupId;
                            rootOrderInfo.groupCode = BIZCONSTANT.POSUSER.groupCode;
                            rootOrderInfo.orgId = BIZCONSTANT.POSUSER.mdId;
                            var orderFoodForm = {}; //订单桌台信息
                            rootOrderInfo.orderFoodForm = orderFoodForm;
                            orderFoodForm.eatRenshu = jieSuan.order.renshu;
                            orderFoodForm.zhuotaiCode = jieSuan.order.zhuotaiCode;
                            orderFoodForm.zhuotaiName = jieSuan.order.zhuotaiName;
                            var dishForms = [];
                            rootOrderInfo.dishForms = dishForms; //订单菜品列表信息
                            var caipins = jieSuan.order.caiPinList;
                            if(caipins && caipins.length > 0) {
                                var orderCaipins = [];
                                for(var i = 0; i < caipins.length; i++) {
                                    var caipin = Utils.clone(caipins[i]);
                                    var newCaiPin = {};
                                    newCaiPin.dishId = caipin.caipinId;
                                    newCaiPin.dishCode = caipin.caipinCode;
                                    newCaiPin.dishName = caipin.name;
                                    newCaiPin.dishNum = caipin.num;
                                    newCaiPin.priceUnit = caipin.price;
                                    newCaiPin.priceTotal = parseFloat(caipin.price) * parseInt(caipin.num - caipin.zengNum);
                                    newCaiPin.priceHy = caipin.hyPrice;
                                    newCaiPin.dishTypeId = caipin.caipinTypeId;
                                    newCaiPin.dishTypeCode = caipin.caipinTypeCode;
                                    newCaiPin.dishTypeName = caipin.caipinTypeName;
                                    newCaiPin.unitId = caipin.unitId;
                                    newCaiPin.unitName = caipin.unitName;
                                    newCaiPin.addNum = caipin.zengNum;
                                    newCaiPin.retreatNum = caipin.tuiNum;
                                    newCaiPin.wayPrice = zuoFaPriceTotal(caipin.zuofas);
                                    orderCaipins.push(newCaiPin);
                                }
                                mergeOrderCaipin(orderCaipins, dishForms);
                            }
                            console.log("rootOrderInfo : " + JSON.stringify(rootOrderInfo))
                            new weiXinUpdateOrderCallBack(JSON.stringify(rootOrderInfo));
                            return;
                        }, true);
                    }else {
                        kafkaDataObj.status = failureStr;
                        kafkaDataObj.msg = "未查询到本地订单信息！";
                        console.log(JSON.stringify(kafkaDataObj));
                        return;
                    }
                }, function (err) {
                    kafkaDataObj.status = failureStr;
                    kafkaDataObj.msg = "查询订单号信息异常：" + JSON.stringify(err);
                    console.log(JSON.stringify(kafkaDataObj));
                    return;
                })
                return;
            }else {
                console.info("memCardNo : " + memCardNo);
                var msg = null;
                var orderDataObj = null;
                //获取微信订单信息
                getWeiXinOrder(kafkaDataStr, function (response) {
                    if(testWeixin == true && userFakeData == true) response = weixinOrderTestDataOjb;
                    console.info("微信订单数据：getWinXinOrder.response： " + JSON.stringify(response));
                    //微信订单对象，包含订单、菜品、交易等信息
                    orderDataObj = response.data;
                    thirdOrderNo = orderDataObj.orderNo;
                    operate.groupId = orderDataObj.groupId;
                    operate.groupCode = orderDataObj.groupCode;
                    operate.mdId = orderDataObj.orgId;
                    memCardName = orderDataObj.memberName;
                    if(orderDataObj.memberId)
                        huiYuanId = orderDataObj.memberId;
                    remark = orderDataObj.remark;
                    var orderDataStr = JSON.stringify(orderDataObj);
                    if (!orderDataStr || response.status == failureStr){
                        console.info("服务端获取数据失败！" );
                        kafkaDataObj.status = failureStr;
                        kafkaDataObj.msg = "获取微信订单失败！";
                        new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                        return;
                    }else{
                        var orderIsValidate = response.data.status;
                        if(!orderIsValidate || orderIsValidate != orderSucc) {
                            kafkaDataObj.status = failureStr;
                            kafkaDataObj.msg = "无效的订单！";
                            new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                            return;
                        }
                        console.info("服务端获取数据成功！");
                    }

                    //检查餐别信息
                    CanbieService.getCurrentCanBie(function (err, result) {
                        console.log("当前餐别信息=====================start=====================");
                        if (err || Utils.isEmpty(result)) {
                            kafkaDataObj.status = failureStr;
                            if (Utils.isEmpty(result)) {
                                kafkaDataObj.msg = "当前时间无法匹配到餐别信息！";
                            }else {
                                kafkaDataObj.msg = err;
                            }
                            console.log("当前餐别信息=====================end.error=====================" + kafkaDataObj.msg);
                            new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                            return;
                        }
                        console.log(result);
                        console.log("当前餐别信息=====================end.success=====================");
                        canbie = result;

                        //检测估清信息

                        //查询桌台信息
                        console.log("桌台信息=====================start=====================zhuotaiCode : " + orderDataObj.wxOrderFoodInfo.zhuotaiCode);
                        ZhuotaiService.getZhuoTaiObjByCode(orderDataObj.wxOrderFoodInfo.zhuotaiCode, function (err, result) {
                            if (err) {
                                kafkaDataObj.status = failureStr;
                                kafkaDataObj.msg = err;
                                console.log("桌台信息=====================end.error===================== : " + JSON.stringify(err));
                                new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                return;
                            }
                            zhuotai = result;
                            if(!zhuotai) {
                                kafkaDataObj.status = failureStr;
                                kafkaDataObj.msg = "未获取到zhuotaiCode为" + orderDataObj.wxOrderFoodInfo.zhuotaiCode + "的桌台信息.";
                                console.log("桌台信息=====================end.error===================== : " + kafkaDataObj.msg);
                                new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                return;
                            }
                            console.log("桌台信息=====================end.success===================== ");

                            //创建打印-桌台对象信息
                            buildPrintZhuotai();
                            //检查是否已经存在订单
                            console.log("检查是否已经存在订单=====================start=====================")
                            orderDao.query(sql_thirdOrderNo).then(function (result1) {
                                console.info("根据thirdOrderNo查询本地订单信息结果2 : " + JSON.stringify(result1));
                                console.log("检查是否已经存在订单=====================end=====================")
                                if(result1 && result1.detail && result1.detail.length > 0) {
                                    var localOrderObj = result1.detail[0];
                                    var jieSuan = new JieSuan();
                                    jieSuan.doNotAutoSave = true;
                                    JieSuanService.loadByOrderId(localOrderObj, jieSuan, function (err,ret1) {
                                        var requestObj = {};
                                        requestObj.orderNo = jieSuan.order.thirdOrderNo;
                                        requestObj.groupCode = BIZCONSTANT.POSUSER.groupCode;
                                        requestObj.groupId = BIZCONSTANT.POSUSER.groupId;
                                        requestObj.orgId = BIZCONSTANT.POSUSER.mdId;
                                        var requestStr = JSON.stringify(requestObj);
                                        if(!err) {
                                            //开始计算并结算
                                            //创建交易记录并结算
                                            makeJieSuanPM(jieSuan, requestObj);
                                        }else {
                                            requestObj.status = failureStr;
                                            requestObj.msg = err;
                                            console.log("通过order对象和jieSuan对象加载订单信息异常========================================== : " + JSON.stringify(err));
                                        }
                                        //new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                                        return;
                                    }, true);
                                }else {
                                    //创建order对象
                                    console.log("创建order对象=====================start===================== ");
                                    buildOrderObj(function (err) {
                                        if(err) {
                                            kafkaDataObj.status = failureStr;
                                            kafkaDataObj.msg = err;
                                            console.log("创建order对象=====================end.error===================== : " + JSON.stringify(err));
                                            new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                            return;
                                        }

                                        //创建pos_billing对象
                                        buildPos_BillingObj();
                                        //创建pos_billing_detail对象
                                        buildPos_BillingDetailOjb();

                                        // var _orderCaipins = buildNetworkOrderCaipins(orderDataObj.wxOrderFoodInfo);
                                        var _orderCaipins = buildOrderCaipinObj(orderDataObj.wxOrderFoodInfo);
                                        //TODO validate dish guqing
                                        var count = 1;

                                        executeXiadan(pos_orderObj, _orderCaipins, function (err, result) {
                                            if (err) {
                                                kafkaDataObj.status = failureStr;
                                                kafkaDataObj.msg = err;
                                                new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                                return;
                                            }
                                            kafkaDataObj.status = successStr;
                                            kafkaDataObj.msg = result;
                                            kafkaDataObj.storeZDNo = zhangDanNo;
                                            kafkaDataObj.storeZhuotaiId = pos_orderObj.zhuotaiCode;
                                            kafkaDataObj.storeZhuotaiName = pos_orderObj.zhuotaiName;
                                            kafkaDataObj.storeCanbieId = pos_orderObj.canbieId;
                                            kafkaDataObj.storeCanbiename = pos_orderObj.canbieName;
                                            new weiXinOrderCallBack(JSON.stringify(kafkaDataObj));
                                            $rootScope.$broadcast('refreshZT', 'true');
                                            return;
                                        })
                                    });
                                }

                            })

                        })
                    });
                })
            }


            //获取微信订单
            function getWeiXinOrder(dataStr, callbackF) {
                if(userFakeData == true) return callbackF(null);
                console.info("before getWeiXinOrder Method  time : " + Utils.now());
                var url = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.GET_WEIXIN_ORDER_URL;
                if(testWeixin == true)
                url = "http://" + VALIDATE_TOKEN_HOST[1].HOST_BASIC + "/yunshan-weixin-api" + WEIXIN.GET_WEIXIN_ORDER_URL; //季老板URL
                callAjax(url, callbackF, dataStr, null, function (err, data) {
                    console.info("获取订单失败！")
                    return callbackF(null);
                })
            }

            //orderCaipin数量合并
            function mergeOrderCaipin(orderCaipins, newOrderCaipins) {
                if(!orderCaipins || orderCaipins.length <= 0) return;
                while(orderCaipins.length > 0) {
                    var orderCaipin = orderCaipins.splice(0, 1)[0];
                    var existOrderCaipin = Utils.arrayFind(newOrderCaipins, orderCaipin.dishId, "dishId");
                    if(existOrderCaipin) {
                        existOrderCaipin.dishNum = existOrderCaipin.dishNum + orderCaipin.dishNum;
                        existOrderCaipin.addNum = existOrderCaipin.addNum + orderCaipin.addNum;
                        existOrderCaipin.retreatNum = existOrderCaipin.retreatNum + orderCaipin.retreatNum;
                        existOrderCaipin.priceTotal = existOrderCaipin.priceTotal + orderCaipin.priceTotal;
                    }else {
                        newOrderCaipins.push(orderCaipin);
                    }
                }
            }

            function zuoFaPriceTotal(zuofas) {
                if(!zuofas || zuofas.length <= 0) return 0;
                var moneyTotal = 0;
                while(zuofas.length > 0) {
                    var zuofa = zuofas.splice(0, 1)[0];
                    moneyTotal += zuofa.price;
                }
                return moneyTotal;
            }

            function executeXiadan(_item, orderCaipins, cb) {
                var _guqingCaipins = [];
                console.log("executeXiadan ：=====================start===================== ");
                for (var idx in orderCaipins) {
                    _guqingCaipins.push(buildGuqingCaipin(orderCaipins[idx]));
                }
                console.log("GuqingService.LuodanCaipinToGuqing ：=====================start===================== ");
                GuqingService.LuodanCaipinToGuqing(_guqingCaipins, operate, function (err, result) {
                    if (err) {
                        console.log("GuqingService.LuodanCaipinToGuqing ：=====================end.error ===================== : " + JSON.stringify(err));
                        return cb(err);
                    }
                    console.log("GuqingService.LuodanCaipinToGuqing.result : " + JSON.stringify(result));
                    console.log("GuqingService.LuodanCaipinToGuqing ：=====================end.success ===================== : ");
                    var caipins = result;

                    InsertData(_item, orderCaipins, function (err, result) {
                        if (err) {
                            return cb(err);
                        }

                        printhelp.printzhizuodan(printZhuotai, printOrderCaipins, PrintService, operate.name);
                        printhelp.printhuadan(printZhuotai, printOrderCaipins, PrintService, operate.name);

                        return cb(null, result);
                    })
                })
            }

            /*
            * execute insert data
            */
            function InsertData(order, caipins, cb) {
                console.log("InsertData ：=====================start===================== ");
                var orderId = order.guid;

                var now = order.luoDanTime;
                if (zhuotai.orderId == null) {
                    var jiesuanId = pos_orderObj.jieSuanId;
                    buildPrintZhuotaiOrder(orderId, order, now);

                    sqls.push(buildZhuotaiSql(orderId));
                    sqls.push(buildOrderSql(jiesuanId, orderId, order, now));
                    // sqls.push(buildOrder_ZhuotaiSql(orderId));
                    var order_zhuotaiSqls = buildOrder_ZhuotaiSql(orderId);
                    if(order_zhuotaiSqls && order_zhuotaiSqls.length > 0) {
                        for(var i = 0; i < order_zhuotaiSqls.length; i++) {
                            sqls.push(order_zhuotaiSqls[i]);
                        }
                    }
                    sqls.push(buildPos_BillingSql());
                    var pos_billing_detailSqls = buildPos_Billing_DetailSql();
                    if(pos_billing_detailSqls && pos_billing_detailSqls.length > 0) {
                        for(var i = 0; i < pos_billing_detailSqls.length; i++) {
                            sqls.push(pos_billing_detailSqls[i]);
                        }
                    }
                    for (var idx in caipins) {
                        // var orderCaipin = createNetworkOrderCaipin(orderId, caipins[idx], now);
                        var orderCaipin = caipins[idx];
                        printOrderCaipins.push(orderCaipin);
                        sqls.push(buildOrderCaipinSql(orderId, orderCaipin));
                    }
                    console.log("InsertData.executeSql ：=====================start===================== ");
                    executeSql(sqls, function (err, result) {
                        if (err) {
                            console.log("InsertData.executeSql ：=====================end.error===================== : " + JSON.stringify(err));
                            console.log("InsertData ：=====================end.error===================== ");
                            return cb(err);
                        }
                        console.log("InsertData.executeSql ：=====================end.success===================== ");
                        console.log("InsertData ：=====================end.success===================== ");
                        return cb(null, "处理成功！");
                    });
                } else {
                    console.log("InsertData ：=====================end.success===================== : 该桌台有订单尚未结算！ ");
                    return cb("该桌台有订单尚未结算！", "处理成功！");
                }
            }

            //创建账单交易对象信息
            function buildOrderTradeInfoObj() {
                var tradeInfoObjs = null;
                var tradeInfoListObjs = orderDataObj.wxOrderTradeInfoList;
                return tradeInfoObjs;
            }

            //创建订单-菜品对象信息
            function buildOrderCaipinObj(wxOrderFoodInfo) {
                console.log("创建OrderCaipinObjs对象=====================start=====================  ");
                var caipins = null;
                if(wxOrderFoodInfo) {
                    var wxOrderCaipins = wxOrderFoodInfo.wxOrderFoodDishInfoList;
                    if(wxOrderCaipins && wxOrderCaipins.length > 0) {
                        caipins = [];
                        for(var i = 0; i < wxOrderCaipins.length; i++) {
                            var wxOrderCaiPin = wxOrderCaipins[i];
                            var _caipin = new OrderCaipin();
                            caipins.push(_caipin);
                            _caipin.guid = wxOrderCaiPin.guid;
                            _caipin.orderId = pos_orderObj.guid;
                            _caipin.caipinId = wxOrderCaiPin.dishId;
                            _caipin.orderCaipinType = 1;
                            _caipin.name = wxOrderCaiPin.dishName;
                            _caipin.price = wxOrderCaiPin.priceUnit;
                            _caipin.zheQianMoney = wxOrderCaiPin.priceUnit;
                            _caipin.num = wxOrderCaiPin.dishNum;
                            _caipin.tuiNum = 0;
                            _caipin.zengNum = 0;
                            _caipin.unitId = wxOrderCaiPin.unitId;
                            _caipin.unitName = wxOrderCaiPin.unitName;

                            // _caipin.printId = caipin.printId;
                            // _caipin.printName = caipin.printName;
                            _caipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
                            _caipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
                            _caipin.minAgio = 0;
                            _caipin.danPinBiLiZheKou = 0;
                            _caipin.danPinJineZheKou = 0;
                            _caipin.danPinZheKou = 0;
                            _caipin.operator = operate.id;
                            _caipin.dianCaiYuan = operate.id;
                            _caipin.dianCaiYuanName = operate.name;
                            _caipin.dianCaiTime = pos_orderObj.kaiTaiTime;
                            _caipin.modTime = pos_orderObj.kaiTaiTime;
                            _caipin.luoDanTime = pos_orderObj.kaiTaiTime;
                            _caipin.needweigh = (wxOrderCaiPin.needweigh == null?  0 : wxOrderCaiPin.needweigh);
                            _caipin.isScomb = null;
                            _caipin.costprice = null;

                            _caipin.caipinTypeId = wxOrderCaiPin.dishTypeId;
                            _caipin.caipinTypeCode = wxOrderCaiPin.dishTypeCode;
                            _caipin.caipinTypeName = wxOrderCaiPin.dishTypeName;
                            var hyPrice = null;
                            if(!huiYuanId || huiYuanId.length <= 0) {
                                hyPrice = null;
                            }else {
                                try{
                                    hyPrice = Utils.m(wxOrderCaiPin.priceHy);
                                }catch (e) {
                                    hyPrice = null;
                                }
                            }
                            if(hyPrice == _caipin.zheQianMoney) hyPrice = null;
                            _caipin.hyPrice = hyPrice;
                            if(!order_zhuotaiId) order_zhuotaiId = Utils.guid();
                            _caipin.orderZhuoTaiId = order_zhuotaiId;

                        }
                    }
                }
                console.log(caipins);
                console.log("创建OrderCaipinObjs对象=====================end.success=====================  ");
                return caipins;
            }

            /* build dish info    start   */
            //wxOrderFoodInfo
            function buildNetworkOrderCaipins(Caipins) {
                var re = [];
                for (var i in Caipins) {
                    var _orderCaipin = Utils.arrayFind(re, Caipins[i].dishId, "guid");
                    handleOrderCaipins(_orderCaipin, re, Caipins[i]);
                }
                return re;
            }

            function handleOrderCaipins(_orderCaipin, re, caipin) {
                if (_orderCaipin == null) {
                    re.push(createNetworkCaipin(caipin))
                }
            }

            function createNetworkCaipin(caipin) {
                var _caipin = new WXOrderCaipin();
                _caipin.guid = caipin.dishId;
                _caipin.code = caipin.dishCode;
                _caipin.name = caipin.dishName;
                _caipin.caipinNum = caipin.dishCount;
                _caipin.caipinGqNum = null;//菜品的估清数量

                _caipin.salePrice = caipin.unitPrice;
                _caipin.hyPrice = caipin.hyPrice;
                _caipin.unitId = caipin.unitId;
                _caipin.unitName = caipin.unitName;
                _caipin.isScomb = null;

                _caipin.typeId = caipin.dishTypeId;
                _caipin.typeCode = caipin.dishTypeCode;
                _caipin.typeName = caipin.dishTypeName;

                return _caipin;
            }


            function buildGuqingCaipin(caipin) {
                var orderCaipin = new OrderCaipin();

                orderCaipin.caipinId = caipin.caipinId;
                orderCaipin.name = caipin.name;
                orderCaipin.num = caipin.num;

                return orderCaipin;
            }

            /*build dish info    end*/





            function executeSql(sqls, cb) {
                orderDao.queryTransaction(sqls).then(function (resultList) {
                    return cb(null, resultList);
                }, function (err) {
                    return cb(err);
                });
            }

            function GetNewOrderCode(cb) {
                var now = new Date();
                UniqueIDService.nextSeq(now, 'order', function (err, seq, nowdate) {
                    if (err) {
                        return cb(err)
                    }
                    var seqNo = nowdate + Utils.formatSeqNo(seq);
                    zhangDanNo = "ZD" + seqNo;

                    return cb(null);
                });
            }


            function buildZhuotaiSql(orderId) {
                return {
                    query: "update pos_zhuotai set orderId=? where guid=? and orderId is null",
                    params: [orderId, zhuotai.guid]
                };
            }

            var order_zhuotaiId = null;
            //建立账单与桌台关联表
            function buildOrder_ZhuotaiSql(orderId) {
                if(!order_zhuotaiId) order_zhuotaiId = Utils.guid();
                var sqls = [];
                var sql1 = {
                    query:"delete from pos_order_zhuotai where orderId=?",
                    params:[orderId]
                }
                var sql2 = {
                    query: "insert into pos_order_zhuotai (guid, orderId, zhuotaiId, zhuotaiCode, zhuotaiName, areaId, areaCode, areaName, renshu, hisOrderId, isDeleted) " +
                    "values (?,?,?,?,?,?,?,?,?,?,?)",
                    params: [order_zhuotaiId, orderId, zhuotai.guid, zhuotai.code, zhuotai.name, zhuotai.areaId, zhuotai.areaCode, zhuotai.areaName, pos_orderObj.renshu, orderId, "false"]
                };
                sqls.push(sql1);
                sqls.push(sql2);
                return sqls;
            }

            /**
             * 建立空账单
             */
            function buildEmptyBilling(jiesuanId, orderId) {
                return {
                    query: "insert into pos_billing ( " +
                    "guid, orderId) " +
                    "values (?, ?)",
                    params: [jiesuanId, orderId]
                }
            }

            /**
             * 建立微信账单
             */
            function buildPos_BillingSql() {
                if(pos_billingObj) {
                    return {
                        query: "insert into pos_billing ( " +
                        "guid, orderId, orderNo, zhangDanTotal, shiShou, zhaoLing, zheKouTotal, fenTanTotal, moLing, canbieCode, canBieName, memo, mdId, enabled, isDeleted, createTime, " +
                        "addOperatorId, addOperatorCode, addOperatorName, moneyZheKou, isFanJieSuan, canbieId, cardNo, cardMemName) " +
                        "values (?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                        params: [pos_billingObj.guid, pos_billingObj.orderId, pos_billingObj.orderNo, pos_billingObj.zhangDanTotal, pos_billingObj.shiShou, pos_billingObj.zhaoLing, pos_billingObj.zheKouTotal, pos_billingObj.fenTanTotal,
                        pos_billingObj.moLing, pos_billingObj.canbieCode, pos_billingObj.canBieName, pos_billingObj.demo, pos_billingObj.mdId, pos_billingObj.enabled, pos_billingObj.isDeleted, pos_billingObj.createTime, pos_billingObj.addOperatorId,
                        pos_billingObj.addOperatorCode, pos_billingObj.addOperatorName, pos_billingObj.moneyZheKou, pos_billingObj.isFanJieSuan, pos_billingObj.canbieId, pos_billingObj.cardNo, memCardName]
                    }
                }
            }

            /**
             * 建立微信账单详情
             */
            function buildPos_Billing_DetailSql() {
                var sqlObjs = [];
                if(pos_billingDetailObjs && pos_billingDetailObjs.length > 0) {
                    for(var i = 0; i < pos_billingDetailObjs.length; i++) {
                        var detailObj = pos_billingDetailObjs[i];
                        var sqlObj = {
                            query: "insert into pos_billing_detail ( " +
                            "guid, jieSuanId, bizCode, bizDesc, type, amount, caiWuShuXing, seq, device, mdId, isDeleted, createTime, " +
                            "addOperatorId, addOperatorCode, addOperatorName, bizAmount, isHyJf, ext1) " +
                            "values (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                            params: [detailObj.guid, detailObj.jieSuanId, detailObj.bizCode, detailObj.bizDesc, detailObj.type, detailObj.amount, detailObj.caiWuShuXing, detailObj.seq,
                                detailObj.device, detailObj.mdId, detailObj.isDeleted, detailObj.createTime, detailObj.addOperatorId,
                                detailObj.addOperatorCode, detailObj.addOperatorName, detailObj.bizAmount, detailObj.isHyJF, detailObj.ext1]
                        }
                        sqlObjs.push(sqlObj);
                    }
                }
                return sqlObjs;
            }

            // build order sql
            function buildOrderSql(jiesuanId, orderId, order, curTime) {
                return {
                    query: "insert into pos_order ( " +
                        "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status,serverId, serverName, operator, operatorName,operatorCode, mdId," +
                        " kaiTaiTime, modTime, isDeleted,fanJieSuanNum,canBieCode,canBieName,canBieId,areaGuid,areaCode,areaName,zhuotaiCode,code,luoDanTime,ordersource,jieSuanId,cardNo, thirdOrderNo, cardMemName, huiYuanId, couponNo) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?, ?,?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                    params: [orderId, zhuotai.guid, zhuotai.name, pos_orderObj.renshu, pos_orderObj.comments, order.totalPrice, 1, operate.id, operate.name,
                        operate.id, operate.name, operate.code, pos_orderObj.mdId,
                        curTime, curTime, false, 0, canbie.code, canbie.name,
                    canbie.guid, zhuotai.areaId, zhuotai.areaCode, zhuotai.areaName, zhuotai.code, order.code, curTime, ORDERSOURCE.WEIXIN, jiesuanId, pos_orderObj.cardNo, pos_orderObj.thirdOrderNo, memCardName, pos_orderObj.huiYuanId, pos_orderObj.couponNo]
                };
            }
            // build order dish sql  start
            function buildOrderCaipinSql(orderId, orderCaipin) {
                return {
                    query: "insert into pos_order_caipin ( " +
                    "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                    "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName,luoDanTime, orderZhuoTaiId) " +
                    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?)",
                    params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                        orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                        orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                        BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime,
                        orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                        orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.modTime, orderCaipin.orderZhuoTaiId]
                };
            }
            function createNetworkOrderCaipin(orderId, caipin, now) {
                var num = 1;
                if (caipin.caipinNum > 1)
                    num = caipin.caipinNum;
                var orderCaipin = new OrderCaipin();
                orderCaipin.guid = orderCaipinDao.guid();
                orderCaipin.orderId = orderId;
                orderCaipin.caipinId = caipin.guid;
                orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
                orderCaipin.name = caipin.name;
                orderCaipin.price = caipin.salePrice;
                orderCaipin.costprice = caipin.costprice == null ? 0 : caipin.costprice;
                orderCaipin.num = num;
                orderCaipin.tuiNum = 0;
                orderCaipin.zengNum = 0;
                orderCaipin.unitName = caipin.unitName;
                orderCaipin.printId = caipin.printId;
                orderCaipin.printName = caipin.printName;
                orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
                orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
                orderCaipin.minAgio = caipin.minAgio;
                orderCaipin.danPinBiLiZheKou = 0;
                orderCaipin.danPinJineZheKou = 0;
                orderCaipin.danPinZheKou = 0;
                orderCaipin.operator = operate.id;
                orderCaipin.dianCaiYuan = operate.id;
                orderCaipin.dianCaiYuanName = operate.name;
                orderCaipin.dianCaiTime = now;
                orderCaipin.modTime = now;
                orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
                orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;

                orderCaipin.hyPrice = caipin.hyPrice;
                orderCaipin.caipinTypeId = caipin.typeId;
                orderCaipin.caipinTypeCode = caipin.typeCode;
                orderCaipin.caipinTypeName = caipin.typeName;

                return orderCaipin;
            }
            //build order dish sql  end

            // build guqing sql
            function buildCaipinGuqingSql(caipin, now) {
                if (caipin.caipinGqNum > 0) {
                    return {
                        query: "UPDATE pos_caipin_guqing SET caipinNum=caipinNum-?,operatorId=?,operatorCode=?,operatorName=?,modTime=? WHERE  caipinGuid =? and caipinNum=?",
                        params: [caipin.caipinNum, operate.id, operate.code, operate.name, now, caipin.guid, caipin.caipinGqNum]
                    };
                }
                return null;
            }


            function buildPrintZhuotai() {
                console.log("创建桌台对象=====================start===================== ");
                printZhuotai.guid = zhuotai.guid;
                printZhuotai.code = zhuotai.code;
                printZhuotai.name = zhuotai.name;
                printZhuotai.areaId = zhuotai.areaId;
                printZhuotai.quickCode = zhuotai.quickCode;
                printZhuotai.canweishu = zhuotai.canweishu;
                printZhuotai.orderId = null;
                printZhuotai.areaCode = zhuotai.areaCode;
                printZhuotai.areaName = zhuotai.areaName;
                console.log(printZhuotai);
                console.log("创建桌台对象=====================end.sucess===================== ");
            }

            function buildOrderObj(cb) {
                if(!pos_orderObj) pos_orderObj = new Order();
                GetNewOrderCode(function (err) {
                    if (err) {
                        return cb(err);
                    }
                    var now = Utils.formatDate(new Date(orderDataObj.xiadanTime), "yyyy-MM-dd hh:mm:ss");
                    var orderInfo = orderDataObj.wxOrderFoodInfo;
                    pos_orderObj.guid = Utils.guid();
                    pos_orderObj.code = zhangDanNo;
                    pos_orderObj.mdId = orderInfo.orgId;
                    pos_orderObj.zhuotaiId = zhuotai.guid;
                    pos_orderObj.zhuotaiCode = zhuotai.code;
                    pos_orderObj.zhuotaiName = zhuotai.name;
                    pos_orderObj.renshu = orderInfo.eatRenshu + "";
                    pos_orderObj.status = 1;
                    pos_orderObj.comments = remark;
                    pos_orderObj.totalPrice = orderDataObj.moneyTotal;
                    pos_orderObj.isDeleted = "false";
                    pos_orderObj.canBieCode = canbie.code;
                    pos_orderObj.canbieName = canbie.name;
                    pos_orderObj.canbieId = canbie.guid;
                    pos_orderObj.serverId = operate.id;
                    pos_orderObj.serverName = operate.name;
                    pos_orderObj.operator = operate.id;
                    pos_orderObj.operatorName = operate.name;
                    pos_orderObj.operatorCode = operate.code;
                    pos_orderObj.kaiTaiTime = now;
                    pos_orderObj.modTime = now;
                    pos_orderObj.fanJieSuanNum = 0;
                    pos_orderObj.areaGuid = zhuotai.areaId;
                    pos_orderObj.areaCode = zhuotai.areaCode;
                    pos_orderObj.areaName = zhuotai.areaName;
                    pos_orderObj.luoDanTime = now;
                    pos_orderObj.ordersource = ORDERSOURCE.WEIXIN;
                    pos_orderObj.cardNo = memCardNo;
                    pos_orderObj.jieSuanId = Utils.guid();
                    pos_orderObj.thirdOrderNo = thirdOrderNo;
                    pos_orderObj.huiYuanId = huiYuanId;
                    pos_orderObj.couponNo = null;
                    console.log(pos_orderObj);
                    console.log("创建order对象=====================end.sucess===================== ");
                    return cb(null);
                })

            }

            var pos_billingObj = null;
            function buildPos_BillingObj() {
                console.log("创建pos_billingObj对象=====================start===================== ");
                if(pos_billingObj == null) pos_billingObj = new Object();
                pos_billingObj.guid = pos_orderObj.jieSuanId;
                pos_billingObj.orderId = pos_orderObj.guid;
                pos_billingObj.orderNo = pos_orderObj.code;
                pos_billingObj.zhangDanTotal = orderDataObj.moneyTotal;
                pos_billingObj.shiShou = orderDataObj.moneyYS;
                pos_billingObj.zhaoLing = 0;
                pos_billingObj.zheKouTotal = orderDataObj.moneyZK;
                pos_billingObj.fenTanTotal = 0;
                pos_billingObj.moLing = 0;
                pos_billingObj.canbieCode = pos_orderObj.canBieCode;
                pos_billingObj.canBieName = pos_orderObj.canbieName;
                pos_billingObj.demo = "备注。。。";
                pos_billingObj.mdId = pos_orderObj.mdId;
                pos_billingObj.enabled = "true";
                pos_billingObj.isDeleted = "false";
                pos_billingObj.createTime = pos_orderObj.luoDanTime;
                pos_billingObj.addOperatorId = operate.id;
                pos_billingObj.addOperatorCode = operate.code;
                pos_billingObj.addOperatorName = operate.name;
                pos_billingObj.moneyZheKou = orderDataObj.moneyZK;
                pos_billingObj.isFanJieSuan = 0;
                pos_billingObj.canbieId = pos_orderObj.canbieId;
                pos_billingObj.cardNo = memCardNo;
                console.log(pos_billingObj);
                console.log("创建pos_billingObj对象=====================end.success===================== ");
            }

            //微信支付结算请求,创建结算支付方式
            function makeJieSuanPM(jieSuan, requestObj) {
                //创建支付方式临时对象
                var tmp_pms = [];
                var pay_pms = [];
                var zk_pms = [];
                var wxOrderTradeInfoList = orderDataObj.wxOrderTradeInfoList;
                if(wxOrderTradeInfoList && wxOrderTradeInfoList.length > 0) {
                    for(var i = 0; i < wxOrderTradeInfoList.length; i++) {
                        var wxOrderTradeInfo = wxOrderTradeInfoList[i];
                        var tmp_pm = {};
                        tmp_pms.push(tmp_pm);
                        var payChannel = wxOrderTradeInfo.payChannel;
                        tmp_pm.money = wxOrderTradeInfo.payMoney;
                        if(payChannel && payChannel == BIZCONSTANT.PM_HUI_YUANJIA_ALIAS) {
                            zk_pms.push(tmp_pm);
                            tmp_pm.type = "ZK";
                            tmp_pm.code = BIZCONSTANT.ZHE_KOU_HY_PRICE;
                        }else if (payChannel == BIZCONSTANT.PM_HUI_YUAN_JF_ALIAS) {
                            pay_pms.push(tmp_pm);
                            tmp_pm.type = "PAY";
                            tmp_pm.code = BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE;
                        }else {
                            var payType1 = PaymentMethod.getVirtualPm(payChannel);
                            payType1 = BIZCONSTANT.getPMbyCode(payType1.code);
                            try{
                                var type = payType1.getType();
                                tmp_pm.type = type;
                                tmp_pm.code = payType1.code;
                                if(type == "PAY") {
                                    pay_pms.push(tmp_pm);
                                }else {
                                    zk_pms.push(tmp_pm);
                                }
                            }catch (e) {
                                console.log("************************payType1.getType()异常************************");
                                console.log(e);
                                console.log("payChannel : " + payChannel);
                                console.log("payType1 : ");
                                console.log(payType1);
                                console.log("************************payType1.getType()异常************************");

                                Utils.winLog("************************payType1.getType()异常************************");
                                Utils.winLog(e);
                                Utils.winLog("payChannel : " + payChannel);
                                Utils.winLog("payType1 : ");
                                Utils.winLog(payType1);
                                Utils.winLog("************************payType1.getType()异常************************");
                            }
                        }
                    }
                }
                if(tmp_pms.length > 0) {
                    if(pay_pms.length > 0) {
                        JieSuanService.getCaiWuKeMu(function (err1, pms1) {
                            if(err1) {
                                jieSuan.noCaiWuKeMu = true;
                            }
                            if(!pms1 || pms1.length <= 0) {
                                jieSuan.noCaiWuKeMu = true;
                            }
                            if(jieSuan.noCaiWuKeMu) {
                                doJieSuan(jieSuan, requestObj);
                                return;
                            }
                            jieSuan.setMember(null);
                            jieSuan.payMethodList = [];
                            jieSuan.allpms = [];
                            for(var i = 0; i < pay_pms.length; i++) {
                                var pay_pm = pay_pms[i];
                                var pm = null;
                                if(pay_pm.code == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE || pay_pm.code == BIZCONSTANT.PM_HUI_YUAN) {
                                    var memberObj = jieSuan.getMember();
                                    if(!memberObj) {
                                        memberObj = new Member();
                                    }
                                    memberObj.setGuid(huiYuanId);
                                    memberObj.setCardNo(memCardNo);
                                    jieSuan.setMember(memberObj);
                                }
                                if(pay_pm.code == BIZCONSTANT.PM_HUI_YUAN) {
                                    //会员卡
                                    memberObj.setPayAmount(pay_pm.money);
                                }else if(pay_pm.code == BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE) {
                                    //会员积分
                                    memberObj.setJfPayAmount(pay_pm.money);
                                }
                                else {
                                    pm = Utils.arrayFind(pms1, pay_pm.code, "code");
                                    pm.addMoney(pay_pm.money);
                                    jieSuan.addPM(pm);
                                }
                            }
                            if(zk_pms.length > 0) {
                                makeTradeRecord_ZK(zk_pms, jieSuan, requestObj);
                            }else {
                                doJieSuan(jieSuan, requestObj);
                            }
                        })
                    }else {
                        if(zk_pms.length > 0) {
                            makeTradeRecord_ZK(zk_pms, jieSuan, requestObj);
                        }else {
                            doJieSuan(jieSuan, requestObj);
                        }
                    }
                }else {
                    jieSuan.noTradeRecord = true;
                    doJieSuan(jieSuan, requestObj);
                }
            }

            //创建ZK交易记录
            function makeTradeRecord_ZK(zk_pms, jieSuan, requestObj) {
                JieSuanService.getAllZheKou(function (err2, pms2) {
                    if(err2) {
                        jieSuan.noZheKouModule = true;
                    }
                    if(!pms2 || pms2.length <= 0) {
                        jieSuan.noZheKouModule = true;
                    }
                    if(jieSuan.noZheKouModule) {
                        doJieSuan(jieSuan, requestObj);
                        return;
                    }else {
                        for(var i = 0; i < zk_pms.length; i++) {
                            var zk_pm = zk_pms[i];
                            var zk = Utils.arrayFind(pms2, zk_pm.code, "zheKouCode");
                            zk.zheKouAmount = zk_pm.money;
                            jieSuan.addZheKou(zk);
                        }
                        doJieSuan(jieSuan, requestObj);
                        return;
                    }
                })
            }

            //结算
            function doJieSuan(jieSuan, requestObj) {
                console.log("**************************结算方式**************************");
                console.log(jieSuan.allpms);
                console.log("**************************结算方式**************************");
                if(jieSuan.noTradeRecord && jieSuan.noTradeRecord == true) {
                    requestObj.status = failureStr;
                    requestObj.msg = "没有生成正确的交易记录！";
                    new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                    console.log("结算异常：========================================== : " + JSON.stringify(requestObj));
                    return;
                }else if(jieSuan.noCaiWuKeMu && jieSuan.noCaiWuKeMu == true) {
                    requestObj.status = failureStr;
                    requestObj.msg = "没有找到财务科目！";
                    new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                    console.log("结算异常：========================================== : " + JSON.stringify(requestObj));
                    return;
                }else if(jieSuan.noZheKouModule && jieSuan.noZheKouModule == true) {
                    requestObj.status = failureStr;
                    requestObj.msg = "没有找到折扣模板！";
                    new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                    console.log("结算异常：========================================== : " + JSON.stringify(requestObj));
                    return;
                }
                jieSuan.setIgnoreXuShou(false);
                var curUser = BIZCONSTANT.POSUSER;
                console.log("curUser : " + JSON.stringify(curUser));
                if(jieSuan.useHuiYuanKa()) {
                    //会员卡
                    JieSuanService.payImmmediate(curUser, jieSuan, function (err, models) {
                        if(err) {
                            requestObj.status = failureStr;
                            requestObj.msg = err;
                            console.log("会员结算异常：========================================== : " + JSON.stringify(err));
                            new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                            return;
                        }
                        return doSave(curUser, jieSuan, requestObj);
                    });
                }else {
                    return doSave(curUser, jieSuan, requestObj);
                }
            }

            function doSave(curUser, jieSuan, requestObj) {
                JieSuanService.save(curUser, jieSuan, function (err1, model) {
                    if (err1) {
                        requestObj.status = failureStr;
                        requestObj.msg = err1;
                        console.log("结算异常：========================================== : " + JSON.stringify(err1));
                        new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                        return;
                    }else {
                        console.log("****************************结算成功，结算对象****************************");
                        console.log(jieSuan);
                        console.log("****************************结算成功，结算对象****************************");
                        //结算成功
                        //打印结账单
                        new weiXinJieSuanCallBack(JSON.stringify(requestObj));
                        printJieZhangDan(jieSuan);
                        ZhuotaiService.openLockZhuoTai(jieSuan.order.zhuotaiId);
                    }
                })
            }

            var pos_billingDetailObjs = null;
            function buildPos_BillingDetailOjb() {
                console.log("创建pos_billingDetailObjs对象=====================start===================== ");
                var wxOrderTradeInfoList = orderDataObj.wxOrderTradeInfoList;
                var hasHYPayType = false; //是否有会员支付方式
                if(wxOrderTradeInfoList && wxOrderTradeInfoList.length > 0) {
                    if(pos_billingDetailObjs == null) pos_billingDetailObjs = [];
                    for(var i = 0; i < wxOrderTradeInfoList.length; i++) {
                        var wxOrderTradeInfo = wxOrderTradeInfoList[i];
                        var pos_billing_detaillObj = new Object();
                        var payChannel = wxOrderTradeInfo.payChannel;
                        if(payChannel && payChannel == BIZCONSTANT.PM_HUI_YUAN_ALIAS) {
                            hasHYPayType = true;
                        }
                        var payType1 = null;
                        if(payChannel == BIZCONSTANT.PM_HUI_YUANJIA_ALIAS) {
                            //会员价支付方式
                            payType1 = {"guid":null, "code":BIZCONSTANT.ZHE_KOU_HY_PRICE, "name":BIZCONSTANT.PM_HUI_YUANJIA_NAME, "caiWuShuXing" : "优免"};
                            pos_billing_detaillObj.type = "ZK";
                            pos_billing_detaillObj.isHyJF = "true";
                            pos_billing_detaillObj.bizAmount = wxOrderTradeInfo.payMoney;
                            pos_billing_detaillObj.amount = 0;
                        }else if (payChannel == BIZCONSTANT.PM_HUI_YUAN_JF_ALIAS){
                            //积分消费
                            payType1 = {"guid":null, "code":BIZCONSTANT.PM_HUI_YUAN_JF_XF_CODE, "name":BIZCONSTANT.PM_HUI_YUAN_JF_XF_NAME, "caiWuShuXing" : "优免"};
                            pos_billing_detaillObj.type = "PAY";
                            pos_billing_detaillObj.isHyJF = "true";
                            pos_billing_detaillObj.bizAmount = 0;
                            pos_billing_detaillObj.amount = wxOrderTradeInfo.payMoney;
                            pos_billingObj.shiShou = pos_billingObj.shiShou + pos_billing_detaillObj.amount;
                        }else {
                            payType1 = PaymentMethod.getVirtualPm(payChannel);
                            payType1 = BIZCONSTANT.getPMbyCode(payType1.code);
                            try{
                                pos_billing_detaillObj.type = payType1.getType();
                            }catch (e) {
                                console.log("************************payType1.getType()异常************************");
                                console.log(e);
                                console.log("payChannel : " + payChannel);
                                console.log("payType1 : ");
                                console.log(payType1);
                                console.log("************************payType1.getType()异常************************");

                                Utils.winLog("************************payType1.getType()异常************************");
                                Utils.winLog(e);
                                Utils.winLog("payChannel : " + payChannel);
                                Utils.winLog("payType1 : ");
                                Utils.winLog(payType1);
                                Utils.winLog("************************payType1.getType()异常************************");
                            }
                            pos_billing_detaillObj.isHyJF = "false";
                            pos_billing_detaillObj.bizAmount = 0;
                            pos_billing_detaillObj.amount = wxOrderTradeInfo.payMoney;
                        }
                        pos_billingDetailObjs.push(pos_billing_detaillObj);
                        pos_billing_detaillObj.guid = wxOrderTradeInfo.guid;
                        pos_billing_detaillObj.jieSuanId = pos_billingObj.guid;
                        pos_billing_detaillObj.bizId = payType1.guid;
                        pos_billing_detaillObj.bizCode = payType1.code;
                        pos_billing_detaillObj.bizDesc = payType1.name;
                        pos_billing_detaillObj.caiWuShuXing = payType1.caiWuShuXing;
                        pos_billing_detaillObj.seq = wxOrderTradeInfo.payTime;
                        pos_billing_detaillObj.device = "weixin";
                        pos_billing_detaillObj.mdId = pos_orderObj.mdId;
                        pos_billing_detaillObj.isDeleted = "false";
                        pos_billing_detaillObj.createTime = pos_orderObj.luoDanTime;
                        pos_billing_detaillObj.addOperatorId = operate.id;
                        pos_billing_detaillObj.addOperatorCode = operate.code;
                        pos_billing_detaillObj.addOperatorName = operate.name;
                        pos_billing_detaillObj.ext1 = wxOrderTradeInfo.credentialNumber;
                        var couponNo1 = wxOrderTradeInfo.couponNo;
                        if(couponNo1 && couponNo1.length > 0) {
                            pos_orderObj.couponNo = couponNo1;
                        }
                    }
                }
                if(hasHYPayType == false) memCardNo = null;
                console.log(pos_billing_detaillObj);
                console.log("创建pos_billingDetailObjs对象=====================end.success===================== ");
            }

            function buildPrintZhuotaiOrder(orderId, order, kaitaiTime) {
                printZhuotai.orderId = orderId;
                printZhuotai.order = new Order();
                printZhuotai.order.guid = orderId;
                printZhuotai.order.zhuotaiId = zhuotai.guid;
                printZhuotai.order.zhuotaiName = zhuotai.name;
                printZhuotai.order.status = order.status;
                printZhuotai.order.renshu = order.renshu;
                printZhuotai.order.totalPrice = order.totalPrice;
                printZhuotai.order.code = zhangDanNo == null ? order.code : zhangDanNo;
                printZhuotai.order.serverId = operate.id;
                printZhuotai.order.serverName = operate.name;
                printZhuotai.order.operator = operate.id;
                printZhuotai.order.comments = order.comments;
                printZhuotai.order.kaiTaiTime = kaitaiTime;
                printZhuotai.order.luoDanTime = kaitaiTime;
                printZhuotai.order.modTime = kaitaiTime;

                printZhuotai.order.canbieId = canbie.guid;
                printZhuotai.order.canBieCode = canbie.code;
                printZhuotai.order.canbieName = canbie.name;
            }

        }

        //处理微信订单后返回结果
        function weiXinOrderCallBack(dataStr) {
            if(userFakeData == true) return;
            var url = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.WEIXIN_ORDER_CALLBACK_URL;
            if(testWeixin == true)
                url = "http://" + VALIDATE_TOKEN_HOST[1].HOST_BASIC + "/yunshan-weixin-api" + WEIXIN.WEIXIN_ORDER_CALLBACK_URL; //季老板URL
            console.info("weiXinOrderCallBack.dataStr : " + dataStr);
            callAjax(url, function (respones) {
                console.info("返回结果成功！" + " : " + dataStr);
            }, dataStr, null, function (err, data) {
                console.info("返回结果失败！");
            })
        }

        //结算后返回结算结果
        function weiXinJieSuanCallBack(dataStr) {
            if(userFakeData == true) return;
            var weixinConfirmUrl = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.WEINXIN_ORDER_CONFIRM_URL;
            if(testWeixin == true) {
                weixinConfirmUrl = "http://" + VALIDATE_TOKEN_HOST[1].HOST_BASIC + "/yunshan-weixin-api" + WEIXIN.WEINXIN_ORDER_CONFIRM_URL; //for test
            }
            console.info("weiXinJieSuanCallBack.dataStr : " + dataStr);
            callAjax(weixinConfirmUrl, function (respones) {
                console.info("返回结果成功！" + " : " + dataStr);
            }, dataStr, null, function (err, data) {
                console.info("返回结果失败！");
            })
        }

        //处理微信扫码支付订单更新
        function weiXinUpdateOrderCallBack(dataStr) {
            if(userFakeData == true) return;
            var url = SERVER_HOST.BASE_HOST + API_CONTEXT.WEIXIN + WEIXIN.WEIXIN_ORDER_UPDATEORDERBYSCANCODE;
            if(testWeixin == true)
                url = "http://" + VALIDATE_TOKEN_HOST[1].HOST_BASIC + "/yunshan-weixin-api" + WEIXIN.WEIXIN_ORDER_UPDATEORDERBYSCANCODE; //王涛URL
            console.info("weiXinUpdateOrderCallBack.dataStr : " + dataStr);
            callAjax(url, function (respones) {
                console.info("返回结果成功！" + " : " + dataStr);
            }, dataStr, null, function (err, data) {
                console.info("返回结果失败！");
            })
        }

        /*
         *打印结账单 zyy
         */
        function printJieZhangDan (jieSuan) {
            DiancaiService.getOrderCaipinsByLuodan(jieSuan.order.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, seq) {
                if (err) {
                    console.log("获取落单菜品异常： " + JSON.stringify(err));
                    return;
                }
                var mergedCaiPins = JieSuanService.mergeLuoDanCaiPin(seq);
                var luodanOrderCaipins = mergedCaiPins;
                printhelp.printJieZhangDan(jieSuan, luodanOrderCaipins, jieSuan.order.zhuotaiName,jieSuan.asDuiZhangDanView(),false, function(){
                })
            });
        }


        return WeiXinService;
    }]);












var testWeixin = false; //使用季老板测试环境
var userFakeData = false; //使用测试数据
var obj = {};
obj.data = '{"cardNo":"18652651017","eventType":"1","credentialNumbers":["HYPJ2016072000011","HYPJ2016072000012"],"crmTradeId":["5fd565e5-07b1-4748-80d3-90457d058c30","93639f76-225e-43a4-b0f6-bd409ef3aad7"],"groupCode":"10058","groupId":"729f6c45-ce34-44ce-ba1f-78f29b820b5d","operateOrgId":"31d556f5-9b24-4691-8a41-baf1cd3ce1af","orderNo":"20160918000003","orgCode":"100001","orgId":"31d556f5-9b24-4691-8a41-baf1cd3ce1af","tradeNo":""}';
var kafkaTestDataStr = JSON.stringify(obj);

var weixinOrderTestDataOjb = {
    "status" : "success",
    "msg" : null,
    "data" : {
        "guid" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
        "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
        "groupIdType" : "2",
        "groupCode" : "10058",
        "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
        "orgCode" : "100001",
        "orderNo" : "20160918000003",
        "moneyTotal" : 198.15,
        "moneyZK" : 185.15,
        "moneyYS" : 13,
        "moneyPaid" : 13,
        "orderType" : "Food",
        "orderSource" : "WeiXin",
        "openId" : "o7-_CvjJNXkTjWx7YretskXNBawc",
        "memberId" : "fc8a532e-da19-46fb-91ca-4b3a6144f939",
        "memberName" : "老季",
        "xiadanTime" : 1474196925000,
        "orgcode" : null,
        "orderStatus" : null,
        "cardNo" : "18652651017",
        "remark" : "",
        "status" : "NoValidate",
        "dp_status" : null,
        "operateOrgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
        "wxOrderTradeInfoList" : [{
            "guid" : "090daaf3-1406-4640-910d-2a0a345f4402",
            "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
            "groupIdType" : "2",
            "groupCode" : "10058",
            "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
            "orgCode" : null,
            "tradeNo" : "20160918000008",
            "orderNo" : "20160918000003",
            "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
            "openId" : "o7-_CvjJNXkTjWx7YretskXNBawc",
            "memberId" : "fc8a532e-da19-46fb-91ca-4b3a6144f939",
            "payMoney" : 5,
            "payChannel" : "JiFen",
            "payTime" : 1474197550000,
            "payResult" : false,
            "payCardNo" : "18652651017",
            "tradeErrorMsg" : null,
            "tradeReturnMsg" : null,
            "jiFen" : "10",
            "couponNo" : null,
            "credentialNumber" : "HYPJ2016091800043",
            "coupon_activityid" : null,
            "wxOrderTradeRefundInfo" : null,
            "wxOrdersInfo" : null,
            "delete" : false
        }, {
            "guid" : "7c07fa31-e206-4321-af36-81906af8d574",
            "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
            "groupIdType" : "2",
            "groupCode" : "10058",
            "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
            "orgCode" : null,
            "tradeNo" : "20160918000007",
            "orderNo" : "20160918000003",
            "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
            "openId" : "o7-_CvjJNXkTjWx7YretskXNBawc",
            "memberId" : "fc8a532e-da19-46fb-91ca-4b3a6144f939",
            "payMoney" : 13,
            "payChannel" : "MemCard",
            "payTime" : 1474197550000,
            "payResult" : true,
            "payCardNo" : "18652651017",
            "tradeErrorMsg" : null,
            "tradeReturnMsg" : null,
            "jiFen" : null,
            "couponNo" : null,
            "credentialNumber" : "HYPJ2016091800042",
            "coupon_activityid" : null,
            "wxOrderTradeRefundInfo" : null,
            "wxOrdersInfo" : null,
            "delete" : false
        }, {
            "guid" : "d1b66208-a8be-4506-a81e-f2666fc339e1",
            "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
            "groupIdType" : "2",
            "groupCode" : "10058",
            "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
            "orgCode" : null,
            "tradeNo" : "20160918000009",
            "orderNo" : "20160918000003",
            "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
            "openId" : "o7-_CvjJNXkTjWx7YretskXNBawc",
            "memberId" : "fc8a532e-da19-46fb-91ca-4b3a6144f939",
            "payMoney" : 180.15,
            "payChannel" : "MemHYJ",
            "payTime" : 1474197550000,
            "payResult" : false,
            "payCardNo" : "18652651017",
            "tradeErrorMsg" : null,
            "tradeReturnMsg" : null,
            "jiFen" : null,
            "couponNo" : null,
            "credentialNumber" : null,
            "coupon_activityid" : null,
            "wxOrderTradeRefundInfo" : null,
            "wxOrdersInfo" : null,
            "delete" : false
        }
        ],
        "wxOrderFoodInfo" : {
            "guid" : "ab4fe4cc-ca7e-4ec9-b297-c0f72f9b44a6",
            "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
            "groupIdType" : "2",
            "groupCode" : "10058",
            "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
            "orgCode" : null,
            "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
            "orderNo" : "20160918000003",
            "orderFoodType" : "TangShi",
            "eatRenshu" : 3,
            "zhuotaiCode" : "1011",
            "zhuotaiName" : "002",
            "daodianTime" : 1474196925000,
            "contactName" : null,
            "contactTel" : null,
            "contactAddress" : null,
            "addTime" : 1474196925000,
            "updatetime" : 1474196925000,
            "wxOrderFoodDishInfoList" : [{
                "guid" : "946e90f4-76ce-4b09-9dae-993d19ba7fe4",
                "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
                "groupIdType" : "2",
                "groupCode" : "10058",
                "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
                "orgCode" : null,
                "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
                "orderNo" : "20160918000003",
                "orderFoodId" : "ab4fe4cc-ca7e-4ec9-b297-c0f72f9b44a6",
                "dishId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af-csc",
                "dishCode" : "00101",
                "dishName" : "测试菜",
                "dishNum" : 1,
                "priceUnit" : 198.11,
                "priceTotal" : 198.11,
                "priceHy" : 18,
                "dishTypeId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af-dly",
                "dishTypeCode" : "11",
                "dishTypeName" : "大类一",
                "unitId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af-f",
                "unitName" : "份",
                "addTime" : 1474197107000,
                "updateTime" : 1474197107000,
                "addFoodNum" : 0,
                "retreatFoodNum" : 0,
                "wayPrice" : 0,
                "delete" : false
            }, {
                "guid" : "c2b01608-9e76-4979-939f-79f7f0ccce94",
                "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
                "groupIdType" : "2",
                "groupCode" : "10058",
                "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
                "orgCode" : null,
                "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
                "orderNo" : "20160918000003",
                "orderFoodId" : "ab4fe4cc-ca7e-4ec9-b297-c0f72f9b44a6",
                "dishId" : "1f10dfaa-170c-4b77-905e-8a15cfeeb785",
                "dishCode" : "1016",
                "dishName" : "小鸡腿",
                "dishNum" : 3,
                "priceUnit" : 0.01,
                "priceTotal" : 0.03,
                "priceHy" : 0,
                "dishTypeId" : "6ea0fe85-a7ab-4446-8bae-6b01e8d743d7",
                "dishTypeCode" : "12",
                "dishTypeName" : "热菜",
                "unitId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af-f",
                "unitName" : "份",
                "addTime" : 1474197107000,
                "updateTime" : 1474197107000,
                "addFoodNum" : 0,
                "retreatFoodNum" : 0,
                "wayPrice" : 0,
                "delete" : false
            }, {
                "guid" : "d6231cd1-d862-469a-9b3c-5889f251edf0",
                "groupId" : "729f6c45-ce34-44ce-ba1f-78f29b820b5d",
                "groupIdType" : "2",
                "groupCode" : "10058",
                "orgId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af",
                "orgCode" : null,
                "orderId" : "e3c1d4a1-6dd7-4f04-ba8c-e7a890dee8a1",
                "orderNo" : "20160918000003",
                "orderFoodId" : "ab4fe4cc-ca7e-4ec9-b297-c0f72f9b44a6",
                "dishId" : "08f800fb-0ffc-4de8-84ef-83ee5410cd31",
                "dishCode" : "1018",
                "dishName" : "太湖白鱼",
                "dishNum" : 1,
                "priceUnit" : 0.01,
                "priceTotal" : 0.01,
                "priceHy" : 0,
                "dishTypeId" : "6ea0fe85-a7ab-4446-8bae-6b01e8d743d7",
                "dishTypeCode" : "12",
                "dishTypeName" : "热菜",
                "unitId" : "31d556f5-9b24-4691-8a41-baf1cd3ce1af-f",
                "unitName" : "份",
                "addTime" : 1474197107000,
                "updateTime" : 1474197107000,
                "addFoodNum" : 0,
                "retreatFoodNum" : 0,
                "wayPrice" : 0,
                "delete" : false
            }
            ],
            "delete" : false
        },
        "wxOrderDianPingInfo" : null,
        "modTime" : 1474197107000,
        "delete" : false
    },
    "dataList" : null,
    "pageList" : null,
    "errorDetails" : [],
    "errorMsg" : null
}
