﻿app.factory('WuXianService', ['$q', 'database', 'UniqueIDService', 'ZhuotaiService', 'OperatorService', 'DiancaiService', 'PrintService',
    'GuqingService', 'AuthService', 'CaipinService', '$rootScope', 'OrderMenuService', 'JieSuanService',
    function ($q, database, UniqueIDService, ZhuotaiService, OperatorService, DiancaiService, PrintService, GuqingService, AuthService,
        CaipinService, $rootScope, OrderMenuService, JieSuanService) {
        var WuXianService = {};

        var wxloginDao = new DatabaseFuncDelegate($q, database, 'pos_wxlogin');
        var wxlshDao = new DatabaseFuncDelegate($q, database, 'pos_wxlsh');
        var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');
        var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');
        var orderScombCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_scomb_caipin');
        var orderScombBxCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_scomb_beixuan_caipin');
        var tuiCaiReasonDao = new DatabaseFuncDelegate($q, database, 'pos_tuicai_reason');
        var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');
        var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');
        var zuofaDao = new DatabaseFuncDelegate($q, database, 'pos_zuofa');
        var caipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_zuofa');
        var bancisDao = new DatabaseFuncDelegate($q, database, 'pos_banci');
        var ciapinUnitsDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_unit');
        var areaDao = new DatabaseFuncDelegate($q, database, 'pos_area');

        //登录
        WuXianService.addWxLogin = function (op, dcj, cb) {
            var sql = "select * from pos_wxlogin where dcj='" + dcj + "' ";
            wxloginDao.query(sql)
            .then(function (result) {
                var wxlogin = null;
                if (result.detail.length > 0) {
                    wxlogin = result.detail[0];
                }

                if (wxlogin == null) {
                    wxlogin = {};
                    wxlogin.guid = wxloginDao.guid();
                    wxlogin.dcj = dcj;
                    wxlogin.operatorID = op.guid;
                    wxlogin.operatorName = op.personName;
                    wxlogin.addTime = (new Date()).format("yyyy-MM-dd hh:mm:ss.S");
                    wxlogin.modTime = (new Date()).format("yyyy-MM-dd hh:mm:ss.S");
                    wxlogin.version = 0;

                    wxloginDao.insert(wxlogin).then(function (result) {
                        if (cb) {
                            cb(result);
                        }
                    });
                }
                else {
                    wxlogin = Utils.clone(wxlogin);
                    wxlogin.operatorID = op.guid;
                    wxlogin.operatorName = op.personName;
                    wxlogin.modTime = (new Date()).format("yyyy-MM-dd hh:mm:ss.S");
                    wxlogin.version += 1;

                    wxloginDao.updateObject(wxlogin, "guid").then(function (result) {
                        if (cb) {
                            cb(result);
                        }
                    });
                }
            });
        }

        //修改密码
        WuXianService.XGPwd = function (dcj, op, opwd, npwd, cb) {
            AuthService.xgpwd(op, opwd, npwd).then(function (opinfo) {
                cb(null, opinfo);

            }, function (err) {
                cb(err.message);
            });
        }

        //添加一个流水号
        WuXianService.addLsh = function (dcj, lsh, cb) {
            var ls = new pos_wxlsh();
            ls.guid = wxlshDao.guid();
            ls.dcj = dcj;
            ls.lsh = lsh;
            ls.addTime = (new Date()).format("yyyy-MM-dd hh:mm:ss.S");
            wxlshDao.insert(ls).then(function (result) {
                if (cb) {
                    cb(result);
                }
            });

        }

        //查询流水
        WuXianService.getLsh = function (dcj, lsh, cb) {
            if (lsh == '')
                return cb([]);
            var sql = "select * from pos_wxlsh where dcj='" + dcj + "' AND lsh='" + lsh + "' ";
            wxlshDao.query(sql)
            .then(function (result) {
                var res = [];
                for (var i in result.detail)
                {
                    if (result.detail[i].addTime.indexOf((new Date()).format('yyyy-MM-dd')) >= 0)
                        res.push(result.detail);
                }
                cb(res);
            });

        }


        //获取操作员 如果点菜器有传过来操作员code 那么根据code查找，没有传递则根据点菜器查找
        WuXianService.getOperatot = function (opcode, dcj, cb) {
            console.info('OP->begin');
            if (opcode && opcode != '') {
                console.info('OP->No Code');
                OperatorService.getByCodeorGuid(opcode, function (err, reslut) {
                    return cb(err, reslut);
                });
            } else {
                console.info('OP->With Code');
                var sql = "select * from pos_wxlogin where dcj='" + dcj + "' ";
                wxloginDao.query(sql)
                .then(function (result) {
                    console.info('OP->With Code->success');
                    var wxlogin = null;
                    if (result.detail.length > 0) {
                        wxlogin = result.detail[0];
                    }
                    if (wxlogin == null)
                        return cb('请先登录');
                    OperatorService.getByCodeorGuid(wxlogin.operatorID, function (err, reslut) {
                        return cb(err, reslut);
                    });
                });
            }
        }

        //开台
        WuXianService.kt = function (dcj, ztcde, rs, opcode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcde, function (zterr, zts) {
                debugger;
                if (zterr != null)
                    return cb(zterr);
                if (zts.length == 0)
                    return cb('找不到桌台');
                var zt = zts[0];
                console.info('KT->findZT');

                if (!rs || rs==''||isNaN(rs))
                    return cb('请输入正确的人数');

                WuXianService.getOperatot(opcode, dcj, function (err, operator) {
                    if (err != null)
                        return cb(err);
                    if (operator == null)
                        return cb('未查找到服务员');
                    console.info('KT->findOperator');
                    var order = new Order();
                    order.zhuotai = zt.guid;
                    order.renshu = parseInt(rs);
                    order.comments = '';
                    order.totalPrice = 0;

                    //todo 验证服务员是否存在
                    order.serverId = operator.personNo;
                    order.serverName = operator.personName;//todo 需要从数据库获取name
                    order.operator = operator.guid;
                    order.operatorName = operator.personName;
                    order.operatorCode = operator.personNo;
                    order.kaiTaiTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                    order.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                    order.mdId = BIZCONSTANT.POSUSER.mdId;

                    if (BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()) == null) {
                        return cb("当前时间段无餐别，请到后台维护！");
                    }

                    order.canbieId = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).guid;
                    order.canBieCode = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).code;
                    order.canbieName = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date()).name;
                    order.zhuotaiCode = zt.code;
                    order.areaGuid = zt.areaId;
                    order.areaCode = zt.areaCode;
                    order.areaName = zt.areaName;

                    ZhuotaiService.doKaitai(zt, order, function (err, orderid) {
                        order.guid = orderid;
                        console.info('KT->yes');
                        if (err != null)
                            cb(err);
                        else
                            cb(null, { name: zt.name, orderid: orderid, order: order }, zt);
                        //$rootScope.$broadcast('refreshZT', 'DCJ');
                        //console.log('DCJ--KT--Refresh');
                    });

                });
            });
        }

        //换台
        WuXianService.ht = function (dcj, oldztcode, newztcode, cb) {
            ZhuotaiService.getZhuotaiByCode(oldztcode, function (zterr, zts) {
                if (zterr)
                    return cb(zterr);
                if (zts.length == 0)
                    return cb('找不到原桌台')
                var ozt = zts[0];
                if (!ozt.order.guid)
                    return cb('原桌台未开台，不允许换台')

                var order = ozt.order;

                ZhuotaiService.getZhuotaiByCode(newztcode, function (nzterr, nzts) {
                    if (nzterr)
                        return cb(nzterr);
                    if (nzts.length == 0)
                        return cb('找不到目标桌台')
                    var nzt = nzts[0];

                    if (nzt.order.guid)
                        return cb('目标桌台已开台，不允许换台')

                    ZhuotaiService.doHuantai(ozt, nzt, function (err, seq) {
                        if (err) {
                            return cb(err.message);
                        }
                        
                        /*  打印换台单  */
                        printHuanTaiDan(ozt, nzt, order);
                        cb(null, "【" + ozt.name + "】成功换到【" + nzt.name + "】");
                        //$rootScope.$broadcast('refreshZT', 'true');

                    }, function (err) {
                        return cb(err.message);
                    });


                });
            });
        }

        //所有空台 返回桌台的名称 以‘|’ 分割
        WuXianService.allKongTai = function (dcj, cb) {
            ZhuotaiService.getZhuotaisByParams({ status: 0 }, 0, 1000, function (err, result) {
                if (err)
                    return cb(err);
                var zts = [];
                for (var i in result) {
                    zts.push(result[i].name);
                }
                cb(null, zts.join('|'));
            });
        }

        //所有预定台 
        WuXianService.allYuDingTai = function (dcj, cb) {
            ZhuotaiService.getZhuotaisByParams({ status: 0 }, 0, 1000, function (err, result) {
                if (err)
                    return cb(err);
                var zts = [];
                for (var i in result) {
                    var ozt = result[i];
                    var sta = '';
                    if (!ozt.order.guid)
                        sta = '已开台';
                    else
                        sta = '空台';
                    zts.push({ name: ozt.name, status: sta });
                }
                cb(null, zts);
            });
        }

        //检查桌台是否空闲 
        WuXianService.checkZtStatus = function (dcj, ztcode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (zterr, zts) {
                if (zterr)
                    return cb(zterr);
                if (zts.length == 0)
                    return cb('找不到桌台')
                var ozt = zts[0];
                if (ozt.order.guid)
                    return cb(null, '已开台');
                else
                    return cb(null, '空台');
                return cb(null, false);
            });
        }

        //修改抬头（修改桌台人数）
        WuXianService.updateTitla = function (dcj, ztcode, rs, opcode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台');
                }
                DiancaiService.updateOrderRenshu(zt.order, rs, function (err, seq) {
                    if (err) {
                        return cb(err.message);
                    }
                    cb(null, zt.name);
                });
            });
        }


        /*  打印换台单  */
        function printHuanTaiDan(oldzt, newzt, order) {
            var huantai = new HuanTaiObject();
            huantai.oldDeskNo = oldzt.name;
            huantai.newDeskNo = newzt.name;
            huantai.diancaiyuan = BIZCONSTANT.POSUSER.name;


            DiancaiService.getOrderCaipinsByLuodan(order.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, seq) {
                if (err) {
                    return;
                }
                debugger;
                var huadanarr = (new printReceipt()).getPrintersByCaipins(seq, BIZCONSTANT.PRINTINVOCECODE.HUANTAIDAN);
                for (var c in huadanarr.printids) {
                    var data = huadanarr[huadanarr.printids[c]];
                    var receipt = data.receipt;
                    var printtext = printhelp.printtext(huantai, receipt);

                    var printjob = new PrinterJob();
                    printjob.name = "换台单";
                    printjob.mPrinterId = receipt.printId;
                    printjob.status = 0;
                    printjob.errorCount = 0;
                    printjob.content = printtext;
                    printjob.createTime = null;
                    printjob.processing = 0;
                    printjob.invoiceCode = null;
                    printjob.ref = null;
                    printjob.orderId = oldzt.order.code;
                    printjob.jobNo = null;
                    printjob.printTime = null;
                    printjob.printCount = 0;
                    PrintService.addJob(printjob);
                    console.log('print')
                }

            },oldzt,orderZhuoTai.guid);
        }

        //点菜
        WuXianService.dc = function (dcj, opcode, ztcode, rs, zf_yq, zt_fs, dishs, lsh, cb) {
            debugger;
            WuXianService.getLsh(dcj, lsh, function (lss) {
                if (lss.length > 0)
                    return cb(null, true);//流水号存在的话，直接返回成功
                ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                    if (err != null)
                        return cb(err.message);
                    var zt = ztlist[0];
                    if (!zt)
                        return cb('桌台不存在');
                    if (!zt.order.guid) {
                        WuXianService.kt(dcj, ztcode, rs, '', function (err, result,nzt) {
                            console.info(result);
                            zt = nzt;
                            if (err != null)
                                return cb('桌台未开台，且开台失败，' + err);
                            zt.order = result.order;
                            loadDCData(function () {
                                DC(dcj,opcode, zt, zf_yq, zt_fs, dishs, lsh, cb);
                            });

                        })
                    }
                    else
                        loadDCData(function () {
                            DC(dcj,opcode, zt, zf_yq, zt_fs, dishs, lsh, cb);
                        });
                });
            });
        }

        function DC(dcj, opcode, zt, zz_kw, notic, dishsarr, lsh, cb) {
            WuXianService.getOperatot(opcode, dcj, function (err, operator) {
                if (err != null)
                    return cb(err);
                if (operator == null)
                    return cb('未查找到服务员');

                var dishs = [];
                for (var i in dishsarr)
                {
                    var tpcp = dishsarr[i];
                    if (tpcp.TCID && tpcp.TCID != '') {
                        var tc = null;
                        var needadd = false;
                        for (var t in dishs)
                        {
                            if (dishs[t].TCID == tpcp.TCID && dishs[t].TCMX == tpcp.TCMX)
                                tc = dishs[t];
                        }
                        if (tc == null)
                        {
                            needadd = true;
                            tc = Utils.clone(tpcp);
                            tc.CPID = tc.TCID;
                            tc.TC = [];
                        }
                        tc.TC.push(tpcp);
                        if (needadd)
                            dishs.push(tc);
                        
                    } else
                        dishs.push(tpcp);
                }


                var cpids = '';
                var cpidlength = 0;
                for (var i in dishs) {
                    var cpid = dishs[i].CPID;
                    cpidlength = cpid.length;
                    if (cpid.length > BIZCONSTANT.DCJ_DishCodeLength)
                        cpid = cpid.substr(cpid.length - BIZCONSTANT.DCJ_DishCodeLength, BIZCONSTANT.DCJ_DishCodeLength);
                    cpids += "'" + cpid + "' ,";;
                }
               
                cpids = cpids.substr(0, cpids.length - 1);
                console.info(cpids);//-------------------------------


                DC_GetDishs(cpids, function (err, result) {
                    //debugger;
                    if (err != null)
                        return cb(err);
                    if (result.length == 0)
                        return cb('所点菜品都不存在');
                    var caipins = [];
                    for (var i in dishs) {

                        var cp = dishs[i];

                        var dishcode = cp.CPID;
                        console.info(dishcode);
                        var dish = null;

                        for (var d in result) {

                            if (dishcode.indexOf(result[d].code)>=0)
                                dish = result[d];
                        }

                        console.info(cp);
                        if (dish == null)
                            continue;

                        dish.caipinNum = cp.CPNUM;
                        if (dish.isScomb == 'true')
                        {
                            dish.caipinNum = cp.TCNUM;
                        }
                        if (dish.guqingNum != -1) {
                            if (dish.guqingNum == 0) {
                                return cb(dish.name + "已估清");
                            }
                            if (dish.guqingNum < dish.caipinNum) {
                                return cb(dish.name + "剩余数量不足");
                            }
                        }

                        dish.zengNum = 0;
                        if (cp.ZSBJ == 1 || cp.ZSBJ == '1')
                            dish.zengNum = cp.CPNUM;

                        if (dish.customize == 'true') {
                            dish.name = cp.CPNAME;
                            dish.salePrice = cp.CPPRICE;
                            if (cp.CPNUIT != '' && cp.CPNUIT) {
                                dish.unitName = cp.CPNUIT;
                            }
                        }
                        if (dish.needweigh == 'true' && cp.CPTZS && cp.CPTZS != '') {
                            dish.caipinNum = cp.CPTZS;
                        }
                        dish.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
                        if (cp.CPBJ && cp.CPBJ != '')
                            dish.chupin = cp.CPBJ;

                        if (notic && notic != '')
                            dish.chupin = notic;
                        var caipin = createOrderCaipin(operator, zt.order, dish);
                        caipin.zfyq = cp.CPZFYQ;
                        if (dish.isScomb == 'true') {
                            caipin.scombCaipins = [];
                            for (var i = 0; i < dish.scombinfo.scombCaipins.length; i++) {
                                var scombdish = dish.scombinfo.scombCaipins[i].scombCaipinInfo;
                                var scompTCCP = null;
                                //debugger;
                                if (cp.TC)
                                {
                                    var needbx = true;
                                    for (var c in cp.TC)
                                    {
                                        var tempTCCP = cp.TC[c];
                                        if (tempTCCP.CPID.indexOf(scombdish.code) >= 0)
                                        {
                                            scompTCCP = tempTCCP;
                                            needbx = false;
                                        }   
                                    }
                                    if (needbx)
                                    {
                                        outer:for (var n in dish.scombinfo.scombCaipins[i].bxScombCaipins)
                                        {
                                            var bxcp = dish.scombinfo.scombCaipins[i].bxScombCaipins[n];
                                            for (var c in cp.TC) {
                                                var tempTCCP = cp.TC[c];
                                                if (tempTCCP.CPID.indexOf(bxcp.code) >= 0)
                                                {
                                                    scombdish = bxcp;
                                                    scompTCCP = tempTCCP;
                                                    break outer;
                                                }
                                            }
                                        }
                                    }
                                }

                                if (scompTCCP != null)
                                    scombdish.caipinNum = scombdish.caipinNum * Utils.m(scompTCCP.TCNUM);
                                if (scombdish.guqingNum != -1) {
                                    if (scombdish.guqingNum == 0) {
                                        return cb('套餐中的' + scombdish.name + "已估清");
                                    }
                                    if (scombdish.guqingNum < scombdish.caipinNum) {
                                        return cb('套餐中的' + scombdish.name + "剩余数量不足");
                                    }
                                }
                                var scombCaipin = createOrderScombCaipin(operator, caipin, scombdish);



                                scombCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
                                if (cp.CPBJ && cp.CPBJ != '')
                                    scombCaipin.chupin = cp.CPBJ;

                                if (notic && notic != '')
                                    scombCaipin.chupin = notic;
                                if (scompTCCP!=null)
                                    scombCaipin.zfyq = scompTCCP.CPZFYQ;

                                caipin.scombCaipins.push(scombCaipin);
                            }
                        }



                        caipins.push(caipin);

                    }

                    var queries = [];
                    for (var c in caipins) {
                        debugger;
                        var orderCaipin = caipins[c];
                        if (orderCaipin.isScomb == 'true')
                        {
                            for (var t in orderCaipin.scombCaipins)
                            {
                                var tpscombcaipin = orderCaipin.scombCaipins[t];
                                setDishZFKW(operator, tpscombcaipin, zz_kw, null);
                                setDishZFKW(operator, tpscombcaipin, tpscombcaipin.zfyq, zz_kw);
                            }
                        }
                        else
                        {
                            setDishZFKW(operator, orderCaipin, zz_kw, null);
                            setDishZFKW(operator, orderCaipin, orderCaipin.zfyq, zz_kw);
                        }
                        

                        queries.push({
                            query: "insert into pos_order_caipin ( " +
                            "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,costprice,hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName,orderZhuoTaiId, dishFastNo,bestTypeId,bestTypeCode,bestTypeName) " +
                            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?, ?, ?,?,?,?,?,?,?,?,?,?,?,?)",
                            params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                                orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                                orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                                orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime,
                                orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.isScomb, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                                orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName,zt.orderZhuoTai.guid,
                                orderCaipin.dishFastNo,orderCaipin.bestTypeId,orderCaipin.bestTypeCode,orderCaipin.bestTypeName
                            ]
                        });

                        if (orderCaipin.isScomb == 'true') {
                            for (var i = 0; i < orderCaipin.scombCaipins.length; i++) {
                                var scombCaipin = orderCaipin.scombCaipins[i];

                                //var scombCaipin = createOrderScombCaipin(operator, orderCaipin, scombdish);
                                debugger;
                                queries.push({
                                    query: "insert into pos_order_scomb_caipin ( " +
                                    "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                                    "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
                                    "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
                                    "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?)",
                                    params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                                        scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                                        scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                                        scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName, scombCaipin.dianCaiTime, scombCaipin.modTime,
                                        scombCaipin.needweigh, orderCaipin.isScomb, scombCaipin.caipinId, scombCaipin.costprice,
                                        scombCaipin.hyPrice, scombCaipin.caipinTypeId, scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName]
                                });
                            }
                        }
                    }
                    orderCaipinDao.queryTransaction(queries).then(function (resultList) {


                        if (Utils.isEmpty(zt.order.code)) {
                            //获取账单号
                            var now = new Date();
                            UniqueIDService.nextSeq(now, 'order', function (err, seq, nowdate) {
                                if (err) {
                                    return cb(err.message);
                                }
                                var seqNo = nowdate + Utils.formatSeqNo(seq);
                                var zhangDanNo = "ZD" + seqNo;
                                zt.order.code = zhangDanNo;
                                doLuodan(dcj, lsh, operator.guid, zt, zt.order, caipins, cb);

                            });
                        } else {
                            doLuodan(dcj, lsh, operator.guid, zt, zt.order, caipins, cb);
                        }
                    }, function (err) {
                        debugger;
                        cb(err.message);
                    });

                });
            });
        }

        function setDishZFKW(operator, orderCaipin,zfkwstr,ZZ_str)
        {
            var zfyq = zfkwstr;
            if (zfyq && zfyq != '')
            {
                var zfkws = zfyq.split('|');
                var kws = [];
                for (var i = 0; i < zfkws.length; i++) {
                    var zfkw = zfkws[i];
                    if (zfkw != '') {

                        if (ZZ_str && ZZ_str.indexOf(zfkw) >= 0)
                            continue;

                        if (isNaN(zfkw) || zfkw.substring(0, 1) == '1')//口味
                        {
                            var kwcode = isNaN(zfkw) ? zfkw : (zfkw.substring(1, zfkw.length));
                            var kw = getKouweisByCode(kwcode);
                            if (kw != null) {
                                debugger;
                                orderCaipin.kouweis.push(kw);
                                DiancaiService.addOrderCaipinKouweis(operator.guid, orderCaipin, kw, function () { })
                            }
                        }
                        if (zfkw.substring(0, 1) == '0')//做法
                        {
                            var zf = getZuofasByCode(zfkw.substring(1, zfkw.length));
                            if (zf != null) {
                                debugger;
                                orderCaipin.zuofas.push(zf);
                                DiancaiService.addOrderCaipinZuofa(operator.guid, orderCaipin, zf, function () { });
                            }
                            
                        }
                    }
                }

            }
        }

        //点菜时 获取所点菜品
        function DC_GetDishs(cpids_in_where, cb) {
            var cpsql = "select c.*,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName,case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as guqingNum " +
                        " ,be.dishTypeCode AS bestTypeCode, be.guid AS bestTypeId, be.dishTypeName AS bestTypeName " +
                           " from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                           " and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid " +
                           " left join pos_caipin_type ct on c.typeId= ct.guid " +
                            " left join pos_caipin_type be on ct.parentId=be.guid " +
                           " where c.isDeleted='false' and c.enabled='true' AND c.code in (" + cpids_in_where + ")";

            caipinDao.query(cpsql)
			    .then(function (result) {
			        if (result.detail.length == 0)
			            return cb('所点菜品都不存在');
			        var caipins = [];
			        var hasscomb = false;
			        for (var i in result.detail) {
			            var dish = result.detail[i];

			            if (dish.isScomb == 'true') {
			                hasscomb = true;
			                break;
			            }
			        }
			        if (!hasscomb) {
			            return cb(null, result.detail);
			        }
			        CaipinService.getScombInfoByCodes(cpids_in_where, function (err, scomblist) {
			            if (err != null)
			                return cb('查询套餐失败：' + err.message);
			            var caipins = [];
			            for (var i in result.detail) {
			                var dish = result.detail[i];

			                if (dish.isScomb == 'true') {
			                    var scombinfo = Utils.arrayFind(scomblist, dish.guid, "guid");
			                    dish.scombinfo = scombinfo;
			                }
			                caipins.push(dish);
			            }
			            return cb(null, caipins);
			        });

			    });
        }

        function getKouweisByCode(code) {

            var kw = null;
            if (BIZCONSTANT.ALLKOUWEI)
            {
                for (var i in BIZCONSTANT.ALLKOUWEI)
                {
                    var tpkw = BIZCONSTANT.ALLKOUWEI[i];
                    if (isNaN(code)) {
                        if (tpkw.kwCode == BIZCONSTANT.SELFKOUWEI_CODE)
                            kw = tpkw;
                    }
                    else
                    {
                        if (tpkw.kwCode == code)
                        {
                            kw = tpkw;
                        }
                    }
                    if (kw != null)
                        break;
                }
            }

            if (kw != null)
            {
                kw = kouweiDbToModel(kw);
                if(isNaN(code))
                    kw.kwName = code;
            }

            return kw;
        };

        function getZuofasByCode(code) {

            var zf = null;
            if (BIZCONSTANT.ALLZUOFA) {
                for (var i in BIZCONSTANT.ALLZUOFA) {
                    var tpkw = BIZCONSTANT.ALLZUOFA[i];
                    if (tpkw.code == code) 
                    { 
                        zf = tpkw;
                        break;
                    }
                }
            }

            if (zf != null) {
                zf = zuofaDbToModel(zf);
            }

            return zf
        };

        function zuofaDbToModel(row) {
            var zuofa = new Zuofa();
            zuofa.guid = row.guid;
            zuofa.code = row.code;
            zuofa.name = row.name;
            zuofa.typeId = row.typeId;
            zuofa.price = row.price;
            zuofa.quickCode = row.quickCode;
            zuofa.jiajiaType = row.jiajiaType;
            zuofa.enabled = row.enabled;
            zuofa.isDeleted = row.isDeleted;

            return zuofa;
        }

        function kouweiDbToModel(row) {
            var kouwei = new Kouwei();
            kouwei.guid = row.guid;
            kouwei.kwCode = row.kwCode;
            kouwei.kwName = row.kwName;
            kouwei.quickCode = row.quickCode;
            kouwei.enabled = row.enabled;
            kouwei.isDeleted = row.isDeleted;

            return kouwei;
        }

        //落单
        function doLuodan(dcj, lsh, operator, zt, order, caipins, cb) {
            DiancaiService.doLuodan(operator, zt, order, caipins, function (err) {
                WuXianService.addLsh(dcj, lsh, function () {

                })
                calculateTotalPrice(zt);
                printhelp.printhuadan(zt, caipins, PrintService, operator.personName);
                printhelp.printzhizuodan(zt, caipins, PrintService, operator.personName);

                var luodanPrintStyle = CAT_PAR.REMOTE.LDDY;
                if (luodanPrintStyle == '打印本次落单菜品') {
                    printhelp.printKeYongDan(caipins, zt.name, order, function () { });
                }
                
                if (luodanPrintStyle == '打印整桌菜品') {
                    //var newArr = $scope.luodanOrderCaipins.concat($scope.disLuodanOrderCaipins);
                    //printhelp.printKeYongDan( newArr, $scope.currentZhuotai.name, $scope.currentOrder);
                    DiancaiService.getOrderCaipinsByLuodan(order.guid, BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE, function (err, seq) {
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }
                        //PrintService.doKeYongDanPrint($scope.currentOrder, seq);
                        printhelp.printKeYongDan(seq, zt.name, order, function () { });
                    });
                }
                cb(null);
            });
        }

        function createOrderScombCaipin(operator, orderCaipin, caipin) {
            var num = 1;
            if (caipin.caipinNum > 1)
                num = caipin.caipinNum;
            var now = new Date().format("yyyy-MM-dd hh:mm:ss");
            var scombCaipin = new OrderCaipin();
            scombCaipin.guid = orderScombCaipinDao.guid();

            scombCaipin.orderCaipinId = orderCaipin.guid;//订单中套餐菜品GUID
            scombCaipin.scombId = orderCaipin.caipinId;//套餐的GUID

            scombCaipin.caipinId = caipin.guid;
            scombCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
            scombCaipin.name = caipin.name;
            scombCaipin.price = caipin.salePrice;
            scombCaipin.costprice = caipin.costprice;
            scombCaipin.num = num;
            scombCaipin.tuiNum = 0;
            scombCaipin.zengNum = 0;
            scombCaipin.unitName = caipin.unitName;
            scombCaipin.printId = caipin.printId;
            scombCaipin.printName = caipin.printName;
            scombCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
            scombCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
            scombCaipin.minAgio = caipin.minAgio;
            scombCaipin.danPinBiLiZheKou = 0;
            scombCaipin.danPinJineZheKou = 0;
            scombCaipin.danPinZheKou = 0;
            scombCaipin.operator = operator.guid;
            scombCaipin.dianCaiYuan = operator.guid;
            scombCaipin.dianCaiYuanName = operator.personName;
            scombCaipin.dianCaiTime = now;
            scombCaipin.modTime = now;
            scombCaipin.needweigh = caipin.needweigh ? 1 : 0;
            scombCaipin.isScomb = 'true';
            scombCaipin.scombMainCaipinId = caipin.guid;


            scombCaipin.hyPrice = caipin.hyPrice;
            scombCaipin.caipinTypeId = caipin.typeId;
            scombCaipin.caipinTypeCode = caipin.typeCode;
            scombCaipin.caipinTypeName = caipin.typeName;

            return scombCaipin;
        }

        function createOrderCaipin(operator, order, caipin) {
            var num = 1;
            if (caipin.caipinNum > 0)
                num = caipin.caipinNum;
            var now = new Date().format("yyyy-MM-dd hh:mm:ss");
            var orderCaipin = new OrderCaipin();
            orderCaipin.guid = orderCaipinDao.guid();
            orderCaipin.orderId = order.guid;
            orderCaipin.caipinId = caipin.guid;
            orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
            orderCaipin.name = caipin.name;
            orderCaipin.price = caipin.salePrice;
            orderCaipin.costprice = caipin.costprice;
            orderCaipin.num = Utils.m(num);
            orderCaipin.tuiNum = 0;
            orderCaipin.zengNum = caipin.zengNum;
            orderCaipin.unitName = caipin.unitName;
            orderCaipin.printId = caipin.printId;
            orderCaipin.printName = caipin.printName;
            orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
            orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
            orderCaipin.minAgio = caipin.minAgio;
            orderCaipin.danPinBiLiZheKou = 0;
            orderCaipin.danPinJineZheKou = 0;
            orderCaipin.danPinZheKou = 0;
            orderCaipin.operator = operator.guid;
            orderCaipin.dianCaiYuan = operator.guid;
            orderCaipin.dianCaiYuanName = operator.personName;
            orderCaipin.dianCaiTime = now;
            orderCaipin.modTime = now;
            orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
            orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;

            orderCaipin.hyPrice = caipin.hyPrice;
            orderCaipin.caipinTypeId = caipin.typeId;
            orderCaipin.caipinTypeCode = caipin.cpTypeCode;
            orderCaipin.caipinTypeName = caipin.cpTypeName;

            orderCaipin.dishFastNo = caipin.quickCode;
            orderCaipin.bestTypeId = caipin.bestTypeId;
            orderCaipin.bestTypeCode = caipin.bestTypeCode;
            orderCaipin.bestTypeName = caipin.bestTypeName;





            return orderCaipin;
        }

        //加载点菜需要的数据，加快点单速度
        function loadDCData(cb)
        {
            if (BIZCONSTANT.ALLZUOFA && BIZCONSTANT.ALLZUOFA.length > 0)
                return cb();
            DiancaiService.getZuofasBySearchKey('', 0, 10000, function (err, zflist) {
                BIZCONSTANT.ALLZUOFA = zflist;
                if (err != null)
                    BIZCONSTANT.ALLZUOFA = [];
                DiancaiService.getKouweis(0, 10000, function (kwerr, kwlist) {
                    BIZCONSTANT.ALLKOUWEI = kwlist;
                    if (err != null)
                        BIZCONSTANT.ALLKOUWEI = [];
                    cb();
                });
            });
        }

        //退菜
        WuXianService.tuiCai = function (dcj, ztcode, dishcode, dishnum, tuicaireasoncode, cb) {
            dishnum = parseInt(dishnum);
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台，无法进行退菜操作');
                }

                console.info(dishcode);
                if (dishcode.length > BIZCONSTANT.DCJ_DishCodeLength)
                    dishcode = dishcode.substr(dishcode.length - BIZCONSTANT.DCJ_DishCodeLength, BIZCONSTANT.DCJ_DishCodeLength);
                console.info(dishcode);

                WuXianService.getOperatot('', dcj, function (err, operator) {
                    if (err != null)
                        return cb(err);
                    if (operator == null)
                        return cb('未查找到服务员');
                    DiancaiService.getTuicaiReasonsByCode(tuicaireasoncode, function (err, tuicaiReason) {
                        if (err != null)
                            return cb(err);
                        if (tuicaiReason == null)
                            return cb('退菜原因不存在');

                        var cpsql = "select c.*,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName,case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as guqingNum " +
                          " from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                          " and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid " +
                          "left join pos_caipin_type ct on c.typeId= ct.guid " +
                          " where c.isDeleted='false' and c.enabled='true' AND c.code = '" + dishcode + "' ";
                        caipinDao.query(cpsql)
                        .then(function (result) {
                            if (result.detail.length == 0)
                                return cb('菜品不存在');
                            var dish = result.detail[0];
                            //---------------------------
                            DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                                if (err != null)
                                    return cb(err.message);
                                if (orderCaipins == null || orderCaipins.length == 0)
                                    return cb('该桌台尚未点单，无法退菜');
                                debugger;
                                var needtuicai = [];
                                var synum = 0;
                                for (var i = 0; i < orderCaipins.length; i++) {
                                    var orderdish = orderCaipins[i];
                                    if (orderdish.caipinId == dish.guid) {
                                        orderdish.synum = (orderdish.num - orderdish.zengNum - orderdish.tuiNum);
                                        if (orderdish.synum > 0) {
                                            synum += orderdish.synum;
                                            needtuicai.push(orderdish);
                                        }
                                    }
                                }
                                if (synum == 0)
                                    return cb('没有可退菜品');
                                if (synum < dishnum)
                                    return cb('菜品剩余数量不足，无法退菜');
                                for (var j in needtuicai) {


                                    var odish = needtuicai[j];
                                    var num = (odish.synum <= dishnum) ? odish.synum : dishnum;
                                    DiancaiService.doTuicai(operator.guid, odish, tuicaiReason, '', num, function (err, ret) {
                                        if (err == null)
                                            printhelp.printtuicai(zt, odish, num, tuicaiReason, PrintService, operator.personName);
                                    });
                                    dishnum = dishnum - odish.synum;

                                    if (dishnum <= 0) {
                                        calculateTotalPrice(zt);
                                        return cb(null, zt.name + needtuicai[0].name + '已退！原因：' + tuicaiReason.name);
                                    }

                                }
                            },zt.orderZhuoTai.guid);
                            //----------end---------------
                        }, function (err) {
                            cb(err.message);
                        });



                    });
                });

            });
        }

        //整桌退菜
        WuXianService.ZZtuiCai = function (dcj, ztcode, tuicaireasoncode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台，无法进行退菜操作');
                }

                WuXianService.getOperatot('', dcj, function (err, operator) {
                    if (err != null)
                        return cb(err);
                    if (operator == null)
                        return cb('未查找到服务员');
                    DiancaiService.getTuicaiReasonsByCode(tuicaireasoncode, function (err, tuicaiReason) {
                        if (err != null)
                            return cb(err);
                        //if (tuicaiReason == null)
                        //    return cb('退菜原因不存在');


                        //---------------------------
                        DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                            if (err != null)
                                return cb(err.message);
                            if (orderCaipins == null || orderCaipins.length == 0)
                                return cb(null, '该桌台尚未点单');

                            for (var i = 0; i < orderCaipins.length; i++) {
                                var orderdish = orderCaipins[i];

                                orderdish.num = (orderdish.num - orderdish.zengNum - orderdish.tuiNum);
                                if (orderdish.num > 0) {
                                    DiancaiService.doTuicai(operator.guid, orderdish, tuicaiReason, '', orderdish.num, function (err, ret) {
                                        if (err == null)
                                            printhelp.printtuicai(zt, orderdish, orderdish.num, tuicaiReason, PrintService, operator.personName);
                                    });
                                }
                            }

                            return cb(null, '桌台' + zt.name + '整桌退菜成功');

                        },zt.orderZhuoTai.guid);
                        //----------end---------------


                    });
                });

            });
        }


        WuXianService.ZengCai = function (dcj, ztcode, dishcode, dishnum, tuicaireasoncode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台，无法进行退菜操作');
                }
                console.info(dishcode);
                if (dishcode.length > BIZCONSTANT.DCJ_DishCodeLength)
                    dishcode = dishcode.substr(dishcode.length - BIZCONSTANT.DCJ_DishCodeLength, BIZCONSTANT.DCJ_DishCodeLength);
                console.info(dishcode);
                if (!tuicaireasoncode || tuicaireasoncode == '')
                    tuicaireasoncode = '点菜器赠送菜品';

                WuXianService.getOperatot('', dcj, function (err, operator) {
                    if (err != null)
                        return cb(err);
                    if (operator == null)
                        return cb('未查找到服务员');
                    DiancaiService.getZengsongReasonsByCode(tuicaireasoncode, function (err, tuicaiReason) {
                        if (err != null)
                            return cb(err);
                        if (tuicaiReason == null)
                            return cb('赠送原因不存在');

                        var cpsql = "select c.*,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName,case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as guqingNum " +
                          " from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
                          " and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid " +
                          "left join pos_caipin_type ct on c.typeId= ct.guid " +
                          " where c.isDeleted='false' and c.enabled='true' AND c.code = '" + dishcode + "' ";
                        caipinDao.query(cpsql)
                        .then(function (result) {
                            if (result.detail.length == 0)
                                return cb('菜品不存在');
                            var dish = result.detail[0];
                            //---------------------------
                            DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                                if (err != null)
                                    return cb(err.message);
                                if (orderCaipins == null || orderCaipins.length == 0)
                                    return cb('该桌台尚未点单，无法赠菜');
                                var needtuicai = [];
                                var synum = 0;
                                for (var i = 0; i < orderCaipins.length; i++) {
                                    var orderdish = orderCaipins[i];
                                    if (orderdish.caipinId == dish.guid) {
                                        orderdish.num = (orderdish.num - orderdish.zengNum - orderdish.tuiNum);
                                        if (orderdish.num > 0) {
                                            synum += orderdish.num;
                                            needtuicai.push(orderdish);
                                        }
                                    }
                                }
                                if (synum == 0)
                                    return cb('没有可赠菜品');
                                if (synum < dishnum)
                                    return cb('菜品剩余数量不足，无法赠送菜');
                                for (var j in needtuicai) {

                                    var odish = needtuicai[j];
                                    var num = (odish.num <= dishnum) ? odish.num : dishnum;
                                    console.log(num);
                                    console.log(odish);
                                    DiancaiService.doZengsong(operator.guid, odish, tuicaiReason, num, function (err, ret) {

                                    });
                                    dishnum = dishnum - odish.num;

                                    if (dishnum <= 0) {
                                        calculateTotalPrice(zt);
                                        return cb(null, zt.name + needtuicai[0].name + '已赠！原因：' + tuicaiReason.name);
                                    }
                                }
                            },zt.orderZhuoTai.guid);
                            //----------end---------------
                        }, function (err) {
                            cb(err.message);
                        });



                    });
                });

            });
        }


        WuXianService.printKYD = function (dcj, ztcode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台');
                }

                DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                    if (err != null)
                        return cb(err.message);
                    if (orderCaipins == null || orderCaipins.length == 0)
                        return cb('该桌台尚未点单，无法打印');
                    try {
                        printhelp.printKeYongDan(orderCaipins, zt.name, zt.order, function (err) {
                        });
                    } catch (e) {

                    }
                    cb(null, zt.name);
                });
            });
        }

        WuXianService.printDZD = function (dcj, ztcode, cb) {
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {
                    return cb('桌台尚未开台');
                }

                DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                    if (err != null)
                        return cb(err.message);
                    if (orderCaipins == null || orderCaipins.length == 0)
                        return cb('该桌台尚未点单，无法打印');
                    try {
                        //printhelp.printDuiZhangDan(orderCaipins, zt.name, zt.order, null, function (err) {
                        //    DiancaiService.orderYuJie(zt.order.guid, function (err) {
                                
                        //    });
                        //});

                        var jiesuan = new JieSuan();
                        JieSuanService.loadByOrderId(zt.order, jiesuan, function () {
                            var dishs = JieSuanService.mergeLuoDanCaiPin(orderCaipins);

                            printhelp.printNewDuiZhangDan(jiesuan, dishs, function () {
                               
                                if (err != null) 
                                    return ;
                                DiancaiService.orderYuJie(cz.orderId, function (err) {
                                   
                                });

                            });
                        });

                    } catch (e) {

                    }
                    cb(null, zt.name);
                });
            });
        }

        //重新计算订单金额
        function calculateTotalPrice(zt, orderZhuotaiId) {
            var orderZhuotaiId = zt.orderZhuoTai.guid;
            var orderzhuotai = zt.orderZhuoTai;
            var order = zt.order;
            DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                var totalPrice = 0;

                _.each(orderCaipins, function (orderCaipin) {
                    totalPrice += orderCaipin.calMoney4DianCai();
                });

                DiancaiService.getOrderCaipinsByLuodan(zt.order.guid,  '0', function (err, disorderCaipins) {
                    _.each(disorderCaipins, function (orderCaipin) {
                        totalPrice += orderCaipin.calMoney4DianCai();
                    });

                    var oldOrderZhuotaiPrice = orderzhuotai.totalPrice;
                    var orderPrice = order.totalPrice - oldOrderZhuotaiPrice + totalPrice;
                    order.totalPrice = orderPrice;
                    orderzhuotai.totalPrice = totalPrice;

                    DiancaiService.updateOrderTotalPrice(order, orderPrice, function (err, seq) {
                        if (err) {
                            return Utils.showFailureInfo(err.message);
                        }

                        DiancaiService.updateOrderZhuotaiTotalPrice(orderzhuotai, totalPrice, function (err, orderZhuotai) {
                            if (err) {
                                return Utils.showFailureInfo(err.message);
                            }

                        });
                    });


                }, orderZhuotaiId);

            }, orderZhuotaiId);
        }

        //账单信息
        WuXianService.getOrderInfo = function (dcj, ztcode, cb) {
            var orderinfo = {};
            ZhuotaiService.getZhuotaiByCode(ztcode, function (err, ztlist) {
                if (err != null)
                    return cb(err.message);
                var zt = ztlist[0];
                if (!zt)
                    return cb('桌台不存在');
                if (!zt.order.guid) {

                    orderinfo.ZTName = zt.name;
                    orderinfo.TotalMoney = 0;
                    orderinfo.PeopleNum = 0;
                    orderinfo.ZTStatus = '未开台';
                    orderinfo.DishNum = 0;
                    orderinfo.Dishs = [];
                    orderinfo.msg = '桌台尚未开台';
                    return cb(null,orderinfo);
                }
                orderinfo.ZTName = zt.name;
                orderinfo.TotalMoney = zt.order.totalPrice;
                orderinfo.PeopleNum = zt.order.renshu;
                orderinfo.ZTStatus = '已开台';
                DiancaiService.getOrderCaipinsByLuodan(zt.order.guid, '1', function (err, orderCaipins) {
                    if (err != null)
                        return cb(err.message);

                    orderinfo.DishNum = orderCaipins.length;
                    orderinfo.Dishs = [];
                    for (var i in orderCaipins) {
                        if (orderCaipins[i].num < 0)
                            continue;
                        //orderinfo.Dishs.push(orderCaipins[i]);
                        var ordercaipin = ordercaipinCal(orderCaipins[i]);
                        ordercaipin.isTCMX = false;
                        ordercaipin.ifLuoDan = true;
                        orderinfo.Dishs.push(ordercaipin);
                        if (orderCaipins[i].isScomb == 'true' && orderCaipins[i].scombCaipins.length>0)
                        {
                            for (var c in orderCaipins[i].scombCaipins)
                            {
                                var scombcp = ordercaipinCal(orderCaipins[i].scombCaipins[c]);
                                scombcp.isTCMX = true;
                                scombcp.ifLuoDan = true;
                                orderinfo.Dishs.push(scombcp);
                            }
                        }
                        
                    }
                    cb(null, orderinfo);
                },zt.orderZhuoTai.guid);

            });
        }


        function ordercaipinCal(caipin)
        {
            var ordercaipin = { name: caipin.name, num: caipin.num , unit: caipin.unitName };
            ordercaipin.chupin = caipin.chupin;
            ordercaipin.price = caipin.price;
            ordercaipin.price = caipin.price;
            ordercaipin.tuiNum = caipin.tuiNum;
            ordercaipin.zengNum = caipin.zengNum;
            ordercaipin.dianCaiYuanName = caipin.dianCaiYuanName;
            ordercaipin.dianCaiTime = caipin.dianCaiTime;
            ordercaipin.kryq = [];

            if (caipin.kouweis.length > 0) {
                for (var y in caipin.kouweis) {
                    ordercaipin.kryq.push(caipin.kouweis[y].name);
                }
            }
            if (caipin.zuofas.length > 0) {
                for (var y in caipin.zuofas) {
                    ordercaipin.kryq.push(caipin.zuofas[y].name);
                }
            }
            return ordercaipin;
        }


        //估清列表
        WuXianService.GuQingList = function (dcj, cb) {
            GuqingService.getGuQingCaipinsForWX(function (err, data) {
                if (err) {
                    return cb(err.message);
                }
                var gqs = [];
                var list = data.detail;
                for (var i in list) {
                    debugger;
                    gqs.push({ name: list[i].caipinName, GQNum: list[i].caipinNum, unit: list[i].unitName, code: list[i].code, desc: '' });
                }
                cb(null, gqs);
            })
        }

        WuXianService.hotelname = function () {
            return { hotelName: getSystemConfig('HotelName', '') };
        }

        //口味和做法 编码首位 0是做法，1是口味
        WuXianService.zfkw = function (cb) {
            DiancaiService.getZuofasBySearchKey('', 0, 10000, function (err, zflist) {
                if (err != null)
                    cb(err.message);
                var zfs = zflist;
                DiancaiService.getKouweis(0, 10000, function (kwerr, kwlist) {
                    if (kwerr != null)
                        cb(kwerr.message);
                    var rtlist = [];
                    for (var i in zfs) {
                        var zf = zfs[i];
                        rtlist.push({ guid: zf.guid, name: zf.name, code: '0' + zf.code, quickCode: zf.quickCode });
                    }
                    for (var j in kwlist) {
                        var kw = kwlist[j];
                        rtlist.push({ guid: kw.guid, name: kw.kwName, code: '1' + kw.kwCode, quickCode: kw.quickCode });
                    }
                    cb(null, rtlist);
                });
            });
        }


        WuXianService.caipinTypes = function (cb) {
            caipinTypeDao.all("isDeleted='false'  order by dishTypeCode ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allcaipins = function (cb) {
            caipinDao.all("isDeleted='false' AND enabled='true' AND (customize <> 'true' or customize is null) AND (isScomb='false' or isScomb is null)  order by code")// AND (isScomb='false' or isScomb is null)  order by code ")
            .then(function (results) {
                var rtarr = [];
                for (var i = 0; i < results.length; i++) {
                    var cp = Utils.clone(results[i]);
                    if (cp.needweigh == null)
                        cp.needweigh = 'false';
                    rtarr.push(cp);
                }
                return cb(null, rtarr);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allcaipinZuofa = function (cb) {
            caipinZuofaDao.all("isDeleted='false' ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allScombs = function (cb) {
            caipinDao.all("isDeleted='false' AND enabled='true'  AND isScomb='true'  order by code ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allScombCaipins = function (cb) {
            orderScombCaipinDao.all("isDeleted='false' order by scombId ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allScombBxCaipins = function (cb) {
            orderScombBxCaipinDao.all("isDeleted='false' order by scombId ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.alltuicaireasons = function (cb) {
            tuiCaiReasonDao.all("isDeleted='false'  order by code ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.allzhuotai = function (cb) {
            zhuotaiDao.all("isDeleted='false'  order by code ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        }

        WuXianService.synBancis = function (cb) {
            bancisDao.all(' status=1 ORDER BY jieBanTime desc LIMIT 0,10;')
             .then(function (results) {
                 var rtarr = [];
                 for (var i in results)
                 {
                     var banci = results[i];
                     var rtbc = {};
                     rtbc.banciNo = banci.banCiNo;
                     rtbc.banciId = banci.guid;
                     rtbc.kaiBanTime = banci.kaiBanTime;
                     rtbc.jieBanTime = banci.jieBanTime;
                     rtbc.jieBanTime = banci.jieBanTime;
                     rtbc.orderCount = banci.orderCount;
                     rtbc.orderIds = banci.orderIds;
                     rtbc.operatorId = banci.addOperatorId;
                     rtbc.operatorName = banci.addOperatorName;
                     rtarr.push(rtbc);
                 }
                 return cb(null, rtarr);
             }, function (error) {
                 return cb(error.message);
             });
        }

        WuXianService.synOrders = function (banciNo,cb) {

            var sql = "SELECT a.*,b.shiShou FROM pos_order a left join pos_billing b on a.jieSuanId=b.guid where a.jieSuanNo is not null ANd a.banciNo='" + banciNo + "'";
            bancisDao.query(sql).then(function (result) {
                var rtarr = [];
                var rows = result.detail;
                for(var i in rows)
                {
                    var row = rows[i];
                    var rt = {};
                    rt.orderNo = row.code;
                    rt.jieSuanTime = row.jieSuanTime;
                    rt.shiShou = row.shiShou;
                    rtarr.push(rt);
                }
                cb(null,rtarr);
            }, function (error) {
                cb(error.message);
            });
        }

        WuXianService.allcaipinUnits = function (cb) {
            ciapinUnitsDao.all(" isDeleted='false'").then(function (reault) {
                var rtarr = [];
                for(var i in reault)
                {
                    var unit = reault[i];
                    var rt = {};
                    rt.caipinId = unit.caipinId;
                    rt.name = unit.unitName;
                    rt.price = unit.price;
                    rtarr.push(rt);
                }
                cb(null,rtarr);
            }, function (error) {
                cb(error.message);
            });
        }

        WuXianService.allArea = function (cb) {
            areaDao.all("isDeleted='false'  order by areaCode ")
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error.message);
            });
        };

        return WuXianService;

    }]);