app.factory("ZhangdanQueryService", ["$q", "database", "AjaxLogger", function ($q, database,AjaxLogger) {
    var ZhangdanQueryService = {};

    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');

    var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');

    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');

    var billdetailDao = new DatabaseFuncDelegate($q, database, 'pos_billing_detail');

    var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');

    ZhangdanQueryService.getZhangdanByParam = function (param, cb) {
        if (!param.bcNo && Utils.isEmpty(param.createTime))
            return cb({ message: "查询参数错误,查询失败!" });
        /*包含付款方式*/
        var sql = "SELECT o.renshu,o.luoDanTime,o.operatorName,o.guid AS o_guid,o.code AS orderNo,o.zhuotaiName AS zhuotaiName, o.zhuotaiId zhuotaiId,o.kaitaitime as orderTime," +
            "o.isKaifapiao as isKaifapiao,cast ((b.shiShou + ifnull(b.hykZSMoney, 0)) as text) AS shishouMoney,o.jieSuanOperatorName AS operatorName,o.canBieName as canBieName,o.canBieCode as canBieCode,o.serverId as oServerId,o.merge as oMerge," +
            "ocp.guid AS ocp_guid, b.guid jieSuanId,ocp.name AS caipinName,ocp.price AS caipinPrice,ocp.hyPrice as hyPrice, ocp.num AS caipinNum,ocp.shiShouMoney AS caipinMoney," +
            "bd.guid AS bd_guid,bd.bizDesc AS bd_bizDesc,bd.type AS bd_type,bd.amount AS bd_amount,bd.bizAmount AS bd_bizAmount," +
            "k.guid kguid,k.name kname,k.orderCaipinId kOrderCpId,k.price kprice,k.jiajiaType kjiajiaType,oscp.name oscpName,o.jieSuanTime " +
        " FROM  pos_banci_order bco " +
        " INNER JOIN pos_order o ON bco.orderId = o.guid " + (Utils.isEmpty(param.zhangdanNo) ? "" : " and o.code like '%" + param.zhangdanNo + "%' ") +
        (Utils.isEmpty(param.zhuotaiName) ? "" : " and o.zhuotaiName like '%" + param.zhuotaiName + "%' ") +
        " INNER JOIN pos_billing b ON bco.orderId = b.orderId and b.isFanJieSuan=0 " +
        " LEFT JOIN pos_billing_detail bd ON b.jieSuanNo = bd.jieSuanNo " +
        " LEFT JOIN pos_order_caipin ocp ON o.guid = ocp.orderId " +
        " left join pos_order_scomb_caipin oscp on ocp.guid=oscp.orderCaipinId "+
        " LEFT JOIN pos_order_caipin_zuofa k on ocp.guid = k.orderCaipinId " +
        " WHERE  o.jieSuanNo is not null AND " + (Utils.isEmpty(param.bcNo) ? "" : "  bco.banciNo = '" + param.bcNo + "'  ") + (Utils.isEmpty(param.createTime) ? "" : " date(b.createTime)='" + param.createTime + "'");


        orderDao.query(sql).then(function (result) {
            var resultList = [];
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];
                    if (Utils.isEmpty(param.caipinName) || (!Utils.isEmpty(param.caipinName) && (param.caipinName == row.caipinName || param.caipinName == row.oscpName))) {


                        var orderInfo = Utils.arrayFind(resultList, row.o_guid, "guid");
                        if (orderInfo == null) {
                            orderInfo = new Order();
                            orderInfo.guid = row.o_guid;
                            orderInfo.orderNo = row.orderNo;
                            orderInfo.code = row.orderNo;
                            orderInfo.orderTime = new Date(row.orderTime);
                            orderInfo.zhuotaiName = row.zhuotaiName;
                            orderInfo.zhuotaiId = row.zhuotaiId;
                            orderInfo.shiShou = row.shishouMoney;
                            orderInfo.operator = row.operatorName;
                            orderInfo.isKaifapiao = row.isKaifapiao;
                            orderInfo.jieSuanId = row.jieSuanId;
                            orderInfo.renshu = row.renshu;
                            orderInfo.luoDanTime = row.luoDanTime;
                            orderInfo.serverName = row.operatorName;
                            orderInfo.canBieCode = row.canBieCode;
                            orderInfo.canbieName = row.canBieName;
                            orderInfo.jieSuanTime = row.jieSuanTime;
                            orderInfo.serverId = row.oServerId;
                            orderInfo.merge = row.oMerge;
                            resultList.push(orderInfo);
                        }

                        //处理付款方式
                        if (row.bd_guid != null) {
                            var billingDetail = Utils.arrayFind(orderInfo.billingDetail, row.bd_guid, "guid");
                            if (billingDetail == null) {
                                billingDetail = new BillingDetail();
                                billingDetail.guid = row.bd_guid;
                                billingDetail.bizAmount = row.bd_bizAmount;
                                billingDetail.bizDesc = row.bd_bizDesc;
                                billingDetail.type = row.bd_type;
                                billingDetail.amount = row.bd_amount;

                                orderInfo.addBillingDetail(billingDetail);
                            }
                        }
                        //处理关联菜品
                        if (row.ocp_guid != null) {
                            var orderCaipin = Utils.arrayFind(orderInfo.orderCaipins, row.ocp_guid, "guid");
                            if (orderCaipin == null) {
                                orderCaipin = new OrderCaipin();
                                orderCaipin.guid = row.ocp_guid;
                                orderCaipin.name = row.caipinName;
                                orderCaipin.price = row.caipinPrice;
                                orderCaipin.hyPrice = row.hyPrice;
                                orderCaipin.num = row.caipinNum;
                                orderCaipin.type = row.bd_type;

                                orderInfo.addCaiPin(orderCaipin);
                            }
                        }

                        if (row.kguid != null) {
                            var orderCaipin = Utils.arrayFind(orderInfo.orderCaipins, row.ocp_guid, "guid");
                            if (orderCaipin != null) {
                                var ocz = Utils.arrayFind(orderCaipin.zuofas, row.orderCaipin, "guid");
                                if (ocz == null) {
                                    ocz = new OrderCaipinZuofa();
                                    ocz.guid = row.kguid;
                                    ocz.price = row.kprice;
                                    ocz.name = row.kname;
                                    ocz.orderCaipinId = row.kOrderCpId;
                                    ocz.jiajiaType = row.kjiajiaType
                                    ocz.parentCaiPin = orderCaipin;

                                    orderCaipin.zuofas.push(ocz);
                                }
                            }
                        }
                    }
                }
            }
            return cb(null, resultList);
        }, function (err) {
            console.log(err);
            return cb(err);
        });
    };

    //获取到账单所有菜品
    ZhangdanQueryService.getZhangdanCaipinByOrderId = function (OrderId, cb) {       
        var sql = "select o.guid as o_guid, o.orderId as o_orderId, o.caipinId as o_caipinId, o.name as o_name, o.price as o_price, o.num as o_num," +
          "o.tuiNum as o_tuiNum, o.zengNum as o_zengNum, o.unitName as o_unitName, o.printId as o_printId, o.printName as o_printName, o.chupin as o_chupin," +
          "o.hyPrice as o_hyPrice,o.luodan as o_luodan, o.caiwuTypeName as o_caiwuTypeName, o.caiwuTypeId as o_caiwuTypeId,o.minAgio as o_minAgio, o.danPinBiLiZheKou as o_danPinBiLiZheKou, o.danPinJineZheKou as o_danPinJineZheKou," +
          "o.danPinZheKou as o_danPinZheKou,o.dianCaiYuan as o_dianCaiYuan,o.dianCaiYuanName as o_dianCaiYuanName, o.operator as o_operator," +
          "o.dianCaiTime as o_dianCaiTime,o.luoDanTime as o_luoDanTime,o.chuPinTime as o_chuPinTime, o.modTime as o_modTime,o.isScomb as o_isScomb," +
          "o.parentId as o_parentId," +
          "k.guid as k_guid, k.kwId as k_kwId, k.name as k_name, k.operator as k_operator, k.modTime as k_modTime," +
          "z.guid as z_guid, z.zuofaId as z_zuofaId, z.name as z_name, z.typeId as z_typeId, z.price as z_price, z.jiajiaType as z_jiajiaType," +
          "z.operator as z_operator, z.modTime as z_modTime,o.needweigh as needweigh, " +
          "osc.guid AS osc_guid,osc.caipinId AS osc_caipinId,	osc.name AS osc_name,	osc.price AS osc_price,	osc.num AS osc_num," +
          "osc.tuiNum AS osc_tuiNum,osc.zengNum AS osc_zengNum,	osc.unitName AS osc_unitName,osc.printId AS osc_printId," +
          "osc.printName AS osc_printName,osc.chupin AS osc_chupin,osc.luodan AS osc_luodan,	osc.minAgio AS osc_minAgio," +
          "osc.danPinBiLiZheKou AS osc_danPinBiLiZheKou,	osc.danPinJineZheKou AS osc_danPinJineZheKou," +
          "osc.danPinZheKou AS osc_danPinZheKou,	osc.dianCaiYuan AS osc_dianCaiYuan,	osc.dianCaiYuanName AS osc_dianCaiYuanName," +
          "osc.operator AS osc_operator,osc.dianCaiTime AS osc_dianCaiTime,	osc.luoDanTime AS osc_luoDanTime," +
          "osc.chuPinTime AS osc_chuPinTime,	osc.modTime AS osc_modTime,osc.parentId as osc_parentId,osck.guid AS osck_guid,	" +
          "osck.kwId AS osck_kwId,osck.name AS osck_name,osck.operator AS osck_operator,osck.modTime AS osck_modTime,oscz.guid AS oscz_guid," +
          "osck.isScomb as osck_isScomb,osck.orderScombCaipinId as osck_orderScombCaipinId," +
          "oscz.zuofaId AS oscz_zuofaId,oscz.name AS oscz_name,oscz.typeId AS oscz_typeId,oscz.price AS oscz_price," +
          "oscz.jiajiaType AS oscz_jiajiaType,oscz.operator AS oscz_operator,	oscz.modTime AS oscz_modTime," +
          "oscz.isScomb as oscz_isScomb,oscz.orderScombCaipinId as oscz_orderScombCaipinId," +
          "osc.needweigh AS osc_needweigh,osc.scombMainCaipinId as osc_scombMainCaipinId " +
          " from pos_order_caipin o" +
          " left join pos_order_caipin_kouwei k on k.orderCaipinId = o.guid and (k.isScomb='false' or k.isScomb is null )" +
          " left join pos_order_caipin_zuofa z on z.orderCaipinId = o.guid and (z.isScomb='false' or z.isScomb is null )" +
          " left join pos_order_scomb_caipin osc on  osc.orderCaipinId=o.guid " +
          " LEFT JOIN pos_order_caipin_kouwei osck ON osck.orderScombCaipinId = osc.guid and osck.orderCaipinId=o.guid " +
          " LEFT JOIN pos_order_caipin_zuofa oscz ON oscz.orderScombCaipinId = osc.guid and oscz.orderCaipinId=o.guid " +
          " where o.orderId='" + OrderId + "' order by o.modTime";
        orderCaipinDao.query(sql).then(function (results) {
            var resultList = [];
            //退菜的菜品
            var tuiCaiMap = {};
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                var orderCaipin = Utils.arrayFind(resultList, row.o_guid, "guid");

                if (orderCaipin == null) {
                    orderCaipin = new OrderCaipin();
                    orderCaipin.guid = row.o_guid;
                    orderCaipin.orderId = row.o_orderId;
                    orderCaipin.caipinId = row.o_caipinId;
                    orderCaipin.name = row.o_name;
                    orderCaipin.price = row.o_price;
                    orderCaipin.num = row.o_num;
                    orderCaipin.tuiNum = row.o_tuiNum;
                    orderCaipin.zengNum = row.o_zengNum;
                    orderCaipin.unitName = row.o_unitName;
                    orderCaipin.printId = row.o_printId;
                    orderCaipin.printName = row.o_printName;
                    orderCaipin.chupin = row.o_chupin;
                    orderCaipin.minAgio = row.o_minAgio;
                    orderCaipin.danPinBiLiZheKou = row.o_danPinBiLiZheKou;
                    orderCaipin.danPinJineZheKou = row.o_danPinJineZheKou;
                    orderCaipin.danPinZheKou = row.o_danPinZheKou;
                    orderCaipin.luodan = row.o_luodan;
                    orderCaipin.dianCaiYuan = row.o_dianCaiYuan;
                    orderCaipin.dianCaiYuanName = row.o_dianCaiYuanName;
                    orderCaipin.dianCaiTime = row.o_dianCaiTime;
                    orderCaipin.luoDanTime = row.o_luoDanTime;
                    orderCaipin.chuPinTime = row.o_chuPinTime;
                    orderCaipin.operator = row.o_operator;
                    orderCaipin.modTime = row.o_modTime;
                    orderCaipin.parentId = row.o_parentId;
                    orderCaipin.needweigh = row.needweigh;
                    orderCaipin.isScomb = row.o_isScomb;
                    orderCaipin.hyPrice = row.o_hyPrice;
                    orderCaipin.caiwuTypeName = row.o_caiwuTypeName;
                    orderCaipin.caiwuTypeId = row.o_caiwuTypeId;

                    if (!orderCaipin.isTui())
                        resultList.push(orderCaipin);
                    else {
                        var ocp = tuiCaiMap[orderCaipin.parentId];
                        if (_.isNil(ocp))
                            tuiCaiMap[orderCaipin.parentId] = [orderCaipin]
                        else {
                            Utils.arrayFind(ocp, orderCaipin.guid, "guid") == null ? ocp.push(orderCaipin) : null;
                        }


                    }

                }
                if (row.k_guid != null) {
                    var orderCaipinKouwei = Utils.arrayFind(orderCaipin.kouweis, row.k_guid, "guid");
                    if (orderCaipinKouwei == null) {
                        orderCaipinKouwei = new OrderCaipinKouwei();
                        orderCaipinKouwei.guid = row.k_guid;
                        orderCaipinKouwei.orderCaipinId = row.o_guid;
                        orderCaipinKouwei.kwId = row.k_kwId;
                        orderCaipinKouwei.name = row.k_name;
                        orderCaipinKouwei.operator = row.k_operator;
                        orderCaipinKouwei.modTime = row.k_modTime;
                        orderCaipin.kouweis.push(orderCaipinKouwei);
                    }
                }
                if (row.z_guid != null) {
                    var orderCaipinZuofa = Utils.arrayFind(orderCaipin.zuofas, row.z_guid, "guid");
                    if (orderCaipinZuofa == null) {
                        orderCaipinZuofa = new OrderCaipinZuofa();
                        orderCaipinZuofa.guid = row.z_guid;
                        orderCaipinZuofa.orderCaipinId = row.o_guid;
                        orderCaipinZuofa.zuofaId = row.z_zuofaId;
                        orderCaipinZuofa.name = row.z_name;
                        orderCaipinZuofa.typeId = row.z_typeId;
                        orderCaipinZuofa.price = row.z_price;
                        orderCaipinZuofa.jiajiaType = row.z_jiajiaType;
                        orderCaipinZuofa.operator = row.z_operator;
                        orderCaipinZuofa.modTime = row.z_modTime;
                        orderCaipinZuofa.parentCaiPin = orderCaipin;
                        orderCaipin.zuofas.push(orderCaipinZuofa);
                    }
                }


                if (row.osc_guid != null) {
                    var orderScombCaipin = Utils.arrayFind(orderCaipin.scombCaipins, row.osc_guid, "guid");
                    if (null == orderScombCaipin) {
                        orderScombCaipin = new OrderCaipin();
                        orderScombCaipin.guid = row.osc_guid;
                        orderScombCaipin.orderCaipinId = row.o_guid;
                        orderScombCaipin.orderId = row.o_orderId;
                        orderScombCaipin.caipinId = row.osc_caipinId;
                        orderScombCaipin.name = row.osc_name;
                        orderScombCaipin.price = row.osc_price;
                        orderScombCaipin.num = row.osc_num;
                        orderScombCaipin.tuiNum = row.osc_tuiNum;
                        orderScombCaipin.zengNum = row.osc_zengNum;
                        orderScombCaipin.unitName = row.osc_unitName;
                        orderScombCaipin.printId = row.osc_printId;
                        orderScombCaipin.printName = row.osc_printName;
                        orderScombCaipin.chupin = row.osc_chupin;
                        orderScombCaipin.minAgio = row.osc_minAgio;
                        orderScombCaipin.danPinBiLiZheKou = row.osc_danPinBiLiZheKou;
                        orderScombCaipin.danPinJineZheKou = row.osc_danPinJineZheKou;
                        orderScombCaipin.danPinZheKou = row.osc_danPinZheKou;
                        orderScombCaipin.luodan = row.osc_luodan;
                        orderScombCaipin.dianCaiYuan = row.osc_dianCaiYuan;
                        orderScombCaipin.dianCaiYuanName = row.osc_dianCaiYuanName;
                        orderScombCaipin.dianCaiTime = row.osc_dianCaiTime;
                        orderScombCaipin.luoDanTime = row.osc_luoDanTime;
                        orderScombCaipin.chuPinTime = row.osc_chuPinTime;
                        orderScombCaipin.operator = row.osc_operator;
                        orderScombCaipin.modTime = row.osc_modTime;
                        orderScombCaipin.parentId = row.osc_parentId;
                        orderScombCaipin.needweigh = row.osc_needweigh;
                        orderScombCaipin.isScomb = row.o_isScomb;
                        orderScombCaipin.scombId = row.o_caipinId;
                        orderScombCaipin.scombMainCaipinId = row.osc_scombMainCaipinId;

                        orderCaipin.scombCaipins.push(orderScombCaipin);
                    }
                    if (row.osck_guid != null) {
                        var orderCaipinKouwei = Utils.arrayFind(orderScombCaipin.kouweis, row.osck_guid, "guid");
                        if (orderCaipinKouwei == null) {
                            orderCaipinKouwei = new OrderCaipinKouwei();
                            orderCaipinKouwei.guid = row.osck_guid;
                            orderCaipinKouwei.orderCaipinId = row.o_guid;
                            orderCaipinKouwei.kwId = row.osck_kwId;
                            orderCaipinKouwei.name = row.osck_name;
                            orderCaipinKouwei.operator = row.osck_operator;
                            orderCaipinKouwei.modTime = row.osck_modTime;
                            orderCaipinKouwei.isScomb = row.osck_isScomb;
                            orderCaipinKouwei.orderScombCaipinId = row.osck_orderScombCaipinId;
                            orderScombCaipin.kouweis.push(orderCaipinKouwei);
                        }
                    }
                    if (row.oscz_guid != null) {
                        var orderCaipinZuofa = Utils.arrayFind(orderScombCaipin.zuofas, row.oscz_guid, "guid");
                        if (orderCaipinZuofa == null) {
                            orderCaipinZuofa = new OrderCaipinZuofa();
                            orderCaipinZuofa.guid = row.oscz_guid;
                            orderCaipinZuofa.orderCaipinId = row.o_guid;
                            orderCaipinZuofa.zuofaId = row.oscz_zuofaId;
                            orderCaipinZuofa.name = row.oscz_name;
                            orderCaipinZuofa.typeId = row.oscz_typeId;
                            orderCaipinZuofa.price = row.oscz_price;
                            orderCaipinZuofa.jiajiaType = row.oscz_jiajiaType;
                            orderCaipinZuofa.operator = row.oscz_operator;
                            orderCaipinZuofa.modTime = row.oscz_modTime;
                            orderCaipinZuofa.isScomb = row.oscz_isScomb;
                            orderCaipinZuofa.orderScombCaipinId = row.oscz_orderScombCaipinId;
                            orderScombCaipin.zuofas.push(orderCaipinZuofa);
                        }
                    }
                }
            }


            //把退菜的菜品和初始菜品关联
            console.log(tuiCaiMap);
            _.forEach(tuiCaiMap, function (value, key) {
                var c = Utils.arrayFind(resultList, key, "guid");
                c.addTuiCai(value);
            });

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });
    }

    //获取到账单支付详细
    ZhangdanQueryService.getZhangdanBilldetailByJiesuanNo = function (jieSuanId, cb) {
        billdetailDao.all("jieSuanId='" + jieSuanId + "'").then(function (result) {
            var pms = [];
           if(result && result.length > 0) {
               var memPM = null;
               var memZSPM = null;
               for(var i = 0; i < result.length; i++) {
                   var pm = result[i];
                   if(pm.type == "PAY" && pm.bizCode == "03") {
                       //会员卡
                       memPM = pm;
                   }else if(pm.type == "PAY" && pm.bizCode == BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE) {
                       //会员卡赠送消费
                       memZSPM = pm;
                   }else {
                       pms.push(pm);
                   }
               }
               if(memPM && memZSPM) {
                   memPM = _.cloneDeep(memPM);
                   memPM.amount = parseFloat(memPM.amount) + parseFloat(memZSPM.amount);
               }
               if(memPM) {
                   pms.push(memPM);
               }
           }
            return cb(null, pms);
        }, function (err) {
            return cb(err);
        });
    }

    //获取到账单总条目金额(不含单品折扣)
    ZhangdanQueryService.getZhangdanBillByJiesuanId = function (jieSuanId, cb) {
        var sql = "select (ifnull(shiShou,0)+ifnull(moLing,0)+ifnull(zheKouTotal,0)+ifnull(moneyDingE,0)+ifnull(hykZSMoney,0)-ifnull(moneyDanPin,0)) as zhangDanTotal from pos_billing where guid='" + jieSuanId + "'";
        billdetailDao.query(sql).then(function (result) {
            return cb(null, result);
        }, function (err) {
            return cb(err);
        })
    }



    ZhangdanQueryService.updateZhangDanByID = function (order, cb) {
        orderDao.query("update pos_order set isKaifapiao='" + order.isKaifapiao + "' where guid='" + order.guid + "'").then(function (result) {
            return cb(null, order);
        }, function (err) {
            return cb(err);
        });
    };

    ZhangdanQueryService.getAllZhangdanBybanciId = function (banciNo, cb) {
        if (!banciNo)
            return cb({ message: "班次号不能为空" });
        /*包含付款方式*/
        var sql = "SELECT o.* " +
        " FROM  pos_banci_order bco " +
        " INNER JOIN pos_order o ON bco.orderId = o.guid " +
        " WHERE  bco.banciNo = '" + banciNo + "' ";;

        orderDao.query(sql).then(function (result) {
            var resultList = [];
            if (result.detail.length > 0) {
                for (var i = 0; i < result.detail.length; i++) {
                    var row = result.detail[i];

                    var orderInfo = Utils.arrayFind(resultList, row.guid, "guid");
                    if (orderInfo == null) {
                        orderInfo = new Order();
                        orderInfo.guid = row.guid;
                        orderInfo.orderNo = row.code;                        

                        resultList.push(orderInfo);
                    }
                }
            }
            return cb(null, resultList);
        }, function (err) {
            console.log(err);
            return cb(err);
        });
    }

    ZhangdanQueryService.getAllZhuotai = function (banciNo,cb) {
        var sql = "select z.name as z_name, z.quickCode as z_quickCode " +                                 
                   " from pos_banci_order bco "+
                   " INNER JOIN pos_order o ON bco.orderId = o.guid  " +
                   " left join pos_zhuotai z  on o.zhuotaiId = z.guid " +
                   " where bco.banciNo = '" + banciNo + "' and  z.isDeleted='false' and z.enabled='true' group by z_name,z_quickCode  ";
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                var zhuotai = new Zhuotai();             
                zhuotai.name = row.z_name;
                zhuotai.quickCode = row.z_quickCode;               

                resultList.push(zhuotai);
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    }
    ZhangdanQueryService.getAllCaipin = function (cb) {
        var sql = "select c.*,case  when gq.caipinNum is NULL then -1 else gq.caipinNum	end as caipinNum from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing WHERE  startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid where isDeleted='false' and enabled='true' ";
        caipinDao.query(sql)
            .then(function (results) {
                console.log(results);
                var resultList = [];
                for (var i = 0; i < results.detail.length; i++) {
                    resultList.push(results.detail[i]);
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    }


    /**
     * 查看是否是空台
     */
    ZhangdanQueryService.isKongTai = function (guid, cb) {

        var sql = "select count(*) c from pos_zhuotai where guid ='" + guid + "' and orderId is null"
        caipinDao.query(sql)
            .then(function (results) {
                var count = results.detail[0].c
                if (count > 0)
                    cb(null, results);
                else
                    cb({ message: "该桌台正在使用，暂时不能反结算" }, null)
            }, function (error) {
                return cb(error);
            });
    }

    /**
     * 查看合并桌台是否是空台
     */
    ZhangdanQueryService.isKongTaiForMerge = function (guid, cb) {
        var guids = guid.split(",");
        var guidStr = [];
        for(var i in guids){
            guidStr.push("'"+guids[i]+"'");
        }
        var sql = "select * from pos_zhuotai where guid in (" + guidStr.toString() + ")";
        //console.log("sql======" + sql);
        caipinDao.query(sql)
            .then(function (results) {
                var rows = results.detail;
                var usingZT = [];
                for(var idx in rows){
                    if(!Utils.isEmpty(rows[idx].orderId)){
                        usingZT.push("【"+rows[idx].name+"】");
                    }
                }
                if(Utils.isEmpty(usingZT)){
                    cb(null);
                } else {
                    cb({ message: "桌台"+usingZT.toString()+"正在使用，暂时不能反结算" });
                }
            }, function (error) {
                return cb(error);
            });
    }


    /**
     * 确认反结算
     *
     * 反结算的时候目标桌台必须为空台.
     *
     * @param guid
     * @param cb
     */
    ZhangdanQueryService.confirmFanJieSuan = function (curOrder, reason, cb, waimia) {
        var sql = [];
        var pre = [];
        var newJieSuanId = Utils.guid();
        var rollbacksql = [];
        var auth_id = '', auth_name = '';
        if (curOrder.authMan) {
            auth_id = curOrder.authMan.id;
            auth_name = curOrder.authMan.name;
        }

        //反结算的信息
        var stringDebug = "@@ orderid__"+ curOrder.guid +
            " auth_id__"+  auth_id +
            " auth_name__" + auth_name+
            " jieSuanId__" + curOrder.jieSuanId+
            " newJieSuanId__" +  newJieSuanId+
            " reason__" +  reason;

        stringDebug =  stringDebug.replaceAll("'","").replaceAll("\"", "");

        //0. 更新桌台的状态 已开台状态，
        if(Utils.isEmpty(curOrder.merge)){//非合并桌台
            pre.push({ query: " update pos_zhuotai set orderId=?  where guid=? and orderId is null ", params: [curOrder.guid, curOrder.zhuotaiId] });
            rollbacksql.push({ query: " update pos_zhuotai set orderId=null  where guid=?  ", params: [curOrder.zhuotaiId] });
        } else {//合并桌台
            var ztIds = curOrder.zhuotaiId.split(",");
            for(var i in ztIds){
                pre.push({ query: " update pos_zhuotai set orderId=?  where guid=? and orderId is null ", params: [curOrder.guid, ztIds[i]] });
                rollbacksql.push({ query: " update pos_zhuotai set orderId=null  where guid=?  ", params: [ztIds[i]] });
            }
        }

        //1. 账单置为   反结算状态，反结算次数+1，
        var operator = BIZCONSTANT.POSUSER.id;
        var operatorCode = BIZCONSTANT.POSUSER.code;
        var operatorName = BIZCONSTANT.POSUSER.name;
        sql.push({ query: " update pos_order " +
        "  set fanJieSuanNum = fanJieSuanNum + 1, " +
        "  isFanJieSuan = "+ BIZCONSTANT.FANJIESUAN_YES +", " +
        "  jieSuanId = ?, " +
        "  jieSuanNo = null, " +
        "  jieSuanTime = null,  " +
        "  debugInfo =  ifnull(debugInfo, '') || '" + stringDebug + "', " +
        "  operator=?, operatorName=?, operatorCode=? " +
        " where guid =?",
            params: [newJieSuanId , operator, operatorName, operatorCode, curOrder.guid ] });
        //2. 结算单置为 反结算状态，反结算原因
        sql.push({ query: " update pos_billing " +
        "set  fanJieSuanReason=?,fanJieSuanAuthManId='" + auth_id + "',fanJieSuanAuthManName='" + auth_name + "', " +
        "  debugInfo =  ifnull(debugInfo, '') || '" + stringDebug + "' , " +
        " syn = " + BIZCONSTANT.DATA_UPLOADED_NO +
        ", isFanJieSuan = "+ BIZCONSTANT.FANJIESUAN_YES +" where guid=?", params: [reason,  curOrder.jieSuanId] });
        //3. 更新状态为已预结
        sql.push({query: "update pos_order set status = "+ BIZCONSTANT.ORDER_STATUS_YI_YuJie +" where guid = '"+ curOrder.guid +"'"})

        var allowed = true;
        var memberCardNo = null;
        var tradeNumber = null;//结帐的时候所生成的凭据号


        //1. 准备数据
        caipinDao.query(" select B.*, A.cardNo, A.tradeNumber, A.cardMemName  " +
            " from  pos_billing A, pos_billing_detail B " +
            "where  A.guid = B.jieSuanId and jieSuanId='"+ curOrder.jieSuanId+"'")
            .then(function(rs) {
                tradeNumber = rs.detail[0].tradeNumber;
                memberCardNo = rs.detail[0].cardNo;
                var memberName = rs.detail[0].cardMemName;
                populate(sql,rs,newJieSuanId);
                sql.push({
                    query: "insert into pos_billing ( " +
                    "guid, orderId,cardMemName, cardNo) " +
                    "values (?, ?, ?, ?)",
                    params: [newJieSuanId, curOrder.guid,memberName, memberCardNo]
                });


                (function(){
                    if(!waimia){
                        caipinDao.queryTransaction(pre)
                            .then(function (results) {
                                if (results.rowsAffected[0] <= 0) {
                                    return cb({message: "该桌台正在使用，暂时不能反结算"});
                                    //allowed = false;
                                }
                                doFanJieSuan(curOrder, memberCardNo, tradeNumber, sql, cb, rollbacksql);
                            }, function (err) {
                                //allowed = false;
                                cb({message: "系统内部错误，暂时不能反结算"});
                            })
                    } else {
                        doFanJieSuan(curOrder, memberCardNo, tradeNumber, sql, cb, rollbacksql);
                    }


                })();

            }, function (err) {
                cb({message: "系统内部错误"});
            })



    }

    /**
     *
     * @param memberCardNo 卡号
     * @param tradeNumber  凭据号
     * @param sql
     * @param cb
     */
    var doFanJieSuan = function (curOrder, memberCardNo, tradeNumber, sql, cb, rollbacksql) {

        //保护性代码
        if(Utils.isEmpty(curOrder.jieSuanId) || Utils.isEmpty(curOrder.guid) ){
            cb({ message: "反结算失败，数据不完整.请重试" }, null)
            return;
        }



        if(memberCardNo != null && memberCardNo != undefined && memberCardNo != "undefined"){
            //会员API4：撤销 结账的时候所产生的凭据 tradeNumber

            //TODO,准备json数据，并发送出去， 回调中调用realWorker
            //alert("会员反结算，调用API...")
            var param = {
               cardCode:memberCardNo,
               terminalNumber:BIZCONSTANT.POSUSER.device,
               orderNo:curOrder.guid,
               pjhList:[tradeNumber] //凭据号列表
            }
            var requestBody = JsonHelper.json4UndoPingJu(param)
            crmsdk.AjaxLogger = AjaxLogger;
            crmsdk.post(MEMBERURL.JIE_SUAN_UNDO, requestBody, function (response) {
                if(response.status == "failed"){
                    cb({ message:"会员反结算失败"}, null);
                    if (rollbacksql)
                        fanjiesuanRollBack(rollbacksql);
                    return;
                }
                realWorker(sql,cb);

            }, function (error, data, errorThrown) {
                if (rollbacksql)
                    fanjiesuanRollBack(rollbacksql);
                cb({ message:"会员交易失败，网络错误"}, null)
            });

        }else{
            realWorker(sql,cb);
        }

    }

    var fanjiesuanRollBack = function (sql,cb) {
        caipinDao.queryTransaction(sql).then(function (rs) {
            if(cb)
                cb(null, null);
        }, function (err) {
            console.log(err);
            if (cb)
                cb({ message: "系统内部错误" });
        });
    }

    var realWorker = function (sql, cb, rollbacksql) {
        caipinDao.queryTransaction(sql).then(function(rs) {
            cb(null, null);
        }, function (err) {
            console.log(err);
            if (rollbacksql)
                fanjiesuanRollBack(rollbacksql);
            cb({message: "系统内部错误"});
        });
    }

    var populate = function(sql,rs,newJieSuanId){
        var pmRes = [];
        //会员卡支付方式
        var memPM = null;
        //会员卡赠送消费
        var memZSPM = null;
        for(var i = 0; i < rs.detail.length; i ++) {
            var e = _.cloneDeep(rs.detail[i]);
            if(e.type == "PAY" && e.bizCode == BIZCONSTANT.PM_HUI_YUAN) {
                memPM = e;
            }else if(e.type == "PAY" && e.bizCode == BIZCONSTANT.PM_HUI_YUANCARD_ZS_XF_CODE) {
                memZSPM = e;
            }else {
                pmRes.push(e);
            }
        }
        if(memPM && memZSPM) {
            memPM.amount = Utils.m(parseFloat(memPM.amount) + parseFloat(memZSPM.amount));
            memPM.hykZSMoney = memZSPM.amount;
        }
        if(memPM){
            pmRes.push(memPM);
        }

        for(var i = 0; i < pmRes.length; i ++) {
            var e = pmRes[i];
            sql.push(
                { query:
                "insert into pos_billing_detail(" +
                "guid, jieSuanId, " +
                "bizId, bizCode, bizAmount, bizDesc,  type, amount, caiWuShuXing, isHyJf," +
                "seq, device," +
                "mdId,isDeleted,createTime,addOperatorId,addOperatorCode,addOperatorName, ext1, hykZSMoney, thirdCouponNum, thirdCouponPayMoney, thirdCouponFaceValueMoney ) values (" +
                "?, ?," +
                "?, ?, ?, ?, ?, ?, ?, ?, " +
                "?, ?," +
                "?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", params :
                    [Utils.guid(), newJieSuanId,
                        e.bizId, e.bizCode, e.bizAmount, e.bizDesc, e.type, e.amount, e.caiWuShuXing, e.isHyJf,
                        e.seq, e.device,
                        e.mdId, e.isDeleted, e.createTime, e.addOperatorId, e.addOperatorCode, e.addOperatorName, e.ext1, e.hykZSMoney, e.thirdCouponNum, e.thirdCouponPayMoney, e.thirdCouponFaceValueMoney]

        });
    }
}
    ZhangdanQueryService.orderBilling = function (order,cb)
    {
        var sql = "SELECT * FROM pos_billing where isFanJieSuan='0' AND guid='" + order.jieSuanId + "'";
        orderDao.query(sql).then(function (result) {
            var bill=null;
            if (result.detail.length > 0)
                bill = result.detail[0];
            cb(null, bill);
        }, function (err) {
            cb(err);
        });
    }

    ZhangdanQueryService.orderBillingDate = function (order,cb)
    {
        var sql = "SELECT * FROM pos_billing_detail where jieSuanId='" + order.jieSuanId + "'";
        orderDao.query(sql).then(function (result) {
            cb(null, result);
        }, function (err) {
            cb(err);
        });
    }

    //获取未结算桌台的订单号
    ZhangdanQueryService.getUnJieSuanZhuoTai_Order = function(callback) {
        var sql = "select orderId from pos_zhuotai where orderId is not null and enabled='true' and isDeleted='false'";
        zhuotaiDao.query(sql).then(function(res) {
                callback(res);
            }
            ,function(error) {
                callback(null);
            }
        );
    }


    //快餐-确认反结算
    ZhangdanQueryService.fastConfirmFanJieSuan = function (curOrder, reason, cb) {
        var sql = [];
        var pre = [];
        var newJieSuanId = Utils.guid();

        //1. 账单置为   反结算状态，反结算次数+1，
        sql.push({ query: " update pos_order set fanJieSuanNum = fanJieSuanNum + 1, isFanJieSuan = "+ BIZCONSTANT.FANJIESUAN_YES +", " +
        "  jieSuanId = ?, jieSuanNo = null, jieSuanTime = null  " +
        " where guid =?",
            params: [newJieSuanId, curOrder.guid] });
        //2. 结算单置为 反结算状态，反结算原因
        sql.push({ query: " update pos_billing " +
        "set  fanJieSuanReason=?, " +
        " syn = " + BIZCONSTANT.DATA_UPLOADED_NO +
        ", isFanJieSuan = "+ BIZCONSTANT.FANJIESUAN_YES +" where guid=?", params: [reason, curOrder.jieSuanId] });
        sql.push({query: "update pos_order set status = "+ BIZCONSTANT.ORDER_STATUS_YI_YuJie +" where guid = '"+ curOrder.guid +"'"})

        var allowed = true;
        var memberCardNo = null;
        var tradeNumber = null;//结帐的时候所生成的凭据号


        //1. 准备数据
        caipinDao.query(" select B.*, A.cardNo, A.tradeNumber, A.cardMemName  " +
            " from  pos_billing A, pos_billing_detail B " +
            "where  A.guid = B.jieSuanId and jieSuanId='"+ curOrder.jieSuanId+"'")
            .then(function(rs) {
                tradeNumber = rs.detail[0].tradeNumber;
                memberCardNo = rs.detail[0].cardNo;
                var memberName = rs.detail[0].cardMemName;
                populate(sql,rs,newJieSuanId);
                sql.push({
                    query: "insert into pos_billing ( " +
                    "guid, orderId,cardMemName, cardNo) " +
                    "values (?, ?, ?, ?)",
                    params: [newJieSuanId, curOrder.guid,memberName, memberCardNo]
                });


            }, function (err) {
                cb({message: "系统内部错误"});
            })
            //2. 查看桌台是否可以反结算
            .then(function(){
                doFanJieSuan(curOrder, memberCardNo, tradeNumber, sql, cb);

            })


    }




    return ZhangdanQueryService;
}])