app.factory('ZhuotaiService', ['$q', '$rootScope', 'database', 'UploadService','UniqueIDService',  function ($q, $rootScope, database, UploadService,UniqueIDService ) {
    var ZhuotaiService = {};

    var areaDao = new DatabaseFuncDelegate($q, database, 'pos_area');

    var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');

    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');

    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');

    var caipinzuofaDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zuofa');

    var caipinzuokouwei = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_kouwei');

    var scombDao = new DatabaseFuncDelegate($q, database, 'pos_order_scomb_caipin');

    ZhuotaiService.getAreas = function (cb) {
        areaDao.all("isDeleted='false'and enabled='true' order by areaCode")
            .then(function (rows) {
                if (rows.length < 1) {
                    return cb({ message: "找不到区域，请联系我司相关的工作人员" });
                }

                return cb(null, rows);
            }, function (error) {
                return cb(error);
            });
    };

    function zhuotaiDbToModel(row) {
        var zhuotai = new Zhuotai();
        zhuotai.guid = row.z_guid;
        zhuotai.consumptionId = row.z_consumptionId;
        zhuotai.code = row.z_code;
        zhuotai.name = row.z_name;
        zhuotai.areaId = row.z_areaId;
        zhuotai.quickCode = row.z_quickCode;
        zhuotai.canweishu = row.z_canweishu;
        zhuotai.orderId = row.z_orderId;

        zhuotai.areaCode = row.a_areaCode;
        zhuotai.areaName = row.a_areaName;
        zhuotai.disLDCount = row.disLD;
        if (row.z_orderId != null) {
            zhuotai.order.guid = row.z_orderId;
            zhuotai.order.zhuotaiId = row.o_zhuotaiId;
            zhuotai.order.zhuotaiName = row.o_zhuotaiName;
            zhuotai.order.zhuotaiCode = row.o_zhuotaiCode;
            zhuotai.order.status = row.o_status;
            zhuotai.order.renshu = row.o_renshu;
            zhuotai.order.totalPrice = row.o_totalPrice;
            zhuotai.order.temZkMoney = row.o_temZkMoney;
            zhuotai.order.code = row.o_code;
            zhuotai.order.serverId = row.o_serverId;
            zhuotai.order.serverName = row.o_serverName;
            zhuotai.order.serverGuid = row.o_serverGuid;
            zhuotai.order.operator = row.o_operator;
            zhuotai.order.operatorCode = row.o_operatorCode;
            zhuotai.order.operatorName = row.o_operatorName;
            zhuotai.order.comments = row.o_comments;
            zhuotai.order.kaiTaiTime = row.o_kaiTaiTime;
            zhuotai.order.luoDanTime = row.o_luoDanTime;
            zhuotai.order.modTime = row.o_modTime;
            zhuotai.order.isFanJieSuan=row.o_isFanJieSuan;
            zhuotai.order.canbieId = row.o_canbieId;
            zhuotai.order.canBieCode = row.o_canbieCode;
            zhuotai.order.canbieName = row.o_canbieName;
            zhuotai.order.jieSuanNo = row.o_jieSuanNo;
            zhuotai.order.jieSuanId = row.o_jieSuanId;
            zhuotai.order.jieSuanOperatorId = row.o_jieSuanOperatorId;
            zhuotai.order.ordersource = row.o_ordersource;
            if(!zhuotai.order.ordersource) zhuotai.order.ordersource = "";
            zhuotai.order.mom = row.o_mom;
            if(row.o_merge) {
                zhuotai.order.merge = row.o_merge;
            }
            //zhuotai.order.modTime = row.o_modTime;
            //zhuotai.order.modTime = row.o_modTime;
        }
        if(row.poz_guid) {
            var order_zhuotai = new OrderZhuotai();
            order_zhuotai.guid = row.poz_guid;
            order_zhuotai.orderId = row.poz_orderId;
            order_zhuotai.zhuotaiId = row.poz_zhuotaiId;
            order_zhuotai.zhuotaiCode = row.poz_zhuotaiCode;
            order_zhuotai.zhuotaiName = row.poz_zhuotaiName;
            order_zhuotai.areaId = row.poz_areaId;
            order_zhuotai.areaCode = row.poz_areaCode;
            order_zhuotai.areaName = row.poz_areaName;
            order_zhuotai.renshu = row.poz_renshu;
            order_zhuotai.hisOrderId = row.poz_hisOrderId;
            order_zhuotai.hisOrderCode = row.poz_hisOrderCode;
            order_zhuotai.totalPrice = row.poz_totalPrice;
            order_zhuotai.luoDanTime = row.poz_luoDanTime;
            zhuotai.orderZhuoTai = order_zhuotai;
        }

        return zhuotai;
    }

    ZhuotaiService.getZhuotaisCount = function (cb) {
        var sql = "select count(guid),df c from pos_zhuotai where isDeleted='false' and enabled='true'";
        zhuotaiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if (count < 1) {
                return cb({ message: "找不到桌台，请联系我司相关的工作人员" });
            }

            return cb(null, count);
        }, function (error) {
            return cb(error);
        });

    };

    ZhuotaiService.getZhuotais = function (first, rows, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName," +
            " o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.isFanJieSuan as o_isFanJieSuan,o.merge as o_merge," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            " a.areaCode as a_areaCode,a.areaName as a_areaName," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId," +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId " +
            " left join pos_area a on a.guid= z.areaId " +
            " left join pos_order_zhuotai poz on z.orderId=poz.orderId and poz.zhuotai=z.guid"+
            " where z.isDeleted='false' and z.enabled='true' order by z.code limit " + first + "," + rows;
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };


    ZhuotaiService.getZhuotaiByCode = function (code, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime,o.isFanJieSuan as o_isFanJieSuan," +
            " o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.merge as o_merge," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "a.areaCode as a_areaCode,a.areaName as a_areaName," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " LEFT JOIN pos_area a on z.areaId=a.guid " +
            " left join pos_order o on o.guid = z.orderId" +
            " left join pos_order_zhuotai poz on o.guid=poz.orderId and poz.zhuotaiCode='" + code + "'" +
            " where z.isDeleted='false' and z.enabled='true' AND z.code='" + code + "'" ;
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };

    //通过zhuotaicode获取桌台
    ZhuotaiService.getZhuoTaiObjByCode = function (code, callback) {
        var sql = "select pz.*, pa.areaCode as areaCode, pa.areaName as areaName from pos_zhuotai pz, pos_area pa where pz.code = '" + code + "' and pz.areaId=pa.guid ";
        zhuotaiDao.query(sql).then(function (result) {
            if(result.detail.length > 0 ) {
                var zhuotaiObj = result.detail[0];
                return callback(null, zhuotaiObj);
            }else {
                return callback(null, null);
            }
        }, function (error) {
            return callback(error);
        });
    }


    ZhuotaiService.getZhuotaisCountByArea = function (areaId, cb) {
        var sql = "select count(guid) c from pos_zhuotai" +
            " where isDeleted='false' and enabled='true' and areaId='" + areaId + "'";
        zhuotaiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });

    };

    ZhuotaiService.getZhuotaisByArea = function (areaId, first, rows, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            " z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            " o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime," +
            " o.luoDanTime as o_luoDanTime,o.isFanJieSuan as o_isFanJieSuan ,o.merge as o_merge," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            " a.areaCode as a_areaCode,a.areaName as a_areaName," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " left join pos_order o on o.guid = z.orderId " +
            " left join pos_area a on a.guid= z.areaId" +
            " left join pos_order_zhuotai poz on z.orderId=poz.orderId and poz.zhuotai=z.guid"+
            " where z.isDeleted='false' and z.enabled='true' and z.areaId='" + areaId + "' order by z.code limit " + first + "," + rows;
        zhuotaiDao.query(sql).then(function (results) {

            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };
    /* JP  2016-04-19
    * 统一处理桌台的查询
    * parsms  为参数对象
    */
    ZhuotaiService.getZhuotaisByParams = function (parsms, first, rows, cb, keyword) {
        var sql = "select z.guid as z_guid,z.consumptionId as z_consumptionId,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status,o.jieSuanOperatorId o_jieSuanOperatorId, o.operator as o_operator,o.operatorCode as o_operatorCode,o.operatorName as o_operatorName, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            "o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName, o.serverGuid as o_serverGuid, o.mom as o_mom, o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime, o.isFanJieSuan as o_isFanJieSuan," +
            "o.canBieId as o_canbieId,o.canBieCode as o_canbieCode,o.canBieName as o_canbieName,o.jieSuanNo as o_jieSuanNo,o.merge as o_merge," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId,o.ordersource as o_ordersource, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "a.guid as a_guid,a.areaCode as a_areaCode,a.areaName as a_areaName ,ifnull(dc.disLDCount,0) disLD , " +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId left join pos_area a on a.guid= z.areaId " +
            " left join pos_order_zhuotai poz on z.orderId=poz.orderId and z.guid=poz.zhuotaiId " +
            " left join (select orderZhuoTaiId,count(*) disLDCount from pos_order_caipin where luodan=0 GROUP BY orderZhuoTaiId) dc on poz.guid=dc.orderZhuoTaiId " +
            " where z.isDeleted='false' and z.enabled='true' ";

        if (parsms.status != null && parsms.status == BIZCONSTANT.ORDER_STATUS_YI_YuJie) {
            sql = sql + " and z.orderId is not null and o.status=3 ";
        } else if (parsms.status != null && !parsms.status) {
            sql = sql + " and z.orderId is  null ";
        } else if (parsms.status != null && parsms.status) {
            sql = sql + " and z.orderId is not null and o.status = 1 OR o.status = 2  "
        }

        if (parsms.areaId != null) {
            sql = sql + " and z.areaId='" + parsms.areaId + "' ";
        }

        //速查码查桌台
        if(keyword){
            sql = sql + "and z.code LIKE '%"+keyword.code+"%' or z.quickCode LIKE '%" +keyword.code+"%' ";
        }

        sql = sql + " order by CAST(z.code as int) asc limit " + first + "," + rows;
        //console.info("zhuotai query sql : " + sql);
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };


    /* JP  2016-04-19
     * 统一处理桌台的数量
     * parsms  为参数对象
     */
    ZhuotaiService.getZhuotaiCountByParams = function (parsms, cb) {
        var sql = "select count(z.guid) c from pos_zhuotai z left join pos_order o on o.guid = z.orderId" +
            " where z.isDeleted='false' and z.enabled='true' ";

        if (parsms.status != null && parsms.status == BIZCONSTANT.ORDER_STATUS_YI_YuJie) {
            sql = sql + " and z.orderId is not null and o.status=3 ";
        } else if (parsms.status != null && !parsms.status) {
            sql = sql + " and z.orderId is  null ";
        } else if (parsms.status != null && parsms.status) {
            sql = sql + " and z.orderId is not null "
        }

        if (parsms.areaId != null) {
            sql = sql + " and z.areaId='" + parsms.areaId + "' ";
        }

        zhuotaiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });

    };

    /**
    * 获取已开台，未开台数量
    * kaitai = true 已开台
    * kaitai=false 未开台
    * */
    ZhuotaiService.getZhuotaiCountByStatus = function (kaitai, cb) {
        var sql = "select count(guid) c from pos_zhuotai" +
            " where isDeleted='false' and enabled='true' and orderId is not null";
        if (!kaitai) {
            sql = "select count(guid) c from pos_zhuotai" +
                " where isDeleted='false' and enabled='true' and orderId is null";
        }
        if (kaitai == BIZCONSTANT.ORDER_STATUS_YI_YuJie)
            sql = 'select Count(a.guid) as c from  pos_zhuotai a left join pos_order b on a.orderId=b.guid where status=3';
        zhuotaiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });

    };

    /**
    * 获取桌台各状态数量
    * */
    ZhuotaiService.getZhuotaiStatusCount = function (parsms, cb) {
        var wh = " where a.isDeleted='false'and a.enabled='true' ";
        if (parsms && parsms.areaId && parsms.areaId != '') {
            wh += " AND a.areaId='" + parsms.areaId + "' ";
        }
        var sql = "select status,count(status) c FROM(select a.*,IFNULL(b.status,0) status from  pos_zhuotai a left join pos_order b on a.orderId=b.guid " + wh + ") tb GROUP BY status";

        zhuotaiDao.query(sql).then(function (result) {
            var ztcounts = { all: 0, ykt: 0, wkt: 0, yyj: 0 };

            for (var i in result.detail) {
                var c = result.detail[i];
                if (c.status == 0)
                    ztcounts.wkt = c.c;
                else
                {
                    if (c.status == 3)
                        ztcounts.yyj = c.c;
                    ztcounts.ykt += c.c;
                }
            }
            ztcounts.all = ztcounts.wkt + ztcounts.ykt;

            return cb(null, ztcounts);
        }, function (error) {
            return cb(error);
        });

    };

    /**
      * 获取已开台，未开台
      * kaitai = true 已开台
      * kaitai=false 未开台
      * */
    ZhuotaiService.getZhuotaisByStatus = function (kaitai, first, rows, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            "o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName," +
            " o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime,o.isFanJieSuan as o_isFanJieSuan," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            " a.areaCode as a_areaCode,a.areaName as a_areaName, o.merge as o_merge " +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId " +
            " left join pos_area a on a.guid= z.areaId " +
            " left join pos_order_zhuotai poz on o.guid=poz.orderId and z.guid=poz.zhuotaiId " +
            " where z.isDeleted='false' and z.enabled='true' ";
        if (kaitai != null) {
            if (kaitai) {
                sql = sql + " and orderId is not null "
            }
            else if (!kaitai) {
                sql = sql + " and orderId is  null "

            }
            if (kaitai == BIZCONSTANT.ORDER_STATUS_YI_YuJie)
                sql = sql + " and orderId is not null and o.status=3 ";
        }


        sql = sql + " order by z.code limit " + first + "," + rows;

        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };

    ZhuotaiService.updateZhuotaiStatus = function (zhuotai, cb) {
        var queries = [];
        queries.push({ query: "update pos_zhuotai set status='" + zhuotai.status + "' where guid='" + zhuotai.guid + "'" });
        zhuotaiDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    }

    //ZhuotaiService.doKaitai = function (zhuotai, order, cb) {
    //    var first = [];
    //    var second = [];
    //    var preConditon = null;
    //    var orderId = order.guid == null ? orderDao.guid() : order.guid;
    //    var jieSuanId = Utils.guid()
    //    if(order.comments === undefined){
    //        order.comments = null;
    //    }
    //
    //    preConditon = { query: "update pos_zhuotai set orderId='" + orderId + "' where guid='" + zhuotai.guid + "' and orderId is null " };
    //    //check status first
    //    first.push(preConditon);
    //
    //
    //    //建立空的账单
    //    second.push({
    //        query: "insert into pos_order ( " +
    //        "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
    //        " serverId, serverName,serverGuid," +
    //        " operator, operatorName,operatorCode, mdId, mdCode," +
    //        " kaiTaiTime, modTime, isDeleted," +
    //        " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
    //        " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource,tsAndwm) " +
    //        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?, ?,?, ?,?,?,?,?,?,?,?,?)",
    //        params: [orderId, zhuotai.guid, zhuotai.name, order.renshu, order.comments, order.totalPrice, 1,
    //            order.serverId, order.serverName,order.serverGuid,
    //            order.operator, order.operatorName, order.operatorCode, order.mdId, order.mdCode,false,
    //            BIZCONSTANT.FANJIESUAN_NO, 0, order.canBieCode, order.canbieName,order.canbieId,
    //            order.areaGuid, order.areaCode, order.areaName, order.zhuotaiCode, jieSuanId,ORDERSOURCE.DEFAULT,'TS']
    //    });
    //
    //    //建立空的结算单
    //    second.push({
    //        query: "insert into pos_billing ( " +
    //        "guid, orderId) " +
    //        "values (?, ?)",
    //        params: [jieSuanId, orderId]
    //    });
    //
    //    //建立账单与桌台关联表
    //    var order_zhuotai_guid = Utils.guid();
    //    second.push({
    //        query:"insert into pos_order_zhuotai ( " +
    //        "guid, orderId, zhuotaiId, zhuotaiCode, zhuotaiName, areaId, renshu, isDeleted, areaCode, areaName, hisOrderId )" +
    //        " values (?,?,?,?,?,?,?,?,?,?,?)",
    //        params:[order_zhuotai_guid, orderId, zhuotai.guid, zhuotai.code, zhuotai.name, zhuotai.areaId, order.renshu + "", 'false', order.areaCode, order.areaName, orderId]
    //    });
    //
    //    var allowed = true;
    //
    //    zhuotaiDao.queryTransaction(first).then(function (resultList) {
    //
    //        if (resultList.rowsAffected[0] <= 0) {
    //            cb('开台失败，' + zhuotai.name + '桌台已被占用');
    //            allowed = false;
    //        }
    //
    //    }, function (err) {
    //        cb('开台失败');
    //        allowed = false;
    //
    //    }).then(function () {
    //        if (allowed) {
    //            zhuotaiDao.queryTransaction(second).then(function (resultList) {
		//			UploadService.syncZhuotai({"zhuotai":zhuotai,"order":{"id":orderId,"status":1}});
    //                var order_zhuotaiObj = new OrderZhuotai();
    //                order_zhuotaiObj.guid = order_zhuotai_guid;
    //                order_zhuotaiObj.orderId = orderId;
    //                order_zhuotaiObj.zhuotaiId = zhuotai.guid;
    //                order_zhuotaiObj.zhuotaiCode = zhuotai.code;
    //                order_zhuotaiObj.zhuotaiName = zhuotai.name;
    //                order_zhuotaiObj.areaId = zhuotai.areaId;
    //                order_zhuotaiObj.areaCode = order.areaCode;
    //                order_zhuotaiObj.areaName = order.areaName;
    //                order_zhuotaiObj.renshu = order.renshu;
    //                order_zhuotaiObj.hisOrderId = orderId;
    //                zhuotai.orderZhuoTai = order_zhuotaiObj;
    //                cb(null, orderId);
    //            }, function (err) {
    //                cb(err);
    //
    //            })
    //        }
    //
    //    });
    //}

    ZhuotaiService.doKaitai = function (zhuotai, order, cb) {
        var second = [];
        var preConditon = null;
        var orderId = order.guid == null ? orderDao.guid() : order.guid;
        var jieSuanId = Utils.guid()
        if(order.comments === undefined){
            order.comments = null;
        }

        //建立空的账单
        second.push({
            query: "insert into pos_order ( " +
            "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
            " serverId, serverName,serverGuid," +
            " operator, operatorName,operatorCode, mdId, mdCode," +
            " kaiTaiTime, modTime, isDeleted," +
            " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
            " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource,tsAndwm) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?, ?,?, ?,?,?,?,?,?,?,?,?)",
            params: [orderId, zhuotai.guid, zhuotai.name, order.renshu, order.comments, order.totalPrice, 1,
                order.serverId, order.serverName,order.serverGuid,
                order.operator, order.operatorName, order.operatorCode, order.mdId, order.mdCode,false,
                BIZCONSTANT.FANJIESUAN_NO, 0, order.canBieCode, order.canbieName,order.canbieId,
                order.areaGuid, order.areaCode, order.areaName, order.zhuotaiCode, jieSuanId,ORDERSOURCE.DEFAULT,'TS']
        });

        //建立空的结算单
        second.push({
            query: "insert into pos_billing ( " +
            "guid, orderId) " +
            "values (?, ?)",
            params: [jieSuanId, orderId]
        });

        //建立账单与桌台关联表
        var order_zhuotai_guid = Utils.guid();
        second.push({
            query:"insert into pos_order_zhuotai ( " +
            "guid, orderId, zhuotaiId, zhuotaiCode, zhuotaiName, areaId, renshu, isDeleted, areaCode, areaName, hisOrderId )" +
            " values (?,?,?,?,?,?,?,?,?,?,?)",
            params:[order_zhuotai_guid, orderId, zhuotai.guid, zhuotai.code, zhuotai.name, zhuotai.areaId, order.renshu + "", 'false', order.areaCode, order.areaName, orderId]
        });

        second.push({query: "update pos_zhuotai set orderId='" + orderId + "' where guid='" + zhuotai.guid + "' and orderId is null"});

        second.push({query: "update pos_order_zhuotai set orderId='" + "999-"+orderId + "', zhuotaiId = '" + "999-"+zhuotai.guid +"', zhuotaiCode = '" + "999-"+zhuotai.code +"' where guid='" + order_zhuotai_guid + "'and changes() = 0" });

        zhuotaiDao.queryTransaction(second).then(function (resultList) {
                UploadService.syncZhuotai({"zhuotai":zhuotai,"order":{"id":orderId,"status":1}});
                var order_zhuotaiObj = new OrderZhuotai();
                order_zhuotaiObj.guid = order_zhuotai_guid;
                order_zhuotaiObj.orderId = orderId;
                order_zhuotaiObj.zhuotaiId = zhuotai.guid;
                order_zhuotaiObj.zhuotaiCode = zhuotai.code;
                order_zhuotaiObj.zhuotaiName = zhuotai.name;
                order_zhuotaiObj.areaId = zhuotai.areaId;
                order_zhuotaiObj.areaCode = order.areaCode;
                order_zhuotaiObj.areaName = order.areaName;
                order_zhuotaiObj.renshu = order.renshu;
                order_zhuotaiObj.hisOrderId = orderId;
                zhuotai.orderZhuoTai = order_zhuotaiObj;
            if(resultList.rowsAffected[4] !=0){
                cb('开台失败');
            }else{
                cb(null, orderId);
            }


        }, function (err) {
            cb('开台失败');
        });
    }

    /* 换台 */
    ZhuotaiService.doHuantai = function (orignal, target, cb) {
        var queries = [];
        var tempTargetZhuotai = Utils.clone(target);

        var order = orignal.order;
        var tempTargetOrder = tempTargetZhuotai.order;

        order.zhuotaiId = target.guid;
        order.zhuotaiName = target.name;
        order.zhuotaiCode = target.code;

        order.areaId = target.areaId;
        order.areaCode = target.areaCode;
        order.areaName = target.areaName;

        target.orderId = order.guid;
        target.order = order;
        target.inArea = orignal.inArea;
        target.inPage = orignal.inPage;
        target.showKaitai = orignal.showKaitai;

        /* JP
        2016-02-29
        加入了对目标桌台的判断
        如果目标桌台已开台，也需要将目标桌台的信息换到原来的桌台        
        */
        /* JP 2016-04-21
        业务有变更  取消了可切换开台的桌台  代码保留
        */
        if (tempTargetZhuotai.orderId) {
            tempTargetOrder.zhuotaiId = orignal.guid;
            tempTargetOrder.zhuotaiName = orignal.name;


            orignal.orderId = tempTargetOrder.guid;
            orignal.order = tempTargetOrder;
            orignal.inArea = tempTargetZhuotai.inArea;
            orignal.inPage = tempTargetZhuotai.inPage;
            orignal.showKaitai = tempTargetZhuotai.showKaitai;
        } else {
            orignal.order = new Order();
            orignal.orderId = null;
            orignal.inArea = null;
            orignal.inPage = null;
            orignal.showKaitai = null;
        }
        //if (tempTargetZhuotai.orderId) {
        //    queries.push({ query: "update pos_zhuotai set orderId='" + orignal.orderId + "' where guid='" + orignal.guid + "'" });
        //    queries.push({
        //        query: "update pos_order set zhuotaiId='" + tempTargetOrder.zhuotaiId + "',zhuotaiName='" + tempTargetOrder.zhuotaiName +
        //            "',zhuotaiCode='" + tempTargetOrder.zhuotaiCode + "',  where guid='" + tempTargetOrder.guid + "'"
        //    });
        //} else {
        //    queries.push({ query: "update pos_zhuotai set orderId=null where guid='" + orignal.guid + "'" });
        //}
        /* 判断处理结束 */

        queries.push({ query: "update pos_zhuotai set orderId='" + target.orderId + "' where guid='" + target.guid + "' and orderId ISNULL AND (select orderId from pos_zhuotai where guid='" + orignal.guid + "') not NULL" });

        queries.push({ query: "update pos_zhuotai set orderId=null where guid='" + orignal.guid + "' and orderId not null  " });

        //queries.push({ query: "update pos_zhuotai set orderId=null where guid='" + orignal.guid + "' and orderId not null and (select orderId from pos_zhuotai where guid='" + target.guid + "') ISNULL " });
        //queries.push({ query: "update pos_zhuotai set orderId='" + target.orderId + "' where guid='" + target.guid + "' and orderId ISNULL " });
        //queries.push({
        //    query: "update pos_order set zhuotaiId='" + order.zhuotaiId + "',zhuotaiName='" + order.zhuotaiName +
        //        "',zhuotaiCode='" + order.zhuotaiCode + "',areaGuid='" + order.areaId + "',areaCode='" + order.areaCode +
        //        "',areaName='" + order.areaName + "' where guid='" + order.guid + "'"
        //});
        zhuotaiDao.queryTransaction(queries).then(function (resultList) {
            var executeNum = 0;
            for (var idx in resultList.rowsAffected) {
                executeNum += resultList.rowsAffected[idx];
            }
            if (executeNum == 2) {
                var secondQueries = [];
                secondQueries.push({query: "update pos_order set zhuotaiId='" + order.zhuotaiId + "',zhuotaiName='" + order.zhuotaiName +
                "',zhuotaiCode='" + order.zhuotaiCode + "',areaGuid='" + order.areaId + "',areaCode='" + order.areaCode +
                "',areaName='" + order.areaName + "' where guid='" + order.guid + "'"});
                secondQueries.push({ query: "update pos_order_zhuotai set zhuotaiId = '" + order.zhuotaiId + "', zhuotaiCode = '" + target.code + "', zhuotaiName = '"  + target.name + "', areaId = '" +
                target.areaId + "', areaCode = '" + target.areaCode  + "', areaName = '"  + target.areaName + "' where orderId = '" + target.order.guid + "'"  });//pos_order_zhuotai
                zhuotaiDao.queryTransaction(secondQueries).then(function (results) {

                    UploadService.syncZhuotai({ zhuotai: orignal, order: { id: "" } });
                    UploadService.syncZhuotai({ zhuotai: target, order: { id: target.orderId, status: -1 } });

                    cb(null, [orignal, target]);
                }, function (error) {
                    return cb(error);
                });               
            } else {
                cb({msg:"换台失败!"});
            }
        }, function (err) {
            cb(err);
        });
    }
    /**
     * peter.shang
     *
     * @param zhuoTai
     * @param cb
     */
    ZhuotaiService.qingTai = function (zhuoTai, cb) {
        if (zhuoTai == null) {
            cb({ message: "未选定桌台" });
            return;
        }
        //1. 未开台
        if (zhuoTai.orderId == null)
            return;
        //2. 开台但是没有账单号
        if (zhuoTai.orderId != null && zhuoTai.order.code == null) {

            var all = [];
            //a.把桌台中的ORDERID置为空
            all.push({
                query: "update pos_zhuotai set orderId = null where guid = ? ",
                params: [zhuoTai.guid]
            });
            //b.把order中的该条账单删除（并未产生账单号）
            all.push({
                query: "update pos_order set isDeleted = 'true' where guid = ? ",
                params: [zhuoTai.order.guid]
            });

            all.push({
                query: "update pos_order_zhuotai set isDeleted = 'true' where guid = ? ",
                params: [zhuoTai.orderZhuoTai.guid]
            });

            zhuotaiDao.queryTransaction(all).then(function (resultList) {
				UploadService.syncZhuotai({zhuotai:zhuoTai,order:{id:""}});
                cb(null, null);
            }, function (err) {
                console.log(err);
                cb({ message: "清台失败." });
            });


        }

        //3. 开台并且有账单号，同时“未结算”
        if (zhuoTai.orderId != null && zhuoTai.order.code != null && zhuoTai.order.status < BIZCONSTANT.ORDER_STATUS_YI_JIE_SUAN) {
            cb({ message: "桌台【" + zhuoTai.name + "】账单【未结算】，不能清台" });
            return;
        }

        //4. 结账的时候会自动清台，无需在此实现。

    }

    /**
     * author, peter.shang
     *
     * 是否存在未落单的商品
     *
     */
    ZhuotaiService.existsUnconfirmedCaiPin = function (orderId, cb) {



        var sql = "select count(1) c, (select luoDanTime from pos_order where guid='" + orderId + "')  luoDanTime from pos_order_caipin where orderId='" + orderId + "' and luodan = 0";
        zhuotaiDao.query(sql).then(function (results) {
            var count = results.detail[0];

            if (count.c == 0)
                return cb(null, count.luoDanTime);

            return cb({ message: '该桌包含了未落单的商品' }, count.luoDanTime);
        }, function (error) {
            return cb(error);
        });
    }

    // 查看各个桌台未确认重量的菜品
    ZhuotaiService.actWeight = function (orderId, cb) {



        var sql = "SELECT A.*,B.zhuotaiName FROM pos_order_caipin A INNER JOIN pos_order_zhuotai B on A.orderZhuoTaiId = B.guid WHERE A.orderId = '" + orderId + "'";
        zhuotaiDao.query(sql).then(function (results) {
            var count = results.detail;
            var msg = [],msgkb = [];
            for(var x in count) {
                if(count[x].needweigh == 1 && (count[x].num - count[x].tuiNum) >0) {
                    //msg = "桌台【"+ count[x].zhuotaiName +"】中的菜品【"+count[x].name+"】";
                    msg.push(count[x]);
                }
                if(count[x].price == 0 && count[x].priceChange==='true' && (count[x].num - count[x].tuiNum) >0){
                    //msgkb = "桌台【"+ count[x].zhuotaiName +"】中的菜品【"+count[x].name+"】";
                    msgkb.push(count[x])
                }
            }

            //if(!!msgkb){
            //    msgkb += "为可变价菜品且价格为“0”，是否确认继续结算？"
            //}
            //
            //if(!!msg){
            //    msg += "需确认重量，请“确认重量”再进行结算操作"
            //}
            cb(null,msg,msgkb);
        }, function (error) {
            return cb(error);
        });
    }

    ZhuotaiService.lockZhuoTai = function (zt_guid,operator,cb)
    {
        if (!operator)
        {
            operator = { operator: BIZCONSTANT.POSUSER.id + Utils.DeviceName(), operatorName: BIZCONSTANT.POSUSER.name + '#' + Utils.DeviceName() };
        }
        var sql = "update pos_zhuotai set operatorId='" + operator.operator + "',operatorName='" + operator.operatorName + "' where guid='" + zt_guid + "' and (operatorId is null OR operatorId='' OR operatorId='" + operator.operator + "') ";
        //console.log(sql);
        zhuotaiDao.query(sql).then(function (resultList) {
            if (resultList.rowsAffected[0] <= 0) {
                zhuotaiDao.getById(zt_guid, 'guid').then(function (zt) {
                    cb(zt.operatorName.replace('#', '正在') + "上操作这个桌台");
                }, function (err) {
                    cb('桌台锁定失败，有其他人在操作此桌台');
                });
            }
            else
                cb(null);
        }, function (err) {
            cb('桌台锁定失败，数据操作失败');
        });
    }

    ZhuotaiService.openLockZhuoTai = function (zt_guid,cb)
    {
        zhuotaiDao.query("update pos_zhuotai set operatorId=null,operatorName=null where guid='" + zt_guid + "'").then(function (resultList) {
            if (resultList.rowsAffected[0] <= 0) {
                if (cb)
                    cb('桌台解锁失败');
            } else if (cb)
                cb(null);
        }, function (err) { if (cb) { cb("解锁失败，数据操作失败");}});
    }

    ZhuotaiService.scombDetail = {}; // 套餐明细对象
    ZhuotaiService.scombMinxi = []; //落单菜品的套餐明细
    //根据order查找坐台菜品, orderZhuoTaiId  orderZhuoTai
    ZhuotaiService.foundCaipin = function (orderid, orderZhuoTai, cb)
    {   ZhuotaiService.scombDetail = {};
        ZhuotaiService.scombMinxi = [];
        var sql = "select * from pos_order_caipin where orderId='" + orderid + "'" + "and luodanTime is not null and orderZhuoTaiId = '" + orderZhuoTai + "' and num >= 0";
        zhuotaiDao.query(sql).then(function (resultList) {
            // AND tuiNum>0
            var sqlt = "SELECT * FROM pos_order_scomb_caipin where orderCaipinId in (select guid from pos_order_caipin where orderId='" + orderid + "'"+ "and luodanTime is not null) AND num >= 0";
            zhuotaiDao.query(sqlt).then(function (res) {
                var reres = [];// 套餐退菜的明细
                for(var j in res.detail){
                    if( res.detail[j].tuiNum>0){
                        reres.push(res.detail[j]);
                    }
                    ZhuotaiService.scombMinxi.push(Utils.clone(res.detail[j]));
                }
                var combSql =[],combObj = {};
                for(var x in resultList.detail){
                    if(resultList.detail[x].isScomb){
                        combSql.push({query: "SELECT * FROM pos_scomb_caipin where scombId = '" + resultList.detail[x].caipinId  + "'"});
                    }
                }
                if(combSql.length > 0) {
                    zhuotaiDao.queryTransaction(combSql).then (function (comblist) {

                        for (var i in comblist.detail){
                            var key = "a" + comblist.detail[i].scombId;
                            if(combObj[key] === undefined){
                                combObj[key] = {};
                               // ZhuotaiService.scombDetail[key] = [];
                                //ZhuotaiService.scombDetail[key].push(comblist.detail[i]);
                                var sKey = "a" + comblist.detail[i].caipinId;
                                combObj[key][sKey] = {};
                                combObj[key][sKey].name = comblist.detail[i].name;
                                combObj[key][sKey].num = comblist.detail[i].num;
                            } else {
                               // ZhuotaiService.scombDetail[key].push(comblist.detail[i]);
                                var sKey = "a" + comblist.detail[i].caipinId;
                                combObj[key][sKey] = {};
                                combObj[key][sKey].name = comblist.detail[i].name;
                                combObj[key][sKey].num = comblist.detail[i].num;
                            }
                        }
                        ZhuotaiService.scombDetail = combObj;
                        return  cb(null, combObj ,resultList,reres);
                        //console.log(combObj)
                    }, function (comerr) {
                        return  cb(null, null ,resultList,reres);
                    })
                } else {
                    return  cb(null, null ,resultList,reres);
                }

            },function(err1){
                return  cb(err1);
            })

        }, function (err) {
            return  cb(err);
        });
    }

    //检查是否有未结算的桌台
    //cb 回调函数，用来同步未结算的桌台
    ZhuotaiService.hasUnJieSuanZhuoTai = function(callback) {
        var sql = "select guid from pos_zhuotai where orderId is not null and enabled='true' and isDeleted='false'";
        zhuotaiDao.query(sql).then(function(res) {
                if(res && res.detail.length > 0) {
                    //有未结算的桌台
                    return callback(true);
                }else {
                    return callback(false);
                }
            },
            function(err) {
                return callback(err);
            }
        )
    }
    ZhuotaiService.justForAddScombzuofaAndKouwei = [];
    //移菜的数据库处理
    ZhuotaiService.runYicai = function(arr, firstorderId,luoDanTime, currentOrder, obj, cb){
        var queries = [],ZDcode;
        if(currentOrder.luoDanTime == null ||currentOrder.luoDanTime == ''){
            queries.push({query:"update pos_order set luoDanTime  = '" + luoDanTime +"' where guid = '" +obj.order.guid + "'"})
        }

        //查找原始台的口味
        ZhuotaiService.founKeweiAndZuofa(firstorderId, arr, function(zuofaErr,zuofa, kouwei){
            if(!zuofaErr) {
                var now = new Date();
                UniqueIDService.nextSeq(now, 'order', function (err, seq, nowdate) {
                    if (err) {
                        return Utils.showFailureInfo(err.message);
                    }
                    if(currentOrder.code == null || currentOrder.code =='') {
                        var seqNo = nowdate + Utils.formatSeqNo(seq);
                        var zhangDanNo = "ZD" + seqNo;
                        ZDcode = zhangDanNo;
                        queries.push({query: "update pos_order set code  = '" + ZDcode + "' where guid = '" + obj.order.guid + "'"});
                    }
                    for (var x in arr){
                        if(arr[x].firstGuid){
                            //改原桌台的数量
                            var bufferGuid = zhuotaiDao.guid(); // 新桌台的套餐GUID
                            queries.push({query: "update pos_order_caipin set num  = num-" + arr[x].num +" where guid = '" +arr[x].guid + "'" });

                            if(arr[x].isScomb){
                                var  buffercaipinId = "a" + arr[x].caipinId;
                                for ( var i in ZhuotaiService.scombMinxi) {
                                    var cp_scombId = "a" + ZhuotaiService.scombMinxi[i].scombId;
                                    if(cp_scombId == buffercaipinId  &&  arr[x].guid == ZhuotaiService.scombMinxi[i].orderCaipinId){
                                        var cp_detail = Utils.clone(ZhuotaiService.scombMinxi[i]);
                                        //原始桌台的明细
                                        queries.push({query: "update pos_order_scomb_caipin set num  = num-" +  ZhuotaiService.scombDetail[buffercaipinId]["a" + cp_detail.caipinId].num*arr[x].num +" where guid = '" + ZhuotaiService.scombMinxi[i].guid + "'" });
                                        //新桌台的明细
                                        cp_detail.num = ZhuotaiService.scombDetail[buffercaipinId]["a" + cp_detail.caipinId].num*arr[x].num;
                                        cp_detail.tuiNum = 0;
                                        var y_oriScomb = cp_detail.guid; // 记录原始GUID，目的为了套餐的做法和口味具体到某一个明细
                                        cp_detail.guid = scombDao.guid();
                                        cp_detail.orderCaipinId = bufferGuid;
                                        //queries.push(scombDao.getInsertsql(cp_detail));
                                        queries.push({
                                            query: "INSERT INTO pos_order_scomb_caipin(guid,orderCaipinId,scombId,caipinId,orderCaipinType,name,price,num," +
                                            "tuiNum,zengNum,unitName,chupin,minAgio,danPinBiLiZheKou,danPinJineZheKou,danPinZheKou,luodan,dianCaiYuan,dianCaiYuanName," +
                                            "operator,modTime,dianCaiTime,needweigh,isScomb,scombMainCaipinId,hyPrice,caipinTypeId,caipinTypeCode," +
                                            "caipinTypeName) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)" ,
                                            params: [cp_detail.guid, cp_detail.orderCaipinId, cp_detail.scombId, cp_detail.caipinId, cp_detail.orderCaipinType, cp_detail.name, cp_detail.price, cp_detail.num,
                                            cp_detail.tuiNum, cp_detail.zengNum, cp_detail.unitName, cp_detail.chupin, cp_detail.minAgio, cp_detail.danPinBiLiZheKou, cp_detail.danPinJineZheKou, cp_detail.danPinZheKou, cp_detail.luodan, cp_detail.dianCaiYuan, cp_detail.dianCaiYuanName,
                                            cp_detail.operator, cp_detail.modTime, cp_detail.dianCaiTime, cp_detail.needweigh, cp_detail.isScomb, cp_detail.scombMainCaipinId, cp_detail.hyPrice, cp_detail.caipinTypeId, cp_detail.caipinTypeCode,
                                            cp_detail.caipinTypeName]
                                        });
                                        //记录每次套餐明细更改的套餐GUID和明细的GUID
                                        ZhuotaiService.justForAddScombzuofaAndKouwei.push({y_t: bufferGuid, y_mx:cp_detail.guid, y_oriScomb:y_oriScomb});
                                    }
                                }
                            }

                            // 口味
                            for ( var key in  kouwei){
                                if (kouwei[key].orderCaipinId == arr[x].guid) {
                                    var sqlkeweiobj = Utils.clone(kouwei[key]);
                                    sqlkeweiobj.orderCaipinId = bufferGuid;
                                    var delsql = " delete from pos_order_caipin_kouwei where orderCaipinId='" + sqlkeweiobj.orderCaipinId + "' AND kwId='" + sqlkeweiobj.kwId + "'";
                                    sqlkeweiobj.guid = caipinzuokouwei.guid()
                                    if (arr[x].isScomb) {
                                        for (var j in ZhuotaiService.justForAddScombzuofaAndKouwei) {
                                            if (ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_t == bufferGuid && kouwei[key].orderScombCaipinId == ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_oriScomb) {
                                                sqlkeweiobj.orderScombCaipinId = ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_mx;
                                            }
                                        }
                                    }
                                    queries.push({query: delsql});

                                    queries.push({
                                        query: "INSERT INTO pos_order_caipin_kouwei(guid,orderCaipinId,kwId,name,operator,modTime,isScomb) VALUES (?,?,?,?,?,?,?)",
                                        params: [sqlkeweiobj.guid, sqlkeweiobj.orderCaipinId, sqlkeweiobj.kwId,sqlkeweiobj.name, sqlkeweiobj.operator, sqlkeweiobj.modTime, sqlkeweiobj.isScomb]
                                    });

                                    //queries.push(caipinzuokouwei.getInsertsql(sqlkeweiobj));//插入orderCaipinId = firstGuid, guid生产的语句
                                }
                            }

                            // 做法
                            for ( var key in  zuofa){
                                if (zuofa[key].orderCaipinId == arr[x].guid) {
                                    var sqlzuofaobj = Utils.clone(zuofa[key]);
                                    sqlzuofaobj.orderCaipinId = bufferGuid;
                                    var delsql = " delete from pos_order_caipin_zuofa where orderCaipinId= '"+ sqlzuofaobj.orderCaipinId + "' AND zuofaId='"+sqlzuofaobj.zuofaId+"'";
                                    sqlzuofaobj.guid = caipinzuofaDao.guid();
                                    if (arr[x].isScomb) {
                                        for (var j in ZhuotaiService.justForAddScombzuofaAndKouwei) {
                                            if (ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_t == bufferGuid && zuofa[key].orderScombCaipinId == ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_oriScomb) {
                                                sqlzuofaobj.orderScombCaipinId = ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_mx;
                                            }
                                        }
                                    }
                                    queries.push({query: delsql});
                                    queries.push({
                                        query: "INSERT INTO pos_order_caipin_zuofa(guid,orderCaipinId,zuofaId,name,price,jiajiaType,operator,modTime,isScomb,orderScombCaipinId) VALUES (?,?,?,?,?,?,?,?,?,?)",
                                        params: [sqlzuofaobj.guid, sqlzuofaobj.orderCaipinId, sqlzuofaobj.zuofaId, sqlzuofaobj.name, sqlzuofaobj.price, sqlzuofaobj.jiajiaType, sqlzuofaobj.operator, sqlzuofaobj.modTime, sqlzuofaobj.isScomb, sqlzuofaobj.orderScombCaipinId]
                                    });

                                    //queries.push(caipinzuofaDao.getInsertsql(sqlzuofaobj));//插入orderCaipinId = firstGuid, guid生产的语句
                                }
                            }

                            //新桌台的数据库语句
                            arr[x].guid = bufferGuid;
                            arr[x].orderId = obj.orderId;
                            arr[x].orderZhuoTaiId = obj.orderZhuoTai.guid;
                            //queries.push(caipinDao.getInsertsql( Utils.clone(arr[x])));
                            queries.push({
                                query:"INSERT INTO pos_order_caipin(guid,orderId,caipinId,orderCaipinType,name,price,num,tuiNum,zengNum,unitName,chupin,minAgio," +
                                "danPinBiLiZheKou,danPinJineZheKou,danPinZheKou,luodan,dianCaiYuan,dianCaiYuanName,operator,modTime,dianCaiTime,luoDanTime,needweigh," +
                                "caipinTypeId,caipinTypeCode,caipinTypeName,caiwuTypeName,caiwuTypeId,firstGuid,orderZhuoTaiId,priceChange,unitId,cpdept) " +
                                "VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)" ,
                                params: [arr[x].guid, arr[x].orderId, arr[x].caipinId, arr[x].orderCaipinType, arr[x].name, arr[x].price, arr[x].num, arr[x].tuiNum, arr[x].zengNum, arr[x].unitName, arr[x].chupin, arr[x].minAgio,
                                arr[x].danPinBiLiZheKou, arr[x].danPinJineZheKou, arr[x].danPinZheKou, arr[x].luodan, arr[x].dianCaiYuan, arr[x].dianCaiYuanName, arr[x].operator, arr[x].modTime, arr[x].dianCaiTime, arr[x].luoDanTime, arr[x].needweigh,
                                arr[x].caipinTypeId, arr[x].caipinTypeCode, arr[x].caipinTypeName, arr[x].caiwuTypeName, arr[x].caiwuTypeId, arr[x].firstGuid, arr[x].orderZhuoTaiId, arr[x].priceChange, arr[x].unitId,arr[x].cpdept]
                            });

                        } else {
                            queries.push({query: "update pos_order_caipin set orderId  = '" + obj.orderId +"', orderZhuoTaiId = '" + obj.orderZhuoTai.guid + "' where guid = '" +arr[x].guid + "'" });
                        }

                    }
                    console.log(queries);
                    ZhuotaiService.justForAddScombzuofaAndKouwei = [];
                    zhuotaiDao.queryTransaction(queries).then(function (res) {
                        cb(null,res);
                    }, function (err) {
                        cb(err);
                    });


                });




            }

        })







    }

    //查原始桌台 口味 和 做法的 结果集
    ZhuotaiService.founKeweiAndZuofa = function(orderId, mubiaoArr, cb) {
        var sqlzuofa = "SELECT * FROM pos_order_caipin_zuofa where orderCaipinId in (SELECT guid from pos_order_caipin where orderId= '" + orderId + "')";
        var zuofa = [], kewei = [];
        zhuotaiDao.query(sqlzuofa).then(function(zuofares){
            zuofa =  zuofares.detail;
            var sqlkewei = "SELECT * FROM pos_order_caipin_kouwei where orderCaipinId in (SELECT guid from pos_order_caipin where orderId= '" + orderId + "')";
            zhuotaiDao.query(sqlkewei).then(function(keweires){
                kewei = keweires.detail;
                cb(null,zuofa,kewei)
            }, function (err2){
                cb(err2)
            })
        }, function (err1){
            cb(err1)
        })

    }
    // 移菜目标桌台的对象合并 ，清理数量为的数据   原桌台的数据firstArr   目标桌台的数据targetArr
    ZhuotaiService.combineCaiPin = function (firstArr, targetArr, cb) {
        var queries = [];
        //原始桌台去除零数量
        for (var x in firstArr) {
            if(firstArr[x].num == 0) {
                queries.push({query: "DELETE FROM pos_order_caipin WHERE guid = '"+firstArr[x].guid+"'"});
                queries.push({query: "DELETE FROM pos_order_scomb_caipin WHERE orderCaipinId = '"+firstArr[x].guid+"'"});
            }
        }
        var targertComArr = [];
        for (var te in targetArr) {
            targertComArr.push(targetArr[te]);
        }

        //目标桌台合并对象 guid  与 firstGuid相等的， firstGuid 与firstGuid相等 合并
        for (var i= 0 ; i < targetArr.length; i++ ) {
            processArr(targertComArr,targetArr[i]);
            for (var j = 0; j < targertComArr.length; j++){

                //if(!targertComArr[j].isScomb){
                    if(targetArr[i].guid == targertComArr[j].firstGuid || (targetArr[i].firstGuid == targertComArr[j].firstGuid && targetArr[i].firstGuid)){
                        if(targertComArr[j].isScomb) {
                            var bufferCaipinId = "a" + targertComArr[j].caipinId;
                            for ( var key in ZhuotaiService.scombMinxi){
                                var cp_scombId = "a" + ZhuotaiService.scombMinxi[key].scombId;
                                if(cp_scombId == bufferCaipinId) {
                                    queries.push({query: "update pos_order_scomb_caipin set num =num +" + targertComArr[j].num * ZhuotaiService.scombDetail[bufferCaipinId]["a" + ZhuotaiService.scombMinxi[key].caipinId].num +
                                    " where scombId = '" + ZhuotaiService.scombMinxi[key].scombId + "'and caipinId = '" +  ZhuotaiService.scombMinxi[key].caipinId  +  "' and orderCaipinId = '" + targetArr[i].guid  + "'"});
                                }
                            }
                        }
                        queries.push({query: "update pos_order_caipin set num =num +" + targertComArr[j].num + " where guid = '" + targetArr[i].guid +  "'"});
                        queries.push({query: "DELETE FROM pos_order_caipin WHERE guid = '" + targertComArr[j].guid +"'"});
                        //同时去除套餐内的明细
                        queries.push({query: "DELETE FROM pos_order_scomb_caipin WHERE orderCaipinId = '"+ targertComArr[j].guid +"'"});
                        ////同时去除该菜品下的做法
                        //queries.push({query: "delete from pos_order_caipin_zuofa where orderCaipinId='"+ targertComArr[j].guid +"'"});
                        ////同时去除该菜品下的口味
                        //queries.push({query: "delete from pos_order_caipin_kouwei where orderCaipinId='"+ targertComArr[j].guid +"'"});
                    }
               // }



            }
        }

        if(queries != []){
            zhuotaiDao.queryTransaction(queries).then(function (res) {
                cb(null,res);
            }, function (err) {
                cb(err);
            });
        }else{
            cb(null);
        }

    }

    //对象合并后查表菜品
    ZhuotaiService.aftercombin = function (orderId, cb) {
        var sql = "select * from pos_order_caipin where orderId = '" + orderId + "' and firstGuid is not null"
        zhuotaiDao.query(sql).then(function(res){
            cb(null,res);
        }, function (err){
            cb(err);
        })
    }

    ////查原始桌台 口味 和 做法的 结果集
    //ZhuotaiService.founKeweiAndZuofa = function(orderId, mubiaoArr, cb) {
    //    var sqlzuofa = "SELECT * FROM pos_order_caipin_zuofa where orderCaipinId in (SELECT guid from pos_order_caipin where orderId= '" + orderId + "')";
    //    var zuofa = [], kewei = [], queries = [];
    //    zhuotaiDao.query(sqlzuofa).then(function(zuofares){
    //        zuofa =  zuofares.detail;
    //        var sqlkewei = "SELECT * FROM pos_order_caipin_kouwei where orderCaipinId in (SELECT guid from pos_order_caipin where orderId= '" + orderId + "')";
    //        zhuotaiDao.query(sqlkewei).then(function(keweires){
    //            kewei = keweires.detail;
    //            for(var x in zuofa){
    //                for(var i= 0; i < mubiaoArr.length; i++){
    //                    if(zuofa[x].orderCaipinId == mubiaoArr[i].firstGuid){
    //                        var sqlzuofaobj = Utils.clone(zuofa[x]);
    //                        sqlzuofaobj.orderCaipinId = mubiaoArr[i].guid;
    //                        var delsql=" delete from pos_order_caipin_zuofa where orderCaipinId='"+sqlzuofaobj.orderCaipinId+"' AND zuofaId='"+sqlzuofaobj.zuofaId+"'";
    //                        sqlzuofaobj.guid = caipinzuofaDao.guid()
    //                        if(mubiaoArr[i].isScomb){
    //                            for(var j in ZhuotaiService.justForAddScombzuofaAndKouwei){
    //                                if(ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_t  ==  mubiaoArr[i].guid && zuofa[x].orderScombCaipinId == ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_oriScomb){
    //                                    sqlzuofaobj.orderScombCaipinId = ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_mx;
    //                                }
    //                            }
    //                        }
    //                        queries.push({query:delsql});
    //                        queries.push(caipinzuofaDao.getInsertsql(sqlzuofaobj));//插入orderCaipinId = firstGuid, guid生产的语句
    //                    }
    //                }
    //            }
    //            for(var x in kewei){
    //                for(var i = 0; i < mubiaoArr.length; i++){
    //                    if(kewei[x].orderCaipinId == mubiaoArr[i].firstGuid){
    //                        var sqlkeweiobj = Utils.clone(kewei[x]);
    //                        sqlkeweiobj.orderCaipinId = mubiaoArr[i].guid;
    //                        var delsql=" delete from pos_order_caipin_kouwei where orderCaipinId='"+sqlkeweiobj.orderCaipinId+"' AND kwId='"+sqlkeweiobj.kwId+"'";
    //                        sqlkeweiobj.guid = caipinzuokouwei.guid();
    //                        if(mubiaoArr[i].isScomb){
    //                            for(var j in ZhuotaiService.justForAddScombzuofaAndKouwei){
    //                                if(ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_t  ==  mubiaoArr[i].guid  &&  kewei[x].orderScombCaipinId == ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_oriScomb){
    //                                    sqlkeweiobj.orderScombCaipinId = ZhuotaiService.justForAddScombzuofaAndKouwei[j].y_mx;
    //                                }
    //                            }
    //                        }
    //                        queries.push({query:delsql});
    //                        queries.push(caipinzuokouwei.getInsertsql(sqlkeweiobj));//插入orderCaipinId = firstGuid
    //                    }
    //                }
    //            }
    //            ZhuotaiService.justForAddScombzuofaAndKouwei = [];
    //            if(queries != []){
    //                zhuotaiDao.queryTransaction(queries).then(function (reslist) {
    //                    cb(null,reslist)
    //                }, function (err3) {
    //                    cb(err3)
    //                });
    //            } else {
    //                cb(null)
    //            }
    //
    //        }, function (err2){
    //            cb(err2)
    //        })
    //    }, function (err1){
    //        cb(err1)
    //    })
    //
    //}

    //数组移除处理函数
    function processArr (arr, ele) {
        var ind = null;
        for(var i = 0; i < arr.length; i++) {
            if(arr[i] == ele) {
                ind = i;
            }
        }
        if(ind != null){
            arr.splice(ind,1);
        }

    }



    //检查是否有未结算的反结算账单
    ZhuotaiService.hasUnJieSuan_FanJSOrder = function(banCiHao, callback) {
        //1.检查是否有未结算的桌台
        var sql = "select orderId from pos_zhuotai where orderId is not null limit 1";
        zhuotaiDao.query(sql).then(function(res) {
                if(res && res.detail && res.detail.length > 0){
                    var obj = res.detail[0]
                    var orderId = obj.orderId;
                    if(orderId && orderId.length > 0) {
                        sql = "select guid from pos_order where jieSuanTime is null and isFanJieSuan=1 and banciNo='" + banCiHao + "'" + " and guid='" + orderId +"' limit 1";
                        orderDao.query(sql).then(function(res) {
                                if(res && res.detail.length > 0) {
                                    //有未结算的桌台
                                    callback(true);
                                }else {
                                    callback(false);
                                }
                            },
                            function(error) {
                                callback(error);
                            }
                        )
                    }else callback(false);
                }else callback(false);
            }
        );
    }

    /*获取待并帐的桌台列表*/
    ZhuotaiService.getMergingZhuotais = function(zhuotaiId, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName," +
            "o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.isFanJieSuan as o_isFanJieSuan," +
            "o.merge as o_merge, o.jieSuanNo as o_jieSuanNo,  ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " inner join pos_order o on o.guid=z.orderId and o.merge is null and o.luoDanTime is not null and o.isDeleted='false' " +
            " inner join pos_order_zhuotai poz on poz.zhuotaiId=z.guid and poz.orderId=z.orderId and poz.isDeleted='false' " +
            " where z.isDeleted='false' and z.orderId is not null and z.guid <> '"+zhuotaiId+"'" +
            " and (select count(*) c from pos_billing_detail pbd where pbd.jieSuanId=o.jieSuanId and pbd.type='PAY')=0 order by z.code";
        console.log("getMergingZhuotais sql=" + sql);
        zhuotaiDao.query(sql).then(function(res){
            var resultList = [];
            for (var i = 0; i < res.detail.length; i++) {
                var row = res.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (err){
            cb(err);
        })
    }

    /*根据桌台号获取待并帐的桌台列表*/
    ZhuotaiService.getMergingZhuotaiByCode = function (zhuotaiId, code, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime,o.isFanJieSuan as o_isFanJieSuan," +
            " o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.merge as o_merge, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId," +
            "a.areaCode as a_areaCode,a.areaName as a_areaName," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " inner join pos_order o on o.guid=z.orderId and o.merge is null and o.luoDanTime is not null and o.isDeleted='false' " +
            " inner join pos_order_zhuotai poz on poz.zhuotaiId=z.guid and poz.orderId=z.orderId and poz.isDeleted='false' " +
            " LEFT JOIN pos_area a on z.areaId=a.guid " +
            " where z.isDeleted='false' and z.enabled='true' and z.orderId is not null and z.guid <> '"+zhuotaiId+"' " +
            " and (z.code like '%" + code + "%' or z.quickCode like '%"+code+"%' or z.name like '%"+code+"%')" +
            " and (select count(*) c from pos_billing_detail pbd where pbd.jieSuanId=o.jieSuanId and pbd.type='PAY')=0" +
            " order by z.code" ;
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };

    /*获取已并帐的桌台列表*/
    ZhuotaiService.getMergedZhuotais = function(zhuotai, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName," +
            "o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.isFanJieSuan as o_isFanJieSuan," +
            "o.merge as o_merge, o.jieSuanNo as o_jieSuanNo, ifnull(o.temZkMoney, 0) as o_temZkMoney,  " +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " inner join pos_order o on o.guid=z.orderId and o.isDeleted='false' " +
            " inner join pos_order_zhuotai poz on poz.zhuotaiId=z.guid and poz.orderId=z.orderId and poz.isDeleted='false' " +
            " where z.isDeleted='false' and z.orderId='"+zhuotai.orderId+"' and z.guid <> '"+zhuotai.guid+"' order by z.code";
        //console.log("getMergedZhuotais sql=" + sql);
        zhuotaiDao.query(sql).then(function(res){
            var resultList = [];
            for (var i = 0; i < res.detail.length; i++) {
                var row = res.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (err){
            cb(err);
        })
    }

    /*根据orderId获取已并帐的桌台列表*/
    ZhuotaiService.getMergedZhuotaisByOrder = function(orderId, cb) {
        var sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.totalPrice as o_totalPrice, " +
            "o.code as o_code,o.comments as o_comments, o.serverId as o_serverId, o.serverName as o_serverName, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime,o.canBieName o_canbieName,o.isFanJieSuan as o_isFanJieSuan," +
            "o.merge as o_merge, o.jieSuanNo as o_jieSuanNo,o.operator as o_operator,o.operatorCode as o_operatorCode,o.operatorName as o_operatorName, " +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId," +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z " +
            " inner join pos_order o on o.guid=z.orderId and o.isDeleted='false' " +
            " inner join pos_order_zhuotai poz on poz.zhuotaiId=z.guid and poz.orderId=z.orderId and poz.isDeleted='false' " +
            " where z.isDeleted='false' and z.orderId='"+orderId+"' order by z.code";

        zhuotaiDao.query(sql).then(function(res){
            var resultList = [];
            for (var i = 0; i < res.detail.length; i++) {
                var row = res.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (err){
            cb(err);
        })
    }

    //获取合并号
    function getMergeNo(usedNos){
        var nos = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];
        for(var i=0; i< usedNos.length; i++){
            Utils.removeFromArray(nos, usedNos[i].merge);
        }
        return nos[0];
    }

    //构建并帐query
    function buildBingzhangQuery(queries, zhuotai, bingruZhuotais, chaifenZhuotais, mergeOriginal, orderNo){
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var targetOrderId = zhuotai.orderId;
        var newJieSuanId = null;
        var newRenshu = zhuotai.order.renshu;
        var newTotalPrice = zhuotai.order.totalPrice;
        var newOrderZhuotaiIds = zhuotai.guid;
        var newOrderZhuotaiCodes = zhuotai.code;
        var newOrderZhuotaiNames = zhuotai.name;
        //第一次合并，将主桌台关联新建的order
        if(mergeOriginal){
            targetOrderId = Utils.guid();
            newJieSuanId = Utils.guid();
            queries.push({
                query: "update pos_zhuotai set orderId='"+targetOrderId+"' where guid='"+zhuotai.guid+"'"
            });
            queries.push({
                query: "update pos_order set isDeleted='true' where guid='"+zhuotai.orderId+"'"
            });
            queries.push({
                query: "update pos_order_zhuotai set orderId='"+targetOrderId+"' where guid='"+zhuotai.orderZhuoTai.guid+"'"
            });
            queries.push({
                query: "update pos_order_caipin set orderId='"+targetOrderId+"' where orderZhuoTaiId='"+zhuotai.orderZhuoTai.guid+"'"
            });
        }
        //处理被合并的桌台
        for(var i=0; i< bingruZhuotais.length; i++){
            newRenshu += bingruZhuotais[i].order.renshu;
            newTotalPrice += bingruZhuotais[i].order.totalPrice;
            newOrderZhuotaiIds += ","+ bingruZhuotais[i].guid;
            newOrderZhuotaiCodes += "," + bingruZhuotais[i].code;
            newOrderZhuotaiNames += "," + bingruZhuotais[i].name;
            queries.push({
                query: "update pos_zhuotai set orderId='"+targetOrderId+"' where guid='"+bingruZhuotais[i].guid+"'"
            });
            queries.push({
                query: "update pos_order set isDeleted='true' where guid='"+bingruZhuotais[i].orderId+"'"
            });
            queries.push({
                query: "update pos_order_zhuotai set orderId='"+targetOrderId+"' where guid='"+bingruZhuotais[i].orderZhuoTai.guid+"'"
            });
            queries.push({
                query: "update pos_order_caipin set orderId='"+targetOrderId+"' where orderZhuoTaiId='"+bingruZhuotais[i].orderZhuoTai.guid+"'"
            });
        }
        //第一次合并的时候，新建order,billing
        if(mergeOriginal){
            //建立空的账单
            var canbie = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date());
            if(orderNo == null){//如果没有落单的桌台，不需要生成账单号
                queries.push({
                    query: "insert into pos_order ( " +
                    "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
                    " serverId, serverName," +
                    " operator, operatorName,operatorCode, mdId," +
                    " kaiTaiTime, modTime, isDeleted," +
                    " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
                    " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource, merge,tsAndwm) " +
                    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?, ?,?, ?,?,?,?,?,?,?,?, ?,?)",
                    params: [targetOrderId, newOrderZhuotaiIds, newOrderZhuotaiNames, newRenshu, "合并桌台"+ zhuotai.order.merge, newTotalPrice, 1,
                        $rootScope.curUser.code, $rootScope.curUser.name,
                        $rootScope.curUser.id, $rootScope.curUser.name, $rootScope.curUser.code, $rootScope.curUser.mdId,
                        now, now, false,
                        BIZCONSTANT.FANJIESUAN_NO, 0, canbie.code, canbie.name,canbie.guid,
                        zhuotai.areaId, zhuotai.areaCode, zhuotai.areaName, newOrderZhuotaiCodes, newJieSuanId,ORDERSOURCE.DEFAULT, zhuotai.order.merge,'TS']
                });
            } else {//如果有落单的桌台，需要生成账单号
                queries.push({
                    query: "insert into pos_order ( " +
                    "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
                    " serverId, serverName," +
                    " operator, operatorName,operatorCode, mdId," +
                    " kaiTaiTime, modTime, isDeleted," +
                    " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
                    " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource, merge,code,luoDanTime,tsAndwm) " +
                    "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?, ?,?, ?,?,?,?,?,?,?,?, ?, ?, ?,?)",
                    params: [targetOrderId, newOrderZhuotaiIds, newOrderZhuotaiNames, newRenshu, "合并桌台"+ zhuotai.order.merge, newTotalPrice, 1,
                        $rootScope.curUser.code, $rootScope.curUser.name,
                        $rootScope.curUser.id, $rootScope.curUser.name, $rootScope.curUser.code, $rootScope.curUser.mdId,
                        now, now, false,
                        BIZCONSTANT.FANJIESUAN_NO, 0, canbie.code, canbie.name,canbie.guid,
                        zhuotai.areaId, zhuotai.areaCode, zhuotai.areaName, newOrderZhuotaiCodes, newJieSuanId,ORDERSOURCE.DEFAULT, zhuotai.order.merge,
                        orderNo, now,'TS']
                });
            }

            //建立空的结算单
            queries.push({
                query: "insert into pos_billing ( " +
                "guid, orderId) " +
                "values (?, ?)",
                params: [newJieSuanId, targetOrderId]
            });
        } else {//不是第一次合并
            //设置zhuotai.order对象的值，如果本次操作同时有拆帐，需要在拆帐操作中修改这些值
            zhuotai.order.renshu = newRenshu;
            zhuotai.order.totalPrice = newTotalPrice;
            zhuotai.order.zhuotaiId = newOrderZhuotaiIds;
            zhuotai.order.zhuotaiName = newOrderZhuotaiNames;
            zhuotai.order.zhuotaiCode = newOrderZhuotaiCodes;
            if(orderNo == null){//如果没有落单的桌台，不需要生成账单号
                if(Utils.isEmpty(chaifenZhuotais)){//如果本次操作没有拆帐，直接修改
                    queries.push({
                        query: "update pos_order set renshu='"+newRenshu+"', totalPrice='"+newTotalPrice+"',zhuotaiId='"+newOrderZhuotaiIds+"',zhuotaiName='"+newOrderZhuotaiNames+"'," +
                        "zhuotaiCode='"+newOrderZhuotaiCodes+"' where guid='"+zhuotai.orderId+"'"
                    });
                }
            } else {//如果没有落单的桌台，不需要生成账单号
                if(Utils.isEmpty(chaifenZhuotais)) {//如果本次操作没有拆帐，直接修改
                    queries.push({
                        query: "update pos_order set renshu='" + newRenshu + "', totalPrice='" + newTotalPrice + "',code='" + orderNo + "',luoDanTime='" + now + "',zhuotaiId='" + newOrderZhuotaiIds + "'," +
                        "zhuotaiName='" + newOrderZhuotaiNames + "',zhuotaiCode='" + newOrderZhuotaiCodes + "' where guid='" + zhuotai.orderId + "'"
                    });
                } else {
                    queries.push({//如果本次操作有拆帐，只修改账单号，落单时间
                        query: "update pos_order set code='" + orderNo + "',luoDanTime='" + now + "' where guid='" + zhuotai.orderId + "'"
                    });
                }
            }

        }
    }

    //从桌台字符串中去除
    function removeFromArrayStr(arrStr, key){
        var arr = arrStr.split(",");
        Utils.removeFromArray(arr, key);
        return arr.toString();
    }

    //构建拆帐query
    function buildChaizhangQuery(queries, zhuotai, chaifenZhuotais, noMerged, newOrderCodes){
        var newRenshu = zhuotai.order.renshu;
        var newTotalPrice = zhuotai.order.totalPrice;
        var newCodesIndex = newOrderCodes.length -1;
        var newOrderZhuotaiIds = zhuotai.order.zhuotaiId;
        var newOrderZhuotaiCodes = zhuotai.order.zhuotaiCode;
        var newOrderZhuotaiNames = zhuotai.order.zhuotaiName;
        if(noMerged){//如果已经全部拆帐
            queries.push({
                query: "update pos_zhuotai set orderId='"+zhuotai.orderZhuoTai.hisOrderId+"' where guid='"+zhuotai.guid+"'"
            });
            if(zhuotai.orderZhuoTai.luoDanTime != null && zhuotai.orderZhuoTai.hisOrderCode == null){//如果被拆桌台已经落单，但没有订单号
                queries.push({
                    query: "update pos_order set isDeleted='false',renshu='"+zhuotai.orderZhuoTai.renshu+"',totalPrice='"+zhuotai.orderZhuoTai.totalPrice+"'," +
                    "luoDanTime='"+zhuotai.orderZhuoTai.luoDanTime+"',code='"+newOrderCodes[newCodesIndex]+"' where guid='"+zhuotai.orderZhuoTai.hisOrderId+"'"
                });
                queries.push({
                    query: "update pos_order_zhuotai set orderId='"+zhuotai.orderZhuoTai.hisOrderId+"',hisOrderCode='"+newOrderCodes[newCodesIndex]+"' where guid='"+zhuotai.orderZhuoTai.guid+"'"
                });
                newCodesIndex -= 1;
            } else if(zhuotai.orderZhuoTai.luoDanTime != null && zhuotai.orderZhuoTai.hisOrderCode != null) {//如果被拆桌台已经落单，有订单号
                queries.push({
                    query: "update pos_order set isDeleted='false',renshu='"+zhuotai.orderZhuoTai.renshu+"',totalPrice='"+zhuotai.orderZhuoTai.totalPrice+"'," +
                    "luoDanTime='"+zhuotai.orderZhuoTai.luoDanTime+"' where guid='"+zhuotai.orderZhuoTai.hisOrderId+"'"
                });
                queries.push({
                    query: "update pos_order_zhuotai set orderId='"+zhuotai.orderZhuoTai.hisOrderId+"' where guid='"+zhuotai.orderZhuoTai.guid+"'"
                });
            } else {//如果被拆桌台未落单
                queries.push({
                    query: "update pos_order set isDeleted='false',renshu='"+zhuotai.orderZhuoTai.renshu+"',totalPrice='"+zhuotai.orderZhuoTai.totalPrice+"'" +
                    " where guid='"+zhuotai.orderZhuoTai.hisOrderId+"'"
                });
                queries.push({
                    query: "update pos_order_zhuotai set orderId='"+zhuotai.orderZhuoTai.hisOrderId+"' where guid='"+zhuotai.orderZhuoTai.guid+"'"
                });
            }

            queries.push({
                query: "update pos_order_caipin set orderId='"+zhuotai.orderZhuoTai.hisOrderId+"' where orderZhuoTaiId='"+zhuotai.orderZhuoTai.guid+"'"
            });

            queries.push({
                query: "update pos_order set isDeleted='true' where guid='"+zhuotai.orderId+"'"
            });
        }
        //处理被拆桌台
        for(var i=0; i< chaifenZhuotais.length; i++){
            if(!Utils.isEmpty(chaifenZhuotais[i].orderZhuoTai.hisOrderId)){
                newRenshu -= chaifenZhuotais[i].orderZhuoTai.renshu;
                newTotalPrice -= chaifenZhuotais[i].orderZhuoTai.totalPrice;
                newOrderZhuotaiIds = removeFromArrayStr(newOrderZhuotaiIds, chaifenZhuotais[i].guid);
                newOrderZhuotaiCodes = removeFromArrayStr(newOrderZhuotaiCodes, chaifenZhuotais[i].code);
                newOrderZhuotaiNames = removeFromArrayStr(newOrderZhuotaiNames, chaifenZhuotais[i].name);
                queries.push({
                    query: "update pos_zhuotai set orderId='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"' where guid='"+chaifenZhuotais[i].guid+"'"
                });
                if(chaifenZhuotais[i].orderZhuoTai.luoDanTime != null && chaifenZhuotais[i].orderZhuoTai.hisOrderCode == null){//如果被拆桌台已经落单，但没有订单号
                    queries.push({
                        query: "update pos_order set isDeleted='false',renshu='"+chaifenZhuotais[i].orderZhuoTai.renshu+"',totalPrice='"+chaifenZhuotais[i].orderZhuoTai.totalPrice+"'," +
                        "luoDanTime='"+chaifenZhuotais[i].orderZhuoTai.luoDanTime+"',code='"+newOrderCodes[newCodesIndex]+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"'"
                    });
                    queries.push({
                        query: "update pos_order_zhuotai set orderId='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"',hisOrderCode='"+newOrderCodes[newCodesIndex]+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.guid+"'"
                    });
                    newCodesIndex -= 1;
                }else if(chaifenZhuotais[i].orderZhuoTai.luoDanTime != null && chaifenZhuotais[i].orderZhuoTai.hisOrderCode != null) {//如果被拆桌台已经落单，有订单号
                    queries.push({
                        query: "update pos_order set isDeleted='false',renshu='"+chaifenZhuotais[i].orderZhuoTai.renshu+"',totalPrice='"+chaifenZhuotais[i].orderZhuoTai.totalPrice+"'," +
                        "luoDanTime='"+chaifenZhuotais[i].orderZhuoTai.luoDanTime+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"'"
                    });
                    queries.push({
                        query: "update pos_order_zhuotai set orderId='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.guid+"'"
                    });
                } else {//如果被拆桌台未落单
                    queries.push({
                        query: "update pos_order set isDeleted='false',renshu='"+chaifenZhuotais[i].orderZhuoTai.renshu+"',totalPrice='"+chaifenZhuotais[i].orderZhuoTai.totalPrice+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"'"
                    });
                    queries.push({
                        query: "update pos_order_zhuotai set orderId='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"' where guid='"+chaifenZhuotais[i].orderZhuoTai.guid+"'"
                    });
                }

                queries.push({
                    query: "update pos_order_caipin set orderId='"+chaifenZhuotais[i].orderZhuoTai.hisOrderId+"' where orderZhuoTaiId='"+chaifenZhuotais[i].orderZhuoTai.guid+"'"
                });
            } else {
                //todo 以后一次开多台的时候，hisOrderId=null,需要新建order,billing
            }

        }
        //如果还有合并的桌台，重新设置合并账单的人数，价格
        if(!noMerged){
            queries.push({
                query: "update pos_order set renshu='"+newRenshu+"',totalPrice='"+newTotalPrice+"'" +
                ",zhuotaiId='"+newOrderZhuotaiIds+"',zhuotaiName='"+newOrderZhuotaiNames+"',zhuotaiCode='"+newOrderZhuotaiCodes+"' where guid='"+zhuotai.orderId+"'"
            });
        }
    }

    //合并账单是否需要落单
    function needLuodan(zhuotai, bingruZhuotais){
        if(Utils.isEmpty(zhuotai.order.merge)){
            if(!Utils.isEmpty(zhuotai.order.luoDanTime)){
                return true;
            }
            for(var idx in bingruZhuotais){
                if(!Utils.isEmpty(bingruZhuotais[idx].order.luoDanTime)){
                    return true;
                }
            }
        } else {
            if(Utils.isEmpty(zhuotai.order.luoDanTime)){
                for(var idx in bingruZhuotais){
                    if(!Utils.isEmpty(bingruZhuotais[idx].order.luoDanTime)){
                        return true;
                    }
                }
            }
        }
        return false;
    }

    //并帐操作
    function doBingzhang(queries,zhuotai, bingruZhuotais, chaifenZhuotais, cb){
        if(!Utils.isEmpty(bingruZhuotais)){//如果有合并账单
            if(needLuodan(zhuotai, bingruZhuotais)){//合并账单是否需要落单
                //获取新账单的账单号
                var now = new Date();
                UniqueIDService.nextSeq(now, 'order', function (err1, seq, nowdate) {
                    if (err1) {
                        return cb(err1);
                    }
                    var seqNo = nowdate + Utils.formatSeqNo(seq);
                    var zhangDanNo = "ZD" + seqNo;
                    if(Utils.isEmpty(zhuotai.order.merge)){//如果是第一次合并
                        orderDao.query("select distinct merge from pos_order where jieSuanNo is null and merge is not null and isDeleted='false'").then(function(res){
                            zhuotai.order.merge = getMergeNo(res.detail);
                            buildBingzhangQuery(queries, zhuotai, bingruZhuotais,chaifenZhuotais, true,zhangDanNo);
                            cb(null);
                        }, function(err){
                            return cb(err);
                        });
                    } else {//不是第一次合并
                        buildBingzhangQuery(queries, zhuotai, bingruZhuotais,chaifenZhuotais, false,zhangDanNo);
                        cb(null);
                    }
                });
            } else {//合并账单不需要落单
                if(Utils.isEmpty(zhuotai.order.merge)){
                    orderDao.query("select distinct merge from pos_order where jieSuanNo is null and merge is not null and isDeleted='false'").then(function(res){
                        zhuotai.order.merge = getMergeNo(res.detail);
                        buildBingzhangQuery(queries, zhuotai, bingruZhuotais,chaifenZhuotais, true,null);
                        cb(null);
                    }, function(err){
                        return cb(err);
                    });
                } else {
                    buildBingzhangQuery(queries, zhuotai, bingruZhuotais,chaifenZhuotais, false,null);
                    cb(null);
                }
            }
        } else {
            cb(null);
        }
    }

    //获取拆帐时需要的新账单号
    function getChaizhangOrderCodes(zhuotai, chaifenZhuotais, noMerged, cb){
        var orderCodes = [];
        var codeNum = 0;
        if(noMerged && zhuotai.orderZhuoTai.luoDanTime != null && zhuotai.orderZhuoTai.hisOrderCode == null){
            codeNum += 1;
        }
        for(var idx in chaifenZhuotais){
            if(chaifenZhuotais[idx].orderZhuoTai.luoDanTime != null && chaifenZhuotais[idx].orderZhuoTai.hisOrderCode == null){
                codeNum += 1;
            }
        }
        if(codeNum > 0){
            var now = new Date();
            UniqueIDService.nextSeqs(now, 'order', codeNum, function (err, seq, nowdate) {
                if (err) {
                    return cb(err);
                }
                for(var idx in seq){
                    var seqNo = nowdate + Utils.formatSeqNo(seq[idx]);
                    var zhangDanNo = "ZD" + seqNo;
                    orderCodes.push(zhangDanNo);
                }
                cb(null, orderCodes);
            });
        } else {
            cb(null, orderCodes);
        }
    }

    //拆帐操作
    function doChaizhang(queries, zhuotai, chaifenZhuotais, noMerged, cb){
        if(!Utils.isEmpty(chaifenZhuotais)){
            getChaizhangOrderCodes(zhuotai, chaifenZhuotais, noMerged, function(err, newOrderCodes){
                if (err) {
                    return cb(err);
                }
                buildChaizhangQuery(queries, zhuotai, chaifenZhuotais, noMerged, newOrderCodes);
                cb(null);
            });

        } else {
            cb(null);
        }
    }

    /*拆并帐*/
    ZhuotaiService.submitMerge = function (zhuotai, bingruZhuotais, chaifenZhuotais, noMerged, cb) {
        var queries = [];
        doBingzhang(queries, zhuotai, bingruZhuotais, chaifenZhuotais, function(err1){
            if(err1){
                return cb(err1);
            }
            doChaizhang(queries, zhuotai, chaifenZhuotais, noMerged, function(err2){
                if(err2){
                    return cb(err2);
                }
                if(!Utils.isEmpty(queries)){
                    orderDao.queryTransaction(queries).then(function (resultList) {
                        cb(null);
                    }, function (err) {
                        cb(err);
                    });
                } else {
                    cb(null);
                }
            });
        });

    }

    //判断是否存在付款方式
    ZhuotaiService.billingDetailExists = function (jieSuanId, cb) {
        var sql = "select count(*) c from pos_billing_detail where jieSuanId='"+jieSuanId+"' and type='PAY'";
        zhuotaiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if(count > 0){
                return cb(null, true);
            }else {
                return cb(null, false);
            }
        }, function (error) {
            return cb(error);
        });

    };

    //查看已结和未接的的金额和人数
    ZhuotaiService.getBalance = function (area,cb) {
        var areaSql = ''
        if(area){
            areaSql = " and areaGuid ='" + area.guid + "'"
        }
        var sql = "SELECT SUM(renshu) renshu, SUM(totalPrice) totalPrice FROM pos_order WHERE jieSuanTime >= '" + new Date().format("yyyy-MM-dd 09:00:00") + "'" + areaSql;
         //console.log("yijie sql : " + sql);
        zhuotaiDao.query(sql).then(function (yijie) {
            var sql00 = "SELECT SUM(po.renshu) renshu, SUM(po.totalPrice) totalPrice FROM pos_order po, pos_zhuotai pz WHERE po.jieSuanTime is NULL and po.zhuotaiId=pz.guid and po.guid=pz.orderId " + areaSql;
            // console.log("weijie sql : " + sql00);
            zhuotaiDao.query(sql00).then(function (weijie) {
                var sql01 = "SELECT sum(ifnull(shiShou,0) + ifnull(hykZSMoney, 0)) totalPrice, sum(ifnull(zheKouTotal,0) + ifnull(moneyDingE,0) + ifnull(moLing,0) + ifnull(jiFenMoney,0)) zkPrice FROM pos_billing WHERE orderId IN (SELECT guid FROM pos_order WHERE jieSuanTime >= '"  +  new Date().format("yyyy-MM-dd 09:00:00")  + "'" +  areaSql  + ")"  +  " and isFanJieSuan = 0" ;
                 //console.log("shishou sql : " + sql01);
                zhuotaiDao.query(sql01).then(function (shishou) {
                    var obj = {};
                   // obj.yjMoney = yijie.detail[0].totalPrice ? yijie.detail[0].totalPrice :0;
                    obj.yjMoney = shishou.detail[0].totalPrice ? shishou.detail[0].totalPrice :0;
                    obj.wjMoney = weijie.detail[0].totalPrice ? weijie.detail[0].totalPrice :0;
                    obj.rsTotal = yijie.detail[0].renshu + weijie.detail[0].renshu;
                    obj.ssMoney = shishou.detail[0].zkPrice ? shishou.detail[0].zkPrice :0;
                    return cb (null,obj);
                },function(error){
                    cb(error);
                })
            }, function (error) {
                cb(error);
            });
        }, function (error) {
            cb(error);
        });



    }

    //查找所有消费类型下的所有菜品
    ZhuotaiService.getAllCaipinsInConsumeType = function (cb) {
        //var sql = "SELECT a.*, b.caipinNum caipinNum ,b.realCaipinId realCaipinId, b.consumptionId consumptionId FROM pos_caipin a INNER JOIN (SELECT * FROM pos_consumption_caipin WHERE consumptionId in (SELECT guid FROM pos_consumption_type)) b on a.guid = b.realCaipinId";

        var sql = "SELECT a.*, b.caipinNum caipinNum, b.realCaipinId realCaipinId, b.consumptionId consumptionId FROM ( SELECT	c.*, ct.guid AS cpTypeId, " +
            "ct.dishTypeCode AS cpTypeCode, ct.dishTypeName AS cpTypeName, be.dishTypeCode AS bestTypeCode, be.guid AS bestTypeId, be.dishTypeName " +
            "AS bestTypeName, CASE WHEN gq.caipinNum IS NULL THEN - 1 ELSE gq.caipinNum END AS guqingNum FROM 	pos_caipin c LEFT JOIN ( SELECT * " +
            "FROM pos_caipin_guqing WHERE startTime <= datetime('now', 'localtime') AND endTime >= datetime('now', 'localtime') ) gq ON c.guid = " +
            "gq.caipinGuid LEFT JOIN pos_caipin_type ct ON c.typeId = ct.guid LEFT JOIN pos_caipin_type b ON c.typeId = b.guid LEFT JOIN pos_caipin_type " +
            "be ON b.parentId = be.guid WHERE c.isDeleted = 'false' AND c.enabled = 'true')a INNER JOIN ( SELECT * FROM pos_consumption_caipin " +
            "WHERE consumptionId IN ( SELECT guid FROM pos_consumption_type ) ) b ON a.guid = b.realCaipinId ";
        zhuotaiDao.query(sql).then(function (r) {
            return cb (null, r.detail);
        },function(error){
            return cb(error);
        })
    }

    ZhuotaiService.doKaiTaiByScanner = function(zhuotai, order,weixinOrderId, cb){
        var second = [];
        var preConditon = null;
        var orderId = order.guid == null ? orderDao.guid() : order.guid;
        var jieSuanId = Utils.guid()
        if(order.comments === undefined){
            order.comments = null;
        }
        //建立空的账单
        second.push({
            query: "insert into pos_order ( " +
            "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
            " serverId, serverName,serverGuid," +
            " operator, operatorName,operatorCode, mdId, mdCode," +
            " kaiTaiTime, modTime, isDeleted," +
            " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
            " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource,tsAndwm,thirdOrderNo) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?, ?,?, ?,?,?,?,?,?,?,?,?,?)",
            params: [orderId, zhuotai.guid, zhuotai.name, order.renshu, order.comments, order.totalPrice, 1,
                order.serverId, order.serverName,order.serverGuid,
                order.operator, order.operatorName, order.operatorCode, order.mdId, order.mdCode,false,
                BIZCONSTANT.FANJIESUAN_NO, 0, order.canBieCode, order.canbieName,order.canbieId,
                order.areaGuid, order.areaCode, order.areaName, order.zhuotaiCode, jieSuanId,ORDERSOURCE.WEIXIN,'TS',weixinOrderId]
        });

        //建立空的结算单
        second.push({
            query: "insert into pos_billing ( " +
            "guid, orderId) " +
            "values (?, ?)",
            params: [jieSuanId, orderId]
        });

        //建立账单与桌台关联表
        var order_zhuotai_guid = Utils.guid();
        second.push({
            query:"insert into pos_order_zhuotai ( " +
            "guid, orderId, zhuotaiId, zhuotaiCode, zhuotaiName, areaId, renshu, isDeleted, areaCode, areaName, hisOrderId )" +
            " values (?,?,?,?,?,?,?,?,?,?,?)",
            params:[order_zhuotai_guid, orderId, zhuotai.guid, zhuotai.code, zhuotai.name, zhuotai.areaId, order.renshu + "", 'false', order.areaCode, order.areaName, orderId]
        });

        second.push({query: "update pos_zhuotai set orderId='" + orderId + "' where guid='" + zhuotai.guid + "' and orderId is null"});

        second.push({query: "update pos_order_zhuotai set orderId='" + "999-"+orderId + "', zhuotaiId = '" + "999-"+zhuotai.guid +"', zhuotaiCode = '" + "999-"+zhuotai.code +"' where guid='" + order_zhuotai_guid + "'and changes() = 0" });

        zhuotaiDao.queryTransaction(second).then(function (resultList) {
            UploadService.syncZhuotai({"zhuotai":zhuotai,"order":{"id":orderId,"status":1}});
            var order_zhuotaiObj = new OrderZhuotai();
            order_zhuotaiObj.guid = order_zhuotai_guid;
            order_zhuotaiObj.orderId = orderId;
            order_zhuotaiObj.zhuotaiId = zhuotai.guid;
            order_zhuotaiObj.zhuotaiCode = zhuotai.code;
            order_zhuotaiObj.zhuotaiName = zhuotai.name;
            order_zhuotaiObj.areaId = zhuotai.areaId;
            order_zhuotaiObj.areaCode = order.areaCode;
            order_zhuotaiObj.areaName = order.areaName;
            order_zhuotaiObj.renshu = order.renshu;
            order_zhuotaiObj.hisOrderId = orderId;
            zhuotai.orderZhuoTai = order_zhuotaiObj;
            if(resultList.rowsAffected[4] !=0){
                cb('开台失败');
            }else{
                cb(null, orderId);
            }
        }, function (err) {
            cb('开台失败');
        });
    }

    // 竖屏pos function, add by jin
    /**
     * 二维码扫描桌台开台
     * @param zhuotai
     * @param order
     * @param weixinOrderId
     * @param cb
     */
    ZhuotaiService.doScannerKaitai = function (zhuotai, order,weixinOrderId, cb) {
        var first = [];
        var second = [];
        var preConditon = null;
        var orderId = order.guid == null ? orderDao.guid() : order.guid;
        var jieSuanId = Utils.guid()
        if(order.comments === undefined){
            order.comments = null;
        }

        preConditon = { query: "update pos_zhuotai set orderId='" + orderId + "' where guid='" + zhuotai.guid + "' and orderId is null " };
        //check status first
        first.push(preConditon);


        //建立空的账单
        second.push({
            query: "insert into pos_order ( " +
            "guid, zhuotaiId,zhuotaiName, renshu, comments,totalPrice, status," +
            " serverId, serverName,serverGuid," +
            " operator, operatorName,operatorCode, mdId, mdCode," +
            " kaiTaiTime, modTime, isDeleted," +
            " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId," +
            " areaGuid,areaCode,areaName,zhuotaiCode,jieSuanId,ordersource,tsAndwm,thirdOrderNo) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?, ?,?, ?,?,?,?,?,?,?,?,?,?)",
            params: [orderId, zhuotai.guid, zhuotai.name, order.renshu, order.comments, order.totalPrice, 1,
                order.serverId, order.serverName,order.serverGuid,
                order.operator, order.operatorName, order.operatorCode, order.mdId, order.mdCode,false,
                BIZCONSTANT.FANJIESUAN_NO, 0, order.canBieCode, order.canbieName,order.canbieId,
                order.areaGuid, order.areaCode, order.areaName, order.zhuotaiCode, jieSuanId,ORDERSOURCE.WEIXIN,'TS',weixinOrderId]
        });

        //建立空的结算单
        second.push({
            query: "insert into pos_billing ( " +
            "guid, orderId) " +
            "values (?, ?)",
            params: [jieSuanId, orderId]
        });

        //建立账单与桌台关联表
        var order_zhuotai_guid = Utils.guid();
        second.push({
            query:"insert into pos_order_zhuotai ( " +
            "guid, orderId, zhuotaiId, zhuotaiCode, zhuotaiName, areaId, renshu, isDeleted, areaCode, areaName, hisOrderId )" +
            " values (?,?,?,?,?,?,?,?,?,?,?)",
            params:[order_zhuotai_guid, orderId, zhuotai.guid, zhuotai.code, zhuotai.name, zhuotai.areaId, order.renshu + "", 'false', order.areaCode, order.areaName, orderId]
        });

        var allowed = true;

        zhuotaiDao.queryTransaction(first).then(function (resultList) {

            if (resultList.rowsAffected[0] <= 0) {
                cb('开台失败，' + zhuotai.name + '桌台已被占用');
                allowed = false;
            }

        }, function (err) {
            cb('开台失败');
            allowed = false;

        }).then(function () {
            if (allowed) {
                zhuotaiDao.queryTransaction(second).then(function (resultList) {
                    UploadService.syncZhuotai({"zhuotai":zhuotai,"order":{"id":orderId,"status":1}});
                    var order_zhuotaiObj = new OrderZhuotai();
                    order_zhuotaiObj.guid = order_zhuotai_guid;
                    order_zhuotaiObj.orderId = orderId;
                    order_zhuotaiObj.zhuotaiId = zhuotai.guid;
                    order_zhuotaiObj.zhuotaiCode = zhuotai.code;
                    order_zhuotaiObj.zhuotaiName = zhuotai.name;
                    order_zhuotaiObj.areaId = zhuotai.areaId;
                    order_zhuotaiObj.areaCode = order.areaCode;
                    order_zhuotaiObj.areaName = order.areaName;
                    order_zhuotaiObj.renshu = order.renshu;
                    order_zhuotaiObj.hisOrderId = orderId;
                    zhuotai.orderZhuoTai = order_zhuotaiObj;
                    cb(null, orderId);
                }, function (err) {
                    cb(err);

                })
            }

        });
    }

    return ZhuotaiService;
}]);