app.factory('ZhuotaiJieSuanService', ['$q', 'database', function ($q,database) {
    var ZhuotaiJieSuanService = {};

    var areaDao = new DatabaseFuncDelegate($q, database, 'pos_area');

    var zhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_zhuotai');

    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');

    ZhuotaiJieSuanService.getAreas = function(cb){
        areaDao.all("isDeleted='false'and enabled='true' order by areaCode")
            .then(function(rows){
                if(rows.length < 1){
                    return cb({message:LANGUAGECACHE["str_tip_cantfindarea"]});
                }

                return cb(null, rows);
            }, function(error){
                return cb(error);
            });
    };


    function zhuotaiDbToModel(row) {
        var zhuotai = new Zhuotai();
        zhuotai.guid = row.z_guid;
        zhuotai.consumptionId = row.z_consumptionId;
        zhuotai.code = row.z_code;
        zhuotai.name = row.z_name;
        zhuotai.areaId = row.z_areaId;
        zhuotai.quickCode = row.z_quickCode;
        zhuotai.canweishu = row.z_canweishu;
        zhuotai.orderId = row.z_orderId;

        zhuotai.areaCode = row.a_areaCode;
        zhuotai.areaName = row.a_areaName;
        zhuotai.disLDCount = row.disLD;
        if (row.z_orderId != null) {
            zhuotai.order.guid = row.z_orderId;
            zhuotai.order.zhuotaiId = row.o_zhuotaiId;
            zhuotai.order.zhuotaiName = row.o_zhuotaiName;
            zhuotai.order.zhuotaiCode = row.o_zhuotaiCode;
            zhuotai.order.status = row.o_status;
            zhuotai.order.renshu = row.o_renshu;
            zhuotai.order.totalPrice = row.o_totalPrice;
            zhuotai.order.temZkMoney = row.o_temZkMoney;
            zhuotai.order.code = row.o_code;
            zhuotai.order.serverId = row.o_serverId;
            zhuotai.order.serverName = row.o_serverName;
            zhuotai.order.serverGuid = row.o_serverGuid;
            zhuotai.order.operator = row.o_operator;
            zhuotai.order.operatorCode = row.o_operatorCode;
            zhuotai.order.operatorName = row.o_operatorName;
            zhuotai.order.comments = row.o_comments;
            zhuotai.order.kaiTaiTime = row.o_kaiTaiTime;
            zhuotai.order.luoDanTime = row.o_luoDanTime;
            zhuotai.order.modTime = row.o_modTime;
            zhuotai.order.isFanJieSuan=row.o_isFanJieSuan;
            zhuotai.order.canbieId = row.o_canbieId;
            zhuotai.order.canBieCode = row.o_canbieCode;
            zhuotai.order.canbieName = row.o_canbieName;
            zhuotai.order.jieSuanNo = row.o_jieSuanNo;
            zhuotai.order.jieSuanId = row.o_jieSuanId;
            zhuotai.order.jieSuanOperatorId = row.o_jieSuanOperatorId;
            zhuotai.order.ordersource = row.o_ordersource;
            if(!zhuotai.order.ordersource) zhuotai.order.ordersource = "";
            zhuotai.order.mom = row.o_mom;
            if(row.o_merge) {
                zhuotai.order.merge = row.o_merge;
            }
            //zhuotai.order.modTime = row.o_modTime;
            //zhuotai.order.modTime = row.o_modTime;
        }
        if(row.poz_guid) {
            var order_zhuotai = new OrderZhuotai();
            order_zhuotai.guid = row.poz_guid;
            order_zhuotai.orderId = row.poz_orderId;
            order_zhuotai.zhuotaiId = row.poz_zhuotaiId;
            order_zhuotai.zhuotaiCode = row.poz_zhuotaiCode;
            order_zhuotai.zhuotaiName = row.poz_zhuotaiName;
            order_zhuotai.areaId = row.poz_areaId;
            order_zhuotai.areaCode = row.poz_areaCode;
            order_zhuotai.areaName = row.poz_areaName;
            order_zhuotai.renshu = row.poz_renshu;
            order_zhuotai.hisOrderId = row.poz_hisOrderId;
            order_zhuotai.hisOrderCode = row.poz_hisOrderCode;
            order_zhuotai.totalPrice = row.poz_totalPrice;
            order_zhuotai.luoDanTime = row.poz_luoDanTime;
            zhuotai.orderZhuoTai = order_zhuotai;
        }

        return zhuotai;
    }

    //返回所有符合结算条件的桌台数量
    ZhuotaiJieSuanService.getJieSuanZhuotaisCount = function(cb){
        sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            "o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime"+
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId" +
            " where z.isDeleted='false' and z.enabled='true' and orderId is not null and o.luoDanTime is not null order by z.code ";
        zhuotaiDao.query(sql).then(function(result){
            var count = result.detail.length;
            return cb(null, count);
        }, function(error){
            return cb(error);
        });

    };

    //根据选择的厅面区域去查询符合结算条件的桌台数量
    ZhuotaiJieSuanService.getJieSuanZhuotaisCountByArea = function(areaId, cb){
        sql = "select z.guid as z_guid,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status, o.operator as o_operator, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            "o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName, o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime"+
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId" +
            " where z.isDeleted='false' and z.enabled='true' and orderId is not null and o.luoDanTime is not null and z.areaId='"+areaId+"' order by z.code ";
        zhuotaiDao.query(sql).then(function(result){
            var count = result.detail.length;
            return cb(null, count);
        }, function(error){
            return cb(error);
        });
    };

    /**
     * author, peter.shang
     *
     * 是否存在未落单的商品
     *
     */
    ZhuotaiJieSuanService.existsUnconfirmedCaiPin = function(orderId, cb){

        var sql = "select count(1) c, (select luoDanTime from pos_order where guid='" + orderId + "')  luoDanTime from pos_order_caipin where orderId='"+orderId+"' and luodan = 0";
        zhuotaiDao.query(sql).then(function(results){
            var count =  results.detail[0];

            if(count.c == 0 )
                return cb(null,count.luoDanTime);

            return cb({message:LANGUAGECACHE["str_tip_tablehasweiluodan"]}, count.luoDanTime);
        }, function(error){
            return cb(error);
        });
    }

    /***
     * 根据传入的条件获取桌台信息
     * @param parsms
     * @param first
     * @param rows
     * @param cb
     */
    ZhuotaiJieSuanService.getZhuotaisByParams = function (areaId, first, rows, cb) {
        var sql = "select z.guid as z_guid,z.consumptionId as z_consumptionId,z.code as z_code, z.name as z_name, z.areaId as z_areaId, z.quickCode as z_quickCode, z.canweishu as z_canweishu," +
            "z.orderId as z_orderId, o.status as o_status,o.jieSuanOperatorId o_jieSuanOperatorId, o.operator as o_operator,o.operatorCode as o_operatorCode,o.operatorName as o_operatorName, o.renshu as o_renshu, o.modTime as o_modTime, o.code as o_code," +
            "o.totalPrice as o_totalPrice,o.serverId as o_serverId, o.serverName as o_serverName, o.serverGuid as o_serverGuid, o.mom as o_mom, o.kaiTaiTime as o_kaiTaiTime, o.luoDanTime as o_luoDanTime, o.isFanJieSuan as o_isFanJieSuan," +
            "o.canBieId as o_canbieId,o.canBieCode as o_canbieCode,o.canBieName as o_canbieName,o.jieSuanNo as o_jieSuanNo,o.merge as o_merge," +
            "o.zhuotaiId as o_zhuotaiId, o.zhuotaiName as o_zhuotaiName, o.zhuotaiCode as o_zhuotaiCode,o.jieSuanId as o_jieSuanId,o.ordersource as o_ordersource, ifnull(o.temZkMoney, 0) as o_temZkMoney, " +
            "a.guid as a_guid,a.areaCode as a_areaCode,a.areaName as a_areaName ,ifnull(dc.disLDCount,0) disLD , " +
            "poz.guid as poz_guid,poz.orderId as poz_orderId,poz.zhuotaiId as poz_zhuotaiId,poz.zhuotaiCode as poz_zhuotaiCode,poz.zhuotaiName as poz_zhuotaiName," +
            "poz.areaId as poz_areaId,poz.areaCode as poz_areaCode,poz.areaName as poz_areaName,poz.renshu as poz_renshu, poz.hisOrderId as poz_hisOrderId, " +
            "poz.hisOrderCode as poz_hisOrderCode, poz.luoDanTime as poz_luoDanTime, poz.totalPrice as poz_totalPrice " +
            " from pos_zhuotai z left join pos_order o on o.guid = z.orderId left join pos_area a on a.guid= z.areaId " +
            " left join pos_order_zhuotai poz on z.orderId=poz.orderId and z.guid=poz.zhuotaiId " +
            " left join (select orderZhuoTaiId,count(*) disLDCount from pos_order_caipin where luodan=0 GROUP BY orderZhuoTaiId) dc on poz.guid=dc.orderZhuoTaiId " +
            " where z.isDeleted='false' and z.enabled='true' ";

        if (areaId != null && areaId!="") {
            sql = sql + " and z.areaId='" + areaId + "' ";
        }
        //已落单并且有过落单菜品
        sql = sql+" and z.orderId is not null and o.luoDanTime is not null "
        //分页
        sql = sql + " order by CAST(z.code as int) asc limit " + first + "," + rows;
        //console.info("zhuotai query sql : " + sql);
        zhuotaiDao.query(sql).then(function (results) {
            var resultList = [];
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                resultList.push(zhuotaiDbToModel(row));
            }

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });

    };


    return ZhuotaiJieSuanService;
}]);