app.factory("ZNService", ['$q', 'database',"$http", function($q, database,$http){
    var ZNService = {};

    var orderDao = new DatabaseFuncDelegate($q,database,'pos_order');

    //正念-获取token
    ZNService.getZNToken = function(cb) {
        $http({
            method: 'POST',
            url: ZN_URL.API_TOKEN_URL,
            headers: {'Content-Type': 'application/x-www-form-urlencoded'},
            transformRequest: function(obj) {
                var str = [];
                for(var p in obj)
                    str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                return str.join("&");
            },
            data: ZN_TOKEN_PS
        }).success(function(data,header,config,status){
            //console.info(data);
            if(data.access_token){
                cb(null, data.access_token);
            } else {
                cb("无法获取正念token，请重试或者联系客服");
            }
        }).error( function(data,header,config,status){
            cb("无法获取正念token，请重试或者联系客服");
        } );

    }

    //正念-获取商户id
    ZNService.getZNCustomerId = function(orgNo, operator, posSn, cb) {
        ZNService.getZNToken(function(err, token){
            if(err){
                return cb(err);
            }
            $http({
                method: 'POST',
                url: ZN_URL.API_CUSTOMERINFO_URL,
                headers: {"Content-Type":"application/json","Authorization":"Bearer "+token},
                data: {Request:{}, PosStoreCode:orgNo, PosOperater:operator, PosSn:posSn}
            }).success(function(data,header,config,status){
                //console.info(data);
                if(data.Code != "0"){
                    cb("无法获取正念商户信息，请联系客服或稍后重试");
                } else {
                    cb(null,data.Result.CustomerID);
                }
            }).error( function(data,header,config,status){
                //console.info(data);
                cb("无法获取正念商户信息，请联系客服或稍后重试");
            } );
        });

    }

    //正念-退单
    ZNService.cancelOrder = function(orgNo, operator, posSn, orderNo, cb) {
        ZNService.getZNToken(function(err, token){
            if(err){
                return cb(err);
            }
            var reqData = {Request:{DeliveryOrderNo:orderNo,DeliveryOrderNoOld:orderNo, UnitCode:orgNo}, PosStoreCode:orgNo, PosOperater:operator, PosSn:posSn};
            //console.info(reqData);
            $http({
                method: 'POST',
                url: ZN_URL.API_CANCELORDER_URL,
                headers: {"Content-Type":"application/json","Authorization":"Bearer "+token},
                data: reqData
            }).success(function(data,header,config,status){
                if(data.Code != "0"){
                    console.info(data);
                    cb("取消正念卡支付失败，请联系客服或稍后重试");
                } else {
                    cb(null);
                }
            }).error( function(data,header,config,status){
                cb("取消正念卡支付失败，请联系客服或稍后重试");
            } );
        });

    }

    ZNService.updateHuiyuanInfo = function (hyId, Cno, Cname, orderId, cb){
        var sql = "update pos_order set huiYuanId='"+hyId+"',cardNo = '" + Cno + "', cardMemName = '" + Cname +"',thirdPaymentType='zn' where guid = '" + orderId + "'";
        orderDao.query(sql).then(function (ret) {
            cb(null);
        }, function (err) {
            cb(err);
        })
    }

    return ZNService;

}]);