function AutoUpdater(){
	this.latestVersion = null;
	var me = this;
	
	this.checkUpdate = function(callback){
		if(CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS){
			var slice = __CONFIG_SLICE__;
			if(slice == "production") {
				slice = "";
			}
			var path = slice == "" ? "http://ieasy360.coding.me/yunshan/upgrade.json" : "http://ieasy360.coding.me/yunshan-"+slice+"/upgrade.json";
			
			var checkDarkLaunch = function(cb){
				callAjax(DARK_LAUNCH_URL + "?t=1&token=1",
	            function (result) {
	            	debugger;
	                if(result.enable) {
	                	var groupOrg = result.flippingStrategy.initParams.groupOrg;
	                	if(CONSTANTS.SystemConfigs != null) {
		                	var orgid = CONSTANTS.SystemConfigs["MD_ID"].systemConfigValue;
		                	if(groupOrg.indexOf(orgid) != -1) {
		                		return cb(true);
		                	}
							if(groupOrg.indexOf("all") != -1){
								return cb(true);
							}
	                	}
	                	return cb(false);
	                }
	                return cb(false);
	            },"",
	            "GET",
            	function (xhr, status, error, data) {
            		return cb(false);
                });
			};
			
			$.getJSON(path + "?"+(new Date()).getTime(), function( data ) {
				me.latestVersion = data.version;
				var hasVersion = false;
				var regedit = require('regedit')
				regedit.list(['HKCU\\SOFTWARE\\IEASY360\\YUNSHAN\\AutoUpdater'])
				.on('data', function(entry) {
					var currentVer = "0";
					try{
						currentVer = entry.data.values['version'].value;
					}catch(ex){
						
					}
					hasVersion = true;
					var versionMatched = compareVersion(data.version,currentVer) == 1;
					if(versionMatched) {
						checkDarkLaunch(callback);
					}
					else{
						return callback(false);
					}
				})
				.on('finish', function () {
					if(!hasVersion){
						return checkDarkLaunch(callback);
					}
				})
				.on('error', function (error) {
					
				});
			});
		}
		else if(CONTEXT.env == CONSTANTS.EnvConstants.ANDROID){
			this.checkUpdateAndroid(callback);
		}
		else if(CONTEXT.env == CONSTANTS.EnvConstants.IOS){
			this.checkUpdateIOS(callback);
		}
	};
	
	var compareVersion = function(v1, v2){
		v1 = "" + v1;
		v2 = "" + v2;
		var y1 = v1.split(".");
		var y2 = v2.split(".");
		if(parseInt(y1[0]) > parseInt(y2[0])){
			return 1;
		}
		else if(parseInt(y1[0]) < parseInt(y2[0])){
			return -1;
		}
		else{
			if(y1.length > y2.length){
				return 1;
			}
			else if(y1.length < y2.length){
				return -1;
			}
			else{
				if(parseInt(y1[1]) > parseInt(y2[1])){
					return 1;
				}
				else if(parseInt(y1[1]) < parseInt(y2[1])){
					return -1;
				}
				return 0;
			}
		}
	}

	this.checkUpdateAndroid = function(callback){
		// TODO: Android 版本检查更新
	};

	this.checkUpdateIOS = function(callback){
		// TODO: IOS 版本检查更新
	};

	var doReload = function(){
		if(!CONSTANTS.syncingData){
			window.location.reload();
		}
		else{
			window.setTimeout(doReload, 10);
		}
	}
	
	this.updateLater = function(){};
	
	this._formatBytes = function(bytes){
		if (bytes === 0) return '0 B';  
  
        var k = 1024;  
  
        sizes = ['B','KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];  
  
        i = Math.floor(Math.log(bytes) / Math.log(k));  
  
		return (bytes / Math.pow(k, i)).toFixed(2) + ' ' + sizes[i]; 
	};
	
	var adjustInfoPos = function(offset) {
        var c = $(window).width();
        var e = $(window).height();
		
        var g = $(".f2").width();
        var h = $(".f2").height();
		var f = $(".fl").outerHeight();
        $('.maskloader').find(".f2").css({ position: "absolute", left: (c / 2) - (g / 2), top: (e / 2) - (h / 2) - f - offset })
    }

	var _self = this;
	this.running = false;

	this.doUpdate = function(){
		var pingService = ieasyModule.get("PingService");
		if(CONTEXT.env == CONSTANTS.EnvConstants.WINDOWS){
			if(!_self.running) {
				$.maskLoader("show", "系统正在努力升级中...请保持您的网络畅通,不要关闭系统");
			}
			debugger;
			var path = require('path');
			debugger;
			var nwPath = process.execPath;
			debugger;
			var nwDir = path.dirname(nwPath);
			debugger;
			if(nwDir == null ) {
				_self.running = true;
				debugger;
				window.setTimeout(_self.doUpdate, 500);
				debugger;
				console.log("try updating " + new Date());
				return;
			}

			_self.running = false;
			var git = loadDll('update.dll');
			git({command:"pull", path: nwDir, 
					progress: function (data, callback) {
						var info = "系统正在努力升级中...请保持您的网络畅通,不要关闭系统";
						info += "<br/>";
						info += "已接收: " + Math.floor(data.received / data.total * 100) + "% ("+data.received + "/" + data.total + "), 共 " + me._formatBytes(data.bytes);
						$.maskLoader("show", info);
						adjustInfoPos(115);
					}
			}, function (error, result) {
				if (error) {
					Utils.showFailureInfo(error.message);
					pingService.upgrade(error.message);
				}
				if(result == "true"){
					var regedit = require('regedit')
					regedit.putValue({
						'HKCU\\SOFTWARE\\IEASY360\\YUNSHAN\\AutoUpdater': {
							'version': {
								value: ''+me.latestVersion,
								type: 'REG_SZ'
							}
						}
					}, function(err) {
						if(err){
							Utils.showFailureInfo(err.message);
							return;
						}
						window.localStorage.setItem("autoUpdate", "success,"+me.latestVersion);
						window.localStorage.setItem("isUpdatedYet", "1"); 
						doReload();
					});
					pingService.upgrade(result);
				}
				else{
					Utils.showFailureInfo("更新失败, [" + result+"]");
					pingService.upgrade(error.message);
				}
			});
		}
		else if(CONTEXT.env == CONSTANTS.EnvConstants.ANDROID){
			this.doUpdateAndroid();
		}
		else if(CONTEXT.env == CONSTANTS.EnvConstants.IOS){
			this.doUpdateIOS();
		}
	};
	
	this.doUpdateAndroid = function(){
		// android更新
	};

	this.doUpdateIOS = function(){
		// IOS更新
	};
};

function docheckDarkLaunch (){
	callAjax(DARK_LAUNCH_URL + "?t=1&token=1",
		function (result) {
			debugger;
			if(result.enable) {
				var groupOrg = result.flippingStrategy.initParams.groupOrg;
				if(CONSTANTS.SystemConfigs != null) {
					var orgid = CONSTANTS.SystemConfigs["MD_ID"].systemConfigValue;
					if(groupOrg.indexOf(orgid) != -1) {
						window.yunshan.doUpdate();
						return;
					}
					if(groupOrg.indexOf("all") != -1){
						window.yunshan.doUpdate();
						return;
					}
				}
			}else{
			}
			//return cb(false);
		},"",
		"GET",
		function (xhr, status, error, data) {
			return Utils.showFailureInfo(error);
		});
}