﻿var paysdk = { BaseHost: SERVER_HOST.BASE_HOST + API_CONTEXT.PAYCENTER };
//var paysdk = { BaseHost: 'http://192.168.3.34:8081/sop-pos-api' };
paysdk.url = POS_API_URL.PAY_URL;
paysdk.AjaxLogger = null;
paysdk.pay = function (paytype, payrequest, callback, errorcallback)
{
    if (paytype == BIZCONSTANT.PM_ALIPAY)
        return paysdk.aliPay(payrequest, callback, errorcallback);
    if (paytype == BIZCONSTANT.PM_WECHAYPAY)
        return paysdk.wechatPay(payrequest, callback, errorcallback);
    Utils.showFailureInfo('第三方支付类型错误');
    errorcallback();
}

paysdk.rollBack = function (paytype, payrequest, callback, errorcallback) {
    payrequest.remark = '收银主动退款';
    if (paytype == BIZCONSTANT.PM_ALIPAY)
        return paysdk.aliPayRollBack(payrequest, callback, errorcallback);
    if (paytype == BIZCONSTANT.PM_WECHAYPAY)
        return paysdk.wechatRollBackPay(payrequest, callback, errorcallback);
    Utils.showFailureInfo('第三方支付类型错误');
    errorcallback();
}

paysdk.wechatPay = function (payrequest, callback, errorcallback)
{
    payrequest.channel = 3010;//2001;
    paysdk.post(payrequest, callback, errorcallback);
}

paysdk.wechatRollBackPay = function (payrequest, callback, errorcallback) {
    payrequest.channel = 2002;
    paysdk.post(payrequest, callback, errorcallback);
}

paysdk.aliPay = function (payrequest, callback, errorcallback)
{
    payrequest.channel = 1001;
    paysdk.post(payrequest, callback, errorcallback);
}

paysdk.aliPayRollBack = function (payrequest, callback, errorcallback) {
    payrequest.channel = 1002;
    paysdk.post(payrequest, callback, errorcallback);
}

paysdk.post = function (payrequest, callback, errorcallback)
{
    paysdk.json4common(payrequest);

    jQuery.ajax({
        type: "POST",
        url: this.BaseHost + this.url,
        data: JSON.stringify(payrequest),
        contentType: "application/json",
        dataType: "json",
        success: function (result) {
            if (paysdk.AjaxLogger) {
                paysdk.AjaxLogger.log(BIZCONSTANT.POSUSER, '第三方支付', JSON.stringify(payrequest), JSON.stringify(result), this.url);
            }
            callback(result);
        },
        error: function (error, data, errorThrown) {
            Utils.showFailureInfo('交易失败 <br>HTTP 状态：' + error.status + '<br>' + errorThrown);
            if (paysdk.AjaxLogger) {
                paysdk.AjaxLogger.error(error.status, '第三方支付', JSON.stringify(payrequest), errorThrown, this.url);
            }
            if (errorcallback)
                errorcallback();
        }
    });

}

paysdk.json4common = function(data){

    //if (__CONFIG_SLICE__ != 'production')
    //{
    //    data.groupCode = '10177';
    //    data.groupId = '49d653b3-bfdd-41a2-95de-9ba407c8861c';
    //    data.groupIdType = '1';
    //    data.orgId = '646f8860-5645-4bf4-9b94-8a151f0ffc13';
    //    data.shopId = '1';
    //}
    //else
    //{
        data.groupCode = BIZCONSTANT.POSUSER.groupCode;
        data.groupId = BIZCONSTANT.POSUSER.groupId;
        data.groupIdType = BIZCONSTANT.POSUSER.groupIdType;
        data.orgId = BIZCONSTANT.POSUSER.mdId;
        data.shopId = BIZCONSTANT.POSUSER.mdId;
    //    //data.originalOrgId = CONSTANTS.SystemConfigs['hyOrigin'] ? CONSTANTS.SystemConfigs['hyOrigin'].systemConfigValue : '';
    //    //if (!data.originalOrgId || data.originalOrgId.length <= 0) data.originalOrgId = data.orgid;
    //}
    

    data.checkerGuid = BIZCONSTANT.POSUSER.id;
    data.checkerName = BIZCONSTANT.POSUSER.name;
    
    data.deviceType = '1';
    data.deviceCode = BIZCONSTANT.POSUSER.ip;//交易终端号
    data.orderSource = "云膳POS";
    data.orderSubject=BIZCONSTANT.POSUSER.HotelName+ "餐饮消费扫码支付";/** 订单标题, 如“xxx商家xxx门店条码付消费” **/
    data.orderBody = '';
    return data;

}


function Goods()
{
    this.goodsId = null;

    var alipayGoodsId=null;

    // 商品名称
    this.goodsName = null;

    // 商品数量
    this.quantity = 0;

    // 商品价格，此处单位为分
    this.price = 0;

    // 商品类别
    this.goodsCategory = null;

    // 商品详情
    this.body = null;

   
}
// 创建一个商品信息，参数含义分别为商品id（使用国标）、商品名称、商品价格（单位为分）、商品数量
Goods.newInstance=function(goodsId, goodsName, price, quantity) 
{
	var info = new Goods();
	info.goodsId = goodsId;
	info.goodsName = goodsName;
	info.price = price;
	info.quantity = quantity;
    return info;
}

function payRequest()
{
    this.channel;

    /** (必需)订单ID **/
    this.orderId;

    /** (必需)消费者授权码,每分钟更新一次 **/
    this.authCode;

    /** (必需)支付总金额:单位分!! **/
    this.totalAmount;

    /** (必需)机构ID **/
    this.orgId;

    /** (必需)集团ID **/
    this.groupId;

    /** (必需)集团CODE **/
    this.groupCode;

    // *以下非必需，请尽量设值,以便定位问题、经营数据统计分析.

    /** 订单来源， 比如：微信点餐，饿了吗，美团等。 **/
    this.orderSource;

    /** 订单标题, 如“xxx商家xxx门店条码付消费” **/
    this.orderSubject;

    /** 订单描述，可以对交易或商品进行一个详细地描述，比如填写"购买商品3件共20.00元" **/
    this.orderBody;

    /** 收银员编号 **/
    this.checkerGuid;

    /** 收银员姓名 **/
    this.checkerName;

    /** 终端设备类型：1-POS机，2-其他 **/
    this.deviceType;

    /** 终端设备编码：比如POS机号 **/
    this.deviceCode;

    /** 门店ID **/
    this.shopId;

    /**
	 * Goods提供newInstance()方法构造实例。<br>
	 * 参数含义分别为商品id、名称、单价（单位为分!!）、数量
	 * <p>
	 * Goods goods1 = Goods.newInstance("goods_id", "goods_name",1599,1);
	 * </p>
	 */
    /** 商品详情 **/
    //List < Goods > goodsList;
    this.goodsList = [];
}

