var printhelp = {};

printhelp.printtext = function (object, invoice) {
    var template = null;
    var toBePrintingText = null;
    switch (invoice.code) {
        case "R001"://制作单
            template = new ZhiZuoDanTemplate();
            break;
        case "R002"://划单
            template = new HuaDanTemplate();
            break;
        case "R003"://退菜单
            template = new TuiCaiDanTemplate();
            break;
        case "R004"://换台单
            template = new HuanTaiDanTemplate();
            break;
        case "R005"://通知单
            template = new TongZhiDanTemplate();
            break;
        case "001": // 结账单
            template = new JieZhangDanTemplate();
            break;
        case "002": // 客用单
            template = new KeYongDanTemplate();
            break;
        case "003": // 对账单
            template = new NewDuiZhangDanTemplate();// DuiZhangDanTemplate();
            break;
        case "004": // 结班单
            template = new JieBanDanTemplate();
            break;
        case "005"://分单测试
            template = new FDDanTestTemplate();
            break;
        case '006'://品相销售单
            template = new XiaoShouTypeTongJiTemplate();
            break;
        case '008'://收银报表单
            template = new ShouYinReportTemplate();
            break;
        case '009'://外卖配送单
            template = new WMPeiSongTemplate();
            break;
        case "101"://充值通知单
            template = new ChongZhiTemplate();
            break;
        case "102"://发卡通知单
            template = new FaKaTemplate();
            break;
        case "103"://消费通知单
            template = new KaXiaoFeiTemplate();
            break;
        case "104"://充值撤销单
            template = new CheXiaoTemplate();
            break;
        case "105"://积分撤销单
            template = new JifenchexiaoTemplate();
            break;
        case "106"://储值撤销单
            template = new ChuzhichexiaoTemplate();
            break;
        case "000"://测试
            template = new CeshiDanTemplate();
            break;
        case "0000":
            template = new ChuDaCeshiDanTemplate();
            break;
        case "108"://不记名卡充值通知单
            template = new BJMKChongZhiTemplate();
            break;
        case "109"://不记名卡退卡通知单
            template = new BJMKTuiKaTemplate();
            break;
        case "010"://退菜汇总单
            template = new TuiCaiHuiZongTemplate();
            break;
    }

    if (template != null) {
        toBePrintingText = template.parse(object, invoice);
    }

    var printtext = '';
    if (invoice.islable == 'true') {
        printtext = toBePrintingText + PrinterCommand.TSCCommand.Print(1, invoice.number);
    } else {
        var suffix = PrinterCommand.CMD_PageGO(invoice.zouzhi) + PrinterCommand.CMD_CutPage();
        for (var i = 0; i < invoice.number; i++) {
            printtext += toBePrintingText + suffix;
        }
    }
    return printtext;
}

//打印退菜单
printhelp.printtuicai = function (zt, cp, tuicainum, tuicaireason, PrintService,operatorname) {
    if (cp.isScomb == '1' || cp.isScomb == 'true') {
        for (var j in cp.scombCaipins) {
            printhelp.printtuicaidan(cp.scombCaipins[j], zt, cp.scombCaipins[j].num, tuicaireason, PrintService,operatorname)
        }
    } else
        printhelp.printtuicaidan(cp, zt, tuicainum, tuicaireason, PrintService,operatorname)
}

printhelp.printtuicaidan = function (caipin, zhuotai, tuicainum, reason, PrintService, operatorname) {

    var operator = printhelp.getOpertor(operatorname);

    var tuicai = new TuiCaiDanObject();
    tuicai.diancaiyuan = operator.name;
    tuicai.deskNo = zhuotai.name;
    tuicai.dish = caipin;
    tuicai.rs = zhuotai.order.renshu;
    tuicai.tuicainum = tuicainum;
    tuicai.tuicaiReason = reason ? reason.name : "";
    tuicai.operator = printhelp.getOpertor().name;
    tuicai.canbie = zhuotai.order.canbieName;
    tuicai.remark = zhuotai.order.comments;
    tuicai.orderno = zhuotai.order.code;

    var receiptarr = (new printReceipt()).culReceipt(caipin.caipinId, BIZCONSTANT.PRINTINVOCECODE.TUICAIDAN);
    for (var p in receiptarr) {
        var receipt = receiptarr[p];
        var printtext = printhelp.printtext(tuicai, receipt);

        var printjob = new PrinterJob();
        printjob.name = "退菜单";
        printjob.mPrinterId = receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = null;
        printjob.ref = caipin.name;
        printjob.orderId = zhuotai.order.code;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }
}

//打印制作单
printhelp.printzhizuodan = function (zhuotai, caipins, PrintService, operatorname) {
    //debugger;
    for (var i in caipins) {
        var cp = caipins[i];

        if (cp.isScomb == '1' || cp.isScomb == 'true') {
            for (var j in cp.scombCaipins) {
                printcpzhizuodan(zhuotai, cp.scombCaipins[j], PrintService, operatorname);
            }
        } else
            printcpzhizuodan(zhuotai, cp, PrintService, operatorname);
    }
}

function printcpzhizuodan(zhuotai, cp, PrintService, operatorname) {

    var operator = printhelp.getOpertor(operatorname);

    var zhizuodan = new ZhiZuoDanObject();
    zhizuodan.deskNo = zhuotai.name;
    zhizuodan.rs = zhuotai.order.renshu;
    zhizuodan.dish = { name: cp.name, price: cp.price, num: cp.num, unitName: cp.unitName, dishze: cp.num * cp.price, kouweis: cp.kouweis, zuofas: cp.zuofas };
    zhizuodan.diancaiyuan = cp.dianCaiYuanName//operator.name;//zhuotai.order.operatorName;
    zhizuodan.notifyText = cp.chupin;
    zhizuodan.ordercode = zhuotai.order.code;

    var receiptarr = (new printReceipt()).culReceipt(cp.caipinId, BIZCONSTANT.PRINTINVOCECODE.ZHIZUODAN);
    for (var p in receiptarr) {
        var receipt = receiptarr[p];
        var printtext = printhelp.printtext(zhizuodan, receipt);

        var printjob = new PrinterJob();
        printjob.name = "制作单";
        printjob.mPrinterId = receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = receipt.code;
        printjob.ref = cp.name;
        printjob.orderId = zhuotai.order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }

}

//快餐-打印制作单
printhelp.printFastZhizuodan = function (order, caipins, PrintService, operatorname) {
    //debugger;
    for (var i in caipins) {
        var cp = caipins[i];

        if (cp.isScomb == '1' || cp.isScomb == 'true') {
            for (var j in cp.scombCaipins) {
                printfastcpzhizuodan(order, cp.scombCaipins[j], PrintService, operatorname);
            }
        } else
            printfastcpzhizuodan(order, cp, PrintService, operatorname);
    }
}

function printfastcpzhizuodan(order, cp, PrintService, operatorname) {

    var operator = printhelp.getOpertor(operatorname);

    var zhizuodan = new ZhiZuoDanObject();
    zhizuodan.deskNo = order.zhuotaiName;
    zhizuodan.rs = order.renshu;
    zhizuodan.dish = { name: cp.name, price: cp.price, num: cp.num, unitName: cp.unitName, dishze: cp.num * cp.price, kouweis: cp.kouweis, zuofas: cp.zuofas };
    zhizuodan.diancaiyuan = operator.name;//zhuotai.order.operatorName;
    zhizuodan.notifyText = cp.chupin;
    zhizuodan.ordercode = order.code;

    var receiptarr = (new printReceipt()).culReceipt(cp.caipinId, BIZCONSTANT.PRINTINVOCECODE.ZHIZUODAN);
    for (var p in receiptarr) {
        var receipt = receiptarr[p];
        var printtext = printhelp.printtext(zhizuodan, receipt);

        var printjob = new PrinterJob();
        printjob.name = "制作单";
        printjob.mPrinterId = receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = receipt.code;
        printjob.ref = cp.name;
        printjob.orderId = order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }

}

//打印划单
printhelp.printhuadan = function (zhuotai, caipins, PrintService,operatorname) {

    var huadanarr = (new printReceipt()).getPrintersByCaipins(caipins, BIZCONSTANT.PRINTINVOCECODE.HUADAN);
    var operator = printhelp.getOpertor(operatorname);

    var margeScomb = function (ocaipins) {
        caipins = Utils.clone(ocaipins);
        var rtarr = [];
        var scombarr = [];
        for (var i in caipins)
        {
            if (caipins[i].scombParent)
            {
                if (!Utils.arrayFind(scombarr, caipins[i].scombParent.guid, 'guid'))
                {
                    caipins[i].scombParent.scombCaipins.length = 0;
                    scombarr.push(caipins[i].scombParent);
                }
            }
        }

        for(var j in scombarr)
        {
            var sp = scombarr[j];
            for(var tc in caipins)
            {
                if (caipins[tc].scombParent && caipins[tc].scombParent.guid == sp.guid)
                    sp.scombCaipins.push(caipins[tc]);
            }
            rtarr.push(sp);
        }

        for(var ri in caipins)
        {
            if(!caipins[ri].scombParent)
                rtarr.push(caipins[ri]);
        }
        return rtarr;
    }

    for (var c in huadanarr.printids) {
        var data = huadanarr[huadanarr.printids[c]];
        var huadan = new HuaDanObject();

        huadan.deskNo = zhuotai.name;;
        huadan.rs = zhuotai.order.renshu;;
        huadan.canbie = zhuotai.order.canbieName;;
        huadan.company = operator.HotelName;
        huadan.companyphone = operator.HotelTel;
        huadan.companyaddress = operator.HotelAddress;
        huadan.ordertime = new Date().format('yyyy-MM-dd hh:mm');
        huadan.orderno = zhuotai.order.code;
        huadan.dishs = margeScomb(data.caipins);
        huadan.diancaiyuan = operator.name;//zhuotai.order.serverName; //zhuotai.order.operatorName;;
        huadan.remark = zhuotai.order.comments;
        huadan.kaiTaiTime = zhuotai.order.kaiTaiTime;

        var printtext = printhelp.printtext(huadan, data.receipt);

        var printjob = new PrinterJob();
        printjob.name = "划单";
        printjob.mPrinterId = data.receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = data.receipt.code;
        printjob.ref = null;
        printjob.orderId = zhuotai.order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }
}

//换台单
printhelp.printHuanTaiDan = function (order,caipins, oldztname, newztnane, PrintService) {
    var huantai = new HuanTaiObject();
    huantai.oldDeskNo = oldztname;
    huantai.newDeskNo = newztnane;
    huantai.diancaiyuan = BIZCONSTANT.POSUSER.name;
    huantai.rs = order.renshu;
    huantai.operator = printhelp.getOpertor().name;
    huantai.canbie = order.canbieName;
    huantai.remark = order.comments;
    huantai.orderno = order.code;

    var huadanarr = (new printReceipt()).getPrintersByCaipins(caipins, BIZCONSTANT.PRINTINVOCECODE.HUANTAIDAN);
    for (var c in huadanarr.printids) {
        var data = huadanarr[huadanarr.printids[c]];
        var receipt = data.receipt;
        var printtext = printhelp.printtext(huantai, receipt);

        var printjob = new PrinterJob();
        printjob.name = "换台单";
        printjob.mPrinterId = receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = null;
        printjob.ref = null;
        printjob.orderId = order.code;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);

    }

}

//快餐-打印划单
printhelp.printFastHuadan = function (order, caipins, PrintService,operatorname) {

    var huadanarr = (new printReceipt()).getPrintersByCaipins(caipins, BIZCONSTANT.PRINTINVOCECODE.HUADAN);
    var operator = printhelp.getOpertor(operatorname);

    var margeScomb = function (ocaipins) {
        caipins = Utils.clone(ocaipins);
        var rtarr = [];
        var scombarr = [];
        for (var i in caipins) {
            if (caipins[i].scombParent) {
                if (!Utils.arrayFind(scombarr, caipins[i].scombParent.guid, 'guid')) {
                    caipins[i].scombParent.scombCaipins.length = 0;
                    scombarr.push(caipins[i].scombParent);
                }
            }
        }

        for (var j in scombarr) {
            var sp = scombarr[j];
            for (var tc in caipins) {
                if (caipins[tc].scombParent && caipins[tc].scombParent.guid == sp.guid)
                    sp.scombCaipins.push(caipins[tc]);
            }
            rtarr.push(sp);
        }

        for (var ri in caipins) {
            if (!caipins[ri].scombParent)
                rtarr.push(caipins[ri]);
        }
        return rtarr;
    }


    for (var c in huadanarr.printids) {
        var data = huadanarr[huadanarr.printids[c]];
        var huadan = new HuaDanObject();
        debugger;
        huadan.deskNo = order.zhuotaiName;
        huadan.rs = order.renshu;
        huadan.canbie = order.canbieName;
        huadan.company = operator.HotelName;
        huadan.companyphone = operator.HotelTel;
        huadan.companyaddress = operator.HotelAddress;
        huadan.ordertime = new Date().format('yyyy-MM-dd hh:mm');
        huadan.orderno = order.code;
        huadan.dishs = margeScomb(data.caipins);
        huadan.diancaiyuan = operator.name; //zhuotai.order.operatorName;;
        huadan.remark = order.comments;

        var printtext = printhelp.printtext(huadan, data.receipt);

        var printjob = new PrinterJob();
        printjob.name = "划单";
        printjob.mPrinterId = data.receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = data.receipt.code;
        printjob.ref = null;
        printjob.orderId = order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }
}

/**
*单个菜品的通知单
*/
printhelp.printCPNoticDan = function (zhuotai, cp, PrintService, chupin) {
    var zhizuodan = new TongZhiDanObject();
    zhizuodan.deskNo = zhuotai.name;
    zhizuodan.rs = zhuotai.order.renshu;
    zhizuodan.dish = cp ? { name: cp.name, price: cp.price, num: cp.num, unitName: cp.unitName, dishze: cp.num * cp.price, kouweis: cp.kouweis, zuofas: cp.zuofas } : {};
    zhizuodan.diancaiyuan = cp.dianCaiYuanName;//zhuotai.order.operatorName;
    zhizuodan.notifyText = cp?cp.chupin:chupin;
    zhizuodan.operator = printhelp.getOpertor().name;
    zhizuodan.canbie = zhuotai.order.canbieName;
    zhizuodan.remark = zhuotai.order.comments;
    zhizuodan.orderno = zhuotai.order.code;

    var receiptarr = (new printReceipt()).culReceipt(cp.caipinId, BIZCONSTANT.PRINTINVOCECODE.TONGZHIDAN);
    for (var p in receiptarr) {
        var receipt = receiptarr[p];
        var printtext = printhelp.printtext(zhizuodan, receipt);

        var printjob = new PrinterJob();
        printjob.name = "通知单";
        printjob.mPrinterId = receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = receipt.code;
        printjob.ref = null;
        printjob.orderId = zhuotai.order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }
}

/**
*整桌通知单
*/
printhelp.printZZNoticDan = function (caipins, zhuotai, PrintService, chupin) {

    var huadanarr = (new printReceipt()).getPrintersByCaipins(caipins, BIZCONSTANT.PRINTINVOCECODE.TONGZHIDAN);
    for (var c in huadanarr.printids) {
        var data = huadanarr[huadanarr.printids[c]];
        var huadan = new TongZhiDanObject();
        huadan.deskNo = zhuotai.name;
        huadan.rs = zhuotai.order.renshu;
        huadan.dishs = {};
        huadan.diancaiyuan = BIZCONSTANT.POSUSER.name;//zhuotai.order.operatorName;
        huadan.notifyText = chupin;
        huadan.isZhengZhuo = true;
        var printtext = printhelp.printtext(huadan, data.receipt);
        var printjob = new PrinterJob();
        printjob.name = "整桌通知单";
        printjob.mPrinterId = data.receipt.printId;
        printjob.status = 0;
        printjob.errorCount = 0;
        printjob.content = printtext;
        printjob.createTime = null;
        printjob.processing = 0;
        printjob.invoiceCode = data.receipt.code;
        printjob.ref = null;
        printjob.orderId = zhuotai.order.guid;
        printjob.jobNo = null;
        printjob.printTime = null;
        printjob.printCount = 0;
        PrintService.addJob(printjob);
    }
}

//会员消费通知单
printhelp.printKaXiaoFeiDan = function (cardNo, hyName, money, yue, pjh, jfxf, syjf) {
    var xiaofei = new KaXiaoFeiObject();
    xiaofei.cardNo = cardNo;
    xiaofei.hyName = hyName;
    xiaofei.money = money;
    xiaofei.zengsong = 0;
    xiaofei.yue = yue;
    xiaofei.paytype = '会员卡';
    xiaofei.operatorName = BIZCONSTANT.POSUSER.name;
    xiaofei.HotelName = BIZCONSTANT.POSUSER.HotelName;
    xiaofei.PJH = pjh;
    xiaofei.jfxf = jfxf;
    xiaofei.syjf = syjf;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.KAXAIOFEIDAN);
    var printtext = printhelp.printtext(xiaofei, receipt);
    var printjob = new PrinterJob();

    printjob.name = "会员消费通知单";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = '';
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (err != null)
            return Utils.showFailureInfo(err);
        Utils.showSuccessInfo("打印成功");
    });
}

/**
*结账单
 *
 * 账单查询界面以及结算界面都复用此方法
 *
*/
printhelp.printJieZhangDan = function (jieSuan, caipins, ztname, ret, isDuiZhang, cb) {
    //var cz = $rootScope.currentZhuotai;
    var order = jieSuan.order;
    var paylist = jieSuan.payMethodList;
    
    var payitems = [];
    ztname = order.zhuotaiName;
    for (var i in paylist) {
        payitems.push({ payname: paylist[i].name, paymoney: paylist[i].pmMoney() });
    }
    var orderprint = new OrderPrint();

    orderprint.rs = order.renshu;
    orderprint.zhuotai = ztname;

    orderprint.deskNo = ztname;;
    orderprint.canbie = order.canbieName;;
    orderprint.xdtime = order.luoDanTime;
    orderprint.ordercode = order.code;
    orderprint.ordermoney = ret.yingShou;
    orderprint.diancaiyuan = order.serverName;
    orderprint.yingshou = ret.yingShou + ret.youMianPayment; // 此处应收的金额需要 加上 优免后的支付方式的金额

    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;
    orderprint.dishs = Utils.clone(caipins);

    orderprint.DCoperator = order.serverName;
    orderprint.syoperator = BIZCONSTANT.POSUSER.name;
    orderprint.CBname = order.canbieName;
    orderprint.remark = order.comments;

    orderprint.waimaiObj = order.waimaiOrder;

    orderprint.jstime = new Date().format('yyyy-MM-dd hh:mm:ss');
    if (order.jieSuanTime && order.jieSuanTime != '')
    {
        orderprint.jstime = order.jieSuanTime;
    }
    orderprint.pay_items = payitems;
    orderprint.shijimoney = ret.yingShou;
    //计算找零金额
    orderprint.zhaolingmoney = ret.zhaoLing;

    orderprint.printName = "结账单"
    orderprint.hyJiaYouHui = ret.hyJiaYouHui;
    if(isDuiZhang)
        orderprint.printName = "对账单"

    orderprint.ret = ret;//jieSuan.asDuiZhangDanView();

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.JIEZHANGDAN);

    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "结账单";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (err != null){
            cb(err);
            return Utils.showFailureInfo(err);
        }
        if(cb){
            cb(null);
        }else{
            Utils.showSuccessInfo("打印成功");
        }


    });
}

/**
*外卖配送单
*/
printhelp.printWMPeiSong=function(jieSuan, caipins, ret,  cb) {
    //var cz = $rootScope.currentZhuotai;
    var order = jieSuan.order;
    var paylist = jieSuan.payMethodList;
    
    var payitems = [];
    var ztname = order.zhuotaiName;
    for (var i in paylist) {
        payitems.push({ payname: paylist[i].name, paymoney: paylist[i].pmMoney() });
    }
    var orderprint = new OrderPrint();

    orderprint.rs = order.renshu;
    orderprint.zhuotai = ztname;

    orderprint.deskNo = ztname;;
    orderprint.canbie = order.canbieName;;
    orderprint.xdtime = order.luoDanTime;
    orderprint.ordercode = order.code;
    orderprint.ordermoney = ret.yingShou;
    orderprint.diancaiyuan = order.serverName;
    orderprint.yingshou = ret.yingShou + ret.youMianPayment; // 此处应收的金额需要 加上 优免后的支付方式的金额

    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;
    orderprint.dishs = caipins;

    orderprint.DCoperator = order.serverName;
    orderprint.syoperator = BIZCONSTANT.POSUSER.name;
    orderprint.CBname = order.canbieName;
    orderprint.remark = order.comments;
    console.warn('remark:'+order.comments);
    orderprint.waimaiObj = order.waimaiOrder;

    orderprint.jstime = new Date().format('yyyy-MM-dd hh:mm:ss');
    if (order.jieSuanTime && order.jieSuanTime != '')
    {
        orderprint.jstime = order.jieSuanTime;
    }
    orderprint.pay_items = payitems;
    orderprint.shijimoney = ret.yingShou;
    //计算找零金额
    orderprint.zhaolingmoney = ret.zhaoLing;

    orderprint.printName = "外卖配送单"
    orderprint.hyJiaYouHui = ret.hyJiaYouHui;

    orderprint.ret = ret;//jieSuan.asDuiZhangDanView();

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.WMPEISONGDAN);

    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "配送单";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (err != null){
            cb(err);
            return Utils.showFailureInfo(err);
        }
        if(cb){
            cb(null);
        }else{
            Utils.showSuccessInfo("打印成功");
        }


    });
}


/*
*新对账单
*/
printhelp.printNewDuiZhangDan = function (jieSuan, caipins, cb) {
    //var cz = $rootScope.currentZhuotai;
    var order = jieSuan.order;
    var ret = jieSuan.asDuiZhangDanView();
    var paylist = jieSuan.payMethodList;

    var payitems = [];
    var ztname = order.zhuotaiName;
    for (var i in paylist) {
        var payname=paylist[i].name;
        if (paylist[i].fklx == 'thirdCoupon')
            payname += '（' + paylist[i].thirdCouponNum + '）';
        payitems.push({ payname: payname, paymoney: paylist[i].pmMoney() });
    }
    var orderprint = new OrderPrint();

    orderprint.rs = order.renshu;
    orderprint.zhuotai = ztname;

    orderprint.deskNo = ztname;;
    orderprint.canbie = order.canbieName;;
    orderprint.xdtime = order.luoDanTime;
    orderprint.ordercode = order.code;
    orderprint.ordermoney = ret.yingShou;
    orderprint.diancaiyuan = order.serverName;
    orderprint.yingshou = ret.yingShou + ret.youMianPayment; // 此处应收的金额需要 加上 优免后的支付方式的金额

    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;
    orderprint.dishs = Utils.clone(caipins);;

    orderprint.DCoperator = order.serverName;
    orderprint.syoperator = BIZCONSTANT.POSUSER.name;
    orderprint.CBname = order.canbieName;
    orderprint.remark = order.comments;

    orderprint.waimaiObj = order.waimaiOrder;

    orderprint.jstime = new Date().format('yyyy-MM-dd hh:mm:ss');
    if (order.jieSuanTime && order.jieSuanTime != '') {
        orderprint.jstime = order.jieSuanTime;
    }
    orderprint.pay_items = payitems;
    orderprint.shijimoney = ret.yingShou;
    //计算找零金额
    orderprint.zhaolingmoney = ret.zhaoLing;

    orderprint.hyJiaYouHui = ret.hyJiaYouHui;

    orderprint.ret = ret;//jieSuan.asDuiZhangDanView();

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.DUIZHANGDAN);

    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "结账单";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (err != null) {
            cb(err);
            return Utils.showFailureInfo(err);
        }
        if (cb) {
            cb(null);
        } else {
            Utils.showSuccessInfo("打印成功");
        }


    });
}


/*
*对账单（已弃用）
*/
printhelp.printDuiZhangDan = function (caipins, zhuotaiName, order, ret, cb) {
    var orderprint = new DuiZhangDanObject();
    orderprint.rs = order.renshu;
    zhuotaiName = order.zhuotaiName;
    orderprint.zhuotai = zhuotaiName;

    orderprint.deskNo = zhuotaiName;;
    //orderprint.rs = $scope.currentZhuotai.name;
    orderprint.canbie = order.canbieName;;
    orderprint.ordertime = order.luoDanTime;
    orderprint.orderno = order.code;
    orderprint.ordermoney = order.totalPrice;
    orderprint.diancaiyuan = order.serverName;
    orderprint.yingshou = order.getYingShou();
    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;
    orderprint.dishs = caipins;
    orderprint.remark = order.comments;

    orderprint.ret = ret;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.DUIZHANGDAN);
    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "对账单";
    printjob.mPrinterId = receipt.printId;
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo(err);
            Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

/**
*客用单
*/
printhelp.printKeYongDan = function (caipins, zhuotaiName, order, cb) {
    var orderprint = new KeYongDanObject();
    orderprint.dishs = caipins;
    orderprint.rs = order.renshu;
    orderprint.deskNo = order.zhuotaiName;
    orderprint.ordercode = order.code;
    orderprint.canbie = order.canbieName;
    orderprint.diancaiyuan = order.serverName;
    orderprint.operator = printhelp.getOpertor().name;
    orderprint.kaiTaiTime = order.kaiTaiTime;
    orderprint.remark = order.comments;

    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.KEYONGDAN);
    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "客用单";
    printjob.mPrinterId = receipt.printId;
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;
    tickPrinter(printjob, function (err) {
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo(err);
            Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

/**
*积分撤销单
*/
printhelp.printJifenChexiaodan = function (jifen, zhuotaiName, order, cb) {
    var orderprint = new JifenchexiaoTemplate();
    orderprint.dishs = jifen;
    /*orderprint.rs = order.renshu;
    orderprint.deskNo = zhuotaiName;
    orderprint.ordercode = order.code;
    orderprint.canbie = order.canbieName;
    orderprint.diancaiyuan = order.serverName;*/

    orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.JIFENCHEXIAO);
    var printtext = printhelp.printtext(orderprint.dishs, receipt);
    var printjob = new PrinterJob();

    printjob.name = "积分撤销单";
    printjob.mPrinterId = receipt.printId;
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    //printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;
    tickPrinter(printjob, function (err) {
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo(err);
            Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

/**
*储值撤销单
*/
printhelp.printChuzhiChexiaodan = function (chuzhi, zhuotaiName, order, cb) {

    //orderprint.rs = order.renshu;
    //orderprint.deskNo = zhuotaiName;
    //orderprint.ordercode = order.code;
    //orderprint.canbie = order.canbieName;
    //orderprint.diancaiyuan = order.serverName;

    chuzhi.HotelName = BIZCONSTANT.POSUSER.HotelName;
    chuzhi.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    chuzhi.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.CHUZHICHEXIAO);
    var printtext = printhelp.printtext(chuzhi, receipt);
    var printjob = new PrinterJob();

    printjob.name = "储值撤销单";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    //printjob.orderId = order.guid;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;
    tickPrinter(printjob, function (err) {
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo(err);
            Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

/**
*打开钱箱
*/
printhelp.openQianXiang = function (cb)
{
    var printjob = new PrinterJob();

    printjob.name = "打开钱箱";
    printjob.mPrinterId = '';
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = PrinterCommand.CMD_QianXiang();
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = '';
    printjob.ref = null;
    printjob.orderId = '';
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;
    tickPrinter(printjob, function (err) {
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo('打开钱箱失败：'+err);
            //Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

/**
*品项销售
*/
printhelp.printPinXiangXiaoShouDan = function (obj,cb)
{
    //var obj = new XiaoShouTypeTongJiObject();
   

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.PINXIANGDAN);
    var printtext = printhelp.printtext(obj, receipt);
    var printjob = new PrinterJob();

    printjob.name = "品相销售单";
    printjob.mPrinterId = receipt.printId;
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;

    tickPrinter(printjob, function (err) {
        if (err != null){
            cb(err);
            return Utils.showFailureInfo(err);
        }
        if(cb){
            cb(null);
        }else{
            Utils.showSuccessInfo("打印成功");
        }
    });
}

/**
 *退菜汇总单
 */
printhelp.printTuiCaiHuiZonggDan = function (tuicais, cb) {
    var orderprint = new TuiCaiHuiZongDanObject();
    orderprint.tuiDishs = tuicais.tuiDishs;
    orderprint.totalNum = tuicais.totalNum;
    orderprint.totalMoney = tuicais.totalMoney;
    orderprint.caozuoyuan = tuicais.caozuoyuan;
    orderprint.startTime = tuicais.startTime;
    orderprint.endTime = tuicais.endTime;
    orderprint.cpType = tuicais.cpType;
    //orderprint.company = BIZCONSTANT.POSUSER.HotelName;
    //orderprint.companyphone = BIZCONSTANT.POSUSER.HotelTel;
    //orderprint.companyaddress = BIZCONSTANT.POSUSER.HotelAddress;

    var receipt = new printReceipt(BIZCONSTANT.PRINTINVOCECODE.TUICAIHUIZONG);
    var printtext = printhelp.printtext(orderprint, receipt);
    var printjob = new PrinterJob();

    printjob.name = "退菜汇总单";
    printjob.mPrinterId = receipt.printId;
    printjob.status = 0;
    printjob.errorCount = 0;
    printjob.content = printtext;
    printjob.createTime = null;
    printjob.processing = 0;
    printjob.invoiceCode = receipt.code;
    printjob.ref = null;
    printjob.jobNo = null;
    printjob.printTime = null;
    printjob.printCount = 0;
    tickPrinter(printjob, function (err) {
        $.maskLoader("hide");
        if (!cb) {
            if (err != null)
                return Utils.showFailureInfo(err);
            Utils.showSuccessInfo("打印成功");
        }
        else
            cb(err);
    });
}

printhelp.getOpertor = function (username)
{
    var user = Utils.clone(BIZCONSTANT.POSUSER);
    if (!username)
        return user;
    user.name = username;
    return user;
}


String.prototype.replaceAll2 = function (s1, s2) {
    //return this.replace(new RegExp(s1, "gm"), s2);
    return this.split(s1).join(s2);
}

String.prototype.replaceAll = function (s1, s2) {
    try {
        return this.replace(new RegExp(s1, "gm"), s2).replaceAll2(s1, s2);
    } catch (e) {
        console.error(s1+'\n'+s2);
    }
    
    //return this.split(s1).join(s2);
}

String.prototype.Count = function (s) {
    if (this.indexOf(s) < 0)
        return 0;
    return this.split(s).length - 1;
}

Number.prototype.ToString = function (format) {
    if (format == 'C') {
        var v = this;
        v = (Math.round((v - 0) * 100)) / 100;
        v = (v == Math.floor(v)) ? v + ".00" : ((v * 10 == Math.floor(v * 10)) ? v
            + "0" : v);
        v = String(v);
        var ps = v.split('.');
        var whole = ps[0];
        var sub = ps[1] ? '.' + ps[1] : '.00';
        var r = /(\d+)(\d{3})/;
        while (r.test(whole)) {
            whole = whole.replace(r, '$1' + ',' + '$2');
        }
        v = whole + sub;
        return v;
    }
    return this + '';
}

