﻿function WuXianProcessorManager(){}
WuXianProcessorManager.cache = {};
WuXianProcessorManager.get = function(command){
	return WuXianProcessorManager.cache[command];
};
WuXianProcessorManager.register = function(processor){
	WuXianProcessorManager.cache[processor.getCmd()] = processor;
};

function WuXianProcessor(){
	this.process = function(request){};
	this.getCmd = function(){};
}
function wxsuccess(message)
{
    message = (typeof message != "undefined" && message!=null) ? message : '';
    return { success: 1, message: message };
}

function wxerror(message) {
    message = (typeof message != "undefined" && message != null) ? message : '';
    return { success: 0, message: message };
}


// 登陆命令
function LoginWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var op = request.INFO_1; // 工号
		var pass = request.INFO_2; // 密码
	    // TODO:
		debugger;
		ieasyModule.get('AuthService').wxlogin(op, pass).then(function (opinfo) {
		    ieasyModule.get('WuXianService').addWxLogin(opinfo, deviceNo, function (result) {
		        cb(wxsuccess(opinfo.personName));
		    });
		    
		},function (err) {
		    cb(wxerror(err.message));
		});
	};
	this.getCmd = function(){
		return "DL";
	};
};
WuXianProcessorManager.register(new LoginWXProcessor());

// 修改密码
function XGPWDProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        var op = request.INFO_1; // 工号
        var opass = request.INFO_2; // 原密码
        var npass = request.INFO_3; // 新密码
        // TODO:
        ieasyModule.get('WuXianService').XGPwd(deviceNo, op, opass, npass, function (err, opinfo) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(opinfo.personName));
        });
    };
    this.getCmd = function () {
        return "XGMM";
    };
};
WuXianProcessorManager.register(new XGPWDProcessor());


// 开台命令
function KaitaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		var peopleNum = request.INFO_2; // 就餐人数
		var waiterNo = request.INFO_3; // 服务员编号，可能为空
		// TODO:
		ieasyModule.get('WuXianService').kt(deviceNo, zhuotaiNo, peopleNum, waiterNo, function (err,result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result.name));
		});
	};
	this.getCmd = function(){
		return "KT";
	};
};
WuXianProcessorManager.register(new KaitaiWXProcessor());

// 换台命令
function HuantaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var oldZt = request.INFO_1; // 原桌台编号或者名称
		var newZt = request.INFO_2; // 原桌台编号或者名称
		// TODO:
		ieasyModule.get('WuXianService').ht(deviceNo, oldZt, newZt, function (err,successmsg) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(successmsg));
		});
	};
	this.getCmd = function(){
		return "HT";
	};
};
WuXianProcessorManager.register(new HuantaiWXProcessor());

// 修改抬头命令
function UpdateTitleWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		var peopleNum = request.INFO_2; // 就餐人数
		var waiterNo = request.INFO_3; // 服务员编号，可能为空
		// TODO:
		ieasyModule.get('WuXianService').updateTitla(deviceNo,zhuotaiNo,peopleNum,waiterNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
		
	};
	this.getCmd = function(){
		return "XGTT";
	};
};
WuXianProcessorManager.register(new UpdateTitleWXProcessor());

// 空闲桌台汇总命令
function FreeTablesWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		// TODO:
		ieasyModule.get('WuXianService').allKongTai(deviceNo,  function (err,result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
		
	};
	this.getCmd = function(){
		return "KXHZ";
	};
};
WuXianProcessorManager.register(new FreeTablesWXProcessor());

// 台号查询空闲命令
function FreeTableWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		// TODO:
		ieasyModule.get('WuXianService').checkZtStatus(deviceNo, zhuotaiNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
		
	};
	this.getCmd = function(){
		return "THKX";
	};
};
WuXianProcessorManager.register(new FreeTableWXProcessor());

// 预定桌台汇总命令
function YuDingTablesWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allYuDingTai(deviceNo, function (err, result) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(result));
        });

    };
    this.getCmd = function () {
        return "YDHZ";
    };
};
WuXianProcessorManager.register(new YuDingTablesWXProcessor());

// 台号查询空闲命令
function YuDingCheckTableWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        var zhuotaiNo = request.INFO_1; // 桌台编号
        // TODO:
        ieasyModule.get('WuXianService').checkZtStatus(deviceNo, zhuotaiNo, function (err, result) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(result));
        });

    };
    this.getCmd = function () {
        return "THYD";
    };
};
WuXianProcessorManager.register(new YuDingCheckTableWXProcessor());



// 退菜命令
function TuiCaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		var cpNo = request.INFO_2; // 菜品编号
		var tcNum = request.INFO_3; // 退菜数量
		var reasonN = request.INFO_4; // 退菜理由编号
		// TODO:
		ieasyModule.get('WuXianService').tuiCai(deviceNo, zhuotaiNo, cpNo, tcNum, reasonN, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "TC";
	};
};
WuXianProcessorManager.register(new TuiCaiWXProcessor());

function ZZTuiCaiWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        var zhuotaiNo = request.INFO_1; // 桌台编号
        var reasonN = request.INFO_2; // 退菜理由编号
        // TODO:
        ieasyModule.get('WuXianService').ZZtuiCai(deviceNo, zhuotaiNo, reasonN, function (err, result) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(result));
        });
    };
    this.getCmd = function () {
        return "ZZTC";
    };
};
WuXianProcessorManager.register(new ZZTuiCaiWXProcessor());


// 赠菜命令
function ZengCaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		var cpNo = request.INFO_2; // 菜品编号
		var tcNum = request.INFO_3; // 赠送数量
		var reasonN = request.INFO_4; // 赠菜理由编号
		// TODO:
		ieasyModule.get('WuXianService').ZengCai(deviceNo, zhuotaiNo, cpNo, tcNum, reasonN, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "ZC";
	};
};
WuXianProcessorManager.register(new ZengCaiWXProcessor());

// 查询账单命令
function QueryOrderWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		// TODO:
		ieasyModule.get('WuXianService').getOrderInfo(deviceNo, zhuotaiNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "ZDCX";
	};
};
WuXianProcessorManager.register(new QueryOrderWXProcessor());

// 沽清列表命令
function GuQingWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
	    var deviceNo = request ? request.DCJ : ''; // 点菜宝编号
		// TODO:
		ieasyModule.get('WuXianService').GuQingList(deviceNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "GQLB";
	};
};
WuXianProcessorManager.register(new GuQingWXProcessor());

// 打印客看单命令
function PrintKeKanDanWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		// TODO:
		ieasyModule.get('WuXianService').printKYD(deviceNo, zhuotaiNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "DXFD";
	};
};
WuXianProcessorManager.register(new PrintKeKanDanWXProcessor()); 

// 打印账单命令
function PrintZhangDanWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var deviceNo = request.DCJ; // 点菜宝编号
		var zhuotaiNo = request.INFO_1; // 桌台编号
		// TODO:
		ieasyModule.get('WuXianService').printDZD(deviceNo, zhuotaiNo, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		});
	};
	this.getCmd = function(){
		return "DJZD";
	};
};
WuXianProcessorManager.register(new PrintZhangDanWXProcessor()); 


var _temp_DCRUN_LSH_ = [];
// 点菜命令
function DianCaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
	    var deviceNo = request.DCJ; // 点菜宝编号
	    var ztcode = request.ZTID; // 桌台编号
		var peopleNum = request.PPNUM; // 桌台人数
		var ztReq = request.ZTDESC; // 整桌要求，做法编号+口味编号+汉字
		var qcfs = request.ZTBJ; // 整桌起菜方式，空字符串时不处理，默认为“即”
		var dishList = request.DISHES; // 菜品列表, dish格式跟点临时菜一样
		var lsh = request.LSH; // 账单流水号，防止重复下单，空字符串不处理

		var FWY = request.FWY;

		//MEMO_1					5个备注字符串，扩展使用
		//MEMO_2
		//MEMO_3
		//MEMO_4
	    //MEMO_5
	    //debugger;
		//var zlsh = deviceNo + lsh;
		//if (_temp_DCRUN_LSH_.indexOf(zlsh) >= 0)
		//    return cb(wxerror('正在处理..'));
		//_temp_DCRUN_LSH_.push(zlsh);

		ieasyModule.get('WuXianService').dc(deviceNo, FWY, ztcode, peopleNum, ztReq, qcfs, dishList, lsh, function (err, result) {
		    if (err != null)
		        cb(wxerror(err));
		    else
		        cb(wxsuccess(result));
		    //Utils.removeFromArray(_temp_DCRUN_LSH_, zlsh, null);
		});
		
	};
	this.getCmd = function(){
		return "DC";
	};
};
WuXianProcessorManager.register(new DianCaiWXProcessor()); 



// 点临时菜命令
function DianTempCaiWXProcessor(){
	this.base = WuXianProcessor;
	this.base();
	
	this.process = function(request,cb){
		var zhuotaiNo = request.ZTID; // 桌台编号或者名称
		var taocanNo = request.TCID; //	套餐编号，空字符串时表示不是套餐
		var taocanDetails = request.TCMX; // 套餐菜品明细编号，菜品在套餐里面的定位，比如套餐的第几个菜
		var taocanNum = request.TCNUM; // 套餐数量，套餐数量为0，需要通过菜品的实际数量，判断点了几份套餐
		var dishNo = request.CPID; // 菜品编号
		var dishName = request.CPNAME; // 菜品名称
		var dishNum = request.CPNUM; //	菜品数量
		var dishUnit = request.CPNUIT; // 菜品单位，空字符串时不处理
		var dishPrice = request.CPPRICE; //	菜品价格
		var qcfs = request.CPBJ; //	菜品起菜方式，空字符串时不处理，默认为“即”
		var zuofa = request.CPZFYQ; //菜品做法要求，做法编号+口味编号+汉字
		var tiaozhishu = request.CPTZS; //菜品条只数
		var isZs = request.ZSBJ; // 是否赠送
		var lsh = request.LSH; //流水号，防止重复下单，空字符串时不处理
		//MEMO_1					5个备注字符串，扩展使用
		//MEMO_2
		//MEMO_3
		//MEMO_4
		//MEMO_5
		cb(wxerror('不支持点临时菜'));
	};
	this.getCmd = function(){
		return "DLSC";
	};
};
WuXianProcessorManager.register(new DianTempCaiWXProcessor());


// 酒店名称
function HotelNameWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request,cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        cb(wxsuccess(ieasyModule.get('WuXianService').hotelname())); 
    };
    this.getCmd = function () {
        return "HOTELNAME";
    };
};
WuXianProcessorManager.register(new HotelNameWXProcessor());

// 做法口味
function ZFKWWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').zfkw(function (err,list) {
            if(err!=null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })
        
    };
    this.getCmd = function () {
        return "ZFKW";
    };
};
WuXianProcessorManager.register(new ZFKWWXProcessor());


function CaipinTypeWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').caipinTypes(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "CAIPINTYPE";
    };
};
WuXianProcessorManager.register(new CaipinTypeWXProcessor());


function CaipinWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allcaipins(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLCAIPIN";
    };
};
WuXianProcessorManager.register(new CaipinWXProcessor());


function CaipinZuoFaWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allcaipinZuofa(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLCAIPINZUOFA";
    };
};
WuXianProcessorManager.register(new CaipinZuoFaWXProcessor());



function AllScombWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allScombs(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLSCOMB";
    };
};
WuXianProcessorManager.register(new AllScombWXProcessor());


function AllScombCaipinWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allScombCaipins(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLSCOMBCAIPIN";
    };
};
WuXianProcessorManager.register(new AllScombCaipinWXProcessor());

function AllScombBxCaipinWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allScombBxCaipins(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLSCOMBBXCAIPIN";
    };
};
WuXianProcessorManager.register(new AllScombBxCaipinWXProcessor());


function AllTuiCaiReasonWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').alltuicaireasons(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLTUICAIREASON";
    };
};
WuXianProcessorManager.register(new AllTuiCaiReasonWXProcessor());

function AllZhuoTaiWXProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        var deviceNo = request.DCJ; // 点菜宝编号
        // TODO:
        ieasyModule.get('WuXianService').allzhuotai(function (err, list) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(list));
        })

    };
    this.getCmd = function () {
        return "ALLZHUOTAI";
    };
};
WuXianProcessorManager.register(new AllZhuoTaiWXProcessor());

function LoadOrderInfoByOrderNoProcessor() {
	this.base = WuXianProcessor;
	this.base();

	this.process = function (request, cb) {
		var orderNo = request.orderNo; // 账单编号
		// TODO:
		ieasyModule.get('OrderMenuService').getOrderInfoByOrderNo(orderNo, function (err, orderInfo) {
			if (err != null)
				cb(wxerror(err));
			else
				cb(wxsuccess(orderInfo));
		})
	};
	this.getCmd = function () {
		return "ORDERINFOBYNO";
	};
};
WuXianProcessorManager.register(new LoadOrderInfoByOrderNoProcessor());

//雅座消费
function AddYazuoXFProcessor() {
	this.base = WuXianProcessor;
	this.base();

	this.process = function (request, cb) {
		// TODO:
		ieasyModule.get('WuXianService').yazuoXF(request, function (err, orderInfo) {
			if (err != null)
				cb(wxerror(err));
			else
				cb(wxsuccess(orderInfo));
		})
	};
	this.getCmd = function () {
		return "YAZUOXF";
	};
};
WuXianProcessorManager.register(new AddYazuoXFProcessor());


function SynBancisProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        // TODO:
        ieasyModule.get('WuXianService').synBancis(function (err, orderInfo) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(orderInfo));
        })
    };
    this.getCmd = function () {
        return "BANCI";
    };
};
WuXianProcessorManager.register(new SynBancisProcessor());


function SynOrdersProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        // TODO:
        var banciNo = request.BANCI;
        ieasyModule.get('WuXianService').synOrders(banciNo, function (err, orderInfo) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(orderInfo));
        });
    };
    this.getCmd = function () {
        return "BANCIZD";
    };
};
WuXianProcessorManager.register(new SynOrdersProcessor());

function AllCaipinUnitsProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        // TODO:
        ieasyModule.get('WuXianService').allcaipinUnits(function (err, orderInfo) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(orderInfo));
        });
    };
    this.getCmd = function () {
        return "ALLCAIPINUNIT";
    };
};
WuXianProcessorManager.register(new AllCaipinUnitsProcessor());

function AllAreaProcessor() {
    this.base = WuXianProcessor;
    this.base();

    this.process = function (request, cb) {
        // TODO:
        ieasyModule.get('WuXianService').allArea(function (err, orderInfo) {
            if (err != null)
                cb(wxerror(err));
            else
                cb(wxsuccess(orderInfo));
        });
    };
    this.getCmd = function () {
        return "ALLAREA";
    };
};
WuXianProcessorManager.register(new AllAreaProcessor());

