app.factory('DiancaiService', ['$q', "$rootScope", 'database', 'PrintService', 'UploadService', 'GuqingService','UniqueIDService',
    function ($q, $rootScope, database, PrintService, UploadService, GuqingService, UniqueIDService) {
    var DiancaiService = {};

    var caipinTypeDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_type');
    var caipinDao = new DatabaseFuncDelegate($q, database, 'pos_caipin');
    var caipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_zuofa');
    var orderDao = new DatabaseFuncDelegate($q, database, 'pos_order');
    var orderCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin');
    var orderScombCaipinDao = new DatabaseFuncDelegate($q, database, 'pos_order_scomb_caipin');
    var kouweiDao = new DatabaseFuncDelegate($q, database, 'pos_kouwei');
    var zuofaTypeDao = new DatabaseFuncDelegate($q, database, 'pos_zuofa_type');
    var zuofaDao = new DatabaseFuncDelegate($q, database, 'pos_zuofa');
    var orderCaipinZuofaDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zuofa');
    var orderCaipinKouweiDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_kouwei');
    var tuicaiReasonDao = new DatabaseFuncDelegate($q, database, 'pos_tuicai_reason');
    var zengsongReasonDao = new DatabaseFuncDelegate($q, database, 'pos_zengsong_reason');
    var orderCaipinZengsongDao = new DatabaseFuncDelegate($q, database, 'pos_order_caipin_zengsong');
    var caipinUnitDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_unit');
    var dishGuqingDao = new DatabaseFuncDelegate($q, database, 'pos_caipin_guqing');
    var orderZhuotaiDao = new DatabaseFuncDelegate($q, database, 'pos_order_zhuotai');

    var curUser = $rootScope.curUser;

    /*获取一级菜品类别*/
    DiancaiService.getParentCaipinTypesCount = function (cb) {
        var sql = "select count(guid) c from pos_caipin_type" +
            " where isDeleted='false' and parentId is null";
        caipinTypeDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if (count < 1) {
                return cb({ message: "找不到菜品大类，请联系我司相关的工作人员" });
            }
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getParentCaipinTypes = function (first, rows, cb) {
        caipinTypeDao.all("isDeleted='false' and parentId is null order by dishTypeCode limit " + first + "," + rows)
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error);
            });
    };

    /*获取二级菜品类别*/
    DiancaiService.getChildCaipinTypesCount = function (parentId, cb) {
        var sql = "select count(guid) c from pos_caipin_type" +
            " where isDeleted='false' and parentId='" + parentId + "'";
        caipinTypeDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getChildCaipinTypes = function (parentId, first, rows, cb) {
        caipinTypeDao.all("isDeleted='false' and parentId='" + parentId + "' order by dishTypeCode limit " + first + "," + rows)
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error);
            });
    };

    /*根据菜品类别获取菜品列表*/
    DiancaiService.getCaipinsCountByType = function (typeId, cb, praentTypeId) {
        var sql;
        if (praentTypeId == null) {
            sql = "select count(guid) c from pos_caipin" +
            " where isDeleted='false' and enabled='true' and typeId='" + typeId + "'";
        }
        else {
            var sql = "select count(cp.guid) c from pos_caipin cp " +
               " left join pos_caipin_type ct on cp.typeId=ct.guid " +
               " WHERE cp.isDeleted = 'false'  AND cp.enabled = 'true' and ct.parentId='" + praentTypeId + "'";
        }
        caipinDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getCaipinsByType = function (typeId, first, rows, cb, parentTypeId) {
        /*  JP
        16-02-25 
        加入了菜品估清数量 */

        var sql = "select c.*,ct.guid as cpTypeId,ct.dishTypeCode as cpTypeCode,ct.dishTypeName as cpTypeName, be.dishTypeCode AS bestTypeCode, be.guid AS bestTypeId, be.dishTypeName AS bestTypeName ,case  when gq.caipinNum is NULL then -1 else gq.caipinNum end as guqingNum " +
               " from pos_caipin c left join ( SELECT * FROM pos_caipin_guqing  WHERE  startTime <= datetime('now','localtime') " +
               " and endTime >= datetime('now','localtime')) gq on c.guid=gq.caipinGuid " +
               "left join pos_caipin_type ct on c.typeId= ct.guid " +
                "left join pos_caipin_type b on c.typeId=b.guid " +
                "left join pos_caipin_type be on b.parentId=be.guid " +
               " where c.isDeleted='false' and c.enabled='true' ";
        if (parentTypeId == null) {
            sql +=  (Utils.isEmpty(typeId) ? "" : (" and typeId='" + typeId + "'"));
        } else {
            sql += " and ct.parentId='" + parentTypeId + "' ";
        }

        sql += " order by code ";
        sql = sql + (rows > 0 ? ("limit " + first + "," + rows) : "");


        caipinDao.query(sql)
            .then(function (results) {
                console.log(results);
                var resultList = [];
                for (var i = 0; i < results.detail.length; i++) {
                    resultList.push(results.detail[i]);
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
        /* */
        //caipinDao.all("isDeleted='false' and enabled='true' and typeId='"+typeId+"' order by code limit "+ first +","+ rows)
        //    .then(function (results) {
        //        return cb(null, results);
        //    }, function(error){
        //        return cb(error);
        //    });
    };

    /*获取菜品关联做法*/
    DiancaiService.getCaipinZuofasCount = function (caipinId, cb) {
        var sql = "select count(guid) c from pos_caipin_zuofa" +
            " where isDeleted='false' and caipinId='" + caipinId + "'";
        caipinDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getCaipinZuofas = function (caipinId, first, rows, cb) {
        caipinZuofaDao.all("isDeleted='false' and caipinId='" + caipinId + "' limit " + first + "," + rows)
            .then(function (results) {
                return cb(null, results);
            }, function (error) {
                return cb(error);
            });
    };

    //快餐-获取所有菜品关联做法，组装成普通做法model
    DiancaiService.fastGetAllCaipinZuofas = function (caipinId, cb) {
        caipinZuofaDao.all("isDeleted='false' and caipinId='" + caipinId + "'")
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    var zuofa = new Zuofa();
                    zuofa.guid = row.zuofaId;
                    zuofa.name = row.zuofaName;
                    zuofa.price = row.jiajiaPrice;
                    zuofa.jiajiaType = row.jiajiaType;
                    zuofa.isDeleted = row.isDeleted;
                    resultList.push(zuofa);
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };


    DiancaiService.getCaipinRelateZuofasCount = function (caipinIds, cb) {

        var sql = "select caipinid,count(*) as zfNum from pos_caipin_zuofa" +
            " where isDeleted='false' and caipinId in (" + caipinIds + ") group by caipinId";
        caipinDao.query(sql).then(function (result) {
            var resultList = result.detail;
            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });
    };

    /*获取菜品关联多单位*/
    DiancaiService.getCaipinUnitCount = function (caipinId, cb) {
        var sql = "select count(guid) c from pos_caipin_unit" +
            " where isDeleted='false' and caipinId='" + caipinId + "'";
        caipinUnitDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if (count) count++;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getCaipinUnits = function (caipinId, first, rows, cb) {

        caipinDao.getById(caipinId, 'guid').then(function (dish) {
            caipinUnitDao.all("isDeleted='false' and caipinId='" + caipinId + "' limit " + first + "," + rows)
            .then(function (results) {
                //第一页，加入默认菜品单位
                if (!first && dish) {
                    if (dish.salePrice) {
                        var firstResults = [{ guid: dish.guid, caipinId: dish.caipinId, unitId: dish.unitId, unitName: dish.unitName, price: dish.salePrice, isDeleted: dish.isDeleted }];
                    } else {
                        var firstResults = [{ guid: dish.guid, caipinId: dish.caipinId, unitId: dish.unitId, unitName: dish.unitName, price: dish.price, isDeleted: dish.isDeleted }];
                    }

                    results = firstResults.concat(results)
                }
                //console.log("测试多单位服务："+results)
                return cb(null, results);
            }, function (error) {
                return cb(error);
            });

        });


    };
    /* 修改ordercaipin 的单位 */
    DiancaiService.updateCaipinUnit = function (orderCaipin, operator, unit, cb) {
        orderCaipin.unitName = unit.unitName;
        orderCaipin.operator = operator;
        orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        var tableName = "pos_order_caipin";
        if(orderCaipin.isScomb == "true") {
            tableName = "pos_order_scomb_caipin";
        }
        queries.push({
            query: "update " + tableName +
            " set unitName='" + orderCaipin.unitName + "',price='" + unit.price + "',operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
            " where guid='" + orderCaipin.guid + "'"
        });
        console.info("queries : " +　JSON.stringify(queries));
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };

    /*获取当前订单关联的菜品列表，包含口味，做法，
    *根据luodan字段获取未落单或者已落单数据,如果luodan!=0,1查询所有
    * 1.获取指定订单的所有的菜品，包括 退菜菜品。 会构建退菜菜品和原始菜品的关系
    * */
    DiancaiService.getOrderCaipinsByLuodan = function (orderId,luodan, cb, zhuotaiId) {
        var conditionSql;
        if(!!zhuotaiId){
            conditionSql = "and o.orderZhuoTaiId = '" + zhuotaiId + "'";
        }else{
            conditionSql = '';
        }

        var sql = "select o.guid as o_guid, o.orderId as o_orderId, o.orderZhuoTaiId as o_orderZhuoTaiId, o.orgNum as o_orgNum, o.mom as o_mom, o.caipinId as o_caipinId,o.caipinCode as o_caipinCode, o.name as o_name, o.price as o_price, o.costprice o_costprice, o.num as o_num," +
            "ifnull(o.tuiNum,0) as o_tuiNum,o.tuicaiReasonId as o_tuicaiReasonId,o.tuicaiReasonName as o_tuicaiReasonName, ifnull(o.zengNum,0) as o_zengNum, o.unitName as o_unitName, o.printId as o_printId, o.printName as o_printName, o.chupin as o_chupin," +
            "o.hyPrice as o_hyPrice, o.caiwuTypeName as o_caiwuTypeName, o.caiwuTypeId as o_caiwuTypeId,  o.firstGuid as o_firstGuid, o.priceChange as o_priceChange,o.tiaoZhiNum as o_tiaoZhiNum, " +
            "  o.customize as o_customize,o.unitId as o_unitId,o.cpdept as o_cpdept,o.cpdeptName as o_cpdeptName," +
            "o.luodan as o_luodan,o.minAgio as o_minAgio, o.danPinBiLiZheKou as o_danPinBiLiZheKou, o.danPinJineZheKou as o_danPinJineZheKou," +
            "o.danPinZheKou as o_danPinZheKou,o.dianCaiYuan as o_dianCaiYuan,o.dianCaiYuanName as o_dianCaiYuanName, o.operator as o_operator," +
            "o.dianCaiTime as o_dianCaiTime,o.luoDanTime as o_luoDanTime,o.chuPinTime as o_chuPinTime, o.modTime as o_modTime,o.isScomb as o_isScomb," +
            "o.parentId as o_parentId,o.caipinTypeId as o_caipinTypeId,o.caipinTypeCode as o_caipinTypeCode,o.caipinTypeName as o_caipinTypeName,o.bestTypeId as o_bestTypeId, o.bestTypeCode as o_bestTypeCode, o.bestTypeName as o_bestTypeName, " +
            "k.guid as k_guid, k.kwId as k_kwId, k.name as k_name, k.operator as k_operator, k.modTime as k_modTime," +
            "z.guid as z_guid, z.zuofaId as z_zuofaId, z.name as z_name, z.typeId as z_typeId, z.price as z_price, z.jiajiaType as z_jiajiaType," +
            "z.operator as z_operator, z.modTime as z_modTime,o.needweigh as needweigh, " +
            "osc.guid AS osc_guid,osc.caipinId AS osc_caipinId,	osc.name AS osc_name,	osc.price AS osc_price,	osc.num AS osc_num," +
            "osc.tuiNum AS osc_tuiNum,osc.zengNum AS osc_zengNum,	osc.unitName AS osc_unitName,osc.printId AS osc_printId," +
            "osc.printName AS osc_printName,osc.chupin AS osc_chupin,osc.luodan AS osc_luodan,	osc.minAgio AS osc_minAgio," +
            "osc.danPinBiLiZheKou AS osc_danPinBiLiZheKou,	osc.danPinJineZheKou AS osc_danPinJineZheKou," +
            "osc.danPinZheKou AS osc_danPinZheKou,	osc.dianCaiYuan AS osc_dianCaiYuan,	osc.dianCaiYuanName AS osc_dianCaiYuanName," +
            "osc.operator AS osc_operator,osc.dianCaiTime AS osc_dianCaiTime,	osc.luoDanTime AS osc_luoDanTime," +
            "osc.chuPinTime AS osc_chuPinTime,	osc.modTime AS osc_modTime,osc.parentId as osc_parentId,osck.guid AS osck_guid,	" +
            "osck.kwId AS osck_kwId,osck.name AS osck_name,osck.operator AS osck_operator,osck.modTime AS osck_modTime,oscz.guid AS oscz_guid," +
            "osc.tuicaiReasonId AS osc_tuicaiReasonId,osc.tuicaiReasonName AS osc_tuicaiReasonName,osck.isScomb as osck_isScomb,osck.orderScombCaipinId as osck_orderScombCaipinId," +
            "oscz.zuofaId AS oscz_zuofaId,oscz.name AS oscz_name,oscz.typeId AS oscz_typeId,oscz.price AS oscz_price," +
            "oscz.jiajiaType AS oscz_jiajiaType,oscz.operator AS oscz_operator,	oscz.modTime AS oscz_modTime," +
            "oscz.isScomb as oscz_isScomb,oscz.orderScombCaipinId as oscz_orderScombCaipinId," +
            "osc.needweigh AS osc_needweigh,osc.scombMainCaipinId as osc_scombMainCaipinId ,ozs.reasonId as ozs_reasonId,ozs.reasonName as ozs_reasonName" +
            " from pos_order_caipin o" +
            " left join pos_order_caipin_kouwei k on k.orderCaipinId = o.guid and (k.isScomb='false' or k.isScomb is null )" +
            " left join pos_order_caipin_zuofa z on z.orderCaipinId = o.guid and (z.isScomb='false' or z.isScomb is null )" +
            " left join pos_order_caipin_zengsong ozs on o.guid=ozs.orderCaipinId " +
            " left join pos_order_scomb_caipin osc on  osc.orderCaipinId=o.guid " +
            " LEFT JOIN pos_order_caipin_kouwei osck ON osck.orderScombCaipinId = osc.guid and osck.orderCaipinId=o.guid " +
            " LEFT JOIN pos_order_caipin_zuofa oscz ON oscz.orderScombCaipinId = osc.guid and oscz.orderCaipinId=o.guid " +
            " where o.orderId='" + orderId + "'" + conditionSql;
        if(luodan == 0 || luodan == 1){
            sql += " and o.luodan='" + luodan + "'";
        }
        sql += " order by o.modTime";
        orderCaipinDao.query(sql).then(function (results) {
            var resultList = [];
            //退菜的菜品
            var tuiCaiMap = {};
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                var orderCaipin = Utils.arrayFind(resultList, row.o_guid, "guid");

                if (orderCaipin == null) {
                    if (row.o_parentId)
                    {
                        try {
                            orderCaipin = Utils.arrayFind(tuiCaiMap[row.o_parentId], row.o_guid, "guid");
                        } catch (e) { }
                        
                    }
                    if (orderCaipin == null) {
                        orderCaipin = new OrderCaipin();
                        orderCaipin.guid = row.o_guid;
                        orderCaipin.orderId = row.o_orderId;
                        orderCaipin.caipinId = row.o_caipinId;
                        orderCaipin.caipinCode = row.o_caipinCode;
                        orderCaipin.name = row.o_name;
                        orderCaipin.price = row.o_price;
                        orderCaipin.costprice = row.o_costprice;
                        orderCaipin.num = row.o_num;
                        orderCaipin.tuiNum = row.o_tuiNum;
                        orderCaipin.zengNum = row.o_zengNum;
                        orderCaipin.unitName = row.o_unitName;
                        orderCaipin.printId = row.o_printId;
                        orderCaipin.printName = row.o_printName;
                        orderCaipin.chupin = row.o_chupin;
                        orderCaipin.minAgio = row.o_minAgio;
                        orderCaipin.danPinBiLiZheKou = row.o_danPinBiLiZheKou;
                        orderCaipin.danPinJineZheKou = row.o_danPinJineZheKou;
                        orderCaipin.danPinZheKou = row.o_danPinZheKou;
                        orderCaipin.luodan = row.o_luodan;
                        orderCaipin.dianCaiYuan = row.o_dianCaiYuan;
                        orderCaipin.dianCaiYuanName = row.o_dianCaiYuanName;
                        orderCaipin.dianCaiTime = row.o_dianCaiTime;
                        orderCaipin.luoDanTime = row.o_luoDanTime;
                        orderCaipin.chuPinTime = row.o_chuPinTime;
                        orderCaipin.operator = row.o_operator;
                        orderCaipin.modTime = row.o_modTime;
                        orderCaipin.parentId = row.o_parentId;
                        orderCaipin.needweigh = row.needweigh;
                        orderCaipin.isScomb = row.o_isScomb;
                        orderCaipin.caipinTypeCode = row.o_caipinTypeCode;
                        orderCaipin.caipinTypeId = row.o_caipinTypeId;
                        orderCaipin.caipinTypeName = row.o_caipinTypeName;
                        orderCaipin.orderZhuoTaiId = row.o_orderZhuoTaiId;
                        orderCaipin.orgNum = row.o_orgNum;
                        orderCaipin.mom = row.o_mom;


                        orderCaipin.dianCaiYuanName = row.o_dianCaiYuanName;
                        orderCaipin.hyPrice = row.o_hyPrice;
                        orderCaipin.caiwuTypeName = row.o_caiwuTypeName;
                        orderCaipin.caiwuTypeId = row.o_caiwuTypeId;
                        orderCaipin.firstGuid = row.o_firstGuid;
                        orderCaipin.priceChange = row.o_priceChange;
                        orderCaipin.tiaoZhiNum = row.o_tiaoZhiNum;

                        orderCaipin.bestTypeId = row.o_bestTypeId;
                        orderCaipin.bestTypeCode = row.o_bestTypeCode;
                        orderCaipin.bestTypeName = row.o_bestTypeName;

                        orderCaipin.customize = row.o_customize;
                        orderCaipin.unitId = row.o_unitId;
                        orderCaipin.cpdept = row.o_cpdept;
                        orderCaipin.cpdeptName = row.o_cpdeptName;
                        orderCaipin.tuicaiReasonId = row.o_tuicaiReasonId;
                        orderCaipin.tuicaiReasonName = row.o_tuicaiReasonName;
                        orderCaipin.zengReasonId = row.ozs_reasonId;
                        orderCaipin.zengReasonName = row.ozs_reasonName;
                    }
                    if (!orderCaipin.isTui())
                        resultList.push(orderCaipin);
                    else {
                        var ocp = tuiCaiMap[orderCaipin.parentId];
                        if (_.isNil(ocp))
                            tuiCaiMap[orderCaipin.parentId] = [orderCaipin]
                        else {
                            Utils.arrayFind(ocp, orderCaipin.guid, "guid") == null ? ocp.push(orderCaipin) : null;
                        }


                    }

                }
                if (row.k_guid != null) {
                    var orderCaipinKouwei = Utils.arrayFind(orderCaipin.kouweis, row.k_guid, "guid");
                    if (orderCaipinKouwei == null) {
                        orderCaipinKouwei = new OrderCaipinKouwei();
                        orderCaipinKouwei.guid = row.k_guid;
                        orderCaipinKouwei.orderCaipinId = row.o_guid;
                        orderCaipinKouwei.kwId = row.k_kwId;
                        orderCaipinKouwei.name = row.k_name;
                        orderCaipinKouwei.operator = row.k_operator;
                        orderCaipinKouwei.modTime = row.k_modTime;
                        orderCaipin.kouweis.push(orderCaipinKouwei);
                    }
                }
                if (row.z_guid != null) {
                    var orderCaipinZuofa = Utils.arrayFind(orderCaipin.zuofas, row.z_guid, "guid");
                    if (orderCaipinZuofa == null) {
                        orderCaipinZuofa = new OrderCaipinZuofa();
                        orderCaipinZuofa.guid = row.z_guid;
                        orderCaipinZuofa.orderCaipinId = row.o_guid;
                        orderCaipinZuofa.zuofaId = row.z_zuofaId;
                        orderCaipinZuofa.name = row.z_name;
                        orderCaipinZuofa.typeId = row.z_typeId;
                        orderCaipinZuofa.price = row.z_price;
                        orderCaipinZuofa.jiajiaType = row.z_jiajiaType;
                        orderCaipinZuofa.operator = row.z_operator;
                        orderCaipinZuofa.modTime = row.z_modTime;
                        orderCaipinZuofa.parentCaiPin = orderCaipin;
                        orderCaipin.zuofas.push(orderCaipinZuofa);
                    }
                }


                if (row.osc_guid != null) {
                    var orderScombCaipin = Utils.arrayFind(orderCaipin.scombCaipins, row.osc_guid, "guid");
                    if (null == orderScombCaipin) {
                        orderScombCaipin = new OrderCaipin();
                        orderScombCaipin.guid = row.osc_guid;
                        orderScombCaipin.orderCaipinId = row.o_guid;
                        orderScombCaipin.orderId = row.o_orderId;
                        orderScombCaipin.caipinId = row.osc_caipinId;
                        orderScombCaipin.name = row.osc_name;
                        orderScombCaipin.price = row.osc_price;
                        orderScombCaipin.num = row.osc_num;
                        orderScombCaipin.tuiNum = row.osc_tuiNum;
                        orderScombCaipin.zengNum = row.osc_zengNum;
                        orderScombCaipin.unitName = row.osc_unitName;
                        orderScombCaipin.printId = row.osc_printId;
                        orderScombCaipin.printName = row.osc_printName;
                        orderScombCaipin.chupin = row.osc_chupin;
                        orderScombCaipin.minAgio = row.osc_minAgio;
                        orderScombCaipin.danPinBiLiZheKou = row.osc_danPinBiLiZheKou;
                        orderScombCaipin.danPinJineZheKou = row.osc_danPinJineZheKou;
                        orderScombCaipin.danPinZheKou = row.osc_danPinZheKou;
                        orderScombCaipin.luodan = row.osc_luodan;
                        orderScombCaipin.dianCaiYuan = row.osc_dianCaiYuan;
                        orderScombCaipin.dianCaiYuanName = row.osc_dianCaiYuanName;
                        orderScombCaipin.dianCaiTime = row.osc_dianCaiTime;
                        orderScombCaipin.luoDanTime = row.osc_luoDanTime;
                        orderScombCaipin.chuPinTime = row.osc_chuPinTime;
                        orderScombCaipin.operator = row.osc_operator;
                        orderScombCaipin.modTime = row.osc_modTime;
                        orderScombCaipin.parentId = row.osc_parentId;
                        orderScombCaipin.needweigh = row.osc_needweigh;
                        orderScombCaipin.isScomb = row.o_isScomb;
                        orderScombCaipin.scombId = row.o_caipinId;
                        orderScombCaipin.scombMainCaipinId = row.osc_scombMainCaipinId;

                        orderScombCaipin.tuicaiReasonId = row.osc_tuicaiReasonId;
                        orderScombCaipin.tuicaiReasonName = row.osc_tuicaiReasonName;
                        orderScombCaipin.zengReasonId = row.ozs_reasonId;
                        orderScombCaipin.zengReasonName = row.ozs_reasonName;

                        orderCaipin.scombCaipins.push(orderScombCaipin);
                    }
                    if (row.osck_guid != null) {
                        var orderCaipinKouwei = Utils.arrayFind(orderScombCaipin.kouweis, row.osck_guid, "guid");
                        if (orderCaipinKouwei == null) {
                            orderCaipinKouwei = new OrderCaipinKouwei();
                            orderCaipinKouwei.guid = row.osck_guid;
                            orderCaipinKouwei.orderCaipinId = row.o_guid;
                            orderCaipinKouwei.kwId = row.osck_kwId;
                            orderCaipinKouwei.name = row.osck_name;
                            orderCaipinKouwei.operator = row.osck_operator;
                            orderCaipinKouwei.modTime = row.osck_modTime;
                            orderCaipinKouwei.isScomb = row.osck_isScomb;
                            orderCaipinKouwei.orderScombCaipinId = row.osck_orderScombCaipinId;
                            orderScombCaipin.kouweis.push(orderCaipinKouwei);
                        }
                    }
                    if (row.oscz_guid != null) {
                        var orderCaipinZuofa = Utils.arrayFind(orderScombCaipin.zuofas, row.oscz_guid, "guid");
                        if (orderCaipinZuofa == null) {
                            orderCaipinZuofa = new OrderCaipinZuofa();
                            orderCaipinZuofa.guid = row.oscz_guid;
                            orderCaipinZuofa.orderCaipinId = row.o_guid;
                            orderCaipinZuofa.zuofaId = row.oscz_zuofaId;
                            orderCaipinZuofa.name = row.oscz_name;
                            orderCaipinZuofa.typeId = row.oscz_typeId;
                            orderCaipinZuofa.price = row.oscz_price;
                            orderCaipinZuofa.jiajiaType = row.oscz_jiajiaType;
                            orderCaipinZuofa.operator = row.oscz_operator;
                            orderCaipinZuofa.modTime = row.oscz_modTime;
                            orderCaipinZuofa.isScomb = row.oscz_isScomb;
                            orderCaipinZuofa.orderScombCaipinId = row.oscz_orderScombCaipinId;
                            orderScombCaipin.zuofas.push(orderCaipinZuofa);
                        }
                    }
                }
            }


            //把退菜的菜品和初始菜品关联
            //console.log(tuiCaiMap);
            _.forEach(tuiCaiMap, function (value, key) {
                var c = Utils.arrayFind(resultList, key, "guid");
                c.addTuiCai(value);
            });

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });
    };

    /* 更改套餐中的菜品 */
    DiancaiService.updateScombCaipin = function (operator, orderScomb, oldScombCaipin, newScombCaipin, cb) {
        var queries = [];
        queries.push({ query: "delete from pos_order_scomb_caipin where guid='" + oldScombCaipin.guid + "'" });
        queries.push({ query: "delete from pos_order_caipin_kouwei where orderScombCaipinId='" + oldScombCaipin.guid + "'" });
        queries.push({ query: "delete from pos_order_caipin_zuofa where orderScombCaipinId='" + oldScombCaipin.guid + "'" });

        var scombCaipin = createOrderScombCaipin(operator, orderScomb, newScombCaipin);
        scombCaipin.scombMainCaipinId = oldScombCaipin.scombMainCaipinId;
        queries.push({
            query: "insert into pos_order_scomb_caipin ( " +
            "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
            "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
            "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?)",
            params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName, scombCaipin.dianCaiTime, scombCaipin.modTime,
                scombCaipin.needweigh, orderScomb.isScomb, scombCaipin.scombMainCaipinId, scombCaipin.costprice, scombCaipin.hyPrice, scombCaipin.caipinTypeId,
                scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName]
        });

        orderScombCaipinDao.queryTransaction(queries).then(function (resuult) {
            return cb(null, scombCaipin);
        }, function (err) {
            return cb(err);
        });
    }


    /* 修改人数*/
    DiancaiService.updateOrderRenshu = function (order, renshu, cb) {
        order.renshu = renshu;
        var queries = [];
        queries.push({ query: "update pos_order set renshu=" + renshu + " where guid='" + order.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order);
        }, function (err) {
            cb(err);
        });
    };

    /* 修改桌台人数-为拆并台新写的*/
    DiancaiService.updateZhuotaiRenshu = function (order, orderZhuotai, renshu, cb) {
        var queries = [];
        if(Utils.isEmpty(order.merge)){
            order.renshu = renshu;
        } else {
            order.renshu = order.renshu - orderZhuotai.renshu + renshu;
        }
        queries.push({ query: "update pos_order set renshu=" + order.renshu + " where guid='" + order.guid + "'" });

        orderZhuotai.renshu = renshu;
        queries.push({ query: "update pos_order_zhuotai set renshu=" + renshu + " where guid='" + orderZhuotai.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order, orderZhuotai);
        }, function (err) {
            cb(err);
        });
    };

    /* 快餐-修改人数*/
    DiancaiService.fastUpdateOrderRenshu = function (order, renshu, orderZhuotai, cb) {
        order.renshu = renshu;
        var queries = [];
        queries.push({ query: "update pos_order set renshu=" + renshu + " where guid='" + order.guid + "'" });

        orderZhuotai.renshu = renshu;
        queries.push({ query: "update pos_order_zhuotai set renshu=" + renshu + " where guid='" + orderZhuotai.guid + "'" });

        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order, orderZhuotai);
        }, function (err) {
            cb(err);
        });
    };

    /* 修改服务员工号*/
    DiancaiService.updateOrderServer = function (operator, order, server, cb) {
        order.serverId = server.personNo;
        order.serverName = server.personName;
        order.serverGuid = server.guid;
        order.operator = operator;
        order.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        queries.push({ query: "update pos_order set serverId='" + order.serverId + "',serverName='" + order.serverName + "',serverGuid ='" + order.serverGuid + "',operator='" + operator + "',modTime=datetime('now', 'localtime') where guid='" + order.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order);
        }, function (err) {
            cb(err);
        });
    };

    /* 修改备注*/
    DiancaiService.updateOrderComments = function (operator, order, comments, cb) {
        order.comments = comments;
        order.operator = operator;
        order.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        queries.push({ query: "update pos_order set comments='" + comments + "',operator='" + operator + "',modTime=datetime('now', 'localtime') where guid='" + order.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order);
        }, function (err) {
            cb(err);
        });
    };

    /*新增一个菜品到定单*/
    DiancaiService.addOrderCaipin = function (operator, order,orderzhuotai, caipin, cb) {

        var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, caipin);
        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin ( " +
            "guid, orderId, caipinId,caipinCode, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId," +
            "caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange,customize,unitId,cpdept,cpdeptName,dishFastNo,bestTypeId,bestTypeCode,bestTypeName,dianCaiYuanNo) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
            params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId,orderCaipin.caipinCode, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, 
                 orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName, orderCaipin.caiwuTypeId,
                orderCaipin.priceChange, orderCaipin.customize, orderCaipin.unitId, orderCaipin.cpdept, orderCaipin.cpdeptName,
                orderCaipin.dishFastNo,orderCaipin.bestTypeId,orderCaipin.bestTypeCode,orderCaipin.bestTypeName, orderCaipin.dianCaiYuanNo]
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };

    /*新增多个菜品到定单*/
    DiancaiService.addOrderCaipins = function (operator, order,orderzhuotai, caipins) {
        var queries = [];
        for(var  x in caipins){
            var bufferNum = 0;
            if(caipins[x].caipinNum == null || caipins[x].caipinNum == 0){
                bufferNum = orderzhuotai.renshu
            }
            var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, caipins[x]);
            if(bufferNum){
                orderCaipin.num = bufferNum;
            }
            queries.push({
                query: "insert into pos_order_caipin ( " +
                "guid, orderId, caipinId,caipinCode, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId," +
                "caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange,customize,unitId,cpdept,cpdeptName,dishFastNo,bestTypeId,bestTypeCode,bestTypeName) " +
                "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId,orderCaipin.caipinCode, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                    orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                    orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                    orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName,
                    orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                    orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName, orderCaipin.caiwuTypeId,
                    orderCaipin.priceChange, orderCaipin.customize, orderCaipin.unitId, orderCaipin.cpdept, orderCaipin.cpdeptName,
                    orderCaipin.dishFastNo,orderCaipin.bestTypeId,orderCaipin.bestTypeCode,orderCaipin.bestTypeName]
            });
        }
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            console.log(resultList)
        }, function (err) {
            console.log(err)
        });
    };


    /*新增订单套餐*/
    DiancaiService.AddOrderScomb = function (operator, order, orderzhuotai, orderScomb, cb) {
        var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, orderScomb.getScombInfo());
        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin ( " +
            "guid, orderId, caipinId,caipinCode, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,costprice," +
            "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange,customize,unitId,cpdept,cpdeptName,dishFastNo,bestTypeId,bestTypeCode,bestTypeName,dianCaiYuanNo) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
            params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.caipinCode, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price, orderCaipin.num,
                orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName, orderCaipin.chupin, orderCaipin.minAgio,
                orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou, orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan,
                orderCaipin.dianCaiYuanName,  orderCaipin.needweigh, orderCaipin.isScomb, orderCaipin.costprice,
                orderCaipin.hyPrice, orderCaipin.caipinTypeId, orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName,
                orderCaipin.caiwuTypeId,orderCaipin.priceChange, orderCaipin.customize, orderCaipin.unitId, orderCaipin.cpdept, orderCaipin.cpdeptName,
                orderCaipin.dishFastNo,orderCaipin.bestTypeId,orderCaipin.bestTypeCode,orderCaipin.bestTypeName,orderCaipin.dianCaiYuanNo]
        });

        var scombCaipins = orderScomb.getScombCaipin();
        if(scombCaipins.length<1){
            return cb({message:"套餐【"+orderCaipin.name+"】下没有明细菜品，请添加菜品后再进行该操作！"})
        }
        for (var i = 0; i < scombCaipins.length; i++) {
            var scombCaipin = createOrderScombCaipin(operator, orderCaipin, orderScomb.getScombCaipin()[i].scombCaipinInfo);

            orderCaipin.scombCaipins.push(scombCaipin);

            queries.push({
                query: "insert into pos_order_scomb_caipin ( " +
                "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
                "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName, dianCaiYuanNo) " +
                "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?)",
                params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                    scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                    scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                    scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName, 
                    scombCaipin.needweigh, orderCaipin.isScomb, scombCaipin.caipinId, scombCaipin.costprice,
                    scombCaipin.hyPrice, scombCaipin.caipinTypeId, scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName, scombCaipin.dianCaiYuanNo]
            });
        }

        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, orderCaipin);
        }, function (err) {
            return cb(err);
        });
    }

    function createOrderCaipin(operator, order, orderzhuotai, caipin) {
        var num = 1;
        console.log("***************DSSDSDfff**********")
        console.log(caipin);
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var orderCaipin = new OrderCaipin();
        orderCaipin.guid = orderCaipinDao.guid();
        orderCaipin.orderId = order.guid;
        orderCaipin.caipinId = caipin.guid;
        orderCaipin.caipinCode = caipin.code;
        orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        orderCaipin.name = caipin.name;
        orderCaipin.price = caipin.salePrice;
        orderCaipin.costprice = caipin.costprice;
        orderCaipin.num = num;
        orderCaipin.tuiNum = 0;
        orderCaipin.zengNum = 0;
        orderCaipin.unitName = caipin.unitName;
        orderCaipin.printId = caipin.printId;
        orderCaipin.printName = caipin.printName;
        orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        orderCaipin.minAgio = caipin.minAgio;
        orderCaipin.danPinBiLiZheKou = 0;
        orderCaipin.danPinJineZheKou = 0;
        orderCaipin.danPinZheKou = 0;
        orderCaipin.operator = operator.id;
        orderCaipin.dianCaiYuanNo = order.serverId;
        orderCaipin.dianCaiYuan = order.serverGuid;
        orderCaipin.dianCaiYuanName = order.serverName;
        orderCaipin.dianCaiTime = now;
        orderCaipin.modTime = now;
        orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
        orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;

        orderCaipin.priceChange = null == caipin.priceChange ? 'false' : caipin.priceChange;

        orderCaipin.hyPrice = caipin.hyPrice;
        orderCaipin.caipinTypeId = caipin.typeId;

        orderCaipin.caipinTypeCode = caipin.cpTypeCode;
        orderCaipin.caipinTypeName = caipin.cpTypeName;

        orderCaipin.customize = caipin.customize; //是否是自定义菜品字段，pos竖屏需要

        orderCaipin.orderZhuoTaiId = orderzhuotai.guid;
        orderCaipin.caiwuTypeName = caipin.caiwuTypeName;
        orderCaipin.caiwuTypeId = caipin.caiwuTypeId;

        orderCaipin.unitId = caipin.unitId;
        orderCaipin.cpdept = caipin.cpdept;
        orderCaipin.cpdeptName = caipin.cpdeptName;
        orderCaipin.mom = null;

        orderCaipin.dishFastNo = caipin.quickCode;
        orderCaipin.bestTypeId = caipin.bestTypeId;
        orderCaipin.bestTypeCode = caipin.bestTypeCode;
        orderCaipin.bestTypeName = caipin.bestTypeName;

        return orderCaipin;
    }


    function createOrderScombCaipin(operator, orderCaipin, caipin) {
        var num = 1;
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var scombCaipin = new OrderCaipin();
        scombCaipin.guid = orderScombCaipinDao.guid();

        scombCaipin.orderCaipinId = orderCaipin.guid;//订单中套餐菜品GUID
        scombCaipin.scombId = orderCaipin.caipinId;//套餐的GUID

        scombCaipin.caipinId = caipin.guid;
        scombCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        scombCaipin.name = caipin.name;
        scombCaipin.price = caipin.salePrice;
        scombCaipin.costprice = caipin.costprice;
        scombCaipin.num = num;
        scombCaipin.tuiNum = 0;
        scombCaipin.zengNum = 0;
        scombCaipin.unitName = caipin.unitName;
        scombCaipin.printId = caipin.printId;
        scombCaipin.printName = caipin.printName;
        scombCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        scombCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        scombCaipin.minAgio = caipin.minAgio;
        scombCaipin.danPinBiLiZheKou = 0;
        scombCaipin.danPinJineZheKou = 0;
        scombCaipin.danPinZheKou = 0;
        scombCaipin.operator = operator.id;
        scombCaipin.dianCaiYuanNo = orderCaipin.dianCaiYuanNo;
        scombCaipin.dianCaiYuan = orderCaipin.dianCaiYuan;
        scombCaipin.dianCaiYuanName = orderCaipin.dianCaiYuanName;
        scombCaipin.dianCaiTime = now;
        scombCaipin.modTime = now;
        scombCaipin.needweigh = caipin.needweigh ? 1 : 0;
        scombCaipin.isScomb = 'true';
        scombCaipin.scombMainCaipinId = caipin.guid;

        scombCaipin.hyPrice = caipin.hyPrice;
        scombCaipin.caipinTypeId = caipin.typeId;
        scombCaipin.caipinTypeCode = caipin.typeCode;
        scombCaipin.caipinTypeName = caipin.typeName;

        return scombCaipin;
    }


    DiancaiService.changeScombCaipin = function (operator, order, orderScomb, cb) {



    }

    /*新增订单菜品数量*/
    DiancaiService.addOrderCaipinNum = function (operator, orderCaipin, num, cb) {
        orderCaipin.num += num;
        orderCaipin.operator = operator;
        orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        queries.push({
            query: "update pos_order_caipin" +
            " set num=" + orderCaipin.num + ",operator='" + operator + "',modTime=datetime('now', 'localtime') " +
            " where guid='" + orderCaipin.guid + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };

    /*修改订单菜品数量*/
    DiancaiService.updateOrderCaipinNum = function (operator, orderCaipin, num, cb,forGqNum) {
        var caipinGuqing = null;
        var xcz = false
        dishGuqingDao.all(" startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipin.caipinId + "'")
            .then(function (result) {
                caipinGuqing = result;
            }, function (err) {
                return cb(err);
            }).then(function () {

                if (caipinGuqing == null || caipinGuqing.length == 0 || (caipinGuqing != null && caipinGuqing[0].caipinNum >= forGqNum)) {
                    var chaNum = orderCaipin.num;
                    orderCaipin.num = num;
                    orderCaipin.operator = operator;
                    orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                    var queries = [];
                    queries.push({
                        query: "update pos_order_caipin set num=" + orderCaipin.num + ",operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
                        " where guid='" + orderCaipin.guid + "'"
                    });
                    queries.push({
                        query: "update pos_order_scomb_caipin set num=num/" + chaNum + "*" + num + ",operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
                        " where orderCaipinId='" + orderCaipin.guid + "'"
                    });

                    if (orderCaipin.needweigh == 1 && orderCaipin.luodan == BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE) {
                        queries.push({
                            query: "update pos_order_caipin" +
                            " set needweigh=2" +
                            " where guid='" + orderCaipin.guid + "'"
                        });
                        xcz = true;
                    }
                    orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                        if (orderCaipin.scombCaipins.length > 0) {
                            for (var idx in orderCaipin.scombCaipins) {
                                var item = orderCaipin.scombCaipins[idx];
                                item.num = item.num / chaNum * num;
                            }
                        }
                        return cb(null, orderCaipin,xcz);
                    }, function (err) {
                        return cb(err);
                    });
                } else {
                    return cb({ message: "菜品数量不足" });
                }

            })
    };

    /*整桌修改订单菜品数量*/
    DiancaiService.updateAllOrderCaipinNum = function (operator, orderCaipins, doublenum, cb) {
        //if(doublenum== 1){
        //    return cb(null, orderCaipins);
        //}
        var caipinGuqing = null;
        var caipinGuids = [],
             queries = [];
        if(orderCaipins.length > 0){
            queries.push({
                query: "update pos_order set mom = '" +doublenum + "'" +
                " where guid='" + orderCaipins[0].orderId + "'"
            })
        }
        for(var x in orderCaipins) {
            caipinGuids.push(orderCaipins[x].caipinId);

            //没有进行翻过倍的菜品
            if(orderCaipins[x].orgNum == null || orderCaipins[x].mom == 1){
                orderCaipins[x].orgNum = orderCaipins[x].num;
                queries.push({
                    query: "update pos_order_caipin set orgNum = '" + orderCaipins[x].orgNum + "'" +
                    " where guid='" + orderCaipins[x].guid + "'"
                })
            }


            //定额加价做法根据倍数加钱
            if(orderCaipins[x].zuofas.length>0){
                var zuofas = orderCaipins[x].zuofas;
                for(var ind in zuofas){
                    if(zuofas[ind].jiajiaType == "002"){
                        if(!orderCaipins[x].mom){
                            var fb_price = zuofas[ind].price*doublenum; // 没有翻倍的做法钱
                        }else{
                            var fb_price = zuofas[ind].price/orderCaipins[x].mom*doublenum; //翻过倍的做法钱
                        }
                        queries.push({
                            query: "update pos_order_caipin_zuofa set price = '" + fb_price + "'" +
                            " where guid='" + zuofas[ind].guid + "'"
                        })
                        zuofas[ind].price = Utils.m(fb_price);
                    }
                }
            }

            //记录翻的倍数
            orderCaipins[x].mom = doublenum;
            queries.push({
                query: "update pos_order_caipin set mom = '" + orderCaipins[x].mom + "'" +
                " where guid='" + orderCaipins[x].guid + "'"
            })




            var chaNum = orderCaipins[x].num;
            orderCaipins[x].num = orderCaipins[x].orgNum*doublenum;
            orderCaipins[x].operator = operator;
            orderCaipins[x].modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            queries.push({
                query: "update pos_order_caipin set num=" + orderCaipins[x].num + ",operator='" + orderCaipins[x].operator + "',modTime=datetime('now', 'localtime') " +
                " where guid='" + orderCaipins[x].guid + "'"
            });
            queries.push({
                query: "update pos_order_scomb_caipin set num=num/" + chaNum + "*" + orderCaipins[x].num + ",operator='" + orderCaipins[x].operator + "',modTime=datetime('now', 'localtime')" +
                " where orderCaipinId='" + orderCaipins[x].guid + "'"
            });

            if (orderCaipins[x].needweigh == 1 && orderCaipins[x].luodan == BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE) {
                queries.push({
                    query: "update pos_order_caipin" +
                    " set needweigh=2" +
                    " where guid='" + orderCaipins[x].guid + "'"
                });
            }

            if (orderCaipins[x].scombCaipins.length > 0) {
                for (var idx in orderCaipins[x].scombCaipins) {
                    var item = orderCaipins[x].scombCaipins[idx];
                    item.num = item.num / chaNum * orderCaipins[x].num;
                }
            }

        }
        var reCaipinGuids = caipinGuids.join("','");
        dishGuqingDao.all(" startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid in ('" + reCaipinGuids  + "')")
            .then(function (result) {
                caipinGuqing = result;
            }, function (err) {
                return cb(err);
            }).then(function () {
                if(caipinGuqing != null && caipinGuqing.length >0) {
                    for(var i = 0; i < caipinGuqing.length; i++) {
                        var cpgq = caipinGuqing[i];
                        for(var j = 0; j < orderCaipins.length; j++) {
                            var oc = orderCaipins[j];
                            if(cpgq.caipinGuid == oc.caipinId && cpgq.caipinNum < oc.num) {
                                return cb({ message: "【" + cpgq.caipinName +  "】数量不足" });
                            }
                        }
                    }
                }
                orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                    return cb(null, orderCaipins);
                }, function (err) {
                    return cb(err);
                });
            })
    };


    /* 口味 */
    DiancaiService.updateOrderCaipinKouweis = function (orderCaipinId, orderCaipinKouweis, cb) {
        var queries = [];
        queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId='" + orderCaipinId + "'" });
        for (var idx in orderCaipinKouweis) {
            orderCaipinKouweis[idx].guid = orderCaipinKouweis[idx].guid == null ? orderCaipinKouweiDao.guid() : orderCaipinKouweis[idx].guid;
            queries.push({
                query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime)" +
                " values(?, ?, ?, ?, ?, datetime('now', 'localtime'))",
                params: [orderCaipinKouweis[idx].guid, orderCaipinKouweis[idx].orderCaipinId, orderCaipinKouweis[idx].kwId, orderCaipinKouweis[idx].name,
                    orderCaipinKouweis[idx].operator]
            });
        }
        orderCaipinKouweiDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinKouweis);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.addOrderCaipinKouweis = function (operator, orderCaipin, Kouwei, cb) {
        var queries = [];
        //queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId='" + orderCaipinId + "'" });
        var isscomb = null;
        var scombid = null;
        var orderCaipinId = orderCaipin.guid;
        if (orderCaipin.isScomb == 'true') {
            isscomb = orderCaipin.isScomb;
            scombid = orderCaipin.scombId;
            orderCaipinId = orderCaipin.guid;
        }
        Kouwei.guid = Kouwei.guid == null ? orderCaipinKouweiDao.guid() : Kouwei.guid;
        queries.push({
            query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb,orderScombCaipinId) values(?, ?, ?, ?, ?, datetime('now', 'localtime'), ?, ?)",
            params: [orderCaipinKouweiDao.guid(), orderCaipinId, Kouwei.guid, Kouwei.kwName, operator,  isscomb, scombid]

        });

        orderCaipinKouweiDao.queryTransaction(queries).then(function (resultList) {
            cb(null, Kouwei);
        }, function (err) {
            console.log('添加口味失败：' + err.message);
            cb(err);
        });
    };

    function kouweiDbToModel(row) {
        var kouwei = new Kouwei();
        kouwei.guid = row.guid;
        kouwei.kwCode = row.kwCode;
        kouwei.kwName = row.kwName;
        kouwei.quickCode = row.quickCode;
        kouwei.enabled = row.enabled;
        kouwei.isDeleted = row.isDeleted;

        return kouwei;
    }

    DiancaiService.getKouweisCount = function (cb) {
        var sql = "select count(guid) c from pos_kouwei" +
            " where isDeleted='false' and enabled='true'";
        kouweiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if (count < 1) {
                return cb({ message: "找不到口味，请联系我司相关的工作人员" });
            }
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getKouweis = function (first, rows, cb) {
        kouweiDao.all("isDeleted='false' and enabled='true' order by kwCode limit " + first + "," + rows)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(kouweiDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getKouweisCountBySearchKey = function (searchKey, cb) {
        var sql = "select count(guid) c from pos_kouwei" +
            " where (kwCode like '%" + searchKey + "%' or kwName like '%" + searchKey + "%' or quickCode like '%" + searchKey + "%')" +
            " and isDeleted='false' and enabled='true'";
        kouweiDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getKouweisBySearchKey = function (searchKey, first, rows, cb) {
        kouweiDao.all("(kwCode like '%" + searchKey + "%' or kwName like '%" + searchKey + "%' or quickCode like '%" + searchKey + "%')" +
            " and isDeleted='false' and enabled='true' order by kwCode limit " + first + "," + rows)
            .then(function (rows) {
                var resultList = [];
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    resultList.push(kouweiDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getKouweisByCode = function (code) {
        var deferred = Utils.defer();//$q.defer();
        var sql = "(kwCode = '" + code + "' ) and isDeleted='false' and enabled='true' ";
        if (isNaN(code))
            sql = "(kwCode = '" + BIZCONSTANT.SELFKOUWEI_CODE + "' ) and isDeleted='false' and enabled='true' ";
        kouweiDao.all()
            .then(function (rows) {
                var resultList = null;
                if (rows.length > 0)
                    resultList = kouweiDbToModel(rows[0])
                console.log(code);
                if (resultList != null && isNaN(code))
                    resultList.kwName = code;

                //return cb(null, resultList);
                deferred.resolve(resultList);
            }, function (error) {
                //return cb(error);
                deferred.reject(error);
            });
        return deferred.promise;
    };

    function orderCaipinKouweiDbToModel(row) {
        var orderCaipinKouwei = new OrderCaipinKouwei();
        orderCaipinKouwei.guid = row.guid;
        orderCaipinKouwei.orderCaipinId = row.orderCaipinId;
        orderCaipinKouwei.kwId = row.kwId;
        orderCaipinKouwei.name = row.name;
        orderCaipinKouwei.operator = row.operator;
        orderCaipinKouwei.modTime = row.modTime;

        return orderCaipinKouwei;
    }

    DiancaiService.getOrderCaipinKouweisByOrderCaipinId = function (orderCaipinId, cb) {
        orderCaipinKouweiDao.all("orderCaipinId='" + orderCaipinId + "'")
            .then(function (rows) {
                var resultList = [];
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    resultList.push(orderCaipinKouweiDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    /*JP
    2016-03-21
    根据菜品获取关联口味，包含套餐菜品的业务处理
    */
    DiancaiService.getOrderCaipinKouweisByOrderCaipin = function (orderCaipin, cb) {
        var sql = "";
        if (orderCaipin.isScombCaipin()) {
            sql = " orderScombCaipinId='" + orderCaipin.guid + "'";
        } else {
            sql = "orderCaipinId='" + orderCaipin.guid + "'";
        }

        orderCaipinKouweiDao.all(sql)
            .then(function (rows) {
                var resultList = [];
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    resultList.push(orderCaipinKouweiDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getAllKouweis = function (cb) {
        kouweiDao.all("isDeleted='false' and enabled='true' order by kwCode")
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(kouweiDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };


    /* 做法 */
    function zuofaTypeDbToModel(row) {
        var zuofaType = new ZuofaType();
        zuofaType.guid = row.guid;
        zuofaType.orderNo = row.orderNo;
        zuofaType.name = row.name;
        zuofaType.enabled = row.enabled;
        zuofaType.isDeleted = row.isDeleted;

        return zuofaType;
    }

    DiancaiService.getZuofaTypesCount = function (cb) {
        var sql = "select count(guid) c from pos_zuofa_type" +
            " where isDeleted='false' and enabled='true'";
        zuofaTypeDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            if (count < 1) {
                return cb({ message: "找不到做法类型，请联系我司相关的工作人员" });
            }
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getZuofaTypes = function (first, rows, cb) {
        zuofaTypeDao.all("isDeleted='false' and enabled='true' order by orderNo limit " + first + "," + rows)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(zuofaTypeDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    function zuofaDbToModel(row) {
        var zuofa = new Zuofa();
        zuofa.guid = row.guid;
        zuofa.code = row.code;
        zuofa.name = row.name;
        zuofa.typeId = row.typeId;
        zuofa.price = row.price;
        zuofa.quickCode = row.quickCode;
        zuofa.jiajiaType = row.jiajiaType;
        zuofa.enabled = row.enabled;
        zuofa.isDeleted = row.isDeleted;

        return zuofa;
    }

    DiancaiService.getZuofasCountByType = function (typeId, cb) {
        var sql = "select count(guid) c from pos_zuofa" +
            " where isDeleted='false' and enabled='true' and typeId='" + typeId + "'";
        zuofaDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    /**
     * 娄金 得到全部做法
     * @param first
     * @param rows
     * @param cb
     */
    DiancaiService.getAllZuofas = function(first,rows,cb){
        var sql = "";
        if(first==0&&rows==0){
            sql = "isDeleted='false' and enabled='true' order by code " ;
        }else{
            sql = "isDeleted='false' and enabled='true' order by code limit " + first + "," + rows;
        }
        zuofaDao.all(sql)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(zuofaDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    }

    DiancaiService.getZuofasByType = function (typeId, first, rows, cb) {
        zuofaDao.all("isDeleted='false' and enabled='true' and typeId='" + typeId + "' order by code limit " + first + "," + rows)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(zuofaDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getZuofasCountBySearchKey = function (searchKey, cb) {
        var sql = "select count(guid) c from pos_zuofa" +
            " where (code like '%" + searchKey + "%' or name like '%" + searchKey + "%' or quickCode like '%" + searchKey + "%')" +
            " and isDeleted='false' and enabled='true'";
        zuofaDao.query(sql).then(function (result) {
            var count = result.detail[0].c;
            return cb(null, count);
        }, function (error) {
            return cb(error);
        });
    };

    DiancaiService.getZuofasBySearchKey = function (searchKey, first, rows, cb) {
        zuofaDao.all("(code like '%" + searchKey + "%' or name like '%" + searchKey + "%' or quickCode like '%" + searchKey + "%')" +
                " and isDeleted='false' and enabled='true' order by code limit " + first + "," + rows)
            .then(function (results) {
                var resultList = [];
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    resultList.push(zuofaDbToModel(row));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getZuofasByCode = function (code, cb) {
        zuofaDao.all(" code = '" + code + "'  and isDeleted='false' and enabled='true' ")
            .then(function (results) {
                var rtresult = null;
                if (results.length > 0)
                    rtresult = zuofaDbToModel(results[0]);

                return cb(null, rtresult);
            }, function (error) {
                return cb(error);
            });
    };

    function orderCaipinZuofaDbToModel(row, orderCaipin) {
        var orderCaipinZuofa = new OrderCaipinZuofa();
        orderCaipinZuofa.guid = row.guid;
        orderCaipinZuofa.orderCaipinId = row.orderCaipinId;
        orderCaipinZuofa.zuofaId = row.zuofaId;
        orderCaipinZuofa.name = row.name;
        orderCaipinZuofa.typeId = row.typeId;
        orderCaipinZuofa.price = row.price;
        orderCaipinZuofa.jiajiaType = row.jiajiaType;
        orderCaipinZuofa.operator = row.operator;
        orderCaipinZuofa.modTime = row.modTime;
        orderCaipinZuofa.parentCaiPin = orderCaipin;

        return orderCaipinZuofa;
    }

    DiancaiService.getOrderCaipinZuofasByOrderCaipinId = function (orderCaipin, cb) {
        orderCaipinZuofaDao.all("orderCaipinId='" + orderCaipin.guid + "'")
            .then(function (rows) {
                var resultList = [];
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    resultList.push(orderCaipinZuofaDbToModel(row, orderCaipin));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };

    /*JP
   2016-03-21
   根据菜品获取关联做法，包含套餐菜品的业务处理
   */
    DiancaiService.getOrderCaipinZuofasByOrderCaipin = function (orderCaipin, cb) {
        var sql = "";
        if (orderCaipin.isScombCaipin()) {
            sql = " orderScombCaipinId='" + orderCaipin.guid + "'";
        } else {
            sql = "orderCaipinId='" + orderCaipin.guid + "'";
        }

        orderCaipinZuofaDao.all(sql)
            .then(function (rows) {
                var resultList = [];
                for (var i = 0; i < rows.length; i++) {
                    var row = rows[i];
                    resultList.push(orderCaipinZuofaDbToModel(row, orderCaipin));
                }
                return cb(null, resultList);
            }, function (error) {
                return cb(error);
            });
    };



    DiancaiService.addOrderCaipinZuofaDirectly = function (operator, orderCaipin, caipinZuofa, cb) {
        var orderCaipinZuofa = new OrderCaipinZuofa();
        orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
        orderCaipinZuofa.orderCaipinId = orderCaipin.guid;
        orderCaipinZuofa.zuofaId = caipinZuofa.zuofaId;
        orderCaipinZuofa.name = caipinZuofa.zuofaName;
        orderCaipinZuofa.typeId = null;
        orderCaipinZuofa.price = caipinZuofa.jiajiaPrice;
        orderCaipinZuofa.jiajiaType = caipinZuofa.jiajiaType;
        orderCaipinZuofa.operator = operator;
        orderCaipinZuofa.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        orderCaipinZuofa.parentCaiPin = orderCaipin;
        var orderScombCaipinId = null;
        if (orderCaipin.isScombCaipin()) {
            orderCaipinZuofa.orderCaipinId = orderCaipin.orderCaipinId;
            orderScombCaipinId = orderCaipin.guid;
        }

        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime,isScomb,orderScombCaipinId)" +
            " values(?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'),?,?)",
            params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator, 
                orderCaipin.isScomb, orderScombCaipinId]
        });
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinZuofa);
        }, function (err) {
            cb(err);
        });
    };

    //快餐-增加菜品做法
    DiancaiService.fastAddOrderCaipinZuofaDirectly = function (operator, orderCaipin, zuofa, cb) {
        var orderCaipinZuofa = new OrderCaipinZuofa();
        orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
        orderCaipinZuofa.orderCaipinId = orderCaipin.guid;
        orderCaipinZuofa.zuofaId = zuofa.guid;
        orderCaipinZuofa.name = zuofa.name;
        orderCaipinZuofa.typeId = null;
        orderCaipinZuofa.price = zuofa.price;
        orderCaipinZuofa.jiajiaType = zuofa.jiajiaType;
        orderCaipinZuofa.operator = operator;
        orderCaipinZuofa.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        orderCaipinZuofa.parentCaiPin = orderCaipin;
        var orderScombCaipinId = null;
        if (orderCaipin.isScombCaipin()) {
            orderCaipinZuofa.orderCaipinId = orderCaipin.orderCaipinId;
            orderScombCaipinId = orderCaipin.guid;
        }

        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime,isScomb,orderScombCaipinId)" +
            " values(?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'),?,?)",
            params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator, 
                orderCaipin.isScomb, orderScombCaipinId]
        });
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinZuofa);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.deleteOrderCaipinZuofaDirectly = function (operator, orderCaipin, zuofaId, cb) {
        var queries = [];
        var sql = "delete from pos_order_caipin_zuofa ";
        if (orderCaipin.isScombCaipin()) {
            sql = sql + "where orderScombCaipinId='" + orderCaipin.guid + "' and zuofaId='" + zuofaId + "'";
        }
        else {
            sql = sql + "where orderCaipinId='" + orderCaipin.guid + "' and zuofaId='" + zuofaId + "'";
        }
        queries.push({ query: sql });
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.addOrderCaipinZuofa = function (operator, orderCaipin, zuofa, cb) {
        var orderCaipinZuofa = new OrderCaipinZuofa();
        orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
        orderCaipinZuofa.orderCaipinId = orderCaipin.guid;
        orderCaipinZuofa.zuofaId = zuofa.guid;
        orderCaipinZuofa.name = zuofa.name;
        orderCaipinZuofa.typeId = zuofa.typeId;
        orderCaipinZuofa.price = zuofa.price;
        orderCaipinZuofa.jiajiaType = zuofa.jiajiaType;
        orderCaipinZuofa.operator = operator;
        orderCaipinZuofa.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        orderCaipinZuofa.parentCaiPin = orderCaipin;

        var isscomb = null;
        var scombid = null;
        if (orderCaipin.isScomb == 'true') {
            isscomb = orderCaipin.isScomb;
            scombid = orderCaipin.guid;
            orderCaipinZuofa.orderCaipinId = orderCaipin.orderCaipinId;
        }


        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime,isScomb,orderScombCaipinId)" +
            " values(?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), ?, ?)",
            params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator, isscomb, scombid]
        });
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinZuofa);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.updateOrderCaipinZuofas = function (orderCaipinId, orderCaipinZuofas, cb) {
        var queries = [];
        queries.push({ query: "delete from pos_order_caipin_zuofa where orderCaipinId='" + orderCaipinId + "'" });
        for (var idx in orderCaipinZuofas) {
            orderCaipinZuofas[idx].guid = orderCaipinZuofas[idx].guid == null ? orderCaipinZuofaDao.guid() : orderCaipinZuofas[idx].guid;
            queries.push({
                query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime)" +
                " values(?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'))",
                params: [orderCaipinZuofas[idx].guid, orderCaipinZuofas[idx].orderCaipinId, orderCaipinZuofas[idx].zuofaId, orderCaipinZuofas[idx].name,
                orderCaipinZuofas[idx].typeId, orderCaipinZuofas[idx].price, orderCaipinZuofas[idx].jiajiaType, orderCaipinZuofas[idx].operator]
            });
        }
        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipinZuofas);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.deleteOrderCaipin = function (orderCaipinId, cb) {
        var queries = [];
        queries.push({ query: "delete from pos_order_caipin_zuofa where orderCaipinId='" + orderCaipinId + "'" });
        queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId='" + orderCaipinId + "'" });
        queries.push({ query: "delete from pos_order_caipin where guid='" + orderCaipinId + "'" });
        queries.push({ query: "delete from pos_order_scomb_caipin where orderCaipinId='" + orderCaipinId + "'" });

        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.deleteAllOrderCaipin = function (orderCaipins, cb) {
        var conditions = [];
        var incondition = '';
        if (orderCaipins.length == 0)
            return cb(null);
        for (var i in orderCaipins)
        {
            conditions.push(orderCaipins[i].guid);
        }
        incondition = "'" + conditions.join("','") + "'";
        var queries = [];
        queries.push({ query: "delete from pos_order_caipin_zuofa where orderCaipinId in (" + incondition + ")" });
        queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId in (" + incondition + ")" });
        queries.push({ query: "delete from pos_order_caipin where guid in (" + incondition + ")" });
        queries.push({ query: "delete from pos_order_scomb_caipin where orderCaipinId in (" + incondition + ")" });

        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.deleteOrderCaipinYaoqiu = function (orderCaipinId, cb) {

        var queries = [];
        queries.push({ query: "delete from pos_order_caipin_zuofa where orderCaipinId='" + orderCaipinId + "'" });
        queries.push({ query: "delete from pos_order_caipin_kouwei where orderCaipinId='" + orderCaipinId + "'" });

        orderCaipinZuofaDao.queryTransaction(queries).then(function (resultList) {
            cb(null, resultList);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.updateChupinYaoqiu = function (operator, orderCaipin, cb) {
        orderCaipin.operator = operator;
        orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        queries.push({
            query: "update pos_order_caipin" +
            " set chupin='" + orderCaipin.chupin + "',operator='" + orderCaipin.operator + "',modTime=datetime('now', 'localtime')" +
            " where guid='" + orderCaipin.guid + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.doZhengzhuoCaozuo = function (operator, orderCaipins, zhengzhuoKouweis, zhengzhuoChupin, cb) {
        var queries = [];
        if (zhengzhuoKouweis != null && zhengzhuoKouweis.length > 0) {
            for (var i = 0; i < orderCaipins.length; i++) {
                var orderCaipinKouweis = orderCaipins[i].kouweis;
                for (var j = 0; j < zhengzhuoKouweis.length; j++) {
                    if (Utils.arrayFind(orderCaipinKouweis, zhengzhuoKouweis[j].guid, "kwId") == null) {
                        var orderCaipinKouwei = new OrderCaipinKouwei();
                        orderCaipinKouwei.guid = orderCaipinKouweiDao.guid();
                        orderCaipinKouwei.orderCaipinId = orderCaipins[i].guid;
                        orderCaipinKouwei.kwId = zhengzhuoKouweis[j].guid;
                        orderCaipinKouwei.name = zhengzhuoKouweis[j].kwName;
                        orderCaipinKouwei.operator = operator;
                        orderCaipinKouwei.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");

                        queries.push({
                            query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime)" +
                            " values(?, ?, ?, ?, ?, datetime('now', 'localtime'))",
                            params: [orderCaipinKouwei.guid, orderCaipinKouwei.orderCaipinId, orderCaipinKouwei.kwId, orderCaipinKouwei.name,
                                orderCaipinKouwei.operator]
                        });

                        orderCaipinKouweis.push(orderCaipinKouwei);
                    }
                }
            }
        }
        if (zhengzhuoChupin != null) {
            for (var i = 0; i < orderCaipins.length; i++) {
                if (orderCaipins[i].chupin != zhengzhuoChupin) {
                    //orderCaipins[i].chupin = zhengzhuoChupin;
                    //orderCaipins[i].operator = operator;
                    //orderCaipins[i].modTime = new Date().format("yyyy-MM-dd hh:mm:ss");

                    //queries.push({
                    //    query: "update pos_order_caipin" +
                    //    " set chupin='" + zhengzhuoChupin + "',operator='" + operator + "',modTime='" + orderCaipins[i].modTime + "'" +
                    //    " where guid='" + orderCaipins[i].guid + "'"
                    //});
                      
                    //if (orderCaipins[i].isScomb == "true" || orderCaipins[i].isScomb) {
                    //    queries.push({
                    //        query: "update pos_order_scomb_caipin" +
                    //        " set chupin='" + zhengzhuoChupin + "',operator='" + operator + "',modTime='" + orderCaipins[i].modTime + "'" +
                    //        " where orderCaipinId='" + orderCaipins[i].guid + "'"
                    //    });

                    //    var scombCaipins = orderCaipins[i].scombCaipins;
                    //    for (var k in scombCaipins) {
                    //        scombCaipins[k].chupin = zhengzhuoChupin;
                    //        scombCaipins[k].operator = operator;
                    //        scombCaipins[k].modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                    //    }
                    //}

                    queries = queries.concat(updateCaipinSate(operator, orderCaipins[i], zhengzhuoChupin));

                }
            }
        }
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipins);
        }, function (err) {
            cb(err);
        });
    };

    //整桌起菜
    DiancaiService.doZhengzhuoQiCai = function (operator, orderCaipins, cb) {
        var queries = [];
        for (var i = 0; i < orderCaipins.length; i++) {
            //if (orderCaipins[i].chupin != BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI) {
            //    orderCaipins[i].chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
            //    orderCaipins[i].operator = operator;
            //    orderCaipins[i].modTime = new Date().format("yyyy-MM-dd hh:mm:ss");

            //    queries.push({
            //        query: "update pos_order_caipin" +
            //        " set chupin='" + BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI + "',operator='" + operator + "',modTime='" + orderCaipins[i].modTime + "'" +
            //        " where guid='" + orderCaipins[i].guid + "'"
            //    });
            //}

            //2016-03-21 JP
            var orderCaipin = orderCaipins[i];
            queries = queries.concat(updateCaipinSate(operator, orderCaipin, BIZCONSTANT.ORDER_CAIPIN_CHUPIN_QI));
        }
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipins);
        }, function (err) {
            cb(err);
        });
    };

    //整桌等叫
    DiancaiService.doZhengzhuoDengjiao = function (operator, orderCaipins, cb) {
        var queries = [];
        for (var i = 0; i < orderCaipins.length; i++) {
            var orderCaipin = orderCaipins[i];
            queries = queries.concat(updateCaipinSate(operator, orderCaipin, BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JIAO));
        }

        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipins);
        }, function (err) {
            cb(err);
        });
    };

    //根据查找用户名


    DiancaiService.caipincaiwu = function (y_caipin) {
        var queries = [], addQueries = [];
        for(var j in y_caipin){
            queries.push({query:"select * from pos_caipin where guid ='"+ y_caipin[j].caipinId +"'"})
        }
        orderCaipinDao.queryTransaction(queries).then(function(reslist){
            for(var x in reslist.detail) {
                for ( var i in y_caipin){
                    if(reslist.detail[x].guid == y_caipin[i].caipinId){
                        if(!reslist.detail[x].caiwuTypeName || !reslist.detail[x].caiwuTypeId)
                        addQueries.push({query:"update pos_order_caipin set caiwuTypeName = '"+ reslist.detail[x].caiwuTypeName + "', caiwuTypeId = '"+ reslist.detail[x].caiwuTypeId + "' where guid = '"+ y_caipin[i].guid + "'"})
                    }

                }
            }

            orderCaipinDao.queryTransaction(addQueries).then(function(r){
               console.log(r)
            },function(e){
                console.log(e)
            })


        },function(err){
            console.log(err)

        })
    }

    //落单操作
    DiancaiService.doLuodan = function (operator, zhuotai, order, orderCaipins, cb) {
        var queries = [];
        //var caipinIds = "";
        //if (orderCaipins != null && orderCaipins.length > 0) {
        //    for (var i = 0; i < orderCaipins.length; i++) {
        //        caipinIds = caipinIds + ",'" + orderCaipins[i].caipinId + "'";
        //    }
        //}
        //caipinIds = caipinIds.substring(1);
        if (orderCaipins.length <= 0) {
            return cb({ message: "落单失败！无法获取菜品！" })
        }
        // var y_caipin = []; //落单的菜品名
        // for(var i in orderCaipins ) {
        //     y_caipin.push(orderCaipins[i])
        // }
        // DiancaiService.caipincaiwu(y_caipin);
        var _orderCaipins = GuqingService.buildOrderCaipins(orderCaipins);

        operator = !operator ? $rootScope.curUser : operator;

        GuqingService.LuodanCaipinToGuqing(_orderCaipins, operator, function (err, result) {
            if (err)
                return cb(err);

            var now = new Date().format("yyyy-MM-dd hh:mm:ss");

            if (order.status < BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI) {
                order.status = BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI;
                order.modTime = now;
                order.luoDanTime = now;
                queries.push({
                    query: "update pos_order set code='" + order.code + "',status=" + order.status + ",modTime='" + now + "', luoDanTime=datetime('now', 'localtime'), operator='" + operator + "'" +
                    " where guid='" + order.guid + "'"
                });
            }
            queries.push({
                query: "update pos_order_caipin" +
                " set luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE + "',operator='" + operator + "',luoDanTime=datetime('now', 'localtime'),modTime=datetime('now', 'localtime')"  +  ",dianCaiYuan = '"  + order.serverGuid + "',dianCaiYuanName = '" + order.serverName + "'" +
                " where orderId='" + order.guid + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
            });

            //修改orderZhuotai落单状态，拆帐时候要使用
            if(zhuotai.orderZhuoTai.orderId == zhuotai.orderZhuoTai.hisOrderId){
                zhuotai.orderZhuoTai.luoDanTime = now;
                zhuotai.orderZhuoTai.hisOrderCode = order.code;
                queries.push({
                    query: "update pos_order_zhuotai set hisOrderCode='" + order.code + "',luoDanTime=datetime('now', 'localtime') where guid='" + zhuotai.orderZhuoTai.guid + "'"
                });
            } else {
                zhuotai.orderZhuoTai.luoDanTime = now;
                queries.push({
                    query: "update pos_order_zhuotai set luoDanTime=datetime('now', 'localtime') where guid='" + zhuotai.orderZhuoTai.guid + "'"
                });
            }

            orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                //落单打印
                //PrintService.doLuodanPrint(orderCaipins, zhuotai, order);
                orderCaipinDao.query("select * from pos_zhuotai where orderId = '" + order.guid + "'").then(function (result) {
                    UploadService.syncZhuotai({ zhuotai: result.detail[0], order: { id: order.guid, status: 2 } });	// 给服务器发送清台数据	
                    cb(null, order, orderCaipins, zhuotai);
                });
            }, function (err) {
                cb(err);
            });


        })



        //dishGuqingDao.query("select * from pos_caipin_guqing where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid in (" + caipinIds + ")").
        //    then(function (result) {

        //        var msg = "";
        //        for (var i = 0; i < result.detail.length; i++) {
        //            var row = result.detail[i];
        //            var orderCaipin = Utils.arrayFind(orderCaipins, row.caipinGuid, "caipinId");
        //            if (row.caipinNum == 0) {
        //                msg = msg + "," + row.caipinName + "已估清";
        //            } else if (row.caipinNum < orderCaipin.num) {
        //                msg = msg + "," + row.caipinName + "数量不足，剩余" + row.caipinNum;
        //            }
        //        }

        //        if (msg.length > 0)
        //            return cb({ message: msg });


        //        if (orderCaipins != null && orderCaipins.length > 0) {
        //            var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        //            for (var i = 0; i < orderCaipins.length; i++) {
        //                orderCaipins[i].luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE;
        //                orderCaipins[i].operator = operator;
        //                orderCaipins[i].luoDanTime = now;
        //                orderCaipins[i].modTime = now;

        //                /*JP
        //                2016-02-26
        //                落单时更新菜品估清数量
        //                */
        //                queries.push({ query: "update pos_caipin_guqing set caipinNum=caipinNum-" + orderCaipins[i].num + " where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipins[i].caipinId + "'" });

        //                /*套餐里面的菜品进行估清*/
        //                if (orderCaipins[i].scombCaipins.length > 0) {
        //                    for (var j = 0; j < orderCaipins[i].scombCaipins.length; j++) {
        //                        var tempCaipin = orderCaipins[i].scombCaipins[j];

        //                        tempCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE;
        //                        tempCaipin.operator = operator;
        //                        tempCaipin.luoDanTime = now;
        //                        tempCaipin.modTime = now;

        //                        queries.push({ query: "update pos_caipin_guqing set caipinNum=caipinNum-" + tempCaipin.num + " where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + tempCaipin.caipinId + "'" });

        //                        queries.push({
        //                            query: "update pos_order_scomb_caipin" +
        //                            " set luodan='" + tempCaipin.luodan + "',operator='" + operator + "',luoDanTime='" + now + "',modTime='" + now + "'" +
        //                            " where orderCaipinId='" + orderCaipins[i].guid + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
        //                        });
        //                    }
        //                }

        //            }
        //            if (order.status < BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI) {
        //                order.status = BIZCONSTANT.ORDER_STATUS_YI_DIAN_CAI;
        //                order.modTime = now;
        //                order.luoDanTime = now;
        //                queries.push({
        //                    query: "update pos_order set code='" + order.code + "',status=" + order.status + ",modTime='" + now + "', luoDanTime='" + now + "', operator='" + operator + "'" +
        //                    " where guid='" + order.guid + "'"
        //                });
        //            }
        //            queries.push({
        //                query: "update pos_order_caipin" +
        //                " set luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE + "',operator='" + operator + "',luoDanTime='" + now + "',modTime='" + now + "'" +
        //                " where orderId='" + order.guid + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
        //            });

        //            orderCaipinDao.queryTransaction(queries).then(function (resultList) {
        //                //落单打印
        //                //PrintService.doLuodanPrint(orderCaipins, zhuotai, order);
        //                orderCaipinDao.query("select * from pos_zhuotai where orderId = '" + order.guid + "'").then(function (result) {
        //                    UploadService.syncZhuotai({ zhuotai: result.detail[0], order: { id: order.guid, status: 2 } });	// 给服务器发送清台数据	
        //                    cb(null, [order, orderCaipins]);
        //                });
        //            }, function (err) {
        //                cb(err);
        //            });
        //        }
        //    });

    };

    DiancaiService.getTuicaiReasons = function (cb) {
        tuicaiReasonDao.all("isDeleted='false' and enabled='true' order by code")
            .then(function (rows) {
                return cb(null, rows);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getTuicaiReasonsBySearchKey = function (searchKey, cb) {
        tuicaiReasonDao.all("(code like '%" + searchKey + "%' or name like '%" + searchKey + "%') and isDeleted='false' and enabled='true' order by code")
            .then(function (rows) {
                return cb(null, rows);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getTuicaiReasonsByCode = function (code, cb) {
        tuicaiReasonDao.all("code ='" + code + "'  and isDeleted='false' and enabled='true'")
            .then(function (rows) {
                var tuicaireason = null;
                if (rows.length > 0)
                    tuicaireason = rows[0];

                return cb(null, tuicaireason);
            }, function (error) {
                return cb(error.message);
            });
    };

    DiancaiService.doTuicai = function (operator, orderCaipin, tuicaiReason, selfTuicaiReason, num, cb) {
        var queries = [];
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        if (!Utils.isEmpty(selfTuicaiReason)) {
        }
        //todo 新增自定义退菜原因
        var reasonId = tuicaiReason == null ? null : tuicaiReason.guid;
        var reasonName = tuicaiReason == null ? selfTuicaiReason : tuicaiReason.name;
        var reasonType = tuicaiReason == null ? '0' : tuicaiReason.retype;

        var tuiOrderCaipin = new OrderCaipin();
        tuiOrderCaipin.guid = orderCaipinDao.guid();
        tuiOrderCaipin.orderId = orderCaipin.orderId;
        tuiOrderCaipin.caipinId = orderCaipin.caipinId;
        tuiOrderCaipin.caipinCode = orderCaipin.caipinCode;
        tuiOrderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_TUI;
        tuiOrderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE;
        tuiOrderCaipin.name = orderCaipin.name;
        tuiOrderCaipin.price = orderCaipin.price;
        tuiOrderCaipin.costprice = orderCaipin.costprice;
        tuiOrderCaipin.num = -num;
        tuiOrderCaipin.unitName = orderCaipin.unitName;
        tuiOrderCaipin.printId = orderCaipin.printId;
        tuiOrderCaipin.printName = orderCaipin.printName;
        tuiOrderCaipin.minAgio = orderCaipin.minAgio;
        tuiOrderCaipin.isScomb = orderCaipin.isScomb;
        tuiOrderCaipin.danPinBiLiZheKou = orderCaipin.danPinBiLiZheKou;
        tuiOrderCaipin.danPinJineZheKou = orderCaipin.danPinJineZheKou;
        tuiOrderCaipin.danPinZheKou = orderCaipin.danPinZheKou;
        tuiOrderCaipin.parentId = orderCaipin.guid;
        tuiOrderCaipin.tuicaiReasonId = reasonId;
        tuiOrderCaipin.tuicaiReasonName = reasonName;
        tuiOrderCaipin.operator = operator;
        tuiOrderCaipin.modTime = now;
        tuiOrderCaipin.tuicaiReasonType = reasonType;
        tuiOrderCaipin.zengNum = 0;
        tuiOrderCaipin.tuiNum = 0;
        tuiOrderCaipin.chupin = orderCaipin.chupin;
        tuiOrderCaipin.dianCaiYuan = orderCaipin.dianCaiYuan;
        tuiOrderCaipin.dianCaiTime = now;
        tuiOrderCaipin.luoDanTime = now;
        tuiOrderCaipin.caipinTypeId = orderCaipin.caipinTypeId;
        tuiOrderCaipin.caipinTypeCode = orderCaipin.caipinTypeCode;
        tuiOrderCaipin.caipinTypeName = orderCaipin.caipinTypeName;
        tuiOrderCaipin.orderZhuoTaiId = orderCaipin.orderZhuoTaiId;

        tuiOrderCaipin.dianCaiYuanName = orderCaipin.dianCaiYuanName;
        tuiOrderCaipin.hyPrice = orderCaipin.hyPrice;
        tuiOrderCaipin.caiwuTypeName = orderCaipin.caiwuTypeName;
        tuiOrderCaipin.caiwuTypeId = orderCaipin.caiwuTypeId;
        tuiOrderCaipin.firstGuid = orderCaipin.firstGuid ? orderCaipin.firstGuid : null;

        tuiOrderCaipin.bestTypeId = orderCaipin.bestTypeId;
        tuiOrderCaipin.bestTypeCode = orderCaipin.bestTypeCode;
        tuiOrderCaipin.bestTypeName = orderCaipin.bestTypeName;

        tuiOrderCaipin.priceChange = orderCaipin.priceChange;
        tuiOrderCaipin.customize = orderCaipin.customize;
        tuiOrderCaipin.unitId = orderCaipin.unitId;
        tuiOrderCaipin.cpdept = orderCaipin.cpdept;
        tuiOrderCaipin.cpdeptName = orderCaipin.cpdeptName;
        tuiOrderCaipin.dishFastNo = orderCaipin.dishFastNo;

        queries.push({
            query: "insert into pos_order_caipin (guid, orderId, caipinId, orderCaipinType, name, price, num, unitName, " +
            "printId, printName, minAgio,danPinBiLiZheKou,danPinJineZheKou,danPinZheKou, luodan, parentId, tuicaiReasonType, " +
            "tuicaiReasonId, tuicaiReasonName, operator, modTime,zengNum,tuiNum,chupin,dianCaiYuan,dianCaiTime,luoDanTime," +
            "caipinTypeId,caipinTypeCode,caipinTypeName,orderZhuoTaiId,dianCaiYuanName,hyPrice,caiwuTypeName,caiwuTypeId,firstGuid," +
            " orderZhuoTaiId,priceChange,customize,unitId,cpdept,cpdeptName,caipinCode,dishFastNo,costprice,bestTypeId,bestTypeCode,bestTypeName)" +
            " values(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
            params: [tuiOrderCaipin.guid, tuiOrderCaipin.orderId, tuiOrderCaipin.caipinId, tuiOrderCaipin.orderCaipinType, tuiOrderCaipin.name,
                tuiOrderCaipin.price, tuiOrderCaipin.num, tuiOrderCaipin.unitName, tuiOrderCaipin.printId, tuiOrderCaipin.printName, tuiOrderCaipin.minAgio,
                tuiOrderCaipin.danPinBiLiZheKou, tuiOrderCaipin.danPinJineZheKou, tuiOrderCaipin.danPinZheKou,
                tuiOrderCaipin.luodan, tuiOrderCaipin.parentId, tuiOrderCaipin.tuicaiReasonType, tuiOrderCaipin.tuicaiReasonId, tuiOrderCaipin.tuicaiReasonName,
                tuiOrderCaipin.operator, tuiOrderCaipin.modTime, tuiOrderCaipin.zengNum, tuiOrderCaipin.tuiNum, tuiOrderCaipin.chupin, tuiOrderCaipin.dianCaiYuan,
                tuiOrderCaipin.dianCaiTime, tuiOrderCaipin.luoDanTime, tuiOrderCaipin.caipinTypeId, tuiOrderCaipin.caipinTypeCode, tuiOrderCaipin.caipinTypeName,
                tuiOrderCaipin.orderZhuoTaiId, tuiOrderCaipin.dianCaiYuanName, tuiOrderCaipin.hyPrice, tuiOrderCaipin.caiwuTypeName, tuiOrderCaipin.caiwuTypeId,
                tuiOrderCaipin.firstGuid, tuiOrderCaipin.orderZhuoTaiId, tuiOrderCaipin.priceChange, tuiOrderCaipin.customize, tuiOrderCaipin.unitId, tuiOrderCaipin.cpdept,
                tuiOrderCaipin.cpdeptName,tuiOrderCaipin.caipinCode,tuiOrderCaipin.dishFastNo,tuiOrderCaipin.costprice,tuiOrderCaipin.bestTypeId,tuiOrderCaipin.bestTypeCode,tuiOrderCaipin.bestTypeName]
        });

        if (!Utils.isEmpty(orderCaipin.zuofas)) {
            var shenyu = orderCaipin.num - orderCaipin.tuiNum - orderCaipin.zengNum - num;
            for (var idx in orderCaipin.zuofas) {
                var dOrderCaipinZuofa = orderCaipin.zuofas[idx];
                //如果加价方式是数量加价，或者剩余数量为0并且定额加价，退菜需关联做法
                if (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_SHULIANG ||
                    (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_DINGE && shenyu == 0)) {
                    var orderCaipinZuofa = new OrderCaipinZuofa();
                    orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
                    orderCaipinZuofa.orderCaipinId = tuiOrderCaipin.guid;
                    orderCaipinZuofa.zuofaId = dOrderCaipinZuofa.zuofaId;
                    orderCaipinZuofa.name = dOrderCaipinZuofa.name;
                    orderCaipinZuofa.typeId = dOrderCaipinZuofa.typeId;
                    orderCaipinZuofa.price = dOrderCaipinZuofa.price;
                    orderCaipinZuofa.jiajiaType = dOrderCaipinZuofa.jiajiaType;
                    orderCaipinZuofa.operator = operator;
                    orderCaipinZuofa.modTime = now;
                    orderCaipinZuofa.parentCaiPin = tuiOrderCaipin;
                    tuiOrderCaipin.zuofas.push(orderCaipinZuofa);
                    queries.push({
                        query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime)" +
                        " values(?, ?, ?, ?, ?, ?, ?, ?, ?)",
                        params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                            orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator, orderCaipinZuofa.modTime]
                    });
                }
            }
        }
        orderCaipin.tuiNum += num;
        //queries.push({ query: "update pos_caipin_guqing set caipinNum=caipinNum+" + num + " where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipin.caipinId + "'" });
        queries.push({ query: "update pos_order_caipin set tuiNum=" + orderCaipin.tuiNum + " where guid='" + orderCaipin.guid + "'" });

        if (orderCaipin.isScombInfo()) {
            for (var i = 0; i < orderCaipin.scombCaipins.length; i++) {
                var tempScombCaipin = orderCaipin.scombCaipins[i];
                tempScombCaipin.orderCaipinId = tuiOrderCaipin.guid;//订单菜品ID 改成当前退菜的ID
                if (tempScombCaipin.num < 0 || tempScombCaipin.num - tempScombCaipin.tuiNum == 0) {

                    continue;
                }

                var tempNum = orderCaipin.num - num;
                if (tempNum == 0) {
                    tempNum = tempScombCaipin.num;
                } else {
                    tempNum = tempScombCaipin.num / orderCaipin.num * num;
                }
                queries = queries.concat(packScombTuicaiSQL(operator, tempScombCaipin, tuicaiReason, selfTuicaiReason, tempNum, tuiOrderCaipin))
            }
        }

        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            var ret = [];
            ret.push(orderCaipin); //原始的菜品
            ret.push(tuiOrderCaipin); //被退的菜品,打印使用
            orderCaipin.addTuiCai(tuiOrderCaipin);

            var _orderCaipin = Utils.clone(orderCaipin);
            _orderCaipin.num = num;
            if(reasonType != 1){
                GuqingService.TuicaiCaipinToGuqing(_orderCaipin, $rootScope.curUser, true, function (err, result) { });
            }
            cb(null, ret);
        }, function (err) {
            cb(err);
        });

    };


    function packScombTuicaiSQL(operator, orderCaipin, tuicaiReason, selfTuicaiReason, num, tuicaiScomb) {
        var queries = [];
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        if (!Utils.isEmpty(selfTuicaiReason)) {
        }
        //todo 新增自定义退菜原因
        var reasonId = tuicaiReason == null ? null : tuicaiReason.guid;
        var reasonName = tuicaiReason == null ? selfTuicaiReason : tuicaiReason.name;
        var tuiOrderCaipin = new OrderCaipin();
        tuiOrderCaipin.guid = orderCaipinDao.guid();
        tuiOrderCaipin.orderCaipinId = orderCaipin.orderCaipinId;
        tuiOrderCaipin.scombId = orderCaipin.scombId;
        tuiOrderCaipin.caipinId = orderCaipin.caipinId;
        tuiOrderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_TUI;
        tuiOrderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE;
        tuiOrderCaipin.name = orderCaipin.name;
        tuiOrderCaipin.price = orderCaipin.price;
        tuiOrderCaipin.num = -num;
        tuiOrderCaipin.unitName = orderCaipin.unitName;
        tuiOrderCaipin.printId = orderCaipin.printId;
        tuiOrderCaipin.printName = orderCaipin.printName;
        tuiOrderCaipin.minAgio = orderCaipin.minAgio;
        tuiOrderCaipin.danPinBiLiZheKou = orderCaipin.danPinBiLiZheKou;
        tuiOrderCaipin.danPinJineZheKou = orderCaipin.danPinJineZheKou;
        tuiOrderCaipin.danPinZheKou = orderCaipin.danPinZheKou;
        tuiOrderCaipin.parentId = orderCaipin.guid;
        tuiOrderCaipin.tuicaiReasonId = reasonId;
        tuiOrderCaipin.tuicaiReasonName = reasonName;
        tuiOrderCaipin.operator = operator;
        tuiOrderCaipin.modTime = now;
        tuiOrderCaipin.isScomb = orderCaipin.isScomb;
        tuiOrderCaipin.scombMainCaipinId = orderCaipin.scombMainCaipinId;


        queries.push({
            query: "insert into pos_order_scomb_caipin (guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, unitName, " +
            "printId, printName, minAgio,danPinBiLiZheKou,danPinJineZheKou,danPinZheKou, luodan, parentId, tuicaiReasonId, tuicaiReasonName, operator, " +
           " modTime,isScomb,scombMainCaipinId)" +
            " values(?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?)",
            params: [tuiOrderCaipin.guid, tuiOrderCaipin.orderCaipinId, tuiOrderCaipin.scombId, tuiOrderCaipin.caipinId, tuiOrderCaipin.orderCaipinType,
                tuiOrderCaipin.name, tuiOrderCaipin.price, tuiOrderCaipin.num, tuiOrderCaipin.unitName, tuiOrderCaipin.printId, tuiOrderCaipin.printName,
                tuiOrderCaipin.minAgio, tuiOrderCaipin.danPinBiLiZheKou, tuiOrderCaipin.danPinJineZheKou, tuiOrderCaipin.danPinZheKou,
                tuiOrderCaipin.luodan, tuiOrderCaipin.parentId, tuiOrderCaipin.tuicaiReasonId, tuiOrderCaipin.tuicaiReasonName,
                tuiOrderCaipin.operator, tuiOrderCaipin.modTime, tuiOrderCaipin.isScomb, tuiOrderCaipin.scombMainCaipinId]
        });

        if (!Utils.isEmpty(orderCaipin.zuofas)) {
            var shenyu = orderCaipin.num - orderCaipin.tuiNum - orderCaipin.zengNum - num;
            for (var idx in orderCaipin.zuofas) {
                var dOrderCaipinZuofa = orderCaipin.zuofas[idx];
                //如果加价方式是数量加价，或者剩余数量为0并且定额加价，退菜需关联做法
                if (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_SHULIANG ||
                    (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_DINGE && shenyu == 0)) {
                    var orderCaipinZuofa = new OrderCaipinZuofa();
                    orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
                    orderCaipinZuofa.orderCaipinId = dOrderCaipinZuofa.orderCaipinId;
                    orderCaipinZuofa.zuofaId = dOrderCaipinZuofa.zuofaId;
                    orderCaipinZuofa.name = dOrderCaipinZuofa.name;
                    orderCaipinZuofa.typeId = dOrderCaipinZuofa.typeId;
                    orderCaipinZuofa.price = dOrderCaipinZuofa.price;
                    orderCaipinZuofa.jiajiaType = dOrderCaipinZuofa.jiajiaType;
                    orderCaipinZuofa.operator = operator;
                    orderCaipinZuofa.modTime = now;
                    // orderCaipinZuofa.parentCaiPin = tuiOrderCaipin;
                    orderCaipinZuofa.isScomb = orderCaipin.isScomb;
                    orderCaipinZuofa.orderScombCaipinId = tuiOrderCaipin.guid;

                    tuiOrderCaipin.zuofas.push(orderCaipinZuofa);
                    queries.push({
                        query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime," +
                        "isScomb,orderScombCaipinId)" +
                        " values(?, ?, ?, ?, ?, ?, ?, ?, ?,?,?)",
                        params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                            orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator,
                            orderCaipinZuofa.modTime, orderCaipinZuofa.isScomb, orderCaipinZuofa.orderScombCaipinId]
                    });
                }
            }
        }
        orderCaipin.tuiNum += num;
        queries.push({ query: "update pos_caipin_guqing set caipinNum=caipinNum+" + num + " where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipin.caipinId + "'" });
        queries.push({ query: "update pos_order_scomb_caipin set tuiNum=" + orderCaipin.tuiNum + " where guid='" + orderCaipin.guid + "'" });

        if (tuicaiScomb != null) {
            tuicaiScomb.scombCaipins.push(tuiOrderCaipin);
        }

        return queries;
    }



    DiancaiService.doScombTuicai = function (operator, orderCaipin, tuicaiReason, selfTuicaiReason, num, cb) {
        var queries = [];
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        if (!Utils.isEmpty(selfTuicaiReason)) {
        }
        //todo 新增自定义退菜原因
        var reasonId = tuicaiReason == null ? null : tuicaiReason.guid;
        var reasonName = tuicaiReason == null ? selfTuicaiReason : tuicaiReason.name;
        var reasonType = tuicaiReason == null ? '0' : tuicaiReason.retype;

        var tuiOrderCaipin = new OrderCaipin();
        tuiOrderCaipin.guid = orderCaipinDao.guid();
        tuiOrderCaipin.orderCaipinId = orderCaipin.orderCaipinId;
        tuiOrderCaipin.scombId = orderCaipin.scombId;
        tuiOrderCaipin.caipinId = orderCaipin.caipinId;
        tuiOrderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_TUI;
        tuiOrderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE;
        tuiOrderCaipin.name = orderCaipin.name;
        tuiOrderCaipin.price = orderCaipin.price;
        tuiOrderCaipin.num = -num;
        tuiOrderCaipin.unitName = orderCaipin.unitName;
        tuiOrderCaipin.printId = orderCaipin.printId;
        tuiOrderCaipin.printName = orderCaipin.printName;
        tuiOrderCaipin.minAgio = orderCaipin.minAgio;
        tuiOrderCaipin.danPinBiLiZheKou = orderCaipin.danPinBiLiZheKou;
        tuiOrderCaipin.danPinJineZheKou = orderCaipin.danPinJineZheKou;
        tuiOrderCaipin.danPinZheKou = orderCaipin.danPinZheKou;
        tuiOrderCaipin.parentId = orderCaipin.guid;
        tuiOrderCaipin.tuicaiReasonId = reasonId;
        tuiOrderCaipin.tuicaiReasonName = reasonName;
        tuiOrderCaipin.operator = operator;
        tuiOrderCaipin.modTime = now;
        tuiOrderCaipin.isScomb = orderCaipin.isScomb;
        tuiOrderCaipin.scombMainCaipinId = orderCaipin.scombMainCaipinId;
        tuiOrderCaipin.tuicaiReasonType = reasonType;

        queries.push({
            query: "insert into pos_order_scomb_caipin (guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, unitName, " +
            "printId, printName, minAgio,danPinBiLiZheKou,danPinJineZheKou,danPinZheKou, luodan, parentId,tuicaiReasonType, tuicaiReasonId, tuicaiReasonName, operator, " +
           " modTime,isScomb,scombMainCaipinId)" +
            " values(?, ?, ?, ?, ?, ?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?)",
            params: [tuiOrderCaipin.guid, tuiOrderCaipin.orderCaipinId, tuiOrderCaipin.scombId, tuiOrderCaipin.caipinId, tuiOrderCaipin.orderCaipinType,
                tuiOrderCaipin.name, tuiOrderCaipin.price, tuiOrderCaipin.num, tuiOrderCaipin.unitName, tuiOrderCaipin.printId, tuiOrderCaipin.printName,
                tuiOrderCaipin.minAgio, tuiOrderCaipin.danPinBiLiZheKou, tuiOrderCaipin.danPinJineZheKou, tuiOrderCaipin.danPinZheKou,
                tuiOrderCaipin.luodan, tuiOrderCaipin.parentId, tuiOrderCaipin.tuicaiReasonType, tuiOrderCaipin.tuicaiReasonId, tuiOrderCaipin.tuicaiReasonName,
                tuiOrderCaipin.operator, tuiOrderCaipin.modTime, tuiOrderCaipin.isScomb, tuiOrderCaipin.scombMainCaipinId]
        });

        if (!Utils.isEmpty(orderCaipin.zuofas)) {
            var shenyu = orderCaipin.num - orderCaipin.tuiNum - orderCaipin.zengNum - num;
            for (var idx in orderCaipin.zuofas) {
                var dOrderCaipinZuofa = orderCaipin.zuofas[idx];
                //如果加价方式是数量加价，或者剩余数量为0并且定额加价，退菜需关联做法
                if (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_SHULIANG ||
                    (dOrderCaipinZuofa.jiajiaType == BIZCONSTANT.JIAJIATYPE_DINGE && shenyu == 0)) {
                    var orderCaipinZuofa = new OrderCaipinZuofa();
                    orderCaipinZuofa.guid = orderCaipinZuofaDao.guid();
                    orderCaipinZuofa.orderCaipinId = dOrderCaipinZuofa.orderCaipinId;
                    orderCaipinZuofa.zuofaId = dOrderCaipinZuofa.zuofaId;
                    orderCaipinZuofa.name = dOrderCaipinZuofa.name;
                    orderCaipinZuofa.typeId = dOrderCaipinZuofa.typeId;
                    orderCaipinZuofa.price = dOrderCaipinZuofa.price;
                    orderCaipinZuofa.jiajiaType = dOrderCaipinZuofa.jiajiaType;
                    orderCaipinZuofa.operator = operator;
                    orderCaipinZuofa.modTime = now;
                    // orderCaipinZuofa.parentCaiPin = tuiOrderCaipin;
                    orderCaipinZuofa.isScomb = orderCaipin.isScomb;
                    orderCaipinZuofa.orderScombCaipinId = tuiOrderCaipin.guid;

                    tuiOrderCaipin.zuofas.push(orderCaipinZuofa);
                    queries.push({
                        query: "insert into pos_order_caipin_zuofa (guid, orderCaipinId, zuofaId, name, typeId, price, jiajiaType, operator, modTime," +
                        "isScomb,orderScombCaipinId)" +
                        " values(?, ?, ?, ?, ?, ?, ?, ?, ?,?,?)",
                        params: [orderCaipinZuofa.guid, orderCaipinZuofa.orderCaipinId, orderCaipinZuofa.zuofaId, orderCaipinZuofa.name,
                            orderCaipinZuofa.typeId, orderCaipinZuofa.price, orderCaipinZuofa.jiajiaType, orderCaipinZuofa.operator,
                            orderCaipinZuofa.modTime, orderCaipinZuofa.isScomb, orderCaipinZuofa.orderScombCaipinId]
                    });
                }
            }
        }
        orderCaipin.tuiNum += num;
        queries.push({ query: "update pos_caipin_guqing set caipinNum=caipinNum+" + orderCaipin.num + " where startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipin.caipinId + "'" });
        queries.push({ query: "update pos_order_scomb_caipin set tuiNum=" + orderCaipin.tuiNum + " where guid='" + orderCaipin.guid + "'" });



        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            var ret = [];
            ret.push(orderCaipin);
            tuiOrderCaipin.isScomb = null;
            ret.push(tuiOrderCaipin);
            cb(null, ret);
        }, function (err) {
            cb(err);
        });

    };




    DiancaiService.doQicai = function (operator, orderCaipin, cb) {
        var queries = updateCaipinSate(operator, orderCaipin, BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI);
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            //todo 向厨房发送起菜指令
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };

    DiancaiService.doCuicai = function (operator, orderCaipin, cb) {
        var queries = updateCaipinSate(operator, orderCaipin, BIZCONSTANT.ORDER_CAIPIN_CHUPIN_FAST);
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            //todo 向厨房发送起菜指令
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };



    DiancaiService.doDengjiao = function (operator, orderCaipin, cb) {
        var queries = updateCaipinSate(operator, orderCaipin, BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JIAO);
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            //todo 向厨房发送等叫指令
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };


    function updateCaipinSate(operator, orderCaipin, state) {
        orderCaipin.chupin = state;
        orderCaipin.operator = operator;
        orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        if (orderCaipin.isScombCaipin()) {
            queries.push({
                query: "update pos_order_scomb_caipin" +
                " set chupin='" + orderCaipin.chupin + "',operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
                " where guid='" + orderCaipin.guid + "'"
            });
        } else {
            queries.push({
                query: "update pos_order_caipin" +
                " set chupin='" + orderCaipin.chupin + "',operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime + "'" +
                " where guid='" + orderCaipin.guid + "'"
            });
            if (orderCaipin.isScombInfo()) {
                for (var i = 0; i < orderCaipin.scombCaipins.length; i++) {
                    queries = queries.concat(updateCaipinSate(operator, orderCaipin.scombCaipins[i], state));
                }
            }
        }
        return queries;
    }





    /* 赠送 */
    DiancaiService.getZengsongReasons = function (cb) {
        zengsongReasonDao.all("isDeleted='false' and enabled='true' order by code")
            .then(function (rows) {
                return cb(null, rows);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getZengsongReasonsBySearchKey = function (searchKey, cb) {
        zengsongReasonDao.all("(code like '%" + searchKey + "%' or name like '%" + searchKey + "%') and isDeleted='false' and enabled='true' order by code")
            .then(function (rows) {
                return cb(null, rows);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.getZengsongReasonsByCode = function (code, cb) {
        console.info(code);
        zengsongReasonDao.all("code = '" + code + "' or code='" + BIZCONSTANT.SELFZENGSONG_REASON_CODE + "'  and isDeleted='false' and enabled='true' order by code")
            .then(function (rows) {
                var reason = null;
                if (rows.length == 1)
                    reason = rows[0];
                else if (rows.length > 1) {
                    for (var i in rows) {
                        if (rows[i].code != BIZCONSTANT.SELFZENGSONG_REASON_CODE)
                            reason = rows[i];
                    }
                }
                if (reason != null && reason.code == BIZCONSTANT.SELFZENGSONG_REASON_CODE) {
                    reason = Utils.clone(reason);
                    reason.name = code;
                }
                console.info(reason);
                return cb(null, reason);
            }, function (error) {
                return cb(error);
            });
    };

    DiancaiService.doZengsong = function (operator, orderCaipin, zengsongReason, num, cb) {
        var queries = [];
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var reasonId = zengsongReason == null ? null : zengsongReason.guid;

        queries.push({
            query: "insert into pos_order_caipin_zengsong (guid, orderCaipinId, reasonId, reasonName, num, operator, modTime)" +
            " values(?, ?, ?, ?, ?, ?, ?)",
            params: [orderCaipinZengsongDao.guid(), orderCaipin.guid, reasonId, zengsongReason.name, num, operator, now]
        });

        orderCaipin.zengNum += num;
        //记录赠送金额
        var zengSongMoney = orderCaipin.mFree() + orderCaipin.calFreeTotal4ZuoFa();
        queries.push({
            query: "update pos_order_caipin set zengNum=" + orderCaipin.zengNum + ",operator='" + operator + "', modTime='" + now + "', zengSongMoney=" + zengSongMoney +
            " where guid='" + orderCaipin.guid + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });

    };

    DiancaiService.doCancelZengsong = function (operator, orderCaipin, cb) {
        var queries = [];
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");

        queries.push({ query: "delete from pos_order_caipin_zengsong where orderCaipinId='" + orderCaipin.guid + "'" });

        orderCaipin.zengNum = 0;
        queries.push({
            query: "update pos_order_caipin set zengNum=" + orderCaipin.zengNum + ", operator='" + operator + "', modTime='" + now + "', zengSongMoney=0 " +
            " where guid='" + orderCaipin.guid + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });

    };

    /* 打折 */
    DiancaiService.doDazhe = function (orderCaipin, bili, jine, cb) {
        var queries = [];

        if (bili != 0) {
            queries.push({ query: "update pos_order_caipin set danPinBiLiZheKou=" + bili + ",danPinZheKou=1 where guid='" + orderCaipin.guid + "'" });
            //如果有退菜，退菜需关联折扣
            if (orderCaipin.tuiNum != null && orderCaipin.tuiNum != 0) {
                queries.push({ query: "update pos_order_caipin set danPinBiLiZheKou=" + bili + ",danPinZheKou=1 where parentId='" + orderCaipin.guid + "'" });
            }
            orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                orderCaipin.setDanPinBiLi(bili);
                cb(null, orderCaipin);

            }, function (err) {
                cb(err);
            });

        }
            //单品金额暂时不需要。
            //else if (jine != 0) {
            //    orderCaipin.danPinJineZheKou = jine;
            //    queries.push({ query: "update pos_order_caipin set danPinjineZheKou=" + jine + ",danPinZheKou=1 where guid='" + orderCaipin.guid + "'" });
            //    //如果有退菜，退菜需关联折扣
            //    if (orderCaipin.tuiNum != null && orderCaipin.tuiNum != 0) {
            //        queries.push({ query: "update pos_order_caipin set danPinjineZheKou=" + jine + ",danPinZheKou=1 where parentId='" + orderCaipin.guid + "'" });
            //    }
            //    orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            //        cb(null, orderCaipin);
            //    }, function (err) {
            //        cb(err);
            //    });
            //}
        else {
            cb("打折比例和金额不能同时为0");
        }

    };

    DiancaiService.doCancelDazhe = function (orderCaipin, cb) {
        var queries = [];
        queries.push({ query: "update pos_order_caipin set danPinBiLiZheKou=0,danPinJineZheKou=0,danPinZheKou=0 where guid='" + orderCaipin.guid + "'" });
        //如果有退菜，需取消关联折扣
        if (orderCaipin.tuiNum != null && orderCaipin.tuiNum != 0) {
            queries.push({ query: "update pos_order_caipin set danPinBiLiZheKou=0,danPinJineZheKou=0,danPinZheKou=0 where parentId='" + orderCaipin.guid + "'" });
        }
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            orderCaipin.setDanPinBiLi(null);
            cb(null, orderCaipin);

        }, function (err) {
            cb(err);
        });

    };

    /* 重量确认 */
    DiancaiService.zhonglqueren = function (orderCaipin, zhongliangqueren, cb, xcz,tzsquren,notes,kbjPrice) {
        var queries = [];
        if (zhongliangqueren != 0) {
            orderCaipin.num = zhongliangqueren;
            //即是可变价又是需称重菜品，更新价格
            if(kbjPrice){
                orderCaipin.price = kbjPrice;
                queries.push({ query: "update pos_order_caipin set price=" + kbjPrice + ", hyPrice=" + kbjPrice + " where guid='" + orderCaipin.guid + "'" });
            }

            //更新num(重量的数据)
            queries.push({ query: "update pos_order_caipin set num=" + zhongliangqueren + " where guid='" + orderCaipin.guid + "'" });

            //如果有退菜，退菜需关联重量
            if (orderCaipin.tuiNum != null && orderCaipin.tuiNum != 0) {
                queries.push({ query: "update pos_order_caipin set num= -" + zhongliangqueren + " where parentId='" + orderCaipin.guid + "'" });
            }

            if(tzsquren){
                queries.push({ query: "update pos_order_caipin set tiaoZhiNum='" + tzsquren + "' where guid='" + orderCaipin.guid + "'" });
            }

            if( notes && notes != ' '){

                queries.push({ query: "DELETE FROM pos_order_caipin_kouwei WHERE orderCaipinId  = '" + orderCaipin.guid + "' AND kwId IN(SELECT guid FROM pos_kouwei WHERE kwCode = '01')" });

                var orderCaipinKouwei = new OrderCaipinKouwei();
                orderCaipinKouwei.guid = orderCaipinKouweiDao.guid();
                orderCaipinKouwei.orderCaipinId = orderCaipin.guid;
                //orderCaipinKouwei.kwId = "SELECT guid FROM pos_kouwei WHERE kwCode = '01'";
                orderCaipinKouwei.name = notes;
                orderCaipinKouwei.operator = $rootScope.curUser.id;
                orderCaipinKouwei.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                orderCaipinKouwei.isScomb = false;
                orderCaipin.kouweis.push(orderCaipinKouwei);
                queries.push({
                    query: "insert into pos_order_caipin_kouwei (guid, orderCaipinId, kwId, name, operator, modTime,isScomb)" +
                    " values('" + orderCaipinKouwei.guid + "','"  + orderCaipinKouwei.orderCaipinId + "',(SELECT guid FROM pos_kouwei WHERE kwCode = '01'),'"  + orderCaipinKouwei.name + "','"  + orderCaipinKouwei.operator + "','"  + orderCaipinKouwei.modTime + "','"  + orderCaipinKouwei.isScomb + "')"
                });
            }

            //debugger;
            if (orderCaipin.needweigh == 1 && orderCaipin.luodan == BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE || xcz) {
                queries.push({
                    query: "update pos_order_caipin" +
                    " set needweigh=2" +
                    " where guid='" + orderCaipin.guid + "'"
                });
                orderCaipin.needweigh = 2;
            }
            console.log(queries)
            orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                cb(null, orderCaipin);
            }, function (err) {
                cb(err);
            });
        }
    }
    /* 修改总金额*/
    DiancaiService.updateOrderTotalPrice = function (order, price, cb) {
        order.totalPrice = price;
        var queries = [];
        queries.push({ query: "update pos_order set totalPrice=" + price + " where guid='" + order.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order);
        }, function (err) {
            cb(err);
        });
    };

    /* 修改orderZhuotai总金额*/
    DiancaiService.updateOrderZhuotaiTotalPrice = function (orderZhuotai, price, cb) {
        orderZhuotai.totalPrice = price;
        var queries = [];
        queries.push({ query: "update pos_order_zhuotai set totalPrice=" + price + " where guid='" + orderZhuotai.guid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderZhuotai);
        }, function (err) {
            cb(err);
        });
    };

    //订单预结
    DiancaiService.orderYuJie = function (orderid, cb) {
        var queries = [];
        queries.push({ query: "update pos_order set status='" + BIZCONSTANT.ORDER_STATUS_YI_YuJie + "' where guid='" + orderid + "'" });
        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, orderid);
        }, function (err) {
            cb(err);
        });
    }
        
    //查找用户名
    DiancaiService.kehuming = function (obj, cb) {
        var sql = "select * from pos_order where guid = '" + obj.guid +"'";
        console.log(sql);
        orderDao.query(sql).then(function (res) {
            cb(null, res);
        }, function (err) {
            cb(err);
        });
        
    }
    //查找支付类别
    DiancaiService.getJieSuanId = function (jiesuanid, cb) {
        var sql = "select * from pos_billing_detail where jieSuanId = '" + jiesuanid +"'";
        console.log(sql);
        orderDao.query(sql).then(function (res) {
            cb(null, res);
        }, function (err) {
            cb(err);
        });

    }

    //快餐-新建空账单，结算单
    DiancaiService.createFastBlankOrder = function (paihao, cb) {
        var orderId = orderDao.guid();
        var jieSuanId = Utils.guid();
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var order = new Order();
        order.guid = orderId;
        order.renshu = 1;
        order.serverId = $rootScope.curUser.code;
        order.serverName = $rootScope.curUser.name;
        order.serverGuid = $rootScope.curUser.id;
        order.operator = $rootScope.curUser.id;
        order.operatorName = $rootScope.curUser.name;
        order.operatorCode = $rootScope.curUser.code;
        order.mdId = $rootScope.curUser.mdId;
        order.modTime = now;
        order.kaiTaiTime = now;
        order.isFanJieSuan = BIZCONSTANT.FANJIESUAN_NO;
        order.fanJieSuanNum = 0;
        var canbie = BIZCONSTANT.POSUSER.getCanBieGroup().getCanBieByTime(new Date());
        order.canbieId = canbie.guid;
        order.canBieCode = canbie.code;
        order.canbieName = canbie.name;
        order.jieSuanId = jieSuanId;
        order.ordersource = ORDERSOURCE.FAST;
        order.areaGuid = "9999";
        order.areaCode = "9999";
        order.areaName = "快餐";
        order.tsAndwm  = "TS";
        order.zhuotaiId = paihao;
        order.zhuotaiCode = paihao;
        order.zhuotaiName = paihao;

        var queries = [];
        queries.push({
            query: "insert into pos_order ( " +
            "guid, renshu, totalPrice, status," +
            " serverId, serverName," +
            " operator, operatorName,operatorCode, mdId," +
            " modTime, kaiTaiTime, isDeleted," +
            " isFanJieSuan, fanJieSuanNum,canBieCode,canBieName,canBieId,jieSuanId, ordersource, areaGuid, areaCode, areaName, zhuotaiId, zhuotaiCode, zhuotaiName, tsAndwm) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?)",
            params: [order.guid, 1, 0 , 1,
                order.serverId, order.serverName,
                order.operator, order.operatorName, order.operatorCode, order.mdId,
                order.modTime,order.kaiTaiTime, false,
                order.isFanJieSuan, 0, order.canBieCode, order.canbieName,order.canbieId, order.jieSuanId, order.ordersource,
                order.areaGuid, order.areaCode, order.areaName, order.zhuotaiId, order.zhuotaiCode, order.zhuotaiName,order.tsAndwm]
        });

        //生成orderZhuotai数据
        var orderZhuotai = new OrderZhuotai();
        orderZhuotai.guid = Utils.guid();
        orderZhuotai.orderId = orderId;
        orderZhuotai.areaId = "9999";
        orderZhuotai.areaCode = "9999";
        orderZhuotai.areaName = "快餐";
        orderZhuotai.renshu = 1;
        orderZhuotai.isDeleted = "false";
        orderZhuotai.zhuotaiId = paihao;
        orderZhuotai.zhuotaiCode = paihao;
        orderZhuotai.zhuotaiName = paihao;
        queries.push({
            query: "insert into pos_order_zhuotai ( " +
            "guid, orderId, areaId, areaCode, areaName, renshu, isDeleted, zhuotaiId, zhuotaiCode, zhuotaiName) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
            params: [orderZhuotai.guid, orderZhuotai.orderId, orderZhuotai.areaId, orderZhuotai.areaCode, orderZhuotai.areaName,orderZhuotai.renshu, orderZhuotai.isDeleted,
                orderZhuotai.zhuotaiId, orderZhuotai.zhuotaiCode, orderZhuotai.zhuotaiName]
        });


        //建立空的结算单
        queries.push({
            query: "insert into pos_billing ( " +
            "guid, orderId) " +
            "values (?, ?)",
            params: [jieSuanId, orderId]
        });

        orderDao.queryTransaction(queries).then(function (resultList) {
            cb(null, order, orderZhuotai);
        }, function (err) {
            cb(err);
        });

    }

    //快餐-新增一个菜品到定单
    DiancaiService.fastAddOrderCaipin = function (operator, order, caipin, cb) {
        var orderCaipin = fastCreateOrderCaipin(operator, order, caipin);
        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin ( " +
            "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId," +
            "caipinTypeCode,caipinTypeName,caiwuTypeName,caiwuTypeId, priceChange) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?, ?, ?, ?)",
            params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime,
                orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.caiwuTypeName, orderCaipin.caiwuTypeId, orderCaipin.priceChange]
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, orderCaipin);
        }, function (err) {
            cb(err);
        });
    };


    /*快餐-新增订单套餐*/
    DiancaiService.fastAddOrderScomb = function (operator, order, orderScomb, cb) {
        var orderCaipin = fastCreateOrderCaipin(operator, order, orderScomb.getScombInfo());
        var queries = [];
        queries.push({
            query: "insert into pos_order_caipin ( " +
            "guid, orderId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,costprice," +
            "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
            "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?)",
            params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price, orderCaipin.num,
                orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName, orderCaipin.chupin, orderCaipin.minAgio,
                orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou, orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan,
                orderCaipin.dianCaiYuanName, orderCaipin.dianCaiTime, orderCaipin.modTime, orderCaipin.needweigh, orderCaipin.isScomb, orderCaipin.costprice,
                orderCaipin.hyPrice, orderCaipin.caipinTypeId, orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName]
        });

        var scombCaipins = orderScomb.getScombCaipin();
        for (var i = 0; i < scombCaipins.length; i++) {
            var scombCaipin = fastCreateOrderScombCaipin(operator, orderCaipin, orderScomb.getScombCaipin()[i].scombCaipinInfo);

            orderCaipin.scombCaipins.push(scombCaipin);

            queries.push({
                query: "insert into pos_order_scomb_caipin ( " +
                "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
                "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
                "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?,?,?,?,?,?,?,?)",
                params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                    scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                    scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                    scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName, scombCaipin.dianCaiTime, scombCaipin.modTime,
                    scombCaipin.needweigh, orderCaipin.isScomb, scombCaipin.caipinId, scombCaipin.costprice,
                    scombCaipin.hyPrice, scombCaipin.caipinTypeId, scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName]
            });
        }

        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            return cb(null, orderCaipin);
        }, function (err) {
            return cb(err);
        });
    }

    //快餐-新建OrderCaipin
    function fastCreateOrderCaipin(operator, order, caipin) {
        var num = 1;
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var orderCaipin = new OrderCaipin();
        orderCaipin.guid = orderCaipinDao.guid();
        orderCaipin.orderId = order.guid;
        orderCaipin.caipinId = caipin.guid;
        orderCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        orderCaipin.name = caipin.name;
        orderCaipin.price = caipin.salePrice;
        orderCaipin.costprice = caipin.costprice;
        orderCaipin.num = num;
        orderCaipin.tuiNum = 0;
        orderCaipin.zengNum = 0;
        orderCaipin.unitName = caipin.unitName;
        orderCaipin.printId = caipin.printId;
        orderCaipin.printName = caipin.printName;
        orderCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        orderCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        orderCaipin.minAgio = caipin.minAgio;
        orderCaipin.danPinBiLiZheKou = 0;
        orderCaipin.danPinJineZheKou = 0;
        orderCaipin.danPinZheKou = 0;
        orderCaipin.operator = operator.id;
        orderCaipin.dianCaiYuan = order.serverGuid;
        orderCaipin.dianCaiYuanName = order.serverName;
        orderCaipin.dianCaiTime = now;
        orderCaipin.modTime = now;
        orderCaipin.needweigh = caipin.needweigh ? 1 : 0;
        orderCaipin.isScomb = null == caipin.isScomb ? 'false' : caipin.isScomb;
        orderCaipin.priceChange = null == caipin.priceChange ? 'false' : caipin.priceChange;

        orderCaipin.hyPrice = caipin.hyPrice;
        orderCaipin.caipinTypeId = caipin.typeId;

        orderCaipin.caipinTypeCode = caipin.cpTypeCode;
        orderCaipin.caipinTypeName = caipin.cpTypeName;

        orderCaipin.customize = caipin.customize; //是否是自定义菜品字段，pos竖屏需要

        orderCaipin.caiwuTypeName = caipin.caiwuTypeName;
        orderCaipin.caiwuTypeId = caipin.caiwuTypeId;

        return orderCaipin;
    }

    function fastCreateOrderScombCaipin(operator, orderCaipin, caipin) {
        var num = 1;
        if (caipin.caipinNum > 1)
            num = caipin.caipinNum;
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var scombCaipin = new OrderCaipin();
        scombCaipin.guid = orderScombCaipinDao.guid();

        scombCaipin.orderCaipinId = orderCaipin.guid;//订单中套餐菜品GUID
        scombCaipin.scombId = orderCaipin.caipinId;//套餐的GUID

        scombCaipin.caipinId = caipin.guid;
        scombCaipin.orderCaipinType = BIZCONSTANT.ORDER_CAIPIN_TYPE_DIAN;
        scombCaipin.name = caipin.name;
        scombCaipin.price = caipin.salePrice;
        scombCaipin.costprice = caipin.costprice;
        scombCaipin.num = num;
        scombCaipin.tuiNum = 0;
        scombCaipin.zengNum = 0;
        scombCaipin.unitName = caipin.unitName;
        scombCaipin.printId = caipin.printId;
        scombCaipin.printName = caipin.printName;
        scombCaipin.chupin = BIZCONSTANT.ORDER_CAIPIN_CHUPIN_JI;
        scombCaipin.luodan = BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE;
        scombCaipin.minAgio = caipin.minAgio;
        scombCaipin.danPinBiLiZheKou = 0;
        scombCaipin.danPinJineZheKou = 0;
        scombCaipin.danPinZheKou = 0;
        scombCaipin.operator = operator.id;
        scombCaipin.dianCaiYuan = orderCaipin.serverGuid;
        scombCaipin.dianCaiYuanName = orderCaipin.serverName;
        scombCaipin.dianCaiTime = now;
        scombCaipin.modTime = now;
        scombCaipin.needweigh = caipin.needweigh ? 1 : 0;
        scombCaipin.isScomb = 'true';
        scombCaipin.scombMainCaipinId = caipin.guid;


        scombCaipin.hyPrice = caipin.hyPrice;
        scombCaipin.caipinTypeId = caipin.typeId;
        scombCaipin.caipinTypeCode = caipin.typeCode;
        scombCaipin.caipinTypeName = caipin.typeName;

        return scombCaipin;
    }

    //快餐-获取账单菜品明细
    DiancaiService.fastGetOrderCaipinsByLuodan = function (orderId, luodan, cb) {
        var sql = "select o.guid as o_guid, o.orderId as o_orderId, o.caipinId as o_caipinId, o.name as o_name, o.price as o_price, o.num as o_num," +
            "ifnull(o.tuiNum,0) as o_tuiNum, ifnull(o.zengNum,0) as o_zengNum, o.unitName as o_unitName, o.printId as o_printId, o.printName as o_printName, o.chupin as o_chupin," +
            "o.hyPrice as o_hyPrice, o.caiwuTypeName as o_caiwuTypeName, o.caiwuTypeId as o_caiwuTypeId,  o.firstGuid as o_firstGuid, o.priceChange as o_priceChange," +

            "o.luodan as o_luodan,o.minAgio as o_minAgio, o.danPinBiLiZheKou as o_danPinBiLiZheKou, o.danPinJineZheKou as o_danPinJineZheKou," +
            "o.danPinZheKou as o_danPinZheKou,o.dianCaiYuan as o_dianCaiYuan,o.dianCaiYuanName as o_dianCaiYuanName, o.operator as o_operator," +
            "o.dianCaiTime as o_dianCaiTime,o.luoDanTime as o_luoDanTime,o.chuPinTime as o_chuPinTime, o.modTime as o_modTime,o.isScomb as o_isScomb," +
            "o.parentId as o_parentId,o.caipinTypeId as o_caipinTypeId,o.caipinTypeCode as o_caipinTypeCode,o.caipinTypeName as o_caipinTypeName," +
            "k.guid as k_guid, k.kwId as k_kwId, k.name as k_name, k.operator as k_operator, k.modTime as k_modTime," +
            "z.guid as z_guid, z.zuofaId as z_zuofaId, z.name as z_name, z.typeId as z_typeId, z.price as z_price, z.jiajiaType as z_jiajiaType," +
            "z.operator as z_operator, z.modTime as z_modTime,o.needweigh as needweigh, " +
            "osc.guid AS osc_guid,osc.caipinId AS osc_caipinId,	osc.name AS osc_name,	osc.price AS osc_price,	osc.num AS osc_num," +
            "osc.tuiNum AS osc_tuiNum,osc.zengNum AS osc_zengNum,	osc.unitName AS osc_unitName,osc.printId AS osc_printId," +
            "osc.printName AS osc_printName,osc.chupin AS osc_chupin,osc.luodan AS osc_luodan,	osc.minAgio AS osc_minAgio," +
            "osc.danPinBiLiZheKou AS osc_danPinBiLiZheKou,	osc.danPinJineZheKou AS osc_danPinJineZheKou," +
            "osc.danPinZheKou AS osc_danPinZheKou,	osc.dianCaiYuan AS osc_dianCaiYuan,	osc.dianCaiYuanName AS osc_dianCaiYuanName," +
            "osc.operator AS osc_operator,osc.dianCaiTime AS osc_dianCaiTime,	osc.luoDanTime AS osc_luoDanTime," +
            "osc.chuPinTime AS osc_chuPinTime,	osc.modTime AS osc_modTime,osc.parentId as osc_parentId,osck.guid AS osck_guid,	" +
            "osck.kwId AS osck_kwId,osck.name AS osck_name,osck.operator AS osck_operator,osck.modTime AS osck_modTime,oscz.guid AS oscz_guid," +
            "osck.isScomb as osck_isScomb,osck.orderScombCaipinId as osck_orderScombCaipinId," +
            "oscz.zuofaId AS oscz_zuofaId,oscz.name AS oscz_name,oscz.typeId AS oscz_typeId,oscz.price AS oscz_price," +
            "oscz.jiajiaType AS oscz_jiajiaType,oscz.operator AS oscz_operator,	oscz.modTime AS oscz_modTime," +
            "oscz.isScomb as oscz_isScomb,oscz.orderScombCaipinId as oscz_orderScombCaipinId," +
            "osc.needweigh AS osc_needweigh,osc.scombMainCaipinId as osc_scombMainCaipinId " +
            " from pos_order_caipin o" +
            " left join pos_order_caipin_kouwei k on k.orderCaipinId = o.guid and (k.isScomb='false' or k.isScomb is null )" +
            " left join pos_order_caipin_zuofa z on z.orderCaipinId = o.guid and (z.isScomb='false' or z.isScomb is null )" +
            " left join pos_order_scomb_caipin osc on  osc.orderCaipinId=o.guid " +
            " LEFT JOIN pos_order_caipin_kouwei osck ON osck.orderScombCaipinId = osc.guid and osck.orderCaipinId=o.guid " +
            " LEFT JOIN pos_order_caipin_zuofa oscz ON oscz.orderScombCaipinId = osc.guid and oscz.orderCaipinId=o.guid " +
            " where o.orderId='" + orderId + "'";
        if(luodan == 0 || luodan == 1){
            sql += " and o.luodan='" + luodan + "'";
        }
        sql += " order by o.modTime";
        orderCaipinDao.query(sql).then(function (results) {
            var resultList = [];
            //退菜的菜品
            var tuiCaiMap = {};
            for (var i = 0; i < results.detail.length; i++) {
                var row = results.detail[i];
                var orderCaipin = Utils.arrayFind(resultList, row.o_guid, "guid");

                if (orderCaipin == null) {
                    orderCaipin = new OrderCaipin();
                    orderCaipin.guid = row.o_guid;
                    orderCaipin.orderId = row.o_orderId;
                    orderCaipin.caipinId = row.o_caipinId;
                    orderCaipin.name = row.o_name;
                    orderCaipin.price = row.o_price;
                    orderCaipin.num = row.o_num;
                    orderCaipin.tuiNum = row.o_tuiNum;
                    orderCaipin.zengNum = row.o_zengNum;
                    orderCaipin.unitName = row.o_unitName;
                    orderCaipin.printId = row.o_printId;
                    orderCaipin.printName = row.o_printName;
                    orderCaipin.chupin = row.o_chupin;
                    orderCaipin.minAgio = row.o_minAgio;
                    orderCaipin.danPinBiLiZheKou = row.o_danPinBiLiZheKou;
                    orderCaipin.danPinJineZheKou = row.o_danPinJineZheKou;
                    orderCaipin.danPinZheKou = row.o_danPinZheKou;
                    orderCaipin.luodan = row.o_luodan;
                    orderCaipin.dianCaiYuan = row.o_dianCaiYuan;
                    orderCaipin.dianCaiYuanName = row.o_dianCaiYuanName;
                    orderCaipin.dianCaiTime = row.o_dianCaiTime;
                    orderCaipin.luoDanTime = row.o_luoDanTime;
                    orderCaipin.chuPinTime = row.o_chuPinTime;
                    orderCaipin.operator = row.o_operator;
                    orderCaipin.modTime = row.o_modTime;
                    orderCaipin.parentId = row.o_parentId;
                    orderCaipin.needweigh = row.needweigh;
                    orderCaipin.isScomb = row.o_isScomb;
                    orderCaipin.caipinTypeCode = row.o_caipinTypeCode;
                    orderCaipin.caipinTypeId = row.o_caipinTypeId;
                    orderCaipin.caipinTypeName = row.o_caipinTypeName;

                    orderCaipin.dianCaiYuanName = row.o_dianCaiYuanName;
                    orderCaipin.hyPrice = row.o_hyPrice;
                    orderCaipin.caiwuTypeName = row.o_caiwuTypeName;
                    orderCaipin.caiwuTypeId = row.o_caiwuTypeId;
                    orderCaipin.firstGuid = row.o_firstGuid;
                    orderCaipin.priceChange = row.o_priceChange;

                    if (!orderCaipin.isTui())
                        resultList.push(orderCaipin);
                    else {
                        var ocp = tuiCaiMap[orderCaipin.parentId];
                        if (_.isNil(ocp))
                            tuiCaiMap[orderCaipin.parentId] = [orderCaipin]
                        else {
                            Utils.arrayFind(ocp, orderCaipin.guid, "guid") == null ? ocp.push(orderCaipin) : null;
                        }


                    }

                }
                if (row.k_guid != null) {
                    var orderCaipinKouwei = Utils.arrayFind(orderCaipin.kouweis, row.k_guid, "guid");
                    if (orderCaipinKouwei == null) {
                        orderCaipinKouwei = new OrderCaipinKouwei();
                        orderCaipinKouwei.guid = row.k_guid;
                        orderCaipinKouwei.orderCaipinId = row.o_guid;
                        orderCaipinKouwei.kwId = row.k_kwId;
                        orderCaipinKouwei.name = row.k_name;
                        orderCaipinKouwei.operator = row.k_operator;
                        orderCaipinKouwei.modTime = row.k_modTime;
                        orderCaipin.kouweis.push(orderCaipinKouwei);
                    }
                }
                if (row.z_guid != null) {
                    var orderCaipinZuofa = Utils.arrayFind(orderCaipin.zuofas, row.z_guid, "guid");
                    if (orderCaipinZuofa == null) {
                        orderCaipinZuofa = new OrderCaipinZuofa();
                        orderCaipinZuofa.guid = row.z_guid;
                        orderCaipinZuofa.orderCaipinId = row.o_guid;
                        orderCaipinZuofa.zuofaId = row.z_zuofaId;
                        orderCaipinZuofa.name = row.z_name;
                        orderCaipinZuofa.typeId = row.z_typeId;
                        orderCaipinZuofa.price = row.z_price;
                        orderCaipinZuofa.jiajiaType = row.z_jiajiaType;
                        orderCaipinZuofa.operator = row.z_operator;
                        orderCaipinZuofa.modTime = row.z_modTime;
                        orderCaipinZuofa.parentCaiPin = orderCaipin;
                        orderCaipin.zuofas.push(orderCaipinZuofa);
                    }
                }


                if (row.osc_guid != null) {
                    var orderScombCaipin = Utils.arrayFind(orderCaipin.scombCaipins, row.osc_guid, "guid");
                    if (null == orderScombCaipin) {
                        orderScombCaipin = new OrderCaipin();
                        orderScombCaipin.guid = row.osc_guid;
                        orderScombCaipin.orderCaipinId = row.o_guid;
                        orderScombCaipin.orderId = row.o_orderId;
                        orderScombCaipin.caipinId = row.osc_caipinId;
                        orderScombCaipin.name = row.osc_name;
                        orderScombCaipin.price = row.osc_price;
                        orderScombCaipin.num = row.osc_num;
                        orderScombCaipin.tuiNum = row.osc_tuiNum;
                        orderScombCaipin.zengNum = row.osc_zengNum;
                        orderScombCaipin.unitName = row.osc_unitName;
                        orderScombCaipin.printId = row.osc_printId;
                        orderScombCaipin.printName = row.osc_printName;
                        orderScombCaipin.chupin = row.osc_chupin;
                        orderScombCaipin.minAgio = row.osc_minAgio;
                        orderScombCaipin.danPinBiLiZheKou = row.osc_danPinBiLiZheKou;
                        orderScombCaipin.danPinJineZheKou = row.osc_danPinJineZheKou;
                        orderScombCaipin.danPinZheKou = row.osc_danPinZheKou;
                        orderScombCaipin.luodan = orderCaipin.luodan;
                        orderScombCaipin.dianCaiYuan = row.osc_dianCaiYuan;
                        orderScombCaipin.dianCaiYuanName = row.osc_dianCaiYuanName;
                        orderScombCaipin.dianCaiTime = row.osc_dianCaiTime;
                        orderScombCaipin.luoDanTime = row.osc_luoDanTime;
                        orderScombCaipin.chuPinTime = row.osc_chuPinTime;
                        orderScombCaipin.operator = row.osc_operator;
                        orderScombCaipin.modTime = row.osc_modTime;
                        orderScombCaipin.parentId = row.osc_parentId;
                        orderScombCaipin.needweigh = row.osc_needweigh;
                        orderScombCaipin.isScomb = row.o_isScomb;
                        orderScombCaipin.scombId = row.o_caipinId;
                        orderScombCaipin.scombMainCaipinId = row.osc_scombMainCaipinId;

                        orderCaipin.scombCaipins.push(orderScombCaipin);
                    }
                    if (row.osck_guid != null) {
                        var orderCaipinKouwei = Utils.arrayFind(orderScombCaipin.kouweis, row.osck_guid, "guid");
                        if (orderCaipinKouwei == null) {
                            orderCaipinKouwei = new OrderCaipinKouwei();
                            orderCaipinKouwei.guid = row.osck_guid;
                            orderCaipinKouwei.orderCaipinId = row.o_guid;
                            orderCaipinKouwei.kwId = row.osck_kwId;
                            orderCaipinKouwei.name = row.osck_name;
                            orderCaipinKouwei.operator = row.osck_operator;
                            orderCaipinKouwei.modTime = row.osck_modTime;
                            orderCaipinKouwei.isScomb = row.osck_isScomb;
                            orderCaipinKouwei.orderScombCaipinId = row.osck_orderScombCaipinId;
                            orderScombCaipin.kouweis.push(orderCaipinKouwei);
                        }
                    }
                    if (row.oscz_guid != null) {
                        var orderCaipinZuofa = Utils.arrayFind(orderScombCaipin.zuofas, row.oscz_guid, "guid");
                        if (orderCaipinZuofa == null) {
                            orderCaipinZuofa = new OrderCaipinZuofa();
                            orderCaipinZuofa.guid = row.oscz_guid;
                            orderCaipinZuofa.orderCaipinId = row.o_guid;
                            orderCaipinZuofa.zuofaId = row.oscz_zuofaId;
                            orderCaipinZuofa.name = row.oscz_name;
                            orderCaipinZuofa.typeId = row.oscz_typeId;
                            orderCaipinZuofa.price = row.oscz_price;
                            orderCaipinZuofa.jiajiaType = row.oscz_jiajiaType;
                            orderCaipinZuofa.operator = row.oscz_operator;
                            orderCaipinZuofa.modTime = row.oscz_modTime;
                            orderCaipinZuofa.isScomb = row.oscz_isScomb;
                            orderCaipinZuofa.orderScombCaipinId = row.oscz_orderScombCaipinId;
                            orderScombCaipin.zuofas.push(orderCaipinZuofa);
                        }
                    }
                }
            }


            //把退菜的菜品和初始菜品关联
            //console.log(tuiCaiMap);
            _.forEach(tuiCaiMap, function (value, key) {
                var c = Utils.arrayFind(resultList, key, "guid");
                c.addTuiCai(value);
            });

            return cb(null, resultList);
        }, function (error) {
            return cb(error);
        });
    };

    //快餐-订单菜品落单
    DiancaiService.fastOrderCaipinsLuodan = function (orderId, cb) {
        var now = new Date().format("yyyy-MM-dd hh:mm:ss");
        var queries = [];
        queries.push({
            query: "update pos_order_caipin" +
            " set luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_TRUE + "',operator='" + $rootScope.curUser.id + "',luoDanTime='" + now + "',modTime='" + now + "'" +
            " where orderId='" + orderId + "' and luodan='" + BIZCONSTANT.ORDER_CAIPIN_LUODAN_FALSE + "'"
        });
        orderCaipinDao.queryTransaction(queries).then(function (resultList) {
            cb(null);
        }, function (err) {
            cb(err);
        });
    }

    //快餐-挂单
    DiancaiService.fastGuadan = function (orderId, cb) {
        var sql = "update pos_order set operator='"+$rootScope.curUser.id+"',operatorName='"+$rootScope.curUser.name+"',modTime='"+new Date().format("yyyy-MM-dd hh:mm:ss")+"'," +
            " ordersource='"+ORDERSOURCE.FAST_GUADAN+"'" +
            " where guid='"+orderId+"'";
        orderDao.query(sql).then(function (res) {
            cb(null);
        }, function (err) {
            cb(err);
        });

    }

    //快餐-获取挂单列表
    DiancaiService.fastGetGuadanList = function (cb) {
        var sql = "select guid, operator,operatorCode, operatorName,modTime,isFanJieSuan,serverId,zhuotaiName,renshu " +
            "from pos_order where isDeleted='false' and (ordersource='"+ORDERSOURCE.FAST_GUADAN+"' or (isFanJieSuan=1 and jieSuanNo is null)) " +
            "order by modTime desc";
        orderDao.query(sql).then(function (res) {
            debugger;
            var resultList = [];
            for (var i = 0; i < res.detail.length; i++) {
                var row = res.detail[i];
                var order = new Order();
                order.guid = row.guid;
                order.operator = row.operator;
                order.operatorCode = row.operatorCode;
                order.operatorName = row.operatorName;
                order.modTime = row.modTime;
                order.isFanJieSuan = row.isFanJieSuan;
                order.serverId = row.serverId;
                order.zhuotaiName = row.zhuotaiName;
                order.renshu = row.renshu;
                resultList.push(order);
            }
            return cb(null, resultList);
        }, function (err) {
            cb(err);
        });

    }

    //快餐-删除挂单
    DiancaiService.fastDeleteGuandanOrder = function (orderId, cb) {
        var sql = "update pos_order set isDeleted='true', operator='"+$rootScope.curUser.id+"', operatorName='"+$rootScope.curUser.name+"'," +
            " modTime='"+new Date().format("yyyy-MM-dd hh:mm:ss")+"' where guid='"+orderId+"'";
        orderDao.query(sql).then(function (res) {
            return cb(null);
        }, function (err) {
            cb(err);
        });

    }

    //快餐-取单
    DiancaiService.fastQudan = function (order, cb) {
        order.ordersource = ORDERSOURCE.FAST;
        order.operator = $rootScope.curUser.id;
        order.operatorName = $rootScope.curUser.name;
        order.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
        var sql = "update pos_order set ordersource='"+order.ordersource+"', operator='"+order.operator+"', operatorName='"+order.operatorName+"'," +
            " modTime='"+order.modTime+"' where guid='"+order.guid+"'";
        orderDao.query(sql).then(function (res) {
            return cb(null, order);
        }, function (err) {
            cb(err);
        });

    }

    /*快餐-根据orderId获取OrderZhuotai对象*/
    DiancaiService.fastGetOrderZhuotaiByOrderId = function (orderId, cb) {
        var sql = "select * from pos_order_zhuotai where orderId='"+orderId+"' and isDeleted='false'";
        orderZhuotaiDao.query(sql).then(function (res) {
            if(res.detail.length > 0){
                var row = res.detail[0];
                var orderZhuotai = new OrderZhuotai();
                orderZhuotai.guid = row.guid;
                orderZhuotai.orderId = row.orderId;
                orderZhuotai.zhuotaiId = row.zhuotaiId;
                orderZhuotai.zhuotaiCode = row.zhuotaiCode;
                orderZhuotai.zhuotaiName = row.zhuotaiName;
                orderZhuotai.areaId = row.areaId;
                orderZhuotai.areaCode = row.areaCode;
                orderZhuotai.areaName = row.areaName;
                orderZhuotai.renshu = row.renshu;
                orderZhuotai.hisOrderId = row.hisOrderId;
                orderZhuotai.isDeleted = row.isDeleted;
                return cb(null, orderZhuotai);
            } else {
                return cb(null, null);
            }
        }, function (err) {
            cb(err);
        });

    }

    //获取销售信息，用于销售报表
    //paramBean 参数对象
    //callback 回掉函数
    //forPrint 是否用于打印,若用于打印,需要根据菜品类别分类
    DiancaiService.getSaleInfo = function(paramBean, callback, forPrint) {
        var sql = "select poc.caipinId, poc.orderCaipinType, poc.name, poc.caipinTypeId, poc.caipinTypeName, poc.unitName, po.addOperatorName personName," +
            "sum(case when poc.num<0 then ((poc.price*poc.num)+poc.zuoFaZheQianTotal) else 0 end) as tuiMoney, " +
            "sum(poc.num) as num, sum(poc.tuiNum) as tuiNum, sum(poc.zengNum) as zengNum, " +
            "sum(poc.price*poc.num) as zheQianMoney, sum(poc.zheKouMoney) as zheKouMoney, sum(poc.shiShouMoney) as shiShouMoney, " +
            "sum(poc.moLingMoney) as moLingMoney, " +
            "sum(poc.fenTanSumMoney) as fenTanSumMoney, " +
            "sum(po.hykZSMoney) as hykZSMoney, " +
            "sum(case when poc.isScomb='true' then 0 else poc.zuoFaZheQianTotal end) AS zuoFaZheQianTotal, " +
            "sum(case when poc.isScomb='true' then 0 else poc.zuoFaShiShouTotal end) AS zuoFaShiShouTotal, " +
            "sum(case when poc.isScomb='true' then 0 else poc.zuoFaZheKouTotal end) AS zuoFaZheKouTotal, " +
            "sum(case when poc.isScomb='true' then 0 else poc.zuoFaFenTanTotal end) AS zuoFaFenTanTotal, " +
            "sum(case when poc.isScomb='true' then 0 else poc.zuoFaMoLingTotal end) AS zuoFaMoLingTotal, " +
            "poc.isScomb from pos_order_caipin poc " +
            " left join pos_billing po on poc.orderId=po.orderId " +
            " where poc.jieSuanTime is not null and po.isFanJieSuan<>1 and ";
        //套餐退款
        var sql2 = "select sum(zheQianMoney) as scombTuiMoney from pos_order_scomb_caipin posc " +
            "where posc.num<0 and posc.orderCaipinId IN " +
            "(select poc.guid from pos_order_caipin poc where poc.jieSuanTime IS NOT NULL ";
        if(paramBean) {
            var canBieId = paramBean.canBieId;
            var operator = paramBean.cashierId;
            var showUnJieSuan = paramBean.showUnJieSuan;
            var startTime = paramBean.startTime;
            var endTime = paramBean.endTime;
            var dishTypeParentId = paramBean.dishTypeParentId;
            var dishTypeChildId = paramBean.dishTypeChildId;
            var whereSql = "";
            if(!showUnJieSuan || showUnJieSuan == false) {
                sql = sql + " po.jieSuanNo is not null and ";
            }
            if(startTime && startTime.length > 0) {
                whereSql = whereSql + " poc.jieSuanTime >= '" + startTime + "' and ";
                sql2 += " and poc.jieSuanTime >= '"  + startTime + "' ";
            }
            if(endTime && endTime.length > 0) {
                whereSql = whereSql + " poc.jieSuanTime <= '" + endTime + "' and ";
                sql2 += " and poc.jieSuanTime <= '"  + endTime + "' ";
            }

            if(dishTypeParentId && dishTypeParentId != "ct1")
            if(dishTypeParentId && dishTypeParentId.length > 0) {
                var dishTypes = "";
                for(var i = 0; i < dishTypeParentId.length; i++) {
                    var dishType = dishTypeParentId[i];
                    if(dishType && dishType != "ct1") {
                        if(dishTypes.length > 0) {
                            dishTypes = dishTypes + ",";
                        }
                        dishTypes = dishTypes + "'" + dishType + "'";
                    }else {
                        dishTypes = "";
                        break;
                    }
                }
                if(dishTypes.length > 0) {
                    dishTypes = "(" + dishTypes + ")";
                    whereSql = whereSql + " poc.caipinTypeId in " + dishTypes + " and ";
                    sql2 += " and poc.caipinTypeId in " + dishTypes;
                }
            }
            /*if(dishTypeChildId && dishTypeChildId.length > 0 && dishTypeChildId != "ct2") {
                whereSql = whereSql + " poc.caipinTypeId = '" + dishTypeChildId + "' and ";
                sql2 += " and poc.caipinTypeId = '" + dishTypeChildId + "' ";
            }else {
                if(dishTypeParentId && dishTypeParentId.length > 0 && dishTypeParentId != "ct1") {
                    whereSql = whereSql + " (poc.caipinTypeId in (select guid from pos_caipin_type where parentId='" + dishTypeParentId + "') or poc.caipinTypeId='" + dishTypeParentId + "') and ";
                    sql2 = sql2 + " and (poc.caipinTypeId in (select guid from pos_caipin_type where parentId='" + dishTypeParentId + "') or poc.caipinTypeId='" + dishTypeParentId + "')  ";
                }
            }*/
            sql2 += " and poc.orderId IN(select pb.orderId from pos_billing pb where pb.jieSuanNo IS NOT NULL and pb.isFanJieSuan<>1 ";
            if(canBieId && canBieId.length > 0 && canBieId != "cb1") {
                whereSql = whereSql + " po.canbieId='" + canBieId + "' and ";
                sql2 += " and pb.canbieId='" + canBieId + "' ";
            }
            if(operator && operator.length > 0 && operator != "cc") {
                whereSql = whereSql + " poc.dianCaiYuan='" + operator + "' and ";
                sql2 += " and poc.dianCaiYuan='" + operator + "' ";
            }
            sql2 += " ))";

            if(whereSql.length > 0) {
                whereSql = whereSql + " 1=1 "
            }
            sql = sql + whereSql;
        }
        sql += " group by  poc.caipinId";
        if(forPrint && forPrint == true) {
            sql += ", poc.caipinTypeId";
        }
        console.info("sale info sql : " + sql);
        orderDao.query(sql).then(function(ret){
            if(ret && ret.detail.length > 0) {
                console.info("sale info scomb tuiMoney sql : " + sql2);
                orderDao.query(sql2).then(function (ret1) {
                    if(ret1 && ret1.detail.length > 0) {
                        var scombTuiMoney = ret1.detail[0].scombTuiMoney;
                        ret.scombTuiMoney = scombTuiMoney;
                    }
                    return callback(null, ret);
                })
            }else {
                return callback(null, ret);
            }
        }, function(err){
            return callback(null);
        })
    }

    DiancaiService.getTuiCaiInfo = function (paramBean, cb){
        var isJiesuanSql = "",isCanBie = "";
        //if(paramBean.showUnJieSuan){
        //    //包含未结算
        //    isJiesuanSql = "";
        //}else{
        //    //不包含未结算
        //    isJiesuanSql = "AND status = '4'";
        //}

        //餐别
        if(paramBean.canBieId != "cb1"){
            isCanBie += "AND canBieId = '" + paramBean.canBieId + "'"
        }

        // 起始时间在查orderId的时候做筛选  结束时间在菜品的时候做限制
        var sql = "SELECT guid, name, abs(num) num, abs(zheQianMoney) zheQianMoney, abs(zuoFaZheQianTotal) zuoFaZheQianTotal, tuicaiReasonId, tuicaiReasonName, tuicaiReasonType " +
            "FROM pos_order_caipin WHERE  orderId IN(SELECT guid FROM pos_order WHERE jieSuanTime> '"+paramBean.startTime+"'" + "AND status = '4'" + isCanBie +")" +
            "AND jieSuanTime < '"+paramBean.endTime+"' AND num<0 ";

        if(paramBean.dishTypeParentId && paramBean.dishTypeParentId.length > 0 && paramBean.dishTypeParentId != "ct1"){
            if(paramBean.dishTypeParentId.length ==1){
                sql += "and caipinTypeId = '" + paramBean.dishTypeParentId + "'";
            } else {
                for(var x in paramBean.dishTypeParentId){
                    if(x==0){
                        sql += "and ( caipinTypeId = '" + paramBean.dishTypeParentId[x] + "'";
                    } else {
                        if(x == (paramBean.dishTypeParentId.length-1)){
                            sql += "or caipinTypeId = '" + paramBean.dishTypeParentId[x] + "')";

                        } else {
                            sql += "or caipinTypeId = '" + paramBean.dishTypeParentId[x] + "'";
                        }

                    }
                }
            }

        }

        console.log(sql);
        orderDao.query(sql).then(function (res) {
            console.log(res.detail);
            return cb(null, res.detail);
        }, function (err) {
            cb(err);
        });


    }


    /*快餐-生成账单号*/
    DiancaiService.generateOrderCode = function(order, cb) {
        var now = new Date();
        UniqueIDService.nextSeq(now, 'order', function (err, seq,nowdate) {
            if (err) {
                return cb(err);
            }
            var seqNo = nowdate + Utils.formatSeqNo(seq);
            var zhangDanNo = "ZD" + seqNo;
            order.code = zhangDanNo;
            var queries = [];
            queries.push({
                query: "update pos_order set code='" + order.code + "' where guid='" + order.guid + "'"
            });

            orderDao.queryTransaction(queries).then(function (resultList) {
                cb(null, order);
            }, function (err) {
                cb(err);
            });
        });
    }



        //------------------------//
        /*   add by js  竖屏增加方法  */

        /**
         * 批量插入菜品
         * @param operator
         * @param order
         * @param orderCaipins
         * @param cb
         */
        function insertOrderCaipins(operator, order, orderCaipins) {
            var queries = [];
            _.each(orderCaipins, function (orderCaipin) {
                if (!orderCaipin.isScomb) {
                    // 不是套餐
                    queries.push({
                        query: "insert into pos_order_caipin ( " +
                        "guid, orderId, caipinId,caipinCode, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                        "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,costprice,hyPrice,caipinTypeId," +
                        "caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange,customize,unitId,cpdept,cpdeptName,dishFastNo,bestTypeId,bestTypeCode,bestTypeName) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                        params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.caipinCode, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price,
                            orderCaipin.num, orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName,
                            orderCaipin.chupin, orderCaipin.minAgio, orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou,
                            orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan, orderCaipin.dianCaiYuanName,
                            orderCaipin.needweigh, orderCaipin.costprice, orderCaipin.hyPrice, orderCaipin.caipinTypeId,
                            orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName, orderCaipin.caiwuTypeId,
                            orderCaipin.priceChange, orderCaipin.customize, orderCaipin.unitId, orderCaipin.cpdept, orderCaipin.cpdeptName,
                            orderCaipin.dishFastNo, orderCaipin.bestTypeId, orderCaipin.bestTypeCode, orderCaipin.bestTypeName,orderCaipin.tzs]
                    });
                } else {
                    // 是套餐
                    queries.push({
                        query: "insert into pos_order_caipin ( " +
                        "guid, orderId, caipinId,caipinCode, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                        "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,costprice," +
                        "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName,orderZhuoTaiId,caiwuTypeName,caiwuTypeId,priceChange,customize,unitId,cpdept,cpdeptName,dishFastNo,bestTypeId,bestTypeCode,bestTypeName) " +
                        "values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                        params: [orderCaipin.guid, orderCaipin.orderId, orderCaipin.caipinId, orderCaipin.caipinCode, orderCaipin.orderCaipinType, orderCaipin.name, orderCaipin.price, orderCaipin.num,
                            orderCaipin.tuiNum, orderCaipin.zengNum, orderCaipin.unitName, orderCaipin.printId, orderCaipin.printName, orderCaipin.chupin, orderCaipin.minAgio,
                            orderCaipin.danPinBiLiZheKou, orderCaipin.danPinJineZheKou, orderCaipin.danPinZheKou, orderCaipin.luodan, orderCaipin.operator, orderCaipin.dianCaiYuan,
                            orderCaipin.dianCaiYuanName, orderCaipin.needweigh, orderCaipin.isScomb, orderCaipin.costprice,
                            orderCaipin.hyPrice, orderCaipin.caipinTypeId, orderCaipin.caipinTypeCode, orderCaipin.caipinTypeName, orderCaipin.orderZhuoTaiId, orderCaipin.caiwuTypeName,
                            orderCaipin.caiwuTypeId, orderCaipin.priceChange, orderCaipin.customize, orderCaipin.unitId, orderCaipin.cpdept, orderCaipin.cpdeptName,
                            orderCaipin.dishFastNo, orderCaipin.bestTypeId, orderCaipin.bestTypeCode, orderCaipin.bestTypeName]
                    });
                    for (var i in orderCaipin.scombCaipins) {
                        var scombCaipin = orderCaipin.scombCaipins[i];
                        queries.push({
                            query: "insert into pos_order_scomb_caipin ( " +
                            "guid, orderCaipinId,scombId, caipinId, orderCaipinType, name, price, num, tuiNum, zengNum, unitName, printId, printName, chupin, minAgio, danPinBiLiZheKou," +
                            "danPinJineZheKou, danPinZheKou, luodan, operator, dianCaiYuan, dianCaiYuanName, dianCaiTime, modTime,needweigh,isScomb,scombMainCaipinId,costprice," +
                            "hyPrice,caipinTypeId,caipinTypeCode,caipinTypeName) " +
                            "values (?,?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, datetime('now', 'localtime'), datetime('now', 'localtime'),?,?,?,?,?,?,?,?)",
                            params: [scombCaipin.guid, scombCaipin.orderCaipinId, scombCaipin.scombId, scombCaipin.caipinId, scombCaipin.orderCaipinType,
                                scombCaipin.name, scombCaipin.price, scombCaipin.num, scombCaipin.tuiNum, scombCaipin.zengNum, scombCaipin.unitName, scombCaipin.printId,
                                scombCaipin.printName, scombCaipin.chupin, scombCaipin.minAgio, scombCaipin.danPinBiLiZheKou, scombCaipin.danPinJineZheKou, scombCaipin.danPinZheKou,
                                scombCaipin.luodan, scombCaipin.operator, scombCaipin.dianCaiYuan, scombCaipin.dianCaiYuanName,
                                scombCaipin.needweigh, orderCaipin.isScomb, scombCaipin.caipinId, scombCaipin.costprice,
                                scombCaipin.hyPrice, scombCaipin.caipinTypeId, scombCaipin.caipinTypeCode, scombCaipin.caipinTypeName]
                        });
                    }
                }
            });
            return queries;
        }

        /**
         * 批量更新菜品
         * @param operator
         * @param orderCaipins
         * @param cb
         */
        function updateOrderCaipins(operator, orderCaipins) {
            var queries = [];
            _.each(orderCaipins, function (orderCaipin) {
                    orderCaipin.operator = operator;
                    orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                    if (!orderCaipin.isScomb) {
                        // 不是套餐
                        //queries.push({
                        //    query: "update pos_order_caipin " +
                        //    " set orderId='" + orderCaipin.orderId + "',caipinId='" + orderCaipin.caipinId +
                        //    "', orderCaipinType='" + orderCaipin.orderCaipinType + "',name='" + orderCaipin.name + "',price='" + orderCaipin.price +
                        //    "', num='" + orderCaipin.num + "',tuiNum='" + orderCaipin.tuiNum + "',zengNum='" + orderCaipin.zengNum + "',unitName='" + orderCaipin.unitName +
                        //    "', printId='" + orderCaipin.printId + "',printName='" + orderCaipin.printName + "',chupin='" + orderCaipin.chupin + "',minAgio='" + orderCaipin.minAgio +
                        //    "', danPinBiLiZheKou='" + orderCaipin.danPinBiLiZheKou + "',danPinJineZheKou='" + orderCaipin.danPinJineZheKou + "',danPinZheKou='" + orderCaipin.danPinZheKou +
                        //    "', luodan='" + orderCaipin.luodan + "',operator='" + orderCaipin.operator + "',dianCaiYuan='" + orderCaipin.dianCaiYuan + "',dianCaiYuanName='" + orderCaipin.dianCaiYuanName +
                        //    "', dianCaiTime='" + orderCaipin.dianCaiTime + "',modTime='" + orderCaipin.modTime + "',needweigh='" + orderCaipin.needweigh + "',costprice='" + orderCaipin.costprice +
                        //    "', hyPrice='" + orderCaipin.hyPrice + "',caipinTypeId='" + orderCaipin.caipinTypeId + "',caipinTypeCode='" + orderCaipin.caipinTypeCode + "',caipinTypeName='" + orderCaipin.caipinTypeName +
                        //    "' where guid='" + orderCaipin.guid + "'"
                        //});

                        queries.push({
                            query: "update pos_order_caipin " +
                            " set name='" + orderCaipin.name + "',price='" + orderCaipin.price +
                            "',operator='" + orderCaipin.operator + "',modTime='" + orderCaipin.modTime +
                            "', num= " + orderCaipin.num + ",unitName='" + orderCaipin.unitName +
                            "'  where guid='" + orderCaipin.guid + "'"
                        });
                    } else {
                        // 是套餐
                        //queries.push({
                        //    query: "update pos_order_caipin " +
                        //    " set orderId='" + orderCaipin.orderId + "',caipinId='" + orderCaipin.caipinId +
                        //    "',orderCaipinType='" + orderCaipin.orderCaipinType + "',name='" + orderCaipin.name + "',price='" + orderCaipin.price +
                        //    "',num='" + orderCaipin.num + "',tuiNum='" + orderCaipin.tuiNum + "',zengNum='" + orderCaipin.zengNum + "',unitName='" + orderCaipin.unitName +
                        //    "',printId='" + orderCaipin.printId + "',printName='" + orderCaipin.printName + "',chupin='" + orderCaipin.chupin + "',minAgio='" + orderCaipin.minAgio +
                        //    "',danPinBiLiZheKou='" + orderCaipin.danPinBiLiZheKou + "',danPinJineZheKou='" + orderCaipin.danPinJineZheKou + "',danPinZheKou='" + orderCaipin.danPinZheKou +
                        //    "',luodan='" + orderCaipin.luodan + "',operator='" + orderCaipin.operator + "',dianCaiYuan='" + orderCaipin.dianCaiYuan + "',dianCaiYuanName='" + orderCaipin.dianCaiYuanName +
                        //    "',dianCaiTime='" + orderCaipin.dianCaiTime + "',modTime='" + orderCaipin.modTime + "',needweigh='" + orderCaipin.needweigh + "',isScomb='" + orderCaipin.isScomb + "',costprice='" + orderCaipin.costprice +
                        //    "',hyPrice='" + orderCaipin.hyPrice + "',caipinTypeId='" + orderCaipin.caipinTypeId + "',caipinTypeCode='" + orderCaipin.caipinTypeCode + "',caipinTypeName='" + orderCaipin.caipinTypeName +
                        //    "' where guid='" + orderCaipin.guid + "'"
                        //});

                        queries.push({
                            query: "update pos_order_caipin" +
                            " set num= " + orderCaipin.num + ",operator='" + operator + "',modTime='" + orderCaipin.modTime + "'" +
                            " where guid='" + orderCaipin.guid + "'"
                        });

                        for (var i in orderCaipin.scombCaipins) {
                            var scombCaipin = orderCaipin.scombCaipins[i];
                            //queries.push({
                            //    query: "update pos_order_scomb_caipin set " +
                            //    "orderCaipinId='" + scombCaipin.orderCaipinId + "',scombId='" + scombCaipin.scombId + "',caipinId='" + scombCaipin.caipinId +
                            //    "',orderCaipinType='" + scombCaipin.orderCaipinType + "',name='" + scombCaipin.name + "',price='" + scombCaipin.price + "',num='" + scombCaipin.num +
                            //    "',tuiNum='" + scombCaipin.tuiNum + "',zengNum='" + scombCaipin.zengNum + "',unitName='" + scombCaipin.unitName + "',printId='" + scombCaipin.printId +
                            //    "',printName='" + scombCaipin.printName + "',chupin='" + scombCaipin.chupin + "',minAgio='" + scombCaipin.minAgio + "',danPinBiLiZheKou='" + scombCaipin.danPinBiLiZheKou +
                            //    "',danPinJineZheKou='" + scombCaipin.danPinJineZheKou + "',danPinZheKou='" + scombCaipin.danPinZheKou + ",luodan='" + scombCaipin.luodan + "',operator='" + scombCaipin.operator +
                            //    "',dianCaiYuan='" + scombCaipin.dianCaiYuan + "',dianCaiYuanName='" + scombCaipin.dianCaiYuanName + "',dianCaiTime='" + scombCaipin.dianCaiTime + "',modTime='" + scombCaipin.modTime +
                            //    "',needweigh='" + scombCaipin.needweigh + "',isScomb='" + scombCaipin.isScomb + "',scombMainCaipinId='" + scombCaipin.scombMainCaipinId + "',costprice='" + scombCaipin.costprice +
                            //    "',hyPrice='" + scombCaipin.hyPrice + "',caipinTypeId='" + scombCaipin.caipinTypeId + "',caipinTypeCode='" + scombCaipin.caipinTypeCode + "',caipinTypeName='" + scombCaipin.caipinTypeName +
                            //    "' where guid='" + scombCaipin.guid + "'"
                            //});

                            queries.push({
                                query: "update pos_order_scomb_caipin set " +
                                "num= " + scombCaipin.num + ",operator='" + scombCaipin.operator + "',modTime='" + scombCaipin.modTime + "'" +
                                " where guid='" + scombCaipin.guid + "'"
                            });

                        }
                    }
                }
            );
            return queries;
        }

        /**
         * 批量删除
         * @param orderCaipins
         * @param cb
         * @returns {*}
         */
        function deleteAllOrderCaipin(orderCaipins) {
            var queries = [];
            if (Utils.isEmpty(orderCaipins)) {
                return queries;
            }
            var conditions = [];
            var incondition = '';
            for (var i in orderCaipins) {
                conditions.push(orderCaipins[i].guid);
            }
            incondition = "'" + conditions.join("','") + "'";
            queries.push({query: "delete from pos_order_caipin_zuofa where orderCaipinId in (" + incondition + ")"});
            queries.push({query: "delete from pos_order_caipin_kouwei where orderCaipinId in (" + incondition + ")"});
            queries.push({query: "delete from pos_order_caipin where guid in (" + incondition + ")"});
            queries.push({query: "delete from pos_order_scomb_caipin where orderCaipinId in (" + incondition + ")"});

            return queries;
        };

        /**
         * 插入、更新、删除操作合并在一个transaction中
         * @param operator
         * @param order
         * @param insertList
         * @param updateList
         * @param deleteList
         * @param cb
         */
        DiancaiService.handleDisLuodanOrderCaipins = function (operator, order, insertList, updateList, deleteList, cb) {
            var queries = [];
            var queriesInsert = insertOrderCaipins(operator, order, insertList);
            var queriesUpdate = updateOrderCaipins(operator, updateList);
            var queriesDelete = deleteAllOrderCaipin(deleteList);
            for (var i in queriesInsert) {
                queries.push(queriesInsert[i]);
            }
            for (var i in queriesUpdate) {
                queries.push(queriesUpdate[i]);
            }
            for (var i in queriesDelete) {
                queries.push(queriesDelete[i]);
            }
            orderCaipinDao.queryTransaction(queries).then(function (resultList) {
                cb(null, resultList);
            }, function (err) {
                cb(err);
            });
        }

        /**
         * 构造落单菜品model
         * @param operator
         * @param order
         * @param caipin
         * @returns {*}
         * @constructor
         */
        DiancaiService.GetOrderCaipin = function (operator, order, orderzhuotai, caipin) {
            var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, caipin);
            return orderCaipin;
        }
        /**
         * 插入套餐菜品
         * @param operator
         * @param order
         * @param orderScomb
         * @param cb
         * @constructor
         */
        DiancaiService.AddOrderScombLocal = function (operator, order, orderzhuotai, orderScomb, cb) {
            var orderCaipin = createOrderCaipin(operator, order, orderzhuotai, orderScomb.getScombInfo());

            var scombCaipins = orderScomb.getScombCaipin();
            for (var i = 0; i < scombCaipins.length; i++) {
                var scombCaipin = createOrderScombCaipin(operator, orderCaipin, orderScomb.getScombCaipin()[i].scombCaipinInfo);
                orderCaipin.scombCaipins.push(scombCaipin);
            }

            cb(orderCaipin);
        }

        /**
         * 更新本地菜品数量
         * @param operator
         * @param orderCaipin
         * @param num
         * @param cb
         */
        DiancaiService.updateOrderCaipinNumLocal = function (operator, orderCaipin, num, cb,tzs) {
            var caipinGuqing = null;
            //dishGuqingDao.all(" startTime <= datetime('now','localtime') and endTime >= datetime('now','localtime') and caipinGuid='" + orderCaipin.caipinId + "'")
            //    .then(function (result) {
            //        caipinGuqing = result;
            var num = Utils.m(num);
            if (caipinGuqing == null || caipinGuqing.length == 0 || (caipinGuqing != null && caipinGuqing[0].caipinNum >= num)) {
                var chaNum = Utils.m(orderCaipin.num);
                if(!Utils.isEmpty(tzs)){
                    tzs = Utils.m(tzs);
                    orderCaipin.tzs = tzs;
                }
                orderCaipin.num = num;
                orderCaipin.operator = operator;
                orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
                if (orderCaipin.scombCaipins.length > 0) {
                    for (var idx in orderCaipin.scombCaipins) {
                        var item = orderCaipin.scombCaipins[idx];
                        item.num = item.num / chaNum * num;
                    }
                }
                cb(null);
            } else {
                cb("菜品数量不足");
            }
            //}, function (err) {
            //    cb(err);
            //});
        };
        /**
         * 根据桌台名称获取本地缓存的菜品数据
         * @param key
         * @param cb
         * @returns {*}
         */
        DiancaiService.getDisLuodanOrderCaipinsFromLocal = function (key, cb) {
            var results = JSON.parse(localStorage.getItem(key));
            var resultList = [];
            //退菜的菜品
            var tuiCaiMap = {};
            if (null != results) {
                for (var i = 0; i < results.length; i++) {
                    var row = results[i];
                    var orderCaipin = Utils.arrayFind(resultList, row.guid, "guid");
                    if (orderCaipin == null) {
                        orderCaipin = new OrderCaipin();
                        orderCaipin.guid = row.guid;
                        orderCaipin.orderId = row.orderId;
                        orderCaipin.caipinId = row.caipinId;
                        orderCaipin.caipinCode = row.caipinCode;
                        orderCaipin.name = row.name;
                        orderCaipin.price = row.price;
                        orderCaipin.num = row.num;
                        orderCaipin.tuiNum = row.tuiNum;
                        orderCaipin.zengNum = row.zengNum;
                        orderCaipin.unitName = row.unitName;
                        orderCaipin.printId = row.printId;
                        orderCaipin.printName = row.printName;
                        orderCaipin.chupin = row.chupin;
                        orderCaipin.minAgio = row.minAgio;
                        orderCaipin.danPinBiLiZheKou = row.danPinBiLiZheKou;
                        orderCaipin.danPinJineZheKou = row.danPinJineZheKou;
                        orderCaipin.danPinZheKou = row.danPinZheKou;
                        orderCaipin.luodan = row.luodan;
                        orderCaipin.dianCaiYuan = row.dianCaiYuan;
                        orderCaipin.dianCaiYuanName = row.dianCaiYuanName;
                        orderCaipin.dianCaiTime = row.dianCaiTime;
                        orderCaipin.luoDanTime = row.luoDanTime;
                        orderCaipin.chuPinTime = row.chuPinTime;
                        orderCaipin.operator = row.operator;
                        orderCaipin.modTime = row.modTime;
                        orderCaipin.parentId = row.parentId;
                        orderCaipin.needweigh = row.needweigh;
                        orderCaipin.isScomb = row.isScomb;
                        orderCaipin.costprice = row.costprice;

                        orderCaipin.caipinTypeCode = row.caipinTypeCode;
                        orderCaipin.caipinTypeId = row.caipinTypeId;
                        orderCaipin.caipinTypeName = row.caipinTypeName;

                        orderCaipin.hyPrice = row.hyPrice;
                        orderCaipin.caiwuTypeName = row.caiwuTypeName;
                        orderCaipin.caiwuTypeId = row.caiwuTypeId;
                        //orderCaipin.firstGuid = row.o_firstGuid;
                        orderCaipin.priceChange = row.priceChange;
                        orderCaipin.customize = row.customize;
                        orderCaipin.unitId = row.unitId;
                        orderCaipin.cpdept = row.cpdept;
                        orderCaipin.cpdeptName = row.cpdeptName;
                        orderCaipin.orderZhuoTaiId = row.orderZhuoTaiId;
                        orderCaipin.orgNum = row.orgNum;
                        orderCaipin.mom = row.mom;
                        orderCaipin.tzs = row.tzs;

                        orderCaipin.dishFastNo = row.dishFastNo;
                        orderCaipin.bestTypeId = row.bestTypeId;
                        orderCaipin.bestTypeCode = row.bestTypeCode;
                        orderCaipin.bestTypeName = row.bestTypeName;

                        if (!orderCaipin.isTui())
                            resultList.push(orderCaipin);
                        else {
                            var ocp = tuiCaiMap[orderCaipin.parentId];
                            if (_.isNil(ocp))
                                tuiCaiMap[orderCaipin.parentId] = [orderCaipin]
                            else {
                                Utils.arrayFind(ocp, orderCaipin.guid, "guid") == null ? ocp.push(orderCaipin) : null;
                            }
                        }
                    }

                    orderCaipin.kouweis = row.kouweis;

                    _.each(row.zuofas, function (zuofa) {
                        var orderCaipinZuofa = new OrderCaipinZuofa();
                        orderCaipinZuofa.guid = zuofa.guid;
                        orderCaipinZuofa.orderCaipinId = zuofa.orderCaipinId;
                        orderCaipinZuofa.zuofaId = zuofa.zuofaId;
                        orderCaipinZuofa.name = zuofa.name;
                        orderCaipinZuofa.typeId = zuofa.typeId;
                        orderCaipinZuofa.price = zuofa.price;
                        orderCaipinZuofa.jiajiaType = zuofa.jiajiaType;
                        orderCaipinZuofa.operator = zuofa.operator;
                        orderCaipinZuofa.modTime = zuofa.modTime;
                        orderCaipinZuofa.parentCaiPin = orderCaipin;
                        orderCaipin.zuofas.push(orderCaipinZuofa);
                    });

                    if (null != row.scombCaipins) {
                        _.each(row.scombCaipins, function (scombCaipin) {
                            var orderScombCaipin = new OrderCaipin();
                            orderScombCaipin.guid = scombCaipin.guid;
                            orderScombCaipin.orderCaipinId = scombCaipin.orderCaipinId;
                            orderScombCaipin.orderId = scombCaipin.orderId;
                            orderScombCaipin.caipinId = scombCaipin.caipinId;
                            orderScombCaipin.name = scombCaipin.name;
                            orderScombCaipin.price = scombCaipin.price;
                            orderScombCaipin.num = scombCaipin.num;
                            orderScombCaipin.tuiNum = scombCaipin.tuiNum;
                            orderScombCaipin.zengNum = scombCaipin.zengNum;
                            orderScombCaipin.unitName = scombCaipin.unitName;
                            orderScombCaipin.printId = scombCaipin.printId;
                            orderScombCaipin.printName = scombCaipin.printName;
                            orderScombCaipin.chupin = scombCaipin.chupin;
                            orderScombCaipin.minAgio = scombCaipin.minAgio;
                            orderScombCaipin.danPinBiLiZheKou = scombCaipin.danPinBiLiZheKou;
                            orderScombCaipin.danPinJineZheKou = scombCaipin.danPinJineZheKou;
                            orderScombCaipin.danPinZheKou = scombCaipin.danPinZheKou;
                            orderScombCaipin.luodan = scombCaipin.luodan;
                            orderScombCaipin.dianCaiYuan = scombCaipin.dianCaiYuan;
                            orderScombCaipin.dianCaiYuanName = scombCaipin.dianCaiYuanName;
                            orderScombCaipin.dianCaiTime = scombCaipin.dianCaiTime;
                            orderScombCaipin.luoDanTime = scombCaipin.luoDanTime;
                            orderScombCaipin.chuPinTime = scombCaipin.chuPinTime;
                            orderScombCaipin.operator = scombCaipin.operator;
                            orderScombCaipin.modTime = scombCaipin.modTime;
                            orderScombCaipin.parentId = scombCaipin.parentId;
                            orderScombCaipin.needweigh = scombCaipin.needweigh;
                            orderScombCaipin.isScomb = scombCaipin.isScomb;
                            orderScombCaipin.scombId = scombCaipin.scombId;
                            orderScombCaipin.scombMainCaipinId = scombCaipin.scombMainCaipinId;
                            orderScombCaipin.kouweis = scombCaipin.kouweis;

                            _.each(scombCaipin.zuofas, function (scombZuofa) {
                                var orderCaipinZuofa = new OrderCaipinZuofa();
                                orderCaipinZuofa.guid = scombZuofa.guid;
                                orderCaipinZuofa.orderCaipinId = scombZuofa.orderCaipinId;
                                orderCaipinZuofa.zuofaId = scombZuofa.zuofaId;
                                orderCaipinZuofa.name = scombZuofa.name;
                                orderCaipinZuofa.typeId = scombZuofa.typeId;
                                orderCaipinZuofa.price = scombZuofa.price;
                                orderCaipinZuofa.jiajiaType = scombZuofa.jiajiaType;
                                orderCaipinZuofa.operator = scombZuofa.operator;
                                orderCaipinZuofa.modTime = scombZuofa.modTime;
                                orderCaipinZuofa.isScomb = scombZuofa.isScomb;
                                orderCaipinZuofa.orderScombCaipinId = scombZuofa.orderScombCaipinId;
                                orderCaipinZuofa.parentCaiPin = orderScombCaipin;
                                orderScombCaipin.zuofas.push(orderCaipinZuofa);
                            });

                            orderCaipin.scombCaipins.push(orderScombCaipin);
                        });
                    }
                }
            }

            //把退菜的菜品和初始菜品关联
            //console.log(tuiCaiMap);
            _.forEach(tuiCaiMap, function (value, key) {
                var c = Utils.arrayFind(resultList, key, "guid");
                c.addTuiCai(value);
            });

            return cb(resultList);
        }

        /**
         * 更新本地备选套餐菜品
         * @param operator
         * @param orderScomb
         * @param oldScombCaipin
         * @param newScombCaipin
         * @param cb
         * @returns {*}
         */
        DiancaiService.updateScombCaipinLocal = function (operator, orderScomb, oldScombCaipin, newScombCaipin, cb) {
            var scombCaipin = createOrderScombCaipin(operator, orderScomb, newScombCaipin);
            scombCaipin.scombMainCaipinId = oldScombCaipin.scombMainCaipinId;
            return cb(null, scombCaipin);
        }

        /**
         *  修改整桌口味
         * @param operator
         * @param orderCaipins
         * @param zhengzhuoKouweis
         * @param zhengzhuoChupin
         * @param cb
         */
        DiancaiService.doZhengzhuoCaozuoLocal = function (operator, orderCaipins, zhengzhuoKouweis, zhengzhuoChupin, cb) {
            if (zhengzhuoKouweis != null && zhengzhuoKouweis.length > 0) {
                for (var i = 0; i < orderCaipins.length; i++) {
                    var orderCaipinKouweis = orderCaipins[i].kouweis;
                    for (var j = 0; j < zhengzhuoKouweis.length; j++) {
                        if (Utils.arrayFind(orderCaipinKouweis, zhengzhuoKouweis[j].guid, "kwId") == null) {
                            var orderCaipinKouwei = new OrderCaipinKouwei();
                            orderCaipinKouwei.guid = orderCaipinKouweiDao.guid();
                            orderCaipinKouwei.orderCaipinId = orderCaipins[i].guid;
                            orderCaipinKouwei.kwId = zhengzhuoKouweis[j].guid;
                            orderCaipinKouwei.name = zhengzhuoKouweis[j].kwName;
                            orderCaipinKouwei.operator = operator;
                            orderCaipinKouwei.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");

                            orderCaipinKouweis.push(orderCaipinKouwei);
                        }
                    }
                }
            }
            if (zhengzhuoChupin != null) {
                for (var i in orderCaipins) {
                    if (orderCaipins[i].chupin != zhengzhuoChupin) {
                        updateCaipinSateLocal(operator, orderCaipins[i], zhengzhuoChupin);
                    }
                }
            }
            cb(orderCaipins);
        };
        /***
         * 修改本地菜品状态（未插入数据库）
         * @param operator
         * @param orderCaipin
         * @param state
         */
        function updateCaipinSateLocal(operator, orderCaipin, state) {
            orderCaipin.chupin = state;
            orderCaipin.operator = operator;
            orderCaipin.modTime = new Date().format("yyyy-MM-dd hh:mm:ss");
            if (!orderCaipin.isScombCaipin()) {
                if (orderCaipin.isScombInfo()) {
                    for (var i = 0; i < orderCaipin.scombCaipins.length; i++) {
                        updateCaipinSateLocal(operator, orderCaipin.scombCaipins[i], state);
                    }
                }
            }
        }

        //需称重做法
        DiancaiService.zfneedwigh = function (caipinId, cb) {
            var sql = "SELECT * FROM pos_caipin_zuofa WHERE caipinId = '" + caipinId + "' and isDeleted = 'false'";
            orderDao.query(sql).then(function (res) {
                return cb(null, res.detail);
            }, function (err) {
                cb(err);
            });
        }

        //口味
        DiancaiService.kwneedwigh = function (cb) {
            var sql = "select * from pos_kouwei  where isDeleted='false' and enabled='true' and kwCode <> '01' limit 0,8"
            orderDao.query(sql).then(function (res) {
                return cb(null, res.detail);
            }, function (err) {
                cb(err);
            });
        }

        return DiancaiService;
    }]);
